(function (factory) {
  typeof define === 'function' && define.amd ? define(factory) :
  factory();
}((function () { 'use strict';

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      enumerableOnly && (symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      })), keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = null != arguments[i] ? arguments[i] : {};
      i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }

    return target;
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";

    return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
      return typeof obj;
    } : function (obj) {
      return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    }, _typeof(obj);
  }

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    Object.defineProperty(Constructor, "prototype", {
      writable: false
    });
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    Object.defineProperty(subClass, "prototype", {
      writable: false
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _construct(Parent, args, Class) {
    if (_isNativeReflectConstruct()) {
      _construct = Reflect.construct;
    } else {
      _construct = function _construct(Parent, args, Class) {
        var a = [null];
        a.push.apply(a, args);
        var Constructor = Function.bind.apply(Parent, a);
        var instance = new Constructor();
        if (Class) _setPrototypeOf(instance, Class.prototype);
        return instance;
      };
    }

    return _construct.apply(null, arguments);
  }

  function _isNativeFunction(fn) {
    return Function.toString.call(fn).indexOf("[native code]") !== -1;
  }

  function _wrapNativeSuper(Class) {
    var _cache = typeof Map === "function" ? new Map() : undefined;

    _wrapNativeSuper = function _wrapNativeSuper(Class) {
      if (Class === null || !_isNativeFunction(Class)) return Class;

      if (typeof Class !== "function") {
        throw new TypeError("Super expression must either be null or a function");
      }

      if (typeof _cache !== "undefined") {
        if (_cache.has(Class)) return _cache.get(Class);

        _cache.set(Class, Wrapper);
      }

      function Wrapper() {
        return _construct(Class, arguments, _getPrototypeOf(this).constructor);
      }

      Wrapper.prototype = Object.create(Class.prototype, {
        constructor: {
          value: Wrapper,
          enumerable: false,
          writable: true,
          configurable: true
        }
      });
      return _setPrototypeOf(Wrapper, Class);
    };

    return _wrapNativeSuper(Class);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    } else if (call !== void 0) {
      throw new TypeError("Derived constructors may only return object or undefined");
    }

    return _assertThisInitialized(self);
  }

  function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();

    return function _createSuperInternal() {
      var Super = _getPrototypeOf(Derived),
          result;

      if (hasNativeReflectConstruct) {
        var NewTarget = _getPrototypeOf(this).constructor;

        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }

      return _possibleConstructorReturn(this, result);
    };
  }

  function _superPropBase(object, property) {
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
      object = _getPrototypeOf(object);
      if (object === null) break;
    }

    return object;
  }

  function _get() {
    if (typeof Reflect !== "undefined" && Reflect.get) {
      _get = Reflect.get;
    } else {
      _get = function _get(target, property, receiver) {
        var base = _superPropBase(target, property);

        if (!base) return;
        var desc = Object.getOwnPropertyDescriptor(base, property);

        if (desc.get) {
          return desc.get.call(arguments.length < 3 ? target : receiver);
        }

        return desc.value;
      };
    }

    return _get.apply(this, arguments);
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArrayLimit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;

    var _s, _e;

    try {
      for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  function _createForOfIteratorHelper(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

    if (!it) {
      if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
        if (it) o = it;
        var i = 0;

        var F = function () {};

        return {
          s: F,
          n: function () {
            if (i >= o.length) return {
              done: true
            };
            return {
              done: false,
              value: o[i++]
            };
          },
          e: function (e) {
            throw e;
          },
          f: F
        };
      }

      throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }

    var normalCompletion = true,
        didErr = false,
        err;
    return {
      s: function () {
        it = it.call(o);
      },
      n: function () {
        var step = it.next();
        normalCompletion = step.done;
        return step;
      },
      e: function (e) {
        didErr = true;
        err = e;
      },
      f: function () {
        try {
          if (!normalCompletion && it.return != null) it.return();
        } finally {
          if (didErr) throw err;
        }
      }
    };
  }

  var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  var runtime_1 = createCommonjsModule(function (module) {
  /**
   * Copyright (c) 2014-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  var runtime = (function (exports) {

    var Op = Object.prototype;
    var hasOwn = Op.hasOwnProperty;
    var undefined$1; // More compressible than void 0.
    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

    function define(obj, key, value) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
      return obj[key];
    }
    try {
      // IE 8 has a broken Object.defineProperty that only works on DOM objects.
      define({}, "");
    } catch (err) {
      define = function(obj, key, value) {
        return obj[key] = value;
      };
    }

    function wrap(innerFn, outerFn, self, tryLocsList) {
      // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context(tryLocsList || []);

      // The ._invoke method unifies the implementations of the .next,
      // .throw, and .return methods.
      generator._invoke = makeInvokeMethod(innerFn, self, context);

      return generator;
    }
    exports.wrap = wrap;

    // Try/catch helper to minimize deoptimizations. Returns a completion
    // record like context.tryEntries[i].completion. This interface could
    // have been (and was previously) designed to take a closure to be
    // invoked without arguments, but in all the cases we care about we
    // already have an existing method we want to call, so there's no need
    // to create a new function object. We can even get away with assuming
    // the method takes exactly one argument, since that happens to be true
    // in every case, so we don't have to touch the arguments object. The
    // only additional allocation required is the completion record, which
    // has a stable shape and so hopefully should be cheap to allocate.
    function tryCatch(fn, obj, arg) {
      try {
        return { type: "normal", arg: fn.call(obj, arg) };
      } catch (err) {
        return { type: "throw", arg: err };
      }
    }

    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed";

    // Returning this object from the innerFn has the same effect as
    // breaking out of the dispatch switch statement.
    var ContinueSentinel = {};

    // Dummy constructor functions that we use as the .constructor and
    // .constructor.prototype properties for functions that return Generator
    // objects. For full spec compliance, you may wish to configure your
    // minifier not to mangle the names of these two functions.
    function Generator() {}
    function GeneratorFunction() {}
    function GeneratorFunctionPrototype() {}

    // This is a polyfill for %IteratorPrototype% for environments that
    // don't natively support it.
    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function () {
      return this;
    });

    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    if (NativeIteratorPrototype &&
        NativeIteratorPrototype !== Op &&
        hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
      // This environment has a native %IteratorPrototype%; use it instead
      // of the polyfill.
      IteratorPrototype = NativeIteratorPrototype;
    }

    var Gp = GeneratorFunctionPrototype.prototype =
      Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = GeneratorFunctionPrototype;
    define(Gp, "constructor", GeneratorFunctionPrototype);
    define(GeneratorFunctionPrototype, "constructor", GeneratorFunction);
    GeneratorFunction.displayName = define(
      GeneratorFunctionPrototype,
      toStringTagSymbol,
      "GeneratorFunction"
    );

    // Helper for defining the .next, .throw, and .return methods of the
    // Iterator interface in terms of a single ._invoke method.
    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function(method) {
        define(prototype, method, function(arg) {
          return this._invoke(method, arg);
        });
      });
    }

    exports.isGeneratorFunction = function(genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor
        ? ctor === GeneratorFunction ||
          // For the native GeneratorFunction constructor, the best we can
          // do is to check its .name property.
          (ctor.displayName || ctor.name) === "GeneratorFunction"
        : false;
    };

    exports.mark = function(genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;
        define(genFun, toStringTagSymbol, "GeneratorFunction");
      }
      genFun.prototype = Object.create(Gp);
      return genFun;
    };

    // Within the body of any async function, `await x` is transformed to
    // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
    // `hasOwn.call(value, "__await")` to determine if the yielded value is
    // meant to be awaited.
    exports.awrap = function(arg) {
      return { __await: arg };
    };

    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);
        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;
          if (value &&
              typeof value === "object" &&
              hasOwn.call(value, "__await")) {
            return PromiseImpl.resolve(value.__await).then(function(value) {
              invoke("next", value, resolve, reject);
            }, function(err) {
              invoke("throw", err, resolve, reject);
            });
          }

          return PromiseImpl.resolve(value).then(function(unwrapped) {
            // When a yielded Promise is resolved, its final value becomes
            // the .value of the Promise<{value,done}> result for the
            // current iteration.
            result.value = unwrapped;
            resolve(result);
          }, function(error) {
            // If a rejected Promise was yielded, throw the rejection back
            // into the async generator function so it can be handled there.
            return invoke("throw", error, resolve, reject);
          });
        }
      }

      var previousPromise;

      function enqueue(method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function(resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise =
          // If enqueue has been called before, then we want to wait until
          // all previous Promises have been resolved before calling invoke,
          // so that results are always delivered in the correct order. If
          // enqueue has not been called before, then it is important to
          // call invoke immediately, without waiting on a callback to fire,
          // so that the async generator function has the opportunity to do
          // any necessary setup in a predictable way. This predictability
          // is why the Promise constructor synchronously invokes its
          // executor callback, and why async functions synchronously
          // execute code before the first await. Since we implement simple
          // async functions in terms of async generators, it is especially
          // important to get this right, even though it requires care.
          previousPromise ? previousPromise.then(
            callInvokeWithMethodAndArg,
            // Avoid propagating failures to Promises returned by later
            // invocations of the iterator.
            callInvokeWithMethodAndArg
          ) : callInvokeWithMethodAndArg();
      }

      // Define the unified helper method that is used to implement .next,
      // .throw, and .return (see defineIteratorMethods).
      this._invoke = enqueue;
    }

    defineIteratorMethods(AsyncIterator.prototype);
    define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
      return this;
    });
    exports.AsyncIterator = AsyncIterator;

    // Note that simple async functions are implemented on top of
    // AsyncIterator objects; they just return a Promise for the value of
    // the final result produced by the iterator.
    exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      if (PromiseImpl === void 0) PromiseImpl = Promise;

      var iter = new AsyncIterator(
        wrap(innerFn, outerFn, self, tryLocsList),
        PromiseImpl
      );

      return exports.isGeneratorFunction(outerFn)
        ? iter // If outerFn is a generator, return the full iterator.
        : iter.next().then(function(result) {
            return result.done ? result.value : iter.next();
          });
    };

    function makeInvokeMethod(innerFn, self, context) {
      var state = GenStateSuspendedStart;

      return function invoke(method, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }

        if (state === GenStateCompleted) {
          if (method === "throw") {
            throw arg;
          }

          // Be forgiving, per 25.3.3.3.3 of the spec:
          // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
          return doneResult();
        }

        context.method = method;
        context.arg = arg;

        while (true) {
          var delegate = context.delegate;
          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);
            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if (context.method === "next") {
            // Setting context._sent for legacy support of Babel's
            // function.sent implementation.
            context.sent = context._sent = context.arg;

          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }

            context.dispatchException(context.arg);

          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }

          state = GenStateExecuting;

          var record = tryCatch(innerFn, self, context);
          if (record.type === "normal") {
            // If an exception is thrown from innerFn, we leave state ===
            // GenStateExecuting and loop back for another invocation.
            state = context.done
              ? GenStateCompleted
              : GenStateSuspendedYield;

            if (record.arg === ContinueSentinel) {
              continue;
            }

            return {
              value: record.arg,
              done: context.done
            };

          } else if (record.type === "throw") {
            state = GenStateCompleted;
            // Dispatch the exception by looping back around to the
            // context.dispatchException(context.arg) call above.
            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    }

    // Call delegate.iterator[context.method](context.arg) and handle the
    // result, either by returning a { value, done } result from the
    // delegate iterator, or by modifying context.method and context.arg,
    // setting context.delegate to null, and returning the ContinueSentinel.
    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];
      if (method === undefined$1) {
        // A .throw or .return when the delegate iterator has no .throw
        // method always terminates the yield* loop.
        context.delegate = null;

        if (context.method === "throw") {
          // Note: ["return"] must be used for ES3 parsing compatibility.
          if (delegate.iterator["return"]) {
            // If the delegate iterator has a return method, give it a
            // chance to clean up.
            context.method = "return";
            context.arg = undefined$1;
            maybeInvokeDelegate(delegate, context);

            if (context.method === "throw") {
              // If maybeInvokeDelegate(context) changed context.method from
              // "return" to "throw", let that override the TypeError below.
              return ContinueSentinel;
            }
          }

          context.method = "throw";
          context.arg = new TypeError(
            "The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);

      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }

      var info = record.arg;

      if (! info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }

      if (info.done) {
        // Assign the result of the finished delegate to the temporary
        // variable specified by delegate.resultName (see delegateYield).
        context[delegate.resultName] = info.value;

        // Resume execution at the desired location (see delegateYield).
        context.next = delegate.nextLoc;

        // If context.method was "throw" but the delegate handled the
        // exception, let the outer generator proceed normally. If
        // context.method was "next", forget context.arg since it has been
        // "consumed" by the delegate iterator. If context.method was
        // "return", allow the original .return call to continue in the
        // outer generator.
        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined$1;
        }

      } else {
        // Re-yield the result returned by the delegate method.
        return info;
      }

      // The delegate iterator is finished, so forget it and continue with
      // the outer generator.
      context.delegate = null;
      return ContinueSentinel;
    }

    // Define Generator.prototype.{next,throw,return} in terms of the
    // unified ._invoke helper method.
    defineIteratorMethods(Gp);

    define(Gp, toStringTagSymbol, "Generator");

    // A Generator should always return itself as the iterator object when the
    // @@iterator function is called on it. Some browsers' implementations of the
    // iterator prototype chain incorrectly implement this, causing the Generator
    // object to not be returned from this call. This ensures that doesn't happen.
    // See https://github.com/facebook/regenerator/issues/274 for more details.
    define(Gp, iteratorSymbol, function() {
      return this;
    });

    define(Gp, "toString", function() {
      return "[object Generator]";
    });

    function pushTryEntry(locs) {
      var entry = { tryLoc: locs[0] };

      if (1 in locs) {
        entry.catchLoc = locs[1];
      }

      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }

      this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }

    function Context(tryLocsList) {
      // The root entry object (effectively a try statement without a catch
      // or a finally block) gives us a place to store values thrown from
      // locations where there is no enclosing try statement.
      this.tryEntries = [{ tryLoc: "root" }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }

    exports.keys = function(object) {
      var keys = [];
      for (var key in object) {
        keys.push(key);
      }
      keys.reverse();

      // Rather than returning an object with a next method, we keep
      // things simple and return the next function itself.
      return function next() {
        while (keys.length) {
          var key = keys.pop();
          if (key in object) {
            next.value = key;
            next.done = false;
            return next;
          }
        }

        // To avoid creating an additional object, we just hang the .value
        // and .done properties off the next function object itself. This
        // also ensures that the minifier will not anonymize the function.
        next.done = true;
        return next;
      };
    };

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }

        if (typeof iterable.next === "function") {
          return iterable;
        }

        if (!isNaN(iterable.length)) {
          var i = -1, next = function next() {
            while (++i < iterable.length) {
              if (hasOwn.call(iterable, i)) {
                next.value = iterable[i];
                next.done = false;
                return next;
              }
            }

            next.value = undefined$1;
            next.done = true;

            return next;
          };

          return next.next = next;
        }
      }

      // Return an iterator with no values.
      return { next: doneResult };
    }
    exports.values = values;

    function doneResult() {
      return { value: undefined$1, done: true };
    }

    Context.prototype = {
      constructor: Context,

      reset: function(skipTempReset) {
        this.prev = 0;
        this.next = 0;
        // Resetting context._sent for legacy support of Babel's
        // function.sent implementation.
        this.sent = this._sent = undefined$1;
        this.done = false;
        this.delegate = null;

        this.method = "next";
        this.arg = undefined$1;

        this.tryEntries.forEach(resetTryEntry);

        if (!skipTempReset) {
          for (var name in this) {
            // Not sure about the optimal order of these conditions:
            if (name.charAt(0) === "t" &&
                hasOwn.call(this, name) &&
                !isNaN(+name.slice(1))) {
              this[name] = undefined$1;
            }
          }
        }
      },

      stop: function() {
        this.done = true;

        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;
        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }

        return this.rval;
      },

      dispatchException: function(exception) {
        if (this.done) {
          throw exception;
        }

        var context = this;
        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;

          if (caught) {
            // If the dispatched exception was caught by a catch block,
            // then let that catch block handle the exception normally.
            context.method = "next";
            context.arg = undefined$1;
          }

          return !! caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;

          if (entry.tryLoc === "root") {
            // Exception thrown outside of any try block that could handle
            // it, so set the completion value of the entire function to
            // throw the exception.
            return handle("end");
          }

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc");
            var hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }

            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }

            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }

            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },

      abrupt: function(type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc <= this.prev &&
              hasOwn.call(entry, "finallyLoc") &&
              this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        if (finallyEntry &&
            (type === "break" ||
             type === "continue") &&
            finallyEntry.tryLoc <= arg &&
            arg <= finallyEntry.finallyLoc) {
          // Ignore the finally entry if control is not jumping to a
          // location outside the try/catch block.
          finallyEntry = null;
        }

        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type;
        record.arg = arg;

        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }

        return this.complete(record);
      },

      complete: function(record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }

        if (record.type === "break" ||
            record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }

        return ContinueSentinel;
      },

      finish: function(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },

      "catch": function(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;
            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }
            return thrown;
          }
        }

        // The context.catch method must only be called with a location
        // argument that corresponds to a known catch block.
        throw new Error("illegal catch attempt");
      },

      delegateYield: function(iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        };

        if (this.method === "next") {
          // Deliberately forget the last sent value so that we don't
          // accidentally pass it on to the delegate.
          this.arg = undefined$1;
        }

        return ContinueSentinel;
      }
    };

    // Regardless of whether this script is executing as a CommonJS module
    // or not, return the runtime object so that we can declare the variable
    // regeneratorRuntime in the outer scope, which allows this module to be
    // injected easily by `bin/regenerator --include-runtime script.js`.
    return exports;

  }(
    // If this script is executing as a CommonJS module, use module.exports
    // as the regeneratorRuntime namespace. Otherwise create a new empty
    // object. Either way, the resulting object will be used to initialize
    // the regeneratorRuntime variable at the top of this file.
     module.exports 
  ));

  try {
    regeneratorRuntime = runtime;
  } catch (accidentalStrictMode) {
    // This module should not be running in strict mode, so the above
    // assignment should always work unless something is misconfigured. Just
    // in case runtime.js accidentally runs in strict mode, in modern engines
    // we can explicitly access globalThis. In older engines we can escape
    // strict mode using a global Function call. This could conceivably fail
    // if a Content Security Policy forbids using Function, but in that case
    // the proper solution is to fix the accidental strict mode problem. If
    // you've misconfigured your bundler to force strict mode and applied a
    // CSP to forbid Function, and you're not willing to fix either of those
    // problems, please detail your unique predicament in a GitHub issue.
    if (typeof globalThis === "object") {
      globalThis.regeneratorRuntime = runtime;
    } else {
      Function("r", "regeneratorRuntime = r")(runtime);
    }
  }
  });

  var check = function (it) {
    return it && it.Math == Math && it;
  };

  // https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
  var global_1 =
    // eslint-disable-next-line es/no-global-this -- safe
    check(typeof globalThis == 'object' && globalThis) ||
    check(typeof window == 'object' && window) ||
    // eslint-disable-next-line no-restricted-globals -- safe
    check(typeof self == 'object' && self) ||
    check(typeof commonjsGlobal == 'object' && commonjsGlobal) ||
    // eslint-disable-next-line no-new-func -- fallback
    (function () { return this; })() || Function('return this')();

  var fails = function (exec) {
    try {
      return !!exec();
    } catch (error) {
      return true;
    }
  };

  // Detect IE8's incomplete defineProperty implementation
  var descriptors = !fails(function () {
    // eslint-disable-next-line es/no-object-defineproperty -- required for testing
    return Object.defineProperty({}, 1, { get: function () { return 7; } })[1] != 7;
  });

  var call = Function.prototype.call;

  var functionCall = call.bind ? call.bind(call) : function () {
    return call.apply(call, arguments);
  };

  var $propertyIsEnumerable = {}.propertyIsEnumerable;
  // eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
  var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

  // Nashorn ~ JDK8 bug
  var NASHORN_BUG = getOwnPropertyDescriptor && !$propertyIsEnumerable.call({ 1: 2 }, 1);

  // `Object.prototype.propertyIsEnumerable` method implementation
  // https://tc39.es/ecma262/#sec-object.prototype.propertyisenumerable
  var f = NASHORN_BUG ? function propertyIsEnumerable(V) {
    var descriptor = getOwnPropertyDescriptor(this, V);
    return !!descriptor && descriptor.enumerable;
  } : $propertyIsEnumerable;

  var objectPropertyIsEnumerable = {
  	f: f
  };

  var createPropertyDescriptor = function (bitmap, value) {
    return {
      enumerable: !(bitmap & 1),
      configurable: !(bitmap & 2),
      writable: !(bitmap & 4),
      value: value
    };
  };

  var FunctionPrototype = Function.prototype;
  var bind = FunctionPrototype.bind;
  var call$1 = FunctionPrototype.call;
  var uncurryThis = bind && bind.bind(call$1, call$1);

  var functionUncurryThis = bind ? function (fn) {
    return fn && uncurryThis(fn);
  } : function (fn) {
    return fn && function () {
      return call$1.apply(fn, arguments);
    };
  };

  var toString = functionUncurryThis({}.toString);
  var stringSlice = functionUncurryThis(''.slice);

  var classofRaw = function (it) {
    return stringSlice(toString(it), 8, -1);
  };

  var Object$1 = global_1.Object;
  var split = functionUncurryThis(''.split);

  // fallback for non-array-like ES3 and non-enumerable old V8 strings
  var indexedObject = fails(function () {
    // throws an error in rhino, see https://github.com/mozilla/rhino/issues/346
    // eslint-disable-next-line no-prototype-builtins -- safe
    return !Object$1('z').propertyIsEnumerable(0);
  }) ? function (it) {
    return classofRaw(it) == 'String' ? split(it, '') : Object$1(it);
  } : Object$1;

  var TypeError$1 = global_1.TypeError;

  // `RequireObjectCoercible` abstract operation
  // https://tc39.es/ecma262/#sec-requireobjectcoercible
  var requireObjectCoercible = function (it) {
    if (it == undefined) throw TypeError$1("Can't call method on " + it);
    return it;
  };

  // toObject with fallback for non-array-like ES3 strings



  var toIndexedObject = function (it) {
    return indexedObject(requireObjectCoercible(it));
  };

  // `IsCallable` abstract operation
  // https://tc39.es/ecma262/#sec-iscallable
  var isCallable = function (argument) {
    return typeof argument == 'function';
  };

  var isObject = function (it) {
    return typeof it == 'object' ? it !== null : isCallable(it);
  };

  var aFunction = function (argument) {
    return isCallable(argument) ? argument : undefined;
  };

  var getBuiltIn = function (namespace, method) {
    return arguments.length < 2 ? aFunction(global_1[namespace]) : global_1[namespace] && global_1[namespace][method];
  };

  var objectIsPrototypeOf = functionUncurryThis({}.isPrototypeOf);

  var engineUserAgent = getBuiltIn('navigator', 'userAgent') || '';

  var process = global_1.process;
  var Deno = global_1.Deno;
  var versions = process && process.versions || Deno && Deno.version;
  var v8 = versions && versions.v8;
  var match, version;

  if (v8) {
    match = v8.split('.');
    // in old Chrome, versions of V8 isn't V8 = Chrome / 10
    // but their correct versions are not interesting for us
    version = match[0] > 0 && match[0] < 4 ? 1 : +(match[0] + match[1]);
  }

  // BrowserFS NodeJS `process` polyfill incorrectly set `.v8` to `0.0`
  // so check `userAgent` even if `.v8` exists, but 0
  if (!version && engineUserAgent) {
    match = engineUserAgent.match(/Edge\/(\d+)/);
    if (!match || match[1] >= 74) {
      match = engineUserAgent.match(/Chrome\/(\d+)/);
      if (match) version = +match[1];
    }
  }

  var engineV8Version = version;

  /* eslint-disable es/no-symbol -- required for testing */



  // eslint-disable-next-line es/no-object-getownpropertysymbols -- required for testing
  var nativeSymbol = !!Object.getOwnPropertySymbols && !fails(function () {
    var symbol = Symbol();
    // Chrome 38 Symbol has incorrect toString conversion
    // `get-own-property-symbols` polyfill symbols converted to object are not Symbol instances
    return !String(symbol) || !(Object(symbol) instanceof Symbol) ||
      // Chrome 38-40 symbols are not inherited from DOM collections prototypes to instances
      !Symbol.sham && engineV8Version && engineV8Version < 41;
  });

  /* eslint-disable es/no-symbol -- required for testing */


  var useSymbolAsUid = nativeSymbol
    && !Symbol.sham
    && typeof Symbol.iterator == 'symbol';

  var Object$2 = global_1.Object;

  var isSymbol = useSymbolAsUid ? function (it) {
    return typeof it == 'symbol';
  } : function (it) {
    var $Symbol = getBuiltIn('Symbol');
    return isCallable($Symbol) && objectIsPrototypeOf($Symbol.prototype, Object$2(it));
  };

  var String$1 = global_1.String;

  var tryToString = function (argument) {
    try {
      return String$1(argument);
    } catch (error) {
      return 'Object';
    }
  };

  var TypeError$2 = global_1.TypeError;

  // `Assert: IsCallable(argument) is true`
  var aCallable = function (argument) {
    if (isCallable(argument)) return argument;
    throw TypeError$2(tryToString(argument) + ' is not a function');
  };

  // `GetMethod` abstract operation
  // https://tc39.es/ecma262/#sec-getmethod
  var getMethod = function (V, P) {
    var func = V[P];
    return func == null ? undefined : aCallable(func);
  };

  var TypeError$3 = global_1.TypeError;

  // `OrdinaryToPrimitive` abstract operation
  // https://tc39.es/ecma262/#sec-ordinarytoprimitive
  var ordinaryToPrimitive = function (input, pref) {
    var fn, val;
    if (pref === 'string' && isCallable(fn = input.toString) && !isObject(val = functionCall(fn, input))) return val;
    if (isCallable(fn = input.valueOf) && !isObject(val = functionCall(fn, input))) return val;
    if (pref !== 'string' && isCallable(fn = input.toString) && !isObject(val = functionCall(fn, input))) return val;
    throw TypeError$3("Can't convert object to primitive value");
  };

  // eslint-disable-next-line es/no-object-defineproperty -- safe
  var defineProperty = Object.defineProperty;

  var setGlobal = function (key, value) {
    try {
      defineProperty(global_1, key, { value: value, configurable: true, writable: true });
    } catch (error) {
      global_1[key] = value;
    } return value;
  };

  var SHARED = '__core-js_shared__';
  var store = global_1[SHARED] || setGlobal(SHARED, {});

  var sharedStore = store;

  var shared = createCommonjsModule(function (module) {
  (module.exports = function (key, value) {
    return sharedStore[key] || (sharedStore[key] = value !== undefined ? value : {});
  })('versions', []).push({
    version: '3.20.2',
    mode:  'global',
    copyright: '© 2022 Denis Pushkarev (zloirock.ru)'
  });
  });

  var Object$3 = global_1.Object;

  // `ToObject` abstract operation
  // https://tc39.es/ecma262/#sec-toobject
  var toObject = function (argument) {
    return Object$3(requireObjectCoercible(argument));
  };

  var hasOwnProperty = functionUncurryThis({}.hasOwnProperty);

  // `HasOwnProperty` abstract operation
  // https://tc39.es/ecma262/#sec-hasownproperty
  var hasOwnProperty_1 = Object.hasOwn || function hasOwn(it, key) {
    return hasOwnProperty(toObject(it), key);
  };

  var id = 0;
  var postfix = Math.random();
  var toString$1 = functionUncurryThis(1.0.toString);

  var uid = function (key) {
    return 'Symbol(' + (key === undefined ? '' : key) + ')_' + toString$1(++id + postfix, 36);
  };

  var WellKnownSymbolsStore = shared('wks');
  var Symbol$1 = global_1.Symbol;
  var symbolFor = Symbol$1 && Symbol$1['for'];
  var createWellKnownSymbol = useSymbolAsUid ? Symbol$1 : Symbol$1 && Symbol$1.withoutSetter || uid;

  var wellKnownSymbol = function (name) {
    if (!hasOwnProperty_1(WellKnownSymbolsStore, name) || !(nativeSymbol || typeof WellKnownSymbolsStore[name] == 'string')) {
      var description = 'Symbol.' + name;
      if (nativeSymbol && hasOwnProperty_1(Symbol$1, name)) {
        WellKnownSymbolsStore[name] = Symbol$1[name];
      } else if (useSymbolAsUid && symbolFor) {
        WellKnownSymbolsStore[name] = symbolFor(description);
      } else {
        WellKnownSymbolsStore[name] = createWellKnownSymbol(description);
      }
    } return WellKnownSymbolsStore[name];
  };

  var TypeError$4 = global_1.TypeError;
  var TO_PRIMITIVE = wellKnownSymbol('toPrimitive');

  // `ToPrimitive` abstract operation
  // https://tc39.es/ecma262/#sec-toprimitive
  var toPrimitive = function (input, pref) {
    if (!isObject(input) || isSymbol(input)) return input;
    var exoticToPrim = getMethod(input, TO_PRIMITIVE);
    var result;
    if (exoticToPrim) {
      if (pref === undefined) pref = 'default';
      result = functionCall(exoticToPrim, input, pref);
      if (!isObject(result) || isSymbol(result)) return result;
      throw TypeError$4("Can't convert object to primitive value");
    }
    if (pref === undefined) pref = 'number';
    return ordinaryToPrimitive(input, pref);
  };

  // `ToPropertyKey` abstract operation
  // https://tc39.es/ecma262/#sec-topropertykey
  var toPropertyKey = function (argument) {
    var key = toPrimitive(argument, 'string');
    return isSymbol(key) ? key : key + '';
  };

  var document$1 = global_1.document;
  // typeof document.createElement is 'object' in old IE
  var EXISTS = isObject(document$1) && isObject(document$1.createElement);

  var documentCreateElement = function (it) {
    return EXISTS ? document$1.createElement(it) : {};
  };

  // Thank's IE8 for his funny defineProperty
  var ie8DomDefine = !descriptors && !fails(function () {
    // eslint-disable-next-line es/no-object-defineproperty -- required for testing
    return Object.defineProperty(documentCreateElement('div'), 'a', {
      get: function () { return 7; }
    }).a != 7;
  });

  // eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
  var $getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

  // `Object.getOwnPropertyDescriptor` method
  // https://tc39.es/ecma262/#sec-object.getownpropertydescriptor
  var f$1 = descriptors ? $getOwnPropertyDescriptor : function getOwnPropertyDescriptor(O, P) {
    O = toIndexedObject(O);
    P = toPropertyKey(P);
    if (ie8DomDefine) try {
      return $getOwnPropertyDescriptor(O, P);
    } catch (error) { /* empty */ }
    if (hasOwnProperty_1(O, P)) return createPropertyDescriptor(!functionCall(objectPropertyIsEnumerable.f, O, P), O[P]);
  };

  var objectGetOwnPropertyDescriptor = {
  	f: f$1
  };

  // V8 ~ Chrome 36-
  // https://bugs.chromium.org/p/v8/issues/detail?id=3334
  var v8PrototypeDefineBug = descriptors && fails(function () {
    // eslint-disable-next-line es/no-object-defineproperty -- required for testing
    return Object.defineProperty(function () { /* empty */ }, 'prototype', {
      value: 42,
      writable: false
    }).prototype != 42;
  });

  var String$2 = global_1.String;
  var TypeError$5 = global_1.TypeError;

  // `Assert: Type(argument) is Object`
  var anObject = function (argument) {
    if (isObject(argument)) return argument;
    throw TypeError$5(String$2(argument) + ' is not an object');
  };

  var TypeError$6 = global_1.TypeError;
  // eslint-disable-next-line es/no-object-defineproperty -- safe
  var $defineProperty = Object.defineProperty;
  // eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
  var $getOwnPropertyDescriptor$1 = Object.getOwnPropertyDescriptor;
  var ENUMERABLE = 'enumerable';
  var CONFIGURABLE = 'configurable';
  var WRITABLE = 'writable';

  // `Object.defineProperty` method
  // https://tc39.es/ecma262/#sec-object.defineproperty
  var f$2 = descriptors ? v8PrototypeDefineBug ? function defineProperty(O, P, Attributes) {
    anObject(O);
    P = toPropertyKey(P);
    anObject(Attributes);
    if (typeof O === 'function' && P === 'prototype' && 'value' in Attributes && WRITABLE in Attributes && !Attributes[WRITABLE]) {
      var current = $getOwnPropertyDescriptor$1(O, P);
      if (current && current[WRITABLE]) {
        O[P] = Attributes.value;
        Attributes = {
          configurable: CONFIGURABLE in Attributes ? Attributes[CONFIGURABLE] : current[CONFIGURABLE],
          enumerable: ENUMERABLE in Attributes ? Attributes[ENUMERABLE] : current[ENUMERABLE],
          writable: false
        };
      }
    } return $defineProperty(O, P, Attributes);
  } : $defineProperty : function defineProperty(O, P, Attributes) {
    anObject(O);
    P = toPropertyKey(P);
    anObject(Attributes);
    if (ie8DomDefine) try {
      return $defineProperty(O, P, Attributes);
    } catch (error) { /* empty */ }
    if ('get' in Attributes || 'set' in Attributes) throw TypeError$6('Accessors not supported');
    if ('value' in Attributes) O[P] = Attributes.value;
    return O;
  };

  var objectDefineProperty = {
  	f: f$2
  };

  var createNonEnumerableProperty = descriptors ? function (object, key, value) {
    return objectDefineProperty.f(object, key, createPropertyDescriptor(1, value));
  } : function (object, key, value) {
    object[key] = value;
    return object;
  };

  var functionToString = functionUncurryThis(Function.toString);

  // this helper broken in `core-js@3.4.1-3.4.4`, so we can't use `shared` helper
  if (!isCallable(sharedStore.inspectSource)) {
    sharedStore.inspectSource = function (it) {
      return functionToString(it);
    };
  }

  var inspectSource = sharedStore.inspectSource;

  var WeakMap = global_1.WeakMap;

  var nativeWeakMap = isCallable(WeakMap) && /native code/.test(inspectSource(WeakMap));

  var keys = shared('keys');

  var sharedKey = function (key) {
    return keys[key] || (keys[key] = uid(key));
  };

  var hiddenKeys = {};

  var OBJECT_ALREADY_INITIALIZED = 'Object already initialized';
  var TypeError$7 = global_1.TypeError;
  var WeakMap$1 = global_1.WeakMap;
  var set, get, has;

  var enforce = function (it) {
    return has(it) ? get(it) : set(it, {});
  };

  var getterFor = function (TYPE) {
    return function (it) {
      var state;
      if (!isObject(it) || (state = get(it)).type !== TYPE) {
        throw TypeError$7('Incompatible receiver, ' + TYPE + ' required');
      } return state;
    };
  };

  if (nativeWeakMap || sharedStore.state) {
    var store$1 = sharedStore.state || (sharedStore.state = new WeakMap$1());
    var wmget = functionUncurryThis(store$1.get);
    var wmhas = functionUncurryThis(store$1.has);
    var wmset = functionUncurryThis(store$1.set);
    set = function (it, metadata) {
      if (wmhas(store$1, it)) throw new TypeError$7(OBJECT_ALREADY_INITIALIZED);
      metadata.facade = it;
      wmset(store$1, it, metadata);
      return metadata;
    };
    get = function (it) {
      return wmget(store$1, it) || {};
    };
    has = function (it) {
      return wmhas(store$1, it);
    };
  } else {
    var STATE = sharedKey('state');
    hiddenKeys[STATE] = true;
    set = function (it, metadata) {
      if (hasOwnProperty_1(it, STATE)) throw new TypeError$7(OBJECT_ALREADY_INITIALIZED);
      metadata.facade = it;
      createNonEnumerableProperty(it, STATE, metadata);
      return metadata;
    };
    get = function (it) {
      return hasOwnProperty_1(it, STATE) ? it[STATE] : {};
    };
    has = function (it) {
      return hasOwnProperty_1(it, STATE);
    };
  }

  var internalState = {
    set: set,
    get: get,
    has: has,
    enforce: enforce,
    getterFor: getterFor
  };

  var FunctionPrototype$1 = Function.prototype;
  // eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
  var getDescriptor = descriptors && Object.getOwnPropertyDescriptor;

  var EXISTS$1 = hasOwnProperty_1(FunctionPrototype$1, 'name');
  // additional protection from minified / mangled / dropped function names
  var PROPER = EXISTS$1 && (function something() { /* empty */ }).name === 'something';
  var CONFIGURABLE$1 = EXISTS$1 && (!descriptors || (descriptors && getDescriptor(FunctionPrototype$1, 'name').configurable));

  var functionName = {
    EXISTS: EXISTS$1,
    PROPER: PROPER,
    CONFIGURABLE: CONFIGURABLE$1
  };

  var redefine = createCommonjsModule(function (module) {
  var CONFIGURABLE_FUNCTION_NAME = functionName.CONFIGURABLE;

  var getInternalState = internalState.get;
  var enforceInternalState = internalState.enforce;
  var TEMPLATE = String(String).split('String');

  (module.exports = function (O, key, value, options) {
    var unsafe = options ? !!options.unsafe : false;
    var simple = options ? !!options.enumerable : false;
    var noTargetGet = options ? !!options.noTargetGet : false;
    var name = options && options.name !== undefined ? options.name : key;
    var state;
    if (isCallable(value)) {
      if (String(name).slice(0, 7) === 'Symbol(') {
        name = '[' + String(name).replace(/^Symbol\(([^)]*)\)/, '$1') + ']';
      }
      if (!hasOwnProperty_1(value, 'name') || (CONFIGURABLE_FUNCTION_NAME && value.name !== name)) {
        createNonEnumerableProperty(value, 'name', name);
      }
      state = enforceInternalState(value);
      if (!state.source) {
        state.source = TEMPLATE.join(typeof name == 'string' ? name : '');
      }
    }
    if (O === global_1) {
      if (simple) O[key] = value;
      else setGlobal(key, value);
      return;
    } else if (!unsafe) {
      delete O[key];
    } else if (!noTargetGet && O[key]) {
      simple = true;
    }
    if (simple) O[key] = value;
    else createNonEnumerableProperty(O, key, value);
  // add fake Function#toString for correct work wrapped methods / constructors with methods like LoDash isNative
  })(Function.prototype, 'toString', function toString() {
    return isCallable(this) && getInternalState(this).source || inspectSource(this);
  });
  });

  var ceil = Math.ceil;
  var floor = Math.floor;

  // `ToIntegerOrInfinity` abstract operation
  // https://tc39.es/ecma262/#sec-tointegerorinfinity
  var toIntegerOrInfinity = function (argument) {
    var number = +argument;
    // eslint-disable-next-line no-self-compare -- safe
    return number !== number || number === 0 ? 0 : (number > 0 ? floor : ceil)(number);
  };

  var max = Math.max;
  var min = Math.min;

  // Helper for a popular repeating case of the spec:
  // Let integer be ? ToInteger(index).
  // If integer < 0, let result be max((length + integer), 0); else let result be min(integer, length).
  var toAbsoluteIndex = function (index, length) {
    var integer = toIntegerOrInfinity(index);
    return integer < 0 ? max(integer + length, 0) : min(integer, length);
  };

  var min$1 = Math.min;

  // `ToLength` abstract operation
  // https://tc39.es/ecma262/#sec-tolength
  var toLength = function (argument) {
    return argument > 0 ? min$1(toIntegerOrInfinity(argument), 0x1FFFFFFFFFFFFF) : 0; // 2 ** 53 - 1 == 9007199254740991
  };

  // `LengthOfArrayLike` abstract operation
  // https://tc39.es/ecma262/#sec-lengthofarraylike
  var lengthOfArrayLike = function (obj) {
    return toLength(obj.length);
  };

  // `Array.prototype.{ indexOf, includes }` methods implementation
  var createMethod = function (IS_INCLUDES) {
    return function ($this, el, fromIndex) {
      var O = toIndexedObject($this);
      var length = lengthOfArrayLike(O);
      var index = toAbsoluteIndex(fromIndex, length);
      var value;
      // Array#includes uses SameValueZero equality algorithm
      // eslint-disable-next-line no-self-compare -- NaN check
      if (IS_INCLUDES && el != el) while (length > index) {
        value = O[index++];
        // eslint-disable-next-line no-self-compare -- NaN check
        if (value != value) return true;
      // Array#indexOf ignores holes, Array#includes - not
      } else for (;length > index; index++) {
        if ((IS_INCLUDES || index in O) && O[index] === el) return IS_INCLUDES || index || 0;
      } return !IS_INCLUDES && -1;
    };
  };

  var arrayIncludes = {
    // `Array.prototype.includes` method
    // https://tc39.es/ecma262/#sec-array.prototype.includes
    includes: createMethod(true),
    // `Array.prototype.indexOf` method
    // https://tc39.es/ecma262/#sec-array.prototype.indexof
    indexOf: createMethod(false)
  };

  var indexOf = arrayIncludes.indexOf;


  var push = functionUncurryThis([].push);

  var objectKeysInternal = function (object, names) {
    var O = toIndexedObject(object);
    var i = 0;
    var result = [];
    var key;
    for (key in O) !hasOwnProperty_1(hiddenKeys, key) && hasOwnProperty_1(O, key) && push(result, key);
    // Don't enum bug & hidden keys
    while (names.length > i) if (hasOwnProperty_1(O, key = names[i++])) {
      ~indexOf(result, key) || push(result, key);
    }
    return result;
  };

  // IE8- don't enum bug keys
  var enumBugKeys = [
    'constructor',
    'hasOwnProperty',
    'isPrototypeOf',
    'propertyIsEnumerable',
    'toLocaleString',
    'toString',
    'valueOf'
  ];

  var hiddenKeys$1 = enumBugKeys.concat('length', 'prototype');

  // `Object.getOwnPropertyNames` method
  // https://tc39.es/ecma262/#sec-object.getownpropertynames
  // eslint-disable-next-line es/no-object-getownpropertynames -- safe
  var f$3 = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
    return objectKeysInternal(O, hiddenKeys$1);
  };

  var objectGetOwnPropertyNames = {
  	f: f$3
  };

  // eslint-disable-next-line es/no-object-getownpropertysymbols -- safe
  var f$4 = Object.getOwnPropertySymbols;

  var objectGetOwnPropertySymbols = {
  	f: f$4
  };

  var concat = functionUncurryThis([].concat);

  // all object keys, includes non-enumerable and symbols
  var ownKeys$1 = getBuiltIn('Reflect', 'ownKeys') || function ownKeys(it) {
    var keys = objectGetOwnPropertyNames.f(anObject(it));
    var getOwnPropertySymbols = objectGetOwnPropertySymbols.f;
    return getOwnPropertySymbols ? concat(keys, getOwnPropertySymbols(it)) : keys;
  };

  var copyConstructorProperties = function (target, source, exceptions) {
    var keys = ownKeys$1(source);
    var defineProperty = objectDefineProperty.f;
    var getOwnPropertyDescriptor = objectGetOwnPropertyDescriptor.f;
    for (var i = 0; i < keys.length; i++) {
      var key = keys[i];
      if (!hasOwnProperty_1(target, key) && !(exceptions && hasOwnProperty_1(exceptions, key))) {
        defineProperty(target, key, getOwnPropertyDescriptor(source, key));
      }
    }
  };

  var replacement = /#|\.prototype\./;

  var isForced = function (feature, detection) {
    var value = data[normalize(feature)];
    return value == POLYFILL ? true
      : value == NATIVE ? false
      : isCallable(detection) ? fails(detection)
      : !!detection;
  };

  var normalize = isForced.normalize = function (string) {
    return String(string).replace(replacement, '.').toLowerCase();
  };

  var data = isForced.data = {};
  var NATIVE = isForced.NATIVE = 'N';
  var POLYFILL = isForced.POLYFILL = 'P';

  var isForced_1 = isForced;

  var getOwnPropertyDescriptor$1 = objectGetOwnPropertyDescriptor.f;






  /*
    options.target      - name of the target object
    options.global      - target is the global object
    options.stat        - export as static methods of target
    options.proto       - export as prototype methods of target
    options.real        - real prototype method for the `pure` version
    options.forced      - export even if the native feature is available
    options.bind        - bind methods to the target, required for the `pure` version
    options.wrap        - wrap constructors to preventing global pollution, required for the `pure` version
    options.unsafe      - use the simple assignment of property instead of delete + defineProperty
    options.sham        - add a flag to not completely full polyfills
    options.enumerable  - export as enumerable property
    options.noTargetGet - prevent calling a getter on target
    options.name        - the .name of the function if it does not match the key
  */
  var _export = function (options, source) {
    var TARGET = options.target;
    var GLOBAL = options.global;
    var STATIC = options.stat;
    var FORCED, target, key, targetProperty, sourceProperty, descriptor;
    if (GLOBAL) {
      target = global_1;
    } else if (STATIC) {
      target = global_1[TARGET] || setGlobal(TARGET, {});
    } else {
      target = (global_1[TARGET] || {}).prototype;
    }
    if (target) for (key in source) {
      sourceProperty = source[key];
      if (options.noTargetGet) {
        descriptor = getOwnPropertyDescriptor$1(target, key);
        targetProperty = descriptor && descriptor.value;
      } else targetProperty = target[key];
      FORCED = isForced_1(GLOBAL ? key : TARGET + (STATIC ? '.' : '#') + key, options.forced);
      // contained in target
      if (!FORCED && targetProperty !== undefined) {
        if (typeof sourceProperty == typeof targetProperty) continue;
        copyConstructorProperties(sourceProperty, targetProperty);
      }
      // add a flag to not completely full polyfills
      if (options.sham || (targetProperty && targetProperty.sham)) {
        createNonEnumerableProperty(sourceProperty, 'sham', true);
      }
      // extend global
      redefine(target, key, sourceProperty, options);
    }
  };

  // `IsArray` abstract operation
  // https://tc39.es/ecma262/#sec-isarray
  // eslint-disable-next-line es/no-array-isarray -- safe
  var isArray = Array.isArray || function isArray(argument) {
    return classofRaw(argument) == 'Array';
  };

  var createProperty = function (object, key, value) {
    var propertyKey = toPropertyKey(key);
    if (propertyKey in object) objectDefineProperty.f(object, propertyKey, createPropertyDescriptor(0, value));
    else object[propertyKey] = value;
  };

  var TO_STRING_TAG = wellKnownSymbol('toStringTag');
  var test = {};

  test[TO_STRING_TAG] = 'z';

  var toStringTagSupport = String(test) === '[object z]';

  var TO_STRING_TAG$1 = wellKnownSymbol('toStringTag');
  var Object$4 = global_1.Object;

  // ES3 wrong here
  var CORRECT_ARGUMENTS = classofRaw(function () { return arguments; }()) == 'Arguments';

  // fallback for IE11 Script Access Denied error
  var tryGet = function (it, key) {
    try {
      return it[key];
    } catch (error) { /* empty */ }
  };

  // getting tag from ES6+ `Object.prototype.toString`
  var classof = toStringTagSupport ? classofRaw : function (it) {
    var O, tag, result;
    return it === undefined ? 'Undefined' : it === null ? 'Null'
      // @@toStringTag case
      : typeof (tag = tryGet(O = Object$4(it), TO_STRING_TAG$1)) == 'string' ? tag
      // builtinTag case
      : CORRECT_ARGUMENTS ? classofRaw(O)
      // ES3 arguments fallback
      : (result = classofRaw(O)) == 'Object' && isCallable(O.callee) ? 'Arguments' : result;
  };

  var noop = function () { /* empty */ };
  var empty = [];
  var construct = getBuiltIn('Reflect', 'construct');
  var constructorRegExp = /^\s*(?:class|function)\b/;
  var exec = functionUncurryThis(constructorRegExp.exec);
  var INCORRECT_TO_STRING = !constructorRegExp.exec(noop);

  var isConstructorModern = function isConstructor(argument) {
    if (!isCallable(argument)) return false;
    try {
      construct(noop, empty, argument);
      return true;
    } catch (error) {
      return false;
    }
  };

  var isConstructorLegacy = function isConstructor(argument) {
    if (!isCallable(argument)) return false;
    switch (classof(argument)) {
      case 'AsyncFunction':
      case 'GeneratorFunction':
      case 'AsyncGeneratorFunction': return false;
    }
    try {
      // we can't check .prototype since constructors produced by .bind haven't it
      // `Function#toString` throws on some built-it function in some legacy engines
      // (for example, `DOMQuad` and similar in FF41-)
      return INCORRECT_TO_STRING || !!exec(constructorRegExp, inspectSource(argument));
    } catch (error) {
      return true;
    }
  };

  isConstructorLegacy.sham = true;

  // `IsConstructor` abstract operation
  // https://tc39.es/ecma262/#sec-isconstructor
  var isConstructor = !construct || fails(function () {
    var called;
    return isConstructorModern(isConstructorModern.call)
      || !isConstructorModern(Object)
      || !isConstructorModern(function () { called = true; })
      || called;
  }) ? isConstructorLegacy : isConstructorModern;

  var SPECIES = wellKnownSymbol('species');
  var Array$1 = global_1.Array;

  // a part of `ArraySpeciesCreate` abstract operation
  // https://tc39.es/ecma262/#sec-arrayspeciescreate
  var arraySpeciesConstructor = function (originalArray) {
    var C;
    if (isArray(originalArray)) {
      C = originalArray.constructor;
      // cross-realm fallback
      if (isConstructor(C) && (C === Array$1 || isArray(C.prototype))) C = undefined;
      else if (isObject(C)) {
        C = C[SPECIES];
        if (C === null) C = undefined;
      }
    } return C === undefined ? Array$1 : C;
  };

  // `ArraySpeciesCreate` abstract operation
  // https://tc39.es/ecma262/#sec-arrayspeciescreate
  var arraySpeciesCreate = function (originalArray, length) {
    return new (arraySpeciesConstructor(originalArray))(length === 0 ? 0 : length);
  };

  var SPECIES$1 = wellKnownSymbol('species');

  var arrayMethodHasSpeciesSupport = function (METHOD_NAME) {
    // We can't use this feature detection in V8 since it causes
    // deoptimization and serious performance degradation
    // https://github.com/zloirock/core-js/issues/677
    return engineV8Version >= 51 || !fails(function () {
      var array = [];
      var constructor = array.constructor = {};
      constructor[SPECIES$1] = function () {
        return { foo: 1 };
      };
      return array[METHOD_NAME](Boolean).foo !== 1;
    });
  };

  var IS_CONCAT_SPREADABLE = wellKnownSymbol('isConcatSpreadable');
  var MAX_SAFE_INTEGER = 0x1FFFFFFFFFFFFF;
  var MAXIMUM_ALLOWED_INDEX_EXCEEDED = 'Maximum allowed index exceeded';
  var TypeError$8 = global_1.TypeError;

  // We can't use this feature detection in V8 since it causes
  // deoptimization and serious performance degradation
  // https://github.com/zloirock/core-js/issues/679
  var IS_CONCAT_SPREADABLE_SUPPORT = engineV8Version >= 51 || !fails(function () {
    var array = [];
    array[IS_CONCAT_SPREADABLE] = false;
    return array.concat()[0] !== array;
  });

  var SPECIES_SUPPORT = arrayMethodHasSpeciesSupport('concat');

  var isConcatSpreadable = function (O) {
    if (!isObject(O)) return false;
    var spreadable = O[IS_CONCAT_SPREADABLE];
    return spreadable !== undefined ? !!spreadable : isArray(O);
  };

  var FORCED = !IS_CONCAT_SPREADABLE_SUPPORT || !SPECIES_SUPPORT;

  // `Array.prototype.concat` method
  // https://tc39.es/ecma262/#sec-array.prototype.concat
  // with adding support of @@isConcatSpreadable and @@species
  _export({ target: 'Array', proto: true, forced: FORCED }, {
    // eslint-disable-next-line no-unused-vars -- required for `.length`
    concat: function concat(arg) {
      var O = toObject(this);
      var A = arraySpeciesCreate(O, 0);
      var n = 0;
      var i, k, length, len, E;
      for (i = -1, length = arguments.length; i < length; i++) {
        E = i === -1 ? O : arguments[i];
        if (isConcatSpreadable(E)) {
          len = lengthOfArrayLike(E);
          if (n + len > MAX_SAFE_INTEGER) throw TypeError$8(MAXIMUM_ALLOWED_INDEX_EXCEEDED);
          for (k = 0; k < len; k++, n++) if (k in E) createProperty(A, n, E[k]);
        } else {
          if (n >= MAX_SAFE_INTEGER) throw TypeError$8(MAXIMUM_ALLOWED_INDEX_EXCEEDED);
          createProperty(A, n++, E);
        }
      }
      A.length = n;
      return A;
    }
  });

  var bind$1 = functionUncurryThis(functionUncurryThis.bind);

  // optional / simple context binding
  var functionBindContext = function (fn, that) {
    aCallable(fn);
    return that === undefined ? fn : bind$1 ? bind$1(fn, that) : function (/* ...args */) {
      return fn.apply(that, arguments);
    };
  };

  var push$1 = functionUncurryThis([].push);

  // `Array.prototype.{ forEach, map, filter, some, every, find, findIndex, filterReject }` methods implementation
  var createMethod$1 = function (TYPE) {
    var IS_MAP = TYPE == 1;
    var IS_FILTER = TYPE == 2;
    var IS_SOME = TYPE == 3;
    var IS_EVERY = TYPE == 4;
    var IS_FIND_INDEX = TYPE == 6;
    var IS_FILTER_REJECT = TYPE == 7;
    var NO_HOLES = TYPE == 5 || IS_FIND_INDEX;
    return function ($this, callbackfn, that, specificCreate) {
      var O = toObject($this);
      var self = indexedObject(O);
      var boundFunction = functionBindContext(callbackfn, that);
      var length = lengthOfArrayLike(self);
      var index = 0;
      var create = specificCreate || arraySpeciesCreate;
      var target = IS_MAP ? create($this, length) : IS_FILTER || IS_FILTER_REJECT ? create($this, 0) : undefined;
      var value, result;
      for (;length > index; index++) if (NO_HOLES || index in self) {
        value = self[index];
        result = boundFunction(value, index, O);
        if (TYPE) {
          if (IS_MAP) target[index] = result; // map
          else if (result) switch (TYPE) {
            case 3: return true;              // some
            case 5: return value;             // find
            case 6: return index;             // findIndex
            case 2: push$1(target, value);      // filter
          } else switch (TYPE) {
            case 4: return false;             // every
            case 7: push$1(target, value);      // filterReject
          }
        }
      }
      return IS_FIND_INDEX ? -1 : IS_SOME || IS_EVERY ? IS_EVERY : target;
    };
  };

  var arrayIteration = {
    // `Array.prototype.forEach` method
    // https://tc39.es/ecma262/#sec-array.prototype.foreach
    forEach: createMethod$1(0),
    // `Array.prototype.map` method
    // https://tc39.es/ecma262/#sec-array.prototype.map
    map: createMethod$1(1),
    // `Array.prototype.filter` method
    // https://tc39.es/ecma262/#sec-array.prototype.filter
    filter: createMethod$1(2),
    // `Array.prototype.some` method
    // https://tc39.es/ecma262/#sec-array.prototype.some
    some: createMethod$1(3),
    // `Array.prototype.every` method
    // https://tc39.es/ecma262/#sec-array.prototype.every
    every: createMethod$1(4),
    // `Array.prototype.find` method
    // https://tc39.es/ecma262/#sec-array.prototype.find
    find: createMethod$1(5),
    // `Array.prototype.findIndex` method
    // https://tc39.es/ecma262/#sec-array.prototype.findIndex
    findIndex: createMethod$1(6),
    // `Array.prototype.filterReject` method
    // https://github.com/tc39/proposal-array-filtering
    filterReject: createMethod$1(7)
  };

  var arrayMethodIsStrict = function (METHOD_NAME, argument) {
    var method = [][METHOD_NAME];
    return !!method && fails(function () {
      // eslint-disable-next-line no-useless-call,no-throw-literal -- required for testing
      method.call(null, argument || function () { throw 1; }, 1);
    });
  };

  var $forEach = arrayIteration.forEach;


  var STRICT_METHOD = arrayMethodIsStrict('forEach');

  // `Array.prototype.forEach` method implementation
  // https://tc39.es/ecma262/#sec-array.prototype.foreach
  var arrayForEach = !STRICT_METHOD ? function forEach(callbackfn /* , thisArg */) {
    return $forEach(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
  // eslint-disable-next-line es/no-array-prototype-foreach -- safe
  } : [].forEach;

  // `Array.prototype.forEach` method
  // https://tc39.es/ecma262/#sec-array.prototype.foreach
  // eslint-disable-next-line es/no-array-prototype-foreach -- safe
  _export({ target: 'Array', proto: true, forced: [].forEach != arrayForEach }, {
    forEach: arrayForEach
  });

  // `Object.prototype.toString` method implementation
  // https://tc39.es/ecma262/#sec-object.prototype.tostring
  var objectToString = toStringTagSupport ? {}.toString : function toString() {
    return '[object ' + classof(this) + ']';
  };

  // `Object.prototype.toString` method
  // https://tc39.es/ecma262/#sec-object.prototype.tostring
  if (!toStringTagSupport) {
    redefine(Object.prototype, 'toString', objectToString, { unsafe: true });
  }

  // iterable DOM collections
  // flag - `iterable` interface - 'entries', 'keys', 'values', 'forEach' methods
  var domIterables = {
    CSSRuleList: 0,
    CSSStyleDeclaration: 0,
    CSSValueList: 0,
    ClientRectList: 0,
    DOMRectList: 0,
    DOMStringList: 0,
    DOMTokenList: 1,
    DataTransferItemList: 0,
    FileList: 0,
    HTMLAllCollection: 0,
    HTMLCollection: 0,
    HTMLFormElement: 0,
    HTMLSelectElement: 0,
    MediaList: 0,
    MimeTypeArray: 0,
    NamedNodeMap: 0,
    NodeList: 1,
    PaintRequestList: 0,
    Plugin: 0,
    PluginArray: 0,
    SVGLengthList: 0,
    SVGNumberList: 0,
    SVGPathSegList: 0,
    SVGPointList: 0,
    SVGStringList: 0,
    SVGTransformList: 0,
    SourceBufferList: 0,
    StyleSheetList: 0,
    TextTrackCueList: 0,
    TextTrackList: 0,
    TouchList: 0
  };

  // in old WebKit versions, `element.classList` is not an instance of global `DOMTokenList`


  var classList = documentCreateElement('span').classList;
  var DOMTokenListPrototype = classList && classList.constructor && classList.constructor.prototype;

  var domTokenListPrototype = DOMTokenListPrototype === Object.prototype ? undefined : DOMTokenListPrototype;

  var handlePrototype = function (CollectionPrototype) {
    // some Chrome versions have non-configurable methods on DOMTokenList
    if (CollectionPrototype && CollectionPrototype.forEach !== arrayForEach) try {
      createNonEnumerableProperty(CollectionPrototype, 'forEach', arrayForEach);
    } catch (error) {
      CollectionPrototype.forEach = arrayForEach;
    }
  };

  for (var COLLECTION_NAME in domIterables) {
    if (domIterables[COLLECTION_NAME]) {
      handlePrototype(global_1[COLLECTION_NAME] && global_1[COLLECTION_NAME].prototype);
    }
  }

  handlePrototype(domTokenListPrototype);

  var String$3 = global_1.String;

  var toString_1 = function (argument) {
    if (classof(argument) === 'Symbol') throw TypeError('Cannot convert a Symbol value to a string');
    return String$3(argument);
  };

  // a string of all valid unicode whitespaces
  var whitespaces = '\u0009\u000A\u000B\u000C\u000D\u0020\u00A0\u1680\u2000\u2001\u2002' +
    '\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF';

  var replace = functionUncurryThis(''.replace);
  var whitespace = '[' + whitespaces + ']';
  var ltrim = RegExp('^' + whitespace + whitespace + '*');
  var rtrim = RegExp(whitespace + whitespace + '*$');

  // `String.prototype.{ trim, trimStart, trimEnd, trimLeft, trimRight }` methods implementation
  var createMethod$2 = function (TYPE) {
    return function ($this) {
      var string = toString_1(requireObjectCoercible($this));
      if (TYPE & 1) string = replace(string, ltrim, '');
      if (TYPE & 2) string = replace(string, rtrim, '');
      return string;
    };
  };

  var stringTrim = {
    // `String.prototype.{ trimLeft, trimStart }` methods
    // https://tc39.es/ecma262/#sec-string.prototype.trimstart
    start: createMethod$2(1),
    // `String.prototype.{ trimRight, trimEnd }` methods
    // https://tc39.es/ecma262/#sec-string.prototype.trimend
    end: createMethod$2(2),
    // `String.prototype.trim` method
    // https://tc39.es/ecma262/#sec-string.prototype.trim
    trim: createMethod$2(3)
  };

  var trim = stringTrim.trim;


  var $parseInt = global_1.parseInt;
  var Symbol$2 = global_1.Symbol;
  var ITERATOR = Symbol$2 && Symbol$2.iterator;
  var hex = /^[+-]?0x/i;
  var exec$1 = functionUncurryThis(hex.exec);
  var FORCED$1 = $parseInt(whitespaces + '08') !== 8 || $parseInt(whitespaces + '0x16') !== 22
    // MS Edge 18- broken with boxed symbols
    || (ITERATOR && !fails(function () { $parseInt(Object(ITERATOR)); }));

  // `parseInt` method
  // https://tc39.es/ecma262/#sec-parseint-string-radix
  var numberParseInt = FORCED$1 ? function parseInt(string, radix) {
    var S = trim(toString_1(string));
    return $parseInt(S, (radix >>> 0) || (exec$1(hex, S) ? 16 : 10));
  } : $parseInt;

  // `parseInt` method
  // https://tc39.es/ecma262/#sec-parseint-string-radix
  _export({ global: true, forced: parseInt != numberParseInt }, {
    parseInt: numberParseInt
  });

  var nativePromiseConstructor = global_1.Promise;

  var redefineAll = function (target, src, options) {
    for (var key in src) redefine(target, key, src[key], options);
    return target;
  };

  var String$4 = global_1.String;
  var TypeError$9 = global_1.TypeError;

  var aPossiblePrototype = function (argument) {
    if (typeof argument == 'object' || isCallable(argument)) return argument;
    throw TypeError$9("Can't set " + String$4(argument) + ' as a prototype');
  };

  /* eslint-disable no-proto -- safe */




  // `Object.setPrototypeOf` method
  // https://tc39.es/ecma262/#sec-object.setprototypeof
  // Works with __proto__ only. Old v8 can't work with null proto objects.
  // eslint-disable-next-line es/no-object-setprototypeof -- safe
  var objectSetPrototypeOf = Object.setPrototypeOf || ('__proto__' in {} ? function () {
    var CORRECT_SETTER = false;
    var test = {};
    var setter;
    try {
      // eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
      setter = functionUncurryThis(Object.getOwnPropertyDescriptor(Object.prototype, '__proto__').set);
      setter(test, []);
      CORRECT_SETTER = test instanceof Array;
    } catch (error) { /* empty */ }
    return function setPrototypeOf(O, proto) {
      anObject(O);
      aPossiblePrototype(proto);
      if (CORRECT_SETTER) setter(O, proto);
      else O.__proto__ = proto;
      return O;
    };
  }() : undefined);

  var defineProperty$1 = objectDefineProperty.f;



  var TO_STRING_TAG$2 = wellKnownSymbol('toStringTag');

  var setToStringTag = function (target, TAG, STATIC) {
    if (target && !STATIC) target = target.prototype;
    if (target && !hasOwnProperty_1(target, TO_STRING_TAG$2)) {
      defineProperty$1(target, TO_STRING_TAG$2, { configurable: true, value: TAG });
    }
  };

  var SPECIES$2 = wellKnownSymbol('species');

  var setSpecies = function (CONSTRUCTOR_NAME) {
    var Constructor = getBuiltIn(CONSTRUCTOR_NAME);
    var defineProperty = objectDefineProperty.f;

    if (descriptors && Constructor && !Constructor[SPECIES$2]) {
      defineProperty(Constructor, SPECIES$2, {
        configurable: true,
        get: function () { return this; }
      });
    }
  };

  var TypeError$a = global_1.TypeError;

  var anInstance = function (it, Prototype) {
    if (objectIsPrototypeOf(Prototype, it)) return it;
    throw TypeError$a('Incorrect invocation');
  };

  var iterators = {};

  var ITERATOR$1 = wellKnownSymbol('iterator');
  var ArrayPrototype = Array.prototype;

  // check on default Array iterator
  var isArrayIteratorMethod = function (it) {
    return it !== undefined && (iterators.Array === it || ArrayPrototype[ITERATOR$1] === it);
  };

  var ITERATOR$2 = wellKnownSymbol('iterator');

  var getIteratorMethod = function (it) {
    if (it != undefined) return getMethod(it, ITERATOR$2)
      || getMethod(it, '@@iterator')
      || iterators[classof(it)];
  };

  var TypeError$b = global_1.TypeError;

  var getIterator = function (argument, usingIterator) {
    var iteratorMethod = arguments.length < 2 ? getIteratorMethod(argument) : usingIterator;
    if (aCallable(iteratorMethod)) return anObject(functionCall(iteratorMethod, argument));
    throw TypeError$b(tryToString(argument) + ' is not iterable');
  };

  var iteratorClose = function (iterator, kind, value) {
    var innerResult, innerError;
    anObject(iterator);
    try {
      innerResult = getMethod(iterator, 'return');
      if (!innerResult) {
        if (kind === 'throw') throw value;
        return value;
      }
      innerResult = functionCall(innerResult, iterator);
    } catch (error) {
      innerError = true;
      innerResult = error;
    }
    if (kind === 'throw') throw value;
    if (innerError) throw innerResult;
    anObject(innerResult);
    return value;
  };

  var TypeError$c = global_1.TypeError;

  var Result = function (stopped, result) {
    this.stopped = stopped;
    this.result = result;
  };

  var ResultPrototype = Result.prototype;

  var iterate = function (iterable, unboundFunction, options) {
    var that = options && options.that;
    var AS_ENTRIES = !!(options && options.AS_ENTRIES);
    var IS_ITERATOR = !!(options && options.IS_ITERATOR);
    var INTERRUPTED = !!(options && options.INTERRUPTED);
    var fn = functionBindContext(unboundFunction, that);
    var iterator, iterFn, index, length, result, next, step;

    var stop = function (condition) {
      if (iterator) iteratorClose(iterator, 'normal', condition);
      return new Result(true, condition);
    };

    var callFn = function (value) {
      if (AS_ENTRIES) {
        anObject(value);
        return INTERRUPTED ? fn(value[0], value[1], stop) : fn(value[0], value[1]);
      } return INTERRUPTED ? fn(value, stop) : fn(value);
    };

    if (IS_ITERATOR) {
      iterator = iterable;
    } else {
      iterFn = getIteratorMethod(iterable);
      if (!iterFn) throw TypeError$c(tryToString(iterable) + ' is not iterable');
      // optimisation for array iterators
      if (isArrayIteratorMethod(iterFn)) {
        for (index = 0, length = lengthOfArrayLike(iterable); length > index; index++) {
          result = callFn(iterable[index]);
          if (result && objectIsPrototypeOf(ResultPrototype, result)) return result;
        } return new Result(false);
      }
      iterator = getIterator(iterable, iterFn);
    }

    next = iterator.next;
    while (!(step = functionCall(next, iterator)).done) {
      try {
        result = callFn(step.value);
      } catch (error) {
        iteratorClose(iterator, 'throw', error);
      }
      if (typeof result == 'object' && result && objectIsPrototypeOf(ResultPrototype, result)) return result;
    } return new Result(false);
  };

  var ITERATOR$3 = wellKnownSymbol('iterator');
  var SAFE_CLOSING = false;

  try {
    var called = 0;
    var iteratorWithReturn = {
      next: function () {
        return { done: !!called++ };
      },
      'return': function () {
        SAFE_CLOSING = true;
      }
    };
    iteratorWithReturn[ITERATOR$3] = function () {
      return this;
    };
    // eslint-disable-next-line es/no-array-from, no-throw-literal -- required for testing
    Array.from(iteratorWithReturn, function () { throw 2; });
  } catch (error) { /* empty */ }

  var checkCorrectnessOfIteration = function (exec, SKIP_CLOSING) {
    if (!SKIP_CLOSING && !SAFE_CLOSING) return false;
    var ITERATION_SUPPORT = false;
    try {
      var object = {};
      object[ITERATOR$3] = function () {
        return {
          next: function () {
            return { done: ITERATION_SUPPORT = true };
          }
        };
      };
      exec(object);
    } catch (error) { /* empty */ }
    return ITERATION_SUPPORT;
  };

  var TypeError$d = global_1.TypeError;

  // `Assert: IsConstructor(argument) is true`
  var aConstructor = function (argument) {
    if (isConstructor(argument)) return argument;
    throw TypeError$d(tryToString(argument) + ' is not a constructor');
  };

  var SPECIES$3 = wellKnownSymbol('species');

  // `SpeciesConstructor` abstract operation
  // https://tc39.es/ecma262/#sec-speciesconstructor
  var speciesConstructor = function (O, defaultConstructor) {
    var C = anObject(O).constructor;
    var S;
    return C === undefined || (S = anObject(C)[SPECIES$3]) == undefined ? defaultConstructor : aConstructor(S);
  };

  var FunctionPrototype$2 = Function.prototype;
  var apply = FunctionPrototype$2.apply;
  var bind$2 = FunctionPrototype$2.bind;
  var call$2 = FunctionPrototype$2.call;

  // eslint-disable-next-line es/no-reflect -- safe
  var functionApply = typeof Reflect == 'object' && Reflect.apply || (bind$2 ? call$2.bind(apply) : function () {
    return call$2.apply(apply, arguments);
  });

  var html = getBuiltIn('document', 'documentElement');

  var arraySlice = functionUncurryThis([].slice);

  var engineIsIos = /(?:ipad|iphone|ipod).*applewebkit/i.test(engineUserAgent);

  var engineIsNode = classofRaw(global_1.process) == 'process';

  var set$1 = global_1.setImmediate;
  var clear = global_1.clearImmediate;
  var process$1 = global_1.process;
  var Dispatch = global_1.Dispatch;
  var Function$1 = global_1.Function;
  var MessageChannel = global_1.MessageChannel;
  var String$5 = global_1.String;
  var counter = 0;
  var queue = {};
  var ONREADYSTATECHANGE = 'onreadystatechange';
  var location$1, defer, channel, port;

  try {
    // Deno throws a ReferenceError on `location` access without `--location` flag
    location$1 = global_1.location;
  } catch (error) { /* empty */ }

  var run = function (id) {
    if (hasOwnProperty_1(queue, id)) {
      var fn = queue[id];
      delete queue[id];
      fn();
    }
  };

  var runner = function (id) {
    return function () {
      run(id);
    };
  };

  var listener = function (event) {
    run(event.data);
  };

  var post = function (id) {
    // old engines have not location.origin
    global_1.postMessage(String$5(id), location$1.protocol + '//' + location$1.host);
  };

  // Node.js 0.9+ & IE10+ has setImmediate, otherwise:
  if (!set$1 || !clear) {
    set$1 = function setImmediate(fn) {
      var args = arraySlice(arguments, 1);
      queue[++counter] = function () {
        functionApply(isCallable(fn) ? fn : Function$1(fn), undefined, args);
      };
      defer(counter);
      return counter;
    };
    clear = function clearImmediate(id) {
      delete queue[id];
    };
    // Node.js 0.8-
    if (engineIsNode) {
      defer = function (id) {
        process$1.nextTick(runner(id));
      };
    // Sphere (JS game engine) Dispatch API
    } else if (Dispatch && Dispatch.now) {
      defer = function (id) {
        Dispatch.now(runner(id));
      };
    // Browsers with MessageChannel, includes WebWorkers
    // except iOS - https://github.com/zloirock/core-js/issues/624
    } else if (MessageChannel && !engineIsIos) {
      channel = new MessageChannel();
      port = channel.port2;
      channel.port1.onmessage = listener;
      defer = functionBindContext(port.postMessage, port);
    // Browsers with postMessage, skip WebWorkers
    // IE8 has postMessage, but it's sync & typeof its postMessage is 'object'
    } else if (
      global_1.addEventListener &&
      isCallable(global_1.postMessage) &&
      !global_1.importScripts &&
      location$1 && location$1.protocol !== 'file:' &&
      !fails(post)
    ) {
      defer = post;
      global_1.addEventListener('message', listener, false);
    // IE8-
    } else if (ONREADYSTATECHANGE in documentCreateElement('script')) {
      defer = function (id) {
        html.appendChild(documentCreateElement('script'))[ONREADYSTATECHANGE] = function () {
          html.removeChild(this);
          run(id);
        };
      };
    // Rest old browsers
    } else {
      defer = function (id) {
        setTimeout(runner(id), 0);
      };
    }
  }

  var task = {
    set: set$1,
    clear: clear
  };

  var engineIsIosPebble = /ipad|iphone|ipod/i.test(engineUserAgent) && global_1.Pebble !== undefined;

  var engineIsWebosWebkit = /web0s(?!.*chrome)/i.test(engineUserAgent);

  var getOwnPropertyDescriptor$2 = objectGetOwnPropertyDescriptor.f;
  var macrotask = task.set;





  var MutationObserver = global_1.MutationObserver || global_1.WebKitMutationObserver;
  var document$2 = global_1.document;
  var process$2 = global_1.process;
  var Promise$1 = global_1.Promise;
  // Node.js 11 shows ExperimentalWarning on getting `queueMicrotask`
  var queueMicrotaskDescriptor = getOwnPropertyDescriptor$2(global_1, 'queueMicrotask');
  var queueMicrotask = queueMicrotaskDescriptor && queueMicrotaskDescriptor.value;

  var flush, head, last, notify, toggle, node, promise, then;

  // modern engines have queueMicrotask method
  if (!queueMicrotask) {
    flush = function () {
      var parent, fn;
      if (engineIsNode && (parent = process$2.domain)) parent.exit();
      while (head) {
        fn = head.fn;
        head = head.next;
        try {
          fn();
        } catch (error) {
          if (head) notify();
          else last = undefined;
          throw error;
        }
      } last = undefined;
      if (parent) parent.enter();
    };

    // browsers with MutationObserver, except iOS - https://github.com/zloirock/core-js/issues/339
    // also except WebOS Webkit https://github.com/zloirock/core-js/issues/898
    if (!engineIsIos && !engineIsNode && !engineIsWebosWebkit && MutationObserver && document$2) {
      toggle = true;
      node = document$2.createTextNode('');
      new MutationObserver(flush).observe(node, { characterData: true });
      notify = function () {
        node.data = toggle = !toggle;
      };
    // environments with maybe non-completely correct, but existent Promise
    } else if (!engineIsIosPebble && Promise$1 && Promise$1.resolve) {
      // Promise.resolve without an argument throws an error in LG WebOS 2
      promise = Promise$1.resolve(undefined);
      // workaround of WebKit ~ iOS Safari 10.1 bug
      promise.constructor = Promise$1;
      then = functionBindContext(promise.then, promise);
      notify = function () {
        then(flush);
      };
    // Node.js without promises
    } else if (engineIsNode) {
      notify = function () {
        process$2.nextTick(flush);
      };
    // for other environments - macrotask based on:
    // - setImmediate
    // - MessageChannel
    // - window.postMessag
    // - onreadystatechange
    // - setTimeout
    } else {
      // strange IE + webpack dev server bug - use .bind(global)
      macrotask = functionBindContext(macrotask, global_1);
      notify = function () {
        macrotask(flush);
      };
    }
  }

  var microtask = queueMicrotask || function (fn) {
    var task = { fn: fn, next: undefined };
    if (last) last.next = task;
    if (!head) {
      head = task;
      notify();
    } last = task;
  };

  var PromiseCapability = function (C) {
    var resolve, reject;
    this.promise = new C(function ($$resolve, $$reject) {
      if (resolve !== undefined || reject !== undefined) throw TypeError('Bad Promise constructor');
      resolve = $$resolve;
      reject = $$reject;
    });
    this.resolve = aCallable(resolve);
    this.reject = aCallable(reject);
  };

  // `NewPromiseCapability` abstract operation
  // https://tc39.es/ecma262/#sec-newpromisecapability
  var f$5 = function (C) {
    return new PromiseCapability(C);
  };

  var newPromiseCapability = {
  	f: f$5
  };

  var promiseResolve = function (C, x) {
    anObject(C);
    if (isObject(x) && x.constructor === C) return x;
    var promiseCapability = newPromiseCapability.f(C);
    var resolve = promiseCapability.resolve;
    resolve(x);
    return promiseCapability.promise;
  };

  var hostReportErrors = function (a, b) {
    var console = global_1.console;
    if (console && console.error) {
      arguments.length == 1 ? console.error(a) : console.error(a, b);
    }
  };

  var perform = function (exec) {
    try {
      return { error: false, value: exec() };
    } catch (error) {
      return { error: true, value: error };
    }
  };

  var Queue = function () {
    this.head = null;
    this.tail = null;
  };

  Queue.prototype = {
    add: function (item) {
      var entry = { item: item, next: null };
      if (this.head) this.tail.next = entry;
      else this.head = entry;
      this.tail = entry;
    },
    get: function () {
      var entry = this.head;
      if (entry) {
        this.head = entry.next;
        if (this.tail === entry) this.tail = null;
        return entry.item;
      }
    }
  };

  var queue$1 = Queue;

  var engineIsBrowser = typeof window == 'object';

  var task$1 = task.set;













  var SPECIES$4 = wellKnownSymbol('species');
  var PROMISE = 'Promise';

  var getInternalState = internalState.getterFor(PROMISE);
  var setInternalState = internalState.set;
  var getInternalPromiseState = internalState.getterFor(PROMISE);
  var NativePromisePrototype = nativePromiseConstructor && nativePromiseConstructor.prototype;
  var PromiseConstructor = nativePromiseConstructor;
  var PromisePrototype = NativePromisePrototype;
  var TypeError$e = global_1.TypeError;
  var document$3 = global_1.document;
  var process$3 = global_1.process;
  var newPromiseCapability$1 = newPromiseCapability.f;
  var newGenericPromiseCapability = newPromiseCapability$1;

  var DISPATCH_EVENT = !!(document$3 && document$3.createEvent && global_1.dispatchEvent);
  var NATIVE_REJECTION_EVENT = isCallable(global_1.PromiseRejectionEvent);
  var UNHANDLED_REJECTION = 'unhandledrejection';
  var REJECTION_HANDLED = 'rejectionhandled';
  var PENDING = 0;
  var FULFILLED = 1;
  var REJECTED = 2;
  var HANDLED = 1;
  var UNHANDLED = 2;
  var SUBCLASSING = false;

  var Internal, OwnPromiseCapability, PromiseWrapper, nativeThen;

  var FORCED$2 = isForced_1(PROMISE, function () {
    var PROMISE_CONSTRUCTOR_SOURCE = inspectSource(PromiseConstructor);
    var GLOBAL_CORE_JS_PROMISE = PROMISE_CONSTRUCTOR_SOURCE !== String(PromiseConstructor);
    // V8 6.6 (Node 10 and Chrome 66) have a bug with resolving custom thenables
    // https://bugs.chromium.org/p/chromium/issues/detail?id=830565
    // We can't detect it synchronously, so just check versions
    if (!GLOBAL_CORE_JS_PROMISE && engineV8Version === 66) return true;
    // We can't use @@species feature detection in V8 since it causes
    // deoptimization and performance degradation
    // https://github.com/zloirock/core-js/issues/679
    if (engineV8Version >= 51 && /native code/.test(PROMISE_CONSTRUCTOR_SOURCE)) return false;
    // Detect correctness of subclassing with @@species support
    var promise = new PromiseConstructor(function (resolve) { resolve(1); });
    var FakePromise = function (exec) {
      exec(function () { /* empty */ }, function () { /* empty */ });
    };
    var constructor = promise.constructor = {};
    constructor[SPECIES$4] = FakePromise;
    SUBCLASSING = promise.then(function () { /* empty */ }) instanceof FakePromise;
    if (!SUBCLASSING) return true;
    // Unhandled rejections tracking support, NodeJS Promise without it fails @@species test
    return !GLOBAL_CORE_JS_PROMISE && engineIsBrowser && !NATIVE_REJECTION_EVENT;
  });

  var INCORRECT_ITERATION = FORCED$2 || !checkCorrectnessOfIteration(function (iterable) {
    PromiseConstructor.all(iterable)['catch'](function () { /* empty */ });
  });

  // helpers
  var isThenable = function (it) {
    var then;
    return isObject(it) && isCallable(then = it.then) ? then : false;
  };

  var callReaction = function (reaction, state) {
    var value = state.value;
    var ok = state.state == FULFILLED;
    var handler = ok ? reaction.ok : reaction.fail;
    var resolve = reaction.resolve;
    var reject = reaction.reject;
    var domain = reaction.domain;
    var result, then, exited;
    try {
      if (handler) {
        if (!ok) {
          if (state.rejection === UNHANDLED) onHandleUnhandled(state);
          state.rejection = HANDLED;
        }
        if (handler === true) result = value;
        else {
          if (domain) domain.enter();
          result = handler(value); // can throw
          if (domain) {
            domain.exit();
            exited = true;
          }
        }
        if (result === reaction.promise) {
          reject(TypeError$e('Promise-chain cycle'));
        } else if (then = isThenable(result)) {
          functionCall(then, result, resolve, reject);
        } else resolve(result);
      } else reject(value);
    } catch (error) {
      if (domain && !exited) domain.exit();
      reject(error);
    }
  };

  var notify$1 = function (state, isReject) {
    if (state.notified) return;
    state.notified = true;
    microtask(function () {
      var reactions = state.reactions;
      var reaction;
      while (reaction = reactions.get()) {
        callReaction(reaction, state);
      }
      state.notified = false;
      if (isReject && !state.rejection) onUnhandled(state);
    });
  };

  var dispatchEvent = function (name, promise, reason) {
    var event, handler;
    if (DISPATCH_EVENT) {
      event = document$3.createEvent('Event');
      event.promise = promise;
      event.reason = reason;
      event.initEvent(name, false, true);
      global_1.dispatchEvent(event);
    } else event = { promise: promise, reason: reason };
    if (!NATIVE_REJECTION_EVENT && (handler = global_1['on' + name])) handler(event);
    else if (name === UNHANDLED_REJECTION) hostReportErrors('Unhandled promise rejection', reason);
  };

  var onUnhandled = function (state) {
    functionCall(task$1, global_1, function () {
      var promise = state.facade;
      var value = state.value;
      var IS_UNHANDLED = isUnhandled(state);
      var result;
      if (IS_UNHANDLED) {
        result = perform(function () {
          if (engineIsNode) {
            process$3.emit('unhandledRejection', value, promise);
          } else dispatchEvent(UNHANDLED_REJECTION, promise, value);
        });
        // Browsers should not trigger `rejectionHandled` event if it was handled here, NodeJS - should
        state.rejection = engineIsNode || isUnhandled(state) ? UNHANDLED : HANDLED;
        if (result.error) throw result.value;
      }
    });
  };

  var isUnhandled = function (state) {
    return state.rejection !== HANDLED && !state.parent;
  };

  var onHandleUnhandled = function (state) {
    functionCall(task$1, global_1, function () {
      var promise = state.facade;
      if (engineIsNode) {
        process$3.emit('rejectionHandled', promise);
      } else dispatchEvent(REJECTION_HANDLED, promise, state.value);
    });
  };

  var bind$3 = function (fn, state, unwrap) {
    return function (value) {
      fn(state, value, unwrap);
    };
  };

  var internalReject = function (state, value, unwrap) {
    if (state.done) return;
    state.done = true;
    if (unwrap) state = unwrap;
    state.value = value;
    state.state = REJECTED;
    notify$1(state, true);
  };

  var internalResolve = function (state, value, unwrap) {
    if (state.done) return;
    state.done = true;
    if (unwrap) state = unwrap;
    try {
      if (state.facade === value) throw TypeError$e("Promise can't be resolved itself");
      var then = isThenable(value);
      if (then) {
        microtask(function () {
          var wrapper = { done: false };
          try {
            functionCall(then, value,
              bind$3(internalResolve, wrapper, state),
              bind$3(internalReject, wrapper, state)
            );
          } catch (error) {
            internalReject(wrapper, error, state);
          }
        });
      } else {
        state.value = value;
        state.state = FULFILLED;
        notify$1(state, false);
      }
    } catch (error) {
      internalReject({ done: false }, error, state);
    }
  };

  // constructor polyfill
  if (FORCED$2) {
    // 25.4.3.1 Promise(executor)
    PromiseConstructor = function Promise(executor) {
      anInstance(this, PromisePrototype);
      aCallable(executor);
      functionCall(Internal, this);
      var state = getInternalState(this);
      try {
        executor(bind$3(internalResolve, state), bind$3(internalReject, state));
      } catch (error) {
        internalReject(state, error);
      }
    };
    PromisePrototype = PromiseConstructor.prototype;
    // eslint-disable-next-line no-unused-vars -- required for `.length`
    Internal = function Promise(executor) {
      setInternalState(this, {
        type: PROMISE,
        done: false,
        notified: false,
        parent: false,
        reactions: new queue$1(),
        rejection: false,
        state: PENDING,
        value: undefined
      });
    };
    Internal.prototype = redefineAll(PromisePrototype, {
      // `Promise.prototype.then` method
      // https://tc39.es/ecma262/#sec-promise.prototype.then
      // eslint-disable-next-line unicorn/no-thenable -- safe
      then: function then(onFulfilled, onRejected) {
        var state = getInternalPromiseState(this);
        var reaction = newPromiseCapability$1(speciesConstructor(this, PromiseConstructor));
        state.parent = true;
        reaction.ok = isCallable(onFulfilled) ? onFulfilled : true;
        reaction.fail = isCallable(onRejected) && onRejected;
        reaction.domain = engineIsNode ? process$3.domain : undefined;
        if (state.state == PENDING) state.reactions.add(reaction);
        else microtask(function () {
          callReaction(reaction, state);
        });
        return reaction.promise;
      },
      // `Promise.prototype.catch` method
      // https://tc39.es/ecma262/#sec-promise.prototype.catch
      'catch': function (onRejected) {
        return this.then(undefined, onRejected);
      }
    });
    OwnPromiseCapability = function () {
      var promise = new Internal();
      var state = getInternalState(promise);
      this.promise = promise;
      this.resolve = bind$3(internalResolve, state);
      this.reject = bind$3(internalReject, state);
    };
    newPromiseCapability.f = newPromiseCapability$1 = function (C) {
      return C === PromiseConstructor || C === PromiseWrapper
        ? new OwnPromiseCapability(C)
        : newGenericPromiseCapability(C);
    };

    if ( isCallable(nativePromiseConstructor) && NativePromisePrototype !== Object.prototype) {
      nativeThen = NativePromisePrototype.then;

      if (!SUBCLASSING) {
        // make `Promise#then` return a polyfilled `Promise` for native promise-based APIs
        redefine(NativePromisePrototype, 'then', function then(onFulfilled, onRejected) {
          var that = this;
          return new PromiseConstructor(function (resolve, reject) {
            functionCall(nativeThen, that, resolve, reject);
          }).then(onFulfilled, onRejected);
        // https://github.com/zloirock/core-js/issues/640
        }, { unsafe: true });

        // makes sure that native promise-based APIs `Promise#catch` properly works with patched `Promise#then`
        redefine(NativePromisePrototype, 'catch', PromisePrototype['catch'], { unsafe: true });
      }

      // make `.constructor === Promise` work for native promise-based APIs
      try {
        delete NativePromisePrototype.constructor;
      } catch (error) { /* empty */ }

      // make `instanceof Promise` work for native promise-based APIs
      if (objectSetPrototypeOf) {
        objectSetPrototypeOf(NativePromisePrototype, PromisePrototype);
      }
    }
  }

  _export({ global: true, wrap: true, forced: FORCED$2 }, {
    Promise: PromiseConstructor
  });

  setToStringTag(PromiseConstructor, PROMISE, false);
  setSpecies(PROMISE);

  PromiseWrapper = getBuiltIn(PROMISE);

  // statics
  _export({ target: PROMISE, stat: true, forced: FORCED$2 }, {
    // `Promise.reject` method
    // https://tc39.es/ecma262/#sec-promise.reject
    reject: function reject(r) {
      var capability = newPromiseCapability$1(this);
      functionCall(capability.reject, undefined, r);
      return capability.promise;
    }
  });

  _export({ target: PROMISE, stat: true, forced:  FORCED$2 }, {
    // `Promise.resolve` method
    // https://tc39.es/ecma262/#sec-promise.resolve
    resolve: function resolve(x) {
      return promiseResolve( this, x);
    }
  });

  _export({ target: PROMISE, stat: true, forced: INCORRECT_ITERATION }, {
    // `Promise.all` method
    // https://tc39.es/ecma262/#sec-promise.all
    all: function all(iterable) {
      var C = this;
      var capability = newPromiseCapability$1(C);
      var resolve = capability.resolve;
      var reject = capability.reject;
      var result = perform(function () {
        var $promiseResolve = aCallable(C.resolve);
        var values = [];
        var counter = 0;
        var remaining = 1;
        iterate(iterable, function (promise) {
          var index = counter++;
          var alreadyCalled = false;
          remaining++;
          functionCall($promiseResolve, C, promise).then(function (value) {
            if (alreadyCalled) return;
            alreadyCalled = true;
            values[index] = value;
            --remaining || resolve(values);
          }, reject);
        });
        --remaining || resolve(values);
      });
      if (result.error) reject(result.value);
      return capability.promise;
    },
    // `Promise.race` method
    // https://tc39.es/ecma262/#sec-promise.race
    race: function race(iterable) {
      var C = this;
      var capability = newPromiseCapability$1(C);
      var reject = capability.reject;
      var result = perform(function () {
        var $promiseResolve = aCallable(C.resolve);
        iterate(iterable, function (promise) {
          functionCall($promiseResolve, C, promise).then(capability.resolve, reject);
        });
      });
      if (result.error) reject(result.value);
      return capability.promise;
    }
  });

  // Safari bug https://bugs.webkit.org/show_bug.cgi?id=200829
  var NON_GENERIC = !!nativePromiseConstructor && fails(function () {
    // eslint-disable-next-line unicorn/no-thenable -- required for testing
    nativePromiseConstructor.prototype['finally'].call({ then: function () { /* empty */ } }, function () { /* empty */ });
  });

  // `Promise.prototype.finally` method
  // https://tc39.es/ecma262/#sec-promise.prototype.finally
  _export({ target: 'Promise', proto: true, real: true, forced: NON_GENERIC }, {
    'finally': function (onFinally) {
      var C = speciesConstructor(this, getBuiltIn('Promise'));
      var isFunction = isCallable(onFinally);
      return this.then(
        isFunction ? function (x) {
          return promiseResolve(C, onFinally()).then(function () { return x; });
        } : onFinally,
        isFunction ? function (e) {
          return promiseResolve(C, onFinally()).then(function () { throw e; });
        } : onFinally
      );
    }
  });

  // makes sure that native promise-based APIs `Promise#finally` properly works with patched `Promise#then`
  if ( isCallable(nativePromiseConstructor)) {
    var method = getBuiltIn('Promise').prototype['finally'];
    if (nativePromiseConstructor.prototype['finally'] !== method) {
      redefine(nativePromiseConstructor.prototype, 'finally', method, { unsafe: true });
    }
  }

  var MSIE = /MSIE .\./.test(engineUserAgent); // <- dirty ie9- check
  var Function$2 = global_1.Function;

  var wrap = function (scheduler) {
    return function (handler, timeout /* , ...arguments */) {
      var boundArgs = arguments.length > 2;
      var args = boundArgs ? arraySlice(arguments, 2) : undefined;
      return scheduler(boundArgs ? function () {
        functionApply(isCallable(handler) ? handler : Function$2(handler), this, args);
      } : handler, timeout);
    };
  };

  // ie9- setTimeout & setInterval additional parameters fix
  // https://html.spec.whatwg.org/multipage/timers-and-user-prompts.html#timers
  _export({ global: true, bind: true, forced: MSIE }, {
    // `setTimeout` method
    // https://html.spec.whatwg.org/multipage/timers-and-user-prompts.html#dom-settimeout
    setTimeout: wrap(global_1.setTimeout),
    // `setInterval` method
    // https://html.spec.whatwg.org/multipage/timers-and-user-prompts.html#dom-setinterval
    setInterval: wrap(global_1.setInterval)
  });

  var $filter = arrayIteration.filter;


  var HAS_SPECIES_SUPPORT = arrayMethodHasSpeciesSupport('filter');

  // `Array.prototype.filter` method
  // https://tc39.es/ecma262/#sec-array.prototype.filter
  // with adding support of @@species
  _export({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT }, {
    filter: function filter(callbackfn /* , thisArg */) {
      return $filter(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
    }
  });

  var DatePrototype = Date.prototype;
  var INVALID_DATE = 'Invalid Date';
  var TO_STRING = 'toString';
  var un$DateToString = functionUncurryThis(DatePrototype[TO_STRING]);
  var getTime = functionUncurryThis(DatePrototype.getTime);

  // `Date.prototype.toString` method
  // https://tc39.es/ecma262/#sec-date.prototype.tostring
  if (String(new Date(NaN)) != INVALID_DATE) {
    redefine(DatePrototype, TO_STRING, function toString() {
      var value = getTime(this);
      // eslint-disable-next-line no-self-compare -- NaN check
      return value === value ? un$DateToString(this) : INVALID_DATE;
    });
  }

  // `RegExp.prototype.flags` getter implementation
  // https://tc39.es/ecma262/#sec-get-regexp.prototype.flags
  var regexpFlags = function () {
    var that = anObject(this);
    var result = '';
    if (that.global) result += 'g';
    if (that.ignoreCase) result += 'i';
    if (that.multiline) result += 'm';
    if (that.dotAll) result += 's';
    if (that.unicode) result += 'u';
    if (that.sticky) result += 'y';
    return result;
  };

  var PROPER_FUNCTION_NAME = functionName.PROPER;







  var TO_STRING$1 = 'toString';
  var RegExpPrototype = RegExp.prototype;
  var n$ToString = RegExpPrototype[TO_STRING$1];
  var getFlags = functionUncurryThis(regexpFlags);

  var NOT_GENERIC = fails(function () { return n$ToString.call({ source: 'a', flags: 'b' }) != '/a/b'; });
  // FF44- RegExp#toString has a wrong name
  var INCORRECT_NAME = PROPER_FUNCTION_NAME && n$ToString.name != TO_STRING$1;

  // `RegExp.prototype.toString` method
  // https://tc39.es/ecma262/#sec-regexp.prototype.tostring
  if (NOT_GENERIC || INCORRECT_NAME) {
    redefine(RegExp.prototype, TO_STRING$1, function toString() {
      var R = anObject(this);
      var p = toString_1(R.source);
      var rf = R.flags;
      var f = toString_1(rf === undefined && objectIsPrototypeOf(RegExpPrototype, R) && !('flags' in RegExpPrototype) ? getFlags(R) : rf);
      return '/' + p + '/' + f;
    }, { unsafe: true });
  }

  var un$Join = functionUncurryThis([].join);

  var ES3_STRINGS = indexedObject != Object;
  var STRICT_METHOD$1 = arrayMethodIsStrict('join', ',');

  // `Array.prototype.join` method
  // https://tc39.es/ecma262/#sec-array.prototype.join
  _export({ target: 'Array', proto: true, forced: ES3_STRINGS || !STRICT_METHOD$1 }, {
    join: function join(separator) {
      return un$Join(toIndexedObject(this), separator === undefined ? ',' : separator);
    }
  });

  var FUNCTION_NAME_EXISTS = functionName.EXISTS;

  var defineProperty$2 = objectDefineProperty.f;

  var FunctionPrototype$3 = Function.prototype;
  var functionToString$1 = functionUncurryThis(FunctionPrototype$3.toString);
  var nameRE = /function\b(?:\s|\/\*[\S\s]*?\*\/|\/\/[^\n\r]*[\n\r]+)*([^\s(/]*)/;
  var regExpExec = functionUncurryThis(nameRE.exec);
  var NAME = 'name';

  // Function instances `.name` property
  // https://tc39.es/ecma262/#sec-function-instances-name
  if (descriptors && !FUNCTION_NAME_EXISTS) {
    defineProperty$2(FunctionPrototype$3, NAME, {
      configurable: true,
      get: function () {
        try {
          return regExpExec(nameRE, functionToString$1(this))[1];
        } catch (error) {
          return '';
        }
      }
    });
  }

  var $map = arrayIteration.map;


  var HAS_SPECIES_SUPPORT$1 = arrayMethodHasSpeciesSupport('map');

  // `Array.prototype.map` method
  // https://tc39.es/ecma262/#sec-array.prototype.map
  // with adding support of @@species
  _export({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT$1 }, {
    map: function map(callbackfn /* , thisArg */) {
      return $map(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
    }
  });

  /*
   *  Copyright (c) 2016 The WebRTC project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */

  let logDisabled_ = true;
  let deprecationWarnings_ = true;

  /**
   * Extract browser version out of the provided user agent string.
   *
   * @param {!string} uastring userAgent string.
   * @param {!string} expr Regular expression used as match criteria.
   * @param {!number} pos position in the version string to be returned.
   * @return {!number} browser version.
   */
  function extractVersion(uastring, expr, pos) {
    const match = uastring.match(expr);
    return match && match.length >= pos && parseInt(match[pos], 10);
  }

  // Wraps the peerconnection event eventNameToWrap in a function
  // which returns the modified event object (or false to prevent
  // the event).
  function wrapPeerConnectionEvent(window, eventNameToWrap, wrapper) {
    if (!window.RTCPeerConnection) {
      return;
    }
    const proto = window.RTCPeerConnection.prototype;
    const nativeAddEventListener = proto.addEventListener;
    proto.addEventListener = function(nativeEventName, cb) {
      if (nativeEventName !== eventNameToWrap) {
        return nativeAddEventListener.apply(this, arguments);
      }
      const wrappedCallback = (e) => {
        const modifiedEvent = wrapper(e);
        if (modifiedEvent) {
          if (cb.handleEvent) {
            cb.handleEvent(modifiedEvent);
          } else {
            cb(modifiedEvent);
          }
        }
      };
      this._eventMap = this._eventMap || {};
      if (!this._eventMap[eventNameToWrap]) {
        this._eventMap[eventNameToWrap] = new Map();
      }
      this._eventMap[eventNameToWrap].set(cb, wrappedCallback);
      return nativeAddEventListener.apply(this, [nativeEventName,
        wrappedCallback]);
    };

    const nativeRemoveEventListener = proto.removeEventListener;
    proto.removeEventListener = function(nativeEventName, cb) {
      if (nativeEventName !== eventNameToWrap || !this._eventMap
          || !this._eventMap[eventNameToWrap]) {
        return nativeRemoveEventListener.apply(this, arguments);
      }
      if (!this._eventMap[eventNameToWrap].has(cb)) {
        return nativeRemoveEventListener.apply(this, arguments);
      }
      const unwrappedCb = this._eventMap[eventNameToWrap].get(cb);
      this._eventMap[eventNameToWrap].delete(cb);
      if (this._eventMap[eventNameToWrap].size === 0) {
        delete this._eventMap[eventNameToWrap];
      }
      if (Object.keys(this._eventMap).length === 0) {
        delete this._eventMap;
      }
      return nativeRemoveEventListener.apply(this, [nativeEventName,
        unwrappedCb]);
    };

    Object.defineProperty(proto, 'on' + eventNameToWrap, {
      get() {
        return this['_on' + eventNameToWrap];
      },
      set(cb) {
        if (this['_on' + eventNameToWrap]) {
          this.removeEventListener(eventNameToWrap,
              this['_on' + eventNameToWrap]);
          delete this['_on' + eventNameToWrap];
        }
        if (cb) {
          this.addEventListener(eventNameToWrap,
              this['_on' + eventNameToWrap] = cb);
        }
      },
      enumerable: true,
      configurable: true
    });
  }

  function disableLog(bool) {
    if (typeof bool !== 'boolean') {
      return new Error('Argument type: ' + typeof bool +
          '. Please use a boolean.');
    }
    logDisabled_ = bool;
    return (bool) ? 'adapter.js logging disabled' :
        'adapter.js logging enabled';
  }

  /**
   * Disable or enable deprecation warnings
   * @param {!boolean} bool set to true to disable warnings.
   */
  function disableWarnings(bool) {
    if (typeof bool !== 'boolean') {
      return new Error('Argument type: ' + typeof bool +
          '. Please use a boolean.');
    }
    deprecationWarnings_ = !bool;
    return 'adapter.js deprecation warnings ' + (bool ? 'disabled' : 'enabled');
  }

  function log() {
    if (typeof window === 'object') {
      if (logDisabled_) {
        return;
      }
      if (typeof console !== 'undefined' && typeof console.log === 'function') {
        console.log.apply(console, arguments);
      }
    }
  }

  /**
   * Shows a deprecation warning suggesting the modern and spec-compatible API.
   */
  function deprecated(oldMethod, newMethod) {
    if (!deprecationWarnings_) {
      return;
    }
    console.warn(oldMethod + ' is deprecated, please use ' + newMethod +
        ' instead.');
  }

  /**
   * Browser detector.
   *
   * @return {object} result containing browser and version
   *     properties.
   */
  function detectBrowser(window) {
    // Returned result object.
    const result = {browser: null, version: null};

    // Fail early if it's not a browser
    if (typeof window === 'undefined' || !window.navigator) {
      result.browser = 'Not a browser.';
      return result;
    }

    const {navigator} = window;

    if (navigator.mozGetUserMedia) { // Firefox.
      result.browser = 'firefox';
      result.version = extractVersion(navigator.userAgent,
          /Firefox\/(\d+)\./, 1);
    } else if (navigator.webkitGetUserMedia ||
        (window.isSecureContext === false && window.webkitRTCPeerConnection &&
         !window.RTCIceGatherer)) {
      // Chrome, Chromium, Webview, Opera.
      // Version matches Chrome/WebRTC version.
      // Chrome 74 removed webkitGetUserMedia on http as well so we need the
      // more complicated fallback to webkitRTCPeerConnection.
      result.browser = 'chrome';
      result.version = extractVersion(navigator.userAgent,
          /Chrom(e|ium)\/(\d+)\./, 2);
    } else if (navigator.mediaDevices &&
        navigator.userAgent.match(/Edge\/(\d+).(\d+)$/)) { // Edge.
      result.browser = 'edge';
      result.version = extractVersion(navigator.userAgent,
          /Edge\/(\d+).(\d+)$/, 2);
    } else if (window.RTCPeerConnection &&
        navigator.userAgent.match(/AppleWebKit\/(\d+)\./)) { // Safari.
      result.browser = 'safari';
      result.version = extractVersion(navigator.userAgent,
          /AppleWebKit\/(\d+)\./, 1);
      result.supportsUnifiedPlan = window.RTCRtpTransceiver &&
          'currentDirection' in window.RTCRtpTransceiver.prototype;
    } else { // Default fallthrough: not supported.
      result.browser = 'Not a supported browser.';
      return result;
    }

    return result;
  }

  /**
   * Checks if something is an object.
   *
   * @param {*} val The something you want to check.
   * @return true if val is an object, false otherwise.
   */
  function isObject$1(val) {
    return Object.prototype.toString.call(val) === '[object Object]';
  }

  /**
   * Remove all empty objects and undefined values
   * from a nested object -- an enhanced and vanilla version
   * of Lodash's `compact`.
   */
  function compactObject(data) {
    if (!isObject$1(data)) {
      return data;
    }

    return Object.keys(data).reduce(function(accumulator, key) {
      const isObj = isObject$1(data[key]);
      const value = isObj ? compactObject(data[key]) : data[key];
      const isEmptyObject = isObj && !Object.keys(value).length;
      if (value === undefined || isEmptyObject) {
        return accumulator;
      }
      return Object.assign(accumulator, {[key]: value});
    }, {});
  }

  /* iterates the stats graph recursively. */
  function walkStats(stats, base, resultSet) {
    if (!base || resultSet.has(base.id)) {
      return;
    }
    resultSet.set(base.id, base);
    Object.keys(base).forEach(name => {
      if (name.endsWith('Id')) {
        walkStats(stats, stats.get(base[name]), resultSet);
      } else if (name.endsWith('Ids')) {
        base[name].forEach(id => {
          walkStats(stats, stats.get(id), resultSet);
        });
      }
    });
  }

  /* filter getStats for a sender/receiver track. */
  function filterStats(result, track, outbound) {
    const streamStatsType = outbound ? 'outbound-rtp' : 'inbound-rtp';
    const filteredResult = new Map();
    if (track === null) {
      return filteredResult;
    }
    const trackStats = [];
    result.forEach(value => {
      if (value.type === 'track' &&
          value.trackIdentifier === track.id) {
        trackStats.push(value);
      }
    });
    trackStats.forEach(trackStat => {
      result.forEach(stats => {
        if (stats.type === streamStatsType && stats.trackId === trackStat.id) {
          walkStats(result, stats, filteredResult);
        }
      });
    });
    return filteredResult;
  }

  /*
   *  Copyright (c) 2016 The WebRTC project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */
  const logging = log;

  function shimGetUserMedia(window, browserDetails) {
    const navigator = window && window.navigator;

    if (!navigator.mediaDevices) {
      return;
    }

    const constraintsToChrome_ = function(c) {
      if (typeof c !== 'object' || c.mandatory || c.optional) {
        return c;
      }
      const cc = {};
      Object.keys(c).forEach(key => {
        if (key === 'require' || key === 'advanced' || key === 'mediaSource') {
          return;
        }
        const r = (typeof c[key] === 'object') ? c[key] : {ideal: c[key]};
        if (r.exact !== undefined && typeof r.exact === 'number') {
          r.min = r.max = r.exact;
        }
        const oldname_ = function(prefix, name) {
          if (prefix) {
            return prefix + name.charAt(0).toUpperCase() + name.slice(1);
          }
          return (name === 'deviceId') ? 'sourceId' : name;
        };
        if (r.ideal !== undefined) {
          cc.optional = cc.optional || [];
          let oc = {};
          if (typeof r.ideal === 'number') {
            oc[oldname_('min', key)] = r.ideal;
            cc.optional.push(oc);
            oc = {};
            oc[oldname_('max', key)] = r.ideal;
            cc.optional.push(oc);
          } else {
            oc[oldname_('', key)] = r.ideal;
            cc.optional.push(oc);
          }
        }
        if (r.exact !== undefined && typeof r.exact !== 'number') {
          cc.mandatory = cc.mandatory || {};
          cc.mandatory[oldname_('', key)] = r.exact;
        } else {
          ['min', 'max'].forEach(mix => {
            if (r[mix] !== undefined) {
              cc.mandatory = cc.mandatory || {};
              cc.mandatory[oldname_(mix, key)] = r[mix];
            }
          });
        }
      });
      if (c.advanced) {
        cc.optional = (cc.optional || []).concat(c.advanced);
      }
      return cc;
    };

    const shimConstraints_ = function(constraints, func) {
      if (browserDetails.version >= 61) {
        return func(constraints);
      }
      constraints = JSON.parse(JSON.stringify(constraints));
      if (constraints && typeof constraints.audio === 'object') {
        const remap = function(obj, a, b) {
          if (a in obj && !(b in obj)) {
            obj[b] = obj[a];
            delete obj[a];
          }
        };
        constraints = JSON.parse(JSON.stringify(constraints));
        remap(constraints.audio, 'autoGainControl', 'googAutoGainControl');
        remap(constraints.audio, 'noiseSuppression', 'googNoiseSuppression');
        constraints.audio = constraintsToChrome_(constraints.audio);
      }
      if (constraints && typeof constraints.video === 'object') {
        // Shim facingMode for mobile & surface pro.
        let face = constraints.video.facingMode;
        face = face && ((typeof face === 'object') ? face : {ideal: face});
        const getSupportedFacingModeLies = browserDetails.version < 66;

        if ((face && (face.exact === 'user' || face.exact === 'environment' ||
                      face.ideal === 'user' || face.ideal === 'environment')) &&
            !(navigator.mediaDevices.getSupportedConstraints &&
              navigator.mediaDevices.getSupportedConstraints().facingMode &&
              !getSupportedFacingModeLies)) {
          delete constraints.video.facingMode;
          let matches;
          if (face.exact === 'environment' || face.ideal === 'environment') {
            matches = ['back', 'rear'];
          } else if (face.exact === 'user' || face.ideal === 'user') {
            matches = ['front'];
          }
          if (matches) {
            // Look for matches in label, or use last cam for back (typical).
            return navigator.mediaDevices.enumerateDevices()
            .then(devices => {
              devices = devices.filter(d => d.kind === 'videoinput');
              let dev = devices.find(d => matches.some(match =>
                d.label.toLowerCase().includes(match)));
              if (!dev && devices.length && matches.includes('back')) {
                dev = devices[devices.length - 1]; // more likely the back cam
              }
              if (dev) {
                constraints.video.deviceId = face.exact ? {exact: dev.deviceId} :
                                                          {ideal: dev.deviceId};
              }
              constraints.video = constraintsToChrome_(constraints.video);
              logging('chrome: ' + JSON.stringify(constraints));
              return func(constraints);
            });
          }
        }
        constraints.video = constraintsToChrome_(constraints.video);
      }
      logging('chrome: ' + JSON.stringify(constraints));
      return func(constraints);
    };

    const shimError_ = function(e) {
      if (browserDetails.version >= 64) {
        return e;
      }
      return {
        name: {
          PermissionDeniedError: 'NotAllowedError',
          PermissionDismissedError: 'NotAllowedError',
          InvalidStateError: 'NotAllowedError',
          DevicesNotFoundError: 'NotFoundError',
          ConstraintNotSatisfiedError: 'OverconstrainedError',
          TrackStartError: 'NotReadableError',
          MediaDeviceFailedDueToShutdown: 'NotAllowedError',
          MediaDeviceKillSwitchOn: 'NotAllowedError',
          TabCaptureError: 'AbortError',
          ScreenCaptureError: 'AbortError',
          DeviceCaptureError: 'AbortError'
        }[e.name] || e.name,
        message: e.message,
        constraint: e.constraint || e.constraintName,
        toString() {
          return this.name + (this.message && ': ') + this.message;
        }
      };
    };

    const getUserMedia_ = function(constraints, onSuccess, onError) {
      shimConstraints_(constraints, c => {
        navigator.webkitGetUserMedia(c, onSuccess, e => {
          if (onError) {
            onError(shimError_(e));
          }
        });
      });
    };
    navigator.getUserMedia = getUserMedia_.bind(navigator);

    // Even though Chrome 45 has navigator.mediaDevices and a getUserMedia
    // function which returns a Promise, it does not accept spec-style
    // constraints.
    if (navigator.mediaDevices.getUserMedia) {
      const origGetUserMedia = navigator.mediaDevices.getUserMedia.
          bind(navigator.mediaDevices);
      navigator.mediaDevices.getUserMedia = function(cs) {
        return shimConstraints_(cs, c => origGetUserMedia(c).then(stream => {
          if (c.audio && !stream.getAudioTracks().length ||
              c.video && !stream.getVideoTracks().length) {
            stream.getTracks().forEach(track => {
              track.stop();
            });
            throw new DOMException('', 'NotFoundError');
          }
          return stream;
        }, e => Promise.reject(shimError_(e))));
      };
    }
  }

  /*
   *  Copyright (c) 2018 The adapter.js project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */
  function shimGetDisplayMedia(window, getSourceId) {
    if (window.navigator.mediaDevices &&
      'getDisplayMedia' in window.navigator.mediaDevices) {
      return;
    }
    if (!(window.navigator.mediaDevices)) {
      return;
    }
    // getSourceId is a function that returns a promise resolving with
    // the sourceId of the screen/window/tab to be shared.
    if (typeof getSourceId !== 'function') {
      console.error('shimGetDisplayMedia: getSourceId argument is not ' +
          'a function');
      return;
    }
    window.navigator.mediaDevices.getDisplayMedia =
      function getDisplayMedia(constraints) {
        return getSourceId(constraints)
          .then(sourceId => {
            const widthSpecified = constraints.video && constraints.video.width;
            const heightSpecified = constraints.video &&
              constraints.video.height;
            const frameRateSpecified = constraints.video &&
              constraints.video.frameRate;
            constraints.video = {
              mandatory: {
                chromeMediaSource: 'desktop',
                chromeMediaSourceId: sourceId,
                maxFrameRate: frameRateSpecified || 3
              }
            };
            if (widthSpecified) {
              constraints.video.mandatory.maxWidth = widthSpecified;
            }
            if (heightSpecified) {
              constraints.video.mandatory.maxHeight = heightSpecified;
            }
            return window.navigator.mediaDevices.getUserMedia(constraints);
          });
      };
  }

  /*
   *  Copyright (c) 2016 The WebRTC project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */

  function shimMediaStream(window) {
    window.MediaStream = window.MediaStream || window.webkitMediaStream;
  }

  function shimOnTrack(window) {
    if (typeof window === 'object' && window.RTCPeerConnection && !('ontrack' in
        window.RTCPeerConnection.prototype)) {
      Object.defineProperty(window.RTCPeerConnection.prototype, 'ontrack', {
        get() {
          return this._ontrack;
        },
        set(f) {
          if (this._ontrack) {
            this.removeEventListener('track', this._ontrack);
          }
          this.addEventListener('track', this._ontrack = f);
        },
        enumerable: true,
        configurable: true
      });
      const origSetRemoteDescription =
          window.RTCPeerConnection.prototype.setRemoteDescription;
      window.RTCPeerConnection.prototype.setRemoteDescription =
        function setRemoteDescription() {
          if (!this._ontrackpoly) {
            this._ontrackpoly = (e) => {
              // onaddstream does not fire when a track is added to an existing
              // stream. But stream.onaddtrack is implemented so we use that.
              e.stream.addEventListener('addtrack', te => {
                let receiver;
                if (window.RTCPeerConnection.prototype.getReceivers) {
                  receiver = this.getReceivers()
                    .find(r => r.track && r.track.id === te.track.id);
                } else {
                  receiver = {track: te.track};
                }

                const event = new Event('track');
                event.track = te.track;
                event.receiver = receiver;
                event.transceiver = {receiver};
                event.streams = [e.stream];
                this.dispatchEvent(event);
              });
              e.stream.getTracks().forEach(track => {
                let receiver;
                if (window.RTCPeerConnection.prototype.getReceivers) {
                  receiver = this.getReceivers()
                    .find(r => r.track && r.track.id === track.id);
                } else {
                  receiver = {track};
                }
                const event = new Event('track');
                event.track = track;
                event.receiver = receiver;
                event.transceiver = {receiver};
                event.streams = [e.stream];
                this.dispatchEvent(event);
              });
            };
            this.addEventListener('addstream', this._ontrackpoly);
          }
          return origSetRemoteDescription.apply(this, arguments);
        };
    } else {
      // even if RTCRtpTransceiver is in window, it is only used and
      // emitted in unified-plan. Unfortunately this means we need
      // to unconditionally wrap the event.
      wrapPeerConnectionEvent(window, 'track', e => {
        if (!e.transceiver) {
          Object.defineProperty(e, 'transceiver',
            {value: {receiver: e.receiver}});
        }
        return e;
      });
    }
  }

  function shimGetSendersWithDtmf(window) {
    // Overrides addTrack/removeTrack, depends on shimAddTrackRemoveTrack.
    if (typeof window === 'object' && window.RTCPeerConnection &&
        !('getSenders' in window.RTCPeerConnection.prototype) &&
        'createDTMFSender' in window.RTCPeerConnection.prototype) {
      const shimSenderWithDtmf = function(pc, track) {
        return {
          track,
          get dtmf() {
            if (this._dtmf === undefined) {
              if (track.kind === 'audio') {
                this._dtmf = pc.createDTMFSender(track);
              } else {
                this._dtmf = null;
              }
            }
            return this._dtmf;
          },
          _pc: pc
        };
      };

      // augment addTrack when getSenders is not available.
      if (!window.RTCPeerConnection.prototype.getSenders) {
        window.RTCPeerConnection.prototype.getSenders = function getSenders() {
          this._senders = this._senders || [];
          return this._senders.slice(); // return a copy of the internal state.
        };
        const origAddTrack = window.RTCPeerConnection.prototype.addTrack;
        window.RTCPeerConnection.prototype.addTrack =
          function addTrack(track, stream) {
            let sender = origAddTrack.apply(this, arguments);
            if (!sender) {
              sender = shimSenderWithDtmf(this, track);
              this._senders.push(sender);
            }
            return sender;
          };

        const origRemoveTrack = window.RTCPeerConnection.prototype.removeTrack;
        window.RTCPeerConnection.prototype.removeTrack =
          function removeTrack(sender) {
            origRemoveTrack.apply(this, arguments);
            const idx = this._senders.indexOf(sender);
            if (idx !== -1) {
              this._senders.splice(idx, 1);
            }
          };
      }
      const origAddStream = window.RTCPeerConnection.prototype.addStream;
      window.RTCPeerConnection.prototype.addStream = function addStream(stream) {
        this._senders = this._senders || [];
        origAddStream.apply(this, [stream]);
        stream.getTracks().forEach(track => {
          this._senders.push(shimSenderWithDtmf(this, track));
        });
      };

      const origRemoveStream = window.RTCPeerConnection.prototype.removeStream;
      window.RTCPeerConnection.prototype.removeStream =
        function removeStream(stream) {
          this._senders = this._senders || [];
          origRemoveStream.apply(this, [stream]);

          stream.getTracks().forEach(track => {
            const sender = this._senders.find(s => s.track === track);
            if (sender) { // remove sender
              this._senders.splice(this._senders.indexOf(sender), 1);
            }
          });
        };
    } else if (typeof window === 'object' && window.RTCPeerConnection &&
               'getSenders' in window.RTCPeerConnection.prototype &&
               'createDTMFSender' in window.RTCPeerConnection.prototype &&
               window.RTCRtpSender &&
               !('dtmf' in window.RTCRtpSender.prototype)) {
      const origGetSenders = window.RTCPeerConnection.prototype.getSenders;
      window.RTCPeerConnection.prototype.getSenders = function getSenders() {
        const senders = origGetSenders.apply(this, []);
        senders.forEach(sender => sender._pc = this);
        return senders;
      };

      Object.defineProperty(window.RTCRtpSender.prototype, 'dtmf', {
        get() {
          if (this._dtmf === undefined) {
            if (this.track.kind === 'audio') {
              this._dtmf = this._pc.createDTMFSender(this.track);
            } else {
              this._dtmf = null;
            }
          }
          return this._dtmf;
        }
      });
    }
  }

  function shimGetStats(window) {
    if (!window.RTCPeerConnection) {
      return;
    }

    const origGetStats = window.RTCPeerConnection.prototype.getStats;
    window.RTCPeerConnection.prototype.getStats = function getStats() {
      const [selector, onSucc, onErr] = arguments;

      // If selector is a function then we are in the old style stats so just
      // pass back the original getStats format to avoid breaking old users.
      if (arguments.length > 0 && typeof selector === 'function') {
        return origGetStats.apply(this, arguments);
      }

      // When spec-style getStats is supported, return those when called with
      // either no arguments or the selector argument is null.
      if (origGetStats.length === 0 && (arguments.length === 0 ||
          typeof selector !== 'function')) {
        return origGetStats.apply(this, []);
      }

      const fixChromeStats_ = function(response) {
        const standardReport = {};
        const reports = response.result();
        reports.forEach(report => {
          const standardStats = {
            id: report.id,
            timestamp: report.timestamp,
            type: {
              localcandidate: 'local-candidate',
              remotecandidate: 'remote-candidate'
            }[report.type] || report.type
          };
          report.names().forEach(name => {
            standardStats[name] = report.stat(name);
          });
          standardReport[standardStats.id] = standardStats;
        });

        return standardReport;
      };

      // shim getStats with maplike support
      const makeMapStats = function(stats) {
        return new Map(Object.keys(stats).map(key => [key, stats[key]]));
      };

      if (arguments.length >= 2) {
        const successCallbackWrapper_ = function(response) {
          onSucc(makeMapStats(fixChromeStats_(response)));
        };

        return origGetStats.apply(this, [successCallbackWrapper_,
          selector]);
      }

      // promise-support
      return new Promise((resolve, reject) => {
        origGetStats.apply(this, [
          function(response) {
            resolve(makeMapStats(fixChromeStats_(response)));
          }, reject]);
      }).then(onSucc, onErr);
    };
  }

  function shimSenderReceiverGetStats(window) {
    if (!(typeof window === 'object' && window.RTCPeerConnection &&
        window.RTCRtpSender && window.RTCRtpReceiver)) {
      return;
    }

    // shim sender stats.
    if (!('getStats' in window.RTCRtpSender.prototype)) {
      const origGetSenders = window.RTCPeerConnection.prototype.getSenders;
      if (origGetSenders) {
        window.RTCPeerConnection.prototype.getSenders = function getSenders() {
          const senders = origGetSenders.apply(this, []);
          senders.forEach(sender => sender._pc = this);
          return senders;
        };
      }

      const origAddTrack = window.RTCPeerConnection.prototype.addTrack;
      if (origAddTrack) {
        window.RTCPeerConnection.prototype.addTrack = function addTrack() {
          const sender = origAddTrack.apply(this, arguments);
          sender._pc = this;
          return sender;
        };
      }
      window.RTCRtpSender.prototype.getStats = function getStats() {
        const sender = this;
        return this._pc.getStats().then(result =>
          /* Note: this will include stats of all senders that
           *   send a track with the same id as sender.track as
           *   it is not possible to identify the RTCRtpSender.
           */
          filterStats(result, sender.track, true));
      };
    }

    // shim receiver stats.
    if (!('getStats' in window.RTCRtpReceiver.prototype)) {
      const origGetReceivers = window.RTCPeerConnection.prototype.getReceivers;
      if (origGetReceivers) {
        window.RTCPeerConnection.prototype.getReceivers =
          function getReceivers() {
            const receivers = origGetReceivers.apply(this, []);
            receivers.forEach(receiver => receiver._pc = this);
            return receivers;
          };
      }
      wrapPeerConnectionEvent(window, 'track', e => {
        e.receiver._pc = e.srcElement;
        return e;
      });
      window.RTCRtpReceiver.prototype.getStats = function getStats() {
        const receiver = this;
        return this._pc.getStats().then(result =>
          filterStats(result, receiver.track, false));
      };
    }

    if (!('getStats' in window.RTCRtpSender.prototype &&
        'getStats' in window.RTCRtpReceiver.prototype)) {
      return;
    }

    // shim RTCPeerConnection.getStats(track).
    const origGetStats = window.RTCPeerConnection.prototype.getStats;
    window.RTCPeerConnection.prototype.getStats = function getStats() {
      if (arguments.length > 0 &&
          arguments[0] instanceof window.MediaStreamTrack) {
        const track = arguments[0];
        let sender;
        let receiver;
        let err;
        this.getSenders().forEach(s => {
          if (s.track === track) {
            if (sender) {
              err = true;
            } else {
              sender = s;
            }
          }
        });
        this.getReceivers().forEach(r => {
          if (r.track === track) {
            if (receiver) {
              err = true;
            } else {
              receiver = r;
            }
          }
          return r.track === track;
        });
        if (err || (sender && receiver)) {
          return Promise.reject(new DOMException(
            'There are more than one sender or receiver for the track.',
            'InvalidAccessError'));
        } else if (sender) {
          return sender.getStats();
        } else if (receiver) {
          return receiver.getStats();
        }
        return Promise.reject(new DOMException(
          'There is no sender or receiver for the track.',
          'InvalidAccessError'));
      }
      return origGetStats.apply(this, arguments);
    };
  }

  function shimAddTrackRemoveTrackWithNative(window) {
    // shim addTrack/removeTrack with native variants in order to make
    // the interactions with legacy getLocalStreams behave as in other browsers.
    // Keeps a mapping stream.id => [stream, rtpsenders...]
    window.RTCPeerConnection.prototype.getLocalStreams =
      function getLocalStreams() {
        this._shimmedLocalStreams = this._shimmedLocalStreams || {};
        return Object.keys(this._shimmedLocalStreams)
          .map(streamId => this._shimmedLocalStreams[streamId][0]);
      };

    const origAddTrack = window.RTCPeerConnection.prototype.addTrack;
    window.RTCPeerConnection.prototype.addTrack =
      function addTrack(track, stream) {
        if (!stream) {
          return origAddTrack.apply(this, arguments);
        }
        this._shimmedLocalStreams = this._shimmedLocalStreams || {};

        const sender = origAddTrack.apply(this, arguments);
        if (!this._shimmedLocalStreams[stream.id]) {
          this._shimmedLocalStreams[stream.id] = [stream, sender];
        } else if (this._shimmedLocalStreams[stream.id].indexOf(sender) === -1) {
          this._shimmedLocalStreams[stream.id].push(sender);
        }
        return sender;
      };

    const origAddStream = window.RTCPeerConnection.prototype.addStream;
    window.RTCPeerConnection.prototype.addStream = function addStream(stream) {
      this._shimmedLocalStreams = this._shimmedLocalStreams || {};

      stream.getTracks().forEach(track => {
        const alreadyExists = this.getSenders().find(s => s.track === track);
        if (alreadyExists) {
          throw new DOMException('Track already exists.',
              'InvalidAccessError');
        }
      });
      const existingSenders = this.getSenders();
      origAddStream.apply(this, arguments);
      const newSenders = this.getSenders()
        .filter(newSender => existingSenders.indexOf(newSender) === -1);
      this._shimmedLocalStreams[stream.id] = [stream].concat(newSenders);
    };

    const origRemoveStream = window.RTCPeerConnection.prototype.removeStream;
    window.RTCPeerConnection.prototype.removeStream =
      function removeStream(stream) {
        this._shimmedLocalStreams = this._shimmedLocalStreams || {};
        delete this._shimmedLocalStreams[stream.id];
        return origRemoveStream.apply(this, arguments);
      };

    const origRemoveTrack = window.RTCPeerConnection.prototype.removeTrack;
    window.RTCPeerConnection.prototype.removeTrack =
      function removeTrack(sender) {
        this._shimmedLocalStreams = this._shimmedLocalStreams || {};
        if (sender) {
          Object.keys(this._shimmedLocalStreams).forEach(streamId => {
            const idx = this._shimmedLocalStreams[streamId].indexOf(sender);
            if (idx !== -1) {
              this._shimmedLocalStreams[streamId].splice(idx, 1);
            }
            if (this._shimmedLocalStreams[streamId].length === 1) {
              delete this._shimmedLocalStreams[streamId];
            }
          });
        }
        return origRemoveTrack.apply(this, arguments);
      };
  }

  function shimAddTrackRemoveTrack(window, browserDetails) {
    if (!window.RTCPeerConnection) {
      return;
    }
    // shim addTrack and removeTrack.
    if (window.RTCPeerConnection.prototype.addTrack &&
        browserDetails.version >= 65) {
      return shimAddTrackRemoveTrackWithNative(window);
    }

    // also shim pc.getLocalStreams when addTrack is shimmed
    // to return the original streams.
    const origGetLocalStreams = window.RTCPeerConnection.prototype
        .getLocalStreams;
    window.RTCPeerConnection.prototype.getLocalStreams =
      function getLocalStreams() {
        const nativeStreams = origGetLocalStreams.apply(this);
        this._reverseStreams = this._reverseStreams || {};
        return nativeStreams.map(stream => this._reverseStreams[stream.id]);
      };

    const origAddStream = window.RTCPeerConnection.prototype.addStream;
    window.RTCPeerConnection.prototype.addStream = function addStream(stream) {
      this._streams = this._streams || {};
      this._reverseStreams = this._reverseStreams || {};

      stream.getTracks().forEach(track => {
        const alreadyExists = this.getSenders().find(s => s.track === track);
        if (alreadyExists) {
          throw new DOMException('Track already exists.',
              'InvalidAccessError');
        }
      });
      // Add identity mapping for consistency with addTrack.
      // Unless this is being used with a stream from addTrack.
      if (!this._reverseStreams[stream.id]) {
        const newStream = new window.MediaStream(stream.getTracks());
        this._streams[stream.id] = newStream;
        this._reverseStreams[newStream.id] = stream;
        stream = newStream;
      }
      origAddStream.apply(this, [stream]);
    };

    const origRemoveStream = window.RTCPeerConnection.prototype.removeStream;
    window.RTCPeerConnection.prototype.removeStream =
      function removeStream(stream) {
        this._streams = this._streams || {};
        this._reverseStreams = this._reverseStreams || {};

        origRemoveStream.apply(this, [(this._streams[stream.id] || stream)]);
        delete this._reverseStreams[(this._streams[stream.id] ?
            this._streams[stream.id].id : stream.id)];
        delete this._streams[stream.id];
      };

    window.RTCPeerConnection.prototype.addTrack =
      function addTrack(track, stream) {
        if (this.signalingState === 'closed') {
          throw new DOMException(
            'The RTCPeerConnection\'s signalingState is \'closed\'.',
            'InvalidStateError');
        }
        const streams = [].slice.call(arguments, 1);
        if (streams.length !== 1 ||
            !streams[0].getTracks().find(t => t === track)) {
          // this is not fully correct but all we can manage without
          // [[associated MediaStreams]] internal slot.
          throw new DOMException(
            'The adapter.js addTrack polyfill only supports a single ' +
            ' stream which is associated with the specified track.',
            'NotSupportedError');
        }

        const alreadyExists = this.getSenders().find(s => s.track === track);
        if (alreadyExists) {
          throw new DOMException('Track already exists.',
              'InvalidAccessError');
        }

        this._streams = this._streams || {};
        this._reverseStreams = this._reverseStreams || {};
        const oldStream = this._streams[stream.id];
        if (oldStream) {
          // this is using odd Chrome behaviour, use with caution:
          // https://bugs.chromium.org/p/webrtc/issues/detail?id=7815
          // Note: we rely on the high-level addTrack/dtmf shim to
          // create the sender with a dtmf sender.
          oldStream.addTrack(track);

          // Trigger ONN async.
          Promise.resolve().then(() => {
            this.dispatchEvent(new Event('negotiationneeded'));
          });
        } else {
          const newStream = new window.MediaStream([track]);
          this._streams[stream.id] = newStream;
          this._reverseStreams[newStream.id] = stream;
          this.addStream(newStream);
        }
        return this.getSenders().find(s => s.track === track);
      };

    // replace the internal stream id with the external one and
    // vice versa.
    function replaceInternalStreamId(pc, description) {
      let sdp = description.sdp;
      Object.keys(pc._reverseStreams || []).forEach(internalId => {
        const externalStream = pc._reverseStreams[internalId];
        const internalStream = pc._streams[externalStream.id];
        sdp = sdp.replace(new RegExp(internalStream.id, 'g'),
            externalStream.id);
      });
      return new RTCSessionDescription({
        type: description.type,
        sdp
      });
    }
    function replaceExternalStreamId(pc, description) {
      let sdp = description.sdp;
      Object.keys(pc._reverseStreams || []).forEach(internalId => {
        const externalStream = pc._reverseStreams[internalId];
        const internalStream = pc._streams[externalStream.id];
        sdp = sdp.replace(new RegExp(externalStream.id, 'g'),
            internalStream.id);
      });
      return new RTCSessionDescription({
        type: description.type,
        sdp
      });
    }
    ['createOffer', 'createAnswer'].forEach(function(method) {
      const nativeMethod = window.RTCPeerConnection.prototype[method];
      const methodObj = {[method]() {
        const args = arguments;
        const isLegacyCall = arguments.length &&
            typeof arguments[0] === 'function';
        if (isLegacyCall) {
          return nativeMethod.apply(this, [
            (description) => {
              const desc = replaceInternalStreamId(this, description);
              args[0].apply(null, [desc]);
            },
            (err) => {
              if (args[1]) {
                args[1].apply(null, err);
              }
            }, arguments[2]
          ]);
        }
        return nativeMethod.apply(this, arguments)
        .then(description => replaceInternalStreamId(this, description));
      }};
      window.RTCPeerConnection.prototype[method] = methodObj[method];
    });

    const origSetLocalDescription =
        window.RTCPeerConnection.prototype.setLocalDescription;
    window.RTCPeerConnection.prototype.setLocalDescription =
      function setLocalDescription() {
        if (!arguments.length || !arguments[0].type) {
          return origSetLocalDescription.apply(this, arguments);
        }
        arguments[0] = replaceExternalStreamId(this, arguments[0]);
        return origSetLocalDescription.apply(this, arguments);
      };

    // TODO: mangle getStats: https://w3c.github.io/webrtc-stats/#dom-rtcmediastreamstats-streamidentifier

    const origLocalDescription = Object.getOwnPropertyDescriptor(
        window.RTCPeerConnection.prototype, 'localDescription');
    Object.defineProperty(window.RTCPeerConnection.prototype,
        'localDescription', {
          get() {
            const description = origLocalDescription.get.apply(this);
            if (description.type === '') {
              return description;
            }
            return replaceInternalStreamId(this, description);
          }
        });

    window.RTCPeerConnection.prototype.removeTrack =
      function removeTrack(sender) {
        if (this.signalingState === 'closed') {
          throw new DOMException(
            'The RTCPeerConnection\'s signalingState is \'closed\'.',
            'InvalidStateError');
        }
        // We can not yet check for sender instanceof RTCRtpSender
        // since we shim RTPSender. So we check if sender._pc is set.
        if (!sender._pc) {
          throw new DOMException('Argument 1 of RTCPeerConnection.removeTrack ' +
              'does not implement interface RTCRtpSender.', 'TypeError');
        }
        const isLocal = sender._pc === this;
        if (!isLocal) {
          throw new DOMException('Sender was not created by this connection.',
              'InvalidAccessError');
        }

        // Search for the native stream the senders track belongs to.
        this._streams = this._streams || {};
        let stream;
        Object.keys(this._streams).forEach(streamid => {
          const hasTrack = this._streams[streamid].getTracks()
            .find(track => sender.track === track);
          if (hasTrack) {
            stream = this._streams[streamid];
          }
        });

        if (stream) {
          if (stream.getTracks().length === 1) {
            // if this is the last track of the stream, remove the stream. This
            // takes care of any shimmed _senders.
            this.removeStream(this._reverseStreams[stream.id]);
          } else {
            // relying on the same odd chrome behaviour as above.
            stream.removeTrack(sender.track);
          }
          this.dispatchEvent(new Event('negotiationneeded'));
        }
      };
  }

  function shimPeerConnection(window, browserDetails) {
    if (!window.RTCPeerConnection && window.webkitRTCPeerConnection) {
      // very basic support for old versions.
      window.RTCPeerConnection = window.webkitRTCPeerConnection;
    }
    if (!window.RTCPeerConnection) {
      return;
    }

    // shim implicit creation of RTCSessionDescription/RTCIceCandidate
    if (browserDetails.version < 53) {
      ['setLocalDescription', 'setRemoteDescription', 'addIceCandidate']
          .forEach(function(method) {
            const nativeMethod = window.RTCPeerConnection.prototype[method];
            const methodObj = {[method]() {
              arguments[0] = new ((method === 'addIceCandidate') ?
                  window.RTCIceCandidate :
                  window.RTCSessionDescription)(arguments[0]);
              return nativeMethod.apply(this, arguments);
            }};
            window.RTCPeerConnection.prototype[method] = methodObj[method];
          });
    }
  }

  // Attempt to fix ONN in plan-b mode.
  function fixNegotiationNeeded(window, browserDetails) {
    wrapPeerConnectionEvent(window, 'negotiationneeded', e => {
      const pc = e.target;
      if (browserDetails.version < 72 || (pc.getConfiguration &&
          pc.getConfiguration().sdpSemantics === 'plan-b')) {
        if (pc.signalingState !== 'stable') {
          return;
        }
      }
      return e;
    });
  }

  var chromeShim = /*#__PURE__*/Object.freeze({
    __proto__: null,
    shimMediaStream: shimMediaStream,
    shimOnTrack: shimOnTrack,
    shimGetSendersWithDtmf: shimGetSendersWithDtmf,
    shimGetStats: shimGetStats,
    shimSenderReceiverGetStats: shimSenderReceiverGetStats,
    shimAddTrackRemoveTrackWithNative: shimAddTrackRemoveTrackWithNative,
    shimAddTrackRemoveTrack: shimAddTrackRemoveTrack,
    shimPeerConnection: shimPeerConnection,
    fixNegotiationNeeded: fixNegotiationNeeded,
    shimGetUserMedia: shimGetUserMedia,
    shimGetDisplayMedia: shimGetDisplayMedia
  });

  /*
   *  Copyright (c) 2018 The WebRTC project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */
  // Edge does not like
  // 1) stun: filtered after 14393 unless ?transport=udp is present
  // 2) turn: that does not have all of turn:host:port?transport=udp
  // 3) turn: with ipv6 addresses
  // 4) turn: occurring muliple times
  function filterIceServers(iceServers, edgeVersion) {
    let hasTurn = false;
    iceServers = JSON.parse(JSON.stringify(iceServers));
    return iceServers.filter(server => {
      if (server && (server.urls || server.url)) {
        let urls = server.urls || server.url;
        if (server.url && !server.urls) {
          deprecated('RTCIceServer.url', 'RTCIceServer.urls');
        }
        const isString = typeof urls === 'string';
        if (isString) {
          urls = [urls];
        }
        urls = urls.filter(url => {
          // filter STUN unconditionally.
          if (url.indexOf('stun:') === 0) {
            return false;
          }

          const validTurn = url.startsWith('turn') &&
              !url.startsWith('turn:[') &&
              url.includes('transport=udp');
          if (validTurn && !hasTurn) {
            hasTurn = true;
            return true;
          }
          return validTurn && !hasTurn;
        });

        delete server.url;
        server.urls = isString ? urls[0] : urls;
        return !!urls.length;
      }
    });
  }

  var sdp = createCommonjsModule(function (module) {

  // SDP helpers.
  var SDPUtils = {};

  // Generate an alphanumeric identifier for cname or mids.
  // TODO: use UUIDs instead? https://gist.github.com/jed/982883
  SDPUtils.generateIdentifier = function() {
    return Math.random().toString(36).substr(2, 10);
  };

  // The RTCP CNAME used by all peerconnections from the same JS.
  SDPUtils.localCName = SDPUtils.generateIdentifier();

  // Splits SDP into lines, dealing with both CRLF and LF.
  SDPUtils.splitLines = function(blob) {
    return blob.trim().split('\n').map(function(line) {
      return line.trim();
    });
  };
  // Splits SDP into sessionpart and mediasections. Ensures CRLF.
  SDPUtils.splitSections = function(blob) {
    var parts = blob.split('\nm=');
    return parts.map(function(part, index) {
      return (index > 0 ? 'm=' + part : part).trim() + '\r\n';
    });
  };

  // returns the session description.
  SDPUtils.getDescription = function(blob) {
    var sections = SDPUtils.splitSections(blob);
    return sections && sections[0];
  };

  // returns the individual media sections.
  SDPUtils.getMediaSections = function(blob) {
    var sections = SDPUtils.splitSections(blob);
    sections.shift();
    return sections;
  };

  // Returns lines that start with a certain prefix.
  SDPUtils.matchPrefix = function(blob, prefix) {
    return SDPUtils.splitLines(blob).filter(function(line) {
      return line.indexOf(prefix) === 0;
    });
  };

  // Parses an ICE candidate line. Sample input:
  // candidate:702786350 2 udp 41819902 8.8.8.8 60769 typ relay raddr 8.8.8.8
  // rport 55996"
  SDPUtils.parseCandidate = function(line) {
    var parts;
    // Parse both variants.
    if (line.indexOf('a=candidate:') === 0) {
      parts = line.substring(12).split(' ');
    } else {
      parts = line.substring(10).split(' ');
    }

    var candidate = {
      foundation: parts[0],
      component: parseInt(parts[1], 10),
      protocol: parts[2].toLowerCase(),
      priority: parseInt(parts[3], 10),
      ip: parts[4],
      address: parts[4], // address is an alias for ip.
      port: parseInt(parts[5], 10),
      // skip parts[6] == 'typ'
      type: parts[7]
    };

    for (var i = 8; i < parts.length; i += 2) {
      switch (parts[i]) {
        case 'raddr':
          candidate.relatedAddress = parts[i + 1];
          break;
        case 'rport':
          candidate.relatedPort = parseInt(parts[i + 1], 10);
          break;
        case 'tcptype':
          candidate.tcpType = parts[i + 1];
          break;
        case 'ufrag':
          candidate.ufrag = parts[i + 1]; // for backward compability.
          candidate.usernameFragment = parts[i + 1];
          break;
        default: // extension handling, in particular ufrag
          candidate[parts[i]] = parts[i + 1];
          break;
      }
    }
    return candidate;
  };

  // Translates a candidate object into SDP candidate attribute.
  SDPUtils.writeCandidate = function(candidate) {
    var sdp = [];
    sdp.push(candidate.foundation);
    sdp.push(candidate.component);
    sdp.push(candidate.protocol.toUpperCase());
    sdp.push(candidate.priority);
    sdp.push(candidate.address || candidate.ip);
    sdp.push(candidate.port);

    var type = candidate.type;
    sdp.push('typ');
    sdp.push(type);
    if (type !== 'host' && candidate.relatedAddress &&
        candidate.relatedPort) {
      sdp.push('raddr');
      sdp.push(candidate.relatedAddress);
      sdp.push('rport');
      sdp.push(candidate.relatedPort);
    }
    if (candidate.tcpType && candidate.protocol.toLowerCase() === 'tcp') {
      sdp.push('tcptype');
      sdp.push(candidate.tcpType);
    }
    if (candidate.usernameFragment || candidate.ufrag) {
      sdp.push('ufrag');
      sdp.push(candidate.usernameFragment || candidate.ufrag);
    }
    return 'candidate:' + sdp.join(' ');
  };

  // Parses an ice-options line, returns an array of option tags.
  // a=ice-options:foo bar
  SDPUtils.parseIceOptions = function(line) {
    return line.substr(14).split(' ');
  };

  // Parses an rtpmap line, returns RTCRtpCoddecParameters. Sample input:
  // a=rtpmap:111 opus/48000/2
  SDPUtils.parseRtpMap = function(line) {
    var parts = line.substr(9).split(' ');
    var parsed = {
      payloadType: parseInt(parts.shift(), 10) // was: id
    };

    parts = parts[0].split('/');

    parsed.name = parts[0];
    parsed.clockRate = parseInt(parts[1], 10); // was: clockrate
    parsed.channels = parts.length === 3 ? parseInt(parts[2], 10) : 1;
    // legacy alias, got renamed back to channels in ORTC.
    parsed.numChannels = parsed.channels;
    return parsed;
  };

  // Generate an a=rtpmap line from RTCRtpCodecCapability or
  // RTCRtpCodecParameters.
  SDPUtils.writeRtpMap = function(codec) {
    var pt = codec.payloadType;
    if (codec.preferredPayloadType !== undefined) {
      pt = codec.preferredPayloadType;
    }
    var channels = codec.channels || codec.numChannels || 1;
    return 'a=rtpmap:' + pt + ' ' + codec.name + '/' + codec.clockRate +
        (channels !== 1 ? '/' + channels : '') + '\r\n';
  };

  // Parses an a=extmap line (headerextension from RFC 5285). Sample input:
  // a=extmap:2 urn:ietf:params:rtp-hdrext:toffset
  // a=extmap:2/sendonly urn:ietf:params:rtp-hdrext:toffset
  SDPUtils.parseExtmap = function(line) {
    var parts = line.substr(9).split(' ');
    return {
      id: parseInt(parts[0], 10),
      direction: parts[0].indexOf('/') > 0 ? parts[0].split('/')[1] : 'sendrecv',
      uri: parts[1]
    };
  };

  // Generates a=extmap line from RTCRtpHeaderExtensionParameters or
  // RTCRtpHeaderExtension.
  SDPUtils.writeExtmap = function(headerExtension) {
    return 'a=extmap:' + (headerExtension.id || headerExtension.preferredId) +
        (headerExtension.direction && headerExtension.direction !== 'sendrecv'
          ? '/' + headerExtension.direction
          : '') +
        ' ' + headerExtension.uri + '\r\n';
  };

  // Parses an ftmp line, returns dictionary. Sample input:
  // a=fmtp:96 vbr=on;cng=on
  // Also deals with vbr=on; cng=on
  SDPUtils.parseFmtp = function(line) {
    var parsed = {};
    var kv;
    var parts = line.substr(line.indexOf(' ') + 1).split(';');
    for (var j = 0; j < parts.length; j++) {
      kv = parts[j].trim().split('=');
      parsed[kv[0].trim()] = kv[1];
    }
    return parsed;
  };

  // Generates an a=ftmp line from RTCRtpCodecCapability or RTCRtpCodecParameters.
  SDPUtils.writeFmtp = function(codec) {
    var line = '';
    var pt = codec.payloadType;
    if (codec.preferredPayloadType !== undefined) {
      pt = codec.preferredPayloadType;
    }
    if (codec.parameters && Object.keys(codec.parameters).length) {
      var params = [];
      Object.keys(codec.parameters).forEach(function(param) {
        if (codec.parameters[param]) {
          params.push(param + '=' + codec.parameters[param]);
        } else {
          params.push(param);
        }
      });
      line += 'a=fmtp:' + pt + ' ' + params.join(';') + '\r\n';
    }
    return line;
  };

  // Parses an rtcp-fb line, returns RTCPRtcpFeedback object. Sample input:
  // a=rtcp-fb:98 nack rpsi
  SDPUtils.parseRtcpFb = function(line) {
    var parts = line.substr(line.indexOf(' ') + 1).split(' ');
    return {
      type: parts.shift(),
      parameter: parts.join(' ')
    };
  };
  // Generate a=rtcp-fb lines from RTCRtpCodecCapability or RTCRtpCodecParameters.
  SDPUtils.writeRtcpFb = function(codec) {
    var lines = '';
    var pt = codec.payloadType;
    if (codec.preferredPayloadType !== undefined) {
      pt = codec.preferredPayloadType;
    }
    if (codec.rtcpFeedback && codec.rtcpFeedback.length) {
      // FIXME: special handling for trr-int?
      codec.rtcpFeedback.forEach(function(fb) {
        lines += 'a=rtcp-fb:' + pt + ' ' + fb.type +
        (fb.parameter && fb.parameter.length ? ' ' + fb.parameter : '') +
            '\r\n';
      });
    }
    return lines;
  };

  // Parses an RFC 5576 ssrc media attribute. Sample input:
  // a=ssrc:3735928559 cname:something
  SDPUtils.parseSsrcMedia = function(line) {
    var sp = line.indexOf(' ');
    var parts = {
      ssrc: parseInt(line.substr(7, sp - 7), 10)
    };
    var colon = line.indexOf(':', sp);
    if (colon > -1) {
      parts.attribute = line.substr(sp + 1, colon - sp - 1);
      parts.value = line.substr(colon + 1);
    } else {
      parts.attribute = line.substr(sp + 1);
    }
    return parts;
  };

  SDPUtils.parseSsrcGroup = function(line) {
    var parts = line.substr(13).split(' ');
    return {
      semantics: parts.shift(),
      ssrcs: parts.map(function(ssrc) {
        return parseInt(ssrc, 10);
      })
    };
  };

  // Extracts the MID (RFC 5888) from a media section.
  // returns the MID or undefined if no mid line was found.
  SDPUtils.getMid = function(mediaSection) {
    var mid = SDPUtils.matchPrefix(mediaSection, 'a=mid:')[0];
    if (mid) {
      return mid.substr(6);
    }
  };

  SDPUtils.parseFingerprint = function(line) {
    var parts = line.substr(14).split(' ');
    return {
      algorithm: parts[0].toLowerCase(), // algorithm is case-sensitive in Edge.
      value: parts[1]
    };
  };

  // Extracts DTLS parameters from SDP media section or sessionpart.
  // FIXME: for consistency with other functions this should only
  //   get the fingerprint line as input. See also getIceParameters.
  SDPUtils.getDtlsParameters = function(mediaSection, sessionpart) {
    var lines = SDPUtils.matchPrefix(mediaSection + sessionpart,
      'a=fingerprint:');
    // Note: a=setup line is ignored since we use the 'auto' role.
    // Note2: 'algorithm' is not case sensitive except in Edge.
    return {
      role: 'auto',
      fingerprints: lines.map(SDPUtils.parseFingerprint)
    };
  };

  // Serializes DTLS parameters to SDP.
  SDPUtils.writeDtlsParameters = function(params, setupType) {
    var sdp = 'a=setup:' + setupType + '\r\n';
    params.fingerprints.forEach(function(fp) {
      sdp += 'a=fingerprint:' + fp.algorithm + ' ' + fp.value + '\r\n';
    });
    return sdp;
  };

  // Parses a=crypto lines into
  //   https://rawgit.com/aboba/edgertc/master/msortc-rs4.html#dictionary-rtcsrtpsdesparameters-members
  SDPUtils.parseCryptoLine = function(line) {
    var parts = line.substr(9).split(' ');
    return {
      tag: parseInt(parts[0], 10),
      cryptoSuite: parts[1],
      keyParams: parts[2],
      sessionParams: parts.slice(3),
    };
  };

  SDPUtils.writeCryptoLine = function(parameters) {
    return 'a=crypto:' + parameters.tag + ' ' +
      parameters.cryptoSuite + ' ' +
      (typeof parameters.keyParams === 'object'
        ? SDPUtils.writeCryptoKeyParams(parameters.keyParams)
        : parameters.keyParams) +
      (parameters.sessionParams ? ' ' + parameters.sessionParams.join(' ') : '') +
      '\r\n';
  };

  // Parses the crypto key parameters into
  //   https://rawgit.com/aboba/edgertc/master/msortc-rs4.html#rtcsrtpkeyparam*
  SDPUtils.parseCryptoKeyParams = function(keyParams) {
    if (keyParams.indexOf('inline:') !== 0) {
      return null;
    }
    var parts = keyParams.substr(7).split('|');
    return {
      keyMethod: 'inline',
      keySalt: parts[0],
      lifeTime: parts[1],
      mkiValue: parts[2] ? parts[2].split(':')[0] : undefined,
      mkiLength: parts[2] ? parts[2].split(':')[1] : undefined,
    };
  };

  SDPUtils.writeCryptoKeyParams = function(keyParams) {
    return keyParams.keyMethod + ':'
      + keyParams.keySalt +
      (keyParams.lifeTime ? '|' + keyParams.lifeTime : '') +
      (keyParams.mkiValue && keyParams.mkiLength
        ? '|' + keyParams.mkiValue + ':' + keyParams.mkiLength
        : '');
  };

  // Extracts all SDES paramters.
  SDPUtils.getCryptoParameters = function(mediaSection, sessionpart) {
    var lines = SDPUtils.matchPrefix(mediaSection + sessionpart,
      'a=crypto:');
    return lines.map(SDPUtils.parseCryptoLine);
  };

  // Parses ICE information from SDP media section or sessionpart.
  // FIXME: for consistency with other functions this should only
  //   get the ice-ufrag and ice-pwd lines as input.
  SDPUtils.getIceParameters = function(mediaSection, sessionpart) {
    var ufrag = SDPUtils.matchPrefix(mediaSection + sessionpart,
      'a=ice-ufrag:')[0];
    var pwd = SDPUtils.matchPrefix(mediaSection + sessionpart,
      'a=ice-pwd:')[0];
    if (!(ufrag && pwd)) {
      return null;
    }
    return {
      usernameFragment: ufrag.substr(12),
      password: pwd.substr(10),
    };
  };

  // Serializes ICE parameters to SDP.
  SDPUtils.writeIceParameters = function(params) {
    return 'a=ice-ufrag:' + params.usernameFragment + '\r\n' +
        'a=ice-pwd:' + params.password + '\r\n';
  };

  // Parses the SDP media section and returns RTCRtpParameters.
  SDPUtils.parseRtpParameters = function(mediaSection) {
    var description = {
      codecs: [],
      headerExtensions: [],
      fecMechanisms: [],
      rtcp: []
    };
    var lines = SDPUtils.splitLines(mediaSection);
    var mline = lines[0].split(' ');
    for (var i = 3; i < mline.length; i++) { // find all codecs from mline[3..]
      var pt = mline[i];
      var rtpmapline = SDPUtils.matchPrefix(
        mediaSection, 'a=rtpmap:' + pt + ' ')[0];
      if (rtpmapline) {
        var codec = SDPUtils.parseRtpMap(rtpmapline);
        var fmtps = SDPUtils.matchPrefix(
          mediaSection, 'a=fmtp:' + pt + ' ');
        // Only the first a=fmtp:<pt> is considered.
        codec.parameters = fmtps.length ? SDPUtils.parseFmtp(fmtps[0]) : {};
        codec.rtcpFeedback = SDPUtils.matchPrefix(
          mediaSection, 'a=rtcp-fb:' + pt + ' ')
          .map(SDPUtils.parseRtcpFb);
        description.codecs.push(codec);
        // parse FEC mechanisms from rtpmap lines.
        switch (codec.name.toUpperCase()) {
          case 'RED':
          case 'ULPFEC':
            description.fecMechanisms.push(codec.name.toUpperCase());
            break;
        }
      }
    }
    SDPUtils.matchPrefix(mediaSection, 'a=extmap:').forEach(function(line) {
      description.headerExtensions.push(SDPUtils.parseExtmap(line));
    });
    // FIXME: parse rtcp.
    return description;
  };

  // Generates parts of the SDP media section describing the capabilities /
  // parameters.
  SDPUtils.writeRtpDescription = function(kind, caps) {
    var sdp = '';

    // Build the mline.
    sdp += 'm=' + kind + ' ';
    sdp += caps.codecs.length > 0 ? '9' : '0'; // reject if no codecs.
    sdp += ' UDP/TLS/RTP/SAVPF ';
    sdp += caps.codecs.map(function(codec) {
      if (codec.preferredPayloadType !== undefined) {
        return codec.preferredPayloadType;
      }
      return codec.payloadType;
    }).join(' ') + '\r\n';

    sdp += 'c=IN IP4 0.0.0.0\r\n';
    sdp += 'a=rtcp:9 IN IP4 0.0.0.0\r\n';

    // Add a=rtpmap lines for each codec. Also fmtp and rtcp-fb.
    caps.codecs.forEach(function(codec) {
      sdp += SDPUtils.writeRtpMap(codec);
      sdp += SDPUtils.writeFmtp(codec);
      sdp += SDPUtils.writeRtcpFb(codec);
    });
    var maxptime = 0;
    caps.codecs.forEach(function(codec) {
      if (codec.maxptime > maxptime) {
        maxptime = codec.maxptime;
      }
    });
    if (maxptime > 0) {
      sdp += 'a=maxptime:' + maxptime + '\r\n';
    }
    sdp += 'a=rtcp-mux\r\n';

    if (caps.headerExtensions) {
      caps.headerExtensions.forEach(function(extension) {
        sdp += SDPUtils.writeExtmap(extension);
      });
    }
    // FIXME: write fecMechanisms.
    return sdp;
  };

  // Parses the SDP media section and returns an array of
  // RTCRtpEncodingParameters.
  SDPUtils.parseRtpEncodingParameters = function(mediaSection) {
    var encodingParameters = [];
    var description = SDPUtils.parseRtpParameters(mediaSection);
    var hasRed = description.fecMechanisms.indexOf('RED') !== -1;
    var hasUlpfec = description.fecMechanisms.indexOf('ULPFEC') !== -1;

    // filter a=ssrc:... cname:, ignore PlanB-msid
    var ssrcs = SDPUtils.matchPrefix(mediaSection, 'a=ssrc:')
      .map(function(line) {
        return SDPUtils.parseSsrcMedia(line);
      })
      .filter(function(parts) {
        return parts.attribute === 'cname';
      });
    var primarySsrc = ssrcs.length > 0 && ssrcs[0].ssrc;
    var secondarySsrc;

    var flows = SDPUtils.matchPrefix(mediaSection, 'a=ssrc-group:FID')
      .map(function(line) {
        var parts = line.substr(17).split(' ');
        return parts.map(function(part) {
          return parseInt(part, 10);
        });
      });
    if (flows.length > 0 && flows[0].length > 1 && flows[0][0] === primarySsrc) {
      secondarySsrc = flows[0][1];
    }

    description.codecs.forEach(function(codec) {
      if (codec.name.toUpperCase() === 'RTX' && codec.parameters.apt) {
        var encParam = {
          ssrc: primarySsrc,
          codecPayloadType: parseInt(codec.parameters.apt, 10)
        };
        if (primarySsrc && secondarySsrc) {
          encParam.rtx = {ssrc: secondarySsrc};
        }
        encodingParameters.push(encParam);
        if (hasRed) {
          encParam = JSON.parse(JSON.stringify(encParam));
          encParam.fec = {
            ssrc: primarySsrc,
            mechanism: hasUlpfec ? 'red+ulpfec' : 'red'
          };
          encodingParameters.push(encParam);
        }
      }
    });
    if (encodingParameters.length === 0 && primarySsrc) {
      encodingParameters.push({
        ssrc: primarySsrc
      });
    }

    // we support both b=AS and b=TIAS but interpret AS as TIAS.
    var bandwidth = SDPUtils.matchPrefix(mediaSection, 'b=');
    if (bandwidth.length) {
      if (bandwidth[0].indexOf('b=TIAS:') === 0) {
        bandwidth = parseInt(bandwidth[0].substr(7), 10);
      } else if (bandwidth[0].indexOf('b=AS:') === 0) {
        // use formula from JSEP to convert b=AS to TIAS value.
        bandwidth = parseInt(bandwidth[0].substr(5), 10) * 1000 * 0.95
            - (50 * 40 * 8);
      } else {
        bandwidth = undefined;
      }
      encodingParameters.forEach(function(params) {
        params.maxBitrate = bandwidth;
      });
    }
    return encodingParameters;
  };

  // parses http://draft.ortc.org/#rtcrtcpparameters*
  SDPUtils.parseRtcpParameters = function(mediaSection) {
    var rtcpParameters = {};

    // Gets the first SSRC. Note tha with RTX there might be multiple
    // SSRCs.
    var remoteSsrc = SDPUtils.matchPrefix(mediaSection, 'a=ssrc:')
      .map(function(line) {
        return SDPUtils.parseSsrcMedia(line);
      })
      .filter(function(obj) {
        return obj.attribute === 'cname';
      })[0];
    if (remoteSsrc) {
      rtcpParameters.cname = remoteSsrc.value;
      rtcpParameters.ssrc = remoteSsrc.ssrc;
    }

    // Edge uses the compound attribute instead of reducedSize
    // compound is !reducedSize
    var rsize = SDPUtils.matchPrefix(mediaSection, 'a=rtcp-rsize');
    rtcpParameters.reducedSize = rsize.length > 0;
    rtcpParameters.compound = rsize.length === 0;

    // parses the rtcp-mux attrіbute.
    // Note that Edge does not support unmuxed RTCP.
    var mux = SDPUtils.matchPrefix(mediaSection, 'a=rtcp-mux');
    rtcpParameters.mux = mux.length > 0;

    return rtcpParameters;
  };

  // parses either a=msid: or a=ssrc:... msid lines and returns
  // the id of the MediaStream and MediaStreamTrack.
  SDPUtils.parseMsid = function(mediaSection) {
    var parts;
    var spec = SDPUtils.matchPrefix(mediaSection, 'a=msid:');
    if (spec.length === 1) {
      parts = spec[0].substr(7).split(' ');
      return {stream: parts[0], track: parts[1]};
    }
    var planB = SDPUtils.matchPrefix(mediaSection, 'a=ssrc:')
      .map(function(line) {
        return SDPUtils.parseSsrcMedia(line);
      })
      .filter(function(msidParts) {
        return msidParts.attribute === 'msid';
      });
    if (planB.length > 0) {
      parts = planB[0].value.split(' ');
      return {stream: parts[0], track: parts[1]};
    }
  };

  // SCTP
  // parses draft-ietf-mmusic-sctp-sdp-26 first and falls back
  // to draft-ietf-mmusic-sctp-sdp-05
  SDPUtils.parseSctpDescription = function(mediaSection) {
    var mline = SDPUtils.parseMLine(mediaSection);
    var maxSizeLine = SDPUtils.matchPrefix(mediaSection, 'a=max-message-size:');
    var maxMessageSize;
    if (maxSizeLine.length > 0) {
      maxMessageSize = parseInt(maxSizeLine[0].substr(19), 10);
    }
    if (isNaN(maxMessageSize)) {
      maxMessageSize = 65536;
    }
    var sctpPort = SDPUtils.matchPrefix(mediaSection, 'a=sctp-port:');
    if (sctpPort.length > 0) {
      return {
        port: parseInt(sctpPort[0].substr(12), 10),
        protocol: mline.fmt,
        maxMessageSize: maxMessageSize
      };
    }
    var sctpMapLines = SDPUtils.matchPrefix(mediaSection, 'a=sctpmap:');
    if (sctpMapLines.length > 0) {
      var parts = SDPUtils.matchPrefix(mediaSection, 'a=sctpmap:')[0]
        .substr(10)
        .split(' ');
      return {
        port: parseInt(parts[0], 10),
        protocol: parts[1],
        maxMessageSize: maxMessageSize
      };
    }
  };

  // SCTP
  // outputs the draft-ietf-mmusic-sctp-sdp-26 version that all browsers
  // support by now receiving in this format, unless we originally parsed
  // as the draft-ietf-mmusic-sctp-sdp-05 format (indicated by the m-line
  // protocol of DTLS/SCTP -- without UDP/ or TCP/)
  SDPUtils.writeSctpDescription = function(media, sctp) {
    var output = [];
    if (media.protocol !== 'DTLS/SCTP') {
      output = [
        'm=' + media.kind + ' 9 ' + media.protocol + ' ' + sctp.protocol + '\r\n',
        'c=IN IP4 0.0.0.0\r\n',
        'a=sctp-port:' + sctp.port + '\r\n'
      ];
    } else {
      output = [
        'm=' + media.kind + ' 9 ' + media.protocol + ' ' + sctp.port + '\r\n',
        'c=IN IP4 0.0.0.0\r\n',
        'a=sctpmap:' + sctp.port + ' ' + sctp.protocol + ' 65535\r\n'
      ];
    }
    if (sctp.maxMessageSize !== undefined) {
      output.push('a=max-message-size:' + sctp.maxMessageSize + '\r\n');
    }
    return output.join('');
  };

  // Generate a session ID for SDP.
  // https://tools.ietf.org/html/draft-ietf-rtcweb-jsep-20#section-5.2.1
  // recommends using a cryptographically random +ve 64-bit value
  // but right now this should be acceptable and within the right range
  SDPUtils.generateSessionId = function() {
    return Math.random().toString().substr(2, 21);
  };

  // Write boilder plate for start of SDP
  // sessId argument is optional - if not supplied it will
  // be generated randomly
  // sessVersion is optional and defaults to 2
  // sessUser is optional and defaults to 'thisisadapterortc'
  SDPUtils.writeSessionBoilerplate = function(sessId, sessVer, sessUser) {
    var sessionId;
    var version = sessVer !== undefined ? sessVer : 2;
    if (sessId) {
      sessionId = sessId;
    } else {
      sessionId = SDPUtils.generateSessionId();
    }
    var user = sessUser || 'thisisadapterortc';
    // FIXME: sess-id should be an NTP timestamp.
    return 'v=0\r\n' +
        'o=' + user + ' ' + sessionId + ' ' + version +
          ' IN IP4 127.0.0.1\r\n' +
        's=-\r\n' +
        't=0 0\r\n';
  };

  SDPUtils.writeMediaSection = function(transceiver, caps, type, stream) {
    var sdp = SDPUtils.writeRtpDescription(transceiver.kind, caps);

    // Map ICE parameters (ufrag, pwd) to SDP.
    sdp += SDPUtils.writeIceParameters(
      transceiver.iceGatherer.getLocalParameters());

    // Map DTLS parameters to SDP.
    sdp += SDPUtils.writeDtlsParameters(
      transceiver.dtlsTransport.getLocalParameters(),
      type === 'offer' ? 'actpass' : 'active');

    sdp += 'a=mid:' + transceiver.mid + '\r\n';

    if (transceiver.direction) {
      sdp += 'a=' + transceiver.direction + '\r\n';
    } else if (transceiver.rtpSender && transceiver.rtpReceiver) {
      sdp += 'a=sendrecv\r\n';
    } else if (transceiver.rtpSender) {
      sdp += 'a=sendonly\r\n';
    } else if (transceiver.rtpReceiver) {
      sdp += 'a=recvonly\r\n';
    } else {
      sdp += 'a=inactive\r\n';
    }

    if (transceiver.rtpSender) {
      // spec.
      var msid = 'msid:' + stream.id + ' ' +
          transceiver.rtpSender.track.id + '\r\n';
      sdp += 'a=' + msid;

      // for Chrome.
      sdp += 'a=ssrc:' + transceiver.sendEncodingParameters[0].ssrc +
          ' ' + msid;
      if (transceiver.sendEncodingParameters[0].rtx) {
        sdp += 'a=ssrc:' + transceiver.sendEncodingParameters[0].rtx.ssrc +
            ' ' + msid;
        sdp += 'a=ssrc-group:FID ' +
            transceiver.sendEncodingParameters[0].ssrc + ' ' +
            transceiver.sendEncodingParameters[0].rtx.ssrc +
            '\r\n';
      }
    }
    // FIXME: this should be written by writeRtpDescription.
    sdp += 'a=ssrc:' + transceiver.sendEncodingParameters[0].ssrc +
        ' cname:' + SDPUtils.localCName + '\r\n';
    if (transceiver.rtpSender && transceiver.sendEncodingParameters[0].rtx) {
      sdp += 'a=ssrc:' + transceiver.sendEncodingParameters[0].rtx.ssrc +
          ' cname:' + SDPUtils.localCName + '\r\n';
    }
    return sdp;
  };

  // Gets the direction from the mediaSection or the sessionpart.
  SDPUtils.getDirection = function(mediaSection, sessionpart) {
    // Look for sendrecv, sendonly, recvonly, inactive, default to sendrecv.
    var lines = SDPUtils.splitLines(mediaSection);
    for (var i = 0; i < lines.length; i++) {
      switch (lines[i]) {
        case 'a=sendrecv':
        case 'a=sendonly':
        case 'a=recvonly':
        case 'a=inactive':
          return lines[i].substr(2);
          // FIXME: What should happen here?
      }
    }
    if (sessionpart) {
      return SDPUtils.getDirection(sessionpart);
    }
    return 'sendrecv';
  };

  SDPUtils.getKind = function(mediaSection) {
    var lines = SDPUtils.splitLines(mediaSection);
    var mline = lines[0].split(' ');
    return mline[0].substr(2);
  };

  SDPUtils.isRejected = function(mediaSection) {
    return mediaSection.split(' ', 2)[1] === '0';
  };

  SDPUtils.parseMLine = function(mediaSection) {
    var lines = SDPUtils.splitLines(mediaSection);
    var parts = lines[0].substr(2).split(' ');
    return {
      kind: parts[0],
      port: parseInt(parts[1], 10),
      protocol: parts[2],
      fmt: parts.slice(3).join(' ')
    };
  };

  SDPUtils.parseOLine = function(mediaSection) {
    var line = SDPUtils.matchPrefix(mediaSection, 'o=')[0];
    var parts = line.substr(2).split(' ');
    return {
      username: parts[0],
      sessionId: parts[1],
      sessionVersion: parseInt(parts[2], 10),
      netType: parts[3],
      addressType: parts[4],
      address: parts[5]
    };
  };

  // a very naive interpretation of a valid SDP.
  SDPUtils.isValidSDP = function(blob) {
    if (typeof blob !== 'string' || blob.length === 0) {
      return false;
    }
    var lines = SDPUtils.splitLines(blob);
    for (var i = 0; i < lines.length; i++) {
      if (lines[i].length < 2 || lines[i].charAt(1) !== '=') {
        return false;
      }
      // TODO: check the modifier a bit more.
    }
    return true;
  };

  // Expose public methods.
  {
    module.exports = SDPUtils;
  }
  });

  function fixStatsType(stat) {
    return {
      inboundrtp: 'inbound-rtp',
      outboundrtp: 'outbound-rtp',
      candidatepair: 'candidate-pair',
      localcandidate: 'local-candidate',
      remotecandidate: 'remote-candidate'
    }[stat.type] || stat.type;
  }

  function writeMediaSection(transceiver, caps, type, stream, dtlsRole) {
    var sdp$1 = sdp.writeRtpDescription(transceiver.kind, caps);

    // Map ICE parameters (ufrag, pwd) to SDP.
    sdp$1 += sdp.writeIceParameters(
        transceiver.iceGatherer.getLocalParameters());

    // Map DTLS parameters to SDP.
    sdp$1 += sdp.writeDtlsParameters(
        transceiver.dtlsTransport.getLocalParameters(),
        type === 'offer' ? 'actpass' : dtlsRole || 'active');

    sdp$1 += 'a=mid:' + transceiver.mid + '\r\n';

    if (transceiver.rtpSender && transceiver.rtpReceiver) {
      sdp$1 += 'a=sendrecv\r\n';
    } else if (transceiver.rtpSender) {
      sdp$1 += 'a=sendonly\r\n';
    } else if (transceiver.rtpReceiver) {
      sdp$1 += 'a=recvonly\r\n';
    } else {
      sdp$1 += 'a=inactive\r\n';
    }

    if (transceiver.rtpSender) {
      var trackId = transceiver.rtpSender._initialTrackId ||
          transceiver.rtpSender.track.id;
      transceiver.rtpSender._initialTrackId = trackId;
      // spec.
      var msid = 'msid:' + (stream ? stream.id : '-') + ' ' +
          trackId + '\r\n';
      sdp$1 += 'a=' + msid;
      // for Chrome. Legacy should no longer be required.
      sdp$1 += 'a=ssrc:' + transceiver.sendEncodingParameters[0].ssrc +
          ' ' + msid;

      // RTX
      if (transceiver.sendEncodingParameters[0].rtx) {
        sdp$1 += 'a=ssrc:' + transceiver.sendEncodingParameters[0].rtx.ssrc +
            ' ' + msid;
        sdp$1 += 'a=ssrc-group:FID ' +
            transceiver.sendEncodingParameters[0].ssrc + ' ' +
            transceiver.sendEncodingParameters[0].rtx.ssrc +
            '\r\n';
      }
    }
    // FIXME: this should be written by writeRtpDescription.
    sdp$1 += 'a=ssrc:' + transceiver.sendEncodingParameters[0].ssrc +
        ' cname:' + sdp.localCName + '\r\n';
    if (transceiver.rtpSender && transceiver.sendEncodingParameters[0].rtx) {
      sdp$1 += 'a=ssrc:' + transceiver.sendEncodingParameters[0].rtx.ssrc +
          ' cname:' + sdp.localCName + '\r\n';
    }
    return sdp$1;
  }

  // Edge does not like
  // 1) stun: filtered after 14393 unless ?transport=udp is present
  // 2) turn: that does not have all of turn:host:port?transport=udp
  // 3) turn: with ipv6 addresses
  // 4) turn: occurring muliple times
  function filterIceServers$1(iceServers, edgeVersion) {
    var hasTurn = false;
    iceServers = JSON.parse(JSON.stringify(iceServers));
    return iceServers.filter(function(server) {
      if (server && (server.urls || server.url)) {
        var urls = server.urls || server.url;
        if (server.url && !server.urls) {
          console.warn('RTCIceServer.url is deprecated! Use urls instead.');
        }
        var isString = typeof urls === 'string';
        if (isString) {
          urls = [urls];
        }
        urls = urls.filter(function(url) {
          var validTurn = url.indexOf('turn:') === 0 &&
              url.indexOf('transport=udp') !== -1 &&
              url.indexOf('turn:[') === -1 &&
              !hasTurn;

          if (validTurn) {
            hasTurn = true;
            return true;
          }
          return url.indexOf('stun:') === 0 && edgeVersion >= 14393 &&
              url.indexOf('?transport=udp') === -1;
        });

        delete server.url;
        server.urls = isString ? urls[0] : urls;
        return !!urls.length;
      }
    });
  }

  // Determines the intersection of local and remote capabilities.
  function getCommonCapabilities(localCapabilities, remoteCapabilities) {
    var commonCapabilities = {
      codecs: [],
      headerExtensions: [],
      fecMechanisms: []
    };

    var findCodecByPayloadType = function(pt, codecs) {
      pt = parseInt(pt, 10);
      for (var i = 0; i < codecs.length; i++) {
        if (codecs[i].payloadType === pt ||
            codecs[i].preferredPayloadType === pt) {
          return codecs[i];
        }
      }
    };

    var rtxCapabilityMatches = function(lRtx, rRtx, lCodecs, rCodecs) {
      var lCodec = findCodecByPayloadType(lRtx.parameters.apt, lCodecs);
      var rCodec = findCodecByPayloadType(rRtx.parameters.apt, rCodecs);
      return lCodec && rCodec &&
          lCodec.name.toLowerCase() === rCodec.name.toLowerCase();
    };

    localCapabilities.codecs.forEach(function(lCodec) {
      for (var i = 0; i < remoteCapabilities.codecs.length; i++) {
        var rCodec = remoteCapabilities.codecs[i];
        if (lCodec.name.toLowerCase() === rCodec.name.toLowerCase() &&
            lCodec.clockRate === rCodec.clockRate) {
          if (lCodec.name.toLowerCase() === 'rtx' &&
              lCodec.parameters && rCodec.parameters.apt) {
            // for RTX we need to find the local rtx that has a apt
            // which points to the same local codec as the remote one.
            if (!rtxCapabilityMatches(lCodec, rCodec,
                localCapabilities.codecs, remoteCapabilities.codecs)) {
              continue;
            }
          }
          rCodec = JSON.parse(JSON.stringify(rCodec)); // deepcopy
          // number of channels is the highest common number of channels
          rCodec.numChannels = Math.min(lCodec.numChannels,
              rCodec.numChannels);
          // push rCodec so we reply with offerer payload type
          commonCapabilities.codecs.push(rCodec);

          // determine common feedback mechanisms
          rCodec.rtcpFeedback = rCodec.rtcpFeedback.filter(function(fb) {
            for (var j = 0; j < lCodec.rtcpFeedback.length; j++) {
              if (lCodec.rtcpFeedback[j].type === fb.type &&
                  lCodec.rtcpFeedback[j].parameter === fb.parameter) {
                return true;
              }
            }
            return false;
          });
          // FIXME: also need to determine .parameters
          //  see https://github.com/openpeer/ortc/issues/569
          break;
        }
      }
    });

    localCapabilities.headerExtensions.forEach(function(lHeaderExtension) {
      for (var i = 0; i < remoteCapabilities.headerExtensions.length;
           i++) {
        var rHeaderExtension = remoteCapabilities.headerExtensions[i];
        if (lHeaderExtension.uri === rHeaderExtension.uri) {
          commonCapabilities.headerExtensions.push(rHeaderExtension);
          break;
        }
      }
    });

    // FIXME: fecMechanisms
    return commonCapabilities;
  }

  // is action=setLocalDescription with type allowed in signalingState
  function isActionAllowedInSignalingState(action, type, signalingState) {
    return {
      offer: {
        setLocalDescription: ['stable', 'have-local-offer'],
        setRemoteDescription: ['stable', 'have-remote-offer']
      },
      answer: {
        setLocalDescription: ['have-remote-offer', 'have-local-pranswer'],
        setRemoteDescription: ['have-local-offer', 'have-remote-pranswer']
      }
    }[type][action].indexOf(signalingState) !== -1;
  }

  function maybeAddCandidate(iceTransport, candidate) {
    // Edge's internal representation adds some fields therefore
    // not all fieldѕ are taken into account.
    var alreadyAdded = iceTransport.getRemoteCandidates()
        .find(function(remoteCandidate) {
          return candidate.foundation === remoteCandidate.foundation &&
              candidate.ip === remoteCandidate.ip &&
              candidate.port === remoteCandidate.port &&
              candidate.priority === remoteCandidate.priority &&
              candidate.protocol === remoteCandidate.protocol &&
              candidate.type === remoteCandidate.type;
        });
    if (!alreadyAdded) {
      iceTransport.addRemoteCandidate(candidate);
    }
    return !alreadyAdded;
  }


  function makeError(name, description) {
    var e = new Error(description);
    e.name = name;
    // legacy error codes from https://heycam.github.io/webidl/#idl-DOMException-error-names
    e.code = {
      NotSupportedError: 9,
      InvalidStateError: 11,
      InvalidAccessError: 15,
      TypeError: undefined,
      OperationError: undefined
    }[name];
    return e;
  }

  var rtcpeerconnection = function(window, edgeVersion) {
    // https://w3c.github.io/mediacapture-main/#mediastream
    // Helper function to add the track to the stream and
    // dispatch the event ourselves.
    function addTrackToStreamAndFireEvent(track, stream) {
      stream.addTrack(track);
      stream.dispatchEvent(new window.MediaStreamTrackEvent('addtrack',
          {track: track}));
    }

    function removeTrackFromStreamAndFireEvent(track, stream) {
      stream.removeTrack(track);
      stream.dispatchEvent(new window.MediaStreamTrackEvent('removetrack',
          {track: track}));
    }

    function fireAddTrack(pc, track, receiver, streams) {
      var trackEvent = new Event('track');
      trackEvent.track = track;
      trackEvent.receiver = receiver;
      trackEvent.transceiver = {receiver: receiver};
      trackEvent.streams = streams;
      window.setTimeout(function() {
        pc._dispatchEvent('track', trackEvent);
      });
    }

    var RTCPeerConnection = function(config) {
      var pc = this;

      var _eventTarget = document.createDocumentFragment();
      ['addEventListener', 'removeEventListener', 'dispatchEvent']
          .forEach(function(method) {
            pc[method] = _eventTarget[method].bind(_eventTarget);
          });

      this.canTrickleIceCandidates = null;

      this.needNegotiation = false;

      this.localStreams = [];
      this.remoteStreams = [];

      this._localDescription = null;
      this._remoteDescription = null;

      this.signalingState = 'stable';
      this.iceConnectionState = 'new';
      this.connectionState = 'new';
      this.iceGatheringState = 'new';

      config = JSON.parse(JSON.stringify(config || {}));

      this.usingBundle = config.bundlePolicy === 'max-bundle';
      if (config.rtcpMuxPolicy === 'negotiate') {
        throw(makeError('NotSupportedError',
            'rtcpMuxPolicy \'negotiate\' is not supported'));
      } else if (!config.rtcpMuxPolicy) {
        config.rtcpMuxPolicy = 'require';
      }

      switch (config.iceTransportPolicy) {
        case 'all':
        case 'relay':
          break;
        default:
          config.iceTransportPolicy = 'all';
          break;
      }

      switch (config.bundlePolicy) {
        case 'balanced':
        case 'max-compat':
        case 'max-bundle':
          break;
        default:
          config.bundlePolicy = 'balanced';
          break;
      }

      config.iceServers = filterIceServers$1(config.iceServers || [], edgeVersion);

      this._iceGatherers = [];
      if (config.iceCandidatePoolSize) {
        for (var i = config.iceCandidatePoolSize; i > 0; i--) {
          this._iceGatherers.push(new window.RTCIceGatherer({
            iceServers: config.iceServers,
            gatherPolicy: config.iceTransportPolicy
          }));
        }
      } else {
        config.iceCandidatePoolSize = 0;
      }

      this._config = config;

      // per-track iceGathers, iceTransports, dtlsTransports, rtpSenders, ...
      // everything that is needed to describe a SDP m-line.
      this.transceivers = [];

      this._sdpSessionId = sdp.generateSessionId();
      this._sdpSessionVersion = 0;

      this._dtlsRole = undefined; // role for a=setup to use in answers.

      this._isClosed = false;
    };

    Object.defineProperty(RTCPeerConnection.prototype, 'localDescription', {
      configurable: true,
      get: function() {
        return this._localDescription;
      }
    });
    Object.defineProperty(RTCPeerConnection.prototype, 'remoteDescription', {
      configurable: true,
      get: function() {
        return this._remoteDescription;
      }
    });

    // set up event handlers on prototype
    RTCPeerConnection.prototype.onicecandidate = null;
    RTCPeerConnection.prototype.onaddstream = null;
    RTCPeerConnection.prototype.ontrack = null;
    RTCPeerConnection.prototype.onremovestream = null;
    RTCPeerConnection.prototype.onsignalingstatechange = null;
    RTCPeerConnection.prototype.oniceconnectionstatechange = null;
    RTCPeerConnection.prototype.onconnectionstatechange = null;
    RTCPeerConnection.prototype.onicegatheringstatechange = null;
    RTCPeerConnection.prototype.onnegotiationneeded = null;
    RTCPeerConnection.prototype.ondatachannel = null;

    RTCPeerConnection.prototype._dispatchEvent = function(name, event) {
      if (this._isClosed) {
        return;
      }
      this.dispatchEvent(event);
      if (typeof this['on' + name] === 'function') {
        this['on' + name](event);
      }
    };

    RTCPeerConnection.prototype._emitGatheringStateChange = function() {
      var event = new Event('icegatheringstatechange');
      this._dispatchEvent('icegatheringstatechange', event);
    };

    RTCPeerConnection.prototype.getConfiguration = function() {
      return this._config;
    };

    RTCPeerConnection.prototype.getLocalStreams = function() {
      return this.localStreams;
    };

    RTCPeerConnection.prototype.getRemoteStreams = function() {
      return this.remoteStreams;
    };

    // internal helper to create a transceiver object.
    // (which is not yet the same as the WebRTC 1.0 transceiver)
    RTCPeerConnection.prototype._createTransceiver = function(kind, doNotAdd) {
      var hasBundleTransport = this.transceivers.length > 0;
      var transceiver = {
        track: null,
        iceGatherer: null,
        iceTransport: null,
        dtlsTransport: null,
        localCapabilities: null,
        remoteCapabilities: null,
        rtpSender: null,
        rtpReceiver: null,
        kind: kind,
        mid: null,
        sendEncodingParameters: null,
        recvEncodingParameters: null,
        stream: null,
        associatedRemoteMediaStreams: [],
        wantReceive: true
      };
      if (this.usingBundle && hasBundleTransport) {
        transceiver.iceTransport = this.transceivers[0].iceTransport;
        transceiver.dtlsTransport = this.transceivers[0].dtlsTransport;
      } else {
        var transports = this._createIceAndDtlsTransports();
        transceiver.iceTransport = transports.iceTransport;
        transceiver.dtlsTransport = transports.dtlsTransport;
      }
      if (!doNotAdd) {
        this.transceivers.push(transceiver);
      }
      return transceiver;
    };

    RTCPeerConnection.prototype.addTrack = function(track, stream) {
      if (this._isClosed) {
        throw makeError('InvalidStateError',
            'Attempted to call addTrack on a closed peerconnection.');
      }

      var alreadyExists = this.transceivers.find(function(s) {
        return s.track === track;
      });

      if (alreadyExists) {
        throw makeError('InvalidAccessError', 'Track already exists.');
      }

      var transceiver;
      for (var i = 0; i < this.transceivers.length; i++) {
        if (!this.transceivers[i].track &&
            this.transceivers[i].kind === track.kind) {
          transceiver = this.transceivers[i];
        }
      }
      if (!transceiver) {
        transceiver = this._createTransceiver(track.kind);
      }

      this._maybeFireNegotiationNeeded();

      if (this.localStreams.indexOf(stream) === -1) {
        this.localStreams.push(stream);
      }

      transceiver.track = track;
      transceiver.stream = stream;
      transceiver.rtpSender = new window.RTCRtpSender(track,
          transceiver.dtlsTransport);
      return transceiver.rtpSender;
    };

    RTCPeerConnection.prototype.addStream = function(stream) {
      var pc = this;
      if (edgeVersion >= 15025) {
        stream.getTracks().forEach(function(track) {
          pc.addTrack(track, stream);
        });
      } else {
        // Clone is necessary for local demos mostly, attaching directly
        // to two different senders does not work (build 10547).
        // Fixed in 15025 (or earlier)
        var clonedStream = stream.clone();
        stream.getTracks().forEach(function(track, idx) {
          var clonedTrack = clonedStream.getTracks()[idx];
          track.addEventListener('enabled', function(event) {
            clonedTrack.enabled = event.enabled;
          });
        });
        clonedStream.getTracks().forEach(function(track) {
          pc.addTrack(track, clonedStream);
        });
      }
    };

    RTCPeerConnection.prototype.removeTrack = function(sender) {
      if (this._isClosed) {
        throw makeError('InvalidStateError',
            'Attempted to call removeTrack on a closed peerconnection.');
      }

      if (!(sender instanceof window.RTCRtpSender)) {
        throw new TypeError('Argument 1 of RTCPeerConnection.removeTrack ' +
            'does not implement interface RTCRtpSender.');
      }

      var transceiver = this.transceivers.find(function(t) {
        return t.rtpSender === sender;
      });

      if (!transceiver) {
        throw makeError('InvalidAccessError',
            'Sender was not created by this connection.');
      }
      var stream = transceiver.stream;

      transceiver.rtpSender.stop();
      transceiver.rtpSender = null;
      transceiver.track = null;
      transceiver.stream = null;

      // remove the stream from the set of local streams
      var localStreams = this.transceivers.map(function(t) {
        return t.stream;
      });
      if (localStreams.indexOf(stream) === -1 &&
          this.localStreams.indexOf(stream) > -1) {
        this.localStreams.splice(this.localStreams.indexOf(stream), 1);
      }

      this._maybeFireNegotiationNeeded();
    };

    RTCPeerConnection.prototype.removeStream = function(stream) {
      var pc = this;
      stream.getTracks().forEach(function(track) {
        var sender = pc.getSenders().find(function(s) {
          return s.track === track;
        });
        if (sender) {
          pc.removeTrack(sender);
        }
      });
    };

    RTCPeerConnection.prototype.getSenders = function() {
      return this.transceivers.filter(function(transceiver) {
        return !!transceiver.rtpSender;
      })
      .map(function(transceiver) {
        return transceiver.rtpSender;
      });
    };

    RTCPeerConnection.prototype.getReceivers = function() {
      return this.transceivers.filter(function(transceiver) {
        return !!transceiver.rtpReceiver;
      })
      .map(function(transceiver) {
        return transceiver.rtpReceiver;
      });
    };


    RTCPeerConnection.prototype._createIceGatherer = function(sdpMLineIndex,
        usingBundle) {
      var pc = this;
      if (usingBundle && sdpMLineIndex > 0) {
        return this.transceivers[0].iceGatherer;
      } else if (this._iceGatherers.length) {
        return this._iceGatherers.shift();
      }
      var iceGatherer = new window.RTCIceGatherer({
        iceServers: this._config.iceServers,
        gatherPolicy: this._config.iceTransportPolicy
      });
      Object.defineProperty(iceGatherer, 'state',
          {value: 'new', writable: true}
      );

      this.transceivers[sdpMLineIndex].bufferedCandidateEvents = [];
      this.transceivers[sdpMLineIndex].bufferCandidates = function(event) {
        var end = !event.candidate || Object.keys(event.candidate).length === 0;
        // polyfill since RTCIceGatherer.state is not implemented in
        // Edge 10547 yet.
        iceGatherer.state = end ? 'completed' : 'gathering';
        if (pc.transceivers[sdpMLineIndex].bufferedCandidateEvents !== null) {
          pc.transceivers[sdpMLineIndex].bufferedCandidateEvents.push(event);
        }
      };
      iceGatherer.addEventListener('localcandidate',
        this.transceivers[sdpMLineIndex].bufferCandidates);
      return iceGatherer;
    };

    // start gathering from an RTCIceGatherer.
    RTCPeerConnection.prototype._gather = function(mid, sdpMLineIndex) {
      var pc = this;
      var iceGatherer = this.transceivers[sdpMLineIndex].iceGatherer;
      if (iceGatherer.onlocalcandidate) {
        return;
      }
      var bufferedCandidateEvents =
        this.transceivers[sdpMLineIndex].bufferedCandidateEvents;
      this.transceivers[sdpMLineIndex].bufferedCandidateEvents = null;
      iceGatherer.removeEventListener('localcandidate',
        this.transceivers[sdpMLineIndex].bufferCandidates);
      iceGatherer.onlocalcandidate = function(evt) {
        if (pc.usingBundle && sdpMLineIndex > 0) {
          // if we know that we use bundle we can drop candidates with
          // ѕdpMLineIndex > 0. If we don't do this then our state gets
          // confused since we dispose the extra ice gatherer.
          return;
        }
        var event = new Event('icecandidate');
        event.candidate = {sdpMid: mid, sdpMLineIndex: sdpMLineIndex};

        var cand = evt.candidate;
        // Edge emits an empty object for RTCIceCandidateComplete‥
        var end = !cand || Object.keys(cand).length === 0;
        if (end) {
          // polyfill since RTCIceGatherer.state is not implemented in
          // Edge 10547 yet.
          if (iceGatherer.state === 'new' || iceGatherer.state === 'gathering') {
            iceGatherer.state = 'completed';
          }
        } else {
          if (iceGatherer.state === 'new') {
            iceGatherer.state = 'gathering';
          }
          // RTCIceCandidate doesn't have a component, needs to be added
          cand.component = 1;
          // also the usernameFragment. TODO: update SDP to take both variants.
          cand.ufrag = iceGatherer.getLocalParameters().usernameFragment;

          var serializedCandidate = sdp.writeCandidate(cand);
          event.candidate = Object.assign(event.candidate,
              sdp.parseCandidate(serializedCandidate));

          event.candidate.candidate = serializedCandidate;
          event.candidate.toJSON = function() {
            return {
              candidate: event.candidate.candidate,
              sdpMid: event.candidate.sdpMid,
              sdpMLineIndex: event.candidate.sdpMLineIndex,
              usernameFragment: event.candidate.usernameFragment
            };
          };
        }

        // update local description.
        var sections = sdp.getMediaSections(pc._localDescription.sdp);
        if (!end) {
          sections[event.candidate.sdpMLineIndex] +=
              'a=' + event.candidate.candidate + '\r\n';
        } else {
          sections[event.candidate.sdpMLineIndex] +=
              'a=end-of-candidates\r\n';
        }
        pc._localDescription.sdp =
            sdp.getDescription(pc._localDescription.sdp) +
            sections.join('');
        var complete = pc.transceivers.every(function(transceiver) {
          return transceiver.iceGatherer &&
              transceiver.iceGatherer.state === 'completed';
        });

        if (pc.iceGatheringState !== 'gathering') {
          pc.iceGatheringState = 'gathering';
          pc._emitGatheringStateChange();
        }

        // Emit candidate. Also emit null candidate when all gatherers are
        // complete.
        if (!end) {
          pc._dispatchEvent('icecandidate', event);
        }
        if (complete) {
          pc._dispatchEvent('icecandidate', new Event('icecandidate'));
          pc.iceGatheringState = 'complete';
          pc._emitGatheringStateChange();
        }
      };

      // emit already gathered candidates.
      window.setTimeout(function() {
        bufferedCandidateEvents.forEach(function(e) {
          iceGatherer.onlocalcandidate(e);
        });
      }, 0);
    };

    // Create ICE transport and DTLS transport.
    RTCPeerConnection.prototype._createIceAndDtlsTransports = function() {
      var pc = this;
      var iceTransport = new window.RTCIceTransport(null);
      iceTransport.onicestatechange = function() {
        pc._updateIceConnectionState();
        pc._updateConnectionState();
      };

      var dtlsTransport = new window.RTCDtlsTransport(iceTransport);
      dtlsTransport.ondtlsstatechange = function() {
        pc._updateConnectionState();
      };
      dtlsTransport.onerror = function() {
        // onerror does not set state to failed by itself.
        Object.defineProperty(dtlsTransport, 'state',
            {value: 'failed', writable: true});
        pc._updateConnectionState();
      };

      return {
        iceTransport: iceTransport,
        dtlsTransport: dtlsTransport
      };
    };

    // Destroy ICE gatherer, ICE transport and DTLS transport.
    // Without triggering the callbacks.
    RTCPeerConnection.prototype._disposeIceAndDtlsTransports = function(
        sdpMLineIndex) {
      var iceGatherer = this.transceivers[sdpMLineIndex].iceGatherer;
      if (iceGatherer) {
        delete iceGatherer.onlocalcandidate;
        delete this.transceivers[sdpMLineIndex].iceGatherer;
      }
      var iceTransport = this.transceivers[sdpMLineIndex].iceTransport;
      if (iceTransport) {
        delete iceTransport.onicestatechange;
        delete this.transceivers[sdpMLineIndex].iceTransport;
      }
      var dtlsTransport = this.transceivers[sdpMLineIndex].dtlsTransport;
      if (dtlsTransport) {
        delete dtlsTransport.ondtlsstatechange;
        delete dtlsTransport.onerror;
        delete this.transceivers[sdpMLineIndex].dtlsTransport;
      }
    };

    // Start the RTP Sender and Receiver for a transceiver.
    RTCPeerConnection.prototype._transceive = function(transceiver,
        send, recv) {
      var params = getCommonCapabilities(transceiver.localCapabilities,
          transceiver.remoteCapabilities);
      if (send && transceiver.rtpSender) {
        params.encodings = transceiver.sendEncodingParameters;
        params.rtcp = {
          cname: sdp.localCName,
          compound: transceiver.rtcpParameters.compound
        };
        if (transceiver.recvEncodingParameters.length) {
          params.rtcp.ssrc = transceiver.recvEncodingParameters[0].ssrc;
        }
        transceiver.rtpSender.send(params);
      }
      if (recv && transceiver.rtpReceiver && params.codecs.length > 0) {
        // remove RTX field in Edge 14942
        if (transceiver.kind === 'video'
            && transceiver.recvEncodingParameters
            && edgeVersion < 15019) {
          transceiver.recvEncodingParameters.forEach(function(p) {
            delete p.rtx;
          });
        }
        if (transceiver.recvEncodingParameters.length) {
          params.encodings = transceiver.recvEncodingParameters;
        } else {
          params.encodings = [{}];
        }
        params.rtcp = {
          compound: transceiver.rtcpParameters.compound
        };
        if (transceiver.rtcpParameters.cname) {
          params.rtcp.cname = transceiver.rtcpParameters.cname;
        }
        if (transceiver.sendEncodingParameters.length) {
          params.rtcp.ssrc = transceiver.sendEncodingParameters[0].ssrc;
        }
        transceiver.rtpReceiver.receive(params);
      }
    };

    RTCPeerConnection.prototype.setLocalDescription = function(description) {
      var pc = this;

      // Note: pranswer is not supported.
      if (['offer', 'answer'].indexOf(description.type) === -1) {
        return Promise.reject(makeError('TypeError',
            'Unsupported type "' + description.type + '"'));
      }

      if (!isActionAllowedInSignalingState('setLocalDescription',
          description.type, pc.signalingState) || pc._isClosed) {
        return Promise.reject(makeError('InvalidStateError',
            'Can not set local ' + description.type +
            ' in state ' + pc.signalingState));
      }

      var sections;
      var sessionpart;
      if (description.type === 'offer') {
        // VERY limited support for SDP munging. Limited to:
        // * changing the order of codecs
        sections = sdp.splitSections(description.sdp);
        sessionpart = sections.shift();
        sections.forEach(function(mediaSection, sdpMLineIndex) {
          var caps = sdp.parseRtpParameters(mediaSection);
          pc.transceivers[sdpMLineIndex].localCapabilities = caps;
        });

        pc.transceivers.forEach(function(transceiver, sdpMLineIndex) {
          pc._gather(transceiver.mid, sdpMLineIndex);
        });
      } else if (description.type === 'answer') {
        sections = sdp.splitSections(pc._remoteDescription.sdp);
        sessionpart = sections.shift();
        var isIceLite = sdp.matchPrefix(sessionpart,
            'a=ice-lite').length > 0;
        sections.forEach(function(mediaSection, sdpMLineIndex) {
          var transceiver = pc.transceivers[sdpMLineIndex];
          var iceGatherer = transceiver.iceGatherer;
          var iceTransport = transceiver.iceTransport;
          var dtlsTransport = transceiver.dtlsTransport;
          var localCapabilities = transceiver.localCapabilities;
          var remoteCapabilities = transceiver.remoteCapabilities;

          // treat bundle-only as not-rejected.
          var rejected = sdp.isRejected(mediaSection) &&
              sdp.matchPrefix(mediaSection, 'a=bundle-only').length === 0;

          if (!rejected && !transceiver.rejected) {
            var remoteIceParameters = sdp.getIceParameters(
                mediaSection, sessionpart);
            var remoteDtlsParameters = sdp.getDtlsParameters(
                mediaSection, sessionpart);
            if (isIceLite) {
              remoteDtlsParameters.role = 'server';
            }

            if (!pc.usingBundle || sdpMLineIndex === 0) {
              pc._gather(transceiver.mid, sdpMLineIndex);
              if (iceTransport.state === 'new') {
                iceTransport.start(iceGatherer, remoteIceParameters,
                    isIceLite ? 'controlling' : 'controlled');
              }
              if (dtlsTransport.state === 'new') {
                dtlsTransport.start(remoteDtlsParameters);
              }
            }

            // Calculate intersection of capabilities.
            var params = getCommonCapabilities(localCapabilities,
                remoteCapabilities);

            // Start the RTCRtpSender. The RTCRtpReceiver for this
            // transceiver has already been started in setRemoteDescription.
            pc._transceive(transceiver,
                params.codecs.length > 0,
                false);
          }
        });
      }

      pc._localDescription = {
        type: description.type,
        sdp: description.sdp
      };
      if (description.type === 'offer') {
        pc._updateSignalingState('have-local-offer');
      } else {
        pc._updateSignalingState('stable');
      }

      return Promise.resolve();
    };

    RTCPeerConnection.prototype.setRemoteDescription = function(description) {
      var pc = this;

      // Note: pranswer is not supported.
      if (['offer', 'answer'].indexOf(description.type) === -1) {
        return Promise.reject(makeError('TypeError',
            'Unsupported type "' + description.type + '"'));
      }

      if (!isActionAllowedInSignalingState('setRemoteDescription',
          description.type, pc.signalingState) || pc._isClosed) {
        return Promise.reject(makeError('InvalidStateError',
            'Can not set remote ' + description.type +
            ' in state ' + pc.signalingState));
      }

      var streams = {};
      pc.remoteStreams.forEach(function(stream) {
        streams[stream.id] = stream;
      });
      var receiverList = [];
      var sections = sdp.splitSections(description.sdp);
      var sessionpart = sections.shift();
      var isIceLite = sdp.matchPrefix(sessionpart,
          'a=ice-lite').length > 0;
      var usingBundle = sdp.matchPrefix(sessionpart,
          'a=group:BUNDLE ').length > 0;
      pc.usingBundle = usingBundle;
      var iceOptions = sdp.matchPrefix(sessionpart,
          'a=ice-options:')[0];
      if (iceOptions) {
        pc.canTrickleIceCandidates = iceOptions.substr(14).split(' ')
            .indexOf('trickle') >= 0;
      } else {
        pc.canTrickleIceCandidates = false;
      }

      sections.forEach(function(mediaSection, sdpMLineIndex) {
        var lines = sdp.splitLines(mediaSection);
        var kind = sdp.getKind(mediaSection);
        // treat bundle-only as not-rejected.
        var rejected = sdp.isRejected(mediaSection) &&
            sdp.matchPrefix(mediaSection, 'a=bundle-only').length === 0;
        var protocol = lines[0].substr(2).split(' ')[2];

        var direction = sdp.getDirection(mediaSection, sessionpart);
        var remoteMsid = sdp.parseMsid(mediaSection);

        var mid = sdp.getMid(mediaSection) || sdp.generateIdentifier();

        // Reject datachannels which are not implemented yet.
        if (rejected || (kind === 'application' && (protocol === 'DTLS/SCTP' ||
            protocol === 'UDP/DTLS/SCTP'))) {
          // TODO: this is dangerous in the case where a non-rejected m-line
          //     becomes rejected.
          pc.transceivers[sdpMLineIndex] = {
            mid: mid,
            kind: kind,
            protocol: protocol,
            rejected: true
          };
          return;
        }

        if (!rejected && pc.transceivers[sdpMLineIndex] &&
            pc.transceivers[sdpMLineIndex].rejected) {
          // recycle a rejected transceiver.
          pc.transceivers[sdpMLineIndex] = pc._createTransceiver(kind, true);
        }

        var transceiver;
        var iceGatherer;
        var iceTransport;
        var dtlsTransport;
        var rtpReceiver;
        var sendEncodingParameters;
        var recvEncodingParameters;
        var localCapabilities;

        var track;
        // FIXME: ensure the mediaSection has rtcp-mux set.
        var remoteCapabilities = sdp.parseRtpParameters(mediaSection);
        var remoteIceParameters;
        var remoteDtlsParameters;
        if (!rejected) {
          remoteIceParameters = sdp.getIceParameters(mediaSection,
              sessionpart);
          remoteDtlsParameters = sdp.getDtlsParameters(mediaSection,
              sessionpart);
          remoteDtlsParameters.role = 'client';
        }
        recvEncodingParameters =
            sdp.parseRtpEncodingParameters(mediaSection);

        var rtcpParameters = sdp.parseRtcpParameters(mediaSection);

        var isComplete = sdp.matchPrefix(mediaSection,
            'a=end-of-candidates', sessionpart).length > 0;
        var cands = sdp.matchPrefix(mediaSection, 'a=candidate:')
            .map(function(cand) {
              return sdp.parseCandidate(cand);
            })
            .filter(function(cand) {
              return cand.component === 1;
            });

        // Check if we can use BUNDLE and dispose transports.
        if ((description.type === 'offer' || description.type === 'answer') &&
            !rejected && usingBundle && sdpMLineIndex > 0 &&
            pc.transceivers[sdpMLineIndex]) {
          pc._disposeIceAndDtlsTransports(sdpMLineIndex);
          pc.transceivers[sdpMLineIndex].iceGatherer =
              pc.transceivers[0].iceGatherer;
          pc.transceivers[sdpMLineIndex].iceTransport =
              pc.transceivers[0].iceTransport;
          pc.transceivers[sdpMLineIndex].dtlsTransport =
              pc.transceivers[0].dtlsTransport;
          if (pc.transceivers[sdpMLineIndex].rtpSender) {
            pc.transceivers[sdpMLineIndex].rtpSender.setTransport(
                pc.transceivers[0].dtlsTransport);
          }
          if (pc.transceivers[sdpMLineIndex].rtpReceiver) {
            pc.transceivers[sdpMLineIndex].rtpReceiver.setTransport(
                pc.transceivers[0].dtlsTransport);
          }
        }
        if (description.type === 'offer' && !rejected) {
          transceiver = pc.transceivers[sdpMLineIndex] ||
              pc._createTransceiver(kind);
          transceiver.mid = mid;

          if (!transceiver.iceGatherer) {
            transceiver.iceGatherer = pc._createIceGatherer(sdpMLineIndex,
                usingBundle);
          }

          if (cands.length && transceiver.iceTransport.state === 'new') {
            if (isComplete && (!usingBundle || sdpMLineIndex === 0)) {
              transceiver.iceTransport.setRemoteCandidates(cands);
            } else {
              cands.forEach(function(candidate) {
                maybeAddCandidate(transceiver.iceTransport, candidate);
              });
            }
          }

          localCapabilities = window.RTCRtpReceiver.getCapabilities(kind);

          // filter RTX until additional stuff needed for RTX is implemented
          // in adapter.js
          if (edgeVersion < 15019) {
            localCapabilities.codecs = localCapabilities.codecs.filter(
                function(codec) {
                  return codec.name !== 'rtx';
                });
          }

          sendEncodingParameters = transceiver.sendEncodingParameters || [{
            ssrc: (2 * sdpMLineIndex + 2) * 1001
          }];

          // TODO: rewrite to use http://w3c.github.io/webrtc-pc/#set-associated-remote-streams
          var isNewTrack = false;
          if (direction === 'sendrecv' || direction === 'sendonly') {
            isNewTrack = !transceiver.rtpReceiver;
            rtpReceiver = transceiver.rtpReceiver ||
                new window.RTCRtpReceiver(transceiver.dtlsTransport, kind);

            if (isNewTrack) {
              var stream;
              track = rtpReceiver.track;
              // FIXME: does not work with Plan B.
              if (remoteMsid && remoteMsid.stream === '-') ; else if (remoteMsid) {
                if (!streams[remoteMsid.stream]) {
                  streams[remoteMsid.stream] = new window.MediaStream();
                  Object.defineProperty(streams[remoteMsid.stream], 'id', {
                    get: function() {
                      return remoteMsid.stream;
                    }
                  });
                }
                Object.defineProperty(track, 'id', {
                  get: function() {
                    return remoteMsid.track;
                  }
                });
                stream = streams[remoteMsid.stream];
              } else {
                if (!streams.default) {
                  streams.default = new window.MediaStream();
                }
                stream = streams.default;
              }
              if (stream) {
                addTrackToStreamAndFireEvent(track, stream);
                transceiver.associatedRemoteMediaStreams.push(stream);
              }
              receiverList.push([track, rtpReceiver, stream]);
            }
          } else if (transceiver.rtpReceiver && transceiver.rtpReceiver.track) {
            transceiver.associatedRemoteMediaStreams.forEach(function(s) {
              var nativeTrack = s.getTracks().find(function(t) {
                return t.id === transceiver.rtpReceiver.track.id;
              });
              if (nativeTrack) {
                removeTrackFromStreamAndFireEvent(nativeTrack, s);
              }
            });
            transceiver.associatedRemoteMediaStreams = [];
          }

          transceiver.localCapabilities = localCapabilities;
          transceiver.remoteCapabilities = remoteCapabilities;
          transceiver.rtpReceiver = rtpReceiver;
          transceiver.rtcpParameters = rtcpParameters;
          transceiver.sendEncodingParameters = sendEncodingParameters;
          transceiver.recvEncodingParameters = recvEncodingParameters;

          // Start the RTCRtpReceiver now. The RTPSender is started in
          // setLocalDescription.
          pc._transceive(pc.transceivers[sdpMLineIndex],
              false,
              isNewTrack);
        } else if (description.type === 'answer' && !rejected) {
          transceiver = pc.transceivers[sdpMLineIndex];
          iceGatherer = transceiver.iceGatherer;
          iceTransport = transceiver.iceTransport;
          dtlsTransport = transceiver.dtlsTransport;
          rtpReceiver = transceiver.rtpReceiver;
          sendEncodingParameters = transceiver.sendEncodingParameters;
          localCapabilities = transceiver.localCapabilities;

          pc.transceivers[sdpMLineIndex].recvEncodingParameters =
              recvEncodingParameters;
          pc.transceivers[sdpMLineIndex].remoteCapabilities =
              remoteCapabilities;
          pc.transceivers[sdpMLineIndex].rtcpParameters = rtcpParameters;

          if (cands.length && iceTransport.state === 'new') {
            if ((isIceLite || isComplete) &&
                (!usingBundle || sdpMLineIndex === 0)) {
              iceTransport.setRemoteCandidates(cands);
            } else {
              cands.forEach(function(candidate) {
                maybeAddCandidate(transceiver.iceTransport, candidate);
              });
            }
          }

          if (!usingBundle || sdpMLineIndex === 0) {
            if (iceTransport.state === 'new') {
              iceTransport.start(iceGatherer, remoteIceParameters,
                  'controlling');
            }
            if (dtlsTransport.state === 'new') {
              dtlsTransport.start(remoteDtlsParameters);
            }
          }

          // If the offer contained RTX but the answer did not,
          // remove RTX from sendEncodingParameters.
          var commonCapabilities = getCommonCapabilities(
            transceiver.localCapabilities,
            transceiver.remoteCapabilities);

          var hasRtx = commonCapabilities.codecs.filter(function(c) {
            return c.name.toLowerCase() === 'rtx';
          }).length;
          if (!hasRtx && transceiver.sendEncodingParameters[0].rtx) {
            delete transceiver.sendEncodingParameters[0].rtx;
          }

          pc._transceive(transceiver,
              direction === 'sendrecv' || direction === 'recvonly',
              direction === 'sendrecv' || direction === 'sendonly');

          // TODO: rewrite to use http://w3c.github.io/webrtc-pc/#set-associated-remote-streams
          if (rtpReceiver &&
              (direction === 'sendrecv' || direction === 'sendonly')) {
            track = rtpReceiver.track;
            if (remoteMsid) {
              if (!streams[remoteMsid.stream]) {
                streams[remoteMsid.stream] = new window.MediaStream();
              }
              addTrackToStreamAndFireEvent(track, streams[remoteMsid.stream]);
              receiverList.push([track, rtpReceiver, streams[remoteMsid.stream]]);
            } else {
              if (!streams.default) {
                streams.default = new window.MediaStream();
              }
              addTrackToStreamAndFireEvent(track, streams.default);
              receiverList.push([track, rtpReceiver, streams.default]);
            }
          } else {
            // FIXME: actually the receiver should be created later.
            delete transceiver.rtpReceiver;
          }
        }
      });

      if (pc._dtlsRole === undefined) {
        pc._dtlsRole = description.type === 'offer' ? 'active' : 'passive';
      }

      pc._remoteDescription = {
        type: description.type,
        sdp: description.sdp
      };
      if (description.type === 'offer') {
        pc._updateSignalingState('have-remote-offer');
      } else {
        pc._updateSignalingState('stable');
      }
      Object.keys(streams).forEach(function(sid) {
        var stream = streams[sid];
        if (stream.getTracks().length) {
          if (pc.remoteStreams.indexOf(stream) === -1) {
            pc.remoteStreams.push(stream);
            var event = new Event('addstream');
            event.stream = stream;
            window.setTimeout(function() {
              pc._dispatchEvent('addstream', event);
            });
          }

          receiverList.forEach(function(item) {
            var track = item[0];
            var receiver = item[1];
            if (stream.id !== item[2].id) {
              return;
            }
            fireAddTrack(pc, track, receiver, [stream]);
          });
        }
      });
      receiverList.forEach(function(item) {
        if (item[2]) {
          return;
        }
        fireAddTrack(pc, item[0], item[1], []);
      });

      // check whether addIceCandidate({}) was called within four seconds after
      // setRemoteDescription.
      window.setTimeout(function() {
        if (!(pc && pc.transceivers)) {
          return;
        }
        pc.transceivers.forEach(function(transceiver) {
          if (transceiver.iceTransport &&
              transceiver.iceTransport.state === 'new' &&
              transceiver.iceTransport.getRemoteCandidates().length > 0) {
            console.warn('Timeout for addRemoteCandidate. Consider sending ' +
                'an end-of-candidates notification');
            transceiver.iceTransport.addRemoteCandidate({});
          }
        });
      }, 4000);

      return Promise.resolve();
    };

    RTCPeerConnection.prototype.close = function() {
      this.transceivers.forEach(function(transceiver) {
        /* not yet
        if (transceiver.iceGatherer) {
          transceiver.iceGatherer.close();
        }
        */
        if (transceiver.iceTransport) {
          transceiver.iceTransport.stop();
        }
        if (transceiver.dtlsTransport) {
          transceiver.dtlsTransport.stop();
        }
        if (transceiver.rtpSender) {
          transceiver.rtpSender.stop();
        }
        if (transceiver.rtpReceiver) {
          transceiver.rtpReceiver.stop();
        }
      });
      // FIXME: clean up tracks, local streams, remote streams, etc
      this._isClosed = true;
      this._updateSignalingState('closed');
    };

    // Update the signaling state.
    RTCPeerConnection.prototype._updateSignalingState = function(newState) {
      this.signalingState = newState;
      var event = new Event('signalingstatechange');
      this._dispatchEvent('signalingstatechange', event);
    };

    // Determine whether to fire the negotiationneeded event.
    RTCPeerConnection.prototype._maybeFireNegotiationNeeded = function() {
      var pc = this;
      if (this.signalingState !== 'stable' || this.needNegotiation === true) {
        return;
      }
      this.needNegotiation = true;
      window.setTimeout(function() {
        if (pc.needNegotiation) {
          pc.needNegotiation = false;
          var event = new Event('negotiationneeded');
          pc._dispatchEvent('negotiationneeded', event);
        }
      }, 0);
    };

    // Update the ice connection state.
    RTCPeerConnection.prototype._updateIceConnectionState = function() {
      var newState;
      var states = {
        'new': 0,
        closed: 0,
        checking: 0,
        connected: 0,
        completed: 0,
        disconnected: 0,
        failed: 0
      };
      this.transceivers.forEach(function(transceiver) {
        if (transceiver.iceTransport && !transceiver.rejected) {
          states[transceiver.iceTransport.state]++;
        }
      });

      newState = 'new';
      if (states.failed > 0) {
        newState = 'failed';
      } else if (states.checking > 0) {
        newState = 'checking';
      } else if (states.disconnected > 0) {
        newState = 'disconnected';
      } else if (states.new > 0) {
        newState = 'new';
      } else if (states.connected > 0) {
        newState = 'connected';
      } else if (states.completed > 0) {
        newState = 'completed';
      }

      if (newState !== this.iceConnectionState) {
        this.iceConnectionState = newState;
        var event = new Event('iceconnectionstatechange');
        this._dispatchEvent('iceconnectionstatechange', event);
      }
    };

    // Update the connection state.
    RTCPeerConnection.prototype._updateConnectionState = function() {
      var newState;
      var states = {
        'new': 0,
        closed: 0,
        connecting: 0,
        connected: 0,
        completed: 0,
        disconnected: 0,
        failed: 0
      };
      this.transceivers.forEach(function(transceiver) {
        if (transceiver.iceTransport && transceiver.dtlsTransport &&
            !transceiver.rejected) {
          states[transceiver.iceTransport.state]++;
          states[transceiver.dtlsTransport.state]++;
        }
      });
      // ICETransport.completed and connected are the same for this purpose.
      states.connected += states.completed;

      newState = 'new';
      if (states.failed > 0) {
        newState = 'failed';
      } else if (states.connecting > 0) {
        newState = 'connecting';
      } else if (states.disconnected > 0) {
        newState = 'disconnected';
      } else if (states.new > 0) {
        newState = 'new';
      } else if (states.connected > 0) {
        newState = 'connected';
      }

      if (newState !== this.connectionState) {
        this.connectionState = newState;
        var event = new Event('connectionstatechange');
        this._dispatchEvent('connectionstatechange', event);
      }
    };

    RTCPeerConnection.prototype.createOffer = function() {
      var pc = this;

      if (pc._isClosed) {
        return Promise.reject(makeError('InvalidStateError',
            'Can not call createOffer after close'));
      }

      var numAudioTracks = pc.transceivers.filter(function(t) {
        return t.kind === 'audio';
      }).length;
      var numVideoTracks = pc.transceivers.filter(function(t) {
        return t.kind === 'video';
      }).length;

      // Determine number of audio and video tracks we need to send/recv.
      var offerOptions = arguments[0];
      if (offerOptions) {
        // Reject Chrome legacy constraints.
        if (offerOptions.mandatory || offerOptions.optional) {
          throw new TypeError(
              'Legacy mandatory/optional constraints not supported.');
        }
        if (offerOptions.offerToReceiveAudio !== undefined) {
          if (offerOptions.offerToReceiveAudio === true) {
            numAudioTracks = 1;
          } else if (offerOptions.offerToReceiveAudio === false) {
            numAudioTracks = 0;
          } else {
            numAudioTracks = offerOptions.offerToReceiveAudio;
          }
        }
        if (offerOptions.offerToReceiveVideo !== undefined) {
          if (offerOptions.offerToReceiveVideo === true) {
            numVideoTracks = 1;
          } else if (offerOptions.offerToReceiveVideo === false) {
            numVideoTracks = 0;
          } else {
            numVideoTracks = offerOptions.offerToReceiveVideo;
          }
        }
      }

      pc.transceivers.forEach(function(transceiver) {
        if (transceiver.kind === 'audio') {
          numAudioTracks--;
          if (numAudioTracks < 0) {
            transceiver.wantReceive = false;
          }
        } else if (transceiver.kind === 'video') {
          numVideoTracks--;
          if (numVideoTracks < 0) {
            transceiver.wantReceive = false;
          }
        }
      });

      // Create M-lines for recvonly streams.
      while (numAudioTracks > 0 || numVideoTracks > 0) {
        if (numAudioTracks > 0) {
          pc._createTransceiver('audio');
          numAudioTracks--;
        }
        if (numVideoTracks > 0) {
          pc._createTransceiver('video');
          numVideoTracks--;
        }
      }

      var sdp$1 = sdp.writeSessionBoilerplate(pc._sdpSessionId,
          pc._sdpSessionVersion++);
      pc.transceivers.forEach(function(transceiver, sdpMLineIndex) {
        // For each track, create an ice gatherer, ice transport,
        // dtls transport, potentially rtpsender and rtpreceiver.
        var track = transceiver.track;
        var kind = transceiver.kind;
        var mid = transceiver.mid || sdp.generateIdentifier();
        transceiver.mid = mid;

        if (!transceiver.iceGatherer) {
          transceiver.iceGatherer = pc._createIceGatherer(sdpMLineIndex,
              pc.usingBundle);
        }

        var localCapabilities = window.RTCRtpSender.getCapabilities(kind);
        // filter RTX until additional stuff needed for RTX is implemented
        // in adapter.js
        if (edgeVersion < 15019) {
          localCapabilities.codecs = localCapabilities.codecs.filter(
              function(codec) {
                return codec.name !== 'rtx';
              });
        }
        localCapabilities.codecs.forEach(function(codec) {
          // work around https://bugs.chromium.org/p/webrtc/issues/detail?id=6552
          // by adding level-asymmetry-allowed=1
          if (codec.name === 'H264' &&
              codec.parameters['level-asymmetry-allowed'] === undefined) {
            codec.parameters['level-asymmetry-allowed'] = '1';
          }

          // for subsequent offers, we might have to re-use the payload
          // type of the last offer.
          if (transceiver.remoteCapabilities &&
              transceiver.remoteCapabilities.codecs) {
            transceiver.remoteCapabilities.codecs.forEach(function(remoteCodec) {
              if (codec.name.toLowerCase() === remoteCodec.name.toLowerCase() &&
                  codec.clockRate === remoteCodec.clockRate) {
                codec.preferredPayloadType = remoteCodec.payloadType;
              }
            });
          }
        });
        localCapabilities.headerExtensions.forEach(function(hdrExt) {
          var remoteExtensions = transceiver.remoteCapabilities &&
              transceiver.remoteCapabilities.headerExtensions || [];
          remoteExtensions.forEach(function(rHdrExt) {
            if (hdrExt.uri === rHdrExt.uri) {
              hdrExt.id = rHdrExt.id;
            }
          });
        });

        // generate an ssrc now, to be used later in rtpSender.send
        var sendEncodingParameters = transceiver.sendEncodingParameters || [{
          ssrc: (2 * sdpMLineIndex + 1) * 1001
        }];
        if (track) {
          // add RTX
          if (edgeVersion >= 15019 && kind === 'video' &&
              !sendEncodingParameters[0].rtx) {
            sendEncodingParameters[0].rtx = {
              ssrc: sendEncodingParameters[0].ssrc + 1
            };
          }
        }

        if (transceiver.wantReceive) {
          transceiver.rtpReceiver = new window.RTCRtpReceiver(
              transceiver.dtlsTransport, kind);
        }

        transceiver.localCapabilities = localCapabilities;
        transceiver.sendEncodingParameters = sendEncodingParameters;
      });

      // always offer BUNDLE and dispose on return if not supported.
      if (pc._config.bundlePolicy !== 'max-compat') {
        sdp$1 += 'a=group:BUNDLE ' + pc.transceivers.map(function(t) {
          return t.mid;
        }).join(' ') + '\r\n';
      }
      sdp$1 += 'a=ice-options:trickle\r\n';

      pc.transceivers.forEach(function(transceiver, sdpMLineIndex) {
        sdp$1 += writeMediaSection(transceiver, transceiver.localCapabilities,
            'offer', transceiver.stream, pc._dtlsRole);
        sdp$1 += 'a=rtcp-rsize\r\n';

        if (transceiver.iceGatherer && pc.iceGatheringState !== 'new' &&
            (sdpMLineIndex === 0 || !pc.usingBundle)) {
          transceiver.iceGatherer.getLocalCandidates().forEach(function(cand) {
            cand.component = 1;
            sdp$1 += 'a=' + sdp.writeCandidate(cand) + '\r\n';
          });

          if (transceiver.iceGatherer.state === 'completed') {
            sdp$1 += 'a=end-of-candidates\r\n';
          }
        }
      });

      var desc = new window.RTCSessionDescription({
        type: 'offer',
        sdp: sdp$1
      });
      return Promise.resolve(desc);
    };

    RTCPeerConnection.prototype.createAnswer = function() {
      var pc = this;

      if (pc._isClosed) {
        return Promise.reject(makeError('InvalidStateError',
            'Can not call createAnswer after close'));
      }

      if (!(pc.signalingState === 'have-remote-offer' ||
          pc.signalingState === 'have-local-pranswer')) {
        return Promise.reject(makeError('InvalidStateError',
            'Can not call createAnswer in signalingState ' + pc.signalingState));
      }

      var sdp$1 = sdp.writeSessionBoilerplate(pc._sdpSessionId,
          pc._sdpSessionVersion++);
      if (pc.usingBundle) {
        sdp$1 += 'a=group:BUNDLE ' + pc.transceivers.map(function(t) {
          return t.mid;
        }).join(' ') + '\r\n';
      }
      sdp$1 += 'a=ice-options:trickle\r\n';

      var mediaSectionsInOffer = sdp.getMediaSections(
          pc._remoteDescription.sdp).length;
      pc.transceivers.forEach(function(transceiver, sdpMLineIndex) {
        if (sdpMLineIndex + 1 > mediaSectionsInOffer) {
          return;
        }
        if (transceiver.rejected) {
          if (transceiver.kind === 'application') {
            if (transceiver.protocol === 'DTLS/SCTP') { // legacy fmt
              sdp$1 += 'm=application 0 DTLS/SCTP 5000\r\n';
            } else {
              sdp$1 += 'm=application 0 ' + transceiver.protocol +
                  ' webrtc-datachannel\r\n';
            }
          } else if (transceiver.kind === 'audio') {
            sdp$1 += 'm=audio 0 UDP/TLS/RTP/SAVPF 0\r\n' +
                'a=rtpmap:0 PCMU/8000\r\n';
          } else if (transceiver.kind === 'video') {
            sdp$1 += 'm=video 0 UDP/TLS/RTP/SAVPF 120\r\n' +
                'a=rtpmap:120 VP8/90000\r\n';
          }
          sdp$1 += 'c=IN IP4 0.0.0.0\r\n' +
              'a=inactive\r\n' +
              'a=mid:' + transceiver.mid + '\r\n';
          return;
        }

        // FIXME: look at direction.
        if (transceiver.stream) {
          var localTrack;
          if (transceiver.kind === 'audio') {
            localTrack = transceiver.stream.getAudioTracks()[0];
          } else if (transceiver.kind === 'video') {
            localTrack = transceiver.stream.getVideoTracks()[0];
          }
          if (localTrack) {
            // add RTX
            if (edgeVersion >= 15019 && transceiver.kind === 'video' &&
                !transceiver.sendEncodingParameters[0].rtx) {
              transceiver.sendEncodingParameters[0].rtx = {
                ssrc: transceiver.sendEncodingParameters[0].ssrc + 1
              };
            }
          }
        }

        // Calculate intersection of capabilities.
        var commonCapabilities = getCommonCapabilities(
            transceiver.localCapabilities,
            transceiver.remoteCapabilities);

        var hasRtx = commonCapabilities.codecs.filter(function(c) {
          return c.name.toLowerCase() === 'rtx';
        }).length;
        if (!hasRtx && transceiver.sendEncodingParameters[0].rtx) {
          delete transceiver.sendEncodingParameters[0].rtx;
        }

        sdp$1 += writeMediaSection(transceiver, commonCapabilities,
            'answer', transceiver.stream, pc._dtlsRole);
        if (transceiver.rtcpParameters &&
            transceiver.rtcpParameters.reducedSize) {
          sdp$1 += 'a=rtcp-rsize\r\n';
        }
      });

      var desc = new window.RTCSessionDescription({
        type: 'answer',
        sdp: sdp$1
      });
      return Promise.resolve(desc);
    };

    RTCPeerConnection.prototype.addIceCandidate = function(candidate) {
      var pc = this;
      var sections;
      if (candidate && !(candidate.sdpMLineIndex !== undefined ||
          candidate.sdpMid)) {
        return Promise.reject(new TypeError('sdpMLineIndex or sdpMid required'));
      }

      // TODO: needs to go into ops queue.
      return new Promise(function(resolve, reject) {
        if (!pc._remoteDescription) {
          return reject(makeError('InvalidStateError',
              'Can not add ICE candidate without a remote description'));
        } else if (!candidate || candidate.candidate === '') {
          for (var j = 0; j < pc.transceivers.length; j++) {
            if (pc.transceivers[j].rejected) {
              continue;
            }
            pc.transceivers[j].iceTransport.addRemoteCandidate({});
            sections = sdp.getMediaSections(pc._remoteDescription.sdp);
            sections[j] += 'a=end-of-candidates\r\n';
            pc._remoteDescription.sdp =
                sdp.getDescription(pc._remoteDescription.sdp) +
                sections.join('');
            if (pc.usingBundle) {
              break;
            }
          }
        } else {
          var sdpMLineIndex = candidate.sdpMLineIndex;
          if (candidate.sdpMid) {
            for (var i = 0; i < pc.transceivers.length; i++) {
              if (pc.transceivers[i].mid === candidate.sdpMid) {
                sdpMLineIndex = i;
                break;
              }
            }
          }
          var transceiver = pc.transceivers[sdpMLineIndex];
          if (transceiver) {
            if (transceiver.rejected) {
              return resolve();
            }
            var cand = Object.keys(candidate.candidate).length > 0 ?
                sdp.parseCandidate(candidate.candidate) : {};
            // Ignore Chrome's invalid candidates since Edge does not like them.
            if (cand.protocol === 'tcp' && (cand.port === 0 || cand.port === 9)) {
              return resolve();
            }
            // Ignore RTCP candidates, we assume RTCP-MUX.
            if (cand.component && cand.component !== 1) {
              return resolve();
            }
            // when using bundle, avoid adding candidates to the wrong
            // ice transport. And avoid adding candidates added in the SDP.
            if (sdpMLineIndex === 0 || (sdpMLineIndex > 0 &&
                transceiver.iceTransport !== pc.transceivers[0].iceTransport)) {
              if (!maybeAddCandidate(transceiver.iceTransport, cand)) {
                return reject(makeError('OperationError',
                    'Can not add ICE candidate'));
              }
            }

            // update the remoteDescription.
            var candidateString = candidate.candidate.trim();
            if (candidateString.indexOf('a=') === 0) {
              candidateString = candidateString.substr(2);
            }
            sections = sdp.getMediaSections(pc._remoteDescription.sdp);
            sections[sdpMLineIndex] += 'a=' +
                (cand.type ? candidateString : 'end-of-candidates')
                + '\r\n';
            pc._remoteDescription.sdp =
                sdp.getDescription(pc._remoteDescription.sdp) +
                sections.join('');
          } else {
            return reject(makeError('OperationError',
                'Can not add ICE candidate'));
          }
        }
        resolve();
      });
    };

    RTCPeerConnection.prototype.getStats = function(selector) {
      if (selector && selector instanceof window.MediaStreamTrack) {
        var senderOrReceiver = null;
        this.transceivers.forEach(function(transceiver) {
          if (transceiver.rtpSender &&
              transceiver.rtpSender.track === selector) {
            senderOrReceiver = transceiver.rtpSender;
          } else if (transceiver.rtpReceiver &&
              transceiver.rtpReceiver.track === selector) {
            senderOrReceiver = transceiver.rtpReceiver;
          }
        });
        if (!senderOrReceiver) {
          throw makeError('InvalidAccessError', 'Invalid selector.');
        }
        return senderOrReceiver.getStats();
      }

      var promises = [];
      this.transceivers.forEach(function(transceiver) {
        ['rtpSender', 'rtpReceiver', 'iceGatherer', 'iceTransport',
            'dtlsTransport'].forEach(function(method) {
              if (transceiver[method]) {
                promises.push(transceiver[method].getStats());
              }
            });
      });
      return Promise.all(promises).then(function(allStats) {
        var results = new Map();
        allStats.forEach(function(stats) {
          stats.forEach(function(stat) {
            results.set(stat.id, stat);
          });
        });
        return results;
      });
    };

    // fix low-level stat names and return Map instead of object.
    var ortcObjects = ['RTCRtpSender', 'RTCRtpReceiver', 'RTCIceGatherer',
      'RTCIceTransport', 'RTCDtlsTransport'];
    ortcObjects.forEach(function(ortcObjectName) {
      var obj = window[ortcObjectName];
      if (obj && obj.prototype && obj.prototype.getStats) {
        var nativeGetstats = obj.prototype.getStats;
        obj.prototype.getStats = function() {
          return nativeGetstats.apply(this)
          .then(function(nativeStats) {
            var mapStats = new Map();
            Object.keys(nativeStats).forEach(function(id) {
              nativeStats[id].type = fixStatsType(nativeStats[id]);
              mapStats.set(id, nativeStats[id]);
            });
            return mapStats;
          });
        };
      }
    });

    // legacy callback shims. Should be moved to adapter.js some days.
    var methods = ['createOffer', 'createAnswer'];
    methods.forEach(function(method) {
      var nativeMethod = RTCPeerConnection.prototype[method];
      RTCPeerConnection.prototype[method] = function() {
        var args = arguments;
        if (typeof args[0] === 'function' ||
            typeof args[1] === 'function') { // legacy
          return nativeMethod.apply(this, [arguments[2]])
          .then(function(description) {
            if (typeof args[0] === 'function') {
              args[0].apply(null, [description]);
            }
          }, function(error) {
            if (typeof args[1] === 'function') {
              args[1].apply(null, [error]);
            }
          });
        }
        return nativeMethod.apply(this, arguments);
      };
    });

    methods = ['setLocalDescription', 'setRemoteDescription', 'addIceCandidate'];
    methods.forEach(function(method) {
      var nativeMethod = RTCPeerConnection.prototype[method];
      RTCPeerConnection.prototype[method] = function() {
        var args = arguments;
        if (typeof args[1] === 'function' ||
            typeof args[2] === 'function') { // legacy
          return nativeMethod.apply(this, arguments)
          .then(function() {
            if (typeof args[1] === 'function') {
              args[1].apply(null);
            }
          }, function(error) {
            if (typeof args[2] === 'function') {
              args[2].apply(null, [error]);
            }
          });
        }
        return nativeMethod.apply(this, arguments);
      };
    });

    // getStats is special. It doesn't have a spec legacy method yet we support
    // getStats(something, cb) without error callbacks.
    ['getStats'].forEach(function(method) {
      var nativeMethod = RTCPeerConnection.prototype[method];
      RTCPeerConnection.prototype[method] = function() {
        var args = arguments;
        if (typeof args[1] === 'function') {
          return nativeMethod.apply(this, arguments)
          .then(function() {
            if (typeof args[1] === 'function') {
              args[1].apply(null);
            }
          });
        }
        return nativeMethod.apply(this, arguments);
      };
    });

    return RTCPeerConnection;
  };

  /*
   *  Copyright (c) 2016 The WebRTC project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */

  function shimGetUserMedia$1(window) {
    const navigator = window && window.navigator;

    const shimError_ = function(e) {
      return {
        name: {PermissionDeniedError: 'NotAllowedError'}[e.name] || e.name,
        message: e.message,
        constraint: e.constraint,
        toString() {
          return this.name;
        }
      };
    };

    // getUserMedia error shim.
    const origGetUserMedia = navigator.mediaDevices.getUserMedia.
        bind(navigator.mediaDevices);
    navigator.mediaDevices.getUserMedia = function(c) {
      return origGetUserMedia(c).catch(e => Promise.reject(shimError_(e)));
    };
  }

  /*
   *  Copyright (c) 2018 The adapter.js project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */

  function shimGetDisplayMedia$1(window) {
    if (!('getDisplayMedia' in window.navigator)) {
      return;
    }
    if (!(window.navigator.mediaDevices)) {
      return;
    }
    if (window.navigator.mediaDevices &&
      'getDisplayMedia' in window.navigator.mediaDevices) {
      return;
    }
    window.navigator.mediaDevices.getDisplayMedia =
      window.navigator.getDisplayMedia.bind(window.navigator);
  }

  /*
   *  Copyright (c) 2016 The WebRTC project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */

  function shimPeerConnection$1(window, browserDetails) {
    if (window.RTCIceGatherer) {
      if (!window.RTCIceCandidate) {
        window.RTCIceCandidate = function RTCIceCandidate(args) {
          return args;
        };
      }
      if (!window.RTCSessionDescription) {
        window.RTCSessionDescription = function RTCSessionDescription(args) {
          return args;
        };
      }
      // this adds an additional event listener to MediaStrackTrack that signals
      // when a tracks enabled property was changed. Workaround for a bug in
      // addStream, see below. No longer required in 15025+
      if (browserDetails.version < 15025) {
        const origMSTEnabled = Object.getOwnPropertyDescriptor(
            window.MediaStreamTrack.prototype, 'enabled');
        Object.defineProperty(window.MediaStreamTrack.prototype, 'enabled', {
          set(value) {
            origMSTEnabled.set.call(this, value);
            const ev = new Event('enabled');
            ev.enabled = value;
            this.dispatchEvent(ev);
          }
        });
      }
    }

    // ORTC defines the DTMF sender a bit different.
    // https://github.com/w3c/ortc/issues/714
    if (window.RTCRtpSender && !('dtmf' in window.RTCRtpSender.prototype)) {
      Object.defineProperty(window.RTCRtpSender.prototype, 'dtmf', {
        get() {
          if (this._dtmf === undefined) {
            if (this.track.kind === 'audio') {
              this._dtmf = new window.RTCDtmfSender(this);
            } else if (this.track.kind === 'video') {
              this._dtmf = null;
            }
          }
          return this._dtmf;
        }
      });
    }
    // Edge currently only implements the RTCDtmfSender, not the
    // RTCDTMFSender alias. See http://draft.ortc.org/#rtcdtmfsender2*
    if (window.RTCDtmfSender && !window.RTCDTMFSender) {
      window.RTCDTMFSender = window.RTCDtmfSender;
    }

    const RTCPeerConnectionShim = rtcpeerconnection(window,
        browserDetails.version);
    window.RTCPeerConnection = function RTCPeerConnection(config) {
      if (config && config.iceServers) {
        config.iceServers = filterIceServers(config.iceServers,
          browserDetails.version);
        log('ICE servers after filtering:', config.iceServers);
      }
      return new RTCPeerConnectionShim(config);
    };
    window.RTCPeerConnection.prototype = RTCPeerConnectionShim.prototype;
  }

  function shimReplaceTrack(window) {
    // ORTC has replaceTrack -- https://github.com/w3c/ortc/issues/614
    if (window.RTCRtpSender &&
        !('replaceTrack' in window.RTCRtpSender.prototype)) {
      window.RTCRtpSender.prototype.replaceTrack =
          window.RTCRtpSender.prototype.setTrack;
    }
  }

  var edgeShim = /*#__PURE__*/Object.freeze({
    __proto__: null,
    shimPeerConnection: shimPeerConnection$1,
    shimReplaceTrack: shimReplaceTrack,
    shimGetUserMedia: shimGetUserMedia$1,
    shimGetDisplayMedia: shimGetDisplayMedia$1
  });

  /*
   *  Copyright (c) 2016 The WebRTC project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */

  function shimGetUserMedia$2(window, browserDetails) {
    const navigator = window && window.navigator;
    const MediaStreamTrack = window && window.MediaStreamTrack;

    navigator.getUserMedia = function(constraints, onSuccess, onError) {
      // Replace Firefox 44+'s deprecation warning with unprefixed version.
      deprecated('navigator.getUserMedia',
          'navigator.mediaDevices.getUserMedia');
      navigator.mediaDevices.getUserMedia(constraints).then(onSuccess, onError);
    };

    if (!(browserDetails.version > 55 &&
        'autoGainControl' in navigator.mediaDevices.getSupportedConstraints())) {
      const remap = function(obj, a, b) {
        if (a in obj && !(b in obj)) {
          obj[b] = obj[a];
          delete obj[a];
        }
      };

      const nativeGetUserMedia = navigator.mediaDevices.getUserMedia.
          bind(navigator.mediaDevices);
      navigator.mediaDevices.getUserMedia = function(c) {
        if (typeof c === 'object' && typeof c.audio === 'object') {
          c = JSON.parse(JSON.stringify(c));
          remap(c.audio, 'autoGainControl', 'mozAutoGainControl');
          remap(c.audio, 'noiseSuppression', 'mozNoiseSuppression');
        }
        return nativeGetUserMedia(c);
      };

      if (MediaStreamTrack && MediaStreamTrack.prototype.getSettings) {
        const nativeGetSettings = MediaStreamTrack.prototype.getSettings;
        MediaStreamTrack.prototype.getSettings = function() {
          const obj = nativeGetSettings.apply(this, arguments);
          remap(obj, 'mozAutoGainControl', 'autoGainControl');
          remap(obj, 'mozNoiseSuppression', 'noiseSuppression');
          return obj;
        };
      }

      if (MediaStreamTrack && MediaStreamTrack.prototype.applyConstraints) {
        const nativeApplyConstraints =
          MediaStreamTrack.prototype.applyConstraints;
        MediaStreamTrack.prototype.applyConstraints = function(c) {
          if (this.kind === 'audio' && typeof c === 'object') {
            c = JSON.parse(JSON.stringify(c));
            remap(c, 'autoGainControl', 'mozAutoGainControl');
            remap(c, 'noiseSuppression', 'mozNoiseSuppression');
          }
          return nativeApplyConstraints.apply(this, [c]);
        };
      }
    }
  }

  /*
   *  Copyright (c) 2018 The adapter.js project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */

  function shimGetDisplayMedia$2(window, preferredMediaSource) {
    if (window.navigator.mediaDevices &&
      'getDisplayMedia' in window.navigator.mediaDevices) {
      return;
    }
    if (!(window.navigator.mediaDevices)) {
      return;
    }
    window.navigator.mediaDevices.getDisplayMedia =
      function getDisplayMedia(constraints) {
        if (!(constraints && constraints.video)) {
          const err = new DOMException('getDisplayMedia without video ' +
              'constraints is undefined');
          err.name = 'NotFoundError';
          // from https://heycam.github.io/webidl/#idl-DOMException-error-names
          err.code = 8;
          return Promise.reject(err);
        }
        if (constraints.video === true) {
          constraints.video = {mediaSource: preferredMediaSource};
        } else {
          constraints.video.mediaSource = preferredMediaSource;
        }
        return window.navigator.mediaDevices.getUserMedia(constraints);
      };
  }

  /*
   *  Copyright (c) 2016 The WebRTC project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */

  function shimOnTrack$1(window) {
    if (typeof window === 'object' && window.RTCTrackEvent &&
        ('receiver' in window.RTCTrackEvent.prototype) &&
        !('transceiver' in window.RTCTrackEvent.prototype)) {
      Object.defineProperty(window.RTCTrackEvent.prototype, 'transceiver', {
        get() {
          return {receiver: this.receiver};
        }
      });
    }
  }

  function shimPeerConnection$2(window, browserDetails) {
    if (typeof window !== 'object' ||
        !(window.RTCPeerConnection || window.mozRTCPeerConnection)) {
      return; // probably media.peerconnection.enabled=false in about:config
    }
    if (!window.RTCPeerConnection && window.mozRTCPeerConnection) {
      // very basic support for old versions.
      window.RTCPeerConnection = window.mozRTCPeerConnection;
    }

    if (browserDetails.version < 53) {
      // shim away need for obsolete RTCIceCandidate/RTCSessionDescription.
      ['setLocalDescription', 'setRemoteDescription', 'addIceCandidate']
          .forEach(function(method) {
            const nativeMethod = window.RTCPeerConnection.prototype[method];
            const methodObj = {[method]() {
              arguments[0] = new ((method === 'addIceCandidate') ?
                  window.RTCIceCandidate :
                  window.RTCSessionDescription)(arguments[0]);
              return nativeMethod.apply(this, arguments);
            }};
            window.RTCPeerConnection.prototype[method] = methodObj[method];
          });
    }

    const modernStatsTypes = {
      inboundrtp: 'inbound-rtp',
      outboundrtp: 'outbound-rtp',
      candidatepair: 'candidate-pair',
      localcandidate: 'local-candidate',
      remotecandidate: 'remote-candidate'
    };

    const nativeGetStats = window.RTCPeerConnection.prototype.getStats;
    window.RTCPeerConnection.prototype.getStats = function getStats() {
      const [selector, onSucc, onErr] = arguments;
      return nativeGetStats.apply(this, [selector || null])
        .then(stats => {
          if (browserDetails.version < 53 && !onSucc) {
            // Shim only promise getStats with spec-hyphens in type names
            // Leave callback version alone; misc old uses of forEach before Map
            try {
              stats.forEach(stat => {
                stat.type = modernStatsTypes[stat.type] || stat.type;
              });
            } catch (e) {
              if (e.name !== 'TypeError') {
                throw e;
              }
              // Avoid TypeError: "type" is read-only, in old versions. 34-43ish
              stats.forEach((stat, i) => {
                stats.set(i, Object.assign({}, stat, {
                  type: modernStatsTypes[stat.type] || stat.type
                }));
              });
            }
          }
          return stats;
        })
        .then(onSucc, onErr);
    };
  }

  function shimSenderGetStats(window) {
    if (!(typeof window === 'object' && window.RTCPeerConnection &&
        window.RTCRtpSender)) {
      return;
    }
    if (window.RTCRtpSender && 'getStats' in window.RTCRtpSender.prototype) {
      return;
    }
    const origGetSenders = window.RTCPeerConnection.prototype.getSenders;
    if (origGetSenders) {
      window.RTCPeerConnection.prototype.getSenders = function getSenders() {
        const senders = origGetSenders.apply(this, []);
        senders.forEach(sender => sender._pc = this);
        return senders;
      };
    }

    const origAddTrack = window.RTCPeerConnection.prototype.addTrack;
    if (origAddTrack) {
      window.RTCPeerConnection.prototype.addTrack = function addTrack() {
        const sender = origAddTrack.apply(this, arguments);
        sender._pc = this;
        return sender;
      };
    }
    window.RTCRtpSender.prototype.getStats = function getStats() {
      return this.track ? this._pc.getStats(this.track) :
          Promise.resolve(new Map());
    };
  }

  function shimReceiverGetStats(window) {
    if (!(typeof window === 'object' && window.RTCPeerConnection &&
        window.RTCRtpSender)) {
      return;
    }
    if (window.RTCRtpSender && 'getStats' in window.RTCRtpReceiver.prototype) {
      return;
    }
    const origGetReceivers = window.RTCPeerConnection.prototype.getReceivers;
    if (origGetReceivers) {
      window.RTCPeerConnection.prototype.getReceivers = function getReceivers() {
        const receivers = origGetReceivers.apply(this, []);
        receivers.forEach(receiver => receiver._pc = this);
        return receivers;
      };
    }
    wrapPeerConnectionEvent(window, 'track', e => {
      e.receiver._pc = e.srcElement;
      return e;
    });
    window.RTCRtpReceiver.prototype.getStats = function getStats() {
      return this._pc.getStats(this.track);
    };
  }

  function shimRemoveStream(window) {
    if (!window.RTCPeerConnection ||
        'removeStream' in window.RTCPeerConnection.prototype) {
      return;
    }
    window.RTCPeerConnection.prototype.removeStream =
      function removeStream(stream) {
        deprecated('removeStream', 'removeTrack');
        this.getSenders().forEach(sender => {
          if (sender.track && stream.getTracks().includes(sender.track)) {
            this.removeTrack(sender);
          }
        });
      };
  }

  function shimRTCDataChannel(window) {
    // rename DataChannel to RTCDataChannel (native fix in FF60):
    // https://bugzilla.mozilla.org/show_bug.cgi?id=1173851
    if (window.DataChannel && !window.RTCDataChannel) {
      window.RTCDataChannel = window.DataChannel;
    }
  }

  function shimAddTransceiver(window) {
    // https://github.com/webrtcHacks/adapter/issues/998#issuecomment-516921647
    // Firefox ignores the init sendEncodings options passed to addTransceiver
    // https://bugzilla.mozilla.org/show_bug.cgi?id=1396918
    if (!(typeof window === 'object' && window.RTCPeerConnection)) {
      return;
    }
    const origAddTransceiver = window.RTCPeerConnection.prototype.addTransceiver;
    if (origAddTransceiver) {
      window.RTCPeerConnection.prototype.addTransceiver =
        function addTransceiver() {
          this.setParametersPromises = [];
          const initParameters = arguments[1];
          const shouldPerformCheck = initParameters &&
                                    'sendEncodings' in initParameters;
          if (shouldPerformCheck) {
            // If sendEncodings params are provided, validate grammar
            initParameters.sendEncodings.forEach((encodingParam) => {
              if ('rid' in encodingParam) {
                const ridRegex = /^[a-z0-9]{0,16}$/i;
                if (!ridRegex.test(encodingParam.rid)) {
                  throw new TypeError('Invalid RID value provided.');
                }
              }
              if ('scaleResolutionDownBy' in encodingParam) {
                if (!(parseFloat(encodingParam.scaleResolutionDownBy) >= 1.0)) {
                  throw new RangeError('scale_resolution_down_by must be >= 1.0');
                }
              }
              if ('maxFramerate' in encodingParam) {
                if (!(parseFloat(encodingParam.maxFramerate) >= 0)) {
                  throw new RangeError('max_framerate must be >= 0.0');
                }
              }
            });
          }
          const transceiver = origAddTransceiver.apply(this, arguments);
          if (shouldPerformCheck) {
            // Check if the init options were applied. If not we do this in an
            // asynchronous way and save the promise reference in a global object.
            // This is an ugly hack, but at the same time is way more robust than
            // checking the sender parameters before and after the createOffer
            // Also note that after the createoffer we are not 100% sure that
            // the params were asynchronously applied so we might miss the
            // opportunity to recreate offer.
            const {sender} = transceiver;
            const params = sender.getParameters();
            if (!('encodings' in params) ||
                // Avoid being fooled by patched getParameters() below.
                (params.encodings.length === 1 &&
                 Object.keys(params.encodings[0]).length === 0)) {
              params.encodings = initParameters.sendEncodings;
              sender.sendEncodings = initParameters.sendEncodings;
              this.setParametersPromises.push(sender.setParameters(params)
                .then(() => {
                  delete sender.sendEncodings;
                }).catch(() => {
                  delete sender.sendEncodings;
                })
              );
            }
          }
          return transceiver;
        };
    }
  }

  function shimGetParameters(window) {
    if (!(typeof window === 'object' && window.RTCRtpSender)) {
      return;
    }
    const origGetParameters = window.RTCRtpSender.prototype.getParameters;
    if (origGetParameters) {
      window.RTCRtpSender.prototype.getParameters =
        function getParameters() {
          const params = origGetParameters.apply(this, arguments);
          if (!('encodings' in params)) {
            params.encodings = [].concat(this.sendEncodings || [{}]);
          }
          return params;
        };
    }
  }

  function shimCreateOffer(window) {
    // https://github.com/webrtcHacks/adapter/issues/998#issuecomment-516921647
    // Firefox ignores the init sendEncodings options passed to addTransceiver
    // https://bugzilla.mozilla.org/show_bug.cgi?id=1396918
    if (!(typeof window === 'object' && window.RTCPeerConnection)) {
      return;
    }
    const origCreateOffer = window.RTCPeerConnection.prototype.createOffer;
    window.RTCPeerConnection.prototype.createOffer = function createOffer() {
      if (this.setParametersPromises && this.setParametersPromises.length) {
        return Promise.all(this.setParametersPromises)
        .then(() => {
          return origCreateOffer.apply(this, arguments);
        })
        .finally(() => {
          this.setParametersPromises = [];
        });
      }
      return origCreateOffer.apply(this, arguments);
    };
  }

  function shimCreateAnswer(window) {
    // https://github.com/webrtcHacks/adapter/issues/998#issuecomment-516921647
    // Firefox ignores the init sendEncodings options passed to addTransceiver
    // https://bugzilla.mozilla.org/show_bug.cgi?id=1396918
    if (!(typeof window === 'object' && window.RTCPeerConnection)) {
      return;
    }
    const origCreateAnswer = window.RTCPeerConnection.prototype.createAnswer;
    window.RTCPeerConnection.prototype.createAnswer = function createAnswer() {
      if (this.setParametersPromises && this.setParametersPromises.length) {
        return Promise.all(this.setParametersPromises)
        .then(() => {
          return origCreateAnswer.apply(this, arguments);
        })
        .finally(() => {
          this.setParametersPromises = [];
        });
      }
      return origCreateAnswer.apply(this, arguments);
    };
  }

  var firefoxShim = /*#__PURE__*/Object.freeze({
    __proto__: null,
    shimOnTrack: shimOnTrack$1,
    shimPeerConnection: shimPeerConnection$2,
    shimSenderGetStats: shimSenderGetStats,
    shimReceiverGetStats: shimReceiverGetStats,
    shimRemoveStream: shimRemoveStream,
    shimRTCDataChannel: shimRTCDataChannel,
    shimAddTransceiver: shimAddTransceiver,
    shimGetParameters: shimGetParameters,
    shimCreateOffer: shimCreateOffer,
    shimCreateAnswer: shimCreateAnswer,
    shimGetUserMedia: shimGetUserMedia$2,
    shimGetDisplayMedia: shimGetDisplayMedia$2
  });

  /*
   *  Copyright (c) 2016 The WebRTC project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */

  function shimLocalStreamsAPI(window) {
    if (typeof window !== 'object' || !window.RTCPeerConnection) {
      return;
    }
    if (!('getLocalStreams' in window.RTCPeerConnection.prototype)) {
      window.RTCPeerConnection.prototype.getLocalStreams =
        function getLocalStreams() {
          if (!this._localStreams) {
            this._localStreams = [];
          }
          return this._localStreams;
        };
    }
    if (!('addStream' in window.RTCPeerConnection.prototype)) {
      const _addTrack = window.RTCPeerConnection.prototype.addTrack;
      window.RTCPeerConnection.prototype.addStream = function addStream(stream) {
        if (!this._localStreams) {
          this._localStreams = [];
        }
        if (!this._localStreams.includes(stream)) {
          this._localStreams.push(stream);
        }
        // Try to emulate Chrome's behaviour of adding in audio-video order.
        // Safari orders by track id.
        stream.getAudioTracks().forEach(track => _addTrack.call(this, track,
          stream));
        stream.getVideoTracks().forEach(track => _addTrack.call(this, track,
          stream));
      };

      window.RTCPeerConnection.prototype.addTrack =
        function addTrack(track, ...streams) {
          if (streams) {
            streams.forEach((stream) => {
              if (!this._localStreams) {
                this._localStreams = [stream];
              } else if (!this._localStreams.includes(stream)) {
                this._localStreams.push(stream);
              }
            });
          }
          return _addTrack.apply(this, arguments);
        };
    }
    if (!('removeStream' in window.RTCPeerConnection.prototype)) {
      window.RTCPeerConnection.prototype.removeStream =
        function removeStream(stream) {
          if (!this._localStreams) {
            this._localStreams = [];
          }
          const index = this._localStreams.indexOf(stream);
          if (index === -1) {
            return;
          }
          this._localStreams.splice(index, 1);
          const tracks = stream.getTracks();
          this.getSenders().forEach(sender => {
            if (tracks.includes(sender.track)) {
              this.removeTrack(sender);
            }
          });
        };
    }
  }

  function shimRemoteStreamsAPI(window) {
    if (typeof window !== 'object' || !window.RTCPeerConnection) {
      return;
    }
    if (!('getRemoteStreams' in window.RTCPeerConnection.prototype)) {
      window.RTCPeerConnection.prototype.getRemoteStreams =
        function getRemoteStreams() {
          return this._remoteStreams ? this._remoteStreams : [];
        };
    }
    if (!('onaddstream' in window.RTCPeerConnection.prototype)) {
      Object.defineProperty(window.RTCPeerConnection.prototype, 'onaddstream', {
        get() {
          return this._onaddstream;
        },
        set(f) {
          if (this._onaddstream) {
            this.removeEventListener('addstream', this._onaddstream);
            this.removeEventListener('track', this._onaddstreampoly);
          }
          this.addEventListener('addstream', this._onaddstream = f);
          this.addEventListener('track', this._onaddstreampoly = (e) => {
            e.streams.forEach(stream => {
              if (!this._remoteStreams) {
                this._remoteStreams = [];
              }
              if (this._remoteStreams.includes(stream)) {
                return;
              }
              this._remoteStreams.push(stream);
              const event = new Event('addstream');
              event.stream = stream;
              this.dispatchEvent(event);
            });
          });
        }
      });
      const origSetRemoteDescription =
        window.RTCPeerConnection.prototype.setRemoteDescription;
      window.RTCPeerConnection.prototype.setRemoteDescription =
        function setRemoteDescription() {
          const pc = this;
          if (!this._onaddstreampoly) {
            this.addEventListener('track', this._onaddstreampoly = function(e) {
              e.streams.forEach(stream => {
                if (!pc._remoteStreams) {
                  pc._remoteStreams = [];
                }
                if (pc._remoteStreams.indexOf(stream) >= 0) {
                  return;
                }
                pc._remoteStreams.push(stream);
                const event = new Event('addstream');
                event.stream = stream;
                pc.dispatchEvent(event);
              });
            });
          }
          return origSetRemoteDescription.apply(pc, arguments);
        };
    }
  }

  function shimCallbacksAPI(window) {
    if (typeof window !== 'object' || !window.RTCPeerConnection) {
      return;
    }
    const prototype = window.RTCPeerConnection.prototype;
    const origCreateOffer = prototype.createOffer;
    const origCreateAnswer = prototype.createAnswer;
    const setLocalDescription = prototype.setLocalDescription;
    const setRemoteDescription = prototype.setRemoteDescription;
    const addIceCandidate = prototype.addIceCandidate;

    prototype.createOffer =
      function createOffer(successCallback, failureCallback) {
        const options = (arguments.length >= 2) ? arguments[2] : arguments[0];
        const promise = origCreateOffer.apply(this, [options]);
        if (!failureCallback) {
          return promise;
        }
        promise.then(successCallback, failureCallback);
        return Promise.resolve();
      };

    prototype.createAnswer =
      function createAnswer(successCallback, failureCallback) {
        const options = (arguments.length >= 2) ? arguments[2] : arguments[0];
        const promise = origCreateAnswer.apply(this, [options]);
        if (!failureCallback) {
          return promise;
        }
        promise.then(successCallback, failureCallback);
        return Promise.resolve();
      };

    let withCallback = function(description, successCallback, failureCallback) {
      const promise = setLocalDescription.apply(this, [description]);
      if (!failureCallback) {
        return promise;
      }
      promise.then(successCallback, failureCallback);
      return Promise.resolve();
    };
    prototype.setLocalDescription = withCallback;

    withCallback = function(description, successCallback, failureCallback) {
      const promise = setRemoteDescription.apply(this, [description]);
      if (!failureCallback) {
        return promise;
      }
      promise.then(successCallback, failureCallback);
      return Promise.resolve();
    };
    prototype.setRemoteDescription = withCallback;

    withCallback = function(candidate, successCallback, failureCallback) {
      const promise = addIceCandidate.apply(this, [candidate]);
      if (!failureCallback) {
        return promise;
      }
      promise.then(successCallback, failureCallback);
      return Promise.resolve();
    };
    prototype.addIceCandidate = withCallback;
  }

  function shimGetUserMedia$3(window) {
    const navigator = window && window.navigator;

    if (navigator.mediaDevices && navigator.mediaDevices.getUserMedia) {
      // shim not needed in Safari 12.1
      const mediaDevices = navigator.mediaDevices;
      const _getUserMedia = mediaDevices.getUserMedia.bind(mediaDevices);
      navigator.mediaDevices.getUserMedia = (constraints) => {
        return _getUserMedia(shimConstraints(constraints));
      };
    }

    if (!navigator.getUserMedia && navigator.mediaDevices &&
      navigator.mediaDevices.getUserMedia) {
      navigator.getUserMedia = function getUserMedia(constraints, cb, errcb) {
        navigator.mediaDevices.getUserMedia(constraints)
        .then(cb, errcb);
      }.bind(navigator);
    }
  }

  function shimConstraints(constraints) {
    if (constraints && constraints.video !== undefined) {
      return Object.assign({},
        constraints,
        {video: compactObject(constraints.video)}
      );
    }

    return constraints;
  }

  function shimRTCIceServerUrls(window) {
    if (!window.RTCPeerConnection) {
      return;
    }
    // migrate from non-spec RTCIceServer.url to RTCIceServer.urls
    const OrigPeerConnection = window.RTCPeerConnection;
    window.RTCPeerConnection =
      function RTCPeerConnection(pcConfig, pcConstraints) {
        if (pcConfig && pcConfig.iceServers) {
          const newIceServers = [];
          for (let i = 0; i < pcConfig.iceServers.length; i++) {
            let server = pcConfig.iceServers[i];
            if (!server.hasOwnProperty('urls') &&
                server.hasOwnProperty('url')) {
              deprecated('RTCIceServer.url', 'RTCIceServer.urls');
              server = JSON.parse(JSON.stringify(server));
              server.urls = server.url;
              delete server.url;
              newIceServers.push(server);
            } else {
              newIceServers.push(pcConfig.iceServers[i]);
            }
          }
          pcConfig.iceServers = newIceServers;
        }
        return new OrigPeerConnection(pcConfig, pcConstraints);
      };
    window.RTCPeerConnection.prototype = OrigPeerConnection.prototype;
    // wrap static methods. Currently just generateCertificate.
    if ('generateCertificate' in OrigPeerConnection) {
      Object.defineProperty(window.RTCPeerConnection, 'generateCertificate', {
        get() {
          return OrigPeerConnection.generateCertificate;
        }
      });
    }
  }

  function shimTrackEventTransceiver(window) {
    // Add event.transceiver member over deprecated event.receiver
    if (typeof window === 'object' && window.RTCTrackEvent &&
        'receiver' in window.RTCTrackEvent.prototype &&
        !('transceiver' in window.RTCTrackEvent.prototype)) {
      Object.defineProperty(window.RTCTrackEvent.prototype, 'transceiver', {
        get() {
          return {receiver: this.receiver};
        }
      });
    }
  }

  function shimCreateOfferLegacy(window) {
    const origCreateOffer = window.RTCPeerConnection.prototype.createOffer;
    window.RTCPeerConnection.prototype.createOffer =
      function createOffer(offerOptions) {
        if (offerOptions) {
          if (typeof offerOptions.offerToReceiveAudio !== 'undefined') {
            // support bit values
            offerOptions.offerToReceiveAudio =
              !!offerOptions.offerToReceiveAudio;
          }
          const audioTransceiver = this.getTransceivers().find(transceiver =>
            transceiver.receiver.track.kind === 'audio');
          if (offerOptions.offerToReceiveAudio === false && audioTransceiver) {
            if (audioTransceiver.direction === 'sendrecv') {
              if (audioTransceiver.setDirection) {
                audioTransceiver.setDirection('sendonly');
              } else {
                audioTransceiver.direction = 'sendonly';
              }
            } else if (audioTransceiver.direction === 'recvonly') {
              if (audioTransceiver.setDirection) {
                audioTransceiver.setDirection('inactive');
              } else {
                audioTransceiver.direction = 'inactive';
              }
            }
          } else if (offerOptions.offerToReceiveAudio === true &&
              !audioTransceiver) {
            this.addTransceiver('audio');
          }

          if (typeof offerOptions.offerToReceiveVideo !== 'undefined') {
            // support bit values
            offerOptions.offerToReceiveVideo =
              !!offerOptions.offerToReceiveVideo;
          }
          const videoTransceiver = this.getTransceivers().find(transceiver =>
            transceiver.receiver.track.kind === 'video');
          if (offerOptions.offerToReceiveVideo === false && videoTransceiver) {
            if (videoTransceiver.direction === 'sendrecv') {
              if (videoTransceiver.setDirection) {
                videoTransceiver.setDirection('sendonly');
              } else {
                videoTransceiver.direction = 'sendonly';
              }
            } else if (videoTransceiver.direction === 'recvonly') {
              if (videoTransceiver.setDirection) {
                videoTransceiver.setDirection('inactive');
              } else {
                videoTransceiver.direction = 'inactive';
              }
            }
          } else if (offerOptions.offerToReceiveVideo === true &&
              !videoTransceiver) {
            this.addTransceiver('video');
          }
        }
        return origCreateOffer.apply(this, arguments);
      };
  }

  function shimAudioContext(window) {
    if (typeof window !== 'object' || window.AudioContext) {
      return;
    }
    window.AudioContext = window.webkitAudioContext;
  }

  var safariShim = /*#__PURE__*/Object.freeze({
    __proto__: null,
    shimLocalStreamsAPI: shimLocalStreamsAPI,
    shimRemoteStreamsAPI: shimRemoteStreamsAPI,
    shimCallbacksAPI: shimCallbacksAPI,
    shimGetUserMedia: shimGetUserMedia$3,
    shimConstraints: shimConstraints,
    shimRTCIceServerUrls: shimRTCIceServerUrls,
    shimTrackEventTransceiver: shimTrackEventTransceiver,
    shimCreateOfferLegacy: shimCreateOfferLegacy,
    shimAudioContext: shimAudioContext
  });

  /*
   *  Copyright (c) 2017 The WebRTC project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */

  function shimRTCIceCandidate(window) {
    // foundation is arbitrarily chosen as an indicator for full support for
    // https://w3c.github.io/webrtc-pc/#rtcicecandidate-interface
    if (!window.RTCIceCandidate || (window.RTCIceCandidate && 'foundation' in
        window.RTCIceCandidate.prototype)) {
      return;
    }

    const NativeRTCIceCandidate = window.RTCIceCandidate;
    window.RTCIceCandidate = function RTCIceCandidate(args) {
      // Remove the a= which shouldn't be part of the candidate string.
      if (typeof args === 'object' && args.candidate &&
          args.candidate.indexOf('a=') === 0) {
        args = JSON.parse(JSON.stringify(args));
        args.candidate = args.candidate.substr(2);
      }

      if (args.candidate && args.candidate.length) {
        // Augment the native candidate with the parsed fields.
        const nativeCandidate = new NativeRTCIceCandidate(args);
        const parsedCandidate = sdp.parseCandidate(args.candidate);
        const augmentedCandidate = Object.assign(nativeCandidate,
            parsedCandidate);

        // Add a serializer that does not serialize the extra attributes.
        augmentedCandidate.toJSON = function toJSON() {
          return {
            candidate: augmentedCandidate.candidate,
            sdpMid: augmentedCandidate.sdpMid,
            sdpMLineIndex: augmentedCandidate.sdpMLineIndex,
            usernameFragment: augmentedCandidate.usernameFragment,
          };
        };
        return augmentedCandidate;
      }
      return new NativeRTCIceCandidate(args);
    };
    window.RTCIceCandidate.prototype = NativeRTCIceCandidate.prototype;

    // Hook up the augmented candidate in onicecandidate and
    // addEventListener('icecandidate', ...)
    wrapPeerConnectionEvent(window, 'icecandidate', e => {
      if (e.candidate) {
        Object.defineProperty(e, 'candidate', {
          value: new window.RTCIceCandidate(e.candidate),
          writable: 'false'
        });
      }
      return e;
    });
  }

  function shimMaxMessageSize(window, browserDetails) {
    if (!window.RTCPeerConnection) {
      return;
    }

    if (!('sctp' in window.RTCPeerConnection.prototype)) {
      Object.defineProperty(window.RTCPeerConnection.prototype, 'sctp', {
        get() {
          return typeof this._sctp === 'undefined' ? null : this._sctp;
        }
      });
    }

    const sctpInDescription = function(description) {
      if (!description || !description.sdp) {
        return false;
      }
      const sections = sdp.splitSections(description.sdp);
      sections.shift();
      return sections.some(mediaSection => {
        const mLine = sdp.parseMLine(mediaSection);
        return mLine && mLine.kind === 'application'
            && mLine.protocol.indexOf('SCTP') !== -1;
      });
    };

    const getRemoteFirefoxVersion = function(description) {
      // TODO: Is there a better solution for detecting Firefox?
      const match = description.sdp.match(/mozilla...THIS_IS_SDPARTA-(\d+)/);
      if (match === null || match.length < 2) {
        return -1;
      }
      const version = parseInt(match[1], 10);
      // Test for NaN (yes, this is ugly)
      return version !== version ? -1 : version;
    };

    const getCanSendMaxMessageSize = function(remoteIsFirefox) {
      // Every implementation we know can send at least 64 KiB.
      // Note: Although Chrome is technically able to send up to 256 KiB, the
      //       data does not reach the other peer reliably.
      //       See: https://bugs.chromium.org/p/webrtc/issues/detail?id=8419
      let canSendMaxMessageSize = 65536;
      if (browserDetails.browser === 'firefox') {
        if (browserDetails.version < 57) {
          if (remoteIsFirefox === -1) {
            // FF < 57 will send in 16 KiB chunks using the deprecated PPID
            // fragmentation.
            canSendMaxMessageSize = 16384;
          } else {
            // However, other FF (and RAWRTC) can reassemble PPID-fragmented
            // messages. Thus, supporting ~2 GiB when sending.
            canSendMaxMessageSize = 2147483637;
          }
        } else if (browserDetails.version < 60) {
          // Currently, all FF >= 57 will reset the remote maximum message size
          // to the default value when a data channel is created at a later
          // stage. :(
          // See: https://bugzilla.mozilla.org/show_bug.cgi?id=1426831
          canSendMaxMessageSize =
            browserDetails.version === 57 ? 65535 : 65536;
        } else {
          // FF >= 60 supports sending ~2 GiB
          canSendMaxMessageSize = 2147483637;
        }
      }
      return canSendMaxMessageSize;
    };

    const getMaxMessageSize = function(description, remoteIsFirefox) {
      // Note: 65536 bytes is the default value from the SDP spec. Also,
      //       every implementation we know supports receiving 65536 bytes.
      let maxMessageSize = 65536;

      // FF 57 has a slightly incorrect default remote max message size, so
      // we need to adjust it here to avoid a failure when sending.
      // See: https://bugzilla.mozilla.org/show_bug.cgi?id=1425697
      if (browserDetails.browser === 'firefox'
           && browserDetails.version === 57) {
        maxMessageSize = 65535;
      }

      const match = sdp.matchPrefix(description.sdp,
        'a=max-message-size:');
      if (match.length > 0) {
        maxMessageSize = parseInt(match[0].substr(19), 10);
      } else if (browserDetails.browser === 'firefox' &&
                  remoteIsFirefox !== -1) {
        // If the maximum message size is not present in the remote SDP and
        // both local and remote are Firefox, the remote peer can receive
        // ~2 GiB.
        maxMessageSize = 2147483637;
      }
      return maxMessageSize;
    };

    const origSetRemoteDescription =
        window.RTCPeerConnection.prototype.setRemoteDescription;
    window.RTCPeerConnection.prototype.setRemoteDescription =
      function setRemoteDescription() {
        this._sctp = null;
        // Chrome decided to not expose .sctp in plan-b mode.
        // As usual, adapter.js has to do an 'ugly worakaround'
        // to cover up the mess.
        if (browserDetails.browser === 'chrome' && browserDetails.version >= 76) {
          const {sdpSemantics} = this.getConfiguration();
          if (sdpSemantics === 'plan-b') {
            Object.defineProperty(this, 'sctp', {
              get() {
                return typeof this._sctp === 'undefined' ? null : this._sctp;
              },
              enumerable: true,
              configurable: true,
            });
          }
        }

        if (sctpInDescription(arguments[0])) {
          // Check if the remote is FF.
          const isFirefox = getRemoteFirefoxVersion(arguments[0]);

          // Get the maximum message size the local peer is capable of sending
          const canSendMMS = getCanSendMaxMessageSize(isFirefox);

          // Get the maximum message size of the remote peer.
          const remoteMMS = getMaxMessageSize(arguments[0], isFirefox);

          // Determine final maximum message size
          let maxMessageSize;
          if (canSendMMS === 0 && remoteMMS === 0) {
            maxMessageSize = Number.POSITIVE_INFINITY;
          } else if (canSendMMS === 0 || remoteMMS === 0) {
            maxMessageSize = Math.max(canSendMMS, remoteMMS);
          } else {
            maxMessageSize = Math.min(canSendMMS, remoteMMS);
          }

          // Create a dummy RTCSctpTransport object and the 'maxMessageSize'
          // attribute.
          const sctp = {};
          Object.defineProperty(sctp, 'maxMessageSize', {
            get() {
              return maxMessageSize;
            }
          });
          this._sctp = sctp;
        }

        return origSetRemoteDescription.apply(this, arguments);
      };
  }

  function shimSendThrowTypeError(window) {
    if (!(window.RTCPeerConnection &&
        'createDataChannel' in window.RTCPeerConnection.prototype)) {
      return;
    }

    // Note: Although Firefox >= 57 has a native implementation, the maximum
    //       message size can be reset for all data channels at a later stage.
    //       See: https://bugzilla.mozilla.org/show_bug.cgi?id=1426831

    function wrapDcSend(dc, pc) {
      const origDataChannelSend = dc.send;
      dc.send = function send() {
        const data = arguments[0];
        const length = data.length || data.size || data.byteLength;
        if (dc.readyState === 'open' &&
            pc.sctp && length > pc.sctp.maxMessageSize) {
          throw new TypeError('Message too large (can send a maximum of ' +
            pc.sctp.maxMessageSize + ' bytes)');
        }
        return origDataChannelSend.apply(dc, arguments);
      };
    }
    const origCreateDataChannel =
      window.RTCPeerConnection.prototype.createDataChannel;
    window.RTCPeerConnection.prototype.createDataChannel =
      function createDataChannel() {
        const dataChannel = origCreateDataChannel.apply(this, arguments);
        wrapDcSend(dataChannel, this);
        return dataChannel;
      };
    wrapPeerConnectionEvent(window, 'datachannel', e => {
      wrapDcSend(e.channel, e.target);
      return e;
    });
  }


  /* shims RTCConnectionState by pretending it is the same as iceConnectionState.
   * See https://bugs.chromium.org/p/webrtc/issues/detail?id=6145#c12
   * for why this is a valid hack in Chrome. In Firefox it is slightly incorrect
   * since DTLS failures would be hidden. See
   * https://bugzilla.mozilla.org/show_bug.cgi?id=1265827
   * for the Firefox tracking bug.
   */
  function shimConnectionState(window) {
    if (!window.RTCPeerConnection ||
        'connectionState' in window.RTCPeerConnection.prototype) {
      return;
    }
    const proto = window.RTCPeerConnection.prototype;
    Object.defineProperty(proto, 'connectionState', {
      get() {
        return {
          completed: 'connected',
          checking: 'connecting'
        }[this.iceConnectionState] || this.iceConnectionState;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(proto, 'onconnectionstatechange', {
      get() {
        return this._onconnectionstatechange || null;
      },
      set(cb) {
        if (this._onconnectionstatechange) {
          this.removeEventListener('connectionstatechange',
              this._onconnectionstatechange);
          delete this._onconnectionstatechange;
        }
        if (cb) {
          this.addEventListener('connectionstatechange',
              this._onconnectionstatechange = cb);
        }
      },
      enumerable: true,
      configurable: true
    });

    ['setLocalDescription', 'setRemoteDescription'].forEach((method) => {
      const origMethod = proto[method];
      proto[method] = function() {
        if (!this._connectionstatechangepoly) {
          this._connectionstatechangepoly = e => {
            const pc = e.target;
            if (pc._lastConnectionState !== pc.connectionState) {
              pc._lastConnectionState = pc.connectionState;
              const newEvent = new Event('connectionstatechange', e);
              pc.dispatchEvent(newEvent);
            }
            return e;
          };
          this.addEventListener('iceconnectionstatechange',
            this._connectionstatechangepoly);
        }
        return origMethod.apply(this, arguments);
      };
    });
  }

  function removeExtmapAllowMixed(window, browserDetails) {
    /* remove a=extmap-allow-mixed for webrtc.org < M71 */
    if (!window.RTCPeerConnection) {
      return;
    }
    if (browserDetails.browser === 'chrome' && browserDetails.version >= 71) {
      return;
    }
    if (browserDetails.browser === 'safari' && browserDetails.version >= 605) {
      return;
    }
    const nativeSRD = window.RTCPeerConnection.prototype.setRemoteDescription;
    window.RTCPeerConnection.prototype.setRemoteDescription =
    function setRemoteDescription(desc) {
      if (desc && desc.sdp && desc.sdp.indexOf('\na=extmap-allow-mixed') !== -1) {
        const sdp = desc.sdp.split('\n').filter((line) => {
          return line.trim() !== 'a=extmap-allow-mixed';
        }).join('\n');
        // Safari enforces read-only-ness of RTCSessionDescription fields.
        if (window.RTCSessionDescription &&
            desc instanceof window.RTCSessionDescription) {
          arguments[0] = new window.RTCSessionDescription({
            type: desc.type,
            sdp,
          });
        } else {
          desc.sdp = sdp;
        }
      }
      return nativeSRD.apply(this, arguments);
    };
  }

  function shimAddIceCandidateNullOrEmpty(window, browserDetails) {
    // Support for addIceCandidate(null or undefined)
    // as well as addIceCandidate({candidate: "", ...})
    // https://bugs.chromium.org/p/chromium/issues/detail?id=978582
    // Note: must be called before other polyfills which change the signature.
    if (!(window.RTCPeerConnection && window.RTCPeerConnection.prototype)) {
      return;
    }
    const nativeAddIceCandidate =
        window.RTCPeerConnection.prototype.addIceCandidate;
    if (!nativeAddIceCandidate || nativeAddIceCandidate.length === 0) {
      return;
    }
    window.RTCPeerConnection.prototype.addIceCandidate =
      function addIceCandidate() {
        if (!arguments[0]) {
          if (arguments[1]) {
            arguments[1].apply(null);
          }
          return Promise.resolve();
        }
        // Firefox 68+ emits and processes {candidate: "", ...}, ignore
        // in older versions.
        // Native support for ignoring exists for Chrome M77+.
        // Safari ignores as well, exact version unknown but works in the same
        // version that also ignores addIceCandidate(null).
        if (((browserDetails.browser === 'chrome' && browserDetails.version < 78)
             || (browserDetails.browser === 'firefox'
                 && browserDetails.version < 68)
             || (browserDetails.browser === 'safari'))
            && arguments[0] && arguments[0].candidate === '') {
          return Promise.resolve();
        }
        return nativeAddIceCandidate.apply(this, arguments);
      };
  }

  var commonShim = /*#__PURE__*/Object.freeze({
    __proto__: null,
    shimRTCIceCandidate: shimRTCIceCandidate,
    shimMaxMessageSize: shimMaxMessageSize,
    shimSendThrowTypeError: shimSendThrowTypeError,
    shimConnectionState: shimConnectionState,
    removeExtmapAllowMixed: removeExtmapAllowMixed,
    shimAddIceCandidateNullOrEmpty: shimAddIceCandidateNullOrEmpty
  });

  /*
   *  Copyright (c) 2016 The WebRTC project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */

  // Shimming starts here.
  function adapterFactory({window} = {}, options = {
    shimChrome: true,
    shimFirefox: true,
    shimEdge: true,
    shimSafari: true,
  }) {
    // Utils.
    const logging = log;
    const browserDetails = detectBrowser(window);

    const adapter = {
      browserDetails,
      commonShim,
      extractVersion: extractVersion,
      disableLog: disableLog,
      disableWarnings: disableWarnings
    };

    // Shim browser if found.
    switch (browserDetails.browser) {
      case 'chrome':
        if (!chromeShim || !shimPeerConnection ||
            !options.shimChrome) {
          logging('Chrome shim is not included in this adapter release.');
          return adapter;
        }
        if (browserDetails.version === null) {
          logging('Chrome shim can not determine version, not shimming.');
          return adapter;
        }
        logging('adapter.js shimming chrome.');
        // Export to the adapter global object visible in the browser.
        adapter.browserShim = chromeShim;

        // Must be called before shimPeerConnection.
        shimAddIceCandidateNullOrEmpty(window, browserDetails);

        shimGetUserMedia(window, browserDetails);
        shimMediaStream(window);
        shimPeerConnection(window, browserDetails);
        shimOnTrack(window);
        shimAddTrackRemoveTrack(window, browserDetails);
        shimGetSendersWithDtmf(window);
        shimGetStats(window);
        shimSenderReceiverGetStats(window);
        fixNegotiationNeeded(window, browserDetails);

        shimRTCIceCandidate(window);
        shimConnectionState(window);
        shimMaxMessageSize(window, browserDetails);
        shimSendThrowTypeError(window);
        removeExtmapAllowMixed(window, browserDetails);
        break;
      case 'firefox':
        if (!firefoxShim || !shimPeerConnection$2 ||
            !options.shimFirefox) {
          logging('Firefox shim is not included in this adapter release.');
          return adapter;
        }
        logging('adapter.js shimming firefox.');
        // Export to the adapter global object visible in the browser.
        adapter.browserShim = firefoxShim;

        // Must be called before shimPeerConnection.
        shimAddIceCandidateNullOrEmpty(window, browserDetails);

        shimGetUserMedia$2(window, browserDetails);
        shimPeerConnection$2(window, browserDetails);
        shimOnTrack$1(window);
        shimRemoveStream(window);
        shimSenderGetStats(window);
        shimReceiverGetStats(window);
        shimRTCDataChannel(window);
        shimAddTransceiver(window);
        shimGetParameters(window);
        shimCreateOffer(window);
        shimCreateAnswer(window);

        shimRTCIceCandidate(window);
        shimConnectionState(window);
        shimMaxMessageSize(window, browserDetails);
        shimSendThrowTypeError(window);
        break;
      case 'edge':
        if (!edgeShim || !shimPeerConnection$1 || !options.shimEdge) {
          logging('MS edge shim is not included in this adapter release.');
          return adapter;
        }
        logging('adapter.js shimming edge.');
        // Export to the adapter global object visible in the browser.
        adapter.browserShim = edgeShim;

        shimGetUserMedia$1(window);
        shimGetDisplayMedia$1(window);
        shimPeerConnection$1(window, browserDetails);
        shimReplaceTrack(window);

        // the edge shim implements the full RTCIceCandidate object.

        shimMaxMessageSize(window, browserDetails);
        shimSendThrowTypeError(window);
        break;
      case 'safari':
        if (!safariShim || !options.shimSafari) {
          logging('Safari shim is not included in this adapter release.');
          return adapter;
        }
        logging('adapter.js shimming safari.');
        // Export to the adapter global object visible in the browser.
        adapter.browserShim = safariShim;

        // Must be called before shimCallbackAPI.
        shimAddIceCandidateNullOrEmpty(window, browserDetails);

        shimRTCIceServerUrls(window);
        shimCreateOfferLegacy(window);
        shimCallbacksAPI(window);
        shimLocalStreamsAPI(window);
        shimRemoteStreamsAPI(window);
        shimTrackEventTransceiver(window);
        shimGetUserMedia$3(window);
        shimAudioContext(window);

        shimRTCIceCandidate(window);
        shimMaxMessageSize(window, browserDetails);
        shimSendThrowTypeError(window);
        removeExtmapAllowMixed(window, browserDetails);
        break;
      default:
        logging('Unsupported browser!');
        break;
    }

    return adapter;
  }

  /*
   *  Copyright (c) 2016 The WebRTC project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */

  const adapter =
    adapterFactory({window: typeof window === 'undefined' ? undefined : window});

  var version$1 = "14.3.12";

  var Function$3 = global_1.Function;
  var concat$1 = functionUncurryThis([].concat);
  var join = functionUncurryThis([].join);
  var factories = {};

  var construct$1 = function (C, argsLength, args) {
    if (!hasOwnProperty_1(factories, argsLength)) {
      for (var list = [], i = 0; i < argsLength; i++) list[i] = 'a[' + i + ']';
      factories[argsLength] = Function$3('C,a', 'return new C(' + join(list, ',') + ')');
    } return factories[argsLength](C, args);
  };

  // `Function.prototype.bind` method implementation
  // https://tc39.es/ecma262/#sec-function.prototype.bind
  var functionBind = Function$3.bind || function bind(that /* , ...args */) {
    var F = aCallable(this);
    var Prototype = F.prototype;
    var partArgs = arraySlice(arguments, 1);
    var boundFunction = function bound(/* args... */) {
      var args = concat$1(partArgs, arraySlice(arguments));
      return this instanceof boundFunction ? construct$1(F, args.length, args) : F.apply(that, args);
    };
    if (isObject(Prototype)) boundFunction.prototype = Prototype;
    return boundFunction;
  };

  // `Function.prototype.bind` method
  // https://tc39.es/ecma262/#sec-function.prototype.bind
  _export({ target: 'Function', proto: true }, {
    bind: functionBind
  });

  /* eslint-disable es/no-array-prototype-indexof -- required for testing */


  var $IndexOf = arrayIncludes.indexOf;


  var un$IndexOf = functionUncurryThis([].indexOf);

  var NEGATIVE_ZERO = !!un$IndexOf && 1 / un$IndexOf([1], 1, -0) < 0;
  var STRICT_METHOD$2 = arrayMethodIsStrict('indexOf');

  // `Array.prototype.indexOf` method
  // https://tc39.es/ecma262/#sec-array.prototype.indexof
  _export({ target: 'Array', proto: true, forced: NEGATIVE_ZERO || !STRICT_METHOD$2 }, {
    indexOf: function indexOf(searchElement /* , fromIndex = 0 */) {
      var fromIndex = arguments.length > 1 ? arguments[1] : undefined;
      return NEGATIVE_ZERO
        // convert -0 to +0
        ? un$IndexOf(this, searchElement, fromIndex) || 0
        : $IndexOf(this, searchElement, fromIndex);
    }
  });

  // babel-minify and Closure Compiler transpiles RegExp('a', 'y') -> /a/y and it causes SyntaxError
  var $RegExp = global_1.RegExp;

  var UNSUPPORTED_Y = fails(function () {
    var re = $RegExp('a', 'y');
    re.lastIndex = 2;
    return re.exec('abcd') != null;
  });

  // UC Browser bug
  // https://github.com/zloirock/core-js/issues/1008
  var MISSED_STICKY = UNSUPPORTED_Y || fails(function () {
    return !$RegExp('a', 'y').sticky;
  });

  var BROKEN_CARET = UNSUPPORTED_Y || fails(function () {
    // https://bugzilla.mozilla.org/show_bug.cgi?id=773687
    var re = $RegExp('^r', 'gy');
    re.lastIndex = 2;
    return re.exec('str') != null;
  });

  var regexpStickyHelpers = {
    BROKEN_CARET: BROKEN_CARET,
    MISSED_STICKY: MISSED_STICKY,
    UNSUPPORTED_Y: UNSUPPORTED_Y
  };

  // `Object.keys` method
  // https://tc39.es/ecma262/#sec-object.keys
  // eslint-disable-next-line es/no-object-keys -- safe
  var objectKeys = Object.keys || function keys(O) {
    return objectKeysInternal(O, enumBugKeys);
  };

  // `Object.defineProperties` method
  // https://tc39.es/ecma262/#sec-object.defineproperties
  // eslint-disable-next-line es/no-object-defineproperties -- safe
  var f$6 = descriptors && !v8PrototypeDefineBug ? Object.defineProperties : function defineProperties(O, Properties) {
    anObject(O);
    var props = toIndexedObject(Properties);
    var keys = objectKeys(Properties);
    var length = keys.length;
    var index = 0;
    var key;
    while (length > index) objectDefineProperty.f(O, key = keys[index++], props[key]);
    return O;
  };

  var objectDefineProperties = {
  	f: f$6
  };

  /* global ActiveXObject -- old IE, WSH */








  var GT = '>';
  var LT = '<';
  var PROTOTYPE = 'prototype';
  var SCRIPT = 'script';
  var IE_PROTO = sharedKey('IE_PROTO');

  var EmptyConstructor = function () { /* empty */ };

  var scriptTag = function (content) {
    return LT + SCRIPT + GT + content + LT + '/' + SCRIPT + GT;
  };

  // Create object with fake `null` prototype: use ActiveX Object with cleared prototype
  var NullProtoObjectViaActiveX = function (activeXDocument) {
    activeXDocument.write(scriptTag(''));
    activeXDocument.close();
    var temp = activeXDocument.parentWindow.Object;
    activeXDocument = null; // avoid memory leak
    return temp;
  };

  // Create object with fake `null` prototype: use iframe Object with cleared prototype
  var NullProtoObjectViaIFrame = function () {
    // Thrash, waste and sodomy: IE GC bug
    var iframe = documentCreateElement('iframe');
    var JS = 'java' + SCRIPT + ':';
    var iframeDocument;
    iframe.style.display = 'none';
    html.appendChild(iframe);
    // https://github.com/zloirock/core-js/issues/475
    iframe.src = String(JS);
    iframeDocument = iframe.contentWindow.document;
    iframeDocument.open();
    iframeDocument.write(scriptTag('document.F=Object'));
    iframeDocument.close();
    return iframeDocument.F;
  };

  // Check for document.domain and active x support
  // No need to use active x approach when document.domain is not set
  // see https://github.com/es-shims/es5-shim/issues/150
  // variation of https://github.com/kitcambridge/es5-shim/commit/4f738ac066346
  // avoid IE GC bug
  var activeXDocument;
  var NullProtoObject = function () {
    try {
      activeXDocument = new ActiveXObject('htmlfile');
    } catch (error) { /* ignore */ }
    NullProtoObject = typeof document != 'undefined'
      ? document.domain && activeXDocument
        ? NullProtoObjectViaActiveX(activeXDocument) // old IE
        : NullProtoObjectViaIFrame()
      : NullProtoObjectViaActiveX(activeXDocument); // WSH
    var length = enumBugKeys.length;
    while (length--) delete NullProtoObject[PROTOTYPE][enumBugKeys[length]];
    return NullProtoObject();
  };

  hiddenKeys[IE_PROTO] = true;

  // `Object.create` method
  // https://tc39.es/ecma262/#sec-object.create
  var objectCreate = Object.create || function create(O, Properties) {
    var result;
    if (O !== null) {
      EmptyConstructor[PROTOTYPE] = anObject(O);
      result = new EmptyConstructor();
      EmptyConstructor[PROTOTYPE] = null;
      // add "__proto__" for Object.getPrototypeOf polyfill
      result[IE_PROTO] = O;
    } else result = NullProtoObject();
    return Properties === undefined ? result : objectDefineProperties.f(result, Properties);
  };

  // babel-minify and Closure Compiler transpiles RegExp('.', 's') -> /./s and it causes SyntaxError
  var $RegExp$1 = global_1.RegExp;

  var regexpUnsupportedDotAll = fails(function () {
    var re = $RegExp$1('.', 's');
    return !(re.dotAll && re.exec('\n') && re.flags === 's');
  });

  // babel-minify and Closure Compiler transpiles RegExp('(?<a>b)', 'g') -> /(?<a>b)/g and it causes SyntaxError
  var $RegExp$2 = global_1.RegExp;

  var regexpUnsupportedNcg = fails(function () {
    var re = $RegExp$2('(?<a>b)', 'g');
    return re.exec('b').groups.a !== 'b' ||
      'b'.replace(re, '$<a>c') !== 'bc';
  });

  /* eslint-disable regexp/no-empty-capturing-group, regexp/no-empty-group, regexp/no-lazy-ends -- testing */
  /* eslint-disable regexp/no-useless-quantifier -- testing */







  var getInternalState$1 = internalState.get;



  var nativeReplace = shared('native-string-replace', String.prototype.replace);
  var nativeExec = RegExp.prototype.exec;
  var patchedExec = nativeExec;
  var charAt = functionUncurryThis(''.charAt);
  var indexOf$1 = functionUncurryThis(''.indexOf);
  var replace$1 = functionUncurryThis(''.replace);
  var stringSlice$1 = functionUncurryThis(''.slice);

  var UPDATES_LAST_INDEX_WRONG = (function () {
    var re1 = /a/;
    var re2 = /b*/g;
    functionCall(nativeExec, re1, 'a');
    functionCall(nativeExec, re2, 'a');
    return re1.lastIndex !== 0 || re2.lastIndex !== 0;
  })();

  var UNSUPPORTED_Y$1 = regexpStickyHelpers.BROKEN_CARET;

  // nonparticipating capturing group, copied from es5-shim's String#split patch.
  var NPCG_INCLUDED = /()??/.exec('')[1] !== undefined;

  var PATCH = UPDATES_LAST_INDEX_WRONG || NPCG_INCLUDED || UNSUPPORTED_Y$1 || regexpUnsupportedDotAll || regexpUnsupportedNcg;

  if (PATCH) {
    patchedExec = function exec(string) {
      var re = this;
      var state = getInternalState$1(re);
      var str = toString_1(string);
      var raw = state.raw;
      var result, reCopy, lastIndex, match, i, object, group;

      if (raw) {
        raw.lastIndex = re.lastIndex;
        result = functionCall(patchedExec, raw, str);
        re.lastIndex = raw.lastIndex;
        return result;
      }

      var groups = state.groups;
      var sticky = UNSUPPORTED_Y$1 && re.sticky;
      var flags = functionCall(regexpFlags, re);
      var source = re.source;
      var charsAdded = 0;
      var strCopy = str;

      if (sticky) {
        flags = replace$1(flags, 'y', '');
        if (indexOf$1(flags, 'g') === -1) {
          flags += 'g';
        }

        strCopy = stringSlice$1(str, re.lastIndex);
        // Support anchored sticky behavior.
        if (re.lastIndex > 0 && (!re.multiline || re.multiline && charAt(str, re.lastIndex - 1) !== '\n')) {
          source = '(?: ' + source + ')';
          strCopy = ' ' + strCopy;
          charsAdded++;
        }
        // ^(? + rx + ) is needed, in combination with some str slicing, to
        // simulate the 'y' flag.
        reCopy = new RegExp('^(?:' + source + ')', flags);
      }

      if (NPCG_INCLUDED) {
        reCopy = new RegExp('^' + source + '$(?!\\s)', flags);
      }
      if (UPDATES_LAST_INDEX_WRONG) lastIndex = re.lastIndex;

      match = functionCall(nativeExec, sticky ? reCopy : re, strCopy);

      if (sticky) {
        if (match) {
          match.input = stringSlice$1(match.input, charsAdded);
          match[0] = stringSlice$1(match[0], charsAdded);
          match.index = re.lastIndex;
          re.lastIndex += match[0].length;
        } else re.lastIndex = 0;
      } else if (UPDATES_LAST_INDEX_WRONG && match) {
        re.lastIndex = re.global ? match.index + match[0].length : lastIndex;
      }
      if (NPCG_INCLUDED && match && match.length > 1) {
        // Fix browsers whose `exec` methods don't consistently return `undefined`
        // for NPCG, like IE8. NOTE: This doesn' work for /(.?)?/
        functionCall(nativeReplace, match[0], reCopy, function () {
          for (i = 1; i < arguments.length - 2; i++) {
            if (arguments[i] === undefined) match[i] = undefined;
          }
        });
      }

      if (match && groups) {
        match.groups = object = objectCreate(null);
        for (i = 0; i < groups.length; i++) {
          group = groups[i];
          object[group[0]] = match[group[1]];
        }
      }

      return match;
    };
  }

  var regexpExec = patchedExec;

  // `RegExp.prototype.exec` method
  // https://tc39.es/ecma262/#sec-regexp.prototype.exec
  _export({ target: 'RegExp', proto: true, forced: /./.exec !== regexpExec }, {
    exec: regexpExec
  });

  var HAS_SPECIES_SUPPORT$2 = arrayMethodHasSpeciesSupport('slice');

  var SPECIES$5 = wellKnownSymbol('species');
  var Array$2 = global_1.Array;
  var max$1 = Math.max;

  // `Array.prototype.slice` method
  // https://tc39.es/ecma262/#sec-array.prototype.slice
  // fallback for not array-like ES3 strings and DOM objects
  _export({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT$2 }, {
    slice: function slice(start, end) {
      var O = toIndexedObject(this);
      var length = lengthOfArrayLike(O);
      var k = toAbsoluteIndex(start, length);
      var fin = toAbsoluteIndex(end === undefined ? length : end, length);
      // inline `ArraySpeciesCreate` for usage native `Array#slice` where it's possible
      var Constructor, result, n;
      if (isArray(O)) {
        Constructor = O.constructor;
        // cross-realm fallback
        if (isConstructor(Constructor) && (Constructor === Array$2 || isArray(Constructor.prototype))) {
          Constructor = undefined;
        } else if (isObject(Constructor)) {
          Constructor = Constructor[SPECIES$5];
          if (Constructor === null) Constructor = undefined;
        }
        if (Constructor === Array$2 || Constructor === undefined) {
          return arraySlice(O, k, fin);
        }
      }
      result = new (Constructor === undefined ? Array$2 : Constructor)(max$1(fin - k, 0));
      for (n = 0; k < fin; k++, n++) if (k in O) createProperty(result, n, O[k]);
      result.length = n;
      return result;
    }
  });

  /* eslint-disable require-jsdoc */
  var logger = function () {
    // Slightly dubious tricks to cut down minimized file size
    var noop = function noop() {};

    var undefinedType = 'undefined';
    var logMethods = ['trace', 'debug', 'info', 'warn', 'error']; // Cross-browser bind equivalent that works at least back to IE6

    function bindMethod(obj, methodName) {
      var method = obj[methodName];

      if (typeof method.bind === 'function') {
        return method.bind(obj);
      } else {
        try {
          return Function.prototype.bind.call(method, obj);
        } catch (e) {
          // Missing bind shim or IE8 + Modernizr, fallback to wrapping
          return function () {
            return Function.prototype.apply.apply(method, [obj, arguments]);
          };
        }
      }
    } // Build the best logging method possible for this env
    // Wherever possible we want to bind, not wrap, to preserve stack traces


    function realMethod(methodName) {
      if (methodName === 'debug') {
        methodName = 'log';
      }

      if ((typeof console === "undefined" ? "undefined" : _typeof(console)) === undefinedType) {
        return false; // No method possible, for now - fixed later by enableLoggingWhenConsoleArrives
      } else if (console[methodName] !== undefined) {
        return bindMethod(console, methodName);
      } else if (console.log !== undefined) {
        return bindMethod(console, 'log');
      } else {
        return noop;
      }
    } // These private functions always need `this` to be set properly


    function replaceLoggingMethods(level, loggerName) {
      /*jshint validthis:true */
      for (var i = 0; i < logMethods.length; i++) {
        var methodName = logMethods[i];
        this[methodName] = i < level ? noop : this.methodFactory(methodName, level, loggerName);
      } // Define log.log as an alias for log.debug


      this.log = this.debug;
    } // In old IE versions, the console isn't present until you first open it.
    // We build realMethod() replacements here that regenerate logging methods


    function enableLoggingWhenConsoleArrives(methodName, level, loggerName) {
      return function () {
        if ((typeof console === "undefined" ? "undefined" : _typeof(console)) !== undefinedType) {
          replaceLoggingMethods.call(this, level, loggerName);
          this[methodName].apply(this, arguments);
        }
      };
    } // By default, we use closely bound real methods wherever possible, and
    // otherwise we wait for a console to appear, and then try again.


    function defaultMethodFactory(methodName, level, loggerName) {
      /*jshint validthis:true */
      return realMethod(methodName) || enableLoggingWhenConsoleArrives.apply(this, arguments);
    }

    function Logger(name, defaultLevel, factory) {
      var self = this;
      var currentLevel;
      var storageKey = 'loglevel';

      if (name) {
        storageKey += ':' + name;
      }

      function persistLevelIfPossible(levelNum) {
        var levelName = (logMethods[levelNum] || 'silent').toUpperCase();
        if ((typeof window === "undefined" ? "undefined" : _typeof(window)) === undefinedType) return; // Use localStorage if available

        try {
          window.localStorage[storageKey] = levelName;
          return;
        } catch (ignore) {// ignore
        } // Use session cookie as fallback


        try {
          window.document.cookie = encodeURIComponent(storageKey) + '=' + levelName + ';';
        } catch (ignore) {// ignore
        }
      }

      function getPersistedLevel() {
        var storedLevel;
        if ((typeof window === "undefined" ? "undefined" : _typeof(window)) === undefinedType) return;

        try {
          storedLevel = window.localStorage[storageKey];
        } catch (ignore) {// ignore
        } // Fallback to cookies if local storage gives us nothing


        if (_typeof(storedLevel) === undefinedType) {
          try {
            var cookie = window.document.cookie;
            var location = cookie.indexOf(encodeURIComponent(storageKey) + '=');

            if (location !== -1) {
              storedLevel = /^([^;]+)/.exec(cookie.slice(location))[1];
            }
          } catch (ignore) {// ignore
          }
        } // If the stored level is not valid, treat it as if nothing was stored.


        if (self.levels[storedLevel] === undefined) {
          storedLevel = undefined;
        }

        return storedLevel;
      }
      /*
       *
       * Public logger API - see https://github.com/pimterry/loglevel for details
       *
       */


      self.name = name;
      self.levels = {
        TRACE: 0,
        DEBUG: 1,
        INFO: 2,
        WARN: 3,
        ERROR: 4,
        SILENT: 5
      };
      self.methodFactory = factory || defaultMethodFactory;

      self.getLevel = function () {
        return currentLevel;
      };

      self.setLevel = function (level, persist) {
        if (typeof level === 'string' && self.levels[level.toUpperCase()] !== undefined) {
          level = self.levels[level.toUpperCase()];
        }

        if (typeof level === 'number' && level >= 0 && level <= self.levels.SILENT) {
          currentLevel = level;

          if (persist !== false) {
            // defaults to true
            persistLevelIfPossible(level);
          }

          replaceLoggingMethods.call(self, level, name);

          if ((typeof console === "undefined" ? "undefined" : _typeof(console)) === undefinedType && level < self.levels.SILENT) {
            return 'No console available for logging';
          }
        } else {
          throw 'log.setLevel() called with invalid level: ' + level;
        }
      };

      self.setDefaultLevel = function (level) {
        if (!getPersistedLevel()) {
          self.setLevel(level, false);
        }
      };

      self.enableAll = function (persist) {
        self.setLevel(self.levels.TRACE, persist);
      };

      self.disableAll = function (persist) {
        self.setLevel(self.levels.SILENT, persist);
      }; // Initialize with the right level


      var initialLevel = getPersistedLevel();

      if (initialLevel == null) {
        initialLevel = defaultLevel == null ? 'WARN' : defaultLevel;
      }

      self.setLevel(initialLevel, false);
    }
    /*
     *
     * Top-level API
     *
     */


    var defaultLogger = new Logger();
    var _loggersByName = {};

    defaultLogger.getLogger = function getLogger(name) {
      if (typeof name !== 'string' || name === '') {
        throw new TypeError('You must supply a name when creating a logger.');
      }

      var logger = _loggersByName[name];

      if (!logger) {
        logger = _loggersByName[name] = new Logger(name, defaultLogger.getLevel(), defaultLogger.methodFactory);
      }

      return logger;
    }; // Grab the current global log variable in case of overwrite


    var _log = (typeof window === "undefined" ? "undefined" : _typeof(window)) !== undefinedType ? window.log : undefined;

    defaultLogger.noConflict = function () {
      if ((typeof window === "undefined" ? "undefined" : _typeof(window)) !== undefinedType && window.log === defaultLogger) {
        window.log = _log;
      }

      return defaultLogger;
    };

    defaultLogger.getLoggers = function getLoggers() {
      return _loggersByName;
    };

    return defaultLogger;
  }();

  var nativeGetOwnPropertyDescriptor = objectGetOwnPropertyDescriptor.f;


  var FAILS_ON_PRIMITIVES = fails(function () { nativeGetOwnPropertyDescriptor(1); });
  var FORCED$3 = !descriptors || FAILS_ON_PRIMITIVES;

  // `Object.getOwnPropertyDescriptor` method
  // https://tc39.es/ecma262/#sec-object.getownpropertydescriptor
  _export({ target: 'Object', stat: true, forced: FORCED$3, sham: !descriptors }, {
    getOwnPropertyDescriptor: function getOwnPropertyDescriptor(it, key) {
      return nativeGetOwnPropertyDescriptor(toIndexedObject(it), key);
    }
  });

  var correctPrototypeGetter = !fails(function () {
    function F() { /* empty */ }
    F.prototype.constructor = null;
    // eslint-disable-next-line es/no-object-getprototypeof -- required for testing
    return Object.getPrototypeOf(new F()) !== F.prototype;
  });

  var IE_PROTO$1 = sharedKey('IE_PROTO');
  var Object$5 = global_1.Object;
  var ObjectPrototype = Object$5.prototype;

  // `Object.getPrototypeOf` method
  // https://tc39.es/ecma262/#sec-object.getprototypeof
  var objectGetPrototypeOf = correctPrototypeGetter ? Object$5.getPrototypeOf : function (O) {
    var object = toObject(O);
    if (hasOwnProperty_1(object, IE_PROTO$1)) return object[IE_PROTO$1];
    var constructor = object.constructor;
    if (isCallable(constructor) && object instanceof constructor) {
      return constructor.prototype;
    } return object instanceof Object$5 ? ObjectPrototype : null;
  };

  var FAILS_ON_PRIMITIVES$1 = fails(function () { objectGetPrototypeOf(1); });

  // `Object.getPrototypeOf` method
  // https://tc39.es/ecma262/#sec-object.getprototypeof
  _export({ target: 'Object', stat: true, forced: FAILS_ON_PRIMITIVES$1, sham: !correctPrototypeGetter }, {
    getPrototypeOf: function getPrototypeOf(it) {
      return objectGetPrototypeOf(toObject(it));
    }
  });

  // TODO: Remove from `core-js@4` since it's moved to entry points








  var SPECIES$6 = wellKnownSymbol('species');
  var RegExpPrototype$1 = RegExp.prototype;

  var fixRegexpWellKnownSymbolLogic = function (KEY, exec, FORCED, SHAM) {
    var SYMBOL = wellKnownSymbol(KEY);

    var DELEGATES_TO_SYMBOL = !fails(function () {
      // String methods call symbol-named RegEp methods
      var O = {};
      O[SYMBOL] = function () { return 7; };
      return ''[KEY](O) != 7;
    });

    var DELEGATES_TO_EXEC = DELEGATES_TO_SYMBOL && !fails(function () {
      // Symbol-named RegExp methods call .exec
      var execCalled = false;
      var re = /a/;

      if (KEY === 'split') {
        // We can't use real regex here since it causes deoptimization
        // and serious performance degradation in V8
        // https://github.com/zloirock/core-js/issues/306
        re = {};
        // RegExp[@@split] doesn't call the regex's exec method, but first creates
        // a new one. We need to return the patched regex when creating the new one.
        re.constructor = {};
        re.constructor[SPECIES$6] = function () { return re; };
        re.flags = '';
        re[SYMBOL] = /./[SYMBOL];
      }

      re.exec = function () { execCalled = true; return null; };

      re[SYMBOL]('');
      return !execCalled;
    });

    if (
      !DELEGATES_TO_SYMBOL ||
      !DELEGATES_TO_EXEC ||
      FORCED
    ) {
      var uncurriedNativeRegExpMethod = functionUncurryThis(/./[SYMBOL]);
      var methods = exec(SYMBOL, ''[KEY], function (nativeMethod, regexp, str, arg2, forceStringMethod) {
        var uncurriedNativeMethod = functionUncurryThis(nativeMethod);
        var $exec = regexp.exec;
        if ($exec === regexpExec || $exec === RegExpPrototype$1.exec) {
          if (DELEGATES_TO_SYMBOL && !forceStringMethod) {
            // The native String method already delegates to @@method (this
            // polyfilled function), leasing to infinite recursion.
            // We avoid it by directly calling the native @@method method.
            return { done: true, value: uncurriedNativeRegExpMethod(regexp, str, arg2) };
          }
          return { done: true, value: uncurriedNativeMethod(str, regexp, arg2) };
        }
        return { done: false };
      });

      redefine(String.prototype, KEY, methods[0]);
      redefine(RegExpPrototype$1, SYMBOL, methods[1]);
    }

    if (SHAM) createNonEnumerableProperty(RegExpPrototype$1[SYMBOL], 'sham', true);
  };

  var charAt$1 = functionUncurryThis(''.charAt);
  var charCodeAt = functionUncurryThis(''.charCodeAt);
  var stringSlice$2 = functionUncurryThis(''.slice);

  var createMethod$3 = function (CONVERT_TO_STRING) {
    return function ($this, pos) {
      var S = toString_1(requireObjectCoercible($this));
      var position = toIntegerOrInfinity(pos);
      var size = S.length;
      var first, second;
      if (position < 0 || position >= size) return CONVERT_TO_STRING ? '' : undefined;
      first = charCodeAt(S, position);
      return first < 0xD800 || first > 0xDBFF || position + 1 === size
        || (second = charCodeAt(S, position + 1)) < 0xDC00 || second > 0xDFFF
          ? CONVERT_TO_STRING
            ? charAt$1(S, position)
            : first
          : CONVERT_TO_STRING
            ? stringSlice$2(S, position, position + 2)
            : (first - 0xD800 << 10) + (second - 0xDC00) + 0x10000;
    };
  };

  var stringMultibyte = {
    // `String.prototype.codePointAt` method
    // https://tc39.es/ecma262/#sec-string.prototype.codepointat
    codeAt: createMethod$3(false),
    // `String.prototype.at` method
    // https://github.com/mathiasbynens/String.prototype.at
    charAt: createMethod$3(true)
  };

  var charAt$2 = stringMultibyte.charAt;

  // `AdvanceStringIndex` abstract operation
  // https://tc39.es/ecma262/#sec-advancestringindex
  var advanceStringIndex = function (S, index, unicode) {
    return index + (unicode ? charAt$2(S, index).length : 1);
  };

  var floor$1 = Math.floor;
  var charAt$3 = functionUncurryThis(''.charAt);
  var replace$2 = functionUncurryThis(''.replace);
  var stringSlice$3 = functionUncurryThis(''.slice);
  var SUBSTITUTION_SYMBOLS = /\$([$&'`]|\d{1,2}|<[^>]*>)/g;
  var SUBSTITUTION_SYMBOLS_NO_NAMED = /\$([$&'`]|\d{1,2})/g;

  // `GetSubstitution` abstract operation
  // https://tc39.es/ecma262/#sec-getsubstitution
  var getSubstitution = function (matched, str, position, captures, namedCaptures, replacement) {
    var tailPos = position + matched.length;
    var m = captures.length;
    var symbols = SUBSTITUTION_SYMBOLS_NO_NAMED;
    if (namedCaptures !== undefined) {
      namedCaptures = toObject(namedCaptures);
      symbols = SUBSTITUTION_SYMBOLS;
    }
    return replace$2(replacement, symbols, function (match, ch) {
      var capture;
      switch (charAt$3(ch, 0)) {
        case '$': return '$';
        case '&': return matched;
        case '`': return stringSlice$3(str, 0, position);
        case "'": return stringSlice$3(str, tailPos);
        case '<':
          capture = namedCaptures[stringSlice$3(ch, 1, -1)];
          break;
        default: // \d\d?
          var n = +ch;
          if (n === 0) return match;
          if (n > m) {
            var f = floor$1(n / 10);
            if (f === 0) return match;
            if (f <= m) return captures[f - 1] === undefined ? charAt$3(ch, 1) : captures[f - 1] + charAt$3(ch, 1);
            return match;
          }
          capture = captures[n - 1];
      }
      return capture === undefined ? '' : capture;
    });
  };

  var TypeError$f = global_1.TypeError;

  // `RegExpExec` abstract operation
  // https://tc39.es/ecma262/#sec-regexpexec
  var regexpExecAbstract = function (R, S) {
    var exec = R.exec;
    if (isCallable(exec)) {
      var result = functionCall(exec, R, S);
      if (result !== null) anObject(result);
      return result;
    }
    if (classofRaw(R) === 'RegExp') return functionCall(regexpExec, R, S);
    throw TypeError$f('RegExp#exec called on incompatible receiver');
  };

  var REPLACE = wellKnownSymbol('replace');
  var max$2 = Math.max;
  var min$2 = Math.min;
  var concat$2 = functionUncurryThis([].concat);
  var push$2 = functionUncurryThis([].push);
  var stringIndexOf = functionUncurryThis(''.indexOf);
  var stringSlice$4 = functionUncurryThis(''.slice);

  var maybeToString = function (it) {
    return it === undefined ? it : String(it);
  };

  // IE <= 11 replaces $0 with the whole match, as if it was $&
  // https://stackoverflow.com/questions/6024666/getting-ie-to-replace-a-regex-with-the-literal-string-0
  var REPLACE_KEEPS_$0 = (function () {
    // eslint-disable-next-line regexp/prefer-escape-replacement-dollar-char -- required for testing
    return 'a'.replace(/./, '$0') === '$0';
  })();

  // Safari <= 13.0.3(?) substitutes nth capture where n>m with an empty string
  var REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE = (function () {
    if (/./[REPLACE]) {
      return /./[REPLACE]('a', '$0') === '';
    }
    return false;
  })();

  var REPLACE_SUPPORTS_NAMED_GROUPS = !fails(function () {
    var re = /./;
    re.exec = function () {
      var result = [];
      result.groups = { a: '7' };
      return result;
    };
    // eslint-disable-next-line regexp/no-useless-dollar-replacements -- false positive
    return ''.replace(re, '$<a>') !== '7';
  });

  // @@replace logic
  fixRegexpWellKnownSymbolLogic('replace', function (_, nativeReplace, maybeCallNative) {
    var UNSAFE_SUBSTITUTE = REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE ? '$' : '$0';

    return [
      // `String.prototype.replace` method
      // https://tc39.es/ecma262/#sec-string.prototype.replace
      function replace(searchValue, replaceValue) {
        var O = requireObjectCoercible(this);
        var replacer = searchValue == undefined ? undefined : getMethod(searchValue, REPLACE);
        return replacer
          ? functionCall(replacer, searchValue, O, replaceValue)
          : functionCall(nativeReplace, toString_1(O), searchValue, replaceValue);
      },
      // `RegExp.prototype[@@replace]` method
      // https://tc39.es/ecma262/#sec-regexp.prototype-@@replace
      function (string, replaceValue) {
        var rx = anObject(this);
        var S = toString_1(string);

        if (
          typeof replaceValue == 'string' &&
          stringIndexOf(replaceValue, UNSAFE_SUBSTITUTE) === -1 &&
          stringIndexOf(replaceValue, '$<') === -1
        ) {
          var res = maybeCallNative(nativeReplace, rx, S, replaceValue);
          if (res.done) return res.value;
        }

        var functionalReplace = isCallable(replaceValue);
        if (!functionalReplace) replaceValue = toString_1(replaceValue);

        var global = rx.global;
        if (global) {
          var fullUnicode = rx.unicode;
          rx.lastIndex = 0;
        }
        var results = [];
        while (true) {
          var result = regexpExecAbstract(rx, S);
          if (result === null) break;

          push$2(results, result);
          if (!global) break;

          var matchStr = toString_1(result[0]);
          if (matchStr === '') rx.lastIndex = advanceStringIndex(S, toLength(rx.lastIndex), fullUnicode);
        }

        var accumulatedResult = '';
        var nextSourcePosition = 0;
        for (var i = 0; i < results.length; i++) {
          result = results[i];

          var matched = toString_1(result[0]);
          var position = max$2(min$2(toIntegerOrInfinity(result.index), S.length), 0);
          var captures = [];
          // NOTE: This is equivalent to
          //   captures = result.slice(1).map(maybeToString)
          // but for some reason `nativeSlice.call(result, 1, result.length)` (called in
          // the slice polyfill when slicing native arrays) "doesn't work" in safari 9 and
          // causes a crash (https://pastebin.com/N21QzeQA) when trying to debug it.
          for (var j = 1; j < result.length; j++) push$2(captures, maybeToString(result[j]));
          var namedCaptures = result.groups;
          if (functionalReplace) {
            var replacerArgs = concat$2([matched], captures, position, S);
            if (namedCaptures !== undefined) push$2(replacerArgs, namedCaptures);
            var replacement = toString_1(functionApply(replaceValue, undefined, replacerArgs));
          } else {
            replacement = getSubstitution(matched, S, position, captures, namedCaptures, replaceValue);
          }
          if (position >= nextSourcePosition) {
            accumulatedResult += stringSlice$4(S, nextSourcePosition, position) + replacement;
            nextSourcePosition = position + matched.length;
          }
        }
        return accumulatedResult + stringSlice$4(S, nextSourcePosition);
      }
    ];
  }, !REPLACE_SUPPORTS_NAMED_GROUPS || !REPLACE_KEEPS_$0 || REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE);

  // `Array.isArray` method
  // https://tc39.es/ecma262/#sec-array.isarray
  _export({ target: 'Array', stat: true }, {
    isArray: isArray
  });

  var HAS_SPECIES_SUPPORT$3 = arrayMethodHasSpeciesSupport('splice');

  var TypeError$g = global_1.TypeError;
  var max$3 = Math.max;
  var min$3 = Math.min;
  var MAX_SAFE_INTEGER$1 = 0x1FFFFFFFFFFFFF;
  var MAXIMUM_ALLOWED_LENGTH_EXCEEDED = 'Maximum allowed length exceeded';

  // `Array.prototype.splice` method
  // https://tc39.es/ecma262/#sec-array.prototype.splice
  // with adding support of @@species
  _export({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT$3 }, {
    splice: function splice(start, deleteCount /* , ...items */) {
      var O = toObject(this);
      var len = lengthOfArrayLike(O);
      var actualStart = toAbsoluteIndex(start, len);
      var argumentsLength = arguments.length;
      var insertCount, actualDeleteCount, A, k, from, to;
      if (argumentsLength === 0) {
        insertCount = actualDeleteCount = 0;
      } else if (argumentsLength === 1) {
        insertCount = 0;
        actualDeleteCount = len - actualStart;
      } else {
        insertCount = argumentsLength - 2;
        actualDeleteCount = min$3(max$3(toIntegerOrInfinity(deleteCount), 0), len - actualStart);
      }
      if (len + insertCount - actualDeleteCount > MAX_SAFE_INTEGER$1) {
        throw TypeError$g(MAXIMUM_ALLOWED_LENGTH_EXCEEDED);
      }
      A = arraySpeciesCreate(O, actualDeleteCount);
      for (k = 0; k < actualDeleteCount; k++) {
        from = actualStart + k;
        if (from in O) createProperty(A, k, O[from]);
      }
      A.length = actualDeleteCount;
      if (insertCount < actualDeleteCount) {
        for (k = actualStart; k < len - actualDeleteCount; k++) {
          from = k + actualDeleteCount;
          to = k + insertCount;
          if (from in O) O[to] = O[from];
          else delete O[to];
        }
        for (k = len; k > len - actualDeleteCount + insertCount; k--) delete O[k - 1];
      } else if (insertCount > actualDeleteCount) {
        for (k = len - actualDeleteCount; k > actualStart; k--) {
          from = k + actualDeleteCount - 1;
          to = k + insertCount - 1;
          if (from in O) O[to] = O[from];
          else delete O[to];
        }
      }
      for (k = 0; k < insertCount; k++) {
        O[k + actualStart] = arguments[k + 2];
      }
      O.length = len - actualDeleteCount + insertCount;
      return A;
    }
  });

  var RangeError$1 = global_1.RangeError;

  // `String.prototype.repeat` method implementation
  // https://tc39.es/ecma262/#sec-string.prototype.repeat
  var stringRepeat = function repeat(count) {
    var str = toString_1(requireObjectCoercible(this));
    var result = '';
    var n = toIntegerOrInfinity(count);
    if (n < 0 || n == Infinity) throw RangeError$1('Wrong number of repetitions');
    for (;n > 0; (n >>>= 1) && (str += str)) if (n & 1) result += str;
    return result;
  };

  // https://github.com/tc39/proposal-string-pad-start-end






  var repeat = functionUncurryThis(stringRepeat);
  var stringSlice$5 = functionUncurryThis(''.slice);
  var ceil$1 = Math.ceil;

  // `String.prototype.{ padStart, padEnd }` methods implementation
  var createMethod$4 = function (IS_END) {
    return function ($this, maxLength, fillString) {
      var S = toString_1(requireObjectCoercible($this));
      var intMaxLength = toLength(maxLength);
      var stringLength = S.length;
      var fillStr = fillString === undefined ? ' ' : toString_1(fillString);
      var fillLen, stringFiller;
      if (intMaxLength <= stringLength || fillStr == '') return S;
      fillLen = intMaxLength - stringLength;
      stringFiller = repeat(fillStr, ceil$1(fillLen / fillStr.length));
      if (stringFiller.length > fillLen) stringFiller = stringSlice$5(stringFiller, 0, fillLen);
      return IS_END ? S + stringFiller : stringFiller + S;
    };
  };

  var stringPad = {
    // `String.prototype.padStart` method
    // https://tc39.es/ecma262/#sec-string.prototype.padstart
    start: createMethod$4(false),
    // `String.prototype.padEnd` method
    // https://tc39.es/ecma262/#sec-string.prototype.padend
    end: createMethod$4(true)
  };

  var padStart = stringPad.start;

  var RangeError$2 = global_1.RangeError;
  var abs = Math.abs;
  var DatePrototype$1 = Date.prototype;
  var n$DateToISOString = DatePrototype$1.toISOString;
  var getTime$1 = functionUncurryThis(DatePrototype$1.getTime);
  var getUTCDate = functionUncurryThis(DatePrototype$1.getUTCDate);
  var getUTCFullYear = functionUncurryThis(DatePrototype$1.getUTCFullYear);
  var getUTCHours = functionUncurryThis(DatePrototype$1.getUTCHours);
  var getUTCMilliseconds = functionUncurryThis(DatePrototype$1.getUTCMilliseconds);
  var getUTCMinutes = functionUncurryThis(DatePrototype$1.getUTCMinutes);
  var getUTCMonth = functionUncurryThis(DatePrototype$1.getUTCMonth);
  var getUTCSeconds = functionUncurryThis(DatePrototype$1.getUTCSeconds);

  // `Date.prototype.toISOString` method implementation
  // https://tc39.es/ecma262/#sec-date.prototype.toisostring
  // PhantomJS / old WebKit fails here:
  var dateToIsoString = (fails(function () {
    return n$DateToISOString.call(new Date(-5e13 - 1)) != '0385-07-25T07:06:39.999Z';
  }) || !fails(function () {
    n$DateToISOString.call(new Date(NaN));
  })) ? function toISOString() {
    if (!isFinite(getTime$1(this))) throw RangeError$2('Invalid time value');
    var date = this;
    var year = getUTCFullYear(date);
    var milliseconds = getUTCMilliseconds(date);
    var sign = year < 0 ? '-' : year > 9999 ? '+' : '';
    return sign + padStart(abs(year), sign ? 6 : 4, 0) +
      '-' + padStart(getUTCMonth(date) + 1, 2, 0) +
      '-' + padStart(getUTCDate(date), 2, 0) +
      'T' + padStart(getUTCHours(date), 2, 0) +
      ':' + padStart(getUTCMinutes(date), 2, 0) +
      ':' + padStart(getUTCSeconds(date), 2, 0) +
      '.' + padStart(milliseconds, 3, 0) +
      'Z';
  } : n$DateToISOString;

  // `Date.prototype.toISOString` method
  // https://tc39.es/ecma262/#sec-date.prototype.toisostring
  // PhantomJS / old WebKit has a broken implementations
  _export({ target: 'Date', proto: true, forced: Date.prototype.toISOString !== dateToIsoString }, {
    toISOString: dateToIsoString
  });

  var $some = arrayIteration.some;


  var STRICT_METHOD$3 = arrayMethodIsStrict('some');

  // `Array.prototype.some` method
  // https://tc39.es/ecma262/#sec-array.prototype.some
  _export({ target: 'Array', proto: true, forced: !STRICT_METHOD$3 }, {
    some: function some(callbackfn /* , thisArg */) {
      return $some(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
    }
  });

  var MATCH = wellKnownSymbol('match');

  // `IsRegExp` abstract operation
  // https://tc39.es/ecma262/#sec-isregexp
  var isRegexp = function (it) {
    var isRegExp;
    return isObject(it) && ((isRegExp = it[MATCH]) !== undefined ? !!isRegExp : classofRaw(it) == 'RegExp');
  };

  var Array$3 = global_1.Array;
  var max$4 = Math.max;

  var arraySliceSimple = function (O, start, end) {
    var length = lengthOfArrayLike(O);
    var k = toAbsoluteIndex(start, length);
    var fin = toAbsoluteIndex(end === undefined ? length : end, length);
    var result = Array$3(max$4(fin - k, 0));
    for (var n = 0; k < fin; k++, n++) createProperty(result, n, O[k]);
    result.length = n;
    return result;
  };

  var UNSUPPORTED_Y$2 = regexpStickyHelpers.UNSUPPORTED_Y;
  var MAX_UINT32 = 0xFFFFFFFF;
  var min$4 = Math.min;
  var $push = [].push;
  var exec$2 = functionUncurryThis(/./.exec);
  var push$3 = functionUncurryThis($push);
  var stringSlice$6 = functionUncurryThis(''.slice);

  // Chrome 51 has a buggy "split" implementation when RegExp#exec !== nativeExec
  // Weex JS has frozen built-in prototypes, so use try / catch wrapper
  var SPLIT_WORKS_WITH_OVERWRITTEN_EXEC = !fails(function () {
    // eslint-disable-next-line regexp/no-empty-group -- required for testing
    var re = /(?:)/;
    var originalExec = re.exec;
    re.exec = function () { return originalExec.apply(this, arguments); };
    var result = 'ab'.split(re);
    return result.length !== 2 || result[0] !== 'a' || result[1] !== 'b';
  });

  // @@split logic
  fixRegexpWellKnownSymbolLogic('split', function (SPLIT, nativeSplit, maybeCallNative) {
    var internalSplit;
    if (
      'abbc'.split(/(b)*/)[1] == 'c' ||
      // eslint-disable-next-line regexp/no-empty-group -- required for testing
      'test'.split(/(?:)/, -1).length != 4 ||
      'ab'.split(/(?:ab)*/).length != 2 ||
      '.'.split(/(.?)(.?)/).length != 4 ||
      // eslint-disable-next-line regexp/no-empty-capturing-group, regexp/no-empty-group -- required for testing
      '.'.split(/()()/).length > 1 ||
      ''.split(/.?/).length
    ) {
      // based on es5-shim implementation, need to rework it
      internalSplit = function (separator, limit) {
        var string = toString_1(requireObjectCoercible(this));
        var lim = limit === undefined ? MAX_UINT32 : limit >>> 0;
        if (lim === 0) return [];
        if (separator === undefined) return [string];
        // If `separator` is not a regex, use native split
        if (!isRegexp(separator)) {
          return functionCall(nativeSplit, string, separator, lim);
        }
        var output = [];
        var flags = (separator.ignoreCase ? 'i' : '') +
                    (separator.multiline ? 'm' : '') +
                    (separator.unicode ? 'u' : '') +
                    (separator.sticky ? 'y' : '');
        var lastLastIndex = 0;
        // Make `global` and avoid `lastIndex` issues by working with a copy
        var separatorCopy = new RegExp(separator.source, flags + 'g');
        var match, lastIndex, lastLength;
        while (match = functionCall(regexpExec, separatorCopy, string)) {
          lastIndex = separatorCopy.lastIndex;
          if (lastIndex > lastLastIndex) {
            push$3(output, stringSlice$6(string, lastLastIndex, match.index));
            if (match.length > 1 && match.index < string.length) functionApply($push, output, arraySliceSimple(match, 1));
            lastLength = match[0].length;
            lastLastIndex = lastIndex;
            if (output.length >= lim) break;
          }
          if (separatorCopy.lastIndex === match.index) separatorCopy.lastIndex++; // Avoid an infinite loop
        }
        if (lastLastIndex === string.length) {
          if (lastLength || !exec$2(separatorCopy, '')) push$3(output, '');
        } else push$3(output, stringSlice$6(string, lastLastIndex));
        return output.length > lim ? arraySliceSimple(output, 0, lim) : output;
      };
    // Chakra, V8
    } else if ('0'.split(undefined, 0).length) {
      internalSplit = function (separator, limit) {
        return separator === undefined && limit === 0 ? [] : functionCall(nativeSplit, this, separator, limit);
      };
    } else internalSplit = nativeSplit;

    return [
      // `String.prototype.split` method
      // https://tc39.es/ecma262/#sec-string.prototype.split
      function split(separator, limit) {
        var O = requireObjectCoercible(this);
        var splitter = separator == undefined ? undefined : getMethod(separator, SPLIT);
        return splitter
          ? functionCall(splitter, separator, O, limit)
          : functionCall(internalSplit, toString_1(O), separator, limit);
      },
      // `RegExp.prototype[@@split]` method
      // https://tc39.es/ecma262/#sec-regexp.prototype-@@split
      //
      // NOTE: This cannot be properly polyfilled in engines that don't support
      // the 'y' flag.
      function (string, limit) {
        var rx = anObject(this);
        var S = toString_1(string);
        var res = maybeCallNative(internalSplit, rx, S, limit, internalSplit !== nativeSplit);

        if (res.done) return res.value;

        var C = speciesConstructor(rx, RegExp);

        var unicodeMatching = rx.unicode;
        var flags = (rx.ignoreCase ? 'i' : '') +
                    (rx.multiline ? 'm' : '') +
                    (rx.unicode ? 'u' : '') +
                    (UNSUPPORTED_Y$2 ? 'g' : 'y');

        // ^(? + rx + ) is needed, in combination with some S slicing, to
        // simulate the 'y' flag.
        var splitter = new C(UNSUPPORTED_Y$2 ? '^(?:' + rx.source + ')' : rx, flags);
        var lim = limit === undefined ? MAX_UINT32 : limit >>> 0;
        if (lim === 0) return [];
        if (S.length === 0) return regexpExecAbstract(splitter, S) === null ? [S] : [];
        var p = 0;
        var q = 0;
        var A = [];
        while (q < S.length) {
          splitter.lastIndex = UNSUPPORTED_Y$2 ? 0 : q;
          var z = regexpExecAbstract(splitter, UNSUPPORTED_Y$2 ? stringSlice$6(S, q) : S);
          var e;
          if (
            z === null ||
            (e = min$4(toLength(splitter.lastIndex + (UNSUPPORTED_Y$2 ? q : 0)), S.length)) === p
          ) {
            q = advanceStringIndex(S, q, unicodeMatching);
          } else {
            push$3(A, stringSlice$6(S, p, q));
            if (A.length === lim) return A;
            for (var i = 1; i <= z.length - 1; i++) {
              push$3(A, z[i]);
              if (A.length === lim) return A;
            }
            q = p = e;
          }
        }
        push$3(A, stringSlice$6(S, p));
        return A;
      }
    ];
  }, !SPLIT_WORKS_WITH_OVERWRITTEN_EXEC, UNSUPPORTED_Y$2);

  var bind$4 = function bind(fn, thisArg) {
    return function wrap() {
      var args = new Array(arguments.length);
      for (var i = 0; i < args.length; i++) {
        args[i] = arguments[i];
      }
      return fn.apply(thisArg, args);
    };
  };

  /*global toString:true*/

  // utils is a library of generic helper functions non-specific to axios

  var toString$2 = Object.prototype.toString;

  /**
   * Determine if a value is an Array
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is an Array, otherwise false
   */
  function isArray$1(val) {
    return toString$2.call(val) === '[object Array]';
  }

  /**
   * Determine if a value is undefined
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if the value is undefined, otherwise false
   */
  function isUndefined(val) {
    return typeof val === 'undefined';
  }

  /**
   * Determine if a value is a Buffer
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is a Buffer, otherwise false
   */
  function isBuffer(val) {
    return val !== null && !isUndefined(val) && val.constructor !== null && !isUndefined(val.constructor)
      && typeof val.constructor.isBuffer === 'function' && val.constructor.isBuffer(val);
  }

  /**
   * Determine if a value is an ArrayBuffer
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is an ArrayBuffer, otherwise false
   */
  function isArrayBuffer(val) {
    return toString$2.call(val) === '[object ArrayBuffer]';
  }

  /**
   * Determine if a value is a FormData
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is an FormData, otherwise false
   */
  function isFormData(val) {
    return (typeof FormData !== 'undefined') && (val instanceof FormData);
  }

  /**
   * Determine if a value is a view on an ArrayBuffer
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is a view on an ArrayBuffer, otherwise false
   */
  function isArrayBufferView(val) {
    var result;
    if ((typeof ArrayBuffer !== 'undefined') && (ArrayBuffer.isView)) {
      result = ArrayBuffer.isView(val);
    } else {
      result = (val) && (val.buffer) && (val.buffer instanceof ArrayBuffer);
    }
    return result;
  }

  /**
   * Determine if a value is a String
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is a String, otherwise false
   */
  function isString(val) {
    return typeof val === 'string';
  }

  /**
   * Determine if a value is a Number
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is a Number, otherwise false
   */
  function isNumber(val) {
    return typeof val === 'number';
  }

  /**
   * Determine if a value is an Object
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is an Object, otherwise false
   */
  function isObject$2(val) {
    return val !== null && typeof val === 'object';
  }

  /**
   * Determine if a value is a Date
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is a Date, otherwise false
   */
  function isDate(val) {
    return toString$2.call(val) === '[object Date]';
  }

  /**
   * Determine if a value is a File
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is a File, otherwise false
   */
  function isFile(val) {
    return toString$2.call(val) === '[object File]';
  }

  /**
   * Determine if a value is a Blob
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is a Blob, otherwise false
   */
  function isBlob(val) {
    return toString$2.call(val) === '[object Blob]';
  }

  /**
   * Determine if a value is a Function
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is a Function, otherwise false
   */
  function isFunction(val) {
    return toString$2.call(val) === '[object Function]';
  }

  /**
   * Determine if a value is a Stream
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is a Stream, otherwise false
   */
  function isStream(val) {
    return isObject$2(val) && isFunction(val.pipe);
  }

  /**
   * Determine if a value is a URLSearchParams object
   *
   * @param {Object} val The value to test
   * @returns {boolean} True if value is a URLSearchParams object, otherwise false
   */
  function isURLSearchParams(val) {
    return typeof URLSearchParams !== 'undefined' && val instanceof URLSearchParams;
  }

  /**
   * Trim excess whitespace off the beginning and end of a string
   *
   * @param {String} str The String to trim
   * @returns {String} The String freed of excess whitespace
   */
  function trim$1(str) {
    return str.replace(/^\s*/, '').replace(/\s*$/, '');
  }

  /**
   * Determine if we're running in a standard browser environment
   *
   * This allows axios to run in a web worker, and react-native.
   * Both environments support XMLHttpRequest, but not fully standard globals.
   *
   * web workers:
   *  typeof window -> undefined
   *  typeof document -> undefined
   *
   * react-native:
   *  navigator.product -> 'ReactNative'
   * nativescript
   *  navigator.product -> 'NativeScript' or 'NS'
   */
  function isStandardBrowserEnv() {
    if (typeof navigator !== 'undefined' && (navigator.product === 'ReactNative' ||
                                             navigator.product === 'NativeScript' ||
                                             navigator.product === 'NS')) {
      return false;
    }
    return (
      typeof window !== 'undefined' &&
      typeof document !== 'undefined'
    );
  }

  /**
   * Iterate over an Array or an Object invoking a function for each item.
   *
   * If `obj` is an Array callback will be called passing
   * the value, index, and complete array for each item.
   *
   * If 'obj' is an Object callback will be called passing
   * the value, key, and complete object for each property.
   *
   * @param {Object|Array} obj The object to iterate
   * @param {Function} fn The callback to invoke for each item
   */
  function forEach(obj, fn) {
    // Don't bother if no value provided
    if (obj === null || typeof obj === 'undefined') {
      return;
    }

    // Force an array if not already something iterable
    if (typeof obj !== 'object') {
      /*eslint no-param-reassign:0*/
      obj = [obj];
    }

    if (isArray$1(obj)) {
      // Iterate over array values
      for (var i = 0, l = obj.length; i < l; i++) {
        fn.call(null, obj[i], i, obj);
      }
    } else {
      // Iterate over object keys
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          fn.call(null, obj[key], key, obj);
        }
      }
    }
  }

  /**
   * Accepts varargs expecting each argument to be an object, then
   * immutably merges the properties of each object and returns result.
   *
   * When multiple objects contain the same key the later object in
   * the arguments list will take precedence.
   *
   * Example:
   *
   * ```js
   * var result = merge({foo: 123}, {foo: 456});
   * console.log(result.foo); // outputs 456
   * ```
   *
   * @param {Object} obj1 Object to merge
   * @returns {Object} Result of all merge properties
   */
  function merge(/* obj1, obj2, obj3, ... */) {
    var result = {};
    function assignValue(val, key) {
      if (typeof result[key] === 'object' && typeof val === 'object') {
        result[key] = merge(result[key], val);
      } else {
        result[key] = val;
      }
    }

    for (var i = 0, l = arguments.length; i < l; i++) {
      forEach(arguments[i], assignValue);
    }
    return result;
  }

  /**
   * Function equal to merge with the difference being that no reference
   * to original objects is kept.
   *
   * @see merge
   * @param {Object} obj1 Object to merge
   * @returns {Object} Result of all merge properties
   */
  function deepMerge(/* obj1, obj2, obj3, ... */) {
    var result = {};
    function assignValue(val, key) {
      if (typeof result[key] === 'object' && typeof val === 'object') {
        result[key] = deepMerge(result[key], val);
      } else if (typeof val === 'object') {
        result[key] = deepMerge({}, val);
      } else {
        result[key] = val;
      }
    }

    for (var i = 0, l = arguments.length; i < l; i++) {
      forEach(arguments[i], assignValue);
    }
    return result;
  }

  /**
   * Extends object a by mutably adding to it the properties of object b.
   *
   * @param {Object} a The object to be extended
   * @param {Object} b The object to copy properties from
   * @param {Object} thisArg The object to bind function to
   * @return {Object} The resulting value of object a
   */
  function extend(a, b, thisArg) {
    forEach(b, function assignValue(val, key) {
      if (thisArg && typeof val === 'function') {
        a[key] = bind$4(val, thisArg);
      } else {
        a[key] = val;
      }
    });
    return a;
  }

  var utils = {
    isArray: isArray$1,
    isArrayBuffer: isArrayBuffer,
    isBuffer: isBuffer,
    isFormData: isFormData,
    isArrayBufferView: isArrayBufferView,
    isString: isString,
    isNumber: isNumber,
    isObject: isObject$2,
    isUndefined: isUndefined,
    isDate: isDate,
    isFile: isFile,
    isBlob: isBlob,
    isFunction: isFunction,
    isStream: isStream,
    isURLSearchParams: isURLSearchParams,
    isStandardBrowserEnv: isStandardBrowserEnv,
    forEach: forEach,
    merge: merge,
    deepMerge: deepMerge,
    extend: extend,
    trim: trim$1
  };

  function encode(val) {
    return encodeURIComponent(val).
      replace(/%40/gi, '@').
      replace(/%3A/gi, ':').
      replace(/%24/g, '$').
      replace(/%2C/gi, ',').
      replace(/%20/g, '+').
      replace(/%5B/gi, '[').
      replace(/%5D/gi, ']');
  }

  /**
   * Build a URL by appending params to the end
   *
   * @param {string} url The base of the url (e.g., http://www.google.com)
   * @param {object} [params] The params to be appended
   * @returns {string} The formatted url
   */
  var buildURL = function buildURL(url, params, paramsSerializer) {
    /*eslint no-param-reassign:0*/
    if (!params) {
      return url;
    }

    var serializedParams;
    if (paramsSerializer) {
      serializedParams = paramsSerializer(params);
    } else if (utils.isURLSearchParams(params)) {
      serializedParams = params.toString();
    } else {
      var parts = [];

      utils.forEach(params, function serialize(val, key) {
        if (val === null || typeof val === 'undefined') {
          return;
        }

        if (utils.isArray(val)) {
          key = key + '[]';
        } else {
          val = [val];
        }

        utils.forEach(val, function parseValue(v) {
          if (utils.isDate(v)) {
            v = v.toISOString();
          } else if (utils.isObject(v)) {
            v = JSON.stringify(v);
          }
          parts.push(encode(key) + '=' + encode(v));
        });
      });

      serializedParams = parts.join('&');
    }

    if (serializedParams) {
      var hashmarkIndex = url.indexOf('#');
      if (hashmarkIndex !== -1) {
        url = url.slice(0, hashmarkIndex);
      }

      url += (url.indexOf('?') === -1 ? '?' : '&') + serializedParams;
    }

    return url;
  };

  function InterceptorManager() {
    this.handlers = [];
  }

  /**
   * Add a new interceptor to the stack
   *
   * @param {Function} fulfilled The function to handle `then` for a `Promise`
   * @param {Function} rejected The function to handle `reject` for a `Promise`
   *
   * @return {Number} An ID used to remove interceptor later
   */
  InterceptorManager.prototype.use = function use(fulfilled, rejected) {
    this.handlers.push({
      fulfilled: fulfilled,
      rejected: rejected
    });
    return this.handlers.length - 1;
  };

  /**
   * Remove an interceptor from the stack
   *
   * @param {Number} id The ID that was returned by `use`
   */
  InterceptorManager.prototype.eject = function eject(id) {
    if (this.handlers[id]) {
      this.handlers[id] = null;
    }
  };

  /**
   * Iterate over all the registered interceptors
   *
   * This method is particularly useful for skipping over any
   * interceptors that may have become `null` calling `eject`.
   *
   * @param {Function} fn The function to call for each interceptor
   */
  InterceptorManager.prototype.forEach = function forEach(fn) {
    utils.forEach(this.handlers, function forEachHandler(h) {
      if (h !== null) {
        fn(h);
      }
    });
  };

  var InterceptorManager_1 = InterceptorManager;

  /**
   * Transform the data for a request or a response
   *
   * @param {Object|String} data The data to be transformed
   * @param {Array} headers The headers for the request or response
   * @param {Array|Function} fns A single function or Array of functions
   * @returns {*} The resulting transformed data
   */
  var transformData = function transformData(data, headers, fns) {
    /*eslint no-param-reassign:0*/
    utils.forEach(fns, function transform(fn) {
      data = fn(data, headers);
    });

    return data;
  };

  var isCancel = function isCancel(value) {
    return !!(value && value.__CANCEL__);
  };

  var global$1 = (typeof global !== "undefined" ? global :
              typeof self !== "undefined" ? self :
              typeof window !== "undefined" ? window : {});

  // shim for using process in browser
  // based off https://github.com/defunctzombie/node-process/blob/master/browser.js

  function defaultSetTimout() {
      throw new Error('setTimeout has not been defined');
  }
  function defaultClearTimeout () {
      throw new Error('clearTimeout has not been defined');
  }
  var cachedSetTimeout = defaultSetTimout;
  var cachedClearTimeout = defaultClearTimeout;
  if (typeof global$1.setTimeout === 'function') {
      cachedSetTimeout = setTimeout;
  }
  if (typeof global$1.clearTimeout === 'function') {
      cachedClearTimeout = clearTimeout;
  }

  function runTimeout(fun) {
      if (cachedSetTimeout === setTimeout) {
          //normal enviroments in sane situations
          return setTimeout(fun, 0);
      }
      // if setTimeout wasn't available but was latter defined
      if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
          cachedSetTimeout = setTimeout;
          return setTimeout(fun, 0);
      }
      try {
          // when when somebody has screwed with setTimeout but no I.E. maddness
          return cachedSetTimeout(fun, 0);
      } catch(e){
          try {
              // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
              return cachedSetTimeout.call(null, fun, 0);
          } catch(e){
              // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
              return cachedSetTimeout.call(this, fun, 0);
          }
      }


  }
  function runClearTimeout(marker) {
      if (cachedClearTimeout === clearTimeout) {
          //normal enviroments in sane situations
          return clearTimeout(marker);
      }
      // if clearTimeout wasn't available but was latter defined
      if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
          cachedClearTimeout = clearTimeout;
          return clearTimeout(marker);
      }
      try {
          // when when somebody has screwed with setTimeout but no I.E. maddness
          return cachedClearTimeout(marker);
      } catch (e){
          try {
              // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
              return cachedClearTimeout.call(null, marker);
          } catch (e){
              // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
              // Some versions of I.E. have different rules for clearTimeout vs setTimeout
              return cachedClearTimeout.call(this, marker);
          }
      }



  }
  var queue$2 = [];
  var draining = false;
  var currentQueue;
  var queueIndex = -1;

  function cleanUpNextTick() {
      if (!draining || !currentQueue) {
          return;
      }
      draining = false;
      if (currentQueue.length) {
          queue$2 = currentQueue.concat(queue$2);
      } else {
          queueIndex = -1;
      }
      if (queue$2.length) {
          drainQueue();
      }
  }

  function drainQueue() {
      if (draining) {
          return;
      }
      var timeout = runTimeout(cleanUpNextTick);
      draining = true;

      var len = queue$2.length;
      while(len) {
          currentQueue = queue$2;
          queue$2 = [];
          while (++queueIndex < len) {
              if (currentQueue) {
                  currentQueue[queueIndex].run();
              }
          }
          queueIndex = -1;
          len = queue$2.length;
      }
      currentQueue = null;
      draining = false;
      runClearTimeout(timeout);
  }
  function nextTick(fun) {
      var args = new Array(arguments.length - 1);
      if (arguments.length > 1) {
          for (var i = 1; i < arguments.length; i++) {
              args[i - 1] = arguments[i];
          }
      }
      queue$2.push(new Item(fun, args));
      if (queue$2.length === 1 && !draining) {
          runTimeout(drainQueue);
      }
  }
  // v8 likes predictible objects
  function Item(fun, array) {
      this.fun = fun;
      this.array = array;
  }
  Item.prototype.run = function () {
      this.fun.apply(null, this.array);
  };
  var title = 'browser';
  var platform = 'browser';
  var browser = true;
  var env = {};
  var argv = [];
  var version$2 = ''; // empty string to avoid regexp issues
  var versions$1 = {};
  var release = {};
  var config = {};

  function noop$1() {}

  var on = noop$1;
  var addListener = noop$1;
  var once = noop$1;
  var off = noop$1;
  var removeListener = noop$1;
  var removeAllListeners = noop$1;
  var emit = noop$1;

  function binding(name) {
      throw new Error('process.binding is not supported');
  }

  function cwd () { return '/' }
  function chdir (dir) {
      throw new Error('process.chdir is not supported');
  }function umask() { return 0; }

  // from https://github.com/kumavis/browser-process-hrtime/blob/master/index.js
  var performance = global$1.performance || {};
  var performanceNow =
    performance.now        ||
    performance.mozNow     ||
    performance.msNow      ||
    performance.oNow       ||
    performance.webkitNow  ||
    function(){ return (new Date()).getTime() };

  // generate timestamp or delta
  // see http://nodejs.org/api/process.html#process_process_hrtime
  function hrtime(previousTimestamp){
    var clocktime = performanceNow.call(performance)*1e-3;
    var seconds = Math.floor(clocktime);
    var nanoseconds = Math.floor((clocktime%1)*1e9);
    if (previousTimestamp) {
      seconds = seconds - previousTimestamp[0];
      nanoseconds = nanoseconds - previousTimestamp[1];
      if (nanoseconds<0) {
        seconds--;
        nanoseconds += 1e9;
      }
    }
    return [seconds,nanoseconds]
  }

  var startTime = new Date();
  function uptime() {
    var currentTime = new Date();
    var dif = currentTime - startTime;
    return dif / 1000;
  }

  var process$4 = {
    nextTick: nextTick,
    title: title,
    browser: browser,
    env: env,
    argv: argv,
    version: version$2,
    versions: versions$1,
    on: on,
    addListener: addListener,
    once: once,
    off: off,
    removeListener: removeListener,
    removeAllListeners: removeAllListeners,
    emit: emit,
    binding: binding,
    cwd: cwd,
    chdir: chdir,
    umask: umask,
    hrtime: hrtime,
    platform: platform,
    release: release,
    config: config,
    uptime: uptime
  };

  var normalizeHeaderName = function normalizeHeaderName(headers, normalizedName) {
    utils.forEach(headers, function processHeader(value, name) {
      if (name !== normalizedName && name.toUpperCase() === normalizedName.toUpperCase()) {
        headers[normalizedName] = value;
        delete headers[name];
      }
    });
  };

  /**
   * Update an Error with the specified config, error code, and response.
   *
   * @param {Error} error The error to update.
   * @param {Object} config The config.
   * @param {string} [code] The error code (for example, 'ECONNABORTED').
   * @param {Object} [request] The request.
   * @param {Object} [response] The response.
   * @returns {Error} The error.
   */
  var enhanceError = function enhanceError(error, config, code, request, response) {
    error.config = config;
    if (code) {
      error.code = code;
    }

    error.request = request;
    error.response = response;
    error.isAxiosError = true;

    error.toJSON = function() {
      return {
        // Standard
        message: this.message,
        name: this.name,
        // Microsoft
        description: this.description,
        number: this.number,
        // Mozilla
        fileName: this.fileName,
        lineNumber: this.lineNumber,
        columnNumber: this.columnNumber,
        stack: this.stack,
        // Axios
        config: this.config,
        code: this.code
      };
    };
    return error;
  };

  /**
   * Create an Error with the specified message, config, error code, request and response.
   *
   * @param {string} message The error message.
   * @param {Object} config The config.
   * @param {string} [code] The error code (for example, 'ECONNABORTED').
   * @param {Object} [request] The request.
   * @param {Object} [response] The response.
   * @returns {Error} The created error.
   */
  var createError = function createError(message, config, code, request, response) {
    var error = new Error(message);
    return enhanceError(error, config, code, request, response);
  };

  /**
   * Resolve or reject a Promise based on response status.
   *
   * @param {Function} resolve A function that resolves the promise.
   * @param {Function} reject A function that rejects the promise.
   * @param {object} response The response.
   */
  var settle = function settle(resolve, reject, response) {
    var validateStatus = response.config.validateStatus;
    if (!validateStatus || validateStatus(response.status)) {
      resolve(response);
    } else {
      reject(createError(
        'Request failed with status code ' + response.status,
        response.config,
        null,
        response.request,
        response
      ));
    }
  };

  /**
   * Determines whether the specified URL is absolute
   *
   * @param {string} url The URL to test
   * @returns {boolean} True if the specified URL is absolute, otherwise false
   */
  var isAbsoluteURL = function isAbsoluteURL(url) {
    // A URL is considered absolute if it begins with "<scheme>://" or "//" (protocol-relative URL).
    // RFC 3986 defines scheme name as a sequence of characters beginning with a letter and followed
    // by any combination of letters, digits, plus, period, or hyphen.
    return /^([a-z][a-z\d\+\-\.]*:)?\/\//i.test(url);
  };

  /**
   * Creates a new URL by combining the specified URLs
   *
   * @param {string} baseURL The base URL
   * @param {string} relativeURL The relative URL
   * @returns {string} The combined URL
   */
  var combineURLs = function combineURLs(baseURL, relativeURL) {
    return relativeURL
      ? baseURL.replace(/\/+$/, '') + '/' + relativeURL.replace(/^\/+/, '')
      : baseURL;
  };

  /**
   * Creates a new URL by combining the baseURL with the requestedURL,
   * only when the requestedURL is not already an absolute URL.
   * If the requestURL is absolute, this function returns the requestedURL untouched.
   *
   * @param {string} baseURL The base URL
   * @param {string} requestedURL Absolute or relative URL to combine
   * @returns {string} The combined full path
   */
  var buildFullPath = function buildFullPath(baseURL, requestedURL) {
    if (baseURL && !isAbsoluteURL(requestedURL)) {
      return combineURLs(baseURL, requestedURL);
    }
    return requestedURL;
  };

  // Headers whose duplicates are ignored by node
  // c.f. https://nodejs.org/api/http.html#http_message_headers
  var ignoreDuplicateOf = [
    'age', 'authorization', 'content-length', 'content-type', 'etag',
    'expires', 'from', 'host', 'if-modified-since', 'if-unmodified-since',
    'last-modified', 'location', 'max-forwards', 'proxy-authorization',
    'referer', 'retry-after', 'user-agent'
  ];

  /**
   * Parse headers into an object
   *
   * ```
   * Date: Wed, 27 Aug 2014 08:58:49 GMT
   * Content-Type: application/json
   * Connection: keep-alive
   * Transfer-Encoding: chunked
   * ```
   *
   * @param {String} headers Headers needing to be parsed
   * @returns {Object} Headers parsed into an object
   */
  var parseHeaders = function parseHeaders(headers) {
    var parsed = {};
    var key;
    var val;
    var i;

    if (!headers) { return parsed; }

    utils.forEach(headers.split('\n'), function parser(line) {
      i = line.indexOf(':');
      key = utils.trim(line.substr(0, i)).toLowerCase();
      val = utils.trim(line.substr(i + 1));

      if (key) {
        if (parsed[key] && ignoreDuplicateOf.indexOf(key) >= 0) {
          return;
        }
        if (key === 'set-cookie') {
          parsed[key] = (parsed[key] ? parsed[key] : []).concat([val]);
        } else {
          parsed[key] = parsed[key] ? parsed[key] + ', ' + val : val;
        }
      }
    });

    return parsed;
  };

  var isURLSameOrigin = (
    utils.isStandardBrowserEnv() ?

    // Standard browser envs have full support of the APIs needed to test
    // whether the request URL is of the same origin as current location.
      (function standardBrowserEnv() {
        var msie = /(msie|trident)/i.test(navigator.userAgent);
        var urlParsingNode = document.createElement('a');
        var originURL;

        /**
      * Parse a URL to discover it's components
      *
      * @param {String} url The URL to be parsed
      * @returns {Object}
      */
        function resolveURL(url) {
          var href = url;

          if (msie) {
          // IE needs attribute set twice to normalize properties
            urlParsingNode.setAttribute('href', href);
            href = urlParsingNode.href;
          }

          urlParsingNode.setAttribute('href', href);

          // urlParsingNode provides the UrlUtils interface - http://url.spec.whatwg.org/#urlutils
          return {
            href: urlParsingNode.href,
            protocol: urlParsingNode.protocol ? urlParsingNode.protocol.replace(/:$/, '') : '',
            host: urlParsingNode.host,
            search: urlParsingNode.search ? urlParsingNode.search.replace(/^\?/, '') : '',
            hash: urlParsingNode.hash ? urlParsingNode.hash.replace(/^#/, '') : '',
            hostname: urlParsingNode.hostname,
            port: urlParsingNode.port,
            pathname: (urlParsingNode.pathname.charAt(0) === '/') ?
              urlParsingNode.pathname :
              '/' + urlParsingNode.pathname
          };
        }

        originURL = resolveURL(window.location.href);

        /**
      * Determine if a URL shares the same origin as the current location
      *
      * @param {String} requestURL The URL to test
      * @returns {boolean} True if URL shares the same origin, otherwise false
      */
        return function isURLSameOrigin(requestURL) {
          var parsed = (utils.isString(requestURL)) ? resolveURL(requestURL) : requestURL;
          return (parsed.protocol === originURL.protocol &&
              parsed.host === originURL.host);
        };
      })() :

    // Non standard browser envs (web workers, react-native) lack needed support.
      (function nonStandardBrowserEnv() {
        return function isURLSameOrigin() {
          return true;
        };
      })()
  );

  var cookies = (
    utils.isStandardBrowserEnv() ?

    // Standard browser envs support document.cookie
      (function standardBrowserEnv() {
        return {
          write: function write(name, value, expires, path, domain, secure) {
            var cookie = [];
            cookie.push(name + '=' + encodeURIComponent(value));

            if (utils.isNumber(expires)) {
              cookie.push('expires=' + new Date(expires).toGMTString());
            }

            if (utils.isString(path)) {
              cookie.push('path=' + path);
            }

            if (utils.isString(domain)) {
              cookie.push('domain=' + domain);
            }

            if (secure === true) {
              cookie.push('secure');
            }

            document.cookie = cookie.join('; ');
          },

          read: function read(name) {
            var match = document.cookie.match(new RegExp('(^|;\\s*)(' + name + ')=([^;]*)'));
            return (match ? decodeURIComponent(match[3]) : null);
          },

          remove: function remove(name) {
            this.write(name, '', Date.now() - 86400000);
          }
        };
      })() :

    // Non standard browser env (web workers, react-native) lack needed support.
      (function nonStandardBrowserEnv() {
        return {
          write: function write() {},
          read: function read() { return null; },
          remove: function remove() {}
        };
      })()
  );

  var xhr = function xhrAdapter(config) {
    return new Promise(function dispatchXhrRequest(resolve, reject) {
      var requestData = config.data;
      var requestHeaders = config.headers;

      if (utils.isFormData(requestData)) {
        delete requestHeaders['Content-Type']; // Let the browser set it
      }

      var request = new XMLHttpRequest();

      // HTTP basic authentication
      if (config.auth) {
        var username = config.auth.username || '';
        var password = config.auth.password || '';
        requestHeaders.Authorization = 'Basic ' + btoa(username + ':' + password);
      }

      var fullPath = buildFullPath(config.baseURL, config.url);
      request.open(config.method.toUpperCase(), buildURL(fullPath, config.params, config.paramsSerializer), true);

      // Set the request timeout in MS
      request.timeout = config.timeout;

      // Listen for ready state
      request.onreadystatechange = function handleLoad() {
        if (!request || request.readyState !== 4) {
          return;
        }

        // The request errored out and we didn't get a response, this will be
        // handled by onerror instead
        // With one exception: request that using file: protocol, most browsers
        // will return status as 0 even though it's a successful request
        if (request.status === 0 && !(request.responseURL && request.responseURL.indexOf('file:') === 0)) {
          return;
        }

        // Prepare the response
        var responseHeaders = 'getAllResponseHeaders' in request ? parseHeaders(request.getAllResponseHeaders()) : null;
        var responseData = !config.responseType || config.responseType === 'text' ? request.responseText : request.response;
        var response = {
          data: responseData,
          status: request.status,
          statusText: request.statusText,
          headers: responseHeaders,
          config: config,
          request: request
        };

        settle(resolve, reject, response);

        // Clean up request
        request = null;
      };

      // Handle browser request cancellation (as opposed to a manual cancellation)
      request.onabort = function handleAbort() {
        if (!request) {
          return;
        }

        reject(createError('Request aborted', config, 'ECONNABORTED', request));

        // Clean up request
        request = null;
      };

      // Handle low level network errors
      request.onerror = function handleError() {
        // Real errors are hidden from us by the browser
        // onerror should only fire if it's a network error
        reject(createError('Network Error', config, null, request));

        // Clean up request
        request = null;
      };

      // Handle timeout
      request.ontimeout = function handleTimeout() {
        var timeoutErrorMessage = 'timeout of ' + config.timeout + 'ms exceeded';
        if (config.timeoutErrorMessage) {
          timeoutErrorMessage = config.timeoutErrorMessage;
        }
        reject(createError(timeoutErrorMessage, config, 'ECONNABORTED',
          request));

        // Clean up request
        request = null;
      };

      // Add xsrf header
      // This is only done if running in a standard browser environment.
      // Specifically not if we're in a web worker, or react-native.
      if (utils.isStandardBrowserEnv()) {
        var cookies$1 = cookies;

        // Add xsrf header
        var xsrfValue = (config.withCredentials || isURLSameOrigin(fullPath)) && config.xsrfCookieName ?
          cookies$1.read(config.xsrfCookieName) :
          undefined;

        if (xsrfValue) {
          requestHeaders[config.xsrfHeaderName] = xsrfValue;
        }
      }

      // Add headers to the request
      if ('setRequestHeader' in request) {
        utils.forEach(requestHeaders, function setRequestHeader(val, key) {
          if (typeof requestData === 'undefined' && key.toLowerCase() === 'content-type') {
            // Remove Content-Type if data is undefined
            delete requestHeaders[key];
          } else {
            // Otherwise add header to the request
            request.setRequestHeader(key, val);
          }
        });
      }

      // Add withCredentials to request if needed
      if (!utils.isUndefined(config.withCredentials)) {
        request.withCredentials = !!config.withCredentials;
      }

      // Add responseType to request if needed
      if (config.responseType) {
        try {
          request.responseType = config.responseType;
        } catch (e) {
          // Expected DOMException thrown by browsers not compatible XMLHttpRequest Level 2.
          // But, this can be suppressed for 'json' type as it can be parsed by default 'transformResponse' function.
          if (config.responseType !== 'json') {
            throw e;
          }
        }
      }

      // Handle progress if needed
      if (typeof config.onDownloadProgress === 'function') {
        request.addEventListener('progress', config.onDownloadProgress);
      }

      // Not all browsers support upload events
      if (typeof config.onUploadProgress === 'function' && request.upload) {
        request.upload.addEventListener('progress', config.onUploadProgress);
      }

      if (config.cancelToken) {
        // Handle cancellation
        config.cancelToken.promise.then(function onCanceled(cancel) {
          if (!request) {
            return;
          }

          request.abort();
          reject(cancel);
          // Clean up request
          request = null;
        });
      }

      if (requestData === undefined) {
        requestData = null;
      }

      // Send the request
      request.send(requestData);
    });
  };

  var DEFAULT_CONTENT_TYPE = {
    'Content-Type': 'application/x-www-form-urlencoded'
  };

  function setContentTypeIfUnset(headers, value) {
    if (!utils.isUndefined(headers) && utils.isUndefined(headers['Content-Type'])) {
      headers['Content-Type'] = value;
    }
  }

  function getDefaultAdapter() {
    var adapter;
    if (typeof XMLHttpRequest !== 'undefined') {
      // For browsers use XHR adapter
      adapter = xhr;
    } else if (typeof process$4 !== 'undefined' && Object.prototype.toString.call(process$4) === '[object process]') {
      // For node use HTTP adapter
      adapter = xhr;
    }
    return adapter;
  }

  var defaults = {
    adapter: getDefaultAdapter(),

    transformRequest: [function transformRequest(data, headers) {
      normalizeHeaderName(headers, 'Accept');
      normalizeHeaderName(headers, 'Content-Type');
      if (utils.isFormData(data) ||
        utils.isArrayBuffer(data) ||
        utils.isBuffer(data) ||
        utils.isStream(data) ||
        utils.isFile(data) ||
        utils.isBlob(data)
      ) {
        return data;
      }
      if (utils.isArrayBufferView(data)) {
        return data.buffer;
      }
      if (utils.isURLSearchParams(data)) {
        setContentTypeIfUnset(headers, 'application/x-www-form-urlencoded;charset=utf-8');
        return data.toString();
      }
      if (utils.isObject(data)) {
        setContentTypeIfUnset(headers, 'application/json;charset=utf-8');
        return JSON.stringify(data);
      }
      return data;
    }],

    transformResponse: [function transformResponse(data) {
      /*eslint no-param-reassign:0*/
      if (typeof data === 'string') {
        try {
          data = JSON.parse(data);
        } catch (e) { /* Ignore */ }
      }
      return data;
    }],

    /**
     * A timeout in milliseconds to abort a request. If set to 0 (default) a
     * timeout is not created.
     */
    timeout: 0,

    xsrfCookieName: 'XSRF-TOKEN',
    xsrfHeaderName: 'X-XSRF-TOKEN',

    maxContentLength: -1,

    validateStatus: function validateStatus(status) {
      return status >= 200 && status < 300;
    }
  };

  defaults.headers = {
    common: {
      'Accept': 'application/json, text/plain, */*'
    }
  };

  utils.forEach(['delete', 'get', 'head'], function forEachMethodNoData(method) {
    defaults.headers[method] = {};
  });

  utils.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
    defaults.headers[method] = utils.merge(DEFAULT_CONTENT_TYPE);
  });

  var defaults_1 = defaults;

  /**
   * Throws a `Cancel` if cancellation has been requested.
   */
  function throwIfCancellationRequested(config) {
    if (config.cancelToken) {
      config.cancelToken.throwIfRequested();
    }
  }

  /**
   * Dispatch a request to the server using the configured adapter.
   *
   * @param {object} config The config that is to be used for the request
   * @returns {Promise} The Promise to be fulfilled
   */
  var dispatchRequest = function dispatchRequest(config) {
    throwIfCancellationRequested(config);

    // Ensure headers exist
    config.headers = config.headers || {};

    // Transform request data
    config.data = transformData(
      config.data,
      config.headers,
      config.transformRequest
    );

    // Flatten headers
    config.headers = utils.merge(
      config.headers.common || {},
      config.headers[config.method] || {},
      config.headers
    );

    utils.forEach(
      ['delete', 'get', 'head', 'post', 'put', 'patch', 'common'],
      function cleanHeaderConfig(method) {
        delete config.headers[method];
      }
    );

    var adapter = config.adapter || defaults_1.adapter;

    return adapter(config).then(function onAdapterResolution(response) {
      throwIfCancellationRequested(config);

      // Transform response data
      response.data = transformData(
        response.data,
        response.headers,
        config.transformResponse
      );

      return response;
    }, function onAdapterRejection(reason) {
      if (!isCancel(reason)) {
        throwIfCancellationRequested(config);

        // Transform response data
        if (reason && reason.response) {
          reason.response.data = transformData(
            reason.response.data,
            reason.response.headers,
            config.transformResponse
          );
        }
      }

      return Promise.reject(reason);
    });
  };

  /**
   * Config-specific merge-function which creates a new config-object
   * by merging two configuration objects together.
   *
   * @param {Object} config1
   * @param {Object} config2
   * @returns {Object} New object resulting from merging config2 to config1
   */
  var mergeConfig = function mergeConfig(config1, config2) {
    // eslint-disable-next-line no-param-reassign
    config2 = config2 || {};
    var config = {};

    var valueFromConfig2Keys = ['url', 'method', 'params', 'data'];
    var mergeDeepPropertiesKeys = ['headers', 'auth', 'proxy'];
    var defaultToConfig2Keys = [
      'baseURL', 'url', 'transformRequest', 'transformResponse', 'paramsSerializer',
      'timeout', 'withCredentials', 'adapter', 'responseType', 'xsrfCookieName',
      'xsrfHeaderName', 'onUploadProgress', 'onDownloadProgress',
      'maxContentLength', 'validateStatus', 'maxRedirects', 'httpAgent',
      'httpsAgent', 'cancelToken', 'socketPath'
    ];

    utils.forEach(valueFromConfig2Keys, function valueFromConfig2(prop) {
      if (typeof config2[prop] !== 'undefined') {
        config[prop] = config2[prop];
      }
    });

    utils.forEach(mergeDeepPropertiesKeys, function mergeDeepProperties(prop) {
      if (utils.isObject(config2[prop])) {
        config[prop] = utils.deepMerge(config1[prop], config2[prop]);
      } else if (typeof config2[prop] !== 'undefined') {
        config[prop] = config2[prop];
      } else if (utils.isObject(config1[prop])) {
        config[prop] = utils.deepMerge(config1[prop]);
      } else if (typeof config1[prop] !== 'undefined') {
        config[prop] = config1[prop];
      }
    });

    utils.forEach(defaultToConfig2Keys, function defaultToConfig2(prop) {
      if (typeof config2[prop] !== 'undefined') {
        config[prop] = config2[prop];
      } else if (typeof config1[prop] !== 'undefined') {
        config[prop] = config1[prop];
      }
    });

    var axiosKeys = valueFromConfig2Keys
      .concat(mergeDeepPropertiesKeys)
      .concat(defaultToConfig2Keys);

    var otherKeys = Object
      .keys(config2)
      .filter(function filterAxiosKeys(key) {
        return axiosKeys.indexOf(key) === -1;
      });

    utils.forEach(otherKeys, function otherKeysDefaultToConfig2(prop) {
      if (typeof config2[prop] !== 'undefined') {
        config[prop] = config2[prop];
      } else if (typeof config1[prop] !== 'undefined') {
        config[prop] = config1[prop];
      }
    });

    return config;
  };

  /**
   * Create a new instance of Axios
   *
   * @param {Object} instanceConfig The default config for the instance
   */
  function Axios(instanceConfig) {
    this.defaults = instanceConfig;
    this.interceptors = {
      request: new InterceptorManager_1(),
      response: new InterceptorManager_1()
    };
  }

  /**
   * Dispatch a request
   *
   * @param {Object} config The config specific for this request (merged with this.defaults)
   */
  Axios.prototype.request = function request(config) {
    /*eslint no-param-reassign:0*/
    // Allow for axios('example/url'[, config]) a la fetch API
    if (typeof config === 'string') {
      config = arguments[1] || {};
      config.url = arguments[0];
    } else {
      config = config || {};
    }

    config = mergeConfig(this.defaults, config);

    // Set config.method
    if (config.method) {
      config.method = config.method.toLowerCase();
    } else if (this.defaults.method) {
      config.method = this.defaults.method.toLowerCase();
    } else {
      config.method = 'get';
    }

    // Hook up interceptors middleware
    var chain = [dispatchRequest, undefined];
    var promise = Promise.resolve(config);

    this.interceptors.request.forEach(function unshiftRequestInterceptors(interceptor) {
      chain.unshift(interceptor.fulfilled, interceptor.rejected);
    });

    this.interceptors.response.forEach(function pushResponseInterceptors(interceptor) {
      chain.push(interceptor.fulfilled, interceptor.rejected);
    });

    while (chain.length) {
      promise = promise.then(chain.shift(), chain.shift());
    }

    return promise;
  };

  Axios.prototype.getUri = function getUri(config) {
    config = mergeConfig(this.defaults, config);
    return buildURL(config.url, config.params, config.paramsSerializer).replace(/^\?/, '');
  };

  // Provide aliases for supported request methods
  utils.forEach(['delete', 'get', 'head', 'options'], function forEachMethodNoData(method) {
    /*eslint func-names:0*/
    Axios.prototype[method] = function(url, config) {
      return this.request(utils.merge(config || {}, {
        method: method,
        url: url
      }));
    };
  });

  utils.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
    /*eslint func-names:0*/
    Axios.prototype[method] = function(url, data, config) {
      return this.request(utils.merge(config || {}, {
        method: method,
        url: url,
        data: data
      }));
    };
  });

  var Axios_1 = Axios;

  /**
   * A `Cancel` is an object that is thrown when an operation is canceled.
   *
   * @class
   * @param {string=} message The message.
   */
  function Cancel(message) {
    this.message = message;
  }

  Cancel.prototype.toString = function toString() {
    return 'Cancel' + (this.message ? ': ' + this.message : '');
  };

  Cancel.prototype.__CANCEL__ = true;

  var Cancel_1 = Cancel;

  /**
   * A `CancelToken` is an object that can be used to request cancellation of an operation.
   *
   * @class
   * @param {Function} executor The executor function.
   */
  function CancelToken(executor) {
    if (typeof executor !== 'function') {
      throw new TypeError('executor must be a function.');
    }

    var resolvePromise;
    this.promise = new Promise(function promiseExecutor(resolve) {
      resolvePromise = resolve;
    });

    var token = this;
    executor(function cancel(message) {
      if (token.reason) {
        // Cancellation has already been requested
        return;
      }

      token.reason = new Cancel_1(message);
      resolvePromise(token.reason);
    });
  }

  /**
   * Throws a `Cancel` if cancellation has been requested.
   */
  CancelToken.prototype.throwIfRequested = function throwIfRequested() {
    if (this.reason) {
      throw this.reason;
    }
  };

  /**
   * Returns an object that contains a new `CancelToken` and a function that, when called,
   * cancels the `CancelToken`.
   */
  CancelToken.source = function source() {
    var cancel;
    var token = new CancelToken(function executor(c) {
      cancel = c;
    });
    return {
      token: token,
      cancel: cancel
    };
  };

  var CancelToken_1 = CancelToken;

  /**
   * Syntactic sugar for invoking a function and expanding an array for arguments.
   *
   * Common use case would be to use `Function.prototype.apply`.
   *
   *  ```js
   *  function f(x, y, z) {}
   *  var args = [1, 2, 3];
   *  f.apply(null, args);
   *  ```
   *
   * With `spread` this example can be re-written.
   *
   *  ```js
   *  spread(function(x, y, z) {})([1, 2, 3]);
   *  ```
   *
   * @param {Function} callback
   * @returns {Function}
   */
  var spread = function spread(callback) {
    return function wrap(arr) {
      return callback.apply(null, arr);
    };
  };

  /**
   * Create an instance of Axios
   *
   * @param {Object} defaultConfig The default config for the instance
   * @return {Axios} A new instance of Axios
   */
  function createInstance(defaultConfig) {
    var context = new Axios_1(defaultConfig);
    var instance = bind$4(Axios_1.prototype.request, context);

    // Copy axios.prototype to instance
    utils.extend(instance, Axios_1.prototype, context);

    // Copy context to instance
    utils.extend(instance, context);

    return instance;
  }

  // Create the default instance to be exported
  var axios = createInstance(defaults_1);

  // Expose Axios class to allow class inheritance
  axios.Axios = Axios_1;

  // Factory for creating new instances
  axios.create = function create(instanceConfig) {
    return createInstance(mergeConfig(axios.defaults, instanceConfig));
  };

  // Expose Cancel & CancelToken
  axios.Cancel = Cancel_1;
  axios.CancelToken = CancelToken_1;
  axios.isCancel = isCancel;

  // Expose all/spread
  axios.all = function all(promises) {
    return Promise.all(promises);
  };
  axios.spread = spread;

  var axios_1 = axios;

  // Allow use of default import syntax in TypeScript
  var default_1 = axios;
  axios_1.default = default_1;

  // based on the baseTime received from remote server

  var baseTime = new Date().getTime();
  var offset = 0;
  var setBaseTime = function setBaseTime(time) {
    baseTime = time;
    offset = baseTime - new Date().getTime();
    var base = new Date();
    base.setTime(time);
    logger.info('baseTime from server: ' + base + ' offset: ' + offset);
  };
  var getCurrentTime = function getCurrentTime() {
    return new Date().getTime() + offset;
  };
  var getTimestamp = function getTimestamp() {
    var now = new Date();
    now.setTime(getCurrentTime());
    return now.toLocaleString();
  };

  var CIRCULAR_ERROR_MESSAGE; // https://github.com/nodejs/node/blob/master/lib/util.js

  function tryStringify(arg) {
    try {
      return JSON.stringify(arg);
    } catch (error) {
      // Populate the circular error message lazily
      if (!CIRCULAR_ERROR_MESSAGE) {
        try {
          var a = {};
          a.a = a;
          JSON.stringify(a);
        } catch (circular) {
          CIRCULAR_ERROR_MESSAGE = circular.message;
        }
      }

      if (error.message === CIRCULAR_ERROR_MESSAGE) {
        return '[Circular]';
      }

      throw error;
    }
  }

  function getConstructorName(obj) {
    if (!Object.getOwnPropertyDescriptor || !Object.getPrototypeOf) {
      return Object.prototype.toString.call(obj).slice(8, -1);
    } // https://github.com/nodejs/node/blob/master/lib/internal/util.js


    while (obj) {
      var descriptor = Object.getOwnPropertyDescriptor(obj, 'constructor');

      if (descriptor !== undefined && typeof descriptor.value === 'function' && descriptor.value.name !== '') {
        return descriptor.value.name;
      }

      obj = Object.getPrototypeOf(obj);
    }

    return '';
  }

  function interpolate(array) {
    var result = '';
    var index = 0;

    if (array.length > 1 && typeof array[0] === 'string') {
      result = array[0].replace(/(%?)(%([sdjo]))/g, function (match, escaped, ptn, flag) {
        if (!escaped) {
          index += 1;
          var arg = array[index];
          var a = '';

          switch (flag) {
            case 's':
              a += arg;
              break;

            case 'd':
              a += +arg;
              break;

            case 'j':
              a = tryStringify(arg);
              break;

            case 'o':
              {
                var obj = tryStringify(arg);

                if (obj[0] !== '{' && obj[0] !== '[') {
                  obj = "<".concat(obj, ">");
                }

                a = getConstructorName(arg) + obj;
                break;
              }
          }

          return a;
        }

        return match;
      }); // update escaped %% values

      result = result.replace(/%{2,2}/g, '%');
      index += 1;
    } // arguments remaining after formatting


    if (array.length > index) {
      if (result) result += ' ';
      result += array.slice(index).join(' ');
    }

    return result;
  }

  var hasOwnProperty$1 = Object.prototype.hasOwnProperty; // Light deep Object.assign({}, ...sources)

  function assign() {
    var target = {};

    for (var s = 0; s < arguments.length; s += 1) {
      var source = Object(arguments[s]);

      for (var key in source) {
        if (hasOwnProperty$1.call(source, key)) {
          target[key] = _typeof(source[key]) === 'object' && !Array.isArray(source[key]) ? assign(target[key], source[key]) : source[key];
        }
      }
    }

    return target;
  }

  function getStacktrace() {
    try {
      throw new Error();
    } catch (trace) {
      return trace.stack;
    }
  }

  function Queue$1(capacity) {
    var _this = this;

    var queue = [];
    var sent = [];

    this.length = function () {
      return queue.length;
    };

    this.sent = function () {
      return sent.length;
    };

    this.push = function (message) {
      queue.push(message);

      if (queue.length > capacity) {
        queue.shift();
      }
    };

    this.send = function () {
      if (!sent.length) {
        sent = queue;
        queue = [];
      }

      return sent;
    };

    this.confirm = function () {
      sent = [];
      _this.content = '';
    };

    this.fail = function () {
      var overflow = 1 + queue.length + sent.length - capacity;

      if (overflow > 0) {
        sent.splice(0, overflow);
        queue = sent.concat(queue);

        _this.confirm();
      } // if (queue.length + sent.length >= capacity) this.confirm();

    };
  }

  var hasStacktraceSupport = !!getStacktrace();
  var loglevel;
  var originalFactory;
  var pluginFactory;

  function plain(log) {
    return "[".concat(log.timestamp, "] <").concat(log.level.label.toUpperCase(), ">").concat(log.logger ? " (".concat(log.logger, ")") : '', ": ").concat(log.message).concat(log.stacktrace ? "\n".concat(log.stacktrace) : '');
  }

  function json(log) {
    log.level = log.level.label;
    return log;
  }

  var defaultCapacity = 500;
  var defaults$1 = {
    // url: 'https://ilivelog.qcloud.com/', // this url of kibana is maintained by neal's team
    // this is the url of kibana maintained by backend team
    // url: 'https://yun.tim.qq.com/v5/AVQualityReportSvc/C2S?sdkappid=1&cmdtype=jssdk_log',
    // url: 'https://test.tim.qq.com/v5/AVQualityReportSvc/C2S?sdkappid=1&cmdtype=jssdk_log',
    interval: 1000,
    level: 'trace',
    capacity: 0,
    stacktrace: {
      levels: ['trace', 'warn', 'error'],
      depth: 3,
      excess: 0
    },
    timestamp: function timestamp() {
      return new Date().toISOString();
    },
    format: plain
  };
  var uploadInterval = -1;
  var isUploadConfigured = false;
  var sdkAppId = '';
  var userId = '';
  var version$3 = '';
  var remote = {
    plain: plain,
    json: json,
    setConfig: function setConfig(config) {
      if (isUploadConfigured) return; // ensure all fields are type of string

      sdkAppId = "".concat(config.sdkAppId);
      userId = "".concat(config.userId);
      version$3 = "".concat(config.version);
      isUploadConfigured = true;
    },
    apply: function apply(logger, options) {
      if (!logger || !logger.getLogger) {
        throw new TypeError('Argument is not a root loglevel object');
      }

      if (loglevel) {
        throw new Error('You can assign a plugin only one time');
      }

      loglevel = logger;
      var config = assign(defaults$1, options);
      config.capacity = config.capacity || defaultCapacity;
      var interval = config.interval;
      var isJSON;
      uploadInterval = setInterval(send, interval);
      var queue = new Queue$1(config.capacity);

      function send() {
        if (!isUploadConfigured) return;

        if (!queue.sent()) {
          if (!queue.length()) {
            return;
          }

          var logs = queue.send();
          queue.content = isJSON ? "{\"logs\":[".concat(logs.join(','), "]}") : logs.join('\n');
        }
      }

      originalFactory = logger.methodFactory;

      pluginFactory = function remoteMethodFactory(methodName, logLevel, loggerName) {
        var rawMethod = originalFactory(methodName, logLevel, loggerName);
        var needStack = hasStacktraceSupport && config.stacktrace.levels.some(function (level) {
          return level === methodName;
        });
        var levelVal = loglevel.levels[methodName.toUpperCase()];
        var needLog = levelVal >= loglevel.levels[config.level.toUpperCase()];
        return function () {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          var message = interpolate(args);

          if (needLog) {
            // const timestamp = config.timestamp();
            // const timestamp = new Date().toLocaleString();
            var _timestamp = getTimestamp();

            var stacktrace = needStack ? getStacktrace() : '';

            if (stacktrace) {
              var lines = stacktrace.split('\n');
              lines.splice(0, config.stacktrace.excess + 3);
              var depth = config.stacktrace.depth;

              if (depth && lines.length !== depth + 1) {
                var shrink = lines.splice(0, depth);
                stacktrace = shrink.join('\n');
                if (lines.length) stacktrace += "\n    and ".concat(lines.length, " more");
              } else {
                stacktrace = lines.join('\n');
              }
            }

            var log = config.format({
              message: message,
              level: {
                label: methodName,
                value: levelVal
              },
              logger: loggerName || '',
              timestamp: _timestamp,
              stacktrace: stacktrace
            });

            if (isJSON === undefined) {
              isJSON = typeof log !== 'string';
            }

            var content = '';

            if (isJSON) {
              try {
                content += JSON.stringify(log);
              } catch (error) {
                rawMethod.apply(void 0, args);
                loglevel.getLogger('logger').error(error);
                return;
              }
            } else {
              content += log;
            } // queue it for uploading when interval timer is fired.


            queue.push(content); // if (!isUploadConfigured) {
            //   // log upload is not ready yet, queue it for later process
            //   queue.push(content);
            // } else {
            //   if (queue.length()) {
            //     // drain the queue
            //     send();
            //   }
            //   uploadLog(content);
            // }
          } // output to console
          // const timestamp = new Date().toTimeString().replace(/.*(\d{2}:\d{2}:\d{2}).*/, '$1');


          var now = new Date();
          now.setTime(getCurrentTime());
          var timestamp = now.toTimeString().replace(/.*(\d{2}:\d{2}:\d{2}).*/, '$1');
          var consoleOutput = '[' + timestamp + '] <' + methodName.toUpperCase() + '> ' + message;
          rawMethod.apply(undefined, [consoleOutput]);
        };
      };

      logger.methodFactory = pluginFactory;
      logger.setLevel(logger.getLevel());
      return logger;
    },
    disable: function disable() {
      if (!loglevel) {
        throw new Error("You can't disable a not appled plugin");
      }

      if (pluginFactory !== loglevel.methodFactory) {
        throw new Error("You can't disable a plugin after appling another plugin");
      }

      loglevel.methodFactory = originalFactory;
      loglevel.setLevel(loglevel.getLevel());
      loglevel = undefined;
      clearInterval(uploadInterval);
    }
  };

  var uploadLogEnabled = false;

  logger.setConfig = function (config) {
    remote.setConfig(config);
  };

  logger.setLogLevel = function (level) {
    logger.info('TRTC LogLevel was set to: ' + level);
    logger.setLevel(level);
  };

  logger.enableUploadLog = function () {
    if (!uploadLogEnabled) {
      logger.info('enable upload log');
      remote.apply(logger);
      uploadLogEnabled = true;
    }
  };

  logger.disableUploadLog = function () {
    if (uploadLogEnabled) {
      logger.warn('disable upload log! Without log we are difficult to help you triage the issue you might run into!');
      remote.disable();
      uploadLogEnabled = false;
    }
  }; // enable log upload by default


  logger.enableUploadLog(); // default log level is 'INFO'

  logger.setLevel('INFO');

  var floor$2 = Math.floor;

  // `IsIntegralNumber` abstract operation
  // https://tc39.es/ecma262/#sec-isintegralnumber
  // eslint-disable-next-line es/no-number-isinteger -- safe
  var isIntegralNumber = Number.isInteger || function isInteger(it) {
    return !isObject(it) && isFinite(it) && floor$2(it) === it;
  };

  // `Number.isInteger` method
  // https://tc39.es/ecma262/#sec-number.isinteger
  _export({ target: 'Number', stat: true }, {
    isInteger: isIntegralNumber
  });

  // makes subclassing work correct for wrapped built-ins
  var inheritIfRequired = function ($this, dummy, Wrapper) {
    var NewTarget, NewTargetPrototype;
    if (
      // it can work only with native `setPrototypeOf`
      objectSetPrototypeOf &&
      // we haven't completely correct pre-ES6 way for getting `new.target`, so use this
      isCallable(NewTarget = dummy.constructor) &&
      NewTarget !== Wrapper &&
      isObject(NewTargetPrototype = NewTarget.prototype) &&
      NewTargetPrototype !== Wrapper.prototype
    ) objectSetPrototypeOf($this, NewTargetPrototype);
    return $this;
  };

  // `thisNumberValue` abstract operation
  // https://tc39.es/ecma262/#sec-thisnumbervalue
  var thisNumberValue = functionUncurryThis(1.0.valueOf);

  var getOwnPropertyNames = objectGetOwnPropertyNames.f;
  var getOwnPropertyDescriptor$3 = objectGetOwnPropertyDescriptor.f;
  var defineProperty$3 = objectDefineProperty.f;

  var trim$2 = stringTrim.trim;

  var NUMBER = 'Number';
  var NativeNumber = global_1[NUMBER];
  var NumberPrototype = NativeNumber.prototype;
  var TypeError$h = global_1.TypeError;
  var arraySlice$1 = functionUncurryThis(''.slice);
  var charCodeAt$1 = functionUncurryThis(''.charCodeAt);

  // `ToNumeric` abstract operation
  // https://tc39.es/ecma262/#sec-tonumeric
  var toNumeric = function (value) {
    var primValue = toPrimitive(value, 'number');
    return typeof primValue == 'bigint' ? primValue : toNumber(primValue);
  };

  // `ToNumber` abstract operation
  // https://tc39.es/ecma262/#sec-tonumber
  var toNumber = function (argument) {
    var it = toPrimitive(argument, 'number');
    var first, third, radix, maxCode, digits, length, index, code;
    if (isSymbol(it)) throw TypeError$h('Cannot convert a Symbol value to a number');
    if (typeof it == 'string' && it.length > 2) {
      it = trim$2(it);
      first = charCodeAt$1(it, 0);
      if (first === 43 || first === 45) {
        third = charCodeAt$1(it, 2);
        if (third === 88 || third === 120) return NaN; // Number('+0x1') should be NaN, old V8 fix
      } else if (first === 48) {
        switch (charCodeAt$1(it, 1)) {
          case 66: case 98: radix = 2; maxCode = 49; break; // fast equal of /^0b[01]+$/i
          case 79: case 111: radix = 8; maxCode = 55; break; // fast equal of /^0o[0-7]+$/i
          default: return +it;
        }
        digits = arraySlice$1(it, 2);
        length = digits.length;
        for (index = 0; index < length; index++) {
          code = charCodeAt$1(digits, index);
          // parseInt parses a string to a first unavailable symbol
          // but ToNumber should return NaN if a string contains unavailable symbols
          if (code < 48 || code > maxCode) return NaN;
        } return parseInt(digits, radix);
      }
    } return +it;
  };

  // `Number` constructor
  // https://tc39.es/ecma262/#sec-number-constructor
  if (isForced_1(NUMBER, !NativeNumber(' 0o1') || !NativeNumber('0b1') || NativeNumber('+0x1'))) {
    var NumberWrapper = function Number(value) {
      var n = arguments.length < 1 ? 0 : NativeNumber(toNumeric(value));
      var dummy = this;
      // check on 1..constructor(foo) case
      return objectIsPrototypeOf(NumberPrototype, dummy) && fails(function () { thisNumberValue(dummy); })
        ? inheritIfRequired(Object(n), dummy, NumberWrapper) : n;
    };
    for (var keys$1 = descriptors ? getOwnPropertyNames(NativeNumber) : (
      // ES3:
      'MAX_VALUE,MIN_VALUE,NaN,NEGATIVE_INFINITY,POSITIVE_INFINITY,' +
      // ES2015 (in case, if modules with ES2015 Number statics required before):
      'EPSILON,MAX_SAFE_INTEGER,MIN_SAFE_INTEGER,isFinite,isInteger,isNaN,isSafeInteger,parseFloat,parseInt,' +
      // ESNext
      'fromString,range'
    ).split(','), j = 0, key; keys$1.length > j; j++) {
      if (hasOwnProperty_1(NativeNumber, key = keys$1[j]) && !hasOwnProperty_1(NumberWrapper, key)) {
        defineProperty$3(NumberWrapper, key, getOwnPropertyDescriptor$3(NativeNumber, key));
      }
    }
    NumberWrapper.prototype = NumberPrototype;
    NumberPrototype.constructor = NumberWrapper;
    redefine(global_1, NUMBER, NumberWrapper);
  }

  var UNSCOPABLES = wellKnownSymbol('unscopables');
  var ArrayPrototype$1 = Array.prototype;

  // Array.prototype[@@unscopables]
  // https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
  if (ArrayPrototype$1[UNSCOPABLES] == undefined) {
    objectDefineProperty.f(ArrayPrototype$1, UNSCOPABLES, {
      configurable: true,
      value: objectCreate(null)
    });
  }

  // add a key to Array.prototype[@@unscopables]
  var addToUnscopables = function (key) {
    ArrayPrototype$1[UNSCOPABLES][key] = true;
  };

  var ITERATOR$4 = wellKnownSymbol('iterator');
  var BUGGY_SAFARI_ITERATORS = false;

  // `%IteratorPrototype%` object
  // https://tc39.es/ecma262/#sec-%iteratorprototype%-object
  var IteratorPrototype, PrototypeOfArrayIteratorPrototype, arrayIterator;

  /* eslint-disable es/no-array-prototype-keys -- safe */
  if ([].keys) {
    arrayIterator = [].keys();
    // Safari 8 has buggy iterators w/o `next`
    if (!('next' in arrayIterator)) BUGGY_SAFARI_ITERATORS = true;
    else {
      PrototypeOfArrayIteratorPrototype = objectGetPrototypeOf(objectGetPrototypeOf(arrayIterator));
      if (PrototypeOfArrayIteratorPrototype !== Object.prototype) IteratorPrototype = PrototypeOfArrayIteratorPrototype;
    }
  }

  var NEW_ITERATOR_PROTOTYPE = IteratorPrototype == undefined || fails(function () {
    var test = {};
    // FF44- legacy iterators case
    return IteratorPrototype[ITERATOR$4].call(test) !== test;
  });

  if (NEW_ITERATOR_PROTOTYPE) IteratorPrototype = {};

  // `%IteratorPrototype%[@@iterator]()` method
  // https://tc39.es/ecma262/#sec-%iteratorprototype%-@@iterator
  if (!isCallable(IteratorPrototype[ITERATOR$4])) {
    redefine(IteratorPrototype, ITERATOR$4, function () {
      return this;
    });
  }

  var iteratorsCore = {
    IteratorPrototype: IteratorPrototype,
    BUGGY_SAFARI_ITERATORS: BUGGY_SAFARI_ITERATORS
  };

  var IteratorPrototype$1 = iteratorsCore.IteratorPrototype;





  var returnThis = function () { return this; };

  var createIteratorConstructor = function (IteratorConstructor, NAME, next, ENUMERABLE_NEXT) {
    var TO_STRING_TAG = NAME + ' Iterator';
    IteratorConstructor.prototype = objectCreate(IteratorPrototype$1, { next: createPropertyDescriptor(+!ENUMERABLE_NEXT, next) });
    setToStringTag(IteratorConstructor, TO_STRING_TAG, false);
    iterators[TO_STRING_TAG] = returnThis;
    return IteratorConstructor;
  };

  var PROPER_FUNCTION_NAME$1 = functionName.PROPER;
  var CONFIGURABLE_FUNCTION_NAME = functionName.CONFIGURABLE;
  var IteratorPrototype$2 = iteratorsCore.IteratorPrototype;
  var BUGGY_SAFARI_ITERATORS$1 = iteratorsCore.BUGGY_SAFARI_ITERATORS;
  var ITERATOR$5 = wellKnownSymbol('iterator');
  var KEYS = 'keys';
  var VALUES = 'values';
  var ENTRIES = 'entries';

  var returnThis$1 = function () { return this; };

  var defineIterator = function (Iterable, NAME, IteratorConstructor, next, DEFAULT, IS_SET, FORCED) {
    createIteratorConstructor(IteratorConstructor, NAME, next);

    var getIterationMethod = function (KIND) {
      if (KIND === DEFAULT && defaultIterator) return defaultIterator;
      if (!BUGGY_SAFARI_ITERATORS$1 && KIND in IterablePrototype) return IterablePrototype[KIND];
      switch (KIND) {
        case KEYS: return function keys() { return new IteratorConstructor(this, KIND); };
        case VALUES: return function values() { return new IteratorConstructor(this, KIND); };
        case ENTRIES: return function entries() { return new IteratorConstructor(this, KIND); };
      } return function () { return new IteratorConstructor(this); };
    };

    var TO_STRING_TAG = NAME + ' Iterator';
    var INCORRECT_VALUES_NAME = false;
    var IterablePrototype = Iterable.prototype;
    var nativeIterator = IterablePrototype[ITERATOR$5]
      || IterablePrototype['@@iterator']
      || DEFAULT && IterablePrototype[DEFAULT];
    var defaultIterator = !BUGGY_SAFARI_ITERATORS$1 && nativeIterator || getIterationMethod(DEFAULT);
    var anyNativeIterator = NAME == 'Array' ? IterablePrototype.entries || nativeIterator : nativeIterator;
    var CurrentIteratorPrototype, methods, KEY;

    // fix native
    if (anyNativeIterator) {
      CurrentIteratorPrototype = objectGetPrototypeOf(anyNativeIterator.call(new Iterable()));
      if (CurrentIteratorPrototype !== Object.prototype && CurrentIteratorPrototype.next) {
        if ( objectGetPrototypeOf(CurrentIteratorPrototype) !== IteratorPrototype$2) {
          if (objectSetPrototypeOf) {
            objectSetPrototypeOf(CurrentIteratorPrototype, IteratorPrototype$2);
          } else if (!isCallable(CurrentIteratorPrototype[ITERATOR$5])) {
            redefine(CurrentIteratorPrototype, ITERATOR$5, returnThis$1);
          }
        }
        // Set @@toStringTag to native iterators
        setToStringTag(CurrentIteratorPrototype, TO_STRING_TAG, true);
      }
    }

    // fix Array.prototype.{ values, @@iterator }.name in V8 / FF
    if (PROPER_FUNCTION_NAME$1 && DEFAULT == VALUES && nativeIterator && nativeIterator.name !== VALUES) {
      if ( CONFIGURABLE_FUNCTION_NAME) {
        createNonEnumerableProperty(IterablePrototype, 'name', VALUES);
      } else {
        INCORRECT_VALUES_NAME = true;
        defaultIterator = function values() { return functionCall(nativeIterator, this); };
      }
    }

    // export additional methods
    if (DEFAULT) {
      methods = {
        values: getIterationMethod(VALUES),
        keys: IS_SET ? defaultIterator : getIterationMethod(KEYS),
        entries: getIterationMethod(ENTRIES)
      };
      if (FORCED) for (KEY in methods) {
        if (BUGGY_SAFARI_ITERATORS$1 || INCORRECT_VALUES_NAME || !(KEY in IterablePrototype)) {
          redefine(IterablePrototype, KEY, methods[KEY]);
        }
      } else _export({ target: NAME, proto: true, forced: BUGGY_SAFARI_ITERATORS$1 || INCORRECT_VALUES_NAME }, methods);
    }

    // define iterator
    if ( IterablePrototype[ITERATOR$5] !== defaultIterator) {
      redefine(IterablePrototype, ITERATOR$5, defaultIterator, { name: DEFAULT });
    }
    iterators[NAME] = defaultIterator;

    return methods;
  };

  var defineProperty$4 = objectDefineProperty.f;




  var ARRAY_ITERATOR = 'Array Iterator';
  var setInternalState$1 = internalState.set;
  var getInternalState$2 = internalState.getterFor(ARRAY_ITERATOR);

  // `Array.prototype.entries` method
  // https://tc39.es/ecma262/#sec-array.prototype.entries
  // `Array.prototype.keys` method
  // https://tc39.es/ecma262/#sec-array.prototype.keys
  // `Array.prototype.values` method
  // https://tc39.es/ecma262/#sec-array.prototype.values
  // `Array.prototype[@@iterator]` method
  // https://tc39.es/ecma262/#sec-array.prototype-@@iterator
  // `CreateArrayIterator` internal method
  // https://tc39.es/ecma262/#sec-createarrayiterator
  var es_array_iterator = defineIterator(Array, 'Array', function (iterated, kind) {
    setInternalState$1(this, {
      type: ARRAY_ITERATOR,
      target: toIndexedObject(iterated), // target
      index: 0,                          // next index
      kind: kind                         // kind
    });
  // `%ArrayIteratorPrototype%.next` method
  // https://tc39.es/ecma262/#sec-%arrayiteratorprototype%.next
  }, function () {
    var state = getInternalState$2(this);
    var target = state.target;
    var kind = state.kind;
    var index = state.index++;
    if (!target || index >= target.length) {
      state.target = undefined;
      return { value: undefined, done: true };
    }
    if (kind == 'keys') return { value: index, done: false };
    if (kind == 'values') return { value: target[index], done: false };
    return { value: [index, target[index]], done: false };
  }, 'values');

  // argumentsList[@@iterator] is %ArrayProto_values%
  // https://tc39.es/ecma262/#sec-createunmappedargumentsobject
  // https://tc39.es/ecma262/#sec-createmappedargumentsobject
  var values = iterators.Arguments = iterators.Array;

  // https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
  addToUnscopables('keys');
  addToUnscopables('values');
  addToUnscopables('entries');

  // V8 ~ Chrome 45- bug
  if ( descriptors && values.name !== 'values') try {
    defineProperty$4(values, 'name', { value: 'values' });
  } catch (error) { /* empty */ }

  /* eslint-disable es/no-object-getownpropertynames -- safe */


  var $getOwnPropertyNames = objectGetOwnPropertyNames.f;


  var windowNames = typeof window == 'object' && window && Object.getOwnPropertyNames
    ? Object.getOwnPropertyNames(window) : [];

  var getWindowNames = function (it) {
    try {
      return $getOwnPropertyNames(it);
    } catch (error) {
      return arraySliceSimple(windowNames);
    }
  };

  // fallback for IE11 buggy Object.getOwnPropertyNames with iframe and window
  var f$7 = function getOwnPropertyNames(it) {
    return windowNames && classofRaw(it) == 'Window'
      ? getWindowNames(it)
      : $getOwnPropertyNames(toIndexedObject(it));
  };

  var objectGetOwnPropertyNamesExternal = {
  	f: f$7
  };

  // FF26- bug: ArrayBuffers are non-extensible, but Object.isExtensible does not report it


  var arrayBufferNonExtensible = fails(function () {
    if (typeof ArrayBuffer == 'function') {
      var buffer = new ArrayBuffer(8);
      // eslint-disable-next-line es/no-object-isextensible, es/no-object-defineproperty -- safe
      if (Object.isExtensible(buffer)) Object.defineProperty(buffer, 'a', { value: 8 });
    }
  });

  // eslint-disable-next-line es/no-object-isextensible -- safe
  var $isExtensible = Object.isExtensible;
  var FAILS_ON_PRIMITIVES$2 = fails(function () { $isExtensible(1); });

  // `Object.isExtensible` method
  // https://tc39.es/ecma262/#sec-object.isextensible
  var objectIsExtensible = (FAILS_ON_PRIMITIVES$2 || arrayBufferNonExtensible) ? function isExtensible(it) {
    if (!isObject(it)) return false;
    if (arrayBufferNonExtensible && classofRaw(it) == 'ArrayBuffer') return false;
    return $isExtensible ? $isExtensible(it) : true;
  } : $isExtensible;

  var freezing = !fails(function () {
    // eslint-disable-next-line es/no-object-isextensible, es/no-object-preventextensions -- required for testing
    return Object.isExtensible(Object.preventExtensions({}));
  });

  var internalMetadata = createCommonjsModule(function (module) {
  var defineProperty = objectDefineProperty.f;






  var REQUIRED = false;
  var METADATA = uid('meta');
  var id = 0;

  var setMetadata = function (it) {
    defineProperty(it, METADATA, { value: {
      objectID: 'O' + id++, // object ID
      weakData: {}          // weak collections IDs
    } });
  };

  var fastKey = function (it, create) {
    // return a primitive with prefix
    if (!isObject(it)) return typeof it == 'symbol' ? it : (typeof it == 'string' ? 'S' : 'P') + it;
    if (!hasOwnProperty_1(it, METADATA)) {
      // can't set metadata to uncaught frozen object
      if (!objectIsExtensible(it)) return 'F';
      // not necessary to add metadata
      if (!create) return 'E';
      // add missing metadata
      setMetadata(it);
    // return object ID
    } return it[METADATA].objectID;
  };

  var getWeakData = function (it, create) {
    if (!hasOwnProperty_1(it, METADATA)) {
      // can't set metadata to uncaught frozen object
      if (!objectIsExtensible(it)) return true;
      // not necessary to add metadata
      if (!create) return false;
      // add missing metadata
      setMetadata(it);
    // return the store of weak collections IDs
    } return it[METADATA].weakData;
  };

  // add metadata on freeze-family methods calling
  var onFreeze = function (it) {
    if (freezing && REQUIRED && objectIsExtensible(it) && !hasOwnProperty_1(it, METADATA)) setMetadata(it);
    return it;
  };

  var enable = function () {
    meta.enable = function () { /* empty */ };
    REQUIRED = true;
    var getOwnPropertyNames = objectGetOwnPropertyNames.f;
    var splice = functionUncurryThis([].splice);
    var test = {};
    test[METADATA] = 1;

    // prevent exposing of metadata key
    if (getOwnPropertyNames(test).length) {
      objectGetOwnPropertyNames.f = function (it) {
        var result = getOwnPropertyNames(it);
        for (var i = 0, length = result.length; i < length; i++) {
          if (result[i] === METADATA) {
            splice(result, i, 1);
            break;
          }
        } return result;
      };

      _export({ target: 'Object', stat: true, forced: true }, {
        getOwnPropertyNames: objectGetOwnPropertyNamesExternal.f
      });
    }
  };

  var meta = module.exports = {
    enable: enable,
    fastKey: fastKey,
    getWeakData: getWeakData,
    onFreeze: onFreeze
  };

  hiddenKeys[METADATA] = true;
  });
  var internalMetadata_1 = internalMetadata.enable;
  var internalMetadata_2 = internalMetadata.fastKey;
  var internalMetadata_3 = internalMetadata.getWeakData;
  var internalMetadata_4 = internalMetadata.onFreeze;

  var collection = function (CONSTRUCTOR_NAME, wrapper, common) {
    var IS_MAP = CONSTRUCTOR_NAME.indexOf('Map') !== -1;
    var IS_WEAK = CONSTRUCTOR_NAME.indexOf('Weak') !== -1;
    var ADDER = IS_MAP ? 'set' : 'add';
    var NativeConstructor = global_1[CONSTRUCTOR_NAME];
    var NativePrototype = NativeConstructor && NativeConstructor.prototype;
    var Constructor = NativeConstructor;
    var exported = {};

    var fixMethod = function (KEY) {
      var uncurriedNativeMethod = functionUncurryThis(NativePrototype[KEY]);
      redefine(NativePrototype, KEY,
        KEY == 'add' ? function add(value) {
          uncurriedNativeMethod(this, value === 0 ? 0 : value);
          return this;
        } : KEY == 'delete' ? function (key) {
          return IS_WEAK && !isObject(key) ? false : uncurriedNativeMethod(this, key === 0 ? 0 : key);
        } : KEY == 'get' ? function get(key) {
          return IS_WEAK && !isObject(key) ? undefined : uncurriedNativeMethod(this, key === 0 ? 0 : key);
        } : KEY == 'has' ? function has(key) {
          return IS_WEAK && !isObject(key) ? false : uncurriedNativeMethod(this, key === 0 ? 0 : key);
        } : function set(key, value) {
          uncurriedNativeMethod(this, key === 0 ? 0 : key, value);
          return this;
        }
      );
    };

    var REPLACE = isForced_1(
      CONSTRUCTOR_NAME,
      !isCallable(NativeConstructor) || !(IS_WEAK || NativePrototype.forEach && !fails(function () {
        new NativeConstructor().entries().next();
      }))
    );

    if (REPLACE) {
      // create collection constructor
      Constructor = common.getConstructor(wrapper, CONSTRUCTOR_NAME, IS_MAP, ADDER);
      internalMetadata.enable();
    } else if (isForced_1(CONSTRUCTOR_NAME, true)) {
      var instance = new Constructor();
      // early implementations not supports chaining
      var HASNT_CHAINING = instance[ADDER](IS_WEAK ? {} : -0, 1) != instance;
      // V8 ~ Chromium 40- weak-collections throws on primitives, but should return false
      var THROWS_ON_PRIMITIVES = fails(function () { instance.has(1); });
      // most early implementations doesn't supports iterables, most modern - not close it correctly
      // eslint-disable-next-line no-new -- required for testing
      var ACCEPT_ITERABLES = checkCorrectnessOfIteration(function (iterable) { new NativeConstructor(iterable); });
      // for early implementations -0 and +0 not the same
      var BUGGY_ZERO = !IS_WEAK && fails(function () {
        // V8 ~ Chromium 42- fails only with 5+ elements
        var $instance = new NativeConstructor();
        var index = 5;
        while (index--) $instance[ADDER](index, index);
        return !$instance.has(-0);
      });

      if (!ACCEPT_ITERABLES) {
        Constructor = wrapper(function (dummy, iterable) {
          anInstance(dummy, NativePrototype);
          var that = inheritIfRequired(new NativeConstructor(), dummy, Constructor);
          if (iterable != undefined) iterate(iterable, that[ADDER], { that: that, AS_ENTRIES: IS_MAP });
          return that;
        });
        Constructor.prototype = NativePrototype;
        NativePrototype.constructor = Constructor;
      }

      if (THROWS_ON_PRIMITIVES || BUGGY_ZERO) {
        fixMethod('delete');
        fixMethod('has');
        IS_MAP && fixMethod('get');
      }

      if (BUGGY_ZERO || HASNT_CHAINING) fixMethod(ADDER);

      // weak collections should not contains .clear method
      if (IS_WEAK && NativePrototype.clear) delete NativePrototype.clear;
    }

    exported[CONSTRUCTOR_NAME] = Constructor;
    _export({ global: true, forced: Constructor != NativeConstructor }, exported);

    setToStringTag(Constructor, CONSTRUCTOR_NAME);

    if (!IS_WEAK) common.setStrong(Constructor, CONSTRUCTOR_NAME, IS_MAP);

    return Constructor;
  };

  var defineProperty$5 = objectDefineProperty.f;








  var fastKey = internalMetadata.fastKey;


  var setInternalState$2 = internalState.set;
  var internalStateGetterFor = internalState.getterFor;

  var collectionStrong = {
    getConstructor: function (wrapper, CONSTRUCTOR_NAME, IS_MAP, ADDER) {
      var Constructor = wrapper(function (that, iterable) {
        anInstance(that, Prototype);
        setInternalState$2(that, {
          type: CONSTRUCTOR_NAME,
          index: objectCreate(null),
          first: undefined,
          last: undefined,
          size: 0
        });
        if (!descriptors) that.size = 0;
        if (iterable != undefined) iterate(iterable, that[ADDER], { that: that, AS_ENTRIES: IS_MAP });
      });

      var Prototype = Constructor.prototype;

      var getInternalState = internalStateGetterFor(CONSTRUCTOR_NAME);

      var define = function (that, key, value) {
        var state = getInternalState(that);
        var entry = getEntry(that, key);
        var previous, index;
        // change existing entry
        if (entry) {
          entry.value = value;
        // create new entry
        } else {
          state.last = entry = {
            index: index = fastKey(key, true),
            key: key,
            value: value,
            previous: previous = state.last,
            next: undefined,
            removed: false
          };
          if (!state.first) state.first = entry;
          if (previous) previous.next = entry;
          if (descriptors) state.size++;
          else that.size++;
          // add to index
          if (index !== 'F') state.index[index] = entry;
        } return that;
      };

      var getEntry = function (that, key) {
        var state = getInternalState(that);
        // fast case
        var index = fastKey(key);
        var entry;
        if (index !== 'F') return state.index[index];
        // frozen object case
        for (entry = state.first; entry; entry = entry.next) {
          if (entry.key == key) return entry;
        }
      };

      redefineAll(Prototype, {
        // `{ Map, Set }.prototype.clear()` methods
        // https://tc39.es/ecma262/#sec-map.prototype.clear
        // https://tc39.es/ecma262/#sec-set.prototype.clear
        clear: function clear() {
          var that = this;
          var state = getInternalState(that);
          var data = state.index;
          var entry = state.first;
          while (entry) {
            entry.removed = true;
            if (entry.previous) entry.previous = entry.previous.next = undefined;
            delete data[entry.index];
            entry = entry.next;
          }
          state.first = state.last = undefined;
          if (descriptors) state.size = 0;
          else that.size = 0;
        },
        // `{ Map, Set }.prototype.delete(key)` methods
        // https://tc39.es/ecma262/#sec-map.prototype.delete
        // https://tc39.es/ecma262/#sec-set.prototype.delete
        'delete': function (key) {
          var that = this;
          var state = getInternalState(that);
          var entry = getEntry(that, key);
          if (entry) {
            var next = entry.next;
            var prev = entry.previous;
            delete state.index[entry.index];
            entry.removed = true;
            if (prev) prev.next = next;
            if (next) next.previous = prev;
            if (state.first == entry) state.first = next;
            if (state.last == entry) state.last = prev;
            if (descriptors) state.size--;
            else that.size--;
          } return !!entry;
        },
        // `{ Map, Set }.prototype.forEach(callbackfn, thisArg = undefined)` methods
        // https://tc39.es/ecma262/#sec-map.prototype.foreach
        // https://tc39.es/ecma262/#sec-set.prototype.foreach
        forEach: function forEach(callbackfn /* , that = undefined */) {
          var state = getInternalState(this);
          var boundFunction = functionBindContext(callbackfn, arguments.length > 1 ? arguments[1] : undefined);
          var entry;
          while (entry = entry ? entry.next : state.first) {
            boundFunction(entry.value, entry.key, this);
            // revert to the last existing entry
            while (entry && entry.removed) entry = entry.previous;
          }
        },
        // `{ Map, Set}.prototype.has(key)` methods
        // https://tc39.es/ecma262/#sec-map.prototype.has
        // https://tc39.es/ecma262/#sec-set.prototype.has
        has: function has(key) {
          return !!getEntry(this, key);
        }
      });

      redefineAll(Prototype, IS_MAP ? {
        // `Map.prototype.get(key)` method
        // https://tc39.es/ecma262/#sec-map.prototype.get
        get: function get(key) {
          var entry = getEntry(this, key);
          return entry && entry.value;
        },
        // `Map.prototype.set(key, value)` method
        // https://tc39.es/ecma262/#sec-map.prototype.set
        set: function set(key, value) {
          return define(this, key === 0 ? 0 : key, value);
        }
      } : {
        // `Set.prototype.add(value)` method
        // https://tc39.es/ecma262/#sec-set.prototype.add
        add: function add(value) {
          return define(this, value = value === 0 ? 0 : value, value);
        }
      });
      if (descriptors) defineProperty$5(Prototype, 'size', {
        get: function () {
          return getInternalState(this).size;
        }
      });
      return Constructor;
    },
    setStrong: function (Constructor, CONSTRUCTOR_NAME, IS_MAP) {
      var ITERATOR_NAME = CONSTRUCTOR_NAME + ' Iterator';
      var getInternalCollectionState = internalStateGetterFor(CONSTRUCTOR_NAME);
      var getInternalIteratorState = internalStateGetterFor(ITERATOR_NAME);
      // `{ Map, Set }.prototype.{ keys, values, entries, @@iterator }()` methods
      // https://tc39.es/ecma262/#sec-map.prototype.entries
      // https://tc39.es/ecma262/#sec-map.prototype.keys
      // https://tc39.es/ecma262/#sec-map.prototype.values
      // https://tc39.es/ecma262/#sec-map.prototype-@@iterator
      // https://tc39.es/ecma262/#sec-set.prototype.entries
      // https://tc39.es/ecma262/#sec-set.prototype.keys
      // https://tc39.es/ecma262/#sec-set.prototype.values
      // https://tc39.es/ecma262/#sec-set.prototype-@@iterator
      defineIterator(Constructor, CONSTRUCTOR_NAME, function (iterated, kind) {
        setInternalState$2(this, {
          type: ITERATOR_NAME,
          target: iterated,
          state: getInternalCollectionState(iterated),
          kind: kind,
          last: undefined
        });
      }, function () {
        var state = getInternalIteratorState(this);
        var kind = state.kind;
        var entry = state.last;
        // revert to the last existing entry
        while (entry && entry.removed) entry = entry.previous;
        // get next entry
        if (!state.target || !(state.last = entry = entry ? entry.next : state.state.first)) {
          // or finish the iteration
          state.target = undefined;
          return { value: undefined, done: true };
        }
        // return step by kind
        if (kind == 'keys') return { value: entry.key, done: false };
        if (kind == 'values') return { value: entry.value, done: false };
        return { value: [entry.key, entry.value], done: false };
      }, IS_MAP ? 'entries' : 'values', !IS_MAP, true);

      // `{ Map, Set }.prototype[@@species]` accessors
      // https://tc39.es/ecma262/#sec-get-map-@@species
      // https://tc39.es/ecma262/#sec-get-set-@@species
      setSpecies(CONSTRUCTOR_NAME);
    }
  };

  // `Map` constructor
  // https://tc39.es/ecma262/#sec-map-objects
  collection('Map', function (init) {
    return function Map() { return init(this, arguments.length ? arguments[0] : undefined); };
  }, collectionStrong);

  var charAt$4 = stringMultibyte.charAt;




  var STRING_ITERATOR = 'String Iterator';
  var setInternalState$3 = internalState.set;
  var getInternalState$3 = internalState.getterFor(STRING_ITERATOR);

  // `String.prototype[@@iterator]` method
  // https://tc39.es/ecma262/#sec-string.prototype-@@iterator
  defineIterator(String, 'String', function (iterated) {
    setInternalState$3(this, {
      type: STRING_ITERATOR,
      string: toString_1(iterated),
      index: 0
    });
  // `%StringIteratorPrototype%.next` method
  // https://tc39.es/ecma262/#sec-%stringiteratorprototype%.next
  }, function next() {
    var state = getInternalState$3(this);
    var string = state.string;
    var index = state.index;
    var point;
    if (index >= string.length) return { value: undefined, done: true };
    point = charAt$4(string, index);
    state.index += point.length;
    return { value: point, done: false };
  });

  var ITERATOR$6 = wellKnownSymbol('iterator');
  var TO_STRING_TAG$3 = wellKnownSymbol('toStringTag');
  var ArrayValues = es_array_iterator.values;

  var handlePrototype$1 = function (CollectionPrototype, COLLECTION_NAME) {
    if (CollectionPrototype) {
      // some Chrome versions have non-configurable methods on DOMTokenList
      if (CollectionPrototype[ITERATOR$6] !== ArrayValues) try {
        createNonEnumerableProperty(CollectionPrototype, ITERATOR$6, ArrayValues);
      } catch (error) {
        CollectionPrototype[ITERATOR$6] = ArrayValues;
      }
      if (!CollectionPrototype[TO_STRING_TAG$3]) {
        createNonEnumerableProperty(CollectionPrototype, TO_STRING_TAG$3, COLLECTION_NAME);
      }
      if (domIterables[COLLECTION_NAME]) for (var METHOD_NAME in es_array_iterator) {
        // some Chrome versions have non-configurable methods on DOMTokenList
        if (CollectionPrototype[METHOD_NAME] !== es_array_iterator[METHOD_NAME]) try {
          createNonEnumerableProperty(CollectionPrototype, METHOD_NAME, es_array_iterator[METHOD_NAME]);
        } catch (error) {
          CollectionPrototype[METHOD_NAME] = es_array_iterator[METHOD_NAME];
        }
      }
    }
  };

  for (var COLLECTION_NAME$1 in domIterables) {
    handlePrototype$1(global_1[COLLECTION_NAME$1] && global_1[COLLECTION_NAME$1].prototype, COLLECTION_NAME$1);
  }

  handlePrototype$1(domTokenListPrototype, 'DOMTokenList');

  var TypeError$i = global_1.TypeError;

  var notARegexp = function (it) {
    if (isRegexp(it)) {
      throw TypeError$i("The method doesn't accept regular expressions");
    } return it;
  };

  var MATCH$1 = wellKnownSymbol('match');

  var correctIsRegexpLogic = function (METHOD_NAME) {
    var regexp = /./;
    try {
      '/./'[METHOD_NAME](regexp);
    } catch (error1) {
      try {
        regexp[MATCH$1] = false;
        return '/./'[METHOD_NAME](regexp);
      } catch (error2) { /* empty */ }
    } return false;
  };

  var getOwnPropertyDescriptor$4 = objectGetOwnPropertyDescriptor.f;







  // eslint-disable-next-line es/no-string-prototype-startswith -- safe
  var un$StartsWith = functionUncurryThis(''.startsWith);
  var stringSlice$7 = functionUncurryThis(''.slice);
  var min$5 = Math.min;

  var CORRECT_IS_REGEXP_LOGIC = correctIsRegexpLogic('startsWith');
  // https://github.com/zloirock/core-js/pull/702
  var MDN_POLYFILL_BUG =  !CORRECT_IS_REGEXP_LOGIC && !!function () {
    var descriptor = getOwnPropertyDescriptor$4(String.prototype, 'startsWith');
    return descriptor && !descriptor.writable;
  }();

  // `String.prototype.startsWith` method
  // https://tc39.es/ecma262/#sec-string.prototype.startswith
  _export({ target: 'String', proto: true, forced: !MDN_POLYFILL_BUG && !CORRECT_IS_REGEXP_LOGIC }, {
    startsWith: function startsWith(searchString /* , position = 0 */) {
      var that = toString_1(requireObjectCoercible(this));
      notARegexp(searchString);
      var index = toLength(min$5(arguments.length > 1 ? arguments[1] : undefined, that.length));
      var search = toString_1(searchString);
      return un$StartsWith
        ? un$StartsWith(that, search, index)
        : stringSlice$7(that, index, index + search.length) === search;
    }
  });

  var $propertyIsEnumerable$1 = objectPropertyIsEnumerable.f;

  var propertyIsEnumerable = functionUncurryThis($propertyIsEnumerable$1);
  var push$4 = functionUncurryThis([].push);

  // `Object.{ entries, values }` methods implementation
  var createMethod$5 = function (TO_ENTRIES) {
    return function (it) {
      var O = toIndexedObject(it);
      var keys = objectKeys(O);
      var length = keys.length;
      var i = 0;
      var result = [];
      var key;
      while (length > i) {
        key = keys[i++];
        if (!descriptors || propertyIsEnumerable(O, key)) {
          push$4(result, TO_ENTRIES ? [key, O[key]] : O[key]);
        }
      }
      return result;
    };
  };

  var objectToArray = {
    // `Object.entries` method
    // https://tc39.es/ecma262/#sec-object.entries
    entries: createMethod$5(true),
    // `Object.values` method
    // https://tc39.es/ecma262/#sec-object.values
    values: createMethod$5(false)
  };

  var $values = objectToArray.values;

  // `Object.values` method
  // https://tc39.es/ecma262/#sec-object.values
  _export({ target: 'Object', stat: true }, {
    values: function values(O) {
      return $values(O);
    }
  });

  var FAILS_ON_PRIMITIVES$3 = fails(function () { objectKeys(1); });

  // `Object.keys` method
  // https://tc39.es/ecma262/#sec-object.keys
  _export({ target: 'Object', stat: true, forced: FAILS_ON_PRIMITIVES$3 }, {
    keys: function keys(it) {
      return objectKeys(toObject(it));
    }
  });

  // @@match logic
  fixRegexpWellKnownSymbolLogic('match', function (MATCH, nativeMatch, maybeCallNative) {
    return [
      // `String.prototype.match` method
      // https://tc39.es/ecma262/#sec-string.prototype.match
      function match(regexp) {
        var O = requireObjectCoercible(this);
        var matcher = regexp == undefined ? undefined : getMethod(regexp, MATCH);
        return matcher ? functionCall(matcher, regexp, O) : new RegExp(regexp)[MATCH](toString_1(O));
      },
      // `RegExp.prototype[@@match]` method
      // https://tc39.es/ecma262/#sec-regexp.prototype-@@match
      function (string) {
        var rx = anObject(this);
        var S = toString_1(string);
        var res = maybeCallNative(nativeMatch, rx, S);

        if (res.done) return res.value;

        if (!rx.global) return regexpExecAbstract(rx, S);

        var fullUnicode = rx.unicode;
        rx.lastIndex = 0;
        var A = [];
        var n = 0;
        var result;
        while ((result = regexpExecAbstract(rx, S)) !== null) {
          var matchStr = toString_1(result[0]);
          A[n] = matchStr;
          if (matchStr === '') rx.lastIndex = advanceStringIndex(S, toLength(rx.lastIndex), fullUnicode);
          n++;
        }
        return n === 0 ? null : A;
      }
    ];
  });

  // `SameValue` abstract operation
  // https://tc39.es/ecma262/#sec-samevalue
  // eslint-disable-next-line es/no-object-is -- safe
  var sameValue = Object.is || function is(x, y) {
    // eslint-disable-next-line no-self-compare -- NaN check
    return x === y ? x !== 0 || 1 / x === 1 / y : x != x && y != y;
  };

  // @@search logic
  fixRegexpWellKnownSymbolLogic('search', function (SEARCH, nativeSearch, maybeCallNative) {
    return [
      // `String.prototype.search` method
      // https://tc39.es/ecma262/#sec-string.prototype.search
      function search(regexp) {
        var O = requireObjectCoercible(this);
        var searcher = regexp == undefined ? undefined : getMethod(regexp, SEARCH);
        return searcher ? functionCall(searcher, regexp, O) : new RegExp(regexp)[SEARCH](toString_1(O));
      },
      // `RegExp.prototype[@@search]` method
      // https://tc39.es/ecma262/#sec-regexp.prototype-@@search
      function (string) {
        var rx = anObject(this);
        var S = toString_1(string);
        var res = maybeCallNative(nativeSearch, rx, S);

        if (res.done) return res.value;

        var previousLastIndex = rx.lastIndex;
        if (!sameValue(previousLastIndex, 0)) rx.lastIndex = 0;
        var result = regexpExecAbstract(rx, S);
        if (!sameValue(rx.lastIndex, previousLastIndex)) rx.lastIndex = previousLastIndex;
        return result === null ? -1 : result.index;
      }
    ];
  });

  var defineProperty$6 = objectDefineProperty.f;
  var getOwnPropertyNames$1 = objectGetOwnPropertyNames.f;








  var enforceInternalState = internalState.enforce;





  var MATCH$2 = wellKnownSymbol('match');
  var NativeRegExp = global_1.RegExp;
  var RegExpPrototype$2 = NativeRegExp.prototype;
  var SyntaxError = global_1.SyntaxError;
  var getFlags$1 = functionUncurryThis(regexpFlags);
  var exec$3 = functionUncurryThis(RegExpPrototype$2.exec);
  var charAt$5 = functionUncurryThis(''.charAt);
  var replace$3 = functionUncurryThis(''.replace);
  var stringIndexOf$1 = functionUncurryThis(''.indexOf);
  var stringSlice$8 = functionUncurryThis(''.slice);
  // TODO: Use only propper RegExpIdentifierName
  var IS_NCG = /^\?<[^\s\d!#%&*+<=>@^][^\s!#%&*+<=>@^]*>/;
  var re1 = /a/g;
  var re2 = /a/g;

  // "new" should create a new object, old webkit bug
  var CORRECT_NEW = new NativeRegExp(re1) !== re1;

  var MISSED_STICKY$1 = regexpStickyHelpers.MISSED_STICKY;
  var UNSUPPORTED_Y$3 = regexpStickyHelpers.UNSUPPORTED_Y;

  var BASE_FORCED = descriptors &&
    (!CORRECT_NEW || MISSED_STICKY$1 || regexpUnsupportedDotAll || regexpUnsupportedNcg || fails(function () {
      re2[MATCH$2] = false;
      // RegExp constructor can alter flags and IsRegExp works correct with @@match
      return NativeRegExp(re1) != re1 || NativeRegExp(re2) == re2 || NativeRegExp(re1, 'i') != '/a/i';
    }));

  var handleDotAll = function (string) {
    var length = string.length;
    var index = 0;
    var result = '';
    var brackets = false;
    var chr;
    for (; index <= length; index++) {
      chr = charAt$5(string, index);
      if (chr === '\\') {
        result += chr + charAt$5(string, ++index);
        continue;
      }
      if (!brackets && chr === '.') {
        result += '[\\s\\S]';
      } else {
        if (chr === '[') {
          brackets = true;
        } else if (chr === ']') {
          brackets = false;
        } result += chr;
      }
    } return result;
  };

  var handleNCG = function (string) {
    var length = string.length;
    var index = 0;
    var result = '';
    var named = [];
    var names = {};
    var brackets = false;
    var ncg = false;
    var groupid = 0;
    var groupname = '';
    var chr;
    for (; index <= length; index++) {
      chr = charAt$5(string, index);
      if (chr === '\\') {
        chr = chr + charAt$5(string, ++index);
      } else if (chr === ']') {
        brackets = false;
      } else if (!brackets) switch (true) {
        case chr === '[':
          brackets = true;
          break;
        case chr === '(':
          if (exec$3(IS_NCG, stringSlice$8(string, index + 1))) {
            index += 2;
            ncg = true;
          }
          result += chr;
          groupid++;
          continue;
        case chr === '>' && ncg:
          if (groupname === '' || hasOwnProperty_1(names, groupname)) {
            throw new SyntaxError('Invalid capture group name');
          }
          names[groupname] = true;
          named[named.length] = [groupname, groupid];
          ncg = false;
          groupname = '';
          continue;
      }
      if (ncg) groupname += chr;
      else result += chr;
    } return [result, named];
  };

  // `RegExp` constructor
  // https://tc39.es/ecma262/#sec-regexp-constructor
  if (isForced_1('RegExp', BASE_FORCED)) {
    var RegExpWrapper = function RegExp(pattern, flags) {
      var thisIsRegExp = objectIsPrototypeOf(RegExpPrototype$2, this);
      var patternIsRegExp = isRegexp(pattern);
      var flagsAreUndefined = flags === undefined;
      var groups = [];
      var rawPattern = pattern;
      var rawFlags, dotAll, sticky, handled, result, state;

      if (!thisIsRegExp && patternIsRegExp && flagsAreUndefined && pattern.constructor === RegExpWrapper) {
        return pattern;
      }

      if (patternIsRegExp || objectIsPrototypeOf(RegExpPrototype$2, pattern)) {
        pattern = pattern.source;
        if (flagsAreUndefined) flags = 'flags' in rawPattern ? rawPattern.flags : getFlags$1(rawPattern);
      }

      pattern = pattern === undefined ? '' : toString_1(pattern);
      flags = flags === undefined ? '' : toString_1(flags);
      rawPattern = pattern;

      if (regexpUnsupportedDotAll && 'dotAll' in re1) {
        dotAll = !!flags && stringIndexOf$1(flags, 's') > -1;
        if (dotAll) flags = replace$3(flags, /s/g, '');
      }

      rawFlags = flags;

      if (MISSED_STICKY$1 && 'sticky' in re1) {
        sticky = !!flags && stringIndexOf$1(flags, 'y') > -1;
        if (sticky && UNSUPPORTED_Y$3) flags = replace$3(flags, /y/g, '');
      }

      if (regexpUnsupportedNcg) {
        handled = handleNCG(pattern);
        pattern = handled[0];
        groups = handled[1];
      }

      result = inheritIfRequired(NativeRegExp(pattern, flags), thisIsRegExp ? this : RegExpPrototype$2, RegExpWrapper);

      if (dotAll || sticky || groups.length) {
        state = enforceInternalState(result);
        if (dotAll) {
          state.dotAll = true;
          state.raw = RegExpWrapper(handleDotAll(pattern), rawFlags);
        }
        if (sticky) state.sticky = true;
        if (groups.length) state.groups = groups;
      }

      if (pattern !== rawPattern) try {
        // fails in old engines, but we have no alternatives for unsupported regex syntax
        createNonEnumerableProperty(result, 'source', rawPattern === '' ? '(?:)' : rawPattern);
      } catch (error) { /* empty */ }

      return result;
    };

    var proxy = function (key) {
      key in RegExpWrapper || defineProperty$6(RegExpWrapper, key, {
        configurable: true,
        get: function () { return NativeRegExp[key]; },
        set: function (it) { NativeRegExp[key] = it; }
      });
    };

    for (var keys$2 = getOwnPropertyNames$1(NativeRegExp), index = 0; keys$2.length > index;) {
      proxy(keys$2[index++]);
    }

    RegExpPrototype$2.constructor = RegExpWrapper;
    RegExpWrapper.prototype = RegExpPrototype$2;
    redefine(global_1, 'RegExp', RegExpWrapper);
  }

  // https://tc39.es/ecma262/#sec-get-regexp-@@species
  setSpecies('RegExp');

  var trim$3 = stringTrim.trim;


  var charAt$6 = functionUncurryThis(''.charAt);
  var n$ParseFloat = global_1.parseFloat;
  var Symbol$3 = global_1.Symbol;
  var ITERATOR$7 = Symbol$3 && Symbol$3.iterator;
  var FORCED$4 = 1 / n$ParseFloat(whitespaces + '-0') !== -Infinity
    // MS Edge 18- broken with boxed symbols
    || (ITERATOR$7 && !fails(function () { n$ParseFloat(Object(ITERATOR$7)); }));

  // `parseFloat` method
  // https://tc39.es/ecma262/#sec-parsefloat-string
  var numberParseFloat = FORCED$4 ? function parseFloat(string) {
    var trimmedString = trim$3(toString_1(string));
    var result = n$ParseFloat(trimmedString);
    return result === 0 && charAt$6(trimmedString, 0) == '-' ? -0 : result;
  } : n$ParseFloat;

  // `parseFloat` method
  // https://tc39.es/ecma262/#sec-parsefloat-string
  _export({ global: true, forced: parseFloat != numberParseFloat }, {
    parseFloat: numberParseFloat
  });

  var USER_AGENT = window.navigator && window.navigator.userAgent || '';
  var webkitVersionMap = /AppleWebKit\/([\d.]+)/i.exec(USER_AGENT);
  var appleWebkitVersion = webkitVersionMap ? parseFloat(webkitVersionMap.pop()) : null;
  /*
   * Device is an iPhone
   *
   * @type {Boolean}
   * @constant
   * @private
   */

  var IS_IPAD = /iPad/i.test(USER_AGENT); // The Facebook app's UIWebView identifies as both an iPhone and iPad, so
  // to identify iPhones, we need to exclude iPads.
  // http://artsy.github.io/blog/2012/10/18/the-perils-of-ios-user-agent-sniffing/

  var IS_IPHONE = /iPhone/i.test(USER_AGENT) && !IS_IPAD;
  var IS_IPOD = /iPod/i.test(USER_AGENT);
  var IS_IOS = IS_IPHONE || IS_IPAD || IS_IPOD;
  var IOS_VERSION = function () {
    var match = USER_AGENT.match(/OS (\d+)_/i);

    if (match && match[1]) {
      return match[1];
    }

    return null;
  }();
  var IS_ANDROID = /Android/i.test(USER_AGENT);
  var ANDROID_VERSION = function () {
    // This matches Android Major.Minor.Patch versions
    // ANDROID_VERSION is Major.Minor as a Number, if Minor isn't available, then only Major is returned
    var match = USER_AGENT.match(/Android (\d+)(?:\.(\d+))?(?:\.(\d+))*/i);

    if (!match) {
      return null;
    }

    var major = match[1] && parseFloat(match[1]);
    var minor = match[2] && parseFloat(match[2]);

    if (major && minor) {
      return parseFloat(match[1] + '.' + match[2]);
    } else if (major) {
      return major;
    }

    return null;
  }(); // Old Android is defined as Version older than 2.3, and requiring a webkit version of the android browser

  var IS_OLD_ANDROID = IS_ANDROID && /webkit/i.test(USER_AGENT) && ANDROID_VERSION < 2.3;
  var IS_FIREFOX = /Firefox/i.test(USER_AGENT);
  var IS_EDGE = /Edge/i.test(USER_AGENT);
  var IS_CHROME = !IS_EDGE && /Chrome/i.test(USER_AGENT);
  var CHROME_MAJOR_VERSION = function () {
    var match = USER_AGENT.match(/Chrome\/(\d+)/);

    if (match && match[1]) {
      return parseFloat(match[1]);
    }

    return null;
  }();
  var CHROME_VERSION = function () {
    var match = USER_AGENT.match(/Chrome\/([\d.]+)/);
    if (match && match[1]) return match[1];
    return null;
  }(); // IE

  var IS_IE8 = /MSIE\s8\.0/.test(USER_AGENT);
  var IE_VERSION = function () {
    var result = /MSIE\s(\d+)\.\d/.exec(USER_AGENT);
    var version = result && parseFloat(result[1]);

    if (!version && /Trident\/7.0/i.test(USER_AGENT) && /rv:11.0/.test(USER_AGENT)) {
      // IE 11 has a different user agent string than other IE versions
      version = 11.0;
    }

    return version;
  }(); // Safari

  var IS_SAFARI = /Safari/i.test(USER_AGENT) && !IS_CHROME && !IS_ANDROID && !IS_EDGE;
  var IS_ANY_SAFARI = IS_SAFARI || IS_IOS;
  var SAFARI_VERSION = function () {
    var match = USER_AGENT.match(/Version\/([\d.]+)/);
    if (match && match[1]) return match[1];
    return null;
  }();
  var IS_TBS = /TBS\/\d+/i.test(USER_AGENT); // 仅X5内核，QQ浏览器默认x5内核，但是agent没有TBS

  var TBS_VERSION = function () {
    var match = USER_AGENT.match(/TBS\/(\d+)/i);

    if (match && match[1]) {
      return match[1];
    }
  }(); // X5内核版本

  var IS_MQQB = !IS_TBS && /MQQBrowser\/\d+/i.test(USER_AGENT); // 移动端QQ浏览器

  var IS_QQB = !IS_TBS && / QQBrowser\/\d+/i.test(USER_AGENT); // pc端QQ浏览器

  var IS_WECHAT = /(micromessenger|webbrowser)/i.test(USER_AGENT);
  var IS_WIN = /Windows/i.test(USER_AGENT); // window系统

  var IS_MAC = /MAC OS X/i.test(USER_AGENT); // MAC系统，先检查IOS

  var IS_LINUX = /Linux/i.test(USER_AGENT);
  var IS_WX = /MicroMessenger/i.test(USER_AGENT); //是否为微信环境

  var IS_UCBROWSER = /UCBrowser/i.test(USER_AGENT);
  var IS_MIUIBROWSER = /MiuiBrowser/i.test(USER_AGENT);
  var IS_HUAWEIBROWSER = /HuaweiBrowser/i.test(USER_AGENT);
  var IS_QQ = /QQ\/\d+/i.test(USER_AGENT); // QQ
  //

  var BROWSER_VERSION = IS_CHROME ? 'Chrome/' + CHROME_VERSION : IS_SAFARI ? 'Safari/' + SAFARI_VERSION : 'NotSupportedBrowser';

  var envName = 'trtc_env';

  var query = function query(name) {
    var match = window.location.search.match(new RegExp('(\\?|&)' + name + '=([^&]*)(&|$)'));
    return !match ? '' : decodeURIComponent(match[2]);
  };

  var getEnv = function getEnv() {
    return query(envName);
  };
  var getUrl = function getUrl(url) {
    var finalUrl = url;
    var env = query(envName);

    if (env) {
      finalUrl = 'wss://' + env + '.rtc.qq.com:8687';
    }

    return finalUrl;
  };
  // terminaltype取值
  // enum TERMINAL_TYPE
  // {
  //     TERMINAL_TYPE_MOBILE       = 1;  //终端手机
  //     TERMINAL_TYPE_IPHONE       = 2;  //终端为iphone
  //     TERMINAL_TYPE_IPAD         = 3;  //ipad
  //     TERMINAL_TYPE_ANDRIOD      = 4;  //andriod
  //     TERMINAL_TYPE_PC           = 5;  //PC
  //     TERMINAL_TYPE_WINRT_PAD    = 6;  //WinRT pad
  //     TERMINAL_TYPE_WINRT_PHONE  = 7;  //WinRT phone
  //     TERMINAL_TYPE_ANDROID_PAD  = 8;  //android pad
  //     TERMINAL_TYPE_VOIP         = 9;  //pstn
  //     TERMINAL_TYPE_MAC          = 12; //MAC
  //     TERMINAL_TYPELINUX         = 13; //LINUX
  //     TERMINAL_TYPE_RTMP         = 14; //RTMP
  //     TERMINAL_TYPE_WEBRTC       = 15; //WEBRTC
  //     TERMINAL_TYPE_PSTN         = 101; //pstn
  // }

  function getTerminalType() {
    if (IS_ANDROID) {
      return 4;
    } else if (IS_IPHONE) {
      return 2;
    } else if (IS_IPAD) {
      return 3;
    } else if (IS_MAC) {
      return 12;
    } else if (IS_WIN) {
      return 5;
    } else if (IS_LINUX) {
      return 13;
    } // unknown


    return 1;
  }

  function getOSType() {
    if (IS_ANDROID) {
      return 'Android';
    } else if (IS_IPHONE) {
      return 'iPhone';
    } else if (IS_IPAD) {
      return 'iPad';
    } else if (IS_MAC) {
      return 'Mac';
    } else if (IS_WIN) {
      return 'Windows';
    } else if (IS_LINUX) {
      return 'Linux';
    }

    return 'unknown';
  }

  var getSysInfo = function getSysInfo() {
    // **NOTE** below code are copied from old sdk with minimal changes.
    var connectionType = 0; // effectiveType is slow-2g/2g/3g/4g

    if (navigator && navigator.connection && navigator.connection.effectiveType) {
      if (navigator.connection.effectiveType === '4g') {
        connectionType = 1; // assume it's wifi
      } else {
        connectionType = 4; // otherwise cellular
      }
    } // type is almost not implemented in browser


    if (navigator && navigator.connection && navigator.connection.type) {
      if (navigator.connection.type === 'wifi') {
        connectionType = 1;
      } else if (navigator.connection.type === 'cellular') {
        connectionType = 4;
      }
    }

    return {
      AbilityOption: {
        GeneralLimit: {
          CPULimit: {
            uint32_CPU_num: String(navigator.hardwareConcurrency || 0),
            //CPU核心数   ok
            str_CPU_name: String(navigator.platform),
            uint32_CPU_maxfreq: String(0),
            model: '',
            uint32_total_memory: String(0)
          },
          uint32_terminal_type: String(getTerminalType()),
          //终端类型，使用enum TERMINAL_TYPE
          uint32_device_type: String(0),
          //机型、设备类型(比如iphone4、iphone5s)，只针对移动终端，pc不用填写
          str_os_verion: getOSType(),
          //操作系统类型、版本
          uint32_link_type: String(1),
          //客户端接口机连接类型，1表示UDP，2表示TCP，0未知（旧版本没有上报此字段）
          str_client_version: version$1,
          uint32_net_type: String(connectionType),
          ua: navigator.userAgent,
          version: ''
        } // below fileds are not used at all
        //   VideoLimit: {
        //     CameraLimit: {
        //       str_camera_auth_name: '',
        //       uint32_video_src_type: 1
        //     },
        //     uint32_screen_width: String(window.screen.width), //屏幕宽
        //     uint32_screen_height: String(window.screen.height) //屏幕高
        //   },
        //   SpeciParam: {
        //     SpeciVidParam: {
        //       uint32_spcivid_proto: String(3), //角色类型
        //       uint32_spcivid_width: String(640),
        //       uint32_spcivid_height: String(368),
        //       uint32_spcivid_fps: String(20)
        //     },
        //     SpeciAudParam: {
        //       uint32_spciaud_fs: String(48000),
        //       uint32_spciaud_ch: String(2)
        //     }
        //   }

      }
    };
  };
  var isPlainObject = function isPlainObject(value) {
    // 判断类型不是 Object 的
    if (!value || _typeof(value) !== 'object' || Object.prototype.toString.call(value) != '[object Object]') {
      return false;
    } // 返回指定对象的原型 判断对象有没有原型，没有原型的对象算纯粹对象


    var proto = Object.getPrototypeOf(value);

    if (proto === null) {
      // Object.create(null) 的情况
      return true;
    } // 最后判断是不是通过 "{}" 或 "new Object" 方式创建的对象
    // 如果 proto 有 constructor属性，Ctor 的值就为 proto.constructor，
    // 原型的 constructor 属性指向关联的构造函数


    var Ctor = Object.prototype.hasOwnProperty.call(proto, 'constructor') && proto.constructor;
    return typeof Ctor == 'function' && // 用于检测构造函数Ctor的 prototype 属性是否出现在某个实例对象(Ctor)的原型链上。
    Ctor instanceof Ctor && // 如果 Ctor 类型是  "function" ，并且调用Function.prototype.toString 方法后得到的字符串 与 "function Object() { [native code] }" 这样的字符串相等就返回true
    // 用来区分 自定义构造函数和 Object 构造函数
    Function.prototype.toString.call(Ctor) === Function.prototype.toString.call(Object);
  };

  /**
   * Has own property.
   *
   * @type {Function}
   */

  var has$1 = Object.prototype.hasOwnProperty;
  /**
   * Test whether a value is "empty".
   *
   * @param {Mixed} val
   * @return {Boolean}
   */

  function isEmpty(val) {
    // Null and Undefined...
    if (val == null) return true; // Booleans...

    if ('boolean' == typeof val) return false; // Numbers...

    if ('number' == typeof val) return val === 0; // Strings...

    if ('string' == typeof val) return val.length === 0; // Functions...

    if ('function' == typeof val) return val.length === 0; // Arrays...

    if (Array.isArray(val)) return val.length === 0; // Errors...

    if (val instanceof Error) return val.message === ''; // Objects...

    if (isPlainObject(val)) {
      switch (Object.prototype.toString.call(val)) {
        // Maps, Sets, Files and Errors...
        case '[object File]':
        case '[object Map]':
        case '[object Set]':
          {
            return val.size === 0;
          }
        // Plain objects...

        case '[object Object]':
          {
            for (var key in val) {
              if (has$1.call(val, key)) return false;
            }

            return true;
          }
      }
    } // Anything else...


    return false;
  }

  var eventemitter3 = createCommonjsModule(function (module) {

  var has = Object.prototype.hasOwnProperty
    , prefix = '~';

  /**
   * Constructor to create a storage for our `EE` objects.
   * An `Events` instance is a plain object whose properties are event names.
   *
   * @constructor
   * @private
   */
  function Events() {}

  //
  // We try to not inherit from `Object.prototype`. In some engines creating an
  // instance in this way is faster than calling `Object.create(null)` directly.
  // If `Object.create(null)` is not supported we prefix the event names with a
  // character to make sure that the built-in object properties are not
  // overridden or used as an attack vector.
  //
  if (Object.create) {
    Events.prototype = Object.create(null);

    //
    // This hack is needed because the `__proto__` property is still inherited in
    // some old browsers like Android 4, iPhone 5.1, Opera 11 and Safari 5.
    //
    if (!new Events().__proto__) prefix = false;
  }

  /**
   * Representation of a single event listener.
   *
   * @param {Function} fn The listener function.
   * @param {*} context The context to invoke the listener with.
   * @param {Boolean} [once=false] Specify if the listener is a one-time listener.
   * @constructor
   * @private
   */
  function EE(fn, context, once) {
    this.fn = fn;
    this.context = context;
    this.once = once || false;
  }

  /**
   * Add a listener for a given event.
   *
   * @param {EventEmitter} emitter Reference to the `EventEmitter` instance.
   * @param {(String|Symbol)} event The event name.
   * @param {Function} fn The listener function.
   * @param {*} context The context to invoke the listener with.
   * @param {Boolean} once Specify if the listener is a one-time listener.
   * @returns {EventEmitter}
   * @private
   */
  function addListener(emitter, event, fn, context, once) {
    if (typeof fn !== 'function') {
      throw new TypeError('The listener must be a function');
    }

    var listener = new EE(fn, context || emitter, once)
      , evt = prefix ? prefix + event : event;

    if (!emitter._events[evt]) emitter._events[evt] = listener, emitter._eventsCount++;
    else if (!emitter._events[evt].fn) emitter._events[evt].push(listener);
    else emitter._events[evt] = [emitter._events[evt], listener];

    return emitter;
  }

  /**
   * Clear event by name.
   *
   * @param {EventEmitter} emitter Reference to the `EventEmitter` instance.
   * @param {(String|Symbol)} evt The Event name.
   * @private
   */
  function clearEvent(emitter, evt) {
    if (--emitter._eventsCount === 0) emitter._events = new Events();
    else delete emitter._events[evt];
  }

  /**
   * Minimal `EventEmitter` interface that is molded against the Node.js
   * `EventEmitter` interface.
   *
   * @constructor
   * @public
   */
  function EventEmitter() {
    this._events = new Events();
    this._eventsCount = 0;
  }

  /**
   * Return an array listing the events for which the emitter has registered
   * listeners.
   *
   * @returns {Array}
   * @public
   */
  EventEmitter.prototype.eventNames = function eventNames() {
    var names = []
      , events
      , name;

    if (this._eventsCount === 0) return names;

    for (name in (events = this._events)) {
      if (has.call(events, name)) names.push(prefix ? name.slice(1) : name);
    }

    if (Object.getOwnPropertySymbols) {
      return names.concat(Object.getOwnPropertySymbols(events));
    }

    return names;
  };

  /**
   * Return the listeners registered for a given event.
   *
   * @param {(String|Symbol)} event The event name.
   * @returns {Array} The registered listeners.
   * @public
   */
  EventEmitter.prototype.listeners = function listeners(event) {
    var evt = prefix ? prefix + event : event
      , handlers = this._events[evt];

    if (!handlers) return [];
    if (handlers.fn) return [handlers.fn];

    for (var i = 0, l = handlers.length, ee = new Array(l); i < l; i++) {
      ee[i] = handlers[i].fn;
    }

    return ee;
  };

  /**
   * Return the number of listeners listening to a given event.
   *
   * @param {(String|Symbol)} event The event name.
   * @returns {Number} The number of listeners.
   * @public
   */
  EventEmitter.prototype.listenerCount = function listenerCount(event) {
    var evt = prefix ? prefix + event : event
      , listeners = this._events[evt];

    if (!listeners) return 0;
    if (listeners.fn) return 1;
    return listeners.length;
  };

  /**
   * Calls each of the listeners registered for a given event.
   *
   * @param {(String|Symbol)} event The event name.
   * @returns {Boolean} `true` if the event had listeners, else `false`.
   * @public
   */
  EventEmitter.prototype.emit = function emit(event, a1, a2, a3, a4, a5) {
    var evt = prefix ? prefix + event : event;

    if (!this._events[evt]) return false;

    var listeners = this._events[evt]
      , len = arguments.length
      , args
      , i;

    if (listeners.fn) {
      if (listeners.once) this.removeListener(event, listeners.fn, undefined, true);

      switch (len) {
        case 1: return listeners.fn.call(listeners.context), true;
        case 2: return listeners.fn.call(listeners.context, a1), true;
        case 3: return listeners.fn.call(listeners.context, a1, a2), true;
        case 4: return listeners.fn.call(listeners.context, a1, a2, a3), true;
        case 5: return listeners.fn.call(listeners.context, a1, a2, a3, a4), true;
        case 6: return listeners.fn.call(listeners.context, a1, a2, a3, a4, a5), true;
      }

      for (i = 1, args = new Array(len -1); i < len; i++) {
        args[i - 1] = arguments[i];
      }

      listeners.fn.apply(listeners.context, args);
    } else {
      var length = listeners.length
        , j;

      for (i = 0; i < length; i++) {
        if (listeners[i].once) this.removeListener(event, listeners[i].fn, undefined, true);

        switch (len) {
          case 1: listeners[i].fn.call(listeners[i].context); break;
          case 2: listeners[i].fn.call(listeners[i].context, a1); break;
          case 3: listeners[i].fn.call(listeners[i].context, a1, a2); break;
          case 4: listeners[i].fn.call(listeners[i].context, a1, a2, a3); break;
          default:
            if (!args) for (j = 1, args = new Array(len -1); j < len; j++) {
              args[j - 1] = arguments[j];
            }

            listeners[i].fn.apply(listeners[i].context, args);
        }
      }
    }

    return true;
  };

  /**
   * Add a listener for a given event.
   *
   * @param {(String|Symbol)} event The event name.
   * @param {Function} fn The listener function.
   * @param {*} [context=this] The context to invoke the listener with.
   * @returns {EventEmitter} `this`.
   * @public
   */
  EventEmitter.prototype.on = function on(event, fn, context) {
    return addListener(this, event, fn, context, false);
  };

  /**
   * Add a one-time listener for a given event.
   *
   * @param {(String|Symbol)} event The event name.
   * @param {Function} fn The listener function.
   * @param {*} [context=this] The context to invoke the listener with.
   * @returns {EventEmitter} `this`.
   * @public
   */
  EventEmitter.prototype.once = function once(event, fn, context) {
    return addListener(this, event, fn, context, true);
  };

  /**
   * Remove the listeners of a given event.
   *
   * @param {(String|Symbol)} event The event name.
   * @param {Function} fn Only remove the listeners that match this function.
   * @param {*} context Only remove the listeners that have this context.
   * @param {Boolean} once Only remove one-time listeners.
   * @returns {EventEmitter} `this`.
   * @public
   */
  EventEmitter.prototype.removeListener = function removeListener(event, fn, context, once) {
    var evt = prefix ? prefix + event : event;

    if (!this._events[evt]) return this;
    if (!fn) {
      clearEvent(this, evt);
      return this;
    }

    var listeners = this._events[evt];

    if (listeners.fn) {
      if (
        listeners.fn === fn &&
        (!once || listeners.once) &&
        (!context || listeners.context === context)
      ) {
        clearEvent(this, evt);
      }
    } else {
      for (var i = 0, events = [], length = listeners.length; i < length; i++) {
        if (
          listeners[i].fn !== fn ||
          (once && !listeners[i].once) ||
          (context && listeners[i].context !== context)
        ) {
          events.push(listeners[i]);
        }
      }

      //
      // Reset the array, or remove it completely if we have no more listeners.
      //
      if (events.length) this._events[evt] = events.length === 1 ? events[0] : events;
      else clearEvent(this, evt);
    }

    return this;
  };

  /**
   * Remove all listeners, or those of the specified event.
   *
   * @param {(String|Symbol)} [event] The event name.
   * @returns {EventEmitter} `this`.
   * @public
   */
  EventEmitter.prototype.removeAllListeners = function removeAllListeners(event) {
    var evt;

    if (event) {
      evt = prefix ? prefix + event : event;
      if (this._events[evt]) clearEvent(this, evt);
    } else {
      this._events = new Events();
      this._eventsCount = 0;
    }

    return this;
  };

  //
  // Alias methods names because people roll like that.
  //
  EventEmitter.prototype.off = EventEmitter.prototype.removeListener;
  EventEmitter.prototype.addListener = EventEmitter.prototype.on;

  //
  // Expose the prefix.
  //
  EventEmitter.prefixed = prefix;

  //
  // Allow `EventEmitter` to be imported as module namespace.
  //
  EventEmitter.EventEmitter = EventEmitter;

  //
  // Expose the module.
  //
  {
    module.exports = EventEmitter;
  }
  });

  /**
   * WebSocket Channel 事件类型
   *
   * @enum {string}
   */
  var ChannelEvent = {
    /** WebSocket 连接状态变化通知 */
    CONNECTION_STATE_CHANGED: 'connection-state-changed',

    /** WebSocket 连接错误 */
    ERROR: 'error'
  };
  /**
   * WebSocket 连接状态
   *
   * @enum {string}
   */

  var ConnectionState = {
    /** WebSocket 断开连接 */
    DISCONNECTED: 'DISCONNECTED',

    /** WebSocket 正在连接 */
    CONNECTING: 'CONNECTING',

    /** WebSocket 断开后正在重连 */
    RECONNECTING: 'RECONNECTING',

    /** WebSocket 连接成功 */
    CONNECTED: 'CONNECTED'
  };
  /**
   * Signal 事件映射表
   */

  var SignalEventMap = {
    /** 远端交换 sdp offer/answer */
    NEW_REMOTE_SDP: 0x2,

    /** 远端交换 iceCandidate */
    NEW_ICE_CANDIDATE: 0x4,

    /** 用户被踢出房间 (Relay超时、同名用户登录等) */
    CLINET_BANNDED: 0x08,

    /** Signal Channel 建立成功 */
    CHANNEL_SETUP_SUCCESS: 0x13,

    /** Signal Channel 建立失败 */
    CHANNEL_SETUP_FAILED: 0x50,

    /** Signal Channel 重连结果 */
    CHANNEL_RECONNECT_RESULT: 0x202,

    /** 用户进房返回结果 */
    JOIN_ROOM_RESULT: 0x14,

    /** 远端用户进房 */
    PEER_JOIN: 0x10,

    /** 远端用户退房 */
    PEER_LEAVE: 0x12,

    /** 远端更新 sdp offer，涉及 audio/video track 增减 */
    UPDATE_REMOTE_SDP: 0x30,
    UPDATE_AUDIO_SSRC: 0x32,
    UPDATE_VIDEO_SSRC: 0x34,

    /** 远端用户音视频mute状态更新 */
    UPDATE_REMOTE_MUTE_STAT: 0x17,

    /** Remote server's acknowledge on SignalCommand.CLOSE_PEER */
    CLOSE_PEER_ACK: 0x0a,

    /** acknowledge on subscription */
    SUBSCRIBE_ACK: 0x1a,
    AUDIO_MODE_RESULT: 0x1c,
    UPDATE_SELF_POSITION: 0x1e
  };
  /**
   * Signal 事件，与 SignalEventMap 一一对应
   */

  var SignalEvent = {
    /** 远端交换 sdp offer/answer */
    NEW_REMOTE_SDP: 'new-remote-sdp',

    /** 远端交换 iceCandidate */
    NEW_ICE_CANDIDATE: 'new-ice-candidate',

    /** 用户被踢出房间 (Relay超时、同名用户登录等) */
    CLINET_BANNDED: 'client-banned',

    /** Signal Channel 建立成功 */
    CHANNEL_SETUP_SUCCESS: 'channel-setup-success',

    /** Signal Channel 建立失败 */
    CHANNEL_SETUP_FAILED: 'channel-setup-failed',

    /** Signal Channel 重连结果 */
    CHANNEL_RECONNECT_RESULT: 'channel-reconnect-result',

    /** 用户进房返回结果 */
    JOIN_ROOM_RESULT: 'join-room-result',

    /** 远端用户进房 */
    PEER_JOIN: 'peer-join',

    /** 远端用户退房 */
    PEER_LEAVE: 'peer-leave',

    /** 远端更新 sdp offer，涉及 audio/video track 增减 */
    UPDATE_REMOTE_SDP: 'update-remote-sdp',
    UPDATE_AUDIO_SSRC: 'update-audio-ssrc',
    UPDATE_VIDEO_SSRC: 'update-video-ssrc',

    /** 远端用户音视频mute状态更新 */
    UPDATE_REMOTE_MUTE_STAT: 'update-remote-mute-stat',

    /** Remote server's acknowledge on SignalCommand.CLOSE_PEER */
    CLOSE_PEER_ACK: 'close-peer-ack',
    SUBSCRIBE_ACK: 'subscribe-ack',
    // internal event
    REQUEST_REBUILD_SESSION: 'request-rebuild-session'
  };
  /**
   * Signal 命令映射表
   * SignalCommand是SDK发往后台信令服务器的信令
   */

  var SignalCommand = {
    NEW_LOCAL_SDP: 'on_peer_sdp',
    // UPDATE_LOCAL_SDP: 'on_update_peer_sdp',
    // new signal commond for updating sdp offer
    UPDATE_LOCAL_SDP: 'on_reexchange_sdp',
    NEW_ICE_CANDIDATE: 'on_peer_candidate',
    // ON_BIND_SESSION: 'on_bind_session',
    // ON_MEDIA_CHANGE: 'on_media_change',
    // ON_START_CHAT: 'on_start_chat',
    // ON_QUIT_CHAT: 'on_quit_chat',
    JOIN_ROOM: 'on_create_room',
    // ON_CREATE_PEER: 'on_create_peer',
    CLOSE_PEER: 'on_close_peer',
    ON_QUALITY_REPORT: 'on_quality_report',
    // ON_GET_USER_MEDIA: 'on_get_user_media',
    // ON_GET_USER_MEDIA_OK: 'on_get_user_media_ok',
    // ON_GET_USER_MEDIA_FAILED: 'on_get_user_media_failed',
    // ON_GET_LOACL_SDP_FAILED: 'on_get_local_sdp_failed',
    // ON_SET_REMOTE_SDP_FAILED: 'on_set_remote_sdp_failed',
    // ON_GET_LOCAL_CANDIDATE_FAILED: 'on_get_local_candidate_failed',
    // ON_SET_REMOTE_CANDIDATE_FAILED: 'on_set_remote_candidate_failed',
    // ON_GET_SRC_PEER_CONNECTION_FAILED: 'on_get_srctinyid_peerconnection_failed',
    // ON_SET_REMOTE_CANDIDATE_SUC: 'on_set_remote_candidate_suc',
    // ON_SET_REMOTE_SDP_SUC: 'on_set_remote_sdp_suc',
    // ON_ICE_COMPLETE: 'on_ice_complete',
    // ON_ICE_BROKEN: 'on_ice_broken',
    // ON_START_WEBRTC_FAILED_WITHOUT_CALLBACK: 'on_start_webrtc_failed_without_callback',
    // ON_CREATE_PEERCONNECTION_FAILED: 'on_create_peerconnection_failed',
    // ON_END_REPORT: 'on_end_report',
    // ON_SPEAR_ROLE_CHANGE: 'on_spear_role_change',
    ON_REBUILD_SESSION: 'on_rebuild_session',
    // ON_START_WEBRTC: 'on_start_webrtc',
    // ON_UPLOAD_WEB_LOG: 'on_upload_web_log',
    // INIT_END_REPORT: 'init_end_report',
    // ON_GET_MAX_TIMEMS: 'on_get_max_timems',
    ON_NOT_SUPPORT_H264: 'on_not_support_h264',
    // ON_STUN_FAILED: 'on_stun_failed',
    // ON_STREAM_NOTIFY: 'on_stream_notify',

    /**
     * parameter:
     * content: {
     *    srctinyid: string
     *    userid:
     *    flag: int
     *  }
     * flag取值：
     * //bit0 Mute主路
     * //bit1 Mute辅路
     * //bit2 Mute音频
     */
    UPDATE_MUTE_STAT: 'on_change_av_state',
    SUBSCRIBE: 'on_subscribe',
    UPDATE_MEDIA_SETTINGS: 'on_constraints_config',
    // send exitCode to remote server to simulate websocket.onclose with specified exitCode
    TEST_WEBSOCKET: 'on_test_ws_broken',
    REFRESH_PEER: 'on_recreate_down_peerc',
    SET_TEAM_ID: 'on_set_team_id',
    SET_AUDIO_MODE: 'on_set_audio_mode',
    UPDATE_SELF_POSITION: 'on_update_self_position'
  };

  /**
   * 错误码定义
   *
   * @module ErrorCode
   */
  var ErrorCode = {
    /**
     * 无效参数
     *
     * @default 0x1000
     * @memberof module:ErrorCode
     */
    INVALID_PARAMETER: 0x1000,

    /**
     * 非法操作
     *
     * @default 0x1001
     * @memberof module:ErrorCode
     */
    INVALID_OPERATION: 0x1001,

    /**
     * 不支持
     *
     * @default 0x1002
     * @memberof module:ErrorCode
     */
    NOT_SUPPORTED: 0x1002,

    /**
     * WebSocket 信令通道建立失败
     *
     * 帐号相关错误信息：
     *
     *
     * | 错误码 | 错误类型 | 描述                                                                                                           |
     * | :----- | :------- | :------------------------------------------------------------------------------------------------------------- |
     * | 70001  | 帐号系统 | userSig 过期，请尝试重新生成。如果是刚生成就过期，请检查有效期填写的是否过小或者误填为 0                       |
     * | 70002  | 帐号系统 | userSig 长度为 0，请确认签名计算是否正确，访问 sign_src 获取计算签名的傻瓜式源码，核对参数，确保签名计算正确性 |
     * | 70003  | 帐号系统 | userSig 校验失败，请确认下 userSig 内容是否被截断，例如缓冲区长度不够导致的内容截断                            |
     * | 70004  | 帐号系统 | userSig 校验失败，请确认下 uerSig 内容是否被截断，例如缓冲区长度不够导致的内容截断                             |
     * | 70005  | 帐号系统 | userSig 校验失败，通过工具来验证生成的 userSig 是否正确                                                        |
     * | 70006  | 帐号系统 | userSig 校验失败，通过工具来验证生成的 userSig 是否正确                                                        |
     * | 70007  | 帐号系统 | userSig 校验失败，通过工具来验证生成的 userSig 是否正确                                                        |
     * | 70008  | 帐号系统 | userSig 校验失败，通过工具来验证生成的 userSig 是否正确                                                        |
     * | 70009  | 帐号系统 | 用业务公钥验证 userSig 失败，请确认生成的 userSig 使用的私钥和 sdkAppId 是否对应                               |
     * | 70010  | 帐号系统 | userSig 校验失败，通过工具来验证生成的 userSig 是否正确                                                        |
     * | 70013  | 帐号系统 | userSig 中 userId 与请求时的 userId 不匹配，请检查登录时填写的 userId 与 userSig 中的是否一致                  |
     * | 70014  | 帐号系统 | userSig 中 sdkAppId 与请求时的 sdkAppId 不匹配，请检查登录时填写的 sdkAppId 与 userSig 中的是否一致            |
     * | 70015  | 帐号系统 | 未找到该 sdkAppId 和帐号类型对应的验证方式，请确认是否已进行帐号集成操作                                       |
     * | 70016  | 帐号系统 | 拉取到的公钥长度为 0，请确认是否已上传公钥，如果是重新上传的公钥需要十分钟后再尝试                             |
     * | 70017  | 帐号系统 | 内部第三方票据验证超时，请重试，如果多次重试仍不成功，请联系 TLS 帐号支持，QQ：3268519604                      |
     * | 70018  | 帐号系统 | 内部验证第三方票据失败                                                                                         |
     * | 70019  | 帐号系统 | 通过 HTTPS 方式验证的票据字段为空，请正确填写 userSig                                                          |
     * | 70020  | 帐号系统 | sdkAppId 未找到，请确认是否已在腾讯云上配置                                                                    |
     * | 70052  | 帐号系统 | userSig 已经失效，请重新生成，再次尝试                                                                         |
     * | 70101  | 帐号系统 | 请求包信息为空                                                                                                 |
     * | 70102  | 帐号系统 | 请求包帐号类型错误                                                                                             |
     * | 70103  | 帐号系统 | 电话号码格式错误                                                                                               |
     * | 70104  | 帐号系统 | 邮箱格式错误                                                                                                   |
     * | 70105  | 帐号系统 | TLS 帐号格式错误                                                                                               |
     * | 70106  | 帐号系统 | 非法帐号格式类型                                                                                               |
     * | 70107  | 帐号系统 | userId 没有注册                                                                                                |
     * | 70113  | 帐号系统 | 批量数量不合法                                                                                                 |
     * | 70114  | 帐号系统 | 安全原因被限制                                                                                                 |
     * | 70115  | 帐号系统 | uin 不是对应 sdkAppId 的开发者 uin                                                                             |
     * | 70140  | 帐号系统 | sdkAppId 和 acctype 不匹配                                                                                     |
     * | 70145  | 帐号系统 | 帐号类型错误                                                                                                   |
     * | 70169  | 帐号系统 | 内部错误，请重试。如果多次重试仍不成功，请联系 TLS 帐号支持，QQ：3268519604                                    |
     * | 70201  | 帐号系统 | 内部错误，请重试。如果多次重试仍不成功，请联系 TLS 帐号支持，QQ：3268519604                                    |
     * | 70202  | 帐号系统 | 内部错误，请重试。如果多次重试仍不成功，请联系 TLS 帐号支持，QQ：3268519604                                    |
     * | 70203  | 帐号系统 | 内部错误，请重试。如果多次重试仍不成功，请联系 TLS 帐号支持，QQ：3268519604                                    |
     * | 70204  | 帐号系统 | sdkAppId 没有对应的 acctype                                                                                    |
     * | 70205  | 帐号系统 | 查找 acctype 失败，请重试                                                                                      |
     * | 70206  | 帐号系统 | 请求中批量数量不合法                                                                                           |
     * | 70207  | 帐号系统 | 内部错误，请重试                                                                                               |
     * | 70208  | 帐号系统 | 内部错误，请重试                                                                                               |
     * | 70209  | 帐号系统 | 获取开发者 uin 标志失败                                                                                        |
     * | 70210  | 帐号系统 | 请求中 uin 为非开发者 uin                                                                                      |
     * | 70211  | 帐号系统 | 请求中 uin 非法                                                                                                |
     * | 70212  | 帐号系统 | 内部错误，请重试。如果多次重试仍不成功，请联系 TLS 帐号支持，QQ：3268519604                                    |
     * | 70213  | 帐号系统 | 访问内部数据失败，请重试。如果多次重试仍不成功，请联系 TLS 帐号支持，QQ：3268519604                            |
     * | 70214  | 帐号系统 | 验证内部票据失败                                                                                               |
     * | 70221  | 帐号系统 | 登录状态无效，请使用 UserSig 重新鉴权                                                                          |
     * | 70222  | 帐号系统 | 内部错误，请重试                                                                                               |
     * | 70225  | 帐号系统 | 内部错误，请重试。如果多次重试仍不成功，请联系 TLS 帐号支持，QQ：3268519604                                    |
     * | 70231  | 帐号系统 | 内部错误，请重试。如果多次重试仍不成功，请联系 TLS 帐号支持，QQ：3268519604                                    |
     * | 70236  | 帐号系统 | 验证 user signature 失败                                                                                       |
     * | 70308  | 帐号系统 | 内部错误，请重试。如果多次重试仍不成功，请联系 TLS 帐号支持，QQ：3268519604                                    |
     * | 70346  | 帐号系统 | 票据校验失败。                                                                                                 |
     * | 70347  | 帐号系统 | 票据因过期原因校验失败                                                                                         |
     * | 70348  | 帐号系统 | 内部错误，请重试。如果多次重试仍不成功，请联系 TLS 帐号支持，QQ：3268519604                                    |
     * | 70362  | 帐号系统 | 内部超时，请重试。如果多次重试仍不成功，请联系 TLS 帐号支持，QQ：3268519604                                    |
     * | 70401  | 帐号系统 | 内部错误，请重试                                                                                               |
     * | 70402  | 帐号系统 | 参数非法。请检查必填字段是否填充，或者字段的填充是否满足协议要求                                               |
     * | 70403  | 帐号系统 | 发起操作者不是 App 管理员，没有权限操作                                                                        |
     * | 70050  | 帐号系统 | 因失败且重试次数过多导致被限制，请检查票据是否正确，一分钟之后再试                                             |
     * | 70051  | 帐号系统 | 帐号已被拉入黑名单，请联系 TLS 帐号支持，QQ：3268519604                                                        |
     *
     * @default 0x4001
     * @memberof module:ErrorCode
     */
    SIGNAL_CAHNNEL_SETUP_FAILED: 0x4001,

    /**
     * WebSocket 信令通道错误
     *
     * @default 0x4002
     * @memberof module:ErrorCode
     */
    SIGNAL_CHANNEL_ERROR: 0x4002,

    /**
     * ICE Transport 连接错误，即音视频数据传输通道错误。
     * <br>
     * 这主要是因为用户端的 UDP 8000 端口异常，可能是用户电脑防火墙或路由器防火墙端口限制引起。
     *
     * @default 0x4003
     * @memberof module:ErrorCode
     */
    ICE_TRANSPORT_ERROR: 0x4003,

    /**
     * 进房失败
     *
     * @default 0x4004
     * @memberof module:ErrorCode
     */
    JOIN_ROOM_FAILED: 0x4004,

    /**
     * 创建 sdp offer 失败
     *
     * @default 0x4005
     * @memberof module:ErrorCode
     */
    CREATE_OFFER_FAILED: 0x4005,

    /**
     * ICE Transport 异常中断，业务侧可以通过重试解决。
     * <br>
     * 这主要是因为用户端的 UDP 8000 端口异常，可能是用户电脑防火墙或路由器防火墙端口限制引起。
     *
     * @default 0x4003
     * @memberof module:ErrorCode
     */
    ICE_TRANSPORT_BROKE: 0x4006,

    /**
     * 用户被踢出房间
     *
     * @default 0x4040
     * @memberof module:ErrorCode
     */
    CLIENT_BANNED: 0x4040,

    /**
     * 媒体传输服务超时
     *
     * @default 0x4041
     * @memberof module:ErrorCode
     */
    SERVER_TIMEOUT: 0x4041,

    /**
     * 远端流订阅超时
     *
     * @default 0x4042
     * @memberof module:ErrorCode
     */
    SUBSCRIPTION_TIMEOUT: 0x4042,

    /**
     * 自动播放被禁止错误<br>
     * 调用 {@link Stream#play play()} 播放音视频时，由于{@link https://developers.google.com/web/updates/2017/09/autoplay-policy-changes 自动播放策略}的限制导致无法自动播放。
     * 此时应该引导用户通过手势操作调用 {@link Stream#resume resume()} 继续进行播放。
     *
     * @default 0x4043
     * @memberof module:ErrorCode
     */
    PLAY_NOT_ALLOWED: 0x4043,

    /**
     * 设置语音模式失败<br>
     * @default 0x4044
     * @memberof module:ErrorCode
     */
    AUDIO_MODE_ERROR: 0x4044,

    /**
     * 更新自己位置信息失败<br>
     * @default 0x4045
     * @memberof module:ErrorCode
     */
    UPDATE_SELF_POSITION_ERROR: 0x4045,

    /**
     * 未知错误
     *
     * @default 0xFFFF
     * @memberof module:ErrorCode
     */
    UNKOWN: 0xffff
  };

  var getErrorName = function getErrorName(code) {
    if (code === ErrorCode.INVALID_PARAMETER) return 'INVALID_PARAMETER';else if (code === ErrorCode.INVALID_OPERATION) return 'INVALID_OPERATION';else if (code === ErrorCode.CLIENT_BANNED) return 'CLIENT_BANNED';else if (code === ErrorCode.CREATE_OFFER_FAILED) return 'CREATE_OFFER_FAILED';else if (code === ErrorCode.JOIN_ROOM_FAILED) return 'JOIN_ROOM_FAILED';else if (code === ErrorCode.ICE_TRANSPORT_ERROR) return 'ICE_TRANSPORT_ERROR';else if (code === ErrorCode.PLAY_NOT_ALLOWED) return 'PLAY_NOT_ALLOWED';else if (code === ErrorCode.NOT_SUPPORTED) return 'NOT_SUPPORTED';else if (code === ErrorCode.SIGNAL_CAHNNEL_SETUP_FAILED) return 'SIGNAL_CHANNEL_SETUP_FAILED';else if (code === ErrorCode.SIGNAL_CHANNEL_ERROR) return 'SIGNAL_CAHNNEL_ERROR';else if (code === ErrorCode.SERVER_TIMEOUT) return 'SERVER_TIMEOUT';else if (code === ErrorCode.SUBSCRIPTION_TIMEOUT) return 'SUBSCRIPTION_TIMEOUT';
    return 'UNKNOWN';
  };
  /**
   * RtcError 错误对象
   *
   * @extends Error
   * @class RtcError
   */


  var RtcError = /*#__PURE__*/function (_Error) {
    _inherits(RtcError, _Error);

    var _super = _createSuper(RtcError);

    function RtcError(_ref) {
      var _this;

      var message = _ref.message,
          _ref$code = _ref.code,
          code = _ref$code === void 0 ? ErrorCode.UNKOWN : _ref$code,
          _ref$extraCode = _ref.extraCode,
          extraCode = _ref$extraCode === void 0 ? 0 : _ref$extraCode;

      _classCallCheck(this, RtcError);

      _this = _super.call(this, message + " <".concat(getErrorName(code), " 0x").concat(code.toString(16), "> https://trtc-1252463788.file.myqcloud.com/web/docs/module-ErrorCode.html"));
      _this.code_ = code; // extra code for internal use only

      _this.extraCode_ = extraCode;
      _this.name = 'RtcError';
      _this.message_ = message;
      return _this;
    }
    /**
     * 获取错误码
     * <br>
     * 详细错误码列表参见 {@link module:ErrorCode ErrorCode}。
     *
     * @memberof RtcError
     */


    _createClass(RtcError, [{
      key: "getCode",
      value: function getCode() {
        return this.code_;
      } // private

    }, {
      key: "getExtraCode",
      value: function getExtraCode() {
        return this.extraCode_;
      }
    }]);

    return RtcError;
  }( /*#__PURE__*/_wrapNativeSuper(Error));

  // const kibanaUrl = 'https://yun.tim.qq.com/v5/AVQualityReportSvc/C2S?sdkappid=1&cmdtype=jssdk_log';

  var config$1 = {
    sdkAppId: '',
    userId: '',
    version: '',
    env: 'qcloud'
  };
  var setLogEventConfig = function setLogEventConfig(options) {
    config$1.sdkAppId = "".concat(options.sdkAppId);
    config$1.version = "".concat(options.version);
    config$1.env = options.env;
    config$1.userId = options.userId;
  };

  var uploadEventToKibana = function uploadEventToKibana(event) {
    var msg = "stat-".concat(event.eventType, "-").concat(event.result);

    if (event.eventType === 'delta-join' || event.eventType === 'delta-leave' || event.eventType === 'delta-publish') {
      msg = "".concat(event.eventType, ":").concat(event.delta);
    }

    if (event.eventType === 'join' && event.result === 'failed') {
      // upload 'stat-join-failed-${code}' to kibana
      msg = "stat-".concat(event.eventType, "-").concat(event.result, "-").concat(event.code);
    }
  }; // logEvent is used to upload the key events to remote server so that it can check
  // the overall connection stats from http://monitor.server.com/link/graph/viewid:18025


  var logEvent = function logEvent(event) {
    if (config$1.env === 'qcloud') {
      // collect cloud env's stats only
      uploadEventToKibana(event);
    } // const message = { ...event, ...config };
    // axios
    //   .post(url, JSON.stringify(message))
    //   .then(function(response) {
    //     // console.log(response);
    //   })
    //   .catch(function(error) {
    //     console.log(error);
    //   });

  };

  // eventId used to show the events on avmonitor sender/receiver details page
  var EventId = {
    PUBLISH_VIDEO: 0x8000,
    // 打开视频
    PUBLISH_AUDIO: 0x8001,
    // 打开音频
    UNPUBLISH_VIDEO: 0x8002,
    // 关闭视频
    UNPUBLISH_AUDIO: 0x8003,
    // 关闭音频
    MUTE_AUDIO: 0x8004,
    // 关闭音频 (仍发送静音包)
    MUTE_VIDEO: 0x8005,
    // 关闭视频 (仍发送黑屏包)
    UNMUTE_AUDIO: 0x8006,
    // 打开音频
    UNMUTE_VIDEO: 0x8007,
    // 打开视频
    SUBSCRIBE_VIDEO: 0x8008,
    // 订阅视频
    SUBSCRIBE_AUDIO: 0x8009,
    // 订阅音频
    UNSUBSCRIBE_VIDEO: 0x800a,
    // 取消订阅视频
    UNSUBSCRIBE_AUDIO: 0x800b,
    // 取消订阅音频
    SWITCH_CAMERA: 0x800c,
    // 切换摄像头
    SWITCH_MICROPHONE: 0x800d,
    // 切换麦克风
    REPLACE_VIDEO: 0x800e,
    // 更新视频
    REPLACE_AUDIO: 0x800f,
    // 更新音频
    MUTE_REMOTE_VIDEO: 0x8010,
    // 关闭远端视频
    MUTE_REMOTE_AUDIO: 0x8011,
    // 关闭远端音频
    UNMUTE_REMOTE_VIDEO: 0x8012,
    // 打开远端视频
    UNMUTE_REMOTE_AUDIO: 0x8013,
    // 打开远端音频
    JOIN: 0x8014,
    // 进房
    LEAVE: 0x8015,
    // 退房
    SIGNAL_DISCONNECTED: 0x8016,
    // 信令通道断开
    SIGNAL_CONNECTED: 0x8017,
    // 信令通道连接成功
    TRANSPORT_DISCONNECTED: 0x8018,
    // 媒体传输通道断开
    TRANSPORT_CONNECTED: 0x8019 // 媒体传输通道连接成功

  };
  var eventHub = new Map(); // add events to the hub

  var addEvent = function addEvent(userId, event) {
    var list = eventHub.get(userId);

    if (!list) {
      eventHub.set(userId, []);
      list = eventHub.get(userId);
    }

    list.push(event);
  }; // get the events and clear them in the hub


  var getEvents = function getEvents(userId) {
    var list = eventHub.get(userId);

    if (!list) {
      list = [];
    } else {
      eventHub["delete"](userId);
    }

    return list;
  };

  var RECONNECT_TRY_COUNT = 0; // 重连间隔事件

  var RECONNECT_TIMEOUT = 50;
  /**
   *
   *
   * @class SignalChannel
   */

  var SignalChannel = /*#__PURE__*/function () {
    function SignalChannel(options) {
      _classCallCheck(this, SignalChannel);

      this.sdkAppId_ = options.sdkAppId;
      this.userId_ = options.userId;
      this.userSig_ = options.userSig;
      this.roomId_ = options.roomId_;
      this.url_ = options.url;
      this.backupUrl_ = options.backupUrl;
      this.version_ = options.version; // this.urlWithParam_ = `${this.url_}?sdkAppid=${this.sdkAppId_}&identifier=${this.userId_}&userSig=${this.userSig_}`;

      this.urlWithParam_ = "".concat(this.url_, "?sdkAppid=").concat(this.sdkAppId_, "&roomId=").concat(this.roomId_, "&identifier=").concat(this.userId_, "&tinyid=").concat(this.userId_, "&privMapEncrypt=").concat(this.userSig_); // this.backupUrlWithParam_ = `${this.backupUrl_}?sdkAppid=${this.sdkAppId_}&identifier=${this.userId_}&userSig=${this.userSig_}`;

      this.backupUrlWithParam_ = "".concat(this.backupUrl_, "?sdkAppid=").concat(this.sdkAppId_, "&roomId=").concat(this.roomId_, "&identifier=").concat(this.userId_, "&tinyid=").concat(this.userId_, "&privMapEncrypt=").concat(this.userSig_);
      this.isConnected_ = false;
      this.isConnecting_ = false;
      this.tryCount_ = RECONNECT_TRY_COUNT;
      this.socketInUse_ = null;
      this.socket_ = null;
      this.backupSocket_ = null;
      this.backupTimer_ = -1;
      this.reconnectTimer_ = -1;
      this.signalInfo_ = {};
      this.currentState_ = ConnectionState.DISCONNECTED;
      this.emitter_ = new eventemitter3();
    }
    /**
     * Connect to Signal Server via WebSocket
     *
     * @memberof SignalChannel
     */


    _createClass(SignalChannel, [{
      key: "connect",
      value: function connect() {
        var _this = this;

        logger.info("connect to url: ".concat(this.urlWithParam_));
        this.emitter_.emit(ChannelEvent.CONNECTION_STATE_CHANGED, {
          prevState: this.currentState_,
          state: ConnectionState.CONNECTING
        });
        this.currentState_ = ConnectionState.CONNECTING;
        this.socket_ = new WebSocket(this.urlWithParam_);
        this.bindSocket(this.socket_); // try connecting to backupUrl in 1s

        this.backupTimer_ = setTimeout(function () {
          if (_this.isConnected_) return;
          logger.info('trying to connect to backupUrl');

          _this.tryConnectBackup();
        }, 1000);
      }
      /**
       * try to connect to backup domain
       *
       * @private
       * @memberof SignalChannel
       */

    }, {
      key: "tryConnectBackup",
      value: function tryConnectBackup() {
        if (this.backupSocket_) return;
        logger.debug("try to connect to url: ".concat(this.backupUrlWithParam_));
        this.backupSocket_ = new WebSocket(this.backupUrlWithParam_);
        this.bindSocket(this.backupSocket_);
      }
      /**
       * bind WebSocket callbacks
       *
       * @private
       * @param {WebSocket} socket
       * @memberof SignalChannel
       */

    }, {
      key: "bindSocket",
      value: function bindSocket(socket) {
        socket.onopen = this.onopen.bind(this);
        socket.onclose = this.onclose.bind(this);
        socket.onerror = this.onerror.bind(this);
        socket.onmessage = this.onmessage.bind(this);
      }
    }, {
      key: "unbindSocket",
      value: function unbindSocket(socket) {
        socket.onopen = function () {};

        socket.onclose = function () {};

        socket.onerror = function () {};

        socket.onmessage = function () {};
      }
    }, {
      key: "unbindAndCloseSocket",
      value: function unbindAndCloseSocket(type) {
        if (type === 'main') {
          if (this.socket_) {
            this.unbindSocket(this.socket_);

            try {
              this.socket_.close(1000);
            } catch (e) {// ignore
            }

            this.socket_ = null;
          }
        } else {
          if (this.backupSocket_) {
            this.unbindSocket(this.backupSocket_);

            try {
              this.backupSocket_.close(1000);
            } catch (e) {// ignore
            }

            this.backupSocket_ = null;
          }
        }
      }
    }, {
      key: "clearBackupTimer",
      value: function clearBackupTimer() {
        if (this.backupTimer_ !== -1) {
          clearTimeout(this.backupTimer_);
          this.backupTimer_ = -1;
        }
      }
      /**
       * WebSocket.onopen callback
       *
       * @private
       * @param {Event} event
       * @memberof SignalChannel
       */

    }, {
      key: "onopen",
      value: function onopen(event) {
        if (this.isConnected_) return;

        if (this.isConnecting_) {
          logEvent({
            eventType: 'websocketReconnectionState',
            result: 'success'
          });
        } else {
          logEvent({
            eventType: 'websocketConnectionState',
            result: 'success'
          });
        }

        this.isConnected_ = true;
        this.isConnecting_ = false; // ensure backup timer is cleared

        this.clearBackupTimer();

        if (event.target === this.socket_) {
          // ensure backup is closed
          this.unbindAndCloseSocket('backup');
          this.socketInUse_ = this.socket_;
        } else {
          // ensure main is closed
          this.unbindAndCloseSocket('main');
          this.socketInUse_ = this.backupSocket_;
        }

        var url = event.target.url;
        logger.info("[".concat(this.userId_, "] websocket[").concat(url, "] is connected"));
        this.emitter_.emit(ChannelEvent.CONNECTION_STATE_CHANGED, {
          prevState: this.currentState_,
          state: ConnectionState.CONNECTED
        });
        this.currentState_ = ConnectionState.CONNECTED;
      }
      /**
       * WebSocket.onclose callback
       *
       * @private
       * @param {CloseEvent} event
       * @memberof SignalChannel
       */

    }, {
      key: "onclose",
      value: function onclose(event) {
        var url = event.target.url;
        var isInUse = event.target === this.socketInUse_;
        logger.info("[".concat(this.userId_, "] websocket[").concat(url, " InUse: ").concat(isInUse, "] is closed with code: ").concat(event.code)); // only handle the close event for the socket in use

        if (event.target === this.socketInUse_) {
          // mark the SignalChannel is disconnected
          this.isConnected_ = false;
          this.addSignalEvent('disconnected'); // 1000 is considered as normal close

          if (event.wasClean && event.code === 1000) {
            this.emitter_.emit(ChannelEvent.CONNECTION_STATE_CHANGED, {
              prevState: this.currentState_,
              state: ConnectionState.DISCONNECTED
            });
            this.currentState_ = ConnectionState.DISCONNECTED;
          } else {
            logger.warn("[".concat(this.userId_, "] onclose code:").concat(event.code, " reason:").concat(event.reason));

            if (this.isConnecting_ && this.tryCount_ <= 0) {
              this.isConnecting_ = false;
              this.tryCount_ = RECONNECT_TRY_COUNT;
              logger.error("[".concat(this.userId_, "] reconnect failed"));
              this.emitter_.emit(ChannelEvent.CONNECTION_STATE_CHANGED, {
                prevState: this.currentState_,
                state: ConnectionState.DISCONNECTED
              });
              this.currentState_ = ConnectionState.DISCONNECTED;
              logEvent({
                eventType: 'websocketReconnectionState',
                result: 'failed'
              }); // reconnection failure should be considered as Error

              this.emitter_.emit(ChannelEvent.ERROR, new RtcError({
                code: ErrorCode.SIGNAL_CHANNEL_ERROR,
                message: 'WebSocket reconnection failed'
              }));
            } else {
              logger.warn('close current websocket and schedule a reconnect timeout');

              this.socketInUse_.onclose = function () {}; // 4011 indicates that we want reconnect with new WebSocket


              this.socketInUse_.close(4011);
              this.socket_ = this.backupSocket_ = this.socketInUse_ = null;
              this.emitter_.emit(ChannelEvent.ERROR, new RtcError({
                code: ErrorCode.ICE_TRANSPORT_BROKE,
                message: 'WebSocket reconnection failed'
              })); // try reconnect
              // this.reconnect(url);
            }
          }
        }
      }
      /**
       * WebSocket.onerror callback
       *
       * @private
       * @param {Event} event
       * @memberof SignalChannel
       */

    }, {
      key: "onerror",
      value: function onerror(event) {
        var url = event.target.url;
        logger.error("[".concat(this.userId_, "] websocket[").concat(url, "] error observed"));

        if (!this.isConnected_) {
          if (event.target == this.socket_) {
            // ensure main is closed
            this.unbindAndCloseSocket('main'); // try backup only when it's not reconnecting.

            if (!this.isConnecting_) {
              // try to connect to backup domain immediately
              logger.warn('main socket error observed, try connecting to backup domain');
              this.tryConnectBackup();
            }
          } else {
            // ensure backup is closed
            this.unbindAndCloseSocket('backup');
          }

          if (this.socket_ === null && this.backupSocket_ === null) {
            if (this.isConnecting_) {
              logEvent({
                eventType: 'websocketReconnectionState',
                result: 'failed'
              });
            } else {
              logEvent({
                eventType: 'websocketConnectionState',
                result: 'failed'
              });
            }

            logger.error('SignalChannel setup failed');
            this.emitter_.emit(ChannelEvent.ERROR, new RtcError({
              code: ErrorCode.SIGNAL_CHANNEL_ERROR,
              message: 'failed to connect to remote server via websocket'
            }));
          }
        } else if (event.target === this.socketInUse_) {
          this.isConnected_ = false;
          this.unbindAndCloseSocket('main');
          this.unbindAndCloseSocket('backup');
          this.socketInUse_ = null;
          this.addSignalEvent('disconnected');
          this.emitter_.emit(ChannelEvent.ERROR, new RtcError({
            code: ErrorCode.SIGNAL_CHANNEL_ERROR,
            message: 'WebSocket error observed'
          }));
        }
      }
      /**
       * WebSocket.onmessage callback
       *
       * @private
       * @param {MessageEvent} event the MessageEvent received from WebSocket
       * @memberof SignalChannel
       */

    }, {
      key: "onmessage",
      value: function onmessage(event) {
        var _this2 = this;

        if (!this.isConnected_) return; // close was requested.

        var data = JSON.parse(event.data);
        var eventCode = data.cmd;
        var content = data.content;
        var signalEventValues = Object.values(SignalEventMap);
        var signalEventKeys = Object.keys(SignalEventMap);
        var index = signalEventKeys[signalEventValues.indexOf(eventCode)];
        var eventName = SignalEvent[index]; // filter out the annoying message

        if (eventCode !== SignalEventMap.UPDATE_REMOTE_MUTE_STAT) {
          var url = event.target == this.socket_ ? this.url_ : this.backupUrl_;
          logger.debug("[".concat(this.userId_, "] websocket[").concat(url, "] received message: ").concat(event.data));
          logger.info("[".concat(this.userId_, "] Received event: [ ").concat(eventName, " ]"));
        }

        switch (eventCode) {
          case SignalEventMap.CHANNEL_SETUP_SUCCESS:
            {
              this.signalInfo_.relayChanged = false;

              if (this.signalInfo_.relayIp && this.signalInfo_.relayIp.localeCompare(content.relayip) == 0) {
                this.signalInfo_.relayChanged = true;
              }

              this.signalInfo_.relayIp = content.relayip;
              this.signalInfo_.relayInnerIp = content.innerip;
              this.signalInfo_.signalIp = content.signalip;
              this.signalInfo_.localIp = content.localip;
              this.signalInfo_.dataPort = content.dataport;
              this.signalInfo_.stunPort = content.stunport;
              this.signalInfo_.checkSigSeq = content.checkSigSeq;
              this.signalInfo_.socketId = content.socketid;
              this.signalInfo_.tinyId = content.tinyid;
              this.signalInfo_.openId = content.openid;
              this.signalInfo_.roomId = content.roomid;
              this.signalInfo_.stunPortList = content.stunportList;

              if (!content.stunportList || content.stunportList.length <= 0) {
                this.signalInfo_.stunServers = 'stun:' + content.relayip + ':' + content.stunport;
              } else {
                this.signalInfo_.stunServers = [];
                content.stunportList.forEach(function (port) {
                  var server = 'stun:' + content.relayip + ':' + port;

                  _this2.signalInfo_.stunServers.push(server);
                });
              }

              if (content.cgiurl) {
                this.signalInfo_.logCgiUrl = content.cgiurl;
              }

              if (content.svrTime) {
                setBaseTime(content.svrTime);
              }

              logger.info("ChannelSetup Success: signalIp:".concat(content.signalip, " relayIp:").concat(content.relayip, " checkSigSeq:").concat(content.checkSigSeq));
              var isReconnect = content.rc || 0;

              if (isReconnect === 1) {
                this.emitter_.emit(SignalEvent.REQUEST_REBUILD_SESSION, {
                  signalInfo: this.signalInfo_
                });
              } else {
                this.emitter_.emit(eventName, {
                  signalInfo: this.signalInfo_
                });
              }

              this.addSignalEvent('connected');
              break;
            }

          case SignalEventMap.CHANNEL_SETUP_FAILED:
            {
              var errorCode = 'sdkAppId invalid';
              var errorMsg = '';

              if (typeof content.errorCode !== 'undefined') {
                errorCode = content.errorCode;
                errorMsg = content.errorMsg;
              }

              this.emitter_.emit(ChannelEvent.ERROR, new RtcError({
                code: ErrorCode.SIGNAL_CAHNNEL_SETUP_FAILED,
                message: "SignalChannel setup failure: ('errorCode': ".concat(errorCode, ", 'errorMsg': ").concat(errorMsg, " })")
              }));
              break;
            }

          case SignalEventMap.CHANNEL_RECONNECT_RESULT:
            {
              if (content.result === -1) {
                logger.error('SignalChannel reconnect failed for the user may have left the room from the perspective of remote relay server');
                logEvent({
                  eventType: 'websocketReconnectionState',
                  result: 'failed'
                });
                this.addSignalEvent('disconnected');
                this.emitter_.emit(ChannelEvent.ERROR, new RtcError({
                  code: ErrorCode.SIGNAL_CAHNNEL_ERROR,
                  message: "SignalChannel reconnect failed"
                }));
              }

              break;
            }

          case SignalEventMap.AUDIO_MODE_RESULT:
            {
              if (content.result !== 0) {
                logger.error("SetRangeAudioMode failed! errorCode: ".concat(content.result));
                this.emitter_.emit(ChannelEvent.ERROR, new RtcError({
                  code: ErrorCode.AUDIO_MODE_ERROR,
                  message: "SetRangeAudioMode failed"
                }));
              }

              break;
            }

          case SignalEventMap.UPDATE_SELF_POSITION:
            {
              if (content.result !== 0) {
                logger.error("UpdateSelfPosition failed! errorCode: ".concat(content.result));
                this.emitter_.emit(ChannelEvent.ERROR, new RtcError({
                  code: ErrorCode.UPDATE_SELF_POSITION_ERROR,
                  message: "UpdateSelfPosition failed"
                }));
              }

              break;
            }

          default:
            // 0x12 退出
            this.emitter_.emit(eventName, {
              /** @type {MessageEvent.data} */
              data: data
            });
            break;
        }
      }
    }, {
      key: "addSignalEvent",
      value: function addSignalEvent(state) {
        if (state === 'connected') {
          addEvent(this.userId_, {
            eventId: EventId.SIGNAL_CONNECTED,
            eventDesc: 'signal channel is connected',
            timestamp: getCurrentTime(),
            userId: this.userId_,
            tinyId: this.signalInfo_.tinyId
          });
        } else {
          addEvent(this.userId_, {
            eventId: EventId.SIGNAL_DISCONNECTED,
            eventDesc: 'signal channel is disconnected',
            timestamp: getCurrentTime(),
            userId: this.userId_,
            tinyId: this.signalInfo_.tinyId
          });
        }
      }
      /**
       * reconnect to signal server
       *
       * @private
       * @param {string} url wss url to which connect
       * @memberof SignalChannel
       */

    }, {
      key: "reconnect",
      value: function reconnect(url) {
        var _this3 = this;

        var timeout = RECONNECT_TIMEOUT;
        this.reconnectTimer_ = setTimeout(function () {
          _this3.isConnecting_ = true;
          _this3.tryCount_ -= 1;
          var finalUrl = url; // avoid inserting dup extra parameters after reconnect retry.
          // if (!isEmpty(this.signalInfo_) && url.indexOf('&rc=1') === -1) {
          //   finalUrl =
          //     url +
          //     '&iip=' +
          //     this.signalInfo_.relayInnerIp +
          //     '&dp=' +
          //     this.signalInfo_.dataPort +
          //     '&oip=' +
          //     this.signalInfo_.relayIp +
          //     '&sp=' +
          //     this.signalInfo_.stunPort +
          //     '&rc=1';
          // }

          if (url.indexOf('&rc=1') === -1) {
            finalUrl = url + '&rc=1';
          }

          _this3.emitter_.emit(ChannelEvent.CONNECTION_STATE_CHANGED, {
            prevState: _this3.currentState_,
            state: ConnectionState.RECONNECTING
          });

          _this3.currentState_ = ConnectionState.RECONNECTING;
          _this3.socket_ = new WebSocket(finalUrl);

          _this3.bindSocket(_this3.socket_);
        }, timeout);
      }
    }, {
      key: "isConnected",
      value: function isConnected() {
        return this.isConnected_;
      }
      /**
       * Send command to signal server
       *
       * @see {@link signal-event.SignalCommand}
       * @param {string} command the signal command sent to signal server
       * @param {object} data the data of the command
       * @memberof SignalChannel
       */

    }, {
      key: "send",
      value: function send(command) {
        var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
        var target = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;

        if (this.isConnected_) {
          var sendMessage = this.createSendMessage(command);
          sendMessage.data = data;

          if (target !== undefined) {
            sendMessage.srctinyid = target;
          }

          this.socketInUse_.send(JSON.stringify(sendMessage));
        }
      } // ugly message format requested by backend, sigh!

    }, {
      key: "sendWithReport",
      value: function sendWithReport(command) {
        var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
        var report = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';

        if (this.isConnected_) {
          var sendMessage = this.createSendMessage(command);
          sendMessage.data = data;

          if (report != undefined && report != '') {
            sendMessage.report = report;
          }

          this.socketInUse_.send(JSON.stringify(sendMessage));
        }
      }
      /**
       * create send message header
       *
       * @private
       * @param {string} command
       * @returns
       * @memberof SignalChannel
       */

    }, {
      key: "createSendMessage",
      value: function createSendMessage(command) {
        return {
          tag_key: command,
          data: '',
          openid: this.userId_,
          tinyid: this.signalInfo_.tinyId,
          version: this.version_,
          ua: navigator.userAgent
        };
      }
      /**
       * close the SignalChannel
       *
       * @memberof SignalChannel
       */

    }, {
      key: "close",
      value: function close() {
        logger.info('close SignalChannel');

        if (this.reconnectTimer_ !== -1) {
          clearTimeout(this.reconnectTimer_);
          this.reconnectTimer_ = -1;
        }

        this.clearBackupTimer();
        this.isConnected_ = false;
        this.socketInUse_ = null;
        this.unbindAndCloseSocket('main');
        this.unbindAndCloseSocket('backup');
      }
      /**
       * add event listeners onto SignalChannel
       *
       * @param {String} event
       * @param {function} handler
       * @param {*} context
       * @memberof SignalChannel
       */

    }, {
      key: "on",
      value: function on(event, handler, context) {
        this.emitter_.on(event, handler, context);
      }
    }, {
      key: "removeListener",
      value: function removeListener(event, handler, context) {
        this.emitter_.removeListener(event, handler, context);
      }
      /**
       * add event listeners onto SignalChannel, the handler will be called once and then unregistered.
       *
       * @param {string} event
       * @param {function} handler
       * @memberof SignalChannel
       */

    }, {
      key: "once",
      value: function once(event, handler) {
        this.emitter_.once(event, handler);
      }
    }]);

    return SignalChannel;
  }();

  /* eslint-disable require-jsdoc */
  // Last time updated on: June 08, 2018
  // Latest file can be found here: https://cdn.webrtc-experiment.com/Screen-Capturing.js
  // Muaz Khan     - www.MuazKhan.com
  // MIT License   - www.WebRTC-Experiment.com/licence
  // Documentation - https://github.com/muaz-khan/Chrome-Extensions/tree/master/Screen-Capturing.js
  // Demo          - https://www.webrtc-experiment.com/Screen-Capturing/
  // ___________________
  // Screen-Capturing.js
  // Source code: https://github.com/muaz-khan/Chrome-Extensions/tree/master/desktopCapture
  // Google AppStore installation path: https://chrome.google.com/webstore/detail/screen-capturing/ajhifddimkapgcifgcodmmfdlknahffk
  // This JavaScript file is aimed to explain steps needed to integrate above chrome extension
  // in your own webpages
  // Usage:
  // getScreenConstraints(function(screen_constraints) {
  //    navigator.mediaDevices.getUserMedia({ video: screen_constraints }).then(onSuccess).catch(onFailure );
  // });
  // First Step: Download the extension, modify "manifest.json" and publish to Google AppStore
  //             https://github.com/muaz-khan/Chrome-Extensions/tree/master/desktopCapture#how-to-publish-yourself
  // Second Step: Listen for postMessage handler
  // postMessage is used to exchange "sourceId" between chrome extension and you webpage.
  // though, there are tons other options as well, e.g. XHR-signaling, websockets, etc.
  window.addEventListener('message', function (event) {
    if (event.origin != window.location.origin) {
      return;
    }

    onMessageCallback(event.data);
  }); // and the function that handles received messages

  function onMessageCallback(data) {
    // "cancel" button is clicked
    if (data == 'PermissionDeniedError') {
      throw new Error('PermissionDeniedError');
    } // extension notified his presence


    if (data.sourceId && screenCallback) {
      screenCallback();
    }
  } // global variables
  var screenCallback; // this method can be used to check if chrome extension is installed & enabled.
  var isOpera = !!window.opera || navigator.userAgent.indexOf(' OPR/') >= 0;

  var isWebRTCSupported = function isWebRTCSupported() {
    var isSupported = false;
    ['RTCPeerConnection', 'webkitRTCPeerConnection', 'RTCIceGatherer'].forEach(function (api) {
      if (api in window) {
        isSupported = true;
      }
    });
    return isSupported;
  };
  var isUnifiedPlanDefault = function isUnifiedPlanDefault() {
    // old browser doesn't support this interface and it's in plan-b
    if (typeof RTCRtpTransceiver === 'undefined') {
      return false;
    } // Safari supports addTransceiver() but not Unified Plan when
    // currentDirection is not defined.
    // eslint-disable-next-line no-undef


    if (!('currentDirection' in RTCRtpTransceiver.prototype)) return false; // If Unified Plan is supported, addTransceiver() should not throw.

    var peer = new RTCPeerConnection();
    var canAddTransceiver = false;

    try {
      peer.addTransceiver('audio');
      canAddTransceiver = true;
    } catch (e) {// ignore
    }

    peer.close();
    return canAddTransceiver;
  };
  var isScreenCaptureApiAvailable = function isScreenCaptureApiAvailable() {
    var isSupported = false;

    if (navigator.mediaDevices && navigator.mediaDevices.getDisplayMedia) {
      isSupported = true;
    }

    return isSupported;
  };
  var isSystemReqChecked = false;
  var cachedSystemReqCheckResult = true;
  var checkSystemRequirementsInternal = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
      var result, isRTCSupported, isAVCSupported;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!isSystemReqChecked) {
                _context2.next = 2;
                break;
              }

              return _context2.abrupt("return", cachedSystemReqCheckResult);

            case 2:
              // check blacklists
              result = true; // !env.IS_FIREFOX &&
              // !env.IS_MQQB &&
              // !env.IS_UCBROWSER &&
              // !env.IS_MIUIBROWSER &&
              // !env.IS_HUAWEIBROWSER;

              if (result) {
                // check WebRTC Api
                isRTCSupported = isWebRTCSupported();
                isAVCSupported = true; // if (isRTCSupported) {
                //   // check H264 encoding capability
                //   isAVCSupported = await isH264Supported();
                // }

                result = isRTCSupported && isAVCSupported;

                if (!result) {
                  logger.error("".concat(navigator.userAgent, " isWebRTCSupported: ").concat(isRTCSupported, " isH264Supported: ").concat(isAVCSupported));
                }
              } else {
                logger.error("blacklist: ".concat(navigator.userAgent));
              }

              isSystemReqChecked = true;
              cachedSystemReqCheckResult = result;
              return _context2.abrupt("return", result);

            case 7:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function checkSystemRequirementsInternal() {
      return _ref2.apply(this, arguments);
    };
  }();
  var isTRTCSupported = function isTRTCSupported() {
    return isSystemReqChecked ? cachedSystemReqCheckResult : true;
  }; // invoke this during page load to ensure system requirements is checked.

  checkSystemRequirementsInternal();

  /**
   * WebSocket main url of the signal server
   * 国内站：isInland = true
   * 国际站：isInland = false
   */
  var mainUrl =  'wss://gme.h5.rtc.qcloud.qq.com:8687' ;
  var mainUrlTest = 'wss://test.rtc.qcloud.qq.com:8687';
  /**
   * WebSocket backup url of the signal server
   */

  var backupUrl =  'wss://gme.h5.rtc.qcloud.qq.com:8687' ;
  var backupUrlTest = 'wss://test.rtc.qcloud.qq.com:8687';
  /**
   * Mode defined by backend
   */

  var Mode = {
    RTC: 1,
    LIVE: 2
  };
  /**
   * Role definied by backend
   */

  var Role = {
    HOST: 20,
    AUDIENCE: 21
  };
  /**
   * uplink connection's muted flag defined by backend
   */

  var VIDEO_MUTED_MASK = 0x01;
  var AUDIO_MUTED_MASK = 0x04;
  /**
   * Stream MSID
   */

  var MAIN_STREAM_MSID = '5Y2wZK8nANNAoVw6dSAHVjNxrD1ObBM2kBPV';
  var AUX_STREAM_MSID = '224d130c-7b5c-415b-aaa2-79c2eb5a6df2';
  /**
   * Stream type defined by backend, used in type deduced from ssrc ID
   */

  var StreamType = {
    NONE: 0,
    AUDIO: 1,
    // audio
    MAIN: 2,
    // main video
    AUX: 7 // auxiliary video

  };

  var $find = arrayIteration.find;


  var FIND = 'find';
  var SKIPS_HOLES = true;

  // Shouldn't skip holes
  if (FIND in []) Array(1)[FIND](function () { SKIPS_HOLES = false; });

  // `Array.prototype.find` method
  // https://tc39.es/ecma262/#sec-array.prototype.find
  _export({ target: 'Array', proto: true, forced: SKIPS_HOLES }, {
    find: function find(callbackfn /* , that = undefined */) {
      return $find(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
    }
  });

  // https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
  addToUnscopables(FIND);

  /**
   *  UUID generator - RFC4122 version 4 compliant solution
   */
  var generateUUID = function generateUUID() {
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
      var r = Math.random() * 16 | 0,
          v = c == 'x' ? r : r & 0x3 | 0x8;
      return v.toString(16);
    });
  };

  /*
   * Connection's Event
   */
  var ConnectionEvent = {
    STREAM_ADDED: 'stream-added',
    STREAM_REMOVED: 'stream-removed',
    STREAM_UPDATED: 'stream-updated',
    STREAM_PUBLISHED: 'stream-published',
    STREAM_SUBSCRIBED: 'stream-subscribed',
    STREAM_UNSUBSCRIBED: 'stream-unsubscribed',
    STATE_CHANGED: 'state-changed',
    ERROR: 'error',
    CONNECTION_STATE_CHANGED: 'connection-state-changed'
  };
  /**
   * **客户端事件列表**<br>
   * <br>
   * `Client.on('eventName')` 事件监听中的事件名称。
   *
   * @module Event
   */

  var ClientEvent = {
    /**
     * @description 远端流添加事件，当远端用户发布流后会收到该通知。
     * @default 'stream-added'
     * @memberOf module:Event
     * @example
     * client.on('stream-added', event => {
     *   const remoteStream = event.stream;
     * });
     */
    STREAM_ADDED: 'stream-added',

    /**
     * @description 远端流移除事件，当远端用户取消发布流后会收到该通知。
     * @default 'stream-removed'
     * @memberOf module:Event
     * @example
     * client.on('stream-removed', event => {
     *   const remoteStream = event.stream;
     * });
     */
    STREAM_REMOVED: 'stream-removed',

    /**
     * @description 远端流更新事件，当远端用户添加、移除或更换音视频轨道后会收到该通知。
     * @default 'stream-updated'
     * @memberOf module:Event
     * @example
     * client.on('stream-updated', event => {
     *   const remoteStream = event.stream;
     * });
     */
    STREAM_UPDATED: 'stream-updated',

    /**
     * @description 远端流订阅成功事件，调用 {@link Client#subscribe subscribe()} 成功后会触发该事件。
     * @default 'stream-subscribed'
     * @memberOf module:Event
     * @example
     * client.on('stream-subscribed', event => {
     *   const remoteStream = event.stream;
     * });
     */
    STREAM_SUBSCRIBED: 'stream-subscribed',

    /**
     * @description WebSocket 信令通道连接状态变化事件
     * - ‘DISCONNECTED’：连接断开
     * - ‘CONNECTING’：正在连接中
     * - ‘RECONNECTING’：自动重连中
     * - ‘CONNECTED’：已连接
     * @default 'connection-state-changed'
     * @memberof module:Event
     * @example
     * client.on('connection-state-changed', event => {
     *   const prevState = event.prevState;
     *   const curState = event.state;
     * });
     */
    CONNECTION_STATE_CHANGED: 'connection-state-changed',

    /**
     * @description 远端用户进房通知，只有主动推流的远端用户进房才会收到该通知。
     *
     * **注意：**
     * - 目前 `peer-join/peer-leave` 事件尚不是严格意义上的用户进退房通知，房间内成员状态管理请使用腾讯云 {@link https://cloud.tencent.com/product/im|WebIM SDK} 或其他信令机制。
     * @default 'peer-join'
     * @memberof module:Event
     * @example
     * client.on('peer-join', event => {
     *   const userId = event.userId;
     * });
     */
    PEER_JOIN: 'peer-join',

    /**
     * @description 远端用户退房通知，只有主动推流的远端用户退房才会收到该通知。
     * @default 'peer-leave'
     * @memberof module:Event
     * @example
     * client.on('peer-leave', event => {
     *   const userId = event.userId;
     * });
     */
    PEER_LEAVE: 'peer-leave',

    /**
     * @description 远端用户禁用音频通知。
     * @default 'mute-audio'
     * @memberof module:Event
     * @example
     * client.on('mute-audio', event => {
     *   const userId = event.userId;
     * });
     */
    MUTE_AUDIO: 'mute-audio',

    /**
     * @description 远端用户禁用视频通知。
     * @default 'mute-video'
     * @memberof module:Event
     * @example
     * client.on('mute-video', event => {
     *   const userId = event.userId;
     * });
     */
    MUTE_VIDEO: 'mute-video',

    /**
     * @description 远端用户启用音频通知。
     * @default 'unmute-audio'
     * @memberof module:Event
     * @example
     * client.on('unmute-audio', event => {
     *   const userId = event.userId;
     * });
     */
    UNMUTE_AUDIO: 'unmute-audio',

    /**
     * @description 远端用户启用视频通知。
     * @default 'unmute-video'
     * @memberof module:Event
     * @example
     * client.on('unmute-video', event => {
     *   const userId = event.userId;
     * });
     */
    UNMUTE_VIDEO: 'unmute-video',

    /**
     * @description 用户被踢出房间通知，被踢原因有：
     * - 同名用户登录，**注意：同名用户同时登陆是不允许的行为，可能会导致双方音视频通话异常，此乃应用业务逻辑错误！**
     * - 被账户管理员主动踢出房间
     *
     * **建议：**
     * - 房间内成员状态管理请使用腾讯云 {@link https://cloud.tencent.com/product/im|WebIM SDK} 或其他信令机制。
     * @default 'client-banned'
     * @memberof module:Event
     * @example
     * client.on('client-banned', error => {
     *   console.error('client-banned observed: ' + error);
     *   // 退出刷新页面
     * });
     */
    CLIENT_BANNED: 'client-banned',

    /**
     * @description 客户端错误事件，当出现不可恢复错误后 Client 会通过该事件上报。
     * @default 'error'
     * @memberof module:Event
     * @example
     * client.on('error', error => {
     *   console.error('client error observed: ' + error);
     *   const errorCode = error.getCode();
     *   // 请根据错误码列表(https://cloud.tencent.com/document/product/647/34342)查看错误类型。
     *   // 当出现客户端错误后，请调用 Client.leave() 退房并尝试通过 Client.join() 重新进房恢复通话。
     * });
     */
    ERROR: 'error'
  };
  /**
   * **Stream 事件列表**
   * Stream.on() 监听的事件。
   *
   * @name module:Event.StreamEvent
   */

  var StreamEvent = {
    /**
     * @description Audio/Video Player 状态变化事件
     * App 可根据状态变化来更新 UI，比如，通过监听 video player 状态变化来关闭或打开遮板。
     * - 'PLAYING'：开始播放
     * - 'PAUSED'：暂停播放
     *   - event.reason 为 ‘pause’ 时，由 \<audio\>/\<video\> element 的 pause 事件触发，如果在 Stream.play() 后
     * App 移动相关 div 容器，在 Chrome M70 版本以下的浏览器上可能会触发该事件，此时您需要调用 Stream.resume() 继续播放。
     *   - event.reason 为 ‘mute’ 时，表明音视频轨道暂时未能提供数据
     *
     * - 'STOPPED'：停止播放
     *
     * reason 状态变化原因：
     * - ‘playing’：开始播放，详见事件 {@link https://developer.mozilla.org/en-US/docs/Web/API/HTMLMediaElement/playing_event | HTMLMediaElement.playing_event}
     * - ‘mute’：音视频轨道暂时未能提供数据，详见事件 {@link https://developer.mozilla.org/en-US/docs/Web/API/MediaStreamTrack/mute_event | MediaStreamTrack.mute_event}
     * - ‘unmute’：音视频轨道恢复提供数据，详见事件 {@link https://developer.mozilla.org/en-US/docs/Web/API/MediaStreamTrack/unmute_event | MediaStreamTrack.unmute_event}
     * - ‘ended’：音视频轨道已被关闭
     * @default 'player-state-changed'
     * @memberof module:Event
     * @example
     * stream.on('player-state-changed', event => {
     *   console.log(`${event.type} player is ${event.state} because of ${event.reason}`);
     * });
     */
    PLAYER_STATE_CHANGED: 'player-state-changed',

    /**
     * @description 本地屏幕分享停止事件通知，仅对本地屏幕分享流有效。
     * @default 'screen-sharing-stopped'
     * @memberof module:Event
     * @example
     * stream.on('screen-sharing-stopped', () => {
     *   console.log('screen sharing was stopped');
     * });
     */
    SCREEN_SHARING_STOPPED: 'screen-sharing-stopped'
  };
  var PlayerEvent = {
    PLAYER_STATE_CHANGED: 'player-state-changed'
  };

  var RangeError$3 = global_1.RangeError;
  var String$6 = global_1.String;
  var floor$3 = Math.floor;
  var repeat$1 = functionUncurryThis(stringRepeat);
  var stringSlice$9 = functionUncurryThis(''.slice);
  var un$ToFixed = functionUncurryThis(1.0.toFixed);

  var pow = function (x, n, acc) {
    return n === 0 ? acc : n % 2 === 1 ? pow(x, n - 1, acc * x) : pow(x * x, n / 2, acc);
  };

  var log$1 = function (x) {
    var n = 0;
    var x2 = x;
    while (x2 >= 4096) {
      n += 12;
      x2 /= 4096;
    }
    while (x2 >= 2) {
      n += 1;
      x2 /= 2;
    } return n;
  };

  var multiply = function (data, n, c) {
    var index = -1;
    var c2 = c;
    while (++index < 6) {
      c2 += n * data[index];
      data[index] = c2 % 1e7;
      c2 = floor$3(c2 / 1e7);
    }
  };

  var divide = function (data, n) {
    var index = 6;
    var c = 0;
    while (--index >= 0) {
      c += data[index];
      data[index] = floor$3(c / n);
      c = (c % n) * 1e7;
    }
  };

  var dataToString = function (data) {
    var index = 6;
    var s = '';
    while (--index >= 0) {
      if (s !== '' || index === 0 || data[index] !== 0) {
        var t = String$6(data[index]);
        s = s === '' ? t : s + repeat$1('0', 7 - t.length) + t;
      }
    } return s;
  };

  var FORCED$5 = fails(function () {
    return un$ToFixed(0.00008, 3) !== '0.000' ||
      un$ToFixed(0.9, 0) !== '1' ||
      un$ToFixed(1.255, 2) !== '1.25' ||
      un$ToFixed(1000000000000000128.0, 0) !== '1000000000000000128';
  }) || !fails(function () {
    // V8 ~ Android 4.3-
    un$ToFixed({});
  });

  // `Number.prototype.toFixed` method
  // https://tc39.es/ecma262/#sec-number.prototype.tofixed
  _export({ target: 'Number', proto: true, forced: FORCED$5 }, {
    toFixed: function toFixed(fractionDigits) {
      var number = thisNumberValue(this);
      var fractDigits = toIntegerOrInfinity(fractionDigits);
      var data = [0, 0, 0, 0, 0, 0];
      var sign = '';
      var result = '0';
      var e, z, j, k;

      // TODO: ES2018 increased the maximum number of fraction digits to 100, need to improve the implementation
      if (fractDigits < 0 || fractDigits > 20) throw RangeError$3('Incorrect fraction digits');
      // eslint-disable-next-line no-self-compare -- NaN check
      if (number != number) return 'NaN';
      if (number <= -1e21 || number >= 1e21) return String$6(number);
      if (number < 0) {
        sign = '-';
        number = -number;
      }
      if (number > 1e-21) {
        e = log$1(number * pow(2, 69, 1)) - 69;
        z = e < 0 ? number * pow(2, -e, 1) : number / pow(2, e, 1);
        z *= 0x10000000000000;
        e = 52 - e;
        if (e > 0) {
          multiply(data, 0, z);
          j = fractDigits;
          while (j >= 7) {
            multiply(data, 1e7, 0);
            j -= 7;
          }
          multiply(data, pow(10, j, 1), 0);
          j = e - 1;
          while (j >= 23) {
            divide(data, 1 << 23);
            j -= 23;
          }
          divide(data, 1 << j);
          multiply(data, 1, 1);
          divide(data, 2);
          result = dataToString(data);
        } else {
          multiply(data, 0, z);
          multiply(data, 1 << -e, 0);
          result = dataToString(data) + repeat$1('0', fractDigits);
        }
      }
      if (fractDigits > 0) {
        k = result.length;
        result = sign + (k <= fractDigits
          ? '0.' + repeat$1('0', fractDigits - k) + result
          : stringSlice$9(result, 0, k - fractDigits) + '.' + stringSlice$9(result, k - fractDigits));
      } else {
        result = sign + result;
      } return result;
    }
  });

  // The meter class itself displays nothing, but it makes the
  // instantaneous and time-decaying volumes available for inspection.
  // It also reports on the fraction of samples that were at or near
  // the top of the measurement range.

  var AudioContext$1 = window.AudioContext || window.webkitAudioContext; // Prior to version 66 Google Chrome only supported up to six audio contexts per tab at a time.
  // to avoid running out of context limits, we use a shared context for all SoundMeters.

  var context = null;

  var SoundMeter = /*#__PURE__*/function () {
    function SoundMeter() {
      var _this = this;

      _classCallCheck(this, SoundMeter);

      if (!context) {
        context = new AudioContext$1();
      }

      this.context_ = context;
      this.instant_ = 0.0;
      this.slow_ = 0.0;
      this.clip_ = 0.0;
      this.script_ = this.context_.createScriptProcessor(2048, 1, 1);

      this.script_.onaudioprocess = function (event) {
        var input = event.inputBuffer.getChannelData(0);
        var i;
        var sum = 0.0;
        var clipcount = 0;

        for (i = 0; i < input.length; ++i) {
          sum += input[i] * input[i];

          if (Math.abs(input[i]) > 0.99) {
            clipcount += 1;
          }
        }

        _this.instant_ = Math.sqrt(sum / input.length);
        _this.slow_ = 0.95 * _this.slow_ + 0.05 * _this.instant_;
        _this.clip_ = clipcount / input.length;
      };
    }

    _createClass(SoundMeter, [{
      key: "connectToSource",
      value: function connectToSource(track, callback) {
        try {
          var stream = new MediaStream();
          stream.addTrack(track);
          this.mic_ = this.context_.createMediaStreamSource(stream);
          this.mic_.connect(this.script_); // necessary to make sample run, but should not be.

          this.script_.connect(this.context_.destination);

          if (typeof callback !== 'undefined') {
            callback(null);
          }
        } catch (e) {
          logger.error('soundMeter connectoToSource error: ' + e);

          if (typeof callback !== 'undefined') {
            callback(e);
          }
        }
      }
    }, {
      key: "stop",
      value: function stop() {
        this.mic_.disconnect();
        this.script_.disconnect();
      }
    }, {
      key: "getVolume",
      value: function getVolume() {
        return this.instant_.toFixed(2);
      }
    }]);

    return SoundMeter;
  }();

  var AudioPlayer = /*#__PURE__*/function () {
    function AudioPlayer(options) {
      _classCallCheck(this, AudioPlayer);

      // Stream this player belong to
      this.stream_ = options.stream;
      this.userId_ = options.stream.getUserId();
      this.log_ = this.stream_.getIDLogger(); // audio track to be played

      this.track_ = options.track; // the div container for appending <audio> element into

      this.div_ = options.div;
      this.muted_ = options.muted; // speaker output deviceId

      this.outputDeviceId_ = options.outputDeviceId;
      this.volume_ = options.volume;
      this.element_ = null;
      this.emitter_ = new eventemitter3();
      this.state_ = 'NONE';
      this.soundMeter_ = null;
    }

    _createClass(AudioPlayer, [{
      key: "play",
      value: function () {
        var _play = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
          var mediaStream, element, errorMessage;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  mediaStream = new MediaStream();
                  mediaStream.addTrack(this.track_);
                  element = document.createElement('audio');
                  element.srcObject = mediaStream;
                  element.muted = this.muted_;
                  element.setAttribute('id', "audio_".concat(this.stream_.getId()));
                  element.setAttribute('autoplay', 'autoplay');
                  element.setAttribute('playsinline', 'playsinline'); // append <audio> to the div container

                  this.div_.appendChild(element);

                  if (!this.outputDeviceId_) {
                    _context.next = 12;
                    break;
                  }

                  _context.next = 12;
                  return element.setSinkId(this.outputDeviceId_);

                case 12:
                  this.element_ = element;
                  this.setVolume(this.volume_);
                  this.handleEvents();
                  _context.prev = 15;
                  _context.next = 18;
                  return element.play();

                case 18:
                  _context.next = 26;
                  break;

                case 20:
                  _context.prev = 20;
                  _context.t0 = _context["catch"](15);
                  this.log_.warn('<audio> play() error: ' + _context.t0);
                  errorMessage = _context.t0.toString() + ' <audio>';

                  if (!errorMessage.startsWith('NotAllowedError')) {
                    _context.next = 26;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.PLAY_NOT_ALLOWED,
                    message: errorMessage
                  });

                case 26:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this, [[15, 20]]);
        }));

        function play() {
          return _play.apply(this, arguments);
        }

        return play;
      }()
    }, {
      key: "handleEvents",
      value: function handleEvents() {
        var _this = this;

        this.element_.addEventListener('playing', function (event) {
          _this.log_.info('stream - audio player is starting playing');

          _this.state_ = 'PLAYING';

          _this.emitter_.emit(PlayerEvent.PLAYER_STATE_CHANGED, {
            state: _this.state_,
            reason: 'playing'
          });
        });
        this.element_.addEventListener('ended', function (event) {
          _this.log_.info('stream - audio player is ended');

          if (_this.state_ !== 'STOPPED') {
            _this.state_ = 'STOPPED';

            _this.emitter_.emit(PlayerEvent.PLAYER_STATE_CHANGED, {
              state: _this.state_,
              reason: 'ended'
            });
          }
        });
        this.element_.addEventListener('pause', function (event) {
          _this.log_.info('stream - audio player is paused');

          _this.state_ = 'PAUSED';

          _this.emitter_.emit(PlayerEvent.PLAYER_STATE_CHANGED, {
            state: _this.state_,
            reason: 'pause'
          });
        }); // listen for track's ended event

        this.track_.addEventListener('ended', function (event) {
          _this.log_.info('stream - audio player track is ended');

          if (_this.state_ !== 'STOPPED') {
            _this.state_ = 'STOPPED';

            _this.emitter_.emit(PlayerEvent.PLAYER_STATE_CHANGED, {
              state: _this.state_,
              reason: 'ended'
            });
          }
        });
        this.track_.addEventListener('mute', function (event) {
          _this.log_.info('stream - audio track is muted');

          if (_this.state_ !== 'PAUSED') {
            _this.state_ = 'PAUSED';

            _this.emitter_.emit(PlayerEvent.PLAYER_STATE_CHANGED, {
              state: _this.state_,
              reason: 'mute'
            });
          }
        });
        this.track_.addEventListener('unmute', function (event) {
          _this.log_.info('stream - audio track is unmuted');

          if (_this.state_ === 'PAUSED') {
            _this.state_ = 'PLAYING';

            _this.emitter_.emit(PlayerEvent.PLAYER_STATE_CHANGED, {
              state: _this.state_,
              reason: 'unmute'
            });
          }
        });
      }
    }, {
      key: "setSinkId",
      value: function () {
        var _setSinkId = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(deviceId) {
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  if (!(this.outputDeviceId_ !== deviceId)) {
                    _context2.next = 4;
                    break;
                  }

                  _context2.next = 3;
                  return this.element_.setSinkId(deviceId);

                case 3:
                  this.outputDeviceId_ = deviceId;

                case 4:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function setSinkId(_x) {
          return _setSinkId.apply(this, arguments);
        }

        return setSinkId;
      }()
    }, {
      key: "setVolume",
      value: function setVolume(volume) {
        this.log_.info("stream - audioElement setVolume to : ".concat(volume));
        this.element_.volume = volume;
      }
    }, {
      key: "getAudioLevel",
      value: function getAudioLevel() {
        if (!this.soundMeter_) {
          // lazy init to preserve resource
          this.soundMeter_ = new SoundMeter();
          this.soundMeter_.connectToSource(this.track_);
        }

        return this.soundMeter_.getVolume();
      }
    }, {
      key: "stop",
      value: function stop() {
        this.div_.removeChild(this.element_);
        this.element_.srcObject = null;

        if (this.soundMeter_) {
          this.soundMeter_.stop();
          this.soundMeter_ = null;
        }
      }
    }, {
      key: "resume",
      value: function () {
        var _resume = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
          var errorMessage;
          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  _context3.prev = 0;
                  _context3.next = 3;
                  return this.element_.play();

                case 3:
                  _context3.next = 11;
                  break;

                case 5:
                  _context3.prev = 5;
                  _context3.t0 = _context3["catch"](0);
                  this.log_.warn('<audio> play() error: ' + _context3.t0);
                  errorMessage = _context3.t0.toString() + ' <audio>';

                  if (!errorMessage.startsWith('NotAllowedError')) {
                    _context3.next = 11;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.PLAY_NOT_ALLOWED,
                    message: errorMessage
                  });

                case 11:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3, this, [[0, 5]]);
        }));

        function resume() {
          return _resume.apply(this, arguments);
        }

        return resume;
      }()
    }, {
      key: "on",
      value: function on(event, handler) {
        this.emitter_.on(event, handler);
      }
    }]);

    return AudioPlayer;
  }();

  var VideoPlayer = /*#__PURE__*/function () {
    function VideoPlayer(options) {
      _classCallCheck(this, VideoPlayer);

      // Stream this player belong to
      this.stream_ = options.stream;
      this.userId_ = options.stream.getUserId(); // share the same IDLogger with stream

      this.log_ = this.stream_.getIDLogger(); // video track to be played

      this.track_ = options.track; // the div container for appending <video> element into

      this.div_ = options.div;
      this.muted_ = options.muted;
      this.objectFit_ = options.objectFit;
      this.mirror_ = options.mirror;
      this.element_ = null;
      this.emitter_ = new eventemitter3();
      this.state_ = 'NONE';
    }

    _createClass(VideoPlayer, [{
      key: "play",
      value: function () {
        var _play = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
          var mediaStream, element, rotateY, errorMessage;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  mediaStream = new MediaStream();
                  mediaStream.addTrack(this.track_);
                  element = document.createElement('video');
                  element.srcObject = mediaStream; // set to true to ensure video autoplay is always successful

                  element.muted = true;
                  rotateY = 0;

                  if (this.mirror_) {
                    rotateY = '180deg';
                  }

                  element.setAttribute('id', "video_".concat(this.stream_.getId()));
                  element.setAttribute('style', "width: 100%; height: 100%; position: absolute; transform: rotateY(".concat(rotateY, "); object-fit: ").concat(this.objectFit_));
                  element.setAttribute('autoplay', 'autoplay');
                  element.setAttribute('playsinline', 'playsinline');
                  this.div_.appendChild(element);
                  this.element_ = element;
                  this.handleEvents();
                  _context.prev = 14;
                  _context.next = 17;
                  return element.play();

                case 17:
                  _context.next = 25;
                  break;

                case 19:
                  _context.prev = 19;
                  _context.t0 = _context["catch"](14);
                  this.log_.warn('<video> play() error: ' + _context.t0);
                  errorMessage = _context.t0.toString() + ' <video>';

                  if (!errorMessage.startsWith('NotAllowedError')) {
                    _context.next = 25;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.PLAY_NOT_ALLOWED,
                    message: errorMessage
                  });

                case 25:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this, [[14, 19]]);
        }));

        function play() {
          return _play.apply(this, arguments);
        }

        return play;
      }()
    }, {
      key: "handleEvents",
      value: function handleEvents() {
        var _this = this;

        this.element_.addEventListener('playing', function (event) {
          _this.log_.info('stream - video player is starting playing');

          _this.state_ = 'PLAYING';

          _this.emitter_.emit(PlayerEvent.PLAYER_STATE_CHANGED, {
            state: _this.state_,
            reason: 'playing'
          });
        });
        this.element_.addEventListener('ended', function (event) {
          _this.log_.info('stream - video player is ended');

          if (_this.state_ !== 'STOPPED') {
            _this.state_ = 'STOPPED';

            _this.emitter_.emit(PlayerEvent.PLAYER_STATE_CHANGED, {
              state: _this.state_,
              reason: 'ended'
            });
          }
        });
        this.element_.addEventListener('pause', function (event) {
          _this.log_.info('stream - video player is paused');

          _this.state_ = 'PAUSED';

          _this.emitter_.emit(PlayerEvent.PLAYER_STATE_CHANGED, {
            state: _this.state_,
            reason: 'pause'
          });
        }); // listen for track's ended event

        this.track_.addEventListener('ended', function (event) {
          _this.log_.info('stream - video player track is ended');

          if (_this.state_ !== 'STOPPED') {
            _this.state_ = 'STOPPED';

            _this.emitter_.emit(PlayerEvent.PLAYER_STATE_CHANGED, {
              state: _this.state_,
              reason: 'ended'
            });
          }
        });
        this.track_.addEventListener('mute', function (event) {
          _this.log_.info('stream - video track is muted');

          if (_this.state_ !== 'PAUSED') {
            _this.state_ = 'PAUSED';

            _this.emitter_.emit(PlayerEvent.PLAYER_STATE_CHANGED, {
              state: _this.state_,
              reason: 'mute'
            });
          }
        });
        this.track_.addEventListener('unmute', function (event) {
          _this.log_.info('stream - video track is unmuted'); // reset the state altered by mute


          if (_this.state_ === 'PAUSED') {
            _this.state_ = 'PLAYING';

            _this.emitter_.emit(PlayerEvent.PLAYER_STATE_CHANGED, {
              state: _this.state_,
              reason: 'unmute'
            });
          }
        });
      }
    }, {
      key: "stop",
      value: function stop() {
        this.div_.removeChild(this.element_);
        this.element_.srcObject = null;
      }
    }, {
      key: "resume",
      value: function () {
        var _resume = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
          var errorMessage;
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.prev = 0;
                  _context2.next = 3;
                  return this.element_.play();

                case 3:
                  _context2.next = 11;
                  break;

                case 5:
                  _context2.prev = 5;
                  _context2.t0 = _context2["catch"](0);
                  this.log_.warn('<video> play() error: ' + _context2.t0);
                  errorMessage = _context2.t0.toString() + ' <video>';

                  if (!errorMessage.startsWith('NotAllowedError')) {
                    _context2.next = 11;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.PLAY_NOT_ALLOWED,
                    message: errorMessage
                  });

                case 11:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this, [[0, 5]]);
        }));

        function resume() {
          return _resume.apply(this, arguments);
        }

        return resume;
      }()
    }, {
      key: "getVideoFrame",
      value: function getVideoFrame() {
        var canvas = document.createElement('canvas');
        canvas.width = this.element_.videoWidth;
        canvas.height = this.element_.videoHeight;
        var context = canvas.getContext('2d');
        context.drawImage(this.element_, 0, 0);
        return canvas.toDataURL('image/png');
      }
    }, {
      key: "on",
      value: function on(event, handler) {
        this.emitter_.on(event, handler);
      }
    }]);

    return VideoPlayer;
  }();

  var IDLogger = /*#__PURE__*/function () {
    /*
     * log with userId and local/remote prefix
     */
    function IDLogger(options) {
      _classCallCheck(this, IDLogger);

      this.id_ = options.id;
      this.direction_ = options.direction; // local or remote

      this.type_ = options.type; // main or aux
      // simplify prefix to avoid floody loggings.

      this.directionPrefix_ = this.direction_ === 'local' ? '' : '*';
    }

    _createClass(IDLogger, [{
      key: "log",
      value: function log(level, message) {
        logger[level]("[".concat(this.directionPrefix_).concat(this.id_, "] ").concat(this.type_, " ").concat(message));
      }
    }, {
      key: "info",
      value: function info(message) {
        this.log('info', message);
        console.info(message);
      }
    }, {
      key: "debug",
      value: function debug(message) {
        this.log('debug', message);
        console.debug(message);
      }
    }, {
      key: "warn",
      value: function warn(message) {
        this.log('warn', message);
        console.warn(message);
      }
    }, {
      key: "error",
      value: function error(message) {
        this.log('error', message);
        console.error(message);
      }
    }]);

    return IDLogger;
  }();

  /**
   * Stream 音视频流，一个 Stream 中最多只能同时包含一个音频 track 和一个视频 track。<br>
   * Stream 类是本地流 LocalStream 和远端流 RemoteStream 的基类，它包含本地流和远端流通用的方法。
   *
   * @class Stream
   */

  var Stream = /*#__PURE__*/function () {
    function Stream(options) {
      _classCallCheck(this, Stream);

      this.userId_ = options.userId;
      this.isRemote_ = options.isRemote;
      this.type_ = options.type;
      this.log_ = new IDLogger({
        id: 's|' + this.userId_,
        direction: this.isRemote_ ? 'remote' : 'local',
        type: this.isRemote_ ? this.type_ : ''
      });
      this.mirror_ = false;

      if (!this.isRemote_) {
        this.mirror_ = true;
      }

      if (typeof options.mirror !== 'undefined') {
        this.mirror_ = options.mirror;
      }

      this.client_ = null;

      if (typeof options.client !== 'undefined') {
        this.client_ = options.client;
      } // the MediaStream associated with this Stream

      /* @type {MediaStream} */


      this.mediaStream_ = null; // container for appending <audio>/<video> elements

      this.div_ = null;
      this.isPlaying_ = false;
      /*
       * the Connection (RTCPeerConnection) to which this Stream attached
       * for local stream, it will be attached to Connection when it's published.
       * for remote stream, there's always a Connection attached when it's created.
       */

      this.connection_ = null;
      this.hasAudio_ = false;
      this.hasVideo_ = false;
      this.audioPlayer_ = null;
      this.videoPlayer_ = null;
      this.muted_ = false;
      this.objectFit_ = 'cover';
      this.id_ = generateUUID();
      this.audioOutputDeviceId_ = 0;
      this.audioVolume_ = 1.0;
      this.emitter_ = new eventemitter3();
    }

    _createClass(Stream, [{
      key: "getType",
      value: function getType() {
        return this.type_;
      }
    }, {
      key: "getIDLogger",
      value: function getIDLogger() {
        return this.log_;
      }
      /**
       *
       * @package
       * @param {Connection} connection
       * @memberof Stream
       */

    }, {
      key: "setConnection",
      value: function setConnection(connection) {
        if (this.connection_ !== connection) {
          this.connection_ = connection;
        }
      }
      /**
       *
       * @package
       * @returns {Connection}
       * @memberof BaseStream
       */

    }, {
      key: "getConnection",
      value: function getConnection() {
        return this.connection_;
      }
      /**
       * 播放该音视频流<br>
       * 该方法会自动创建 \<audio\> 和 \<video\> 标签并在指定的标签上播放音频和视频，同时该标签会被添加到页面中名为 `elementId` 的 div 容器。<br>
       * 换句说，Stream 内部会自动创建相应的音频播放器和视频播放器来播放相应的音频和视频。
       *
       * **NOTE**
       *
       * - 由于浏览器[自动播放策略](https://developers.google.com/web/updates/2017/09/autoplay-policy-changes)的影响，调用该接口可能会返回 `PLAY_NOT_ALLOWED` 错误，
       * 此时需要引导用户通过手势操作调用 {@link Stream#resume resume()} 恢复音视频播放。
       * @example
       * stream.play('remote').then(() => {
       *   // autoplay success
       * }).catch((e) => {
       *   const errorCode = e.getCode();
       *   if (errorCode === 0x4043) {
       *     // PLAY_NOT_ALLOWED,引导用户手势操作恢复音视频播放
       *     // stream.resume()
       *   }
       * });
       *
       * @param {string|HTMLDivElement} elementId HTML \<div\> 标签 ID 或者 HTMLDivElement 对象，该方法内部自动创建的音视频标签将被添加到该容器中。
       * @param {object=} options 播放选项
       * @param {string} options.objectFit 视频画面显示模式，参考 {@link https://developer.mozilla.org/zh-CN/docs/Web/CSS/object-fit| CSS object-fit} 属性
       * - 'contain' 优先保证视频内容全部显示。视频尺寸等比缩放，直至视频窗口的一边与视窗边框对齐。如果视频尺寸与显示视窗尺寸不一致，在保持长宽比的前提下，将视频进行缩放后填满视窗，缩放后的视频四周会有一圈黑边。
       * - 'cover' 优先保证视窗被填满。视频尺寸等比缩放，直至整个视窗被视频填满。如果视频长宽与显示窗口不同，则视频流会按照显示视窗的比例进行周边裁剪或图像拉伸后填满视窗。
       * <br>
       * <br>
       * 对于本地流，播放视频流默认使用 cover 模式，屏幕共享默认使用 contain 模式。
       * @param {boolean} options.muted 是否需要 mute 声音，对于本地流通常需要 mute 声音以防止播放从麦克风采集回来的声音。
       * @throws {RtcError}
       * @returns {Promise}
       * @memberof Stream
       */

    }, {
      key: "play",
      value: function () {
        var _play = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(elementId, options) {
          var div, container;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!this.isPlaying_) {
                    _context.next = 2;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_OPERATION,
                    message: 'duplicated play() call observed, please stop() firstly'
                  });

                case 2:
                  this.isPlaying_ = true;
                  this.log_.info("stream start to play with options: ".concat(JSON.stringify(options))); // container

                  div = document.createElement('div');
                  div.setAttribute('id', "player_".concat(this.id_));
                  div.setAttribute('style', 'width: 100%; height: 100%; position: relative; background-color: black; overflow: hidden;');
                  container = elementId;

                  if (_typeof(elementId) !== 'object') {
                    container = document.getElementById(elementId);
                  }

                  container.appendChild(div);
                  this.div_ = div;

                  if (!this.isRemote_) {
                    // ensure audio is muted for local stream to avoid playing back the sound from microphone
                    this.muted_ = true;
                  }

                  if (options && typeof options.muted !== 'undefined') {
                    this.muted_ = options.muted;
                  } // auxiliary stream is usually a screen share, we use 'contain' object-fit for that by default.


                  if (this.isRemote_ && this.getType() === 'auxiliary') {
                    this.objectFit_ = 'contain';
                  }

                  if (options && typeof options.objectFit !== 'undefined') {
                    this.objectFit_ = options.objectFit;
                  }

                  if (!this.hasVideo_) {
                    _context.next = 18;
                    break;
                  }

                  _context.next = 18;
                  return this.playVideo();

                case 18:
                  if (!this.hasAudio_) {
                    _context.next = 21;
                    break;
                  }

                  _context.next = 21;
                  return this.playAudio();

                case 21:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function play(_x, _x2) {
          return _play.apply(this, arguments);
        }

        return play;
      }()
    }, {
      key: "playAudio",
      value: function () {
        var _playAudio = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
          var _this = this;

          var audioTrack;
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  audioTrack = this.getAudioTrack();

                  if (!(!this.audioPlayer_ && audioTrack)) {
                    _context2.next = 7;
                    break;
                  }

                  this.log_.info('stream - create AudioPlayer and play');
                  this.audioPlayer_ = new AudioPlayer({
                    stream: this,
                    track: audioTrack,
                    div: this.div_,
                    muted: this.muted_,
                    outputDeviceId: this.audioOutputDeviceId_,
                    volume: this.audioVolume_
                  });
                  this.audioPlayer_.on(PlayerEvent.PLAYER_STATE_CHANGED, function (event) {
                    _this.emitter_.emit(StreamEvent.PLAYER_STATE_CHANGED, {
                      type: 'audio',
                      state: event.state,
                      reason: event.reason
                    });
                  });
                  _context2.next = 7;
                  return this.audioPlayer_.play();

                case 7:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function playAudio() {
          return _playAudio.apply(this, arguments);
        }

        return playAudio;
      }()
    }, {
      key: "playVideo",
      value: function () {
        var _playVideo = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
          var _this2 = this;

          var videoTrack;
          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  videoTrack = this.getVideoTrack();

                  if (!(!this.videoPlayer_ && videoTrack)) {
                    _context3.next = 7;
                    break;
                  }

                  this.log_.info('stream - create VideoPlayer and play');
                  this.videoPlayer_ = new VideoPlayer({
                    stream: this,
                    track: videoTrack,
                    div: this.div_,
                    muted: this.muted_,
                    objectFit: this.objectFit_,
                    mirror: this.mirror_
                  });
                  this.videoPlayer_.on(PlayerEvent.PLAYER_STATE_CHANGED, function (event) {
                    _this2.emitter_.emit(StreamEvent.PLAYER_STATE_CHANGED, {
                      type: 'video',
                      state: event.state,
                      reason: event.reason
                    });
                  });
                  _context3.next = 7;
                  return this.videoPlayer_.play();

                case 7:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3, this);
        }));

        function playVideo() {
          return _playVideo.apply(this, arguments);
        }

        return playVideo;
      }()
    }, {
      key: "stopAudio",
      value: function stopAudio() {
        if (this.audioPlayer_) {
          this.log_.info('stream - stop AudioPlayer');
          this.audioPlayer_.stop();
          this.audioPlayer_ = null;
        }
      }
    }, {
      key: "stopVideo",
      value: function stopVideo() {
        if (this.videoPlayer_) {
          this.log_.info('stream - stop VideoPlayer');
          this.videoPlayer_.stop();
          this.videoPlayer_ = null;
        }
      }
    }, {
      key: "restartAudio",
      value: function restartAudio() {
        if (!this.isPlaying_) return;
        this.stopAudio();
        this.playAudio();
      }
    }, {
      key: "restartVideo",
      value: function restartVideo() {
        if (!this.isPlaying_) return;
        this.stopVideo();
        this.playVideo();
      }
      /**
       * 停止播放音视频流
       * <br>
       * <br>
       * 该方法还会将由 {@link Stream#play play()} 创建的音视频标签从 HTML 页面中删除。
       */

    }, {
      key: "stop",
      value: function stop() {
        if (!this.isPlaying_) return;
        this.isPlaying_ = false;
        this.stopAudio();
        this.stopVideo();
        this.div_.parentNode.removeChild(this.div_);
      }
      /**
       * 恢复播放音视频
       * <br>
       * **NOTE**
       * - 在某些版本浏览器上移动传入 {@link Stream#play play()} 的 div 容器可能会导致音视频播放器进入 ‘PAUSED’ 状态，此时
       * 需要调用该接口恢复播放。
       * - 由于浏览器自动播放策略的限制，在 {@link Stream#play play()} 返回 `PLAY_NOT_ALLOWED` 错误后需要引导用户通过手势
       * 调用该接口恢复播放。
       * @memberof Stream
       * @throws {RtcError}
       * @returns {Promise}
       * @example
       * stream.on('player-state-changed', event => {
       *   if (event.state === 'PAUSED') {
       *     // resume audio/video playback
       *     stream.resume();
       *   }
       * });
       */

    }, {
      key: "resume",
      value: function () {
        var _resume = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
          return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  if (this.isPlaying_) {
                    _context4.next = 2;
                    break;
                  }

                  return _context4.abrupt("return");

                case 2:
                  this.log_.info('stream - resume'); // audio should come first before video otherwise there will be NotAllowedError exception
                  // in WebChat browser on iOS.

                  if (!this.audioPlayer_) {
                    _context4.next = 6;
                    break;
                  }

                  _context4.next = 6;
                  return this.audioPlayer_.resume();

                case 6:
                  if (!this.videoPlayer_) {
                    _context4.next = 9;
                    break;
                  }

                  _context4.next = 9;
                  return this.videoPlayer_.resume();

                case 9:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4, this);
        }));

        function resume() {
          return _resume.apply(this, arguments);
        }

        return resume;
      }()
      /**
       * 关闭音视频流<br>
       * <br>
       * 对于本地流，该方法会关闭摄像头并释放摄像头和麦克风访问权限。
       */

    }, {
      key: "close",
      value: function close() {
        // sanity check
        if (this.isPlaying_) {
          this.stop();
        }

        if (this.mediaStream_) {
          this.mediaStream_.preventEvent = 1;
          this.mediaStream_.getTracks().forEach(function (track) {
            track.stop();
          });
          this.mediaStream_ = null;
        }
      }
      /**
       * 禁用音频轨道<br>
       * <br>
       * - 对于本地流，调用该方法会停止发送音频，远端会触发 `Client.on('mute-audio')` 事件。
       * - 对于远端流，调用该方法会停止播放音频，但是仍然接收音频数据。
       *
       * @returns {boolean}
       * - true 禁用音频轨道成功。
       * - false 禁用音频轨道失败，因为没有音频轨道。
       * @memberof Stream
       */

    }, {
      key: "muteAudio",
      value: function muteAudio() {
        this.addRemoteEvent(true, 'audio');
        return this.doEnableTrack('audio', false);
      }
      /**
       * 禁用视频轨道<br>
       * <br>
       * - 对于本地流，调用该方法会停止发送视频，远端会触发 `Client.on('mute-video')` 事件。<br>
       * 如果视频是从摄像头采集，此时摄像头灯仍然是亮着的。若想完全禁用视频轨道(即关闭摄像头)，<br>
       * 可以使用 {@link LocalStream#removeTrack removeTrack()} 删除视频轨道然后调用
       * {@link https://developer.mozilla.org/en-US/docs/Web/API/MediaStreamTrack/stop|MediaStreamTrack.stop()}
       * 关闭视频轨道（关闭摄像头）。
       * - 对于远端流，调用该方法会停止播放视频，但是仍然接收视频数据.
       *
       * @returns {boolean}
       * - true 禁用视频轨道成功
       * - false 禁用视频轨道失败，因为没有视频轨道。
       * @memberof Stream
       */

    }, {
      key: "muteVideo",
      value: function muteVideo() {
        this.addRemoteEvent(true, 'video');
        return this.doEnableTrack('video', false);
      }
      /**
       * 启用音频轨道<br>
       * <br>
       * 对于本地流，调用该方法会触发远端 `Client.on('unmute-audio')` 事件。<br>
       * <br>
       * 音频轨道默认是开启的，若你调用 {@link Stream#muteAudio muteAudio()} 后可用该方法重新启用音频。
       *
       * @returns {boolean}
       * - true 启用音频轨道成功。
       * - false 没有音频轨道，启用失败。
       * @memberof Stream
       */

    }, {
      key: "unmuteAudio",
      value: function unmuteAudio() {
        this.addRemoteEvent(false, 'audio');
        return this.doEnableTrack('audio', true);
      }
      /**
       * 启用视频轨道<br>
       * <br>
       * 对于本地流，调用该方法会触发远端 `Client.on('unmute-video')` 事件。<br>
       * <br>
       * 视频轨道默认是开启的，若你调用 {@link Stream#muteVideo muteVideo()} 后可用该方法重新启用视频。
       *
       * @return {boolean}
       * - true 启用视频轨道成功。
       * - false 没有视频轨道，启用失败。
       * @memberof Stream
       */

    }, {
      key: "unmuteVideo",
      value: function unmuteVideo() {
        this.addRemoteEvent(false, 'video');
        return this.doEnableTrack('video', true);
      }
    }, {
      key: "addRemoteEvent",
      value: function addRemoteEvent(mute, kind) {
        if (this.isRemote_ && this.client_) {
          var uid = this.client_.getUserId();
          var eventId;
          var eventDesc = "".concat(mute ? 'mute' : 'unmute', " remote ").concat(kind);

          if (kind === 'audio') {
            eventId = mute ? EventId.MUTE_REMOTE_AUDIO : EventId.UNMUTE_REMOTE_AUDIO;
          } else {
            eventId = mute ? EventId.MUTE_REMOTE_VIDEO : EventId.UNMUTE_REMOTE_VIDEO;
          }

          addEvent(uid, {
            eventId: eventId,
            eventDesc: eventDesc,
            timestamp: new Date().getTime(),
            // the stream owner - the client's IDs
            userId: uid,
            tinyId: this.client_.getTinyId(),
            // remote peer's IDs
            remoteUserId: this.userId_,
            remoteTinyId: this.connection_.getTinyId()
          });
        }
      }
    }, {
      key: "doEnableTrack",
      value: function doEnableTrack(kind, enable) {
        var has = false;

        if (kind === 'audio') {
          this.mediaStream_.getAudioTracks().forEach(function (track) {
            has = true;
            track.enabled = enable;
          });
        } else {
          this.mediaStream_.getVideoTracks().forEach(function (track) {
            has = true;
            track.enabled = enable;
          });
        }

        return has;
      }
      /**
       * 获取 Stream 唯一标识ID
       *
       * @returns {string} Id 流唯一标识
       * @memberof Stream
       */

    }, {
      key: "getId",
      value: function getId() {
        return this.id_;
      }
      /**
       * 获取该流所属的用户ID
       *
       * @returns {string} userId 用户ID
       * @memberof Stream
       */

    }, {
      key: "getUserId",
      value: function getUserId() {
        return this.userId_;
      }
    }, {
      key: "isPlaying",
      value: function isPlaying() {
        return this.isPlaying_;
      }
      /**
       * 设置声音输出设备
       *
       * @param {string} deviceId 设备标识，通过 {@link TRTC.getSpeakers getSpeakers()} 获取。
       * @memberof Stream
       */

    }, {
      key: "setAudioOutput",
      value: function () {
        var _setAudioOutput = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(deviceId) {
          return regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  this.audioOutputDeviceId_ = deviceId;

                  if (!this.audioPlayer_) {
                    _context5.next = 4;
                    break;
                  }

                  _context5.next = 4;
                  return this.audioPlayer_.setSinkId(deviceId);

                case 4:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee5, this);
        }));

        function setAudioOutput(_x3) {
          return _setAudioOutput.apply(this, arguments);
        }

        return setAudioOutput;
      }()
      /**
       * 设置播放音量大小<br>
       *
       * @param {double} volume 音量大小，取值在 0.0 (静音) 到 1.0 (最大音量) 之间。
       * @memberof Stream
       */

    }, {
      key: "setAudioVolume",
      value: function setAudioVolume(volume) {
        this.audioVolume_ = volume;
        this.log_.info("setAudioVolume to ".concat(volume));

        if (this.audioPlayer_) {
          this.audioPlayer_.setVolume(volume);
        }
      }
      /**
       * 获取当前音量大小<br>
       * 只有当本地流或远端流中有音频数据才有效。
       *
       * @returns {number} audioLevel 音量大小
       * - 返回值在(0.0, 1.0)之间，通常认为值大于0.1为用户正在说话。
       * @example
       * setInterval(() => {
       *   const level = stream.getAudioLevel();
       *   if (level >= 0.1) {
       *     console.log(`user ${stream.getUserId()} is speaking`);
       *   }
       * }, 200);
       */

    }, {
      key: "getAudioLevel",
      value: function getAudioLevel() {
        var vol = 0.0;

        if (this.audioPlayer_) {
          vol = this.audioPlayer_.getAudioLevel();
        }

        return vol;
      }
      /**
       * 是否包含音频轨道
       *
       * @returns {boolean}
       * @memberof Stream
       */

    }, {
      key: "hasAudio",
      value: function hasAudio() {
        return this.hasAudio_;
      }
      /**
       * 是否包含视频轨道
       *
       * @returns {boolean}
       * @memberof Stream
       */

    }, {
      key: "hasVideo",
      value: function hasVideo() {
        return this.hasVideo_;
      }
      /**
       * 获取音频轨道
       *
       * @returns {MediaStreamTrack?} 音频轨道
       * @memberof Stream
       */

    }, {
      key: "getAudioTrack",
      value: function getAudioTrack() {
        var track = null;

        if (this.mediaStream_) {
          var audioTracks = this.mediaStream_.getAudioTracks();

          if (audioTracks.length > 0) {
            track = audioTracks[0];
          }
        }

        return track;
      }
      /**
       * 获取视频轨道
       *
       * @returns {MediaStreamTrack?} 视频轨道
       * @memberof Stream
       */

    }, {
      key: "getVideoTrack",
      value: function getVideoTrack() {
        var track = null;

        if (this.mediaStream_) {
          var videoTracks = this.mediaStream_.getVideoTracks();

          if (videoTracks.length > 0) {
            track = videoTracks[0];
          }
        }

        return track;
      }
      /**
       * 获取当前视频帧
       * <br>
       * **NOTE**
       * - 该方法需要在 {@link Stream#play play()} 后调用，并且 Stream 中有视频流才有效
       *
       * @returns {String?} 'image/png' 类型的 {@link https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/Data_URIs dataURL}
       * @memberof Stream
       * @example
       * // 截取当前视频帧
       * const frame = stream.getVideoFrame();
       * if (frame) {
       *   const img = document.createElement('img');
       *   img.src = frame;
       * }
       */

    }, {
      key: "getVideoFrame",
      value: function getVideoFrame() {
        if (!this.videoPlayer_) return null;
        return this.videoPlayer_.getVideoFrame();
      } // package

    }, {
      key: "getMediaStream",
      value: function getMediaStream() {
        return this.mediaStream_;
      }
    }, {
      key: "setMediaStream",
      value: function setMediaStream(stream) {
        if (stream !== this.mediaStream_) {
          // release unused media resources
          if (this.mediaStream_) {
            this.mediaStream_.getTracks().forEach(function (track) {
              return track.stop();
            });
          }

          this.mediaStream_ = stream;
        }
      }
      /**
       *
       * @package
       * @param {boolean} has
       * @memberof Stream
       */

    }, {
      key: "setHasVideo",
      value: function setHasVideo(has) {
        this.hasVideo_ = has; // ensure video is played/stopped after stream is updated

        if (this.isPlaying_) {
          if (has) {
            this.log_.info('stream updated, play video');
            this.playVideo();
          } else {
            this.log_.info('stream updated, stop video');
            this.stopVideo();
          }
        }
      }
      /**
       *
       * @package
       * @param {boolean} has
       * @memberof Stream
       */

    }, {
      key: "setHasAudio",
      value: function setHasAudio(has) {
        this.hasAudio_ = has; // ensure audio is played/stopped after stream is updated

        if (this.isPlaying_) {
          if (has) {
            this.log_.info('stream updated, play audio');
            this.playAudio();
          } else {
            this.log_.info('stream updated, stop audio');
            this.stopAudio();
          }
        }
      }
      /**
       * 监听Stream事件<br>
       * 详细事件列表请参见：{@link module:Event.StreamEvent StreamEvent }
       *
       * @param {string} eventName 事件名称
       * @param {function} handler 事件处理方法
       * @memberof Stream
       * @example
       * stream.on('player-state-changed', event => {
       *   console.log(`${event.type} player is ${event.state}`);
       * });
       */

    }, {
      key: "on",
      value: function on(event, handler) {
        this.emitter_.on(event, handler);
      }
    }, {
      key: "isRemote",
      value: function isRemote() {
        return this.isRemote_;
      }
    }]);

    return Stream;
  }();

  /**
   * 远端音视频流，通过监听 `Client.on('stream-added')` 事件获得。<br>
   * <br>
   * 一个远端用户可发送至多两个远端流对象，其中一个远端流对象包含一路音频和一路主路视频，另一个远端流对象仅仅包含一路辅路视频。<br>
   * 这两种远端流对象的类型可通过 {@link RemoteStream#getType getType()} 来识别。<br>
   * <br>
   * 远端流的生命周期在事件 `Client.on('stream-added')` 到事件 `Client.on('stream-removed')` 之间，在这两个事件之间，远端流可能会通过
   * `Client.on('stream-updated')` 进行更新，比如远端用户通过 {@link LocalStream#addTrack addTrack()} 或 {@link LocalStream#removeTrack removeTrack()}
   * 增加或删除 track 后本地就会收到此通知。
   *
   * @class RemoteStream
   * @extends {Stream}
   * @example
   * // 远端流生命周期内的操作示例
   *
   * // 通过监听‘stream-added’事件获得远端流对象
   * const client = TRTC.createClient({ sdkAppId, userId, userSig, mode: 'live'});
   * client.on('stream-added', event => {
   *   const remoteStream = event.stream;
   *   const remoteUserId = remoteStream.getUserId();
   *   console.log('received a remoteStream ID: ' + remoteStream.getId() + ' from user: ' + remoteUserId);
   *   // 若需要观看该远端流，则需要订阅它
   *   client.subscribe(remoteStream);
   *
   *   // 若不需要观看该远端流，请取消订阅它，否则SDK会接收远端流数据。
   *   // client.unsubscribe(remoteStream);
   * });
   *
   * // 监听‘stream-removed’事件
   * client.on('stream-removed', event => {
   *   const remoteStream = event.stream;
   *   console.log('remoteStream ID: ' + remoteStream.getId() + ' has been removed');
   *   // 停止播放并删除相应<video>标签
   * });
   *
   * // 监听‘stream-updated’事件
   * client.on('stream-updated', event => {
   *   const remoteStream = event.stream;
   *   console.log('remoteStream ID: ' + remoteStream.getId() + ' was updated hasAudio: '
   *               + remoteStream.hasAudio() + ' hasVideo: ' + remoteStream.hasVideo());
   * });
   *
   * // 监听‘stream-subscribed’事件
   * client.on('stream-subscribed', event => {
   *   const remoteStream = event.stream;
   *   // 远端流订阅成功，在HTML页面中创建一个<video>标签，假设该标签ID为‘remote-video-view’
   *   // 播放该远端流
   *   remoteStream.play('remote-video-view');
   * });
   */

  var RemoteStream = /*#__PURE__*/function (_Stream) {
    _inherits(RemoteStream, _Stream);

    var _super = _createSuper(RemoteStream);

    /**
     * Creates an instance of RemoteStream.
     * @package
     * @param {object} options
     * @param {string} options.userId the remote userId who initiated the downlink connection
     * @memberof RemoteStream
     */
    function RemoteStream(options) {
      var _this;

      _classCallCheck(this, RemoteStream);

      var extra = {
        isRemote: true,
        type: options.type
      };

      var opt = _objectSpread2(_objectSpread2({}, options), extra);

      _this = _super.call(this, opt);
      _this.isInSubscriptionCycle_ = false;
      return _this;
    }
    /**
     * 获取远端流类型<br>
     * <br>
     * 主要用于判断一个远端流是主音视频流还是辅路视频流，辅路视频流通常是一个屏幕分享流。
     *
     * @returns {string} 远端流类型
     * - 'main' 主音视频流
     * - ‘auxiliary’ 辅助视频流，通常是一个屏幕分享流
     * @memberof RemoteStream
     */


    _createClass(RemoteStream, [{
      key: "getType",
      value: function getType() {
        return _get(_getPrototypeOf(RemoteStream.prototype), "getType", this).call(this);
      }
    }, {
      key: "setInSubscriptionCycle",
      value: function setInSubscriptionCycle(subscribing) {
        this.isInSubscriptionCycle_ = subscribing;
      }
    }, {
      key: "isInSubscriptionCycle",
      value: function isInSubscriptionCycle() {
        return this.isInSubscriptionCycle_;
      }
    }]);

    return RemoteStream;
  }(Stream);

  var grammar_1 = createCommonjsModule(function (module) {
  var grammar = module.exports = {
    v: [{
      name: 'version',
      reg: /^(\d*)$/
    }],
    o: [{
      // o=- 20518 0 IN IP4 203.0.113.1
      // NB: sessionId will be a String in most cases because it is huge
      name: 'origin',
      reg: /^(\S*) (\d*) (\d*) (\S*) IP(\d) (\S*)/,
      names: ['username', 'sessionId', 'sessionVersion', 'netType', 'ipVer', 'address'],
      format: '%s %s %d %s IP%d %s'
    }],
    // default parsing of these only (though some of these feel outdated)
    s: [{ name: 'name' }],
    i: [{ name: 'description' }],
    u: [{ name: 'uri' }],
    e: [{ name: 'email' }],
    p: [{ name: 'phone' }],
    z: [{ name: 'timezones' }], // TODO: this one can actually be parsed properly...
    r: [{ name: 'repeats' }],   // TODO: this one can also be parsed properly
    // k: [{}], // outdated thing ignored
    t: [{
      // t=0 0
      name: 'timing',
      reg: /^(\d*) (\d*)/,
      names: ['start', 'stop'],
      format: '%d %d'
    }],
    c: [{
      // c=IN IP4 10.47.197.26
      name: 'connection',
      reg: /^IN IP(\d) (\S*)/,
      names: ['version', 'ip'],
      format: 'IN IP%d %s'
    }],
    b: [{
      // b=AS:4000
      push: 'bandwidth',
      reg: /^(TIAS|AS|CT|RR|RS):(\d*)/,
      names: ['type', 'limit'],
      format: '%s:%s'
    }],
    m: [{
      // m=video 51744 RTP/AVP 126 97 98 34 31
      // NB: special - pushes to session
      // TODO: rtp/fmtp should be filtered by the payloads found here?
      reg: /^(\w*) (\d*) ([\w/]*)(?: (.*))?/,
      names: ['type', 'port', 'protocol', 'payloads'],
      format: '%s %d %s %s'
    }],
    a: [
      {
        // a=rtpmap:110 opus/48000/2
        push: 'rtp',
        reg: /^rtpmap:(\d*) ([\w\-.]*)(?:\s*\/(\d*)(?:\s*\/(\S*))?)?/,
        names: ['payload', 'codec', 'rate', 'encoding'],
        format: function (o) {
          return (o.encoding)
            ? 'rtpmap:%d %s/%s/%s'
            : o.rate
              ? 'rtpmap:%d %s/%s'
              : 'rtpmap:%d %s';
        }
      },
      {
        // a=fmtp:108 profile-level-id=24;object=23;bitrate=64000
        // a=fmtp:111 minptime=10; useinbandfec=1
        push: 'fmtp',
        reg: /^fmtp:(\d*) ([\S| ]*)/,
        names: ['payload', 'config'],
        format: 'fmtp:%d %s'
      },
      {
        // a=control:streamid=0
        name: 'control',
        reg: /^control:(.*)/,
        format: 'control:%s'
      },
      {
        // a=rtcp:65179 IN IP4 193.84.77.194
        name: 'rtcp',
        reg: /^rtcp:(\d*)(?: (\S*) IP(\d) (\S*))?/,
        names: ['port', 'netType', 'ipVer', 'address'],
        format: function (o) {
          return (o.address != null)
            ? 'rtcp:%d %s IP%d %s'
            : 'rtcp:%d';
        }
      },
      {
        // a=rtcp-fb:98 trr-int 100
        push: 'rtcpFbTrrInt',
        reg: /^rtcp-fb:(\*|\d*) trr-int (\d*)/,
        names: ['payload', 'value'],
        format: 'rtcp-fb:%s trr-int %d'
      },
      {
        // a=rtcp-fb:98 nack rpsi
        push: 'rtcpFb',
        reg: /^rtcp-fb:(\*|\d*) ([\w-_]*)(?: ([\w-_]*))?/,
        names: ['payload', 'type', 'subtype'],
        format: function (o) {
          return (o.subtype != null)
            ? 'rtcp-fb:%s %s %s'
            : 'rtcp-fb:%s %s';
        }
      },
      {
        // a=extmap:2 urn:ietf:params:rtp-hdrext:toffset
        // a=extmap:1/recvonly URI-gps-string
        // a=extmap:3 urn:ietf:params:rtp-hdrext:encrypt urn:ietf:params:rtp-hdrext:smpte-tc 25@600/24
        push: 'ext',
        reg: /^extmap:(\d+)(?:\/(\w+))?(?: (urn:ietf:params:rtp-hdrext:encrypt))? (\S*)(?: (\S*))?/,
        names: ['value', 'direction', 'encrypt-uri', 'uri', 'config'],
        format: function (o) {
          return (
            'extmap:%d' +
            (o.direction ? '/%s' : '%v') +
            (o['encrypt-uri'] ? ' %s' : '%v') +
            ' %s' +
            (o.config ? ' %s' : '')
          );
        }
      },
      {
        // a=extmap-allow-mixed
        name: 'extmapAllowMixed',
        reg: /^(extmap-allow-mixed)/
      },
      {
        // a=crypto:1 AES_CM_128_HMAC_SHA1_80 inline:PS1uQCVeeCFCanVmcjkpPywjNWhcYD0mXXtxaVBR|2^20|1:32
        push: 'crypto',
        reg: /^crypto:(\d*) ([\w_]*) (\S*)(?: (\S*))?/,
        names: ['id', 'suite', 'config', 'sessionConfig'],
        format: function (o) {
          return (o.sessionConfig != null)
            ? 'crypto:%d %s %s %s'
            : 'crypto:%d %s %s';
        }
      },
      {
        // a=setup:actpass
        name: 'setup',
        reg: /^setup:(\w*)/,
        format: 'setup:%s'
      },
      {
        // a=connection:new
        name: 'connectionType',
        reg: /^connection:(new|existing)/,
        format: 'connection:%s'
      },
      {
        // a=mid:1
        name: 'mid',
        reg: /^mid:([^\s]*)/,
        format: 'mid:%s'
      },
      {
        // a=msid:0c8b064d-d807-43b4-b434-f92a889d8587 98178685-d409-46e0-8e16-7ef0db0db64a
        name: 'msid',
        reg: /^msid:(.*)/,
        format: 'msid:%s'
      },
      {
        // a=ptime:20
        name: 'ptime',
        reg: /^ptime:(\d*(?:\.\d*)*)/,
        format: 'ptime:%d'
      },
      {
        // a=maxptime:60
        name: 'maxptime',
        reg: /^maxptime:(\d*(?:\.\d*)*)/,
        format: 'maxptime:%d'
      },
      {
        // a=sendrecv
        name: 'direction',
        reg: /^(sendrecv|recvonly|sendonly|inactive)/
      },
      {
        // a=ice-lite
        name: 'icelite',
        reg: /^(ice-lite)/
      },
      {
        // a=ice-ufrag:F7gI
        name: 'iceUfrag',
        reg: /^ice-ufrag:(\S*)/,
        format: 'ice-ufrag:%s'
      },
      {
        // a=ice-pwd:x9cml/YzichV2+XlhiMu8g
        name: 'icePwd',
        reg: /^ice-pwd:(\S*)/,
        format: 'ice-pwd:%s'
      },
      {
        // a=fingerprint:SHA-1 00:11:22:33:44:55:66:77:88:99:AA:BB:CC:DD:EE:FF:00:11:22:33
        name: 'fingerprint',
        reg: /^fingerprint:(\S*) (\S*)/,
        names: ['type', 'hash'],
        format: 'fingerprint:%s %s'
      },
      {
        // a=candidate:0 1 UDP 2113667327 203.0.113.1 54400 typ host
        // a=candidate:1162875081 1 udp 2113937151 192.168.34.75 60017 typ host generation 0 network-id 3 network-cost 10
        // a=candidate:3289912957 2 udp 1845501695 193.84.77.194 60017 typ srflx raddr 192.168.34.75 rport 60017 generation 0 network-id 3 network-cost 10
        // a=candidate:229815620 1 tcp 1518280447 192.168.150.19 60017 typ host tcptype active generation 0 network-id 3 network-cost 10
        // a=candidate:3289912957 2 tcp 1845501695 193.84.77.194 60017 typ srflx raddr 192.168.34.75 rport 60017 tcptype passive generation 0 network-id 3 network-cost 10
        push:'candidates',
        reg: /^candidate:(\S*) (\d*) (\S*) (\d*) (\S*) (\d*) typ (\S*)(?: raddr (\S*) rport (\d*))?(?: tcptype (\S*))?(?: generation (\d*))?(?: network-id (\d*))?(?: network-cost (\d*))?/,
        names: ['foundation', 'component', 'transport', 'priority', 'ip', 'port', 'type', 'raddr', 'rport', 'tcptype', 'generation', 'network-id', 'network-cost'],
        format: function (o) {
          var str = 'candidate:%s %d %s %d %s %d typ %s';

          str += (o.raddr != null) ? ' raddr %s rport %d' : '%v%v';

          // NB: candidate has three optional chunks, so %void middles one if it's missing
          str += (o.tcptype != null) ? ' tcptype %s' : '%v';

          if (o.generation != null) {
            str += ' generation %d';
          }

          str += (o['network-id'] != null) ? ' network-id %d' : '%v';
          str += (o['network-cost'] != null) ? ' network-cost %d' : '%v';
          return str;
        }
      },
      {
        // a=end-of-candidates (keep after the candidates line for readability)
        name: 'endOfCandidates',
        reg: /^(end-of-candidates)/
      },
      {
        // a=remote-candidates:1 203.0.113.1 54400 2 203.0.113.1 54401 ...
        name: 'remoteCandidates',
        reg: /^remote-candidates:(.*)/,
        format: 'remote-candidates:%s'
      },
      {
        // a=ice-options:google-ice
        name: 'iceOptions',
        reg: /^ice-options:(\S*)/,
        format: 'ice-options:%s'
      },
      {
        // a=ssrc:2566107569 cname:t9YU8M1UxTF8Y1A1
        push: 'ssrcs',
        reg: /^ssrc:(\d*) ([\w_-]*)(?::(.*))?/,
        names: ['id', 'attribute', 'value'],
        format: function (o) {
          var str = 'ssrc:%d';
          if (o.attribute != null) {
            str += ' %s';
            if (o.value != null) {
              str += ':%s';
            }
          }
          return str;
        }
      },
      {
        // a=ssrc-group:FEC 1 2
        // a=ssrc-group:FEC-FR 3004364195 1080772241
        push: 'ssrcGroups',
        // token-char = %x21 / %x23-27 / %x2A-2B / %x2D-2E / %x30-39 / %x41-5A / %x5E-7E
        reg: /^ssrc-group:([\x21\x23\x24\x25\x26\x27\x2A\x2B\x2D\x2E\w]*) (.*)/,
        names: ['semantics', 'ssrcs'],
        format: 'ssrc-group:%s %s'
      },
      {
        // a=msid-semantic: WMS Jvlam5X3SX1OP6pn20zWogvaKJz5Hjf9OnlV
        name: 'msidSemantic',
        reg: /^msid-semantic:\s?(\w*) (\S*)/,
        names: ['semantic', 'token'],
        format: 'msid-semantic: %s %s' // space after ':' is not accidental
      },
      {
        // a=group:BUNDLE audio video
        push: 'groups',
        reg: /^group:(\w*) (.*)/,
        names: ['type', 'mids'],
        format: 'group:%s %s'
      },
      {
        // a=rtcp-mux
        name: 'rtcpMux',
        reg: /^(rtcp-mux)/
      },
      {
        // a=rtcp-rsize
        name: 'rtcpRsize',
        reg: /^(rtcp-rsize)/
      },
      {
        // a=sctpmap:5000 webrtc-datachannel 1024
        name: 'sctpmap',
        reg: /^sctpmap:([\w_/]*) (\S*)(?: (\S*))?/,
        names: ['sctpmapNumber', 'app', 'maxMessageSize'],
        format: function (o) {
          return (o.maxMessageSize != null)
            ? 'sctpmap:%s %s %s'
            : 'sctpmap:%s %s';
        }
      },
      {
        // a=x-google-flag:conference
        name: 'xGoogleFlag',
        reg: /^x-google-flag:([^\s]*)/,
        format: 'x-google-flag:%s'
      },
      {
        // a=rid:1 send max-width=1280;max-height=720;max-fps=30;depend=0
        push: 'rids',
        reg: /^rid:([\d\w]+) (\w+)(?: ([\S| ]*))?/,
        names: ['id', 'direction', 'params'],
        format: function (o) {
          return (o.params) ? 'rid:%s %s %s' : 'rid:%s %s';
        }
      },
      {
        // a=imageattr:97 send [x=800,y=640,sar=1.1,q=0.6] [x=480,y=320] recv [x=330,y=250]
        // a=imageattr:* send [x=800,y=640] recv *
        // a=imageattr:100 recv [x=320,y=240]
        push: 'imageattrs',
        reg: new RegExp(
          // a=imageattr:97
          '^imageattr:(\\d+|\\*)' +
          // send [x=800,y=640,sar=1.1,q=0.6] [x=480,y=320]
          '[\\s\\t]+(send|recv)[\\s\\t]+(\\*|\\[\\S+\\](?:[\\s\\t]+\\[\\S+\\])*)' +
          // recv [x=330,y=250]
          '(?:[\\s\\t]+(recv|send)[\\s\\t]+(\\*|\\[\\S+\\](?:[\\s\\t]+\\[\\S+\\])*))?'
        ),
        names: ['pt', 'dir1', 'attrs1', 'dir2', 'attrs2'],
        format: function (o) {
          return 'imageattr:%s %s %s' + (o.dir2 ? ' %s %s' : '');
        }
      },
      {
        // a=simulcast:send 1,2,3;~4,~5 recv 6;~7,~8
        // a=simulcast:recv 1;4,5 send 6;7
        name: 'simulcast',
        reg: new RegExp(
          // a=simulcast:
          '^simulcast:' +
          // send 1,2,3;~4,~5
          '(send|recv) ([a-zA-Z0-9\\-_~;,]+)' +
          // space + recv 6;~7,~8
          '(?:\\s?(send|recv) ([a-zA-Z0-9\\-_~;,]+))?' +
          // end
          '$'
        ),
        names: ['dir1', 'list1', 'dir2', 'list2'],
        format: function (o) {
          return 'simulcast:%s %s' + (o.dir2 ? ' %s %s' : '');
        }
      },
      {
        // old simulcast draft 03 (implemented by Firefox)
        //   https://tools.ietf.org/html/draft-ietf-mmusic-sdp-simulcast-03
        // a=simulcast: recv pt=97;98 send pt=97
        // a=simulcast: send rid=5;6;7 paused=6,7
        name: 'simulcast_03',
        reg: /^simulcast:[\s\t]+([\S+\s\t]+)$/,
        names: ['value'],
        format: 'simulcast: %s'
      },
      {
        // a=framerate:25
        // a=framerate:29.97
        name: 'framerate',
        reg: /^framerate:(\d+(?:$|\.\d+))/,
        format: 'framerate:%s'
      },
      {
        // RFC4570
        // a=source-filter: incl IN IP4 239.5.2.31 10.1.15.5
        name: 'sourceFilter',
        reg: /^source-filter: *(excl|incl) (\S*) (IP4|IP6|\*) (\S*) (.*)/,
        names: ['filterMode', 'netType', 'addressTypes', 'destAddress', 'srcList'],
        format: 'source-filter: %s %s %s %s %s'
      },
      {
        // a=bundle-only
        name: 'bundleOnly',
        reg: /^(bundle-only)/
      },
      {
        // a=label:1
        name: 'label',
        reg: /^label:(.+)/,
        format: 'label:%s'
      },
      {
        // RFC version 26 for SCTP over DTLS
        // https://tools.ietf.org/html/draft-ietf-mmusic-sctp-sdp-26#section-5
        name: 'sctpPort',
        reg: /^sctp-port:(\d+)$/,
        format: 'sctp-port:%s'
      },
      {
        // RFC version 26 for SCTP over DTLS
        // https://tools.ietf.org/html/draft-ietf-mmusic-sctp-sdp-26#section-6
        name: 'maxMessageSize',
        reg: /^max-message-size:(\d+)$/,
        format: 'max-message-size:%s'
      },
      {
        // RFC7273
        // a=ts-refclk:ptp=IEEE1588-2008:39-A7-94-FF-FE-07-CB-D0:37
        push:'tsRefClocks',
        reg: /^ts-refclk:([^\s=]*)(?:=(\S*))?/,
        names: ['clksrc', 'clksrcExt'],
        format: function (o) {
          return 'ts-refclk:%s' + (o.clksrcExt != null ? '=%s' : '');
        }
      },
      {
        // RFC7273
        // a=mediaclk:direct=963214424
        name:'mediaClk',
        reg: /^mediaclk:(?:id=(\S*))? *([^\s=]*)(?:=(\S*))?(?: *rate=(\d+)\/(\d+))?/,
        names: ['id', 'mediaClockName', 'mediaClockValue', 'rateNumerator', 'rateDenominator'],
        format: function (o) {
          var str = 'mediaclk:';
          str += (o.id != null ? 'id=%s %s' : '%v%s');
          str += (o.mediaClockValue != null ? '=%s' : '');
          str += (o.rateNumerator != null ? ' rate=%s' : '');
          str += (o.rateDenominator != null ? '/%s' : '');
          return str;
        }
      },
      {
        // a=keywds:keywords
        name: 'keywords',
        reg: /^keywds:(.+)$/,
        format: 'keywds:%s'
      },
      {
        // a=content:main
        name: 'content',
        reg: /^content:(.+)/,
        format: 'content:%s'
      },
      // BFCP https://tools.ietf.org/html/rfc4583
      {
        // a=floorctrl:c-s
        name: 'bfcpFloorCtrl',
        reg: /^floorctrl:(c-only|s-only|c-s)/,
        format: 'floorctrl:%s'
      },
      {
        // a=confid:1
        name: 'bfcpConfId',
        reg: /^confid:(\d+)/,
        format: 'confid:%s'
      },
      {
        // a=userid:1
        name: 'bfcpUserId',
        reg: /^userid:(\d+)/,
        format: 'userid:%s'
      },
      {
        // a=floorid:1
        name: 'bfcpFloorId',
        reg: /^floorid:(.+) (?:m-stream|mstrm):(.+)/,
        names: ['id', 'mStream'],
        format: 'floorid:%s mstrm:%s'
      },
      {
        // any a= that we don't understand is kept verbatim on media.invalid
        push: 'invalid',
        names: ['value']
      }
    ]
  };

  // set sensible defaults to avoid polluting the grammar with boring details
  Object.keys(grammar).forEach(function (key) {
    var objs = grammar[key];
    objs.forEach(function (obj) {
      if (!obj.reg) {
        obj.reg = /(.*)/;
      }
      if (!obj.format) {
        obj.format = '%s';
      }
    });
  });
  });
  var grammar_2 = grammar_1.v;
  var grammar_3 = grammar_1.o;
  var grammar_4 = grammar_1.s;
  var grammar_5 = grammar_1.i;
  var grammar_6 = grammar_1.u;
  var grammar_7 = grammar_1.e;
  var grammar_8 = grammar_1.p;
  var grammar_9 = grammar_1.z;
  var grammar_10 = grammar_1.r;
  var grammar_11 = grammar_1.t;
  var grammar_12 = grammar_1.c;
  var grammar_13 = grammar_1.b;
  var grammar_14 = grammar_1.m;
  var grammar_15 = grammar_1.a;

  var parser = createCommonjsModule(function (module, exports) {
  var toIntIfInt = function (v) {
    return String(Number(v)) === v ? Number(v) : v;
  };

  var attachProperties = function (match, location, names, rawName) {
    if (rawName && !names) {
      location[rawName] = toIntIfInt(match[1]);
    }
    else {
      for (var i = 0; i < names.length; i += 1) {
        if (match[i+1] != null) {
          location[names[i]] = toIntIfInt(match[i+1]);
        }
      }
    }
  };

  var parseReg = function (obj, location, content) {
    var needsBlank = obj.name && obj.names;
    if (obj.push && !location[obj.push]) {
      location[obj.push] = [];
    }
    else if (needsBlank && !location[obj.name]) {
      location[obj.name] = {};
    }
    var keyLocation = obj.push ?
      {} :  // blank object that will be pushed
      needsBlank ? location[obj.name] : location; // otherwise, named location or root

    attachProperties(content.match(obj.reg), keyLocation, obj.names, obj.name);

    if (obj.push) {
      location[obj.push].push(keyLocation);
    }
  };


  var validLine = RegExp.prototype.test.bind(/^([a-z])=(.*)/);

  exports.parse = function (sdp) {
    var session = {}
      , media = []
      , location = session; // points at where properties go under (one of the above)

    // parse lines we understand
    sdp.split(/(\r\n|\r|\n)/).filter(validLine).forEach(function (l) {
      var type = l[0];
      var content = l.slice(2);
      if (type === 'm') {
        media.push({rtp: [], fmtp: []});
        location = media[media.length-1]; // point at latest media line
      }

      for (var j = 0; j < (grammar_1[type] || []).length; j += 1) {
        var obj = grammar_1[type][j];
        if (obj.reg.test(content)) {
          return parseReg(obj, location, content);
        }
      }
    });

    session.media = media; // link it up
    return session;
  };

  var paramReducer = function (acc, expr) {
    var s = expr.split(/=(.+)/, 2);
    if (s.length === 2) {
      acc[s[0]] = toIntIfInt(s[1]);
    } else if (s.length === 1 && expr.length > 1) {
      acc[s[0]] = undefined;
    }
    return acc;
  };

  exports.parseParams = function (str) {
    return str.split(/;\s?/).reduce(paramReducer, {});
  };

  // For backward compatibility - alias will be removed in 3.0.0
  exports.parseFmtpConfig = exports.parseParams;

  exports.parsePayloads = function (str) {
    return str.toString().split(' ').map(Number);
  };

  exports.parseRemoteCandidates = function (str) {
    var candidates = [];
    var parts = str.split(' ').map(toIntIfInt);
    for (var i = 0; i < parts.length; i += 3) {
      candidates.push({
        component: parts[i],
        ip: parts[i + 1],
        port: parts[i + 2]
      });
    }
    return candidates;
  };

  exports.parseImageAttributes = function (str) {
    return str.split(' ').map(function (item) {
      return item.substring(1, item.length-1).split(',').reduce(paramReducer, {});
    });
  };

  exports.parseSimulcastStreamList = function (str) {
    return str.split(';').map(function (stream) {
      return stream.split(',').map(function (format) {
        var scid, paused = false;

        if (format[0] !== '~') {
          scid = toIntIfInt(format);
        } else {
          scid = toIntIfInt(format.substring(1, format.length));
          paused = true;
        }

        return {
          scid: scid,
          paused: paused
        };
      });
    });
  };
  });
  var parser_1 = parser.parse;
  var parser_2 = parser.parseParams;
  var parser_3 = parser.parseFmtpConfig;
  var parser_4 = parser.parsePayloads;
  var parser_5 = parser.parseRemoteCandidates;
  var parser_6 = parser.parseImageAttributes;
  var parser_7 = parser.parseSimulcastStreamList;

  // customized util.format - discards excess arguments and can void middle ones
  var formatRegExp = /%[sdv%]/g;
  var format = function (formatStr) {
    var i = 1;
    var args = arguments;
    var len = args.length;
    return formatStr.replace(formatRegExp, function (x) {
      if (i >= len) {
        return x; // missing argument
      }
      var arg = args[i];
      i += 1;
      switch (x) {
      case '%%':
        return '%';
      case '%s':
        return String(arg);
      case '%d':
        return Number(arg);
      case '%v':
        return '';
      }
    });
    // NB: we discard excess arguments - they are typically undefined from makeLine
  };

  var makeLine = function (type, obj, location) {
    var str = obj.format instanceof Function ?
      (obj.format(obj.push ? location : location[obj.name])) :
      obj.format;

    var args = [type + '=' + str];
    if (obj.names) {
      for (var i = 0; i < obj.names.length; i += 1) {
        var n = obj.names[i];
        if (obj.name) {
          args.push(location[obj.name][n]);
        }
        else { // for mLine and push attributes
          args.push(location[obj.names[i]]);
        }
      }
    }
    else {
      args.push(location[obj.name]);
    }
    return format.apply(null, args);
  };

  // RFC specified order
  // TODO: extend this with all the rest
  var defaultOuterOrder = [
    'v', 'o', 's', 'i',
    'u', 'e', 'p', 'c',
    'b', 't', 'r', 'z', 'a'
  ];
  var defaultInnerOrder = ['i', 'c', 'b', 'a'];


  var writer = function (session, opts) {
    opts = opts || {};
    // ensure certain properties exist
    if (session.version == null) {
      session.version = 0; // 'v=0' must be there (only defined version atm)
    }
    if (session.name == null) {
      session.name = ' '; // 's= ' must be there if no meaningful name set
    }
    session.media.forEach(function (mLine) {
      if (mLine.payloads == null) {
        mLine.payloads = '';
      }
    });

    var outerOrder = opts.outerOrder || defaultOuterOrder;
    var innerOrder = opts.innerOrder || defaultInnerOrder;
    var sdp = [];

    // loop through outerOrder for matching properties on session
    outerOrder.forEach(function (type) {
      grammar_1[type].forEach(function (obj) {
        if (obj.name in session && session[obj.name] != null) {
          sdp.push(makeLine(type, obj, session));
        }
        else if (obj.push in session && session[obj.push] != null) {
          session[obj.push].forEach(function (el) {
            sdp.push(makeLine(type, obj, el));
          });
        }
      });
    });

    // then for each media line, follow the innerOrder
    session.media.forEach(function (mLine) {
      sdp.push(makeLine('m', grammar_1.m[0], mLine));

      innerOrder.forEach(function (type) {
        grammar_1[type].forEach(function (obj) {
          if (obj.name in mLine && mLine[obj.name] != null) {
            sdp.push(makeLine(type, obj, mLine));
          }
          else if (obj.push in mLine && mLine[obj.push] != null) {
            mLine[obj.push].forEach(function (el) {
              sdp.push(makeLine(type, obj, el));
            });
          }
        });
      });
    });

    return sdp.join('\r\n') + '\r\n';
  };

  var write = writer;
  var parse = parser.parse;
  var parseParams = parser.parseParams;
  var parseFmtpConfig = parser.parseFmtpConfig; // Alias of parseParams().
  var parsePayloads = parser.parsePayloads;
  var parseRemoteCandidates = parser.parseRemoteCandidates;
  var parseImageAttributes = parser.parseImageAttributes;
  var parseSimulcastStreamList = parser.parseSimulcastStreamList;

  var lib = {
  	write: write,
  	parse: parse,
  	parseParams: parseParams,
  	parseFmtpConfig: parseFmtpConfig,
  	parsePayloads: parsePayloads,
  	parseRemoteCandidates: parseRemoteCandidates,
  	parseImageAttributes: parseImageAttributes,
  	parseSimulcastStreamList: parseSimulcastStreamList
  };

  var checkTrack = function checkTrack(prevSdp, curSdp) {
    var prevMedia = lib.parse(prevSdp).media;
    var curMedia = lib.parse(curSdp).media;
    var added = curMedia.filter(function (item) {
      var p = prevMedia.find(function (pi) {
        return pi.mid === item.mid;
      });
      return (p === undefined || p.ssrcs === undefined) && item.ssrcs;
    });
    var removed = prevMedia.filter(function (item) {
      var c = curMedia.find(function (ci) {
        return ci.mid === item.mid;
      });
      return (c === undefined || c.ssrcs === undefined) && item.ssrcs;
    });
    return {
      added: added,
      removed: removed
    };
  };
  /**
   * validate if a track is associated with a valid ssrc.
   * assuming that audio track is packaged together with main video track in the same stream
   * and auxiliary video track is in separate stream
   */

  var validateStreams = function validateStreams(sdp) {
    var parsed = lib.parse(sdp);
    var validated = {
      audio: [],
      video: []
    };
    parsed.media.forEach(function (item) {
      if (item.ssrcs) {
        var id = item.ssrcs[0].id;
        var type = id >> 16 & 0xff;

        if (item.type === 'audio') {
          // audio is always in main stream.
          validated.audio.push(MAIN_STREAM_MSID);
        } else if (item.type == 'video') {
          var msid = type === StreamType.MAIN ? MAIN_STREAM_MSID : AUX_STREAM_MSID;
          validated.video.push(msid);
        }
      }
    });
    return validated;
  };
  var parse$1 = function parse(sdp) {
    return lib.parse(sdp);
  };
  var getStreamTypeFromSsrc = function getStreamTypeFromSsrc(ssrcId) {
    return ssrcId >> 16 & 0xff;
  };

  var Stats = /*#__PURE__*/function () {
    function Stats(options) {
      _classCallCheck(this, Stats);

      this.prevReport_ = {};
    }

    _createClass(Stats, [{
      key: "getSenderStats",
      value: function () {
        var _getSenderStats = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(connection) {
          var stats, pc, results;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  stats = {
                    audio: {
                      bytesSent: 0,
                      packetsSent: 0,
                      audioLevel: 0,
                      totalAudioEnergy: 0
                    },
                    video: {
                      bytesSent: 0,
                      packetsSent: 0,
                      framesEncoded: 0,
                      frameWidth: 0,
                      frameHeight: 0,
                      framesSent: 0
                    },
                    rtt: 0
                  };
                  pc = connection.getPeerConnection();

                  if (!pc) {
                    _context.next = 13;
                    break;
                  }

                  _context.prev = 3;
                  _context.next = 6;
                  return pc.getStats();

                case 6:
                  results = _context.sent;
                  results.forEach(function (item) {
                    // log.debug('uplink item: ' + JSON.stringify(item));
                    if (item.type === 'outbound-rtp') {
                      // log.debug('outbound-rtp item: ' + JSON.stringify(item));
                      if (item.mediaType === 'video') {
                        stats.video.bytesSent = item.bytesSent;
                        stats.video.packetsSent = item.packetsSent;
                        stats.video.framesEncoded = item.framesEncoded;
                      } else if (item.mediaType === 'audio') {
                        stats.audio.bytesSent = item.bytesSent;
                        stats.audio.packetsSent = item.packetsSent;
                      }
                    } else if (item.type === 'candidate-pair') {
                      stats.rtt = item.currentRoundTripTime * 1000;
                    } else if (item.type === 'track') {
                      if (item.frameWidth !== 'undefined') {
                        // this is the trackId for video sender
                        stats.video.frameWidth = item.frameWidth;
                        stats.video.frameHeight = item.frameHeight;
                        stats.video.framesSent = item.framesSent;
                      } // safari type = 'track'


                      if (typeof item.audioLevel !== 'undefined') {
                        stats.audio.audioLevel = item.audioLevel || 0;
                      }
                    } else if (item.type === 'media-source') {
                      // chrome 78+ 'media-source'
                      if (item.kind === 'audio') {
                        stats.audio.audioLevel = item.audioLevel || 0;
                        stats.audio.totalAudioEnergy = item.totalAudioEnergy || 0;
                      }
                    }
                  });
                  _context.next = 13;
                  break;

                case 10:
                  _context.prev = 10;
                  _context.t0 = _context["catch"](3);
                  logger.warn('failed to getStats on sender connection');

                case 13:
                  return _context.abrupt("return", stats);

                case 14:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[3, 10]]);
        }));

        function getSenderStats(_x) {
          return _getSenderStats.apply(this, arguments);
        }

        return getSenderStats;
      }()
    }, {
      key: "getReceiverStats",
      value: function () {
        var _getReceiverStats = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(connection) {
          var stats, pc, results;
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  stats = {
                    tinyId: connection.getTinyId(),
                    userId: connection.getUserId(),
                    hasAudio: false,
                    hasVideo: false,
                    audio: {
                      bytesReceived: 0,
                      packetsReceived: 0,
                      packetsLost: 0,
                      jitter: 0,
                      audioLevel: 0,
                      totalAudioEnergy: 0
                    },
                    video: {
                      bytesReceived: 0,
                      packetsReceived: 0,
                      packetsLost: 0,
                      framesDecoded: 0,
                      frameWidth: 0,
                      frameHeight: 0
                    }
                  };
                  pc = connection.getPeerConnection();

                  if (!pc) {
                    _context2.next = 13;
                    break;
                  }

                  _context2.prev = 3;
                  _context2.next = 6;
                  return pc.getStats();

                case 6:
                  results = _context2.sent;
                  results.forEach(function (item) {
                    // log.debug('downlink item: ' + JSON.stringify(item));
                    if (item.type === 'inbound-rtp') {
                      // log.debug('inbound-rtp item: ' + JSON.stringify(item));
                      if (item.mediaType === 'audio') {
                        stats.audio.packetsReceived = item.packetsReceived;
                        stats.audio.bytesReceived = item.bytesReceived;
                        stats.audio.packetsLost = item.packetsLost;
                        stats.audio.jitter = item.jitter;
                        stats.hasAudio = true;
                      } else if (item.mediaType === 'video') {
                        stats.video.packetsReceived = item.packetsReceived;
                        stats.video.bytesReceived = item.bytesReceived;
                        stats.video.packetsLost = item.packetsLost;
                        stats.video.framesDecoded = item.framesDecoded;
                        stats.hasVideo = true;
                      }
                    } else if (item.type === 'track') {
                      if (typeof item.frameWidth !== 'undefined') {
                        // this is a track for video receiver
                        stats.video.frameWidth = item.frameWidth;
                        stats.video.frameHeight = item.frameHeight;
                      }

                      if (item.kind === 'audio') {
                        stats.audio.audioLevel = item.audioLevel || 0;
                        stats.audio.totalAudioEnergy = item.totalAudioEnergy || 0;
                      }
                    }
                  });
                  _context2.next = 13;
                  break;

                case 10:
                  _context2.prev = 10;
                  _context2.t0 = _context2["catch"](3);
                  logger.warn('failed to getStats on receiver connection');

                case 13:
                  return _context2.abrupt("return", stats);

                case 14:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, null, [[3, 10]]);
        }));

        function getReceiverStats(_x2) {
          return _getReceiverStats.apply(this, arguments);
        }

        return getReceiverStats;
      }()
    }, {
      key: "getStats",
      value: function () {
        var _getStats = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(uplinkConnection, downlinkConnections) {
          var senderStats, receiverStats, _iterator, _step, _step$value, key, value, st;

          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  senderStats = {};

                  if (!uplinkConnection) {
                    _context3.next = 5;
                    break;
                  }

                  _context3.next = 4;
                  return this.getSenderStats(uplinkConnection);

                case 4:
                  senderStats = _context3.sent;

                case 5:
                  receiverStats = [];
                  _iterator = _createForOfIteratorHelper(downlinkConnections);
                  _context3.prev = 7;

                  _iterator.s();

                case 9:
                  if ((_step = _iterator.n()).done) {
                    _context3.next = 17;
                    break;
                  }

                  _step$value = _slicedToArray(_step.value, 2), key = _step$value[0], value = _step$value[1];
                  _context3.next = 13;
                  return this.getReceiverStats(value);

                case 13:
                  st = _context3.sent;
                  receiverStats.push(st);

                case 15:
                  _context3.next = 9;
                  break;

                case 17:
                  _context3.next = 22;
                  break;

                case 19:
                  _context3.prev = 19;
                  _context3.t0 = _context3["catch"](7);

                  _iterator.e(_context3.t0);

                case 22:
                  _context3.prev = 22;

                  _iterator.f();

                  return _context3.finish(22);

                case 25:
                  return _context3.abrupt("return", {
                    senderStats: senderStats,
                    receiverStats: receiverStats
                  });

                case 26:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3, this, [[7, 19, 22, 25]]);
        }));

        function getStats(_x3, _x4) {
          return _getStats.apply(this, arguments);
        }

        return getStats;
      }()
    }, {
      key: "prepareReport",
      value: function prepareReport(stats, report) {
        // senders' stats
        if (!isEmpty(stats.senderStats)) {
          report.uint32_delay = stats.senderStats.rtt;
          report.AudioReportState.sentAudioLevel = stats.senderStats.audio.audioLevel;
          report.AudioReportState.sentAudioEnergy = stats.senderStats.audio.totalAudioEnergy;
          report.AudioReportState.uint32_audio_enc_pkg_br = stats.senderStats.audio.bytesSent;
          report.VideoReportState.uint32_video_snd_br = stats.senderStats.video.bytesSent;
          report.VideoReportState.uint32_send_total_pkg = stats.senderStats.video.packetsSent; // video encode stats

          report.VideoReportState.VideoEncState[0].uint32_enc_width = stats.senderStats.video.frameWidth;
          report.VideoReportState.VideoEncState[0].uint32_enc_height = stats.senderStats.video.frameHeight;
          report.VideoReportState.VideoEncState[0].uint32_enc_fps = stats.senderStats.video.framesSent;
        }

        stats.receiverStats.forEach(function (st) {
          if (st.hasAudio) {
            report.AudioReportState.AudioDecState.push({
              uint32_audio_delay: 0,
              uint32_audio_jitter: st.audio.jitter,
              uint32_audio_real_recv_pkg: st.audio.packetsReceived,
              uint32_audio_flow: st.audio.bytesReceived,
              uint32_audio_real_recv_br: 0,
              uint64_sender_uin: st.tinyId,
              packetsLost: st.audio.packetsLost,
              totalPacketsLost: st.audio.packetsLost,
              audioLevel: st.audio.audioLevel,
              audioEnergy: st.audio.totalAudioEnergy
            });
            report.AudioReportState.uint32_audio_real_recv_pkg += st.audio.packetsReceived;
            report.AudioReportState.uint32_audio_flow += st.audio.bytesReceived;
            report.uint32_real_num += st.audio.packetsReceived;
          }

          if (st.hasVideo) {
            report.VideoReportState.VideoDecState.push({
              uint32_video_recv_fps: st.video.framesDecoded,
              uint32_video_recv_br: st.video.bytesReceived,
              //单路视频下行码率
              uint32_video_real_recv_pkg: st.video.packetsReceived,
              //单路下行收包
              uint32_dec_height: st.video.frameHeight,
              uint32_dec_width: st.video.frameWidth,
              uint32_video_jitter: 0,
              uint64_sender_uin: st.tinyId,
              packetsLost: st.video.packetsLost,
              totalPacketsLost: st.video.packetsLost
            });
            report.VideoReportState.uint32_video_total_real_recv_pkg += st.video.packetsReceived;
            report.VideoReportState.uint32_video_rcv_br += st.video.bytesReceived;
          }
        });
        report.uint64_end_utime = new Date().getTime();
        var prevReport = this.prevReport_; // it's fine that use JSON.parse/strigify to do a deep copy as
        // all field in the report is JSON stringifyable

        this.prevReport_ = JSON.parse(JSON.stringify(report)); // code below are copied from old SDK

        if (isEmpty(prevReport)) {
          report.AudioReportState.uint32_audio_enc_pkg_br = report.AudioReportState.uint32_audio_enc_pkg_br * 8 / 2;
          report.VideoReportState.uint32_video_rcv_br = report.VideoReportState.uint32_video_rcv_br * 8 / 2;
          report.VideoReportState.uint32_video_snd_br = report.VideoReportState.uint32_video_snd_br * 8 / 2;
          report.VideoReportState.VideoDecState.forEach(function (st) {
            st.uint32_video_recv_br = st.uint32_video_recv_br * 8 / 2;
            report.uint32_total_send_bps = report.AudioReportState.uint32_audio_enc_pkg_br + report.VideoReportState.uint32_video_snd_br;
          });
        } else {
          report.uint64_begine_utime = prevReport.uint64_end_utime;
          report.uint32_real_num -= prevReport.uint32_real_num;

          if (report.uint32_real_num <= 0) {
            report.uint32_real_num = 0;
          }

          report.AudioReportState.uint32_audio_real_recv_pkg -= prevReport.AudioReportState.uint32_audio_real_recv_pkg;

          if (report.AudioReportState.uint32_audio_real_recv_pkg <= 0) {
            report.AudioReportState.uint32_audio_real_recv_pkg = 0;
          }

          report.AudioReportState.uint32_audio_enc_pkg_br -= prevReport.AudioReportState.uint32_audio_enc_pkg_br;

          if (report.AudioReportState.uint32_audio_enc_pkg_br <= 0) {
            report.AudioReportState.uint32_audio_enc_pkg_br = 0;
          }

          report.AudioReportState.uint32_audio_enc_pkg_br = report.AudioReportState.uint32_audio_enc_pkg_br * 8 / 2;
          report.VideoReportState.uint32_video_snd_br -= prevReport.VideoReportState.uint32_video_snd_br;

          if (report.VideoReportState.uint32_video_snd_br <= 0) {
            report.VideoReportState.uint32_video_snd_br = 0;
          }

          report.VideoReportState.uint32_video_snd_br = report.VideoReportState.uint32_video_snd_br * 8 / 2;
          report.AudioReportState.uint32_audio_flow -= prevReport.AudioReportState.uint32_audio_flow;

          if (report.AudioReportState.uint32_audio_flow <= 0) {
            report.AudioReportState.uint32_audio_flow = 0;
          }

          report.VideoReportState.uint32_send_total_pkg -= prevReport.VideoReportState.uint32_send_total_pkg;

          if (report.VideoReportState.uint32_send_total_pkg <= 0) {
            report.VideoReportState.uint32_send_total_pkg = 0;
          }

          report.VideoReportState.uint32_video_rcv_br -= prevReport.VideoReportState.uint32_video_rcv_br;

          if (report.VideoReportState.uint32_video_rcv_br <= 0) {
            report.VideoReportState.uint32_video_rcv_br = 0;
          }

          report.VideoReportState.uint32_video_rcv_br = report.VideoReportState.uint32_video_rcv_br * 8 / 2;
          report.VideoReportState.uint32_video_total_real_recv_pkg -= prevReport.VideoReportState.uint32_video_total_real_recv_pkg;

          if (report.VideoReportState.uint32_video_total_real_recv_pkg <= 0) {
            report.VideoReportState.uint32_video_total_real_recv_pkg = 0;
          } // encode fps calc


          report.VideoReportState.VideoEncState[0].uint32_enc_fps -= prevReport.VideoReportState.VideoEncState[0].uint32_enc_fps;

          if (report.VideoReportState.VideoEncState[0].uint32_enc_fps < 0) {
            report.VideoReportState.VideoEncState[0].uint32_enc_fps = 0;
          }

          report.VideoReportState.VideoEncState[0].uint32_enc_fps = report.VideoReportState.VideoEncState[0].uint32_enc_fps / 2;
          var len = report.VideoReportState.VideoDecState.length;

          for (var i = 0; i < len; i++) {
            var decVideoItem = report.VideoReportState.VideoDecState[i];
            var tinyid = decVideoItem.uint64_sender_uin;
            var recvPackage = decVideoItem.uint32_video_real_recv_pkg;
            var recvBr = decVideoItem.uint32_video_recv_br;
            var fps = decVideoItem.uint32_video_recv_fps;

            for (var k = 0; k < prevReport.VideoReportState.VideoDecState.length; k++) {
              var tempItem = prevReport.VideoReportState.VideoDecState[k];

              if (tempItem.uint64_sender_uin === tinyid) {
                // packetsLost should be the 2s' delta
                decVideoItem.packetsLost = decVideoItem.totalPacketsLost - tempItem.totalPacketsLost;
                recvPackage -= tempItem.uint32_video_real_recv_pkg;

                if (recvPackage <= 0) {
                  recvPackage = 0;
                }

                recvBr -= tempItem.uint32_video_recv_br;

                if (recvBr <= 0) {
                  recvBr = 0;
                } // decode fps calc


                fps -= tempItem.uint32_video_recv_fps;
                if (fps < 0) fps = 0;
                break;
              }
            }

            report.VideoReportState.VideoDecState[i].uint32_video_real_recv_pkg = recvPackage;
            report.VideoReportState.VideoDecState[i].uint32_video_recv_br = recvBr * 8 / 2;
            report.VideoReportState.VideoDecState[i].uint32_video_recv_fps = fps / 2;
          }

          len = report.AudioReportState.AudioDecState.length;

          for (var _i = 0; _i < len; _i++) {
            var decAudioItem = report.AudioReportState.AudioDecState[_i];
            var audioRecvPack = decAudioItem.uint32_audio_real_recv_pkg;
            var audioRecvFlow = decAudioItem.uint32_audio_flow;
            var _tinyid = decAudioItem.uint64_sender_uin;

            for (var h = 0; h < prevReport.AudioReportState.AudioDecState.length; h++) {
              var tempAudioItem = prevReport.AudioReportState.AudioDecState[h];

              if (tempAudioItem.uint64_sender_uin === _tinyid) {
                // packetsLost should be the 2s' delta
                decAudioItem.packetsLost = decAudioItem.totalPacketsLost - tempAudioItem.totalPacketsLost;
                audioRecvPack -= tempAudioItem.uint32_audio_real_recv_pkg;

                if (audioRecvPack <= 0) {
                  audioRecvPack = 0;
                }

                audioRecvFlow -= tempAudioItem.uint32_audio_flow;

                if (audioRecvFlow <= 0) {
                  audioRecvFlow = 0;
                }

                break;
              }
            }

            report.AudioReportState.AudioDecState[_i].uint32_audio_real_recv_pkg = audioRecvPack;
            report.AudioReportState.AudioDecState[_i].uint32_audio_flow = audioRecvFlow;
            report.AudioReportState.AudioDecState[_i].uint32_audio_real_recv_br = audioRecvFlow * 8 / 2;
          }

          report.AudioReportState.uint32_audio_real_recv_br = report.AudioReportState.uint32_audio_flow * 8 / 2;
          report.uint32_real_num = report.AudioReportState.uint32_audio_real_recv_pkg + report.VideoReportState.uint32_video_total_real_recv_pkg;
          report.uint32_total_send_bps = report.AudioReportState.uint32_audio_enc_pkg_br + report.VideoReportState.uint32_video_snd_br;
          report.uint32_total_recv_bps = report.AudioReportState.uint32_audio_real_recv_br + report.VideoReportState.uint32_video_rcv_br;
        }

        return report;
      }
    }, {
      key: "getStatsReport",
      value: function () {
        var _getStatsReport = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(uplinkConnection, downlinkConnections) {
          var report, stats;
          return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  report = {
                    uint64_begine_utime: new Date().getTime(),
                    uint64_end_utime: 0,
                    uint32_real_num: 0,
                    //音频总下行包
                    uint32_delay: 0,
                    // Conn-audio-1-0 googRtt
                    uint32_CPU_curfreq: 0,
                    uint32_total_send_bps: 0,
                    //总上行码率
                    uint32_total_recv_bps: 0,
                    AudioReportState: {
                      uint32_audio_enc_pkg_br: 0,
                      //音频上行码率
                      uint32_audio_real_recv_pkg: 0,
                      //音频下行收包
                      uint32_audio_flow: 0,
                      //音频下行流量
                      uint32_audio_real_recv_br: 0,
                      //音频下行码率
                      uint32_audio_delay: 0,
                      //googCurrentDelayMs
                      uint32_audio_jitter: 0,
                      //googJitterBufferMs
                      uint32_microphone_status: 1,
                      sentAudioLevel: 0,
                      sentAudioEnergy: 0,
                      AudioDecState: []
                    },
                    VideoReportState: {
                      uint32_video_delay: 0,
                      //googTargetDelayMs
                      uint32_video_snd_br: 0,
                      //视频上行码率
                      uint32_video_total_real_recv_pkg: 0,
                      //视频下行收包
                      uint32_video_rcv_br: 0,
                      //视频下行码率
                      uint32_send_total_pkg: 0,
                      //视频上行发包
                      VideoEncState: [{
                        uint32_enc_width: 0,
                        uint32_enc_height: 0,
                        uint32_capture_fps: 0,
                        uint32_enc_fps: 0
                      }],
                      VideoDecState: []
                    }
                  };
                  _context4.next = 3;
                  return this.getStats(uplinkConnection, downlinkConnections);

                case 3:
                  stats = _context4.sent;
                  this.prepareReport(stats, report);
                  return _context4.abrupt("return", report);

                case 6:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4, this);
        }));

        function getStatsReport(_x5, _x6) {
          return _getStatsReport.apply(this, arguments);
        }

        return getStatsReport;
      }()
    }]);

    return Stats;
  }();

  var offerOptions = {
    // offerToReceiveAudio: true,
    // offerToReceiveVideo: true,
    voiceActivityDetection: false
  };
  /**
   * Connection represents a peer connection between the local and remote
   * It handles the events received from RTCPeerConnection and events
   * received from SignalChannel which is dedicated to the connection.
   *
   * For uplink connection, it's also responsible for publishing local stream.
   * For downlink connection, it's responsible for constructing remote stream.
   * There could be two remote streams in one downlink connection, one of the two
   * is the remote stream containing the audio track and the main video track,
   * another one is the remote stream containing only the auxiliary video stream,
   * e.g, the screen sharing stream
   *
   * @export
   * @class Connection
   */

  var Connection = /*#__PURE__*/function () {
    function Connection(options) {
      _classCallCheck(this, Connection);

      /*
       * the userId who initiates the connection, for uplink connection it's the local userId
       * for downlink connection, it's the remote userId.
       */
      this.userId_ = options.userId; // tinyId is the userId representation in remote server.

      this.tinyId_ = options.tinyId;
      this.client_ = options.client;
      this.sdpSemantics_ = options.client.getSdpSemantics();
      this.isUplink_ = options.isUplink;
      this.log_ = new IDLogger({
        id: 'n|' + this.userId_,
        direction: this.isUplink_ ? 'local' : 'remote',
        type: ''
      });
      this.signalChannel_ = options.signalChannel;
      this.peerConnection_ = null;
      this.connectTimer_ = -1;
      /** @type {Map<number:Stream>} streamId -> Stream */

      this.remoteStreams_ = new Map();
      this.localStream_ = null;
      this.waitForUpdatedAnswer_ = false; // used to prevent multiple Error Report.

      this.isErrorObserved_ = false; // uplink's muted state

      this.mutedState_ = 0; // downlink's subscribing state

      this.subscribeState_ = {
        audio: true,
        // audio track
        video: true,
        // main video track
        auxiliary: true // auxiliary video track

      };
      this.pendingSubscription_ = [];
      this.pendingStreams_ = [];
      this.subscriptionTimeout_ = -1;
      this.subscriptionRetryCount_ = 0;
      this.isSubscriptionPending_ = false;
      this.sentSubscriptionAfterConnected_ = false;
      this.emitter_ = new eventemitter3(); // 视频通话健康度统计
      // 视频生效时间

      this.startTime_ = new Date(); // 视频结束时间

      this.endTime_ = this.startTime_;
      this.hasValidEndTime_ = false;
      this.hasVideo_ = false;
    }
    /**
     * Intialize the connection, which install the permenant handlers for RTCPeerConnection and SignalChannel events
     *
     * @memberof Connection
     */


    _createClass(Connection, [{
      key: "initialize",
      value: function initialize() {
        var iceServers = this.client_.getIceServers(); // set to |relay| if user set a TURN server to force it go through TURN,
        // otherwise use |all| for normal connection.
        // This is used only for TEST!
        // const iceTransportPolicy = isEmpty(iceServers) ? 'all' : 'relay';
        // set to |all| to allow ICE select the best candidate to connect
        // it may use host/srflx to connect if it's reachable, otherwise it
        // may use relay to connect if there's a TURN available.

        var iceTransportPolicy = 'all';
        var configuration = {
          iceServers: iceServers,
          iceTransportPolicy: iceTransportPolicy,
          sdpSemantics: this.sdpSemantics_,
          bundlePolicy: 'max-bundle',
          rtcpMuxPolicy: 'require',
          // the two items below are non-standard & obsolete
          tcpCandidatePolicy: 'disable',
          IceTransportsType: 'nohost'
        };
        this.peerConnection_ = new RTCPeerConnection(configuration);
        this.peerConnection_.onconnectionstatechange = this.onConnectionStateChange.bind(this); // uplink RTCPeerConnection doesn't need to listen on ontrack event

        if (!this.isUplink_) {
          this.peerConnection_.ontrack = this.onTrack.bind(this);
        }
        /*
         * Uplink RTCPeerConnection flow:
         * 1. addTrack() of local stream
         * 2. createOffer/setLocalDescription and sending offer to remote server.
         * 3. remote server sends back answer over SignalChannel and setRemoteDescription
         */


        this.installSignalChannelEvents();
      }
      /**
       * Publish a local stream via this uplink connection
       *
       * @param {Stream} stream Local stream created by TRTC.createStream()
       * @param {function} failureCallback callback to be called on publishing failure
       * @memberof Connection
       */

    }, {
      key: "publish",
      value: function publish(stream, failureCallback) {
        var _this = this;

        this.localStream_ = stream;
        var mediaStream = stream.getMediaStream();
        this.log_.info("is publishing stream: ".concat(stream.getId()));
        mediaStream.getTracks().forEach(function (track) {
          if (track.kind === 'video') {
            _this.setVideoStats('start');
          } // The adapter.js addTrack polyfill expects a MediaStream parameter
          // verified with Chrome M59.


          _this.peerConnection_.addTrack(track, mediaStream);
        }); // update media setting before exchanging offer with remote server.

        this.updateMediaSettings(mediaStream);
        this.exchangeOffer(failureCallback);
      }
    }, {
      key: "updateMediaSettings",
      value: function updateMediaSettings(mediaStream) {
        var _this2 = this;

        // data structure defined by backend team, please bear with the ugly style.
        var mediaSettings = {
          EncVideoCodec: 'H264',
          EncVideoWidth: 0,
          EncVideoHeight: 0,
          EncVideoBr: '0',
          // bps
          EncVideoFps: 0,
          EncAudioCodec: 'opus',
          EncAudioFS: 0,
          // 采样率
          EncAudioCh: 0,
          // 声道数
          EncAudioBr: '0' // 单位bps

        };

        if ('getSettings' in MediaStreamTrack.prototype) {
          mediaStream.getTracks().forEach(function (track) {
            var settings = track.getSettings();

            if (track.kind === 'audio') {
              var channelCount = 1; // no channelCount in Safari 12.1.1

              if (settings.channelCount) channelCount = settings.channelCount;
              mediaSettings.EncAudioCh = channelCount;
              mediaSettings.EncAudioBr = "".concat(_this2.localStream_.getAudioBitrate() * 1000); // bps

              mediaSettings.EncAudioFS = settings.sampleRate;
            } else if (track.kind === 'video') {
              mediaSettings.EncVideoWidth = settings.width;
              mediaSettings.EncVideoHeight = settings.height;
              mediaSettings.EncVideoFps = settings.frameRate;
              mediaSettings.EncVideoBr = "".concat(_this2.localStream_.getVideoBitrate() * 1000); // bps
            }
          });
        } else {
          mediaSettings = this.getMediaSettingsFromProfile(mediaSettings);
        }

        this.log_.info('updateMediaSettings: ' + JSON.stringify(mediaSettings));
        this.signalChannel_.send(SignalCommand.UPDATE_MEDIA_SETTINGS, mediaSettings);
      }
    }, {
      key: "getMediaSettingsFromProfile",
      value: function getMediaSettingsFromProfile(settings) {
        var stream = this.localStream_;

        if (stream) {
          if (stream.getAudioTrack()) {
            var profile = stream.getAudioProfile();
            settings.EncAudioCh = profile.channelCount;
            settings.EncAudioBr = "".concat(profile.bitrate * 1000); // bps

            settings.EncAudioFS = profile.sampleRate;
          }

          if (stream.getVideoTrack()) {
            var _profile = stream.getVideoProfile();

            settings.EncVideoWidth = _profile.width;
            settings.EncVideoHeight = _profile.height;
            settings.EncVideoFps = _profile.frameRate;
            settings.EncVideoBr = "".concat(_profile.bitrate * 1000); // bps
          }
        }

        return settings;
      }
      /**
       * replace the tracks in the on-going RTCPeerConnection.
       * this is only valid for uplink connection
       *
       * @param {MediaStream} stream
       */

    }, {
      key: "replaceStream",
      value: function () {
        var _replaceStream = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(stream) {
          var _this3 = this;

          var videoTracks, audioTracks, senders;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!this.peerConnection_) {
                    _context.next = 8;
                    break;
                  }

                  videoTracks = stream.getVideoTracks();
                  audioTracks = stream.getAudioTracks();
                  senders = this.peerConnection_.getSenders() || [];
                  senders.forEach(function (sender) {
                    if (sender.track) {
                      if (sender.track.kind === 'video') {
                        if (sender.replaceTrack && videoTracks.length > 0) {
                          sender.replaceTrack(videoTracks[0]);
                        } else {
                          _this3.peerConnection_.removeTrack(sender);

                          if (videoTracks.length > 0) {
                            _this3.peerConnection_.addTrack(videoTracks[0], stream);
                          }
                        }
                      } else if (sender.track.kind === 'audio') {
                        if (sender.replaceTrack && audioTracks.length > 0) {
                          sender.replaceTrack(audioTracks[0]);
                        } else {
                          _this3.peerConnection_.removeTrack(sender);

                          if (audioTracks.length > 0) {
                            _this3.peerConnection_.addTrack(audioTracks[0], stream);
                          }
                        }
                      }
                    }
                  }); // update media setting before exchanging offer with remote server.

                  this.updateMediaSettings(stream);
                  _context.next = 8;
                  return this.updateOffer();

                case 8:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function replaceStream(_x) {
          return _replaceStream.apply(this, arguments);
        }

        return replaceStream;
      }()
    }, {
      key: "addTrack",
      value: function () {
        var _addTrack = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(track) {
          var mediaStream;
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  if (!this.peerConnection_) {
                    _context2.next = 8;
                    break;
                  }

                  this.log_.info("is adding ".concat(track.kind, " track to current published local stream")); // The adapter.js addTrack polyfill expects a MediaStream parameter

                  mediaStream = this.localStream_.getMediaStream();
                  this.peerConnection_.addTrack(track, mediaStream);

                  if (track.kind === 'video') {
                    this.setVideoStats('start');
                  } // update media setting before exchanging offer with remote server.


                  this.updateMediaSettings(mediaStream);
                  _context2.next = 8;
                  return this.updateOffer();

                case 8:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function addTrack(_x2) {
          return _addTrack.apply(this, arguments);
        }

        return addTrack;
      }()
    }, {
      key: "removeTrack",
      value: function () {
        var _removeTrack = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(track) {
          var sender;
          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  if (!this.peerConnection_) {
                    _context3.next = 9;
                    break;
                  }

                  this.log_.info("is removing ".concat(track.kind, " track from current published local stream"));
                  sender = this.peerConnection_.getSenders().find(function (sender) {
                    return sender.track === track;
                  });

                  if (!sender) {
                    _context3.next = 9;
                    break;
                  }

                  this.peerConnection_.removeTrack(sender);

                  if (track.kind === 'video') {
                    this.setVideoStats('end');
                  } // update media setting before exchanging offer with remote server.


                  this.updateMediaSettings(this.localStream_.getMediaStream());
                  _context3.next = 9;
                  return this.updateOffer();

                case 9:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3, this);
        }));

        function removeTrack(_x3) {
          return _removeTrack.apply(this, arguments);
        }

        return removeTrack;
      }()
    }, {
      key: "isReplaceTrackAvailable",
      value: function isReplaceTrackAvailable() {
        return 'RTCRtpSender' in window && 'replaceTrack' in window.RTCRtpSender.prototype;
      }
    }, {
      key: "replaceTrack",
      value: function () {
        var _replaceTrack = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(track) {
          var _this4 = this;

          var senders;
          return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  if (this.isReplaceTrackAvailable()) {
                    _context4.next = 2;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_OPERATION,
                    message: 'replaceTrack is not supported in this browser, please use switchDevice or addTrack instead'
                  });

                case 2:
                  if (this.peerConnection_) {
                    _context4.next = 4;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_OPERATION,
                    message: 'replaceTrack() is only valid after the LocalStream has been published'
                  });

                case 4:
                  // getSenders is available since of Chrome M64
                  senders = this.peerConnection_.getSenders();

                  if (!(senders.length === 0)) {
                    _context4.next = 7;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_OPERATION,
                    message: 'replaceTrack() is only valid after the LocalStream has been published'
                  });

                case 7:
                  senders.forEach(function (sender) {
                    if (sender.track && sender.track.kind === track.kind) {
                      // replaceTrack() is available since of Chrome M65
                      _this4.log_.info("is replacing ".concat(track.kind, " track to current published local stream"));

                      sender.replaceTrack(track);
                    }
                  });

                case 8:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4, this);
        }));

        function replaceTrack(_x4) {
          return _replaceTrack.apply(this, arguments);
        }

        return replaceTrack;
      }()
      /**
       * Close the connection and release all of its resources
       * For downlink connection, it also cleanup the remote stream
       *
       * @memberof Connection
       */

    }, {
      key: "close",
      value: function close() {
        var _this5 = this;

        this.log_.info('closing connection');

        if (this.connectTimer_ !== -1) {
          clearTimeout(this.connectTimer_);
          this.connectTimer_ = -1;
        }

        if (this.subscriptionTimeout_ !== -1) {
          clearTimeout(this.subscriptionTimeout_);
          this.subscriptionTimeout_ = -1;
        }

        if (this.peerConnection_) {
          // reset onconnectionstatechange to avoid handling |closed| event
          this.peerConnection_.onconnectionstatechange = function (event) {};

          this.peerConnection_.close();
          this.peerConnection_ = null;
        }

        if (!this.isUplink_) {
          this.remoteStreams_.forEach(function (value, key, map) {
            var stream = value;
            stream.setConnection(null);

            _this5.emitter_.emit(ConnectionEvent.STREAM_REMOVED, {
              stream: stream
            });
          });
          this.remoteStreams_.clear();
        } // cleanup the listeners on SignalChennel to avoid being called after closed.


        this.uninstallSignalChannelEvents();
      }
      /**
       *
       * @private
       * @memberof Connection
       */

    }, {
      key: "installSignalChannelEvents",
      value: function installSignalChannelEvents() {
        if (this.isUplink_) {
          this.signalChannel_.on(SignalEvent.NEW_REMOTE_SDP, this.onNewRemoteSdp, this);
        }

        if (!this.isUplink_) {
          this.signalChannel_.on(SignalEvent.UPDATE_REMOTE_SDP, this.onUpdateRemoteSdp, this);
          this.signalChannel_.on(SignalEvent.UPDATE_AUDIO_SSRC, this.onUpdateAudioSSRC, this);
          this.signalChannel_.on(SignalEvent.UPDATE_VIDEO_SSRC, this.onUpdateVideoSSRC, this);
          this.signalChannel_.on(SignalEvent.SUBSCRIBE_ACK, this.onSubscription, this);
        }
      }
    }, {
      key: "uninstallSignalChannelEvents",
      value: function uninstallSignalChannelEvents() {
        if (this.isUplink_) {
          this.signalChannel_.removeListener(SignalEvent.NEW_REMOTE_SDP, this.onNewRemoteSdp, this);
        }

        if (!this.isUplink_) {
          this.signalChannel_.removeListener(SignalEvent.UPDATE_REMOTE_SDP, this.onUpdateRemoteSdp, this);
          this.signalChannel_.removeListener(SignalEvent.UPDATE_AUDIO_SSRC, this.onUpdateAudioSSRC, this);
          this.signalChannel_.removeListener(SignalEvent.UPDATE_VIDEO_SSRC, this.onUpdateVideoSSRC, this);
          this.signalChannel_.removeListener(SignalEvent.SUBSCRIBE_ACK, this.onSubscription, this);
        }
      }
    }, {
      key: "onNewRemoteSdp",
      value: function onNewRemoteSdp(event) {
        if (this.hitTest(event.data.srctinyid)) {
          var answer = event.data.content;
          this.acceptAnswer(answer);
        }
      }
    }, {
      key: "onUpdateRemoteSdp",
      value: function onUpdateRemoteSdp(event) {
        var content = event.data.content;

        if (this.hitTest(content.srctinyid)) {
          this.log_.info('is updating remote sdp offer');
          var sdp = content.newSdp;
          this.updateRemoteDescription(sdp);
        }
      }
    }, {
      key: "onUpdateAudioSSRC",
      value: function onUpdateAudioSSRC(event) {
        var content = event.data.content;

        if (this.hitTest(content.srctinyid)) {
          this.log_.info('is updating audio ssrc');
          var sdp = content.newSdp;
          this.updateRemoteDescription(sdp);
        }
      }
    }, {
      key: "onUpdateVideoSSRC",
      value: function onUpdateVideoSSRC(event) {
        var content = event.data.content;

        if (this.hitTest(content.srctinyid)) {
          this.log_.info('is updating video ssrc');
          var sdp = content.newSdp;
          this.updateRemoteDescription(sdp);
        }
      }
      /**
       * RTCPeerConnection.ontrack handler
       *
       * @private
       * @param {*} event
       * @memberof Connection
       */

    }, {
      key: "onTrack",
      value: function onTrack(
      /** @type {RTCTrackEvent} */
      event) {
        var stream = event.streams[0];
        var track = event.track;
        this.log_.info("ontrack() kind: ".concat(track.kind, " id: ").concat(track.id, " streamId: ").concat(stream.id));
        /**
         * validate streams in unified-plan as the remote backend adds invalid m= line to sdp offer
         * in plan-b the m= line is always valid.
         */

        if (this.sdpSemantics_ === 'unified-plan') {
          var sdpOffer = this.peerConnection_.remoteDescription.sdp;
          var validated = validateStreams(sdpOffer);

          if (track.kind === 'audio') {
            // audio is always packed into main stream
            // if remote peer unpublish and then publish immediately, backend will send
            // two update-audio-ssrc sequentially and this will cause ontrack with an invalid
            // audio track but the stream.id is not equal to MAIN_STREAM_MSID
            if (validated.audio.length === 0 || stream.id !== MAIN_STREAM_MSID) {
              this.log_.debug('skip this invalid audio track');
              return;
            }
          } else {
            if (validated.video.indexOf(stream.id) === -1) {
              this.log_.debug("skip this invalid video track: ".concat(track.id, "  msid: ").concat(stream.id));
              return;
            }
          }
        }

        logEvent({
          eventType: 'ontrack',
          kind: track.kind
        });
        var added = false;
        var remoteStream = this.remoteStreams_.get(stream.id);

        if (remoteStream === undefined) {
          var type = stream.id === MAIN_STREAM_MSID ? 'main' : 'auxiliary';
          remoteStream = new RemoteStream({
            type: type,
            userId: this.userId_,
            client: this.client_
          });
          remoteStream.setConnection(this);
          this.remoteStreams_.set(stream.id, remoteStream);
          added = true;
        } // always update the MediaStream in case of track is added/removed


        remoteStream.setMediaStream(stream);

        if (track.kind === 'audio') {
          // the previous audio track may be in muted/ended state after remote updating
          // audio ssrc so we have to restart audio player with the fresh track
          if (remoteStream.hasAudio() && remoteStream.isPlaying()) {
            this.log_.debug('already has an audio track, restart audio player with the new track');
            remoteStream.restartAudio();
          }

          remoteStream.setHasAudio(true);
        } else {
          // 视频状态统计
          this.setVideoStats('start');

          if (remoteStream.hasVideo() && remoteStream.isPlaying()) {
            this.log_.debug('already has an video track, restart video player with the new track');
            remoteStream.restartVideo();
          }

          remoteStream.setHasVideo(true);
        }

        if (added) {
          // fire 'stream-added' event
          this.emitter_.emit(ConnectionEvent.STREAM_ADDED, {
            stream: remoteStream
          });
        } else {
          // fire 'stream-updated' event to let custom renderer update audio/video track
          this.emitter_.emit(ConnectionEvent.STREAM_UPDATED, {
            stream: remoteStream
          });
        }
      }
    }, {
      key: "isRtpSenderAvailable",
      value: function isRtpSenderAvailable() {
        return 'RTCRtpSender' in window && 'setParameters' in window.RTCRtpSender.prototype;
      }
    }, {
      key: "setBandwidth",
      value: function () {
        var _setBandwidth = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(bandwidth, type) {
          var _this6 = this;

          var sender, parameters;
          return regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  if (this.isUplink_) {
                    _context5.next = 2;
                    break;
                  }

                  return _context5.abrupt("return");

                case 2:
                  if (type === undefined) {
                    type = 'video';
                  } // In Chrome, use RTCRtpSender.setParameters to change bandwidth without
                  // (local) renegotiation. Note that this will be within the envelope of
                  // the initial maximum bandwidth negotiated via SDP.


                  if (this.isRtpSenderAvailable()) {
                    sender = this.peerConnection_.getSenders().find(function (sender) {
                      return sender.track && sender.track.kind === type;
                    });

                    if (sender) {
                      parameters = sender.getParameters();

                      if (!parameters.encodings) {
                        parameters.encodings = [{}];
                      }

                      if (bandwidth === 'unlimited') {
                        delete parameters.encodings[0].maxBitrate;
                      } else {
                        parameters.encodings[0].maxBitrate = bandwidth * 1000;
                      }

                      sender.setParameters(parameters).then(function () {
                        _this6.log_.debug(type + ' bandwidth was set to ' + bandwidth + ' kbps');
                      })["catch"](function (e) {
                        return _this6.log_.error('failed to set bandwidth: ' + e);
                      });
                    }
                  }

                case 4:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee5, this);
        }));

        function setBandwidth(_x5, _x6) {
          return _setBandwidth.apply(this, arguments);
        }

        return setBandwidth;
      }() // bandwidth setting via munging sdp
      // refer to: http://www.rtcbits.com/2016/11/controlling-bandwidth-usage-in-webrtc.html

    }, {
      key: "updateVideoBandwidthRestriction",
      value: function updateVideoBandwidthRestriction(sdp, bandwidth) {
        var modifier = 'AS'; // if (adapter.browserDetails.browser === 'firefox') {
        //   bandwidth = (bandwidth >>> 0) * 1000;
        //   modifier = 'TIAS';
        // }

        if (sdp.indexOf('b=' + modifier + ':') === -1) {
          // insert b= after c= line of m=video
          sdp = sdp.replace(/m=video (.*)\r\nc=IN (.*)\r\n/, 'm=video $1\r\nc=IN $2\r\nb=' + modifier + ':' + bandwidth + '\r\n');
        } else {
          sdp = sdp.replace(new RegExp('b=' + modifier + ':.*\r\n'), 'b=' + modifier + ':' + bandwidth + '\r\n');
        }

        return sdp;
      }
    }, {
      key: "updateAudioBandwidthRestriction",
      value: function updateAudioBandwidthRestriction(sdp, bandwidth) {
        var modifier = 'AS'; // insert b= after c= line of m=audio

        sdp = sdp.replace(/m=audio (.*)\r\nc=IN (.*)\r\n/, 'm=audio $1\r\nc=IN $2\r\nb=' + modifier + ':' + bandwidth + '\r\n');
        return sdp;
      }
    }, {
      key: "removeBandwidthRestriction",
      value: function removeBandwidthRestriction(sdp) {
        return sdp.replace(/b=AS:.*\r\n/, '').replace(/b=TIAS:.*\r\n/, '');
      }
      /**
       *
       * @private
       * @param {*} failureCallback
       * @memberof Connection
       */

    }, {
      key: "exchangeOffer",
      value: function exchangeOffer(failureCallback) {
        var _this7 = this;

        this.peerConnection_.createOffer(offerOptions).then(function (offer) {
          return _this7.peerConnection_.setLocalDescription(offer);
        }).then(function () {
          _this7.log_.info('createOffer success, sending offer to remote server');

          var desc = _this7.peerConnection_.localDescription;

          _this7.log_.debug('sending sdp offer: ' + desc.sdp); // FIXME: target is supposed to be tinyId, but if we send this.tinyId_ remote server return nothing.


          _this7.signalChannel_.send(SignalCommand.NEW_LOCAL_SDP, desc,
          /** myself */
          0);

          logEvent({
            eventType: 'setLocalDescription',
            kind: 'offer',
            result: 'success'
          });
        })["catch"](function (err) {
          logEvent({
            eventType: 'setLocalDescription',
            kind: 'offer',
            result: 'failed'
          });

          _this7.log_.error('failed to create offer');

          failureCallback(new RtcError({
            code: ErrorCode.CREATE_OFFER_FAILED,
            message: 'failed to create offer'
          }));
        });
      }
    }, {
      key: "updateOffer",
      value: function () {
        var _updateOffer = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
          var offer, desc;
          return regeneratorRuntime.wrap(function _callee6$(_context6) {
            while (1) {
              switch (_context6.prev = _context6.next) {
                case 0:
                  offer = '';
                  _context6.prev = 1;
                  _context6.next = 4;
                  return this.peerConnection_.createOffer(offerOptions);

                case 4:
                  offer = _context6.sent;
                  _context6.next = 7;
                  return this.peerConnection_.setLocalDescription(offer);

                case 7:
                  desc = this.peerConnection_.localDescription;
                  this.log_.info('createOffer success, sending updated offer to remote server');
                  this.log_.debug('updatedOffer: ' + desc.sdp);
                  this.signalChannel_.send(SignalCommand.UPDATE_LOCAL_SDP, desc, 0);
                  this.waitForUpdatedAnswer_ = true;
                  logEvent({
                    eventType: 'setLocalDescription',
                    kind: 'offer',
                    result: 'success'
                  });
                  _context6.next = 20;
                  break;

                case 15:
                  _context6.prev = 15;
                  _context6.t0 = _context6["catch"](1);
                  logEvent({
                    eventType: 'setLocalDescription',
                    kind: 'offer',
                    result: 'failed'
                  });
                  this.log_.error('failed to create updated sdp offer');
                  throw new RtcError({
                    code: ErrorCode.CREATE_OFFER_FAILED,
                    message: 'failed to create updated sdp offer'
                  });

                case 20:
                case "end":
                  return _context6.stop();
              }
            }
          }, _callee6, this, [[1, 15]]);
        }));

        function updateOffer() {
          return _updateOffer.apply(this, arguments);
        }

        return updateOffer;
      }()
      /**
       *
       * @private
       * @param {*} answer
       * @memberof Connection
       * @fires 'stream-published'
       */

    }, {
      key: "acceptAnswer",
      value: function acceptAnswer(answer) {
        var _this8 = this;

        // set video bitrate
        var videoBitrate = this.localStream_.getVideoBitrate();
        var sdp = this.updateVideoBandwidthRestriction(answer.sdp, videoBitrate); // set audio bitrate

        var audioBitrate = this.localStream_.getAudioBitrate();
        sdp = this.updateAudioBandwidthRestriction(sdp, audioBitrate);
        var desc = {
          type: answer.type,
          sdp: sdp
        };
        this.peerConnection_.setRemoteDescription(desc).then(function () {
          _this8.log_.debug('accepted anwswer: ' + sdp); // ensure the maxBitrate is set via RTCRtpSender.setParameter


          _this8.setBandwidth(audioBitrate, 'audio');

          _this8.setBandwidth(videoBitrate, 'video');

          if (!_this8.waitForUpdatedAnswer_) {
            _this8.log_.info('accepted remote answer, fired stream-published event');

            _this8.emitter_.emit(ConnectionEvent.STREAM_PUBLISHED, {
              stream: _this8.localStream_
            });
          }

          if (_this8.waitForUpdatedAnswer_) {
            _this8.waitForUpdatedAnswer_ = false;
          }

          logEvent({
            eventType: 'setRemoteDescription',
            kind: 'answer',
            result: 'success'
          });
        }, function (error) {
          logEvent({
            eventType: 'setRemoteDescription',
            kind: 'answer',
            result: 'failed'
          });

          _this8.log_.error('failed to accept remote answer ' + error);
        });
      } // fire a ICE failure event for test

    }, {
      key: "failIceConnectionForTest",
      value: function failIceConnectionForTest() {
        this.log_.warn('failIceConnectionForTest()');
        this.emitter_.emit(ConnectionEvent.ERROR, new RtcError({
          message: 'fake ICE failure fired',
          code: ErrorCode.ICE_TRANSPORT_ERROR
        }));
      }
    }, {
      key: "onConnectionStateChange",
      value: function onConnectionStateChange(event) {
        var _this9 = this;

        this.log_.warn('onConnectionStateChange() connectionState: ' + event.target.connectionState);

        if (event.target.connectionState === 'connecting') {
          // assume that ICE/DTLS Transport connection shall be established successfully in 10s.
          // otherwise throw error to let app refresh the page.
          var TIMEOUT = 10000;
          this.connectTimer_ = setTimeout(function () {
            var message = "DTLS Transport connection timeout (".concat(TIMEOUT / 1000, "s)");
            logEvent({
              eventType: 'iceConnectionState',
              result: 'failed'
            });

            _this9.log_.error(message);

            _this9.addTransportEvent('disconnected');

            _this9.isErrorObserved_ = true;

            _this9.emitter_.emit(ConnectionEvent.ERROR, new RtcError({
              message: message,
              code: ErrorCode.ICE_TRANSPORT_ERROR
            }));
          }, TIMEOUT);
          this.emitter_.emit(ConnectionEvent.CONNECTION_STATE_CHANGED, {
            state: 'connecting'
          });
        } else {
          clearTimeout(this.connectTimer_);
          this.connectTimer_ = -1;
        } // |closed| should only be fired by RTCPeerConnection.close(). In case, |closed| is fired
        // by browser internal error, we reset onconnectionstatechange callback before RTCPeerConnection.close
        // and then take both |failed| and |closed| as error
        // seiyabai


        if (event.target.connectionState === 'failed' || event.target.connectionState === 'closed') {
          var message = "ICE/DTLS Transport connection ".concat(event.target.connectionState);
          logEvent({
            eventType: 'iceConnectionState',
            result: 'failed'
          });
          this.log_.error(message);

          if (!this.isErrorObserved_) {
            this.addTransportEvent('disconnected'); // only fire the ERROR event if error hasn't been fired before.

            this.emitter_.emit(ConnectionEvent.ERROR, new RtcError({
              message: message,
              code: ErrorCode.ICE_TRANSPORT_ERROR
            }));
          }
        }

        if (event.target.connectionState === 'connected' || event.target.connectionState === 'completed') {
          logEvent({
            eventType: 'iceConnectionState',
            result: 'success'
          });
          this.addTransportEvent('connected');
          this.emitter_.emit(ConnectionEvent.CONNECTION_STATE_CHANGED, {
            state: 'connected'
          }); // send pending subscription

          if (!this.sentSubscriptionAfterConnected_ && this.pendingSubscription_.length > 0) {
            this.log_.info('send pending subscription after RTCPeerConnection is connected');
            var sub = this.pendingSubscription_[0];
            this.doSendSubscription(sub.data, sub.stream); // sent it once, don't send after RTCPeerConnection auto reconnected

            this.sentSubscriptionAfterConnected_ = true;
          }
        } else if (event.target.connectionState === 'disconnected') {
          this.close(); // this.addTransportEvent('disconnected');

          var _message = "ICE/DTLS Transport connection ".concat(event.target.connectionState);

          this.emitter_.emit(ConnectionEvent.ERROR, new RtcError({
            message: _message,
            code: ErrorCode.ICE_TRANSPORT_BROKE
          }));
        }
      } // check if the srctinyid is associated with me.

    }, {
      key: "hitTest",
      value: function hitTest(srctinyid) {
        // for uplink connection, sometimes the srctinyid sent from remote is 0
        return (srctinyid === 0 || srctinyid === '0') && this.isUplink_ || srctinyid === this.tinyId_;
      }
    }, {
      key: "updateRemoteDescription",
      value: function updateRemoteDescription(sdp) {
        var _this10 = this;

        this.log_.debug("updateRemoteDescription() ".concat(sdp.sdp));
        var prevSdp = this.peerConnection_.remoteDescription.sdp;
        this.peerConnection_.setRemoteDescription(sdp).then(function () {
          logEvent({
            eventType: 'setRemoteDescription',
            kind: 'offer',
            result: 'success'
          });

          _this10.log_.info('updateRemoteDescription success');

          if (_this10.sdpSemantics_ === 'unified-plan') {
            var changed = checkTrack(prevSdp, sdp.sdp);
            /**
             * addTrack based on sdp m=line diff for unified-plan only.
             * in plan-b, ontrack is guaranteed to be fired to add track.
             */

            _this10.addRemoteTrack(changed.added);

            _this10.removeRemoteTrack(changed.removed);
          } else {
            // plan-b: remove track based on ssrcs/ssrcGroups existence
            _this10.removeRemoteTrackLegacy(prevSdp, sdp.sdp);
          }

          var stream = _this10.pendingStreams_.shift();

          if (stream) {
            _this10.log_.debug("mark ".concat(stream.getType(), " stream exit subscription cycle"));

            stream.setInSubscriptionCycle(false);
          }
        })["catch"](function (error) {
          logEvent({
            eventType: 'setRemoteDescription',
            kind: 'offer',
            result: 'failed'
          });

          _this10.log_.error("updateRemoteDescription failed ".concat(error));
        });
      }
      /**
       *
       * @private
       * @param {*} added
       * @memberof Connection
       */

    }, {
      key: "addRemoteTrack",
      value: function addRemoteTrack(added) {
        var _this11 = this;

        added.forEach(function (item) {
          var mid = item.mid;
          var type = getStreamTypeFromSsrc(item.ssrcs[0].id);
          var msid = type === StreamType.AUX ? AUX_STREAM_MSID : MAIN_STREAM_MSID;

          var receiver = _this11.peerConnection_.getReceivers()[mid];

          if (receiver && receiver.track) {
            _this11.log_.info("add ".concat(receiver.track.kind, " track ").concat(receiver.track.id));

            var remoteStream = _this11.remoteStreams_.get(msid);

            if (remoteStream) {
              remoteStream.getMediaStream().addTrack(receiver.track);

              if (receiver.track.kind === 'audio') {
                remoteStream.setHasAudio(true);
              } else {
                remoteStream.setHasVideo(true); // 视频状态统计

                _this11.setVideoStats('start');
              }

              _this11.emitter_.emit(ConnectionEvent.STREAM_UPDATED, {
                stream: remoteStream
              });
            } else {
              _this11.log_.debug("remoteStream for msid:".concat(msid, " not exist"));

              var stream = new MediaStream();
              stream.addTrack(receiver.track);
              var st = msid === MAIN_STREAM_MSID ? 'main' : 'auxiliary';
              remoteStream = new RemoteStream({
                type: st,
                userId: _this11.userId_,
                client: _this11.client_
              });
              remoteStream.setMediaStream(stream);
              remoteStream.setConnection(_this11);

              _this11.remoteStreams_.set(msid, remoteStream);

              if (receiver.track.kind === 'audio') {
                remoteStream.setHasAudio(true);
              } else {
                remoteStream.setHasVideo(true);
              } // fire 'stream-added' event


              _this11.emitter_.emit('stream-added', {
                stream: remoteStream
              });
            }
          }
        });
      }
      /**
       *
       * @private
       * @param {*} removed
       * @memberof Connection
       */

    }, {
      key: "removeRemoteTrack",
      value: function removeRemoteTrack(removed) {
        var _this12 = this;

        removed.forEach(function (item) {
          var type = getStreamTypeFromSsrc(item.ssrcs[0].id);
          var kind = type === StreamType.MAIN ? 'video' : type === StreamType.AUX ? 'auxVideo' : 'audio';

          _this12.log_.info("[".concat(kind, "] track was removed"));

          var msid = kind === 'auxVideo' ? AUX_STREAM_MSID : MAIN_STREAM_MSID;

          var remoteStream = _this12.remoteStreams_.get(msid);

          if (remoteStream) {
            if ((msid === AUX_STREAM_MSID || remoteStream.getMediaStream().getTracks().length === 0) && !remoteStream.isInSubscriptionCycle()) {
              // delete the stream if and only if it's not in subscription cycle
              _this12.log_.info("remote stream ".concat(msid, " removed"));

              _this12.remoteStreams_["delete"](msid);

              _this12.emitter_.emit(ConnectionEvent.STREAM_REMOVED, {
                stream: remoteStream
              });
            } else {
              if (kind === 'audio') {
                remoteStream.setHasAudio(false);
              } else {
                remoteStream.setHasVideo(false); // 视频状态统计

                _this12.setVideoStats('end');
              }

              _this12.emitter_.emit(ConnectionEvent.STREAM_UPDATED, {
                stream: remoteStream
              });
            }
          }
        });
      }
      /**
       * plan-b legacy API
       * remove track based on the existence of ssrcs/ssrcGroups
       * audio m= line comes with/without ssrcs, video m= line comes
       * with/without ssrcGroups/ssrcs. for m= line with auxiliary video
       * track, ssrcGroups.length > 1
       *
       * @private
       * @param {string} prevSdp
       * @param {string} curSdp
       * @memberof Connection
       */

    }, {
      key: "removeRemoteTrackLegacy",
      value: function removeRemoteTrackLegacy(prevSdp, curSdp) {
        var _this13 = this;

        var prevMedia = parse$1(prevSdp).media;
        var curMedia = parse$1(curSdp).media;
        prevMedia.filter(function (item) {
          var c = curMedia.find(function (ci) {
            return ci.type === item.type;
          });
          var msid = StreamType.MAIN;
          var remoteStream;

          if (item.type === 'audio') {
            if ((c === undefined || c.ssrcs === undefined) && item.ssrcs) {
              _this13.log_.info('[audio] track was removed');

              remoteStream = _this13.remoteStreams_.get(msid);

              if (remoteStream) {
                if (remoteStream.getMediaStream().getTracks().length === 0) {
                  // delete the stream if and only if it's not in subscription cycle
                  if (!remoteStream.isInSubscriptionCycle()) {
                    _this13.log_.info("remote stream ".concat(msid, " removed"));

                    _this13.remoteStreams_["delete"](msid);

                    _this13.emitter_.emit(ConnectionEvent.STREAM_REMOVED, {
                      stream: remoteStream
                    });
                  }
                } else {
                  remoteStream.setHasAudio(false);

                  _this13.emitter_.emit(ConnectionEvent.STREAM_UPDATED, {
                    stream: remoteStream
                  });
                }
              }
            }
          } else {
            if ((c === undefined || c.ssrcs === undefined) && item.ssrcs || c.ssrcGroups && item.ssrcGroups && c.ssrcGroups.length < item.ssrcGroups.length) {
              var mainRemoved = false;
              var auxRemoved = false;

              if (c.ssrcs === undefined && item.ssrcGroups.length === 2) {
                // both main and aux video tracks were removed simultaneously
                _this13.log_.info('[main & aux video] tracks were removed');

                mainRemoved = true;
                auxRemoved = true;
              } else if (c.ssrcs === undefined && item.ssrcGroups.length === 1) {
                // main video track was removed.
                _this13.log_.info('[main video] track was removed');

                mainRemoved = true;
              } else if (item.ssrcGroups.length > c.ssrcGroups.length) {
                // auxiliary video was removed.
                _this13.log_.info('[auxiliary video] track was removed');

                auxRemoved = true;
              } // remove aux's RemoteStream


              if (auxRemoved) {
                msid = AUX_STREAM_MSID;

                _this13.log_.info("remote stream ".concat(msid, " removed"));

                remoteStream = _this13.remoteStreams_.get(msid);

                if (remoteStream && !remoteStream.isInSubscriptionCycle()) {
                  _this13.remoteStreams_["delete"](msid);

                  _this13.emitter_.emit(ConnectionEvent.STREAM_REMOVED, {
                    stream: remoteStream
                  });
                }
              }

              if (mainRemoved) {
                msid = MAIN_STREAM_MSID;
                remoteStream = _this13.remoteStreams_.get(msid);

                if (remoteStream) {
                  if (remoteStream.getMediaStream().getTracks().length === 0) {
                    if (!remoteStream.isInSubscriptionCycle()) {
                      _this13.log_.info("remote stream ".concat(msid, " removed"));

                      _this13.remoteStreams_["delete"](msid);

                      _this13.emitter_.emit(ConnectionEvent.STREAM_REMOVED, {
                        stream: remoteStream
                      });
                    }
                  } else {
                    // 视频状态统计
                    _this13.setVideoStats('end');

                    remoteStream.setHasVideo(false);

                    _this13.emitter_.emit(ConnectionEvent.STREAM_UPDATED, {
                      stream: remoteStream
                    });
                  }
                }
              }
            }
          }
        });
      } // set the remote offer received from remote server. this is only valid for downlink connection

    }, {
      key: "setRemoteOffer",
      value: function setRemoteOffer(sdp) {
        var _this14 = this;

        this.log_.info("[".concat(this.userId_, "] setRemoteOffer sdp: ").concat(sdp.sdp));
        this.peerConnection_.setRemoteDescription(sdp).then(function () {
          logEvent({
            eventType: 'setRemoteDescription',
            kind: 'offer',
            result: 'success'
          });
          return _this14.peerConnection_.createAnswer();
        }).then(function (answer) {
          return _this14.peerConnection_.setLocalDescription(answer);
        }).then(function () {
          var desc = _this14.peerConnection_.localDescription;

          _this14.signalChannel_.send(SignalCommand.NEW_LOCAL_SDP, desc, _this14.tinyId_);

          _this14.log_.info('accepted remote offer and acknowledged answer');
        })["catch"](function (error) {
          logEvent({
            eventType: 'setRemoteDescription',
            kind: 'offer',
            result: 'failed'
          });

          _this14.log_.error('failed to accept remote offer ' + error);
        });
      }
    }, {
      key: "setMutedState",
      value: function setMutedState(kind, muted) {
        if (!this.isUplink_) return;

        if (kind === 'audio') {
          if (muted) {
            this.mutedState_ |= AUDIO_MUTED_MASK;
          } else {
            this.mutedState_ &= ~AUDIO_MUTED_MASK;
          }
        } else {
          if (muted) {
            this.mutedState_ |= VIDEO_MUTED_MASK;
          } else {
            this.mutedState_ &= ~VIDEO_MUTED_MASK;
          }
        }

        var data = {
          srctinyid: 0,
          userid: this.userId_,
          flag: this.mutedState_
        };
        this.log_.info("set ".concat(kind, " muted state: [").concat(muted ? 'mute' : 'unmute', "]"));
        this.signalChannel_.send(SignalCommand.UPDATE_MUTE_STAT, data);
      }
    }, {
      key: "onSubscription",
      value: function onSubscription(event) {
        var content = event.data.content;
        var tinyId = content.srctinyid;

        if (this.hitTest(tinyId)) {
          var result = content.errCode === 0 ? true : false;
          var subscription = this.pendingSubscription_.shift();

          if (subscription !== undefined) {
            // clear retry stuffs
            this.subscriptionRetryCount_ = 0;
            this.isSubscriptionPending_ = false;

            if (this.subscriptionTimeout_ !== -1) {
              clearTimeout(this.subscriptionTimeout_);
              this.subscriptionTimeout_ = -1;
            }

            var stream = subscription.stream;
            this.log_.info("".concat(stream.getType(), " stream ").concat(subscription.type, " result: ").concat(result ? 'success' : 'failure', " errCode: ").concat(content.errCode));
            subscription.callback(result);
            logEvent({
              eventType: subscription.type,
              result: content.errCode === 0 ? 'success' : 'failed'
            });

            if (result && subscription.type === 'subscribe') {
              // fire 'stream-subscribed' once the subscription is done ok
              this.emitter_.emit(ConnectionEvent.STREAM_SUBSCRIBED, {
                stream: stream
              });
            }
          }

          if (this.pendingSubscription_.length > 0) {
            var sub = this.pendingSubscription_[0];
            this.log_.info('schedule a pending subscription');
            this.doSendSubscription(sub.data, sub.stream);
          }
        }
      } // subscribe/unsubscribe must be done in sequence otherwise the state on remote side
      // will be in chaos

    }, {
      key: "subscribe",
      value: function subscribe(stream, options) {
        var _this15 = this;

        return new Promise(function (resolve, reject) {
          if ( // default subscription
          typeof options === 'undefined' || // main stream - audio & video
          stream.getType() === 'main' && typeof options.audio !== 'undefined' && typeof options.video !== 'undefined' && options.audio === _this15.subscribeState_.audio && options.video === _this15.subscribeState_.video || // aux stream
          stream.getType() === 'auxiliary' && typeof options.video !== 'undefined' && _this15.subscribeState_.auxiliary === options.video) {
            // audio & video stream has been already subscribed by default and received from remote server
            // immediately after the transport channel has been established successfully.
            // so we don't need to go through the round-trip and instread firing 'stream-subscribed'
            // event immediately.
            _this15.emitter_.emit(ConnectionEvent.STREAM_SUBSCRIBED, {
              stream: stream,
              result: true
            });

            return resolve();
          }

          if (stream.getType() === 'main') {
            if (typeof options.audio !== 'undefined') {
              _this15.subscribeState_.audio = options.audio;
            }

            if (typeof options.video !== 'undefined') {
              _this15.subscribeState_.video = options.video;
            }

            var eventId;
            var eventDesc;

            if (_this15.subscribeState_.audio) {
              eventId = EventId.SUBSCRIBE_AUDIO;
              eventDesc = 'subscribe audio';
            } else {
              eventId = EventId.UNSUBSCRIBE_AUDIO;
              eventDesc = 'unsubscribe audio';
            }

            _this15.addEventInternal(eventId, eventDesc);

            if (_this15.subscribeState_.video) {
              eventId = EventId.SUBSCRIBE_VIDEO;
              eventDesc = 'subscribe video';
            } else {
              eventId = EventId.UNSUBSCRIBE_VIDEO;
              eventDesc = 'unsubscribe video';
            }

            _this15.addEventInternal(eventId, eventDesc);
          } else {
            if (typeof options.video !== 'undefined') {
              _this15.subscribeState_.auxiliary = options.video;
            }
          }

          _this15.log_.info("subscribe ".concat(stream.getType(), " stream with options ").concat(JSON.stringify(options), " current state: ").concat(JSON.stringify(_this15.subscribeState_)));

          _this15.sendSubscription(stream, 'subscribe', function (result) {
            if (result) {
              resolve();
            } else {
              var message = 'failed to subscribe remote stream';

              _this15.log_.error(message);

              reject(new RtcError({
                message: message
              }));
            }
          });
        });
      }
    }, {
      key: "unsubscribe",
      value: function unsubscribe(stream) {
        var _this16 = this;

        return new Promise(function (resolve, reject) {
          if (stream.getType() === 'main') {
            _this16.subscribeState_.audio = false;
            _this16.subscribeState_.video = false;
          } else {
            _this16.subscribeState_.auxiliary = false;
          }

          _this16.log_.info("unsubscribe ".concat(stream.getType(), " stream with ").concat(JSON.stringify(_this16.subscribeState_)));

          _this16.sendSubscription(stream, 'unsubscribe', function (result) {
            if (result) {
              resolve();
            } else {
              var message = 'failed to unsubscribe remote stream';

              _this16.log_.error(message);

              reject(new RtcError({
                message: message
              }));
            }
          });

          _this16.addEventInternal(EventId.UNSUBSCRIBE_AUDIO, 'unsubscribe audio');

          _this16.addEventInternal(EventId.UNSUBSCRIBE_VIDEO, 'unsubscribe video');
        });
      }
    }, {
      key: "addEventInternal",
      value: function addEventInternal(eventId, eventDesc) {
        var uid = this.client_.getUserId();
        var event = {
          eventId: eventId,
          eventDesc: eventDesc,
          timestamp: getCurrentTime(),
          // the stream owner - the client's IDs
          userId: uid,
          tinyId: this.client_.getTinyId()
        };

        if (!this.isUplink_) {
          // remote peer's IDs
          event.remoteUserId = this.userId_;
          event.remoteTinyId = this.tinyId_;
        }

        addEvent(uid, event);
      }
    }, {
      key: "addTransportEvent",
      value: function addTransportEvent(state) {
        if (state === 'connected') {
          this.addEventInternal(EventId.TRANSPORT_CONNECTED, 'ice transport is connected');
        } else {
          this.addEventInternal(EventId.TRANSPORT_DISCONNECTED, 'ice transport is disconnected');
        }
      }
    }, {
      key: "sendSubscription",
      value: function sendSubscription(stream, type, callback) {
        var data = {
          srctinyid: this.tinyId_,
          userid: this.userId_,
          audio: this.subscribeState_.audio,
          bigVideo: this.subscribeState_.video,
          auxVideo: this.subscribeState_.auxiliary
        }; // subscription order is enforced by SDK

        if (this.pendingSubscription_.length > 0) {
          this.log_.debug('queue the subscription for later handling');
        } else {
          this.doSendSubscription(data, stream);
        }

        this.pendingSubscription_.push({
          stream: stream,
          type: type,
          data: data,
          callback: callback
        }); // mark the stream as is in subscription cycle, stream in subscription cycle
        // shall not be removed otherwise user will be unable to resubscribe it again.

        stream.setInSubscriptionCycle(true);
      }
    }, {
      key: "doSendSubscription",
      value: function doSendSubscription(data, stream) {
        var _this17 = this;

        if (this.peerConnection_.connectionState !== 'connected' && this.peerConnection_.connectionState !== 'completed') {
          this.log_.debug("try to send subscription when connectionState ".concat(this.peerConnection_.connectionState)); // if we send subscription request to remote server before connectionState is connected
          // remote server will be in a mess state. so we have to postpone the request until the
          // RTCPeerConnection is connected successfully.

          return;
        }

        if (stream) {
          this.pendingStreams_.push(stream);
        }

        this.log_.debug("doSendSubscription() send SUBSCRIBE command with data: ".concat(JSON.stringify(data)));
        this.signalChannel_.send(SignalCommand.SUBSCRIBE, data);
        this.isSubscriptionPending_ = true;
        this.subscriptionTimeout_ = setTimeout(function () {
          if (_this17.isSubscriptionPending_) {
            _this17.log_.debug('subscription timeout');

            _this17.subscriptionRetryCount_ += 1;

            if (_this17.subscriptionRetryCount_ <= 3) {
              _this17.log_.debug('resend subscription');

              var subData = _this17.pendingSubscription_[0].data;

              _this17.doSendSubscription(subData);
            } else {
              _this17.log_.error('remote server not response to subscription'); // remove the failed one


              _this17.pendingSubscription_.shift();

              _this17.pendingStreams_.shift();

              _this17.isSubscriptionPending_ = false;
              _this17.subscriptionRetryCount_ = 0;

              _this17.emitter_.emit(ConnectionEvent.ERROR, new RtcError({
                code: ErrorCode.SUBSCRIPTION_TIMEOUT,
                message: 'remote server not response to subscription'
              }));
            }
          }
        }, 5000);
      }
      /**
       *
       * @package
       * @returns {RTCPeerConnection}
       * @memberof Connection
       */

    }, {
      key: "getPeerConnection",
      value: function getPeerConnection() {
        return this.peerConnection_;
      }
      /**
       *
       * @package
       * @returns
       * @memberof Connection
       */

    }, {
      key: "getUserId",
      value: function getUserId() {
        return this.userId_;
      }
      /**
       *
       * @package
       */

    }, {
      key: "getTinyId",
      value: function getTinyId() {
        return this.tinyId_;
      }
    }, {
      key: "setVideoStats",
      value: function setVideoStats(stage) {
        if (stage === 'start') {
          this.hasVideo_ = true;
          this.startTime_ = new Date();
          this.hasValidEndTime_ = false;
        } else {
          // 远端用户停止推流之后，浏览器 |Chrome| 将接收状态清零导致无法统计
          this.hasVideo_ = false;
          this.endTime_ = new Date();
          this.hasValidEndTime_ = true;
        }
      } // 在 Close 之前调用，获取视频通话健康度统计

    }, {
      key: "getVideoHealthStats",
      value: function () {
        var _getVideoHealthStats = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
          var duration, valid, framerate, width, height, stats;
          return regeneratorRuntime.wrap(function _callee7$(_context7) {
            while (1) {
              switch (_context7.prev = _context7.next) {
                case 0:
                  if (!this.hasValidEndTime_) {
                    // 视频状态没有变更过，则当前时间为截止时间
                    this.endTime_ = new Date();
                  }

                  duration = (this.endTime_ - this.startTime_) / 1000;
                  valid = false;
                  framerate = 0;
                  width = 0;
                  height = 0;

                  if (!this.hasVideo_) {
                    _context7.next = 21;
                    break;
                  }

                  // 有效状态统计
                  valid = true;

                  if (!this.isUplink_) {
                    _context7.next = 15;
                    break;
                  }

                  _context7.next = 11;
                  return new Stats().getSenderStats(this);

                case 11:
                  stats = _context7.sent;
                  framerate = stats.video.framesSent / duration;
                  _context7.next = 19;
                  break;

                case 15:
                  _context7.next = 17;
                  return new Stats().getReceiverStats(this);

                case 17:
                  stats = _context7.sent;
                  framerate = stats.video.framesDecoded / duration;

                case 19:
                  width = stats.video.frameWidth;
                  height = stats.video.frameHeight;

                case 21:
                  return _context7.abrupt("return", {
                    valid: valid,
                    framerate: framerate,
                    duration: duration,
                    width: width,
                    height: height
                  });

                case 22:
                case "end":
                  return _context7.stop();
              }
            }
          }, _callee7, this);
        }));

        function getVideoHealthStats() {
          return _getVideoHealthStats.apply(this, arguments);
        }

        return getVideoHealthStats;
      }()
      /**
       * add listeners to Connection
       *
       * @param {*} event
       * @param {*} handler
       * @memberof Connection
       */

    }, {
      key: "on",
      value: function on(event, handler) {
        this.emitter_.on(event, handler);
      }
    }]);

    return Connection;
  }();

  /**
   * 音视频通话客户端对象 Client 通过 {@link TRTC.createClient createClient()} 创建，代表一次音视频会话。<br>
   * Client 客户端对象提供 TRTC Web SDK 的核心功能，包括:
   * - 进房 {@link Client#join join()}
   * - 退房 {@link Client#leave leave()}
   * - 发布本地流 {@link Client#publish publish()}
   * - 取消发布本地流 {@link Client#unpublish unpublish()}
   * - 订阅远端流 {@link Client#subscribe subscribe()}
   * - 取消订阅远端流 {@link Client#unsubscribe unsubscribe()}
   *
   * @class Client
   */

  var Client = /*#__PURE__*/function () {
    /**
     * Creates an instance of Client.
     * @package
     * @param {*} options
     */
    function Client(options) {
      _classCallCheck(this, Client);

      this.mode_ = options.mode;

      if (options.sdpSemantics && options.sdpSemantics.length > 0) {
        this.sdpSemantics_ = options.sdpSemantics;
      } else {
        this.sdpSemantics_ = 'plan-b';
      }

      if (typeof options.sdpSemantics !== 'undefined') {
        this.sdpSemantics_ = options.sdpSemantics;
      } else if (isUnifiedPlanDefault()) {
        this.sdpSemantics_ = 'unified-plan';
      }

      this.sdkAppId_ = options.sdkAppId;
      this.userId_ = options.userId;
      this.UseTestEnv = options.UseTestEnv;
      this.log_ = new IDLogger({
        id: 'c|' + this.userId_,
        direction: 'local',
        type: ''
      });
      this.userSig_ = options.userSig;
      this.roomId_ = 0;
      this.teamID_ = 0;
      this.rangeAudioMode_ = 0;
      this.receiveRang_ = 0; // hidden parameter for special customers to use string roomId

      this.useStringRoomId_ = options.useStringRoomId;
      this.recordId_ = null;
      this.pureAudioPushMode_ = null;
      this.version_ = options.version;
      this.log_.info('using sdpSemantics: ' + this.sdpSemantics_); // configure the logger for uploading

      logger.setConfig({
        sdkAppId: this.sdkAppId_,
        userId: this.userId_,
        version: this.version_
      }); // validate parameters - DEPRECATED

      if (typeof options.recordId !== 'undefined') {
        if (!Number.isInteger(Number(options.recordId))) {
          throw new RtcError({
            code: ErrorCode.INVALID_PARAM,
            message: 'recordId must be an integer number'
          });
        }

        this.recordId_ = options.recordId;
      }

      if (typeof options.pureAudioPushMode !== 'undefined') {
        if (!Number.isInteger(Number(options.pureAudioPushMode))) {
          throw new RtcError({
            code: ErrorCode.INVALID_PARAM,
            message: 'pureAudioPushMode must be an integer number'
          });
        }

        this.pureAudioPushMode_ = options.pureAudioPushMode;
      } // business info pass through to remote server.


      this.bussinessInfo_ = options.bussinessInfo; // prefer streamId/userDefeinedRecordId to bussinessInfo

      var bzInfo;

      if (typeof options.streamId !== 'undefined') {
        bzInfo = {
          Str_uc_params: {
            userdefine_streamid_main: options.streamId
          }
        };
      }

      if (typeof options.userDefineRecordId !== 'undefined') {
        if (bzInfo) {
          bzInfo.Str_uc_params.userdefine_record_id = options.userDefineRecordId;
        } else {
          bzInfo = {
            Str_uc_params: {
              userdefine_record_id: options.userDefineRecordId
            }
          };
        }
      }

      if (bzInfo) {
        // businessInfo must be in JSON format
        this.bussinessInfo_ = JSON.stringify(bzInfo);
      }

      this.disableReceiver_ = false;
      this.signalChannel_ = null;
      this.isScreenShareOnly_ = 0; // 隐藏参数，TRTC.createClient({ isScreenShareOnly: true }), 后台会把该用户当成一个推送屏幕分享的“辅流”
      // 一个房间内只能有一个“辅流” - 屏幕分享

      if (typeof options.isScreenShareOnly !== 'undefined') {
        this.isScreenShareOnly_ = options.isScreenShareOnly ? 1 : 0;
      } // by default the role is 'host'.


      this.role_ = 'anchor'; // backup for switchRole

      this.privateMapKey_ = ''; // userId's representation in remote server

      this.tinyId_ = 0; // wss proxy url

      this.proxy_ = null; // TURN server setting

      this.turnServer_ = null;
      /*
       * remote connection map, tinyId -> Connection
       * @type {Map<number:Connection>}
       */

      this.connections_ = new Map();
      this.connectionsRefreshCount_ = new Map();
      this.pendingRefresh_ = new Map();
      /*
       * @typedef MutedState
       * @property {boolean} hasVideo
       * @property {boolean} hasAudio
       * @property {boolean} audioMuted
       * @property {boolean} videoMuted
       */

      /*
       * remote user's muted state, tinyId -> state
       * @type {Map<number:MutedState>}
       */

      this.mutedStates_ = new Map(); // local stuffs

      this.localStream_ = null;
      this.isPublishing_ = false; // uplink connection, created on demand once a local Stream is published

      this.uplinkConnection_ = null;
      this.emitter_ = new eventemitter3();
      this.signalInfo_ = {};
      this.isInitialized_ = false;
      this.isJoined_ = false;
      this.heartbeat_ = -1;
      this.stats_ = new Stats();
      this.joinTimeout_ = -1;
      this.publishTimeout_ = -1;
      this.unpublishTimeout_ = -1;
      this.publishRetryCount_ = 0;
      this.startJoinTimestamp_ = new Date();
      this.joinedTimestamp_ = new Date();
      this.downlinkVideoHealthStats_ = {};
      this.uplinkVideoHealthStats_ = {};
    }
    /**
     * 设置代理服务器
     * <br>
     * 该方法适用于企业自己部署代理服务器，如 ngnix+coturn 方案。
     *
     * <br>
     * Note:
     *
     * - 该方法需要在 {@link Client#join join()} 之前调用。
     *
     * @param {string} url websocket 代理服务器地址，格式如：‘wss://proxy.example.com:443’
     * @memberof Client
     * @example
     * client.setProxyServer('wss://proxy.example.com:443');
     */


    _createClass(Client, [{
      key: "setProxyServer",
      value: function setProxyServer(url) {
        if (!url.startsWith('wss://')) {
          throw new RtcError({
            code: ErrorCode.INVALID_PARAMETER,
            message: 'proxy server url shall be started with "wss://"'
          });
        }

        this.proxy_ = url;
      }
    }, {
      key: "getUrl",
      value: function getUrl$1(url) {
        var finalUrl = getUrl(url);

        if (!getEnv() && this.proxy_) {
          finalUrl = this.proxy_;
        }

        return finalUrl; //return this.proxy_ ? this.proxy_ : Util.getUrl(mainUrl);
      }
    }, {
      key: "getBackupUrl",
      value: function getBackupUrl() {
        return this.proxy_ ? this.proxy_ : getUrl(backupUrl);
      }
    }, {
      key: "getUserId",
      value: function getUserId() {
        return this.userId_;
      }
    }, {
      key: "getTinyId",
      value: function getTinyId() {
        return this.tinyId_;
      }
      /**
       * 设置 TURN 服务器
       * <br>
       * 该方法配合 {@link Client#setProxyServer setProxyServer()} 使用，适用于企业自己部署代理服务器和 TURN 中转。
       *
       * <br>
       * Note:
       *
       * - 该方法需要在 {@link Client#join join()} 之前调用。
       *
       * @param {object} config TURN 服务器配置项
       * @param {string} config.url TURN 服务器 url
       * @param {string=} config.username TURN 服务器验证用户名
       * @param {string=} config.credential TURN 服务器验证密码
       * @param {string=} config.credentialType TURN 服务器验证密码类型，默认是 ‘password’
       * <br>
       * {@link https://developer.mozilla.org/en-US/docs/Web/API/RTCIceServer/credentialType credentialType参考}
       * @memberof Client
       * @example
       * client.setTurnServer({ url: '192.168.0.110:3478', username: 'bob', credential: 'bobspassword', credentialType: 'password' });
       */

    }, {
      key: "setTurnServer",
      value: function setTurnServer(config) {
        this.turnServer_ = {}; // the right turn URL format is: turn:192.168.0.110:3478

        this.turnServer_.urls = 'turn:' + config.url;

        if (typeof config.username !== 'undefined' && typeof config.credential !== 'undefined') {
          this.turnServer_.username = config.username;
          this.turnServer_.credential = config.credential;
          this.turnServer_.credentialType = 'password';

          if (typeof config.credentialType !== 'undefined') {
            this.turnServer_.credentialType = config.credentialType;
          }
        }
      }
      /**
       * setup the signal channel.
       *
       * @private
       * @returns {Promise}
       * @memberof Client
       */

    }, {
      key: "initialize",
      value: function initialize() {
        var _this = this;

        var loginMainURL = mainUrl;
        var loginBackupURL = backupUrl;
        return new Promise(function (resolve, reject) {
          console.log('InitEnv:' + _this.UseTestEnv);

          if (_this.UseTestEnv) {
            loginMainURL = mainUrlTest;
            loginBackupURL = backupUrlTest;
          }

          _this.log_.info('setup signal channel');

          _this.signalChannel_ = new SignalChannel({
            sdkAppId: _this.sdkAppId_,
            userId: _this.userId_,
            userSig: _this.userSig_,
            roomId_: _this.roomId_,
            url: _this.getUrl(loginMainURL),
            backupUrl: _this.getUrl(loginBackupURL),
            version: _this.version_
          }); // signal channel (WebSocket) connection state changed handler

          _this.signalChannel_.on(ChannelEvent.CONNECTION_STATE_CHANGED, function (event) {
            _this.log_.info("SignalChannel state changed from ".concat(event.prevState, " to ").concat(event.state));

            _this.emitter_.emit(ClientEvent.CONNECTION_STATE_CHANGED, event);
          }); // signal channel Error handler


          _this.signalChannel_.on(ChannelEvent.ERROR, function (error) {
            if (!_this.isInitialized_) {
              reject(error);
            } else {
              // ensure uplink connection is closed to avoid a/v state in backend run into chaos
              _this.closeUplink(); // also close downlink connections to prevent unexpected ice failed report.


              _this.closeConnections();

              _this.emitter_.emit(ClientEvent.ERROR, error);
            }
          }); // signal channel setup failure handler


          _this.signalChannel_.on(SignalEvent.CHANNEL_SETUP_FAILED, function (error) {
            _this.log_.error('signal channel setup failed');

            reject(error);
          }); // signal channel setup success handler


          _this.signalChannel_.on(SignalEvent.CHANNEL_SETUP_SUCCESS, function (event) {
            _this.signalInfo_ = event.signalInfo;
            _this.tinyId_ = _this.signalInfo_.tinyId;
            _this.roomId_ = _this.signalInfo_.roomId;
            _this.isInitialized_ = true;
            resolve();
          }); // peer-join event handler


          _this.signalChannel_.on(SignalEvent.PEER_JOIN, function (event) {
            // hanadle peer-join only when the receiver is not disabled.
            if (!_this.disableReceiver_) {
              _this.onPeerJoin(event.data);
            }
          }); // peer-leave


          _this.signalChannel_.on(SignalEvent.PEER_LEAVE, function (event) {
            _this.onPeerLeave(event.data);
          });

          _this.signalChannel_.on(SignalEvent.UPDATE_REMOTE_MUTE_STAT, function (event) {
            _this.onUpdateRemoteMuteStat(event.data);
          });

          _this.signalChannel_.on(SignalEvent.CLINET_BANNDED, function (event) {
            var content = event.data.content; // close uplink connection to clear a/v state in case app continue to
            // publish stream even the user was banned either by kick or relay timeout

            _this.closeUplink(); // also close downlink connections to prevent unexpected ICE failed report.


            _this.closeConnections();

            if (content.type === 'banned') {
              var reason = 'you got banned by account admin';

              _this.log_.error('user was banned because of ' + reason);

              _this.onClientBanned(reason);
            } else if (content.type === 'kick') {
              var _reason = 'duplicated userId joining the room';

              _this.log_.error('user was banned because of ' + _reason);

              _this.onClientBanned(_reason);
            } else {
              _this.log_.error('Relay server timeout observed');

              _this.emitter_.emit(ClientEvent.ERROR, new RtcError({
                code: ErrorCode.SERVER_TIMEOUT,
                message: 'Relay server timeout observed'
              }));
            }
          });

          _this.signalChannel_.on(SignalEvent.REQUEST_REBUILD_SESSION, function (event) {
            _this.signalInfo_ = event.signalInfo;
            var tinyIds = [];

            if (_this.connections_) {
              // add 0 for uplink connection, it indicates that the uplink connection
              // had already been established.
              tinyIds.push(0);
            }

            var remoteSdpOffers = [];

            var _iterator = _createForOfIteratorHelper(_this.connections_),
                _step;

            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                var _step$value = _slicedToArray(_step.value, 2),
                    key = _step$value[0],
                    value = _step$value[1];

                tinyIds.push(key);
                var desc = value.getPeerConnection().remoteDescription;

                if (desc) {
                  remoteSdpOffers.push(desc.sdp);
                }
              }
            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }

            var data = {
              socketid: _this.signalInfo_.socketId,
              tinyid: _this.tinyId_,
              appid: _this.sdkAppId_,
              openid: _this.userId_,
              sessionid: String(_this.roomId_),
              sids: tinyIds,
              relayInfo: _this.signalInfo_.relayInnerIp,
              remotesdp: remoteSdpOffers
            };

            try {
              _this.log_.info("reconnect - rebuild session with data: ".concat(JSON.stringify(data)));

              _this.signalChannel_.send(SignalCommand.ON_REBUILD_SESSION, data);
            } catch (error) {
              _this.log_.error('reconnect failed because rebuild session failed');
            }
          });

          _this.signalChannel_.connect();
        });
      }
      /**
       * 加入一个音视频通话房间。<br>
       * 进房代表开始一个音视频通话会话，这时候 SDK 会监听远端用户进房退房情况，若有远端用户进房并且发布流，<br>
       * 本地会收到 'stream-added' 事件。进房后用户可以通过 {@link Client#publish publish()} 发布本地流，本地流发布成功后远端用户就会收到相应
       * 'stream-added' 事件通知从而完成一个双向的音视频通话连接。
       *
       * @param {object} options 进房参数
       * @param {number} options.roomId 房间号，32位整型
       * @param {string=} options.role 用户角色，仅在 ‘live’ 模式下有意义，目前支持两种角色：
       * - ‘anchor’ 主播
       * - ‘audience’ 观众
       * <br>
       * 注意：互动直播 live 模式下的观众角色没有发布本地流的权限，只有收看远端流的权限。如果观众想要连麦跟主播互动，
       * 请先通过 {@link Client#switchRole switchRole()} 切换角色到主播 anchor 后再发布本地流。
       * @param {string=} options.privateMapKey `Deprecated` 进房钥匙，若需要权限控制请携带该参数，因某些局限性目前已不建议使用该参数。
       * @returns {Promise}
       * @throws RtcError
       * @example
       * const client = TRTC.createClient({ mode: 'live', sdkAppId, userId, userSig });
       * client.join({ roomId: 8888, role: 'anchor' }).then(() => {
       *   // join room success
       * }).catch(error => {
       *   console.error('Join room failed: ' + error);
       * });
       */

    }, {
      key: "join",
      value: function () {
        var _join = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(options) {
          var env, errorCode, extraCode, _errorCode, delta;

          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (isTRTCSupported()) {
                    _context.next = 2;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.NOT_SUPPORTED,
                    message: 'the browser does NOT support TRTC!'
                  });

                case 2:
                  if (options.roomId) {
                    // if set roomid refresh it, GME need room id to init signalChannel
                    this.roomId_ = options.roomId;
                  }

                  if (options.teamID) {
                    // if set roomid refresh it, GME need room id to init signalChannel
                    this.teamID_ = options.teamID;
                  }

                  if (options.rangeAudioMode) {
                    // if set roomid refresh it, GME need room id to init signalChannel
                    this.rangeAudioMode_ = options.rangeAudioMode;
                  }

                  this.startJoinTimestamp_ = new Date(); // configure logEvent

                  env = getEnv();

                  if (!env) {
                    env = 'qcloud';

                    if (this.proxy_ && this.proxy_.startsWith('wss://trtc.rtc.qq.com')) {
                      // 'trtc' is a special env for tencent call center
                      env = 'trtc';
                    }
                  }

                  setLogEventConfig({
                    env: env,
                    sdkAppId: this.sdkAppId_,
                    userId: this.userId_,
                    version: this.version_
                  });
                  addEvent(this.userId_, {
                    eventId: EventId.JOIN,
                    eventDesc: 'joining room',
                    timestamp: getCurrentTime(),
                    userId: this.userId_,
                    tinyId: this.tinyId_
                  });
                  _context.prev = 10;
                  _context.next = 13;
                  return this.initialize();

                case 13:
                  _context.next = 20;
                  break;

                case 15:
                  _context.prev = 15;
                  _context.t0 = _context["catch"](10);
                  errorCode = _context.t0.getCode();
                  logEvent({
                    eventType: 'join',
                    result: 'failed',
                    code: errorCode
                  }); // rethrow the error to abort the call

                  throw _context.t0;

                case 20:
                  _context.prev = 20;
                  _context.next = 23;
                  return this.doJoin(options);

                case 23:
                  _context.next = 31;
                  break;

                case 25:
                  _context.prev = 25;
                  _context.t1 = _context["catch"](20);
                  extraCode = _context.t1.getExtraCode();
                  _errorCode = extraCode !== 0 ? extraCode : _context.t1.getCode(); // log the detailed extraCode for join-failure case

                  logEvent({
                    eventType: 'join',
                    result: 'failed',
                    code: _errorCode
                  }); // rethrow the error to abort the call

                  throw _context.t1;

                case 31:
                  this.joinedTimestamp_ = new Date(); // how many ms it took to join the room

                  delta = this.joinedTimestamp_ - this.startJoinTimestamp_;
                  logEvent({
                    eventType: 'delta-join',
                    result: 'success',
                    delta: delta
                  });
                  logEvent({
                    eventType: 'join',
                    result: 'success'
                  });

                case 35:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this, [[10, 15], [20, 25]]);
        }));

        function join(_x) {
          return _join.apply(this, arguments);
        }

        return join;
      }()
    }, {
      key: "getVersion",
      value: function getVersion() {
        var v = this.version_.split('.'); // the jsSdkVersion requested by backend, sigh!

        return parseInt(v[0]) * 1000 + parseInt(v[1]) * 100 + parseInt(v[2]);
      }
    }, {
      key: "doJoin",
      value: function doJoin(options) {
        var _this2 = this;

        return new Promise(function (resolve, reject) {
          if (!_this2.isInitialized_) {
            throw new RtcError({
              code: ErrorCode.INVALID_OPERATION,
              message: 'SignalChannel is not ready yet'
            });
          }

          if (_this2.isJoined_) {
            throw new RtcError({
              code: ErrorCode.INVALID_OPERATION,
              message: 'duplicate join() called'
            });
          } // mandatory parameters


          if (_this2.roomId_ === undefined) {
            _this2.roomId_ = options.roomId;
          } // optional paramters


          if (typeof options.role !== 'undefined') {
            _this2.role_ = options.role;
          }

          var privateMapKey = '';

          if (typeof options.privateMapKey !== 'undefined') {
            privateMapKey = options.privateMapKey;
          }

          _this2.privateMapKey_ = privateMapKey;

          _this2.log_.info("Join() => joining room: ".concat(options.roomId, " mode: ").concat(_this2.mode_, " role: ").concat(_this2.role_));

          var signalInfo = _this2.signalInfo_; // join room parameters, it's awkful that plenty of params are not meaningful at all.

          var data = {
            openid: signalInfo.openId,
            tinyid: signalInfo.tinyId,
            // unused
            peerconnectionport: '',
            // WTF, useStrRoomid must be numeric 1 for true.
            useStrRoomid: _this2.useStringRoomId_ ? 1 : false,
            roomid: String(_this2.roomId_),
            sdkAppID: String(_this2.sdkAppId_),
            socketid: signalInfo.socketId,
            userSig: _this2.userSig_,
            // privateMapKey
            privMapEncrypt: privateMapKey,
            // unused?
            privMap: '',
            relayip: signalInfo.relayInnerIp,
            dataport: signalInfo.dataPort,
            stunport: signalInfo.stunPort,
            checkSigSeq: signalInfo.checkSigSeq,
            // pstn unused
            pstnBizType: 0,
            pstnPhoneNumber: null,
            recordId: _this2.recordId_,
            pureAudioPushMod: _this2.pureAudioPushMode_,
            role: 'user',
            // SpearRole was deprecated so this is unused at all.
            jsSdkVersion: String(_this2.getVersion()),
            // SDK Version starting with v4.0.0
            sdpSemantics: _this2.sdpSemantics_,
            browserVersion: BROWSER_VERSION,
            closeLocalMedia: true,
            trtcscene: _this2.mode_ === 'live' ? Mode.LIVE : Mode.RTC,
            trtcrole: _this2.role_ === 'anchor' ? Role.HOST : Role.AUDIENCE,
            bussinessInfo: _this2.bussinessInfo_,
            isAuxUser: _this2.isScreenShareOnly_,
            teamID: _this2.teamID_,
            rangeAudioMode: _this2.rangeAudioMode_
          }; // schedule timeout to check if join room could be finished in 2s

          _this2.joinTimeout_ = setTimeout(function () {
            _this2.log_.error('join room timeout observed');

            reject(new RtcError({
              code: ErrorCode.JOIN_ROOM_FAILED,
              message: 'join room timeout'
            }));
          }, 5000);

          _this2.signalChannel_.sendWithReport(SignalCommand.JOIN_ROOM, data, getSysInfo());

          _this2.signalChannel_.once(SignalEvent.JOIN_ROOM_RESULT, function (evt) {
            clearTimeout(_this2.joinTimeout_);
            _this2.joinTimeout_ = -1;
            var result = evt.data.content.ret;

            if (!result) {
              _this2.isJoined_ = true;

              _this2.log_.info('Join room success, start heartbeat');

              _this2.startHeartbeat();

              resolve();
            } else {
              _this2.log_.error('Join room failed result: ' + result + ' error: ' + evt.data.content.error); // TODO: join room failure error code


              reject(new RtcError({
                code: ErrorCode.JOIN_ROOM_FAILED,
                extraCode: result,
                message: 'Failed to join room - ' + evt.data.content.error
              }));
            }
          });
        });
      }
      /**
       * 设置teamID
       *
       * @param {number} teamID 房间号，32位整型
       * @returns {Promise}
       * @throws RtcError
       * @example
       */
      // eslint-disable-next-line classes/name

    }, {
      key: "SetRangeAudioTeamID",
      value: function () {
        var _SetRangeAudioTeamID = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(teamID) {
          var _this3 = this;

          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  if (!(this.teamID_ == teamID)) {
                    _context2.next = 2;
                    break;
                  }

                  return _context2.abrupt("return");

                case 2:
                  this.teamID_ = teamID;

                  if (this.isJoined_) {
                    _context2.next = 5;
                    break;
                  }

                  return _context2.abrupt("return");

                case 5:
                  return _context2.abrupt("return", new Promise(function (resolve, reject) {
                    _this3.log_.info("SetRangeAudioTeamID: ".concat(teamID));

                    var signalInfo = _this3.signalInfo_;
                    var data = {
                      relayip: signalInfo.relayInnerIp,
                      dataport: signalInfo.dataPort,
                      sdkAppID: String(_this3.sdkAppId_),
                      openid: signalInfo.openId,
                      tinyid: signalInfo.tinyId,
                      srctinyid: '',
                      peerconnectionport: '',
                      sessionid: String(_this3.roomId_),
                      userSig: _this3.userSig_,
                      teamID: teamID,
                      checkSigSeq: signalInfo.checkSigSeq,
                      jsSdkVersion: String(_this3.getVersion()),
                      // SDK Version starting with v4.0.0
                      browserVersion: BROWSER_VERSION,
                      role: 'user'
                    };

                    _this3.signalChannel_.sendWithReport(SignalCommand.SET_TEAM_ID, data, '');
                  }));

                case 6:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function SetRangeAudioTeamID(_x2) {
          return _SetRangeAudioTeamID.apply(this, arguments);
        }

        return SetRangeAudioTeamID;
      }()
    }, {
      key: "updateAudioRecvRange",
      value: function updateAudioRecvRange(range) {
        if (this.receiveRang_ == range) {
          return;
        }

        this.receiveRang_ = range;
        this.log_.info("updateAudioRecvRange, range: ".concat(range));
      }
      /**
       * 设置语音模式
       *
       * @param {number} rangeAudioMode 0 代表“所有人”，1 代表"仅小队"
       * @returns {Promise}
       * @throws RtcError
       * @example
       */
      // eslint-disable-next-line classes/name

    }, {
      key: "SetRangeAudioMode",
      value: function () {
        var _SetRangeAudioMode = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(rangeAudioMode) {
          var _this4 = this;

          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  if (!(this.rangeAudioMode_ == rangeAudioMode)) {
                    _context3.next = 2;
                    break;
                  }

                  return _context3.abrupt("return");

                case 2:
                  this.rangeAudioMode_ = rangeAudioMode;
                  this.log_.info("SetRangeAudioMode, rangeAudioMode: ".concat(rangeAudioMode));

                  if (this.isJoined_) {
                    _context3.next = 6;
                    break;
                  }

                  return _context3.abrupt("return");

                case 6:
                  return _context3.abrupt("return", new Promise(function (resolve, reject) {
                    _this4.log_.info("SetRangeAudioMode: ".concat(rangeAudioMode));

                    var signalInfo = _this4.signalInfo_;
                    var data = {
                      relayip: signalInfo.relayInnerIp,
                      dataport: signalInfo.dataPort,
                      sdkAppID: String(_this4.sdkAppId_),
                      openid: signalInfo.openId,
                      tinyid: signalInfo.tinyId,
                      srctinyid: '',
                      peerconnectionport: '',
                      sessionid: String(_this4.roomId_),
                      userSig: _this4.userSig_,
                      rangeAudioMode: rangeAudioMode,
                      checkSigSeq: signalInfo.checkSigSeq,
                      jsSdkVersion: String(_this4.getVersion()),
                      // SDK Version starting with v4.0.0
                      browserVersion: BROWSER_VERSION,
                      role: 'user'
                    };

                    _this4.signalChannel_.sendWithReport(SignalCommand.SET_AUDIO_MODE, data, '');
                  }));

                case 7:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3, this);
        }));

        function SetRangeAudioMode(_x3) {
          return _SetRangeAudioMode.apply(this, arguments);
        }

        return SetRangeAudioMode;
      }()
      /**
       * 更新声源方位
       *
       * @param position    自身在世界坐标系中的坐标，顺序是前、右、上
       * @param axisForward 自身坐标系前轴的单位向量（范围语音不需要设置）
       * @param axisRight   自身坐标系右轴的单位向量（范围语音不需要设置）
       * @param axisUp      自身坐标系上轴的单位向量（范围语音不需要设置）
       * @returns {Promise}
       * @throws RtcError
       * @example
       */
      // eslint-disable-next-line classes/name

    }, {
      key: "UpdateSelfPosition",
      value: function () {
        var _UpdateSelfPosition = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(position, axisForward, axisRight, axisUp) {
          var _this5 = this;

          return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  return _context4.abrupt("return", new Promise(function (resolve, reject) {
                    if (!_this5.isInitialized_) {
                      throw new RtcError({
                        code: ErrorCode.INVALID_OPERATION,
                        message: 'SignalChannel is not ready yet'
                      });
                    }

                    if (!_this5.isJoined_) {
                      throw new RtcError({
                        code: ErrorCode.INVALID_OPERATION,
                        message: 'room not exist'
                      });
                    }

                    _this5.log_.info("UpdateSelfPosition, position: ".concat(position, ", receiveRang: ").concat(_this5.receiveRang_));

                    var signalInfo = _this5.signalInfo_;
                    var data = {
                      relayip: signalInfo.relayInnerIp,
                      dataport: signalInfo.dataPort,
                      sdkAppID: String(_this5.sdkAppId_),
                      openid: signalInfo.openId,
                      tinyid: signalInfo.tinyId,
                      srctinyid: '',
                      peerconnectionport: '',
                      sessionid: String(_this5.roomId_),
                      userSig: _this5.userSig_,
                      position: position,
                      receiveRang: _this5.receiveRang_,
                      checkSigSeq: signalInfo.checkSigSeq,
                      jsSdkVersion: String(_this5.getVersion()),
                      // SDK Version starting with v4.0.0
                      browserVersion: BROWSER_VERSION,
                      role: 'user'
                    };

                    _this5.signalChannel_.sendWithReport(SignalCommand.UPDATE_SELF_POSITION, data, '');
                  }));

                case 1:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4);
        }));

        function UpdateSelfPosition(_x4, _x5, _x6, _x7) {
          return _UpdateSelfPosition.apply(this, arguments);
        }

        return UpdateSelfPosition;
      }()
      /**
       * 退出当前音视频通话房间，结束一次音视频通话会话。<br>
       * 退房前请确保已经通过 {@link Client#unpublish unpublish()} 取消发布本地流，若未取消发布本地流，SDK 内部会自动取消发布本地流。
       * 同时，退房会关闭所有远端流。
       *
       * @returns {Promise}
       * @memberof Client
       * @example
       * client.leave().then(() => {
       *   // leaving room success
       * }).catch(error => {
       *   console.error('leaving room failed: ' + error);
       * });
       */

    }, {
      key: "leave",
      value: function () {
        var _leave = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
          var found, _iterator2, _step2, _step2$value, key, value, health, healthStats, delta;

          return regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  addEvent(this.userId_, {
                    eventId: EventId.LEAVE,
                    eventDesc: 'leaving room',
                    timestamp: getCurrentTime(),
                    userId: this.userId_,
                    tinyId: this.tinyId_
                  });
                  _context5.prev = 1;
                  _context5.next = 4;
                  return this.doHeartbeat();

                case 4:
                  _context5.next = 8;
                  break;

                case 6:
                  _context5.prev = 6;
                  _context5.t0 = _context5["catch"](1);

                case 8:
                  found = false;
                  _iterator2 = _createForOfIteratorHelper(this.connections_);
                  _context5.prev = 10;

                  _iterator2.s();

                case 12:
                  if ((_step2 = _iterator2.n()).done) {
                    _context5.next = 21;
                    break;
                  }

                  _step2$value = _slicedToArray(_step2.value, 2), key = _step2$value[0], value = _step2$value[1];

                  if (found) {
                    _context5.next = 19;
                    break;
                  }

                  _context5.next = 17;
                  return value.getVideoHealthStats();

                case 17:
                  health = _context5.sent;

                  if (health.valid) {
                    found = true;
                    this.downlinkVideoHealthStats_ = health;
                  }

                case 19:
                  _context5.next = 12;
                  break;

                case 21:
                  _context5.next = 26;
                  break;

                case 23:
                  _context5.prev = 23;
                  _context5.t1 = _context5["catch"](10);

                  _iterator2.e(_context5.t1);

                case 26:
                  _context5.prev = 26;

                  _iterator2.f();

                  return _context5.finish(26);

                case 29:
                  // 视频通话健康度上报
                  healthStats = {
                    HealthStats: {
                      userAgent: navigator.userAgent,
                      uplink: this.uplinkVideoHealthStats_,
                      downlink: this.downlinkVideoHealthStats_
                    }
                  };
                  this.log_.info(JSON.stringify(healthStats));
                  _context5.prev = 31;
                  _context5.next = 34;
                  return this.doLeave();

                case 34:
                  _context5.next = 38;
                  break;

                case 36:
                  _context5.prev = 36;
                  _context5.t2 = _context5["catch"](31);

                case 38:
                  this.isJoined_ = false;
                  this.destroy();
                  logEvent({
                    eventType: 'leave',
                    result: 'success'
                  }); // how many seconds the client spent in the room

                  delta = Math.floor((new Date() - this.joinedTimestamp_) / 1000);
                  logEvent({
                    eventType: 'delta-leave',
                    result: 'success',
                    delta: delta
                  });

                case 43:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee5, this, [[1, 6], [10, 23, 26, 29], [31, 36]]);
        }));

        function leave() {
          return _leave.apply(this, arguments);
        }

        return leave;
      }()
    }, {
      key: "doLeave",
      value: function doLeave() {
        var _this6 = this;

        return new Promise(function (resolve, reject) {
          if (!_this6.isJoined_) return resolve();

          _this6.log_.info("leave() => leaving room");

          _this6.stopHeartbeat();

          _this6.closeConnections();

          _this6.mutedStates_.clear(); // cleanup the timeouts


          _this6.clearPublishTimeout();

          _this6.clearUnpublishTimeout(); // clean up pending refresh if any


          _this6.pendingRefresh_.clear(); // terminate uplink w/o notifying remote server


          _this6.closeUplink();

          return resolve();
        });
      }
    }, {
      key: "clearPublishTimeout",
      value: function clearPublishTimeout() {
        if (this.publishTimeout_ !== -1) {
          clearTimeout(this.publishTimeout_);
          this.publishTimeout_ = -1;
        }
      }
    }, {
      key: "clearUnpublishTimeout",
      value: function clearUnpublishTimeout() {
        if (this.unpublishTimeout_) {
          clearTimeout(this.unpublishTimeout_);
          this.unpublishTimeout_ = -1;
        }
      } // close all downlink connections

    }, {
      key: "closeConnections",
      value: function closeConnections() {
        this.connections_.forEach(function (connection) {
          connection.close();
        });
        this.connections_.clear();
        this.connectionsRefreshCount_.clear();
      }
      /**
       * counterpart to initialize(), this will destroy the SignalChannel
       * and close the WebSocket underlying. Remote server requires that
       * closing the websocket after leaving the room and reopen a new
       * websocket before re-join the room. That is, a websocket session
       * is only valid for the timeline beween a join and a leave.
       *
       * @private
       * @memberof Client
       */

    }, {
      key: "destroy",
      value: function destroy() {
        if (this.isJoined_) {
          this.log_.warn('please call leave() before destroy() client');
          throw new RtcError({
            code: ErrorCode.INVALID_OPERATION,
            message: 'Please call leave() before destory() the client'
          });
        }

        this.log_.info('destroying SignalChannel');

        if (this.signalChannel_) {
          this.signalChannel_.close();
          this.signalChannel_ = null;
        }
      }
      /**
       * 发布本地音视频流。<br>
       * 该方法需要在 {@link Client#join join()} 进房后调用，一次音视频会话中只能发布一个本地流。若想发布另外一个本地流，可先通过
       * {@link Client#unpublish unpublish()} 取消发布当前本地流后再发布新的本地流。<br>
       * 在发布本地流后，可通过 {@link LocalStream#removeTrack removeTrack()}、{@link LocalStream#addTrack addTrack()}、
       * {@link LocalStream#replaceTrack replaceTrack()} 来更新本地流中的某个音频或视频流。<br>
       * 发布本地流后远端会收到 ‘stream-added’ 事件通知。
       *
       * **NOTE**
       *
       * - 在 Client `mode` 为 'live' 及 `role` 为 'audience' 的场景下，即互动直播观众角色场景下，用户没有发布本地流权限。
       * 如果观众想要连麦互动，需要先调用 {@link Client#switchRole switchRole('anchor')} 切换到主播角色后再调用该接口发布本地流。
       *
       * @param {Stream} stream 本地流，通过 {@link TRTC.createStream createStream()} 创建出来。
       * @returns {Promise}
       * @throws RtcError
       * @memberof Client
       * @example
       * localStream.initialize().then(() => {
       *   // 本地流初始化成功，发布本地流
       *   client.publish(localStream).then(() => {
       *     // 本地流发布成功
       *   });
       * });
       */

    }, {
      key: "publish",
      value: function publish(stream) {
        var _this7 = this;

        return new Promise(function (resolve, reject) {
          if (!isTRTCSupported()) {
            throw new RtcError({
              code: ErrorCode.NOT_SUPPORTED,
              message: 'the browser does NOT support TRTC!'
            });
          }

          if (!_this7.isJoined_) {
            throw new RtcError({
              code: ErrorCode.INVALID_OPERATION,
              message: 'please call join() before publish()'
            });
          }

          if (_this7.mode_ === 'live' && _this7.role_ === 'audience') {
            throw new RtcError({
              code: ErrorCode.INVALID_OPERATION,
              message: 'no permission to publish() under live/audience, please call swithRole("anchor") firstly before publish()'
            });
          }

          if (_this7.localStream_) {
            throw new RtcError({
              code: ErrorCode.INVALID_OPERATION,
              message: 'duplicate publishing, please unpublish and then re-publish'
            });
          }

          if (_this7.isPublishing_) {
            throw new RtcError({
              code: ErrorCode.INVALID_OPERATION,
              message: 'previous publishing is ongoing, please avod re-publishing'
            });
          }

          _this7.isPublishing_ = true;
          var startTime = new Date();

          _this7.log_.info("publish() => publishing local stream");

          var connection = new Connection({
            userId: _this7.userId_,
            tinyId: _this7.tinyId_,
            client: _this7,
            isUplink: true,
            signalChannel: _this7.signalChannel_
          });
          connection.initialize(); // schedule timeout to check if publish could be finished in 2s

          _this7.publishTimeout_ = setTimeout(function () {
            _this7.isPublishing_ = false;
            connection.close();

            _this7.log_.error('failed to publish because of timeout');

            logEvent({
              eventType: 'publish',
              result: 'failed'
            });
            reject(new RtcError({
              code: ErrorCode.UNKNOWN,
              message: 'publish timeout'
            }));
          }, 10000);
          connection.publish(stream, function (error) {
            _this7.clearPublishTimeout();

            _this7.isPublishing_ = false;
            connection.close();

            _this7.log_.error('failed to publish stream');

            logEvent({
              eventType: 'publish',
              result: 'failed'
            });
            reject(error);
          });
          connection.on(ConnectionEvent.STREAM_PUBLISHED, function (event) {
            _this7.clearPublishTimeout();

            _this7.isPublishing_ = false;
            _this7.localStream_ = event.stream;

            _this7.localStream_.setConnection(connection);

            _this7.uplinkConnection_ = connection;
            logEvent({
              eventType: 'publish',
              result: 'success'
            });
            var endTime = new Date();
            var delta = endTime - startTime;
            logEvent({
              eventType: 'delta-publish',
              result: 'success',
              delta: delta
            });

            if (stream.hasAudio()) {
              addEvent(_this7.userId_, {
                eventId: EventId.PUBLISH_AUDIO,
                eventDesc: 'publish audio track',
                timestamp: getCurrentTime(),
                userId: _this7.userId_,
                tinyId: _this7.tinyId_
              });
            }

            if (stream.hasVideo()) {
              addEvent(_this7.userId_, {
                eventId: EventId.PUBLISH_VIDEO,
                eventDesc: 'publish video track',
                timestamp: getCurrentTime(),
                userId: _this7.userId_,
                tinyId: _this7.tinyId_
              });
            }

            resolve();
          });
          connection.on(ConnectionEvent.CONNECTION_STATE_CHANGED, function (event) {
            if (event.state === 'connected') {
              if (_this7.publishRetryCount_) {
                // clear the auto re-publish flag if any.
                _this7.publishRetryCount_ = 0;

                _this7.log_.info('auto re-publish success');
              }
            }
          });
          connection.on(ConnectionEvent.ERROR, function (error) {
            var errorCode = error.getCode();

            if (errorCode === ErrorCode.ICE_TRANSPORT_ERROR && _this7.publishRetryCount_ < 3 && // try re-publish only when it's already published
            _this7.localStream_ === stream) {
              // try to re-publish the stream in case of ICE failure
              _this7.publishRetryCount_ += 1;

              _this7.log_.warn('try to re-plublish the stream due to ice failure observed');

              _this7.unpublish(stream).then(function () {
                _this7.log_.warn('trying re-publish');

                _this7.publish(stream).then(function () {
                  _this7.log_.info('auto re-publish is ongoing');
                })["catch"](function (e) {
                  _this7.log_.warn('auto re-publish failure');

                  _this7.publishRetryCount_ = 0; // rethrow the ICE_TRANSPORT_ERROR

                  _this7.emitter_.emit(ClientEvent.ERROR, error);
                });
              })["catch"](function (e) {
                _this7.log_.error('re-plublish/unpublish failure observed');

                _this7.publishRetryCount_ = 0;

                _this7.emitter_.emit(ClientEvent.ERROR, error);
              });

              return;
            }

            _this7.emitter_.emit(ClientEvent.ERROR, error);
          });
        });
      }
      /**
       * 取消发布本地流。<br>
       * 取消发布本地流后远端会收到 'stream-removed' 事件通知。<br>
       * 请在 {@link Client#leave leave()} 退房前取消已经发布的本地流。
       *
       * @param {Stream} stream 本地流
       * @returns {Promise}
       * @throws RtcError
       * @memberof Client
       * @example
       * // 取消发布本地流
       * client.unpublish(localStream).then(() => {
       *   // 取消发布本地流成功
       * });
       */

    }, {
      key: "unpublish",
      value: function unpublish(stream) {
        var _this8 = this;

        return new Promise(function (resolve, reject) {
          if (_this8.isPublishing_) {
            throw new RtcError({
              code: ErrorCode.INVALID_OPERATION,
              message: 'unpublish() is being called during publish() is ongoing'
            });
          }

          if (stream !== _this8.localStream_) {
            throw new RtcError({
              code: ErrorCode.INVALID_PARAMETER,
              message: 'stream has not been published yet'
            });
          }

          _this8.log_.info("unpublish() => unpublishing local stream");

          _this8.doUnpublish().then(function () {
            logEvent({
              eventType: 'unpublish',
              result: 'success'
            });
            resolve();
          })["catch"](function (e) {
            logEvent({
              eventType: 'unpublish',
              result: 'failed'
            });
            reject();
          });
        });
      }
      /**
       * remote server runs into exception if we close the uplink connection directly
       * WA: we send to remote server to request a peer close and close the connection
       * once we receive the ack from remote.
       *
       * @private
       * @returns {Promise}
       * @memberof Client
       */

    }, {
      key: "doUnpublish",
      value: function doUnpublish() {
        var _this9 = this;

        return new Promise(function (resolve, reject) {
          _this9.signalChannel_.send(SignalCommand.CLOSE_PEER); // schedule timeout to check if remote server can response in 2s


          _this9.unpublishTimeout_ = setTimeout(function () {
            _this9.log_.warn('unpublish() timeout observed'); // force to close uplink


            _this9.closeUplink();

            return reject();
          }, 5000);

          _this9.signalChannel_.once(SignalEvent.CLOSE_PEER_ACK, function (data) {
            _this9.clearUnpublishTimeout();

            _this9.log_.info('received CLOSE_PEER_ACK, close uplink connection');

            _this9.closeUplink();

            return resolve();
          });
        });
      }
    }, {
      key: "closeUplink",
      value: function () {
        var _closeUplink = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
          return regeneratorRuntime.wrap(function _callee6$(_context6) {
            while (1) {
              switch (_context6.prev = _context6.next) {
                case 0:
                  if (!this.uplinkConnection_) {
                    _context6.next = 10;
                    break;
                  }

                  _context6.next = 3;
                  return this.uplinkConnection_.getVideoHealthStats();

                case 3:
                  this.uplinkVideoHealthStats_ = _context6.sent;
                  this.uplinkConnection_.close();
                  this.uplinkConnection_ = null;

                  if (this.localStream_.hasAudio()) {
                    addEvent(this.userId_, {
                      eventId: EventId.UNPUBLISH_AUDIO,
                      eventDesc: 'unpublish audio track',
                      timestamp: getCurrentTime(),
                      userId: this.userId_,
                      tinyId: this.tinyId_
                    });
                  }

                  if (this.localStream_.hasVideo()) {
                    addEvent(this.userId_, {
                      eventId: EventId.UNPUBLISH_VIDEO,
                      eventDesc: 'unpublish video track',
                      timestamp: getCurrentTime(),
                      userId: this.userId_,
                      tinyId: this.tinyId_
                    });
                  } // set localStream null to indicate that no local stream is published at all.


                  this.localStream_.setConnection(null);
                  this.localStream_ = null;

                case 10:
                case "end":
                  return _context6.stop();
              }
            }
          }, _callee6, this);
        }));

        function closeUplink() {
          return _closeUplink.apply(this, arguments);
        }

        return closeUplink;
      }()
      /**
       * 订阅远端流<br>
       * 默认情况下，当收到远端流增加事件 'stream-added' 后，SDK 会立刻接收并解码该远端流所包含的音视频数据。<br>
       * 开发者可通过该订阅接口指明需要订阅音频、视频或者音视频流。若不想接收该远端流所包含的任何音视频数据，请通过
       * {@link Client#unsubscribe unsubscribe()} 取消订阅。
       *
       * @param {Stream} stream 远端流，通过监听 'stream-added' 事件获得。
       * @param {object=} options 订阅选项
       * @param {boolean=} options.audio 是否订阅音频
       * @param {boolean=} options.video 是否订阅视频
       * @memberof Client
       * @throws RtcError
       * @fires Event.STREAM_SUBSCRIBED 订阅成功事件通知
       * @example
       * // 监听远端流订阅成功事件
       * client.on('stream-subscribed', event => {
       *   const remoteStream = event.stream;
       *   // 远端流订阅成功，播放远端音视频流
       *   remoteStream.play('remote_stream');
       * });
       * // 监听远端流增加事件
       * client.on('stream-added', event => {
       *   const remoteStream = event.stream;
       *   // 订阅远端音频和视频流
       *   client.subscribe(remoteStream, { audio: true, video: true }).catch(e => {
       *     console.error('failed to subscribe remoteStream');
       *   });
       *
       *   // 仅订阅音频数据
       *   // client.subscribe(remoteStream, { audio: true, video: false }).catch(e => {
       *   //  console.error('failed to subscribe remoteStream');
       *   // });
       * });
       *
       */

    }, {
      key: "subscribe",
      value: function () {
        var _subscribe = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(stream, options) {
          var connection;
          return regeneratorRuntime.wrap(function _callee7$(_context7) {
            while (1) {
              switch (_context7.prev = _context7.next) {
                case 0:
                  if (stream.isRemote()) {
                    _context7.next = 2;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_PARAMETER,
                    message: 'try to subscribe a local stream'
                  });

                case 2:
                  this.log_.info("subscribe() => subscribe to [".concat(stream.getUserId(), "] ").concat(stream.getType(), " stream with options: ").concat(JSON.stringify(options)));
                  connection = stream.getConnection();
                  _context7.next = 6;
                  return connection.subscribe(stream, options);

                case 6:
                case "end":
                  return _context7.stop();
              }
            }
          }, _callee7, this);
        }));

        function subscribe(_x8, _x9) {
          return _subscribe.apply(this, arguments);
        }

        return subscribe;
      }()
      /**
       * 取消订阅远端流<br>
       * 当收到远端流增加事件 'stream-added' 通知后，SDK 默认会立刻接收并解码该远端流所包含的音视频数据，如果你想拒绝接收
       * 该远端流的任何音视频数据，请在 'stream-added' 事件处理回调中调用此接口。<br>
       * 如果你想默认拒绝接收所有的远端流，请在 {@link Client#join join()} 进房前调用 {@link Client#setDefaultMuteRemoteStreams setDefaultMuteRemoteStreams(true)}
       *
       * @param {Stream} stream 远端流，通过监听 ‘stream-added’ 事件获得。
       * @memberof Client
       * @throws RtcError
       * @example
       * client.on('stream-added', event => {
       *   const remoteStream = event.stream;
       *   // 拒绝接收该远端流所包含的任何音视频数据
       *   client.unsubscribe(remoteStream).catch(e => {
       *     console.error('failed to unsubscribe remoteStream');
       *   });
       * });
       */

    }, {
      key: "unsubscribe",
      value: function () {
        var _unsubscribe = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(stream) {
          var connection;
          return regeneratorRuntime.wrap(function _callee8$(_context8) {
            while (1) {
              switch (_context8.prev = _context8.next) {
                case 0:
                  if (stream.isRemote()) {
                    _context8.next = 2;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_PARAMETER,
                    message: 'try to unsubscribe a local stream'
                  });

                case 2:
                  this.log_.info("unsubscribe() => unsubscribe to [".concat(stream.getUserId(), "] ").concat(stream.getType(), " stream"));
                  connection = stream.getConnection();
                  _context8.next = 6;
                  return connection.unsubscribe(stream);

                case 6:
                case "end":
                  return _context8.stop();
              }
            }
          }, _callee8, this);
        }));

        function unsubscribe(_x10) {
          return _unsubscribe.apply(this, arguments);
        }

        return unsubscribe;
      }()
      /**
       * 切换用户角色，仅在 ‘live’ 互动直播模式下生效。<br>
       * 该方法主要用于互动直播模式下观众用户连麦推流场景，在观众用户连麦推流之前，请先将用户角色转换为 ‘anchor’ 主播角色然后再发布本地流。<br>
       *
       * @param {string} role 用户角色
       * - ‘anchor’ 主播
       * - ‘audience’ 观众
       * @returns {Promise}
       * @throws RtcError
       * @memberof Client
       * @example
       * // live互动直播模式下，观众连麦推流
       * client.switchRole('anchor').then(() => {
       *   // 连麦观众角色切换为主播，开始推流
       *   client.publish(localStream);
       * });
       */

    }, {
      key: "switchRole",
      value: function () {
        var _switchRole = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(role) {
          return regeneratorRuntime.wrap(function _callee9$(_context9) {
            while (1) {
              switch (_context9.prev = _context9.next) {
                case 0:
                  if (!(this.mode_ !== 'live')) {
                    _context9.next = 2;
                    break;
                  }

                  return _context9.abrupt("return");

                case 2:
                  if (!(this.role_ !== role)) {
                    _context9.next = 11;
                    break;
                  }

                  this.role_ = role;
                  this.log_.info('switchRole() => switch role to: ' + role);

                  if (this.isJoined_) {
                    _context9.next = 7;
                    break;
                  }

                  return _context9.abrupt("return");

                case 7:
                  _context9.next = 9;
                  return this.leave();

                case 9:
                  _context9.next = 11;
                  return this.join({
                    role: role,
                    roomId: this.roomId_,
                    privateMapKey: this.privateMapKey_
                  });

                case 11:
                case "end":
                  return _context9.stop();
              }
            }
          }, _callee9, this);
        }));

        function switchRole(_x11) {
          return _switchRole.apply(this, arguments);
        }

        return switchRole;
      }()
      /**
       * 监听客户端对象事件<br>
       * 详细事件列表请参见：{@link module:Event Event}
       *
       * @param {string} eventName 事件名称
       * @param {function} handler 事件处理方法
       * @memberof Client
       * @example
       * client.on('stream-added', event => {
       *   // stream-added event handler
       * });
       */

    }, {
      key: "on",
      value: function on(eventName, handler) {
        this.emitter_.on(eventName, handler);
      }
      /**
       * 取消事件绑定<br>
       * 用于移除通过 {@link Client#on on()} 绑定的事件。
       *
       * @param {string} eventName 事件名称，传入通配符 '*' 会解除所有事件绑定。
       * @param {function} handler 事件处理方法
       * @memberof Client
       * @example
       * client.on('peer-join', function peerJoinHandler(event) {
       *   // peer-join event handler
       *   console.log('peer joined');
       *
       *   client.off('peer-join', peerJoinHandler);
       * });
       *
       * // 解除所有事件绑定
       * client.off('*');
       */

    }, {
      key: "off",
      value: function off(eventName, handler) {
        if (eventName === '*') {
          this.emitter_.removeAllListeners();
        } else {
          this.emitter_.off(eventName, handler);
        }
      }
      /**
       * 远端用户音视频 mute 状态
       * @typedef RemoteMutedState
       * @property {string} userId 远端用户ID
       * @property {boolean} hasVideo 是否有视频
       * @property {boolean} hasAudio 是否有音频
       * @property {boolean} audioMuted 是否静音
       * @property {boolean} videoMuted 是否关闭摄像头
       */

      /**
       * 获取当前房间内远端用户音视频 mute 状态列表。
       *
       * @returns {RemoteMutedState[]} 远端用户音视频 mute 状态数组
       * @memberof Client
       */

    }, {
      key: "getRemoteMutedState",
      value: function getRemoteMutedState() {
        var _this10 = this;

        var states = [];
        this.mutedStates_.forEach(function (value, key, map) {
          var connection = _this10.connections_.get(key);

          if (connection) {
            states.push(_objectSpread2({
              userId: connection.getUserId()
            }, value));
          }
        });
        return states;
      }
      /**
       * 设置是否默认接收远端流。该方法可在 {@link Client#join join()} 调用前使用，若在进房后调用，会接收不到后续进房的远端用户音视频流。
       *
       * @param {boolean} muted 是否默认不接收远端流
       * - true 默认不接收任何远端流。
       * - false 默认接收所有远端流。（默认）
       * @memberof Client
       * @example
       * // 设置默认不接收任何远端流
       * client.setDefaultMuteRemoteStreams(true);
       * client.join({ roomId: 8888 }).then(() => {
       *   // 进房成功，此后不会接收到任何远端流，只能发布本地流
       * });
       */

    }, {
      key: "setDefaultMuteRemoteStreams",
      value: function setDefaultMuteRemoteStreams(muted) {
        this.log_.info('setDefaultMuteRemoteStreams muted: ' + muted);
        this.disableReceiver_ = muted;
      }
      /**
       * 传输状态统计
       * @typedef {object} TransportStats
       * @property {number} rtt SDK 到腾讯视频云的 RTT (Round-Trip Time)，单位 ms
       */

      /**
       * 获取当前网络传输状况统计数据
       * <br>
       * 该方法需要在 {@link Client#publish publish()} 后调用。
       *
       * @returns {Promise<TransportStats>} Promise成功返回 `TransportStats`
       * @memberof Client
       * @example
       * client.getTransportStats().then(stats => {
       *     console.log('RTT: ' + stats.rtt);
       *   }
       * });
       */

    }, {
      key: "getTransportStats",
      value: function () {
        var _getTransportStats = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
          var ts, stats;
          return regeneratorRuntime.wrap(function _callee10$(_context10) {
            while (1) {
              switch (_context10.prev = _context10.next) {
                case 0:
                  ts = {
                    rtt: 0
                  };

                  if (!this.uplinkConnection_) {
                    _context10.next = 6;
                    break;
                  }

                  _context10.next = 4;
                  return this.stats_.getSenderStats(this.uplinkConnection_);

                case 4:
                  stats = _context10.sent;
                  ts.rtt = stats.rtt;

                case 6:
                  return _context10.abrupt("return", ts);

                case 7:
                case "end":
                  return _context10.stop();
              }
            }
          }, _callee10, this);
        }));

        function getTransportStats() {
          return _getTransportStats.apply(this, arguments);
        }

        return getTransportStats;
      }()
      /**
       * 本地流音频统计数据
       * @typedef {object} LocalAudioStats
       * @property {number} bytesSent 已发送字节数
       * @property {number} packetsSent 已发送包数
       */

      /**
       * 本地流音频统计数据Map对象，一个 `userId` 对应一个 `LocalAudioStats`。
       * @typedef {object} LocalAudioStatsMap
       */

      /**
       * 获取当前已发布本地流的音频统计数据
       * <br>
       * 该方法需要在 {@link Client#publish publish()} 后调用。
       *
       * @returns {Promise<LocalAudioStatsMap>} Promise成功返回 `LocalAudioStatsMap`
       * @memberof Client
       * @example
       * client.getLocalAudioStats().then(stats => {
       *   for (let userId in stats) {
       *     console.log('userId: ' + userId +
       *                 ' bytesSent: ' + stats[userId].bytesSent +
       *                 ' packetsSent: ' + stats[userId].packetsSent);
       *   }
       * });
       */

    }, {
      key: "getLocalAudioStats",
      value: function () {
        var _getLocalAudioStats = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11() {
          var statsMap, stats;
          return regeneratorRuntime.wrap(function _callee11$(_context11) {
            while (1) {
              switch (_context11.prev = _context11.next) {
                case 0:
                  statsMap = {};
                  statsMap[this.userId_] = {
                    bytesSent: 0,
                    packetsSent: 0
                  };

                  if (!this.uplinkConnection_) {
                    _context11.next = 7;
                    break;
                  }

                  _context11.next = 5;
                  return this.stats_.getSenderStats(this.uplinkConnection_);

                case 5:
                  stats = _context11.sent;
                  statsMap[this.userId_] = {
                    bytesSent: stats.audio.bytesSent,
                    packetsSent: stats.audio.packetsSent
                  };

                case 7:
                  return _context11.abrupt("return", statsMap);

                case 8:
                case "end":
                  return _context11.stop();
              }
            }
          }, _callee11, this);
        }));

        function getLocalAudioStats() {
          return _getLocalAudioStats.apply(this, arguments);
        }

        return getLocalAudioStats;
      }()
      /**
       * 本地流视频统计数据
       * @typedef {object} LocalVideoStats
       * @property {number} bytesSent 已发送字节数
       * @property {number} packetsSent 已发送包数
       * @property {number} framesEncoded 已编码帧数
       * @property {number} framesSent 已发送帧数
       * @property {number} frameWidth 视频宽度
       * @property {number} frameHeight 视频高度
       */

      /**
       * 本地流视频统计数据Map对象，一个 `userId` 对应一个 `LocalVideoStats`。
       * @typedef {object} LocalVideoStatsMap
       */

      /**
       * 获取当前已发布本地流的视频统计数据
       * <br>
       * 该方法需要在 {@link Client#publish publish()} 后调用。
       *
       * @returns {Promise<LocalVideoStatsMap>} Promise成功返回 `LocalVideoStatsMap`
       * @memberof Client
       * @example
       * client.getLocalVideoStats().then(stats => {
       *   for (let userId in stats) {
       *     console.log('userId: ' + userId +
       *                 'bytesSent: ' + stats[userId].bytesSent +
       *                 'packetsSent: ' + stats[userId].packetsSent +
       *                 'framesEncoded: ' + stats[userId].framesEncoded +
       *                 'framesSent: ' + stats[userId].framesSent +
       *                 'frameWidth: ' + stats[userId].frameWidth +
       *                 'frameHeight: ' + stats[userId].frameHeight);
       *   }
       * });
       */

    }, {
      key: "getLocalVideoStats",
      value: function () {
        var _getLocalVideoStats = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12() {
          var statsMap, stats;
          return regeneratorRuntime.wrap(function _callee12$(_context12) {
            while (1) {
              switch (_context12.prev = _context12.next) {
                case 0:
                  statsMap = {};
                  statsMap[this.userId_] = {
                    bytesSent: 0,
                    packetsSent: 0,
                    framesEncoded: 0,
                    framesSent: 0,
                    frameWidth: 0,
                    frameHeight: 0
                  };

                  if (!this.uplinkConnection_) {
                    _context12.next = 7;
                    break;
                  }

                  _context12.next = 5;
                  return this.stats_.getSenderStats(this.uplinkConnection_);

                case 5:
                  stats = _context12.sent;
                  statsMap[this.userId_] = {
                    bytesSent: stats.video.bytesSent,
                    packetsSent: stats.video.packetsSent,
                    framesEncoded: stats.video.framesEncoded,
                    framesSent: stats.video.framesSent,
                    frameWidth: stats.video.frameWidth,
                    frameHeight: stats.video.frameHeight
                  };

                case 7:
                  return _context12.abrupt("return", statsMap);

                case 8:
                case "end":
                  return _context12.stop();
              }
            }
          }, _callee12, this);
        }));

        function getLocalVideoStats() {
          return _getLocalVideoStats.apply(this, arguments);
        }

        return getLocalVideoStats;
      }()
      /**
       * 远端流音频统计数据
       * @typedef {object} RemoteAudioStats
       * @property {number} bytesReceived 已接收字节数
       * @property {number} packetsReceived 已接收包数
       * @property {number} packetsLost 丢包数
       */

      /**
       * 远端流音频统计数据Map对象，一个 `userId` 对应一个 `RemoteAudioStats`。
       * @typedef {object} RemoteAudioStatsMap
       */

      /**
       * 获取当前所有远端流的音频统计数据
       * <br>
       *
       * @returns {Promise<RemoteAudioStatsMap>} Promise成功返回 `RemoteAudioStatsMap`
       * @memberof Client
       * @example
       * client.getRemoteAudioStats().then(stats => {
       *   for (let userId in stats) {
       *     console.log('userId: ' + userId +
       *                 ' bytesReceived: ' + stats[userId].bytesReceived +
       *                 ' packetsReceived: ' + stats[userId].packetsReceived +
       *                 ' packetsLost: ' + stats[userId].packetsLost);
       *   }
       * });
       */

    }, {
      key: "getRemoteAudioStats",
      value: function () {
        var _getRemoteAudioStats = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13() {
          var statsMap, _iterator3, _step3, _step3$value, key, value, stats;

          return regeneratorRuntime.wrap(function _callee13$(_context13) {
            while (1) {
              switch (_context13.prev = _context13.next) {
                case 0:
                  statsMap = {};
                  _iterator3 = _createForOfIteratorHelper(this.connections_);
                  _context13.prev = 2;

                  _iterator3.s();

                case 4:
                  if ((_step3 = _iterator3.n()).done) {
                    _context13.next = 12;
                    break;
                  }

                  _step3$value = _slicedToArray(_step3.value, 2), key = _step3$value[0], value = _step3$value[1];
                  _context13.next = 8;
                  return this.stats_.getReceiverStats(value);

                case 8:
                  stats = _context13.sent;

                  if (stats.hasAudio) {
                    statsMap[stats.userId] = {
                      bytesReceived: stats.audio.bytesReceived,
                      packetsReceived: stats.audio.packetsReceived,
                      packetsLost: stats.audio.packetsLost,
                      jitter: stats.audio.jitter
                    };
                  }

                case 10:
                  _context13.next = 4;
                  break;

                case 12:
                  _context13.next = 17;
                  break;

                case 14:
                  _context13.prev = 14;
                  _context13.t0 = _context13["catch"](2);

                  _iterator3.e(_context13.t0);

                case 17:
                  _context13.prev = 17;

                  _iterator3.f();

                  return _context13.finish(17);

                case 20:
                  return _context13.abrupt("return", statsMap);

                case 21:
                case "end":
                  return _context13.stop();
              }
            }
          }, _callee13, this, [[2, 14, 17, 20]]);
        }));

        function getRemoteAudioStats() {
          return _getRemoteAudioStats.apply(this, arguments);
        }

        return getRemoteAudioStats;
      }()
      /**
       * 远端视频统计数据
       * @typedef {object} RemoteVideoStats
       * @property {number} bytesReceived 已接收字节数
       * @property {number} packetsReceived 已接收包数
       * @property {number} packetsLost 丢包数
       * @property {number} framesDecoded 已解码帧数
       * @property {number} frameWidth 视频宽度
       * @property {number} frameHeight 视频高度
       */

      /**
       * 远端流视频统计数据Map对象，一个 `userId` 对应一个 `RemoteVideoStats`。
       * @typedef {object} RemoteVideoStatsMap
       */

      /**
       * 获取当前所有远端流的视频统计数据
       *
       * @returns {Promise<RemoteVideoStatsMap>} Promise成功返回 `RemoteVideoStatsMap`
       * @memberof Client
       * @example
       * client.getRemoteVideoStats().then(stats => {
       *   for (let userId in stats) {
       *     console.log('userId: ' + userId +
       *                 ' bytesReceived: ' + stats[userId].bytesReceived +
       *                 ' packetsReceived: ' + stats[userId].packetsReceived +
       *                 ' packetsLost: ' + stats[userId].packetsLost +
       *                 ' framesDecoded: ' + stats[userId].framesDecoded +
       *                 ' frameWidth: ' + stats[userId].frameWidth +
       *                 ' frameHeight: ' + stats[userId].frameHeight);
       *
       *   }
       * });
       */

    }, {
      key: "getRemoteVideoStats",
      value: function () {
        var _getRemoteVideoStats = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14() {
          var statsMap, _iterator4, _step4, _step4$value, key, value, stats;

          return regeneratorRuntime.wrap(function _callee14$(_context14) {
            while (1) {
              switch (_context14.prev = _context14.next) {
                case 0:
                  statsMap = {};
                  _iterator4 = _createForOfIteratorHelper(this.connections_);
                  _context14.prev = 2;

                  _iterator4.s();

                case 4:
                  if ((_step4 = _iterator4.n()).done) {
                    _context14.next = 12;
                    break;
                  }

                  _step4$value = _slicedToArray(_step4.value, 2), key = _step4$value[0], value = _step4$value[1];
                  _context14.next = 8;
                  return this.stats_.getReceiverStats(value);

                case 8:
                  stats = _context14.sent;

                  if (stats.hasVideo) {
                    statsMap[stats.userId] = {
                      bytesReceived: stats.video.bytesReceived,
                      packetsReceived: stats.video.packetsReceived,
                      packetsLost: stats.video.packetsLost,
                      framesDecoded: stats.video.framesDecoded,
                      frameWidth: stats.video.frameWidth,
                      frameHeight: stats.video.frameHeight
                    };
                  }

                case 10:
                  _context14.next = 4;
                  break;

                case 12:
                  _context14.next = 17;
                  break;

                case 14:
                  _context14.prev = 14;
                  _context14.t0 = _context14["catch"](2);

                  _iterator4.e(_context14.t0);

                case 17:
                  _context14.prev = 17;

                  _iterator4.f();

                  return _context14.finish(17);

                case 20:
                  return _context14.abrupt("return", statsMap);

                case 21:
                case "end":
                  return _context14.stop();
              }
            }
          }, _callee14, this, [[2, 14, 17, 20]]);
        }));

        function getRemoteVideoStats() {
          return _getRemoteVideoStats.apply(this, arguments);
        }

        return getRemoteVideoStats;
      }()
      /**
       *
       * @package
       * @returns {string} sdpSemantics
       * @memberof Client
       */

    }, {
      key: "getSdpSemantics",
      value: function getSdpSemantics() {
        return this.sdpSemantics_;
      }
      /**
       *
       * @package
       * @returns {Array.<string>} Ice STUN/TURN servers
       * @memberof Client
       */

    }, {
      key: "getIceServers",
      value: function getIceServers() {
        var iceServers = []; // disable STUN as we exchange iceCandidate through remote sdp offer/answer immediately
        // iceServers.push({ urls: this.signalInfo_.stunServers });

        if (this.turnServer_) {
          iceServers.push(this.turnServer_);
        }

        return iceServers;
      }
      /**
       *
       * @private
       * @memberof Client
       */

    }, {
      key: "startHeartbeat",
      value: function startHeartbeat() {
        if (this.heartbeat_ === -1) {
          var hearbeatInterval = 2000;
          this.log_.info('startHeartbeat...');
          this.heartbeat_ = setInterval(this.doHeartbeat.bind(this), hearbeatInterval);
        }
      }
      /**
       *
       * @private
       * @memberof Client
       */

    }, {
      key: "stopHeartbeat",
      value: function stopHeartbeat() {
        if (this.heartbeat_ !== -1) {
          this.log_.info('stopHeartbeat');
          clearInterval(this.heartbeat_);
          this.heartbeat_ = -1;
        }
      }
      /**
       *
       * @private
       * @memberof Client
       */

    }, {
      key: "doHeartbeat",
      value: function () {
        var _doHeartbeat = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee15() {
          var stats, eventList, report, micStatus, audioTracks;
          return regeneratorRuntime.wrap(function _callee15$(_context15) {
            while (1) {
              switch (_context15.prev = _context15.next) {
                case 0:
                  _context15.next = 2;
                  return this.stats_.getStatsReport(this.uplinkConnection_, this.connections_);

                case 2:
                  stats = _context15.sent;
                  // send event only when the signal channel is connected.
                  eventList = this.signalChannel_.isConnected() ? getEvents(this.userId_) : [];
                  report = {
                    WebRTCQualityReq: stats,
                    eventList: eventList,
                    sdkAppId: this.sdkAppId_,
                    tinyid: this.tinyId_,
                    roomid: this.roomId_,
                    socketid: this.signalInfo_.socketId,
                    clientip: this.signalInfo_.localIp,
                    serverip: this.signalInfo_.relayIp,
                    cpunumber: navigator.hardwareConcurrency || 0,
                    cpudevice: navigator.platform,
                    devicename: navigator.platform,
                    ostype: navigator.platform
                  };
                  micStatus = 0;

                  if (this.localStream_ && this.localStream_.getMediaStream()) {
                    audioTracks = this.localStream_.getMediaStream().getAudioTracks();

                    if (audioTracks.length > 0 && audioTracks[0].muted) {
                      micStatus = 3;
                    } else {
                      micStatus = 1;
                    }
                  }

                  report.WebRTCQualityReq.AudioReportState.uint32_microphone_status = micStatus;
                  this.signalChannel_.send(SignalCommand.ON_QUALITY_REPORT, report);

                case 9:
                case "end":
                  return _context15.stop();
              }
            }
          }, _callee15, this);
        }));

        function doHeartbeat() {
          return _doHeartbeat.apply(this, arguments);
        }

        return doHeartbeat;
      }()
      /**
       *
       * @private
       * @param {object} data
       * @memberof Client
       */

    }, {
      key: "onPeerJoin",
      value: function onPeerJoin(data) {
        var _this11 = this;

        var content = data.content;
        var userId = content.srcopenid;
        var tinyId = content.srctinyid;
        var sdp = content.remoteoffer; // remote may send duplicated peer-join if the previous connection is on-going and
        // a SignalChannel reconnection was requested.

        var prev = this.connections_.get(tinyId);

        if (prev) {
          this.log_.warn('duplicated peer-join observed, rebuild the connection');
          this.log_.info("remote peer [".concat(userId, "] is leaving"));
          this.emitter_.emit(ClientEvent.PEER_LEAVE, {
            userId: userId
          });
          prev.close();
          this.connections_["delete"](tinyId);
        } // clean up the pending timeout if any


        var timeout = this.pendingRefresh_.get(tinyId);

        if (timeout) {
          clearTimeout(timeout);
          this.pendingRefresh_["delete"](tinyId);
        }

        this.log_.info("remote peer [".concat(userId, "] is online")); // fire the peer-join event to let app determine whether it wants to block this user or not

        this.emitter_.emit(ClientEvent.PEER_JOIN, {
          userId: userId
        });
        var connection = new Connection({
          userId: userId,
          tinyId: tinyId,
          client: this,
          isUplink: false,
          signalChannel: this.signalChannel_
        });
        this.connections_.set(tinyId, connection);
        connection.initialize();
        connection.setRemoteOffer(sdp);
        connection.on(ConnectionEvent.STREAM_ADDED, function (event) {
          _this11.emitter_.emit(ClientEvent.STREAM_ADDED, {
            stream: event.stream
          });
        });
        connection.on(ConnectionEvent.STREAM_REMOVED, function (event) {
          _this11.emitter_.emit(ClientEvent.STREAM_REMOVED, {
            stream: event.stream
          });
        });
        connection.on(ConnectionEvent.STREAM_UPDATED, function (event) {
          _this11.emitter_.emit(ClientEvent.STREAM_UPDATED, {
            stream: event.stream
          });
        });
        connection.on(ConnectionEvent.STREAM_SUBSCRIBED, function (event) {
          _this11.emitter_.emit(ClientEvent.STREAM_SUBSCRIBED, {
            stream: event.stream
          });
        });
        connection.on(ConnectionEvent.ERROR, function (error) {
          var errorCode = error.getCode();

          var refreshCount = _this11.connectionsRefreshCount_.get(tinyId);

          if (errorCode === ErrorCode.ICE_TRANSPORT_ERROR && refreshCount < 5) {
            refreshCount += 1;

            _this11.connectionsRefreshCount_.set(tinyId, refreshCount);

            _this11.log_.warn("try to refresh remote peer [".concat(userId, "]"));

            var _data = {
              srctinyid: tinyId
            }; // try to refresh peer so that remote will send a new CreatePeerConnection
            // request for this remote user to re-establish the connection.

            _this11.signalChannel_.send(SignalCommand.REFRESH_PEER, _data); // schedule a timeout to check if remote refresh can be completed in 10s


            var timeout = _this11.pendingRefresh_.get(tinyId);

            if (timeout) {
              clearTimeout(timeout);
            }

            var that = _this11;
            timeout = setTimeout(function () {
              _this11.log_.warn("refresh remote peer timeout observed");

              that.emitter_.emit(ClientEvent.ERROR, error);
            }, 10000);

            _this11.pendingRefresh_.set(tinyId, timeout);

            return;
          }

          _this11.emitter_.emit(ClientEvent.ERROR, error);
        });
        connection.on(ConnectionEvent.CONNECTION_STATE_CHANGED, function (event) {
          if (event.state === 'connected') {
            // reset the refresh count in case this connection is re-established for the refresh
            _this11.connectionsRefreshCount_.set(tinyId, 0);
          }
        });
      }
      /**
       *
       * @private
       * @param {object} data
       * @memberof Client
       */

    }, {
      key: "onPeerLeave",
      value: function onPeerLeave(data) {
        var content = data.content;
        var tinyId = content.srctinyid;
        var userId = content.srcopenid;
        var connection = this.connections_.get(tinyId);

        if (connection) {
          // WA: remote server doesn't send the srcopenid
          if (userId === undefined) {
            userId = connection.getUserId();
          }

          this.log_.info("remote peer [".concat(userId, "] is leaving"));
          this.emitter_.emit(ClientEvent.PEER_LEAVE, {
            userId: userId
          });
          connection.close();
          this.connections_["delete"](tinyId);
          this.connectionsRefreshCount_["delete"](tinyId);
        }
      }
      /**
       *
       * @private
       * @memberof Client
       */

    }, {
      key: "onUpdateRemoteMuteStat",
      value: function onUpdateRemoteMuteStat(data) {
        var _this12 = this;

        var content = data.content; // TODO
        // data = {
        //     userlist:[
        //         {
        //             srctinyid,
        //             userid,
        //             // bit0: 大视频
        //             // bit1: 小视频 unused
        //             // bit2: 辅路，屏幕分享
        //             // bit3: 音频
        //             // bit4: 大视频mute状态
        //             // bit5: 辅路mute状态
        //             // bit6: 音频mute状态
        //             flag,
        //         },
        //         {},
        //     ]
        // }

        var VIDEO_STAT_BIT = 0x01;
        var AUDIO_STAT_BIT = 0x08;
        var AUDIO_MUTE_BIT = 0x40;
        var VIDEO_MUTE_BIT = 0x10;
        content.userlist.forEach(function (item) {
          var tinyId = item.srctinyid;
          var userId = item.userid; // skip my stats

          if (tinyId === 0 || tinyId === _this12.tinyId_) return; // the remote user had been left the room, skip it.

          if (!_this12.connections_.get(tinyId)) {
            // also make sure remove its stats
            _this12.mutedStates_["delete"](tinyId);

            return;
          }

          var hasVideo = !!(item.flag & VIDEO_STAT_BIT);
          var hasAudio = !!(item.flag & AUDIO_STAT_BIT);
          var audioMuted = !!(item.flag & AUDIO_MUTE_BIT);
          var videoMuted = !!(item.flag & VIDEO_MUTE_BIT);

          var state = _this12.mutedStates_.get(tinyId);

          if (state === undefined) {
            // hit the user at the first time
            _this12.mutedStates_.set(tinyId, {
              hasAudio: hasAudio,
              hasVideo: hasVideo,
              audioMuted: audioMuted,
              videoMuted: videoMuted
            });

            if (hasVideo) {
              if (videoMuted) {
                _this12.emitter_.emit(ClientEvent.MUTE_VIDEO, {
                  userId: userId
                });
              } else {
                _this12.emitter_.emit(ClientEvent.UNMUTE_VIDEO, {
                  userId: userId
                });
              }
            }

            if (hasAudio) {
              if (audioMuted) {
                _this12.emitter_.emit(ClientEvent.MUTE_AUDIO, {
                  userId: userId
                });
              } else {
                _this12.emitter_.emit(ClientEvent.UNMUTE_AUDIO, {
                  userId: userId
                });
              }
            }

            return;
          } else {
            if (hasAudio && state.audioMuted !== audioMuted) {
              if (audioMuted) {
                _this12.emitter_.emit(ClientEvent.MUTE_AUDIO, {
                  userId: userId
                });
              } else {
                _this12.emitter_.emit(ClientEvent.UNMUTE_AUDIO, {
                  userId: userId
                });
              }
            }

            var prevVideoAvailable = !state.videoMuted && state.hasVideo;
            var videoAvailable = !videoMuted && hasVideo;

            if (prevVideoAvailable !== videoAvailable) {
              if (!videoAvailable) {
                _this12.emitter_.emit(ClientEvent.MUTE_VIDEO, {
                  userId: userId
                });
              } else {
                _this12.emitter_.emit(ClientEvent.UNMUTE_VIDEO, {
                  userId: userId
                });
              }
            } // update the state


            _this12.mutedStates_.set(tinyId, {
              hasAudio: hasAudio,
              hasVideo: hasVideo,
              audioMuted: audioMuted,
              videoMuted: videoMuted
            });
          }
        });
      }
      /**
       *
       * @private
       * @memberof Client
       */

    }, {
      key: "onClientBanned",
      value: function onClientBanned(reason) {
        this.emitter_.emit(ClientEvent.CLIENT_BANNED, new RtcError({
          code: ErrorCode.CLIENT_BANNED,
          message: 'client was banned because of ' + reason
        }));
      }
    }, {
      key: "triggerReconnectForTest",
      value: function triggerReconnectForTest(code) {
        var data = {
          exitcode: code
        };
        this.log_.warn('triggerReconnectForTest exitcode: ' + code);
        this.signalChannel_.send(SignalCommand.TEST_WEBSOCKET, data);
      }
    }, {
      key: "setBandwidthForTest",
      value: function setBandwidthForTest(bandwidth) {
        if (this.uplinkConnection_) {
          this.uplinkConnection_.setBandwidth(bandwidth);
        }
      }
    }]);

    return Client;
  }();

  var getUserMedia = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(options) {
      var constraints;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (navigator.mediaDevices) {
                _context.next = 3;
                break;
              }

              logger.error('navigator.mediaDevices is undefined');
              return _context.abrupt("return");

            case 3:
              constraints = buildConstraints(options);
              logger.info('getUserMedia with contraints: ' + JSON.stringify(constraints));
              _context.next = 7;
              return navigator.mediaDevices.getUserMedia(constraints);

            case 7:
              return _context.abrupt("return", _context.sent);

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function getUserMedia(_x) {
      return _ref.apply(this, arguments);
    };
  }();

  function buildConstraints(options) {
    var audioConstraints = {};

    if (!options.audio) {
      audioConstraints = false;
    } else if (typeof options.microphoneId !== 'undefined') {
      audioConstraints = {
        deviceId: {
          exact: options.microphoneId
        },
        sampleRate: options.sampleRate,
        channelCount: options.channelCount
      };
    } else {
      audioConstraints = {
        sampleRate: options.sampleRate,
        channelCount: options.channelCount
      };
    }

    var videoConstraints = {};

    if (typeof options.facingMode !== 'undefined' && options.video) {
      videoConstraints = {
        facingMode: options.facingMode,
        width: options.width,
        height: options.height,
        frameRate: options.frameRate
      };
    } else if (typeof options.cameraId !== 'undefined' && options.video) {
      videoConstraints = {
        deviceId: {
          exact: options.cameraId
        },
        width: options.width,
        height: options.height,
        frameRate: options.frameRate
      };
    } else {
      if (!options.video) {
        videoConstraints = false;
      } else {
        if (typeof options.width !== 'undefined') {
          videoConstraints = {
            width: options.width,
            height: options.height,
            frameRate: options.frameRate
          };
        } else {
          videoConstraints = true;
        }
      }
    }

    return {
      audio: audioConstraints,
      video: videoConstraints
    };
  }

  var getDisplayMedia = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(options) {
      var audioStream, constraints, screenConstraints, captureStream;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (navigator.mediaDevices) {
                _context.next = 3;
                break;
              }

              logger.error('navigator.mediaDevices is undefined');
              return _context.abrupt("return");

            case 3:
              audioStream = null;

              if (!options.audio) {
                _context.next = 10;
                break;
              }

              constraints = buildConstraints$1(options);
              logger.info('getUserMedia with constraints: ' + JSON.stringify(constraints));
              _context.next = 9;
              return navigator.mediaDevices.getUserMedia(constraints);

            case 9:
              audioStream = _context.sent;

            case 10:
              screenConstraints = buildScreenConstraints(options);
              logger.info('getDisplayMedia with contraints: ' + JSON.stringify(screenConstraints));
              _context.next = 14;
              return navigator.mediaDevices.getDisplayMedia(screenConstraints);

            case 14:
              captureStream = _context.sent;

              if (audioStream) {
                captureStream.addTrack(audioStream.getAudioTracks()[0]);
              }

              return _context.abrupt("return", captureStream);

            case 17:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function getDisplayMedia(_x) {
      return _ref.apply(this, arguments);
    };
  }();

  function buildConstraints$1(options) {
    var audioConstraints = {};

    if (typeof options.microphoneId !== 'undefined') {
      audioConstraints = {
        deviceId: {
          exact: options.microphoneId
        },
        sampleRate: options.sampleRate,
        channelCount: options.channelCount
      };
    } else {
      audioConstraints = {
        sampleRate: options.sampleRate,
        channelCount: options.channelCount
      };
    }

    return {
      audio: audioConstraints,
      video: false
    };
  }

  function buildScreenConstraints(options) {
    var videoConstraints = {
      width: options.width,
      height: options.height,
      frameRate: options.frameRate
    };

    if (typeof options.screenSource !== 'undefined') {
      videoConstraints.displaySurface = options.screenSource;
    }

    return {
      video: videoConstraints
    };
  }

  var videoProfileMap = new Map();
  /*
   * | 视频Profile | 分辨率（宽 x 高）| 帧率（fps）| 码率（kbps）|
   * | :---       | :---           | :---      | :---      |
   * | 120p       | 160 x 120      | 15        | 200        |
   * | 180p       | 320 x 180      | 15        | 350        |
   * | 240p       | 320 x 240      | 15        | 400       |
   * | 360p       | 640 x 360      | 15        | 800       |
   * | 480p       | 640 x 480      | 15        | 900       |
   * | 720p       | 1280 x 720     | 15        | 1500      |
   * | 1080p      | 1920 x 1080    | 15        | 2000      |
   * | 1440p      | 2560 x 1440    | 30        | 4860      |
   * | 4K         | 3840 x 2160    | 30        | 9000      |
   */

  videoProfileMap.set('120p', {
    width: 160,
    height: 120,
    frameRate: 15,
    bitrate: 200
  });
  videoProfileMap.set('180p', {
    width: 320,
    height: 180,
    frameRate: 15,
    bitrate: 350
  });
  videoProfileMap.set('240p', {
    width: 320,
    height: 240,
    frameRate: 15,
    bitrate: 400
  });
  videoProfileMap.set('360p', {
    width: 640,
    height: 360,
    frameRate: 15,
    bitrate: 800
  });
  videoProfileMap.set('480p', {
    width: 640,
    height: 480,
    frameRate: 15,
    bitrate: 900
  });
  videoProfileMap.set('720p', {
    width: 1280,
    height: 720,
    frameRate: 15,
    bitrate: 1500
  });
  videoProfileMap.set('1080p', {
    width: 1920,
    height: 1080,
    frameRate: 15,
    bitrate: 2000
  });
  videoProfileMap.set('1440p', {
    width: 2560,
    height: 1440,
    frameRate: 30,
    bitrate: 4860
  });
  videoProfileMap.set('4K', {
    width: 3840,
    height: 2160,
    frameRate: 30,
    bitrate: 9000
  });
  var screenProfileMap = new Map();
  screenProfileMap.set('480p', {
    width: 640,
    height: 480,
    frameRate: 5,
    bitrate: 900
  });
  screenProfileMap.set('480p_2', {
    width: 640,
    height: 480,
    frameRate: 30,
    bitrate: 1000
  });
  screenProfileMap.set('720p', {
    width: 1280,
    height: 720,
    frameRate: 5,
    bitrate: 1200
  });
  screenProfileMap.set('720p_2', {
    width: 1280,
    height: 720,
    frameRate: 30,
    bitrate: 3000
  });
  screenProfileMap.set('1080p', {
    width: 1920,
    height: 1080,
    frameRate: 5,
    bitrate: 1600
  });
  videoProfileMap.set('1080p_2', {
    width: 1920,
    height: 1080,
    frameRate: 30,
    bitrate: 4000
  });

  var audioProfileMap = new Map(); // the recommended profiles for audio
  // for compatibility concern currently we should allow one channel only

  audioProfileMap.set('standard', {
    sampleRate: 48000,
    channelCount: 1,
    bitrate: 40
  }); // audioProfileMap.set('standard-stereo', { sampleRate: 48000, channelCount: 2, bitrate: 64 });

  audioProfileMap.set('high', {
    sampleRate: 48000,
    channelCount: 1,
    bitrate: 128
  }); // audioProfileMap.set('high-stereo', { sampleRate: 48000, channelCount: 2, bitrate: 192 });

  /**
   * LocalStream 本地音视频流，通过 {@link TRTC.createStream createStream()} 创建。
   *
   * @class LocalStream
   * @extends {Stream}
   */

  var LocalStream = /*#__PURE__*/function (_Stream) {
    _inherits(LocalStream, _Stream);

    var _super = _createSuper(LocalStream);

    function LocalStream(options) {
      var _this;

      _classCallCheck(this, LocalStream);

      var extra = {
        isRemote: false,
        type: 'local'
      };

      var opt = _objectSpread2(_objectSpread2({}, options), extra);

      if (options.screen) {
        // mirror is invalid in screenshare
        opt.mirror = false;
      }

      _this = _super.call(this, opt); // local stream creation properties

      _this.video_ = options.video;
      _this.audio_ = options.audio; // optional parameters for specified deviceId

      _this.cameraId_ = options.cameraId;
      _this.facingMode_ = options.facingMode;
      _this.microphoneId_ = options.microphoneId; // Audio/Video tracks (MediaStreamTrack) are provided by app

      _this.videoSource_ = options.videoSource;
      _this.audioSource_ = options.audioSource; // whether want screen share or not

      _this.screen_ = options.screen;
      _this.screenSource_ = options.screenSource;
      _this.audioProfile_ = {
        sampleRate: 48000,
        channelCount: 1,
        bitrate: 40 // kbps

      }; // video profile for local stream

      _this.videoProfile_ = {
        // parameters for getUserMedia
        width: 640,
        height: 480,
        frameRate: 15,
        bitrate: 900
      }; // video profile for screen sharing

      _this.screenProfile_ = {
        width: 1920,
        height: 1080,
        frameRate: 5,
        bitrate: 1600
      };
      _this.videoBitrate_ = _this.screen_ ? 1600 : 900; // kbps

      return _this;
    }
    /**
     * 初始化本地音视频流对象<br>
     * <br>
     * 错误信息：
     * 
     * | 错误名                   | 描述                                                         | 处理建议                                                     |
     * | ------------------------ | ------------------------------------------------------------ | ------------------------------------------------------------ |
     * | **NotFoundError**        | 找不到满足请求参数的媒体类型（包括：音频、视频、屏幕分享）。例如：PC 没有摄像头，但是请求浏览器获取视频流，则会报此错误。 | 建议在通话开始前引导用户检查通话所需的摄像头或麦克风等外设，若没有摄像头且需要进行语音通话，可在 `TRTC.createStream({ audio: true, video: false })` 指明仅采集麦克风。   |
     * | **NotAllowedError**      | 用户拒绝了当前的浏览器实例的访问音频、视频、屏幕分享请求。   | 提示用户不授权摄像头/麦克风访问无法进行音视频通话                                           |
     * | **NotReadableError**     | 尽管用户已经授权使用相应的设备，但是由于操作系统上某个硬件、浏览器或者网页层面发生的错误导致设备无法被访问。 | 根据浏览器的报错信息处理，并提示用户：<br />**“暂时无法访问摄像头/麦克风，请确保当前没有其他应用请求访问摄像头/麦克风，并重试”** |
     * | **OverConstrainedError** | cameraId/microphoneId 参数的值无效                           | 确保 cameraId/microphoneId 传值正确且有效                    |
     * | **AbortError**           | 由于某些未知原因导致设备无法被使用                           |                                                              |
     * 
     * 参考：[getUserMedia 异常](<https://developer.mozilla.org/zh-CN/docs/Web/API/MediaDevices/getUserMedia#异常>) 和 [getDisplayMedia 异常](<https://developer.mozilla.org/zh-CN/docs/Web/API/MediaDevices/getDisplayMedia#异常>)
     * @example
     * // 例如：处理 NotReadableError 错误
     * localStream.initialize().then(() => {
     *   // 本地流初始化成功，发布本地流
     *   client.publish(localStream).then(() => {
     *   // 本地流发布成功
     *   })
     * }).catch((error) => {
     *   // 本地流初始化失败
     *    switch (error.name) {
     *      case 'NotReadableError':
     *        // 提示用户：暂时无法访问摄像头/麦克风，请确保当前没有其他应用请求访问摄像头/麦克风，并重试。
     *        break;
     *      default:
     *        console.error(error);
     *        break;
     *    }
     * })
     * @returns {Promise}
     * @memberof LocalStream
     */


    _createClass(LocalStream, [{
      key: "initialize",
      value: function initialize() {
        var _this2 = this;

        return new Promise(function (resolve, reject) {
          if (typeof _this2.audio_ !== 'undefined') {
            if (_this2.screen_) {
              _this2.log_.info('initialize stream audio: ' + _this2.audio_ + ' screen: ' + _this2.screen_);

              getDisplayMedia({
                audio: _this2.audio_,
                microphoneId: _this2.microphoneId_,
                screenSource: _this2.screenSource_,
                width: _this2.screenProfile_.width,
                height: _this2.screenProfile_.height,
                frameRate: _this2.screenProfile_.frameRate,
                sampleRate: _this2.audioProfile_.sampleRate,
                channelCount: _this2.audioProfile_.channelCount
              })["catch"](function (error) {
                logEvent({
                  eventType: 'stream-initialize',
                  kind: 'getDisplayMedia',
                  result: 'failed'
                });

                _this2.log_.error('getDisplayMedia error observed ' + error);

                reject(error);
              }).then(function (stream) {
                _this2.setMediaStream(stream);

                _this2.setHasAudio(_this2.audio_);

                _this2.setHasVideo(true);

                _this2.listenForScreenSharingStopped(_this2.getVideoTrack()); // set default content hint for screencast


                _this2.setVideoContentHint('detail');

                logEvent({
                  eventType: 'stream-initialize',
                  kind: 'getDisplayMedia',
                  result: 'success'
                });
                return resolve();
              });
            } else {
              _this2.log_.info('initialize stream audio: ' + _this2.audio_ + ' video: ' + _this2.video_);

              getUserMedia({
                audio: _this2.audio_,
                video: _this2.video_,
                facingMode: _this2.facingMode_,
                cameraId: _this2.cameraId_,
                microphoneId: _this2.microphoneId_,
                width: _this2.videoProfile_.width,
                height: _this2.videoProfile_.height,
                frameRate: _this2.videoProfile_.frameRate,
                sampleRate: _this2.audioProfile_.sampleRate,
                channelCount: _this2.audioProfile_.channelCount
              })["catch"](function (error) {
                logEvent({
                  eventType: 'stream-initialize',
                  kind: 'getUserMedia',
                  result: 'failed'
                });

                _this2.log_.error('getUserMedia error observed ' + error); // FIXME: detailed error report?


                reject(error);
              }).then(function (stream) {
                _this2.setMediaStream(stream);

                _this2.setHasAudio(_this2.audio_);

                _this2.setHasVideo(_this2.video_);

                _this2.log_.debug('gotStream hasAudio: ' + _this2.hasAudio_ + ' hasVideo: ' + _this2.hasVideo_);

                logEvent({
                  eventType: 'stream-initialize',
                  kind: 'getUserMedia',
                  result: 'success'
                });
                return resolve();
              });
            }
          } else {
            var stream = new MediaStream();

            if (typeof _this2.audioSource_ !== 'undefined') {
              stream.addTrack(_this2.audioSource_);

              _this2.setHasAudio(true);
            }

            if (typeof _this2.videoSource_ !== 'undefined') {
              stream.addTrack(_this2.videoSource_);

              _this2.setHasVideo(true);
            }

            _this2.setMediaStream(stream);

            logEvent({
              eventType: 'stream-initialize',
              kind: 'custom',
              result: 'success'
            });
            return resolve();
          }
        });
      }
    }, {
      key: "listenForScreenSharingStopped",
      value: function listenForScreenSharingStopped(track) {
        var _this3 = this;

        // listen for track's ended event
        track.addEventListener('ended', function (event) {
          _this3.log_.info('screensharing was stopped because the video track is ended');

          _this3.emitter_.emit(StreamEvent.SCREEN_SHARING_STOPPED);
        });
      }
      /**
       * @override
       * @memberof LocalStream
       */

    }, {
      key: "muteAudio",
      value: function muteAudio() {
        var result = _get(_getPrototypeOf(LocalStream.prototype), "muteAudio", this).call(this);

        if (result) {
          this.log_.info('localStream mute audio');
          var connection = this.getConnection();

          if (connection) {
            connection.setMutedState('audio', true);
            var uid = connection.getUserId();
            var tid = connection.getTinyId();
            addEvent(uid, {
              eventId: EventId.MUTE_AUDIO,
              eventDesc: 'mute local audio track',
              timestamp: getCurrentTime(),
              userId: uid,
              tinyId: tid
            });
          }
        }

        return result;
      }
      /**
       * @override
       * @memberof LocalStream
       */

    }, {
      key: "muteVideo",
      value: function muteVideo() {
        this.log_.info('localStream mute video');

        var result = _get(_getPrototypeOf(LocalStream.prototype), "muteVideo", this).call(this); // always set muted state for video even if there's no video track in place
        // this is used to simulate a mute


        if (result) {
          var connection = this.getConnection();

          if (connection) {
            connection.setMutedState('video', true);
            var uid = connection.getUserId();
            var tid = connection.getTinyId();
            addEvent(uid, {
              eventId: EventId.MUTE_VIDEO,
              eventDesc: 'mute local video track',
              timestamp: getCurrentTime(),
              userId: uid,
              tinyId: tid
            });
          }
        }

        return result;
      }
      /**
       * @override
       * @memberof LocalStream
       */

    }, {
      key: "unmuteAudio",
      value: function unmuteAudio() {
        var result = _get(_getPrototypeOf(LocalStream.prototype), "unmuteAudio", this).call(this);

        if (result) {
          this.log_.info('localStream unmute audio');
          var connection = this.getConnection();

          if (connection) {
            connection.setMutedState('audio', false);
            var uid = connection.getUserId();
            var tid = connection.getTinyId();
            addEvent(uid, {
              eventId: EventId.UNMUTE_AUDIO,
              eventDesc: 'unmute local audio track',
              timestamp: getCurrentTime(),
              userId: uid,
              tinyId: tid
            });
          }
        }

        return result;
      }
      /**
       * @override
       * @memberof LocalStream
       */

    }, {
      key: "unmuteVideo",
      value: function unmuteVideo() {
        this.log_.info('localStream unmute video');

        var result = _get(_getPrototypeOf(LocalStream.prototype), "unmuteVideo", this).call(this);

        if (result) {
          var connection = this.getConnection();

          if (connection) {
            connection.setMutedState('video', false);
            var uid = connection.getUserId();
            var tid = connection.getTinyId();
            addEvent(uid, {
              eventId: EventId.UNMUTE_VIDEO,
              eventDesc: 'unmute local video track',
              timestamp: getCurrentTime(),
              userId: uid,
              tinyId: tid
            });
          }
        }

        return result;
      }
      /**
       * 设置音频 Profile
       * <br>
       * 该方法需要在调用 {@link LocalStream#initialize initialize()} 之前调用。
       *
       * @param {string} profile 音频 Profile
       * | 音频 Profile | 采样率 | 声道 | 码率 (kbps) |
       * | :---        | :---  | :--- | :---       |
       * | standard    | 48000 | 单声道| 40         |
       * | high        | 48000 | 单声道| 128        |
       * 默认使用 `standard`。
       *
       * @memberof LocalStream
       * @example
       * localStream.setAudioProfile('high');
       * localStream.initialize().then(() => {
       *   // localStream was initialized success
       * });
       */

    }, {
      key: "setAudioProfile",
      value: function setAudioProfile(profile) {
        var p;

        if (_typeof(profile) === 'object') {
          p = profile;
        } else {
          p = audioProfileMap.get(profile);

          if (p === undefined) {
            p = audioProfileMap.get('standard');
          }
        }

        this.log_.info('setAudioProfile: ' + JSON.stringify(p));
        this.audioProfile_ = p;
      }
      /**
       * 设置视频 Profile<br>
       * <br>
       * 该方法需要在调用 {@link LocalStream#initialize initialize()} 之前调用。
       *
       * @param {string|object} profile 视频 Profile
       * | 视频 Profile | 分辨率（宽 x 高）| 帧率（fps）| 码率（kbps）|
       * | :---       | :---           | :---      | :---      |
       * | 120p       | 160 x 120      | 15        | 200        |
       * | 180p       | 320 x 180      | 15        | 350       |
       * | 240p       | 320 x 240      | 15        | 400       |
       * | 360p       | 640 x 360      | 15        | 800       |
       * | 480p       | 640 x 480      | 15        | 900       |
       * | 720p       | 1280 x 720     | 15        | 1500      |
       * | 1080p      | 1920 x 1080    | 15        | 2000      |
       * | 1440p      | 2560 x 1440    | 30        | 4860      |
       * | 4K         | 3840 x 2160    | 30        | 9000      |
       * - 由于设备和浏览器的限制，视频分辨率不一定能够完全匹配，在这种情况下，浏览器会自动调整分辨率使其接近 Profile 对应的分辨率。
       * - 如果以上视频 Profile 不符合您的要求，您可以设置自定义 Profile。
       * - 默认使用 `480p`。
       * @memberof LocalStream
       * @example
       * // 使用预定义Profile设置
       * localStream.setVideoProfile('480p');
       * localStream.initialize().then(() => {
       *   // local stream was initialized successfully.
       * });
       *
       * // 使用自定义视频Profile设置
       * localStream.setVideoProfile({
       *   width: 360, // 视频宽度
       *   height: 360, // 视频高度
       *   frameRate: 10, // 帧率
       *   bitrate: 400 // 比特率 kbps
       * });
       * localStream.initialize().then(() => {
       *   // local stream was initialized successfully.
       * });
       */

    }, {
      key: "setVideoProfile",
      value: function setVideoProfile(profile) {
        var p;

        if (_typeof(profile) === 'object') {
          p = profile;
        } else {
          p = videoProfileMap.get(profile);

          if (p === undefined) {
            p = videoProfileMap.get('480p');
          }
        }

        this.log_.info('setVideoProfile ' + JSON.stringify(p));
        this.videoProfile_ = p;
        this.videoBitrate_ = p.bitrate;
      }
    }, {
      key: "getVideoBitrate",
      value: function getVideoBitrate() {
        return this.videoBitrate_;
      }
    }, {
      key: "getAudioBitrate",
      value: function getAudioBitrate() {
        return this.audioProfile_.bitrate;
      }
      /**
       * 设置屏幕分享 Profile<br>
       * <br>
       * 该方法需要在调用 {@link LocalStream#initialize initialize()} 之前调用。
       *
       * @param {string} profile screen profile
       * | 屏幕 Profile | 分辨率（宽 x 高）| 帧率（fps）| 码率 (kbps) |
       * | :---       | :---           | :---      | :---        |
       * | 480p       | 640 x 480      | 5         | 900         |
       * | 480p_2     | 640 x 480      | 30        | 1000        |
       * | 720p       | 1280 x 720     | 5         | 1200        |
       * | 720p_2     | 1280 x 720     | 30        | 3000        |
       * | 1080p      | 1920 x 1080    | 5         | 1600        |
       * | 1080p_2    | 1920 x 1080    | 30        | 4000        |
       * - 屏幕分享默认使用 `1080p`。
       * - 若以上 Profile 不能满足您的业务需求，您也可以指定自定义的分辨率、帧率和码率。
       * @memberof LocalStream
       * @example
       * // 指定 Profile
       * localStream.setScreenProfile('1080p');
       * localStream.initialize().then(() => {
       *   // local stream was initialized successfully
       * });
       *
       * // 指定自定义分辨率、帧率和码率
       * localStream.setScreenProfile({ width: 1920, height: 1080, frameRate: 5, bitrate: 1600 });
       * localStream.initialize().then(() => {
       *   // local stream was initialized successfully
       * });
       */

    }, {
      key: "setScreenProfile",
      value: function setScreenProfile(profile) {
        var p = profile;

        if (_typeof(profile) !== 'object') {
          p = screenProfileMap.get(profile);

          if (p === undefined) {
            p = screenProfileMap.get('1080p');
          }
        }

        this.log_.info('setScreenProfile ' + JSON.stringify(profile));
        this.screenProfile_ = p;
        this.videoBitrate_ = p.bitrate;
      } // package

    }, {
      key: "getVideoProfile",
      value: function getVideoProfile() {
        return this.screen_ ? this.screenProfile_ : this.videoProfile_;
      }
    }, {
      key: "getAudioProfile",
      value: function getAudioProfile() {
        return this.audioProfile_;
      }
      /**
       * 设置视频内容提示，主要用于提升在不同场景下的视频编码质量。
       * <br>
       * 该方法需要在调用 {@link LocalStream#initialize initialize()} 成功之后调用。
       * @param {string} hint 内容提示，参考 {@link https://www.w3.org/TR/mst-content-hint/ MediaStreamTrack.contentHint}
       * - 'motion'：本地流视频内容为从摄像头采集的内容、电影或者视频游戏等。
       * - 'detail'：本地视频内容为 ppt、带有文本内容、绘画或艺术线条的网页。一般屏幕分享默认使用这个提示。
       * - 'text'：本地视频内容主要是含有文本的 ppt 或网页等。
       * @memberof LocalStream
       * @example
       * const localStream = TRTC.createStream({ audio: false, screen: true });
       * localStream.initialize().then(() => {
       *   // 若当前屏幕分享的主要内容是一般网页
       *   localStream.setVideoContentHint('detail');
       *
       *   // 若当前屏幕分享的主要内容中含有大量的文字
       *   // localStream.setVideoContentHint('text');
       *
       *   client.publish(localStream);
       * });
       */

    }, {
      key: "setVideoContentHint",
      value: function setVideoContentHint(hint) {
        var videoTrack = this.getVideoTrack();

        if (videoTrack && 'contentHint' in videoTrack) {
          this.log_.info('set video track contentHint to: ' + hint);
          videoTrack.contentHint = hint;

          if (videoTrack.contentHint !== hint) {
            this.log_.warn('Invalid video track contentHint: ' + hint);
          }
        }
      }
      /**
       * 切换媒体输入设备<br>
       * <br>
       * 调用该方法可更换本地流的媒体输入设备：
       * - 音频输入设备，如麦克风。
       * - 视频输入设备，如摄像头。
       *
       * <br>
       * 注意：该方法仅适用于从摄像头和麦克风采集音视频的本地流。即：屏幕分享流不支持调用该接口<br>
       * <br>
       * 若该本地流已经被发布，该方法会自动更新发往远端的音视频流，此时，远端会收到 `Client.on('stream-updated')` 事件通知。
       *
       * @param {string} type 媒体类型
       * - ‘audio’ 音频
       * - ‘video’ 视频
       * @param {string} deviceId 设备标识
       * - 摄像头设备标识通过 {@link TRTC.getCameras getCameras()} 获取。<br>
       * 在移动设备上，可以通过设置 deviceId 为 'user' 和 'environment' 来切换前置和后置摄像头。
       * - 麦克风设备标识通过 {@link TRTC.getMicrophones getMicrophones()} 获取。
       *
       * @returns {Promise}
       * @memberof LocalStream
       * @example
       * // ...
       * // 发布本地流
       * client.publish(localStream);
       *
       * // ...
       *
       * TRTC.getCameras().then(devices => {
       *   // 切换camera设备
       *   localStream.switchDevice('video', devices[0].deviceId).then(() => {
       *     // camera切换成功
       *   });
       * });
       *
       */

    }, {
      key: "switchDevice",
      value: function () {
        var _switchDevice = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(type, deviceId) {
          var videoTrack, stream, connection, uid, tid, eventId, eventDesc;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!this.screen_) {
                    _context.next = 2;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_OPERATION,
                    message: 'switch device is not supported in screen sharing'
                  });

                case 2:
                  if (!(type === 'audio' && this.microphoneId_ === deviceId || type === 'video' && this.cameraId_ === deviceId || this.audioSource_ || this.videoSource_)) {
                    _context.next = 4;
                    break;
                  }

                  return _context.abrupt("return");

                case 4:
                  if (type === 'audio') {
                    this.microphoneId_ = deviceId; // ensure audio is being requested

                    if (!this.audio_) {
                      this.audio_ = true;
                    }
                  }

                  if (type === 'video') {
                    if (deviceId === 'user' || deviceId === 'environment') {
                      this.facingMode_ = deviceId;
                    } else {
                      this.cameraId_ = deviceId;
                    } // ensure video is being requested


                    if (!this.video_) {
                      this.video_ = true;
                    }
                  }

                  if (this.getMediaStream()) {
                    _context.next = 8;
                    break;
                  }

                  return _context.abrupt("return");

                case 8:
                  this.log_.info('switchDevice ' + type + ' to: ' + deviceId);

                  if (type === 'video' && (IS_ANDROID || IS_IOS)) {
                    // on mobile platform we have to release the camera before switching to another
                    // camera otherwise it may get stuck.
                    videoTrack = this.getVideoTrack();

                    if (videoTrack) {
                      videoTrack.stop();
                    }
                  }

                  _context.next = 12;
                  return getUserMedia({
                    audio: this.audio_,
                    video: this.video_,
                    facingMode: this.facingMode_,
                    cameraId: this.cameraId_,
                    microphoneId: this.microphoneId_,
                    width: this.videoProfile_.width,
                    height: this.videoProfile_.height,
                    frameRate: this.videoProfile_.frameRate,
                    sampleRate: this.audioProfile_.sampleRate,
                    channelCount: this.audioProfile_.channelCount
                  });

                case 12:
                  stream = _context.sent;
                  this.setMediaStream(stream);
                  connection = this.getConnection();

                  if (!connection) {
                    _context.next = 24;
                    break;
                  }

                  _context.next = 18;
                  return connection.replaceStream(stream);

                case 18:
                  uid = connection.getUserId();
                  tid = connection.getTinyId();
                  eventId = EventId.SWITCH_CAMERA;
                  eventDesc = 'switch camera';

                  if (type === 'audio') {
                    eventId = EventId.SWITCH_MICROPHONE;
                    eventDesc = 'switch microphone';
                  }

                  addEvent(uid, {
                    eventId: eventId,
                    eventDesc: eventDesc,
                    timestamp: getCurrentTime(),
                    userId: uid,
                    tinyId: tid
                  });

                case 24:
                  this.log_.info('swichDevice - restart audio/video player');

                  _get(_getPrototypeOf(LocalStream.prototype), "restartAudio", this).call(this);

                  _get(_getPrototypeOf(LocalStream.prototype), "restartVideo", this).call(this);

                  return _context.abrupt("return");

                case 28:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function switchDevice(_x, _x2) {
          return _switchDevice.apply(this, arguments);
        }

        return switchDevice;
      }()
      /**
       * 添加音频或视频轨道<br>
       * <br>
       * 调用该方法将音频或视频轨道添加到本地流，若该本地流已经被发布，则会自动更新发往远端的音视频流，此时远端会收到 `Client.on('stream-updated')` 事件通知。<br>
       * <br>
       * 请注意，一个 Stream 对象中最多只能同时包含一路音频轨道和一路视频轨道。如果你想要更换同类型的轨道，请使用 {@link LocalStream#replaceTrack replaceTrack()}。
       * <br>
       * <br>
       * 新的音视频轨道可以通过 {@link TRTC.createStream createStream()}/{@link Stream#getAudioTrack getAudioTrack()}|{@link Stream#getVideoTrack getVideoTrack()} 获取，
       * 或者直接通过 {@link https://developer.mozilla.org/en-US/docs/Web/API/MediaDevices/getUserMedia getUserMedia()}、{@link https://developer.mozilla.org/en-US/docs/Web/API/HTMLMediaElement/captureStream captureStream()} 获取。
       *
       * **Note**
       * - 在增加视频轨道时，要求视频分辨率跟 {@link LocalStream#setVideoProfile setVideoProfile()} 设置保持一致，否则会抛出异常。
       *
       * @throws RtcError
       * @param {MediaStreamTrack} track 音频或视频轨道
       * @memberof LocalStream
       * @example
       *
       * const localStream = TRTC.createStream({ userId, audio: true, video: false });
       * localStream.initialize().then(() => {
       *   // 分布本地流（只有从麦克风采集的音频流）
       *   client.publish(localStream);
       * });
       *
       * // ...
       *
       * // 开启视频通话
       * const videoStream = TRTC.createStream({ userId, audio: false, video: true });
       * videoStream.initialize().then(() => {
       *   const videoTrack = videoStream.getVideoTrack();
       *   // 将从摄像头采集的视频轨道插入当前已发布的本地流对象LocalStream
       *   localStream.addTrack(videoTrack).then(() => {
       *     // 视频通话开启成功，远端流将会收到‘stream-updated’通知
       *   });
       * });
       * //
       */

    }, {
      key: "addTrack",
      value: function () {
        var _addTrack = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(track) {
          var mediaStream, settings, connection, uid, tid, eventId, eventDesc;
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  mediaStream = this.getMediaStream();

                  if (mediaStream) {
                    _context2.next = 3;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_OPERATION,
                    message: 'the local stream is not initialized yet'
                  });

                case 3:
                  if (!(track.kind === 'audio' && mediaStream.getAudioTracks().length > 0 || track.kind === 'video' && mediaStream.getVideoTracks().length > 0)) {
                    _context2.next = 5;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_OPERATION,
                    message: 'A Stream has at most one audio track and one video track'
                  });

                case 5:
                  if (!(track.kind === 'video')) {
                    _context2.next = 10;
                    break;
                  }

                  if (!('getSettings' in MediaStreamTrack.prototype)) {
                    _context2.next = 10;
                    break;
                  }

                  settings = track.getSettings();

                  if (!(settings.width !== this.videoProfile_.width || settings.height !== this.videoProfile_.height)) {
                    _context2.next = 10;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_PARAMETER,
                    message: "video resolution of the track (".concat(settings.width, " x ").concat(settings.height, ") shall be kept the same as the one defined via setVideoProfile(): ").concat(this.videoProfile_.width, " x ").concat(this.videoProfile_.height)
                  });

                case 10:
                  mediaStream.addTrack(track);

                  if (track.kind === 'audio') {
                    this.setHasAudio(true);
                  } else {
                    this.setHasVideo(true);
                  }

                  connection = this.getConnection();

                  if (!connection) {
                    _context2.next = 22;
                    break;
                  }

                  _context2.next = 16;
                  return connection.addTrack(track);

                case 16:
                  uid = connection.getUserId();
                  tid = connection.getTinyId();
                  eventId = EventId.PUBLISH_VIDEO;
                  eventDesc = 'add video track to current published stream';

                  if (track.kind === 'audio') {
                    eventId = EventId.PUBLISH_AUDIO;
                    eventDesc = 'add audio track to current published stream';
                  }

                  addEvent(uid, {
                    eventId: eventId,
                    eventDesc: eventDesc,
                    timestamp: getCurrentTime(),
                    userId: uid,
                    tinyId: tid
                  });

                case 22:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function addTrack(_x3) {
          return _addTrack.apply(this, arguments);
        }

        return addTrack;
      }()
      /**
       * 移除视频轨道<br>
       * <br>
       * 调用该方法会移除本地流中的视频轨道，若本地流已经被发布，则会自动更新发往远端的视频流，此时远端会收到 `Client.on('stream-updated')` 事件通知。<br>
       * <br>
       * 请注意，一个已经发布的Stream对象中至少要有一个媒体轨道，如果你想完全删除本地流中的音视频轨道，请直接通过 {@link Client#unpublish unpublish()} 取消发布，
       * 然后再通过 {@link LocalStream#close close()} 关闭本地流。<br>
       * **NOTE**
       * - 目前尚不支持移除音频轨道，若想禁用音频，可通过调用 {@link LocalStream#muteAudio muteAudio()} 实现。
       *
       * @param {MediaStreamTrack} track 视频轨道，track 通过 {@link Stream#getVideoTrack getVideoTrack()} 获取。
       * @memberof LocalStream
       * @throws RtcError
       * @example
       * // 关闭视频通话示例，对应addTrack接口的开启视频通话示例
       * const videoTrack = localStream.getVideoTrack();
       * if (videoTrack) {
       *   localStream.removeTrack(videoTrack).then(() => {
       *     // 关闭视频通话成功，停止videoTrack并释放摄像头资源
       *     videoTrack.stop();
       *   });
       * }
       */

    }, {
      key: "removeTrack",
      value: function () {
        var _removeTrack = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(track) {
          var mediaStream, connection, uid, tid, eventId, eventDesc;
          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  if (!(track.kind === 'audio')) {
                    _context3.next = 2;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_PARAMETER,
                    message: 'remove audio track is not supported'
                  });

                case 2:
                  mediaStream = this.getMediaStream();

                  if (mediaStream) {
                    _context3.next = 5;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_OPERATION,
                    message: 'the local stream is not initialized yet'
                  });

                case 5:
                  if (!(mediaStream.getTracks().indexOf(track) === -1)) {
                    _context3.next = 7;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_PARAMETER,
                    message: 'the track to be removed is not being publishing'
                  });

                case 7:
                  mediaStream.removeTrack(track);

                  if (track.kind === 'audio') {
                    this.setHasAudio(false);
                  } else {
                    this.setHasVideo(false);
                  }

                  connection = this.getConnection();

                  if (!connection) {
                    _context3.next = 19;
                    break;
                  }

                  _context3.next = 13;
                  return connection.removeTrack(track);

                case 13:
                  uid = connection.getUserId();
                  tid = connection.getTinyId();
                  eventId = EventId.UNPUBLISH_VIDEO;
                  eventDesc = 'remove video track from current published stream';

                  if (track.kind === 'audio') {
                    eventId = EventId.UNPUBLISH_AUDIO;
                    eventDesc = 'remove audio track from current published stream';
                  }

                  addEvent(uid, {
                    eventId: eventId,
                    eventDesc: eventDesc,
                    timestamp: getCurrentTime(),
                    userId: uid,
                    tinyId: tid
                  });

                case 19:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3, this);
        }));

        function removeTrack(_x4) {
          return _removeTrack.apply(this, arguments);
        }

        return removeTrack;
      }()
      /**
       * 更换音频或视频轨道<br>
       * <br>
       * 调用该方法更换本地流中的同类型轨道，若本地流已经被发布，该方法会自动更新发往远端的音视频流，此时远端会收到 `Client.on('stream-updated')` 事件通知。<br>
       * <br>
       * 新的音视频轨道可以通过 {@link TRTC.createStream createStream()}/{@link Stream#getAudioTrack getAudioTrack()}|{@link Stream#getVideoTrack getVideoTrack()} 获取，
       * 或者直接通过 {@link https://developer.mozilla.org/en-US/docs/Web/API/MediaDevices/getUserMedia getUserMedia()}、{@link https://developer.mozilla.org/en-US/docs/Web/API/HTMLMediaElement/captureStream captureStream()} 获取。
       * <br>
       * <br>
       * **Note**:
       * - 如果需要更换媒体输入设备，推荐使用 {@link LocalStream#switchDevice switchDevice()}。
       * - 在更换视频轨道时，要求视频分辨率跟 {@link LocalStream#setVideoProfile setVideoProfile()} 设置保持一致，否则会抛出异常。
       * - 支持 Chrome 65+、Safari 浏览器。
       *
       * @param {MediaStreamTrack} track 音频或视频轨道
       * @memberof LocalStream
       * @throws RtcError
       */

    }, {
      key: "replaceTrack",
      value: function () {
        var _replaceTrack = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(track) {
          var mediaStream, settings, connection, uid, tid, eventId, eventDesc;
          return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  mediaStream = this.getMediaStream();

                  if (mediaStream) {
                    _context4.next = 3;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_OPERATION,
                    message: 'the local stream is not initialized yet'
                  });

                case 3:
                  if (!(track.kind === 'audio' && mediaStream.getAudioTracks().length <= 0 || track.kind === 'video' && mediaStream.getVideoTracks().length <= 0)) {
                    _context4.next = 5;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_PARAMETER,
                    message: "try to replace ".concat(track.kind, " track but there's no previous ").concat(track.kind, " being published")
                  });

                case 5:
                  if (!(track.kind === 'video')) {
                    _context4.next = 10;
                    break;
                  }

                  if (!('getSettings' in MediaStreamTrack.prototype)) {
                    _context4.next = 10;
                    break;
                  }

                  settings = track.getSettings();

                  if (!(settings.width !== this.videoProfile_.width || settings.height !== this.videoProfile_.height)) {
                    _context4.next = 10;
                    break;
                  }

                  throw new RtcError({
                    code: ErrorCode.INVALID_PARAMETER,
                    message: "video resolution of the track (".concat(settings.width, " x ").concat(settings.height, ") shall be kept the same as the one defined via setVideoProfile(): ").concat(this.videoProfile_.width, " x ").concat(this.videoProfile_.height)
                  });

                case 10:
                  if (track.kind === 'audio') {
                    mediaStream.removeTrack(mediaStream.getAudioTracks()[0]);
                    mediaStream.addTrack(track); // restart audio player as the track has already been changed.

                    _get(_getPrototypeOf(LocalStream.prototype), "restartAudio", this).call(this);
                  } else {
                    mediaStream.removeTrack(mediaStream.getVideoTracks()[0]);
                    mediaStream.addTrack(track); // restart video player as the track has already been changed

                    _get(_getPrototypeOf(LocalStream.prototype), "restartVideo", this).call(this);
                  }

                  connection = this.getConnection();

                  if (!connection) {
                    _context4.next = 21;
                    break;
                  }

                  _context4.next = 15;
                  return connection.replaceTrack(track);

                case 15:
                  uid = connection.getUserId();
                  tid = connection.getTinyId();
                  eventId = EventId.REPLACE_VIDEO;
                  eventDesc = 'replace video track from current published stream';

                  if (track.kind === 'audio') {
                    eventId = EventId.REPLACE_AUDIO;
                    eventDesc = 'replace audio track from current published stream';
                  }

                  addEvent(uid, {
                    eventId: eventId,
                    eventDesc: eventDesc,
                    timestamp: getCurrentTime(),
                    userId: uid,
                    tinyId: tid
                  });

                case 21:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4, this);
        }));

        function replaceTrack(_x5) {
          return _replaceTrack.apply(this, arguments);
        }

        return replaceTrack;
      }()
      /**
       * @private
       * @memberof LocalStream
       */

    }, {
      key: "setAudioVolume",
      value: function setAudioVolume(volume) {
        _get(_getPrototypeOf(LocalStream.prototype), "setAudioVolume", this).call(this, volume);
      }
    }]);

    return LocalStream;
  }(Stream);

  /**
   * 封装 MTA SDK，仅支持 Web
   * {@link https://mta.qq.com/docs/h5.html MTA Web接入}
   * @class MTA
   * @author rychouwei
   */
  var MTA = /*#__PURE__*/function () {
    function MTA() {
      _classCallCheck(this, MTA);

      this.cache = []; // 缓存队列。Web端的MTA是异步加载的，若 MTA 没加载完成，触发了 report，则先进入缓存队列。下次 report 时再上报。

      this.init();
    }
    /**
     * 手动上报事件，具体配置参考
     * {@link https://mta.qq.com/h5/visitor/ctr_custom_param_config?custom_id=246778&app_id=500690998 Web}
     * @param {String} name
     * @param {Object} param
     * @memberof MTA
     * @example
     * tim.mta.report('sdkAppID', { value: 'your sdkAppID' })
     */


    _createClass(MTA, [{
      key: "report",
      value: function report(name, param) {// try {
        //   // Web
        //   if (window.MtaH5) {
        //     window.MtaH5.clickStat(name, param);
        //     // 上报缓存队列的事件
        //     this.cache.forEach(({ name, param }) => {
        //       window.MtaH5.clickStat(name, param);
        //       this.cache.shift();
        //     });
        //   } else {
        //     // 将事件缓存
        //     this.cache.push({ name, param });
        //   }
        // } catch (error) {
        //   // 拦截错误即可，不做处理
        // }
      }
      /**
       * 手动上报 PV
       * 开启了自动上报 PV 则无需调用该函数
       * @memberof MTA
       */

    }, {
      key: "stat",
      value: function stat() {// try {
        //   if (window.MtaH5) {
        //     window.MtaH5.pgv();
        //   }
        // } catch (error) {
        //   // 拦截错误即可，不做处理
        // }
      }
      /**
       * 初始化
       * @private
       * @memberof MTA
       */

    }, {
      key: "init",
      value: function init() {// try {
        //   window._mtac = { autoReport: 1 }; // 初始化完成时，自动上报 PV
        //   var mta = document.createElement('script');
        //   mta.src = 'https://pingjs.qq.com/h5/stats.js?v2.0.4';
        //   mta.setAttribute('name', 'MTAH5');
        //   // mta.setAttribute('sid', '500699039');
        //   // mta.setAttribute('cid', '500699088');
        //   mta.setAttribute('sid', '500716927');
        // 	mta.setAttribute("cid", "500717299");
        //   var s = document.getElementsByTagName('script')[0];
        //   s.parentNode.insertBefore(mta, s);
        // } catch (error) {
        //   // 拦截错误即可，不做处理
        // }
      }
    }]);

    return MTA;
  }();

  console.log("WebRTC-adapter ".concat(adapter.browserDetails.browser, "/").concat(adapter.browserDetails.version)); // MTA 上报相关。目前暂时写在此处，后续得讨论优化。

  var mta = new MTA();
  /**
   * TRTC 是 TRTC Web SDK 的主入口，通过 TRTC 方法可以创建一个实时音视频通信的客户端对象 (Client)
   * 和本地音视频流对象 (Stream)。
   * TRTC 方法还可以检测浏览器的兼容性，是否支持屏幕分享，以及设置日志级别及日志上传。
   *
   * @namespace TRTC
   */

  var TRTC = {
    /**
     * TRTC Web SDK 版本号
     * @type {string}
     */
    VERSION: version$1,

    /**
     * 提供日志设置方法，包括设置日志输出等级、打开或关闭日志上传。
     *
     * @memberof TRTC
     * @namespace TRTC.Logger
     */
    Logger: {
      // Loglevel definitions, please align with loglevel definition in utils/log/loglevel.js
      // self.levels = { TRACE: 0, DEBUG: 1, INFO: 2, WARN: 3, ERROR: 4, SILENT: 5 }

      /**
       * 日志输出等级
       * @readonly
       * @enum {number}
       */
      LogLevel: {
        /**
         * 输出所有日志
         */
        TRACE: 0,

        /**
         * 输出 DEBUG、INFO、WARN、ERROR 等级日志
         */
        DEBUG: 1,

        /**
         * 输出 INFO、WARN、ERROR 等级日志
         */
        INFO: 2,

        /**
         * 输出 WARN、ERROR 等级日志
         */
        WARN: 3,

        /**
         * 输出 ERROR 等级日志
         */
        ERROR: 4,

        /**
         * 不输出任何日志
         * **注意：**
         * **关闭日之后我们将无法帮助您定位线上问题，建议至少保留 WARN 日志等级！**
         */
        NONE: 5
      },

      /**
       * 设置日志输出等级
       * <br>
       * 默认输出 INFO 日志等级，该日志等级包含 SDK 关键路径信息。
       *
       * @param {LogLevel} level 日志输出等级 {@link TRTC.Logger.LogLevel LogLevel}
       * @example
       * // 输出INFO以上日志等级
       * TRTC.Logger.setLogLevel(TRTC.Logger.LogLevel.INFO);
       */
      setLogLevel: function setLogLevel(level) {
        logger.setLogLevel(level);
      },

      /**
       * 打开日志上传
       * <br>
       * 默认打开日志上传。如无特别原因，请保持打开日志上传，以便我们帮助您定位线上问题。
       *
       */
      enableUploadLog: function enableUploadLog() {
        logger.enableUploadLog();
      },

      /**
       * 关闭日志上传
       * <br>
       * **注意：**
       * **如果您关闭了日志上传，我们将无法协助您定位线上问题！**
       */
      disableUploadLog: function disableUploadLog() {
        logger.disableUploadLog();
      }
    },

    /**
     * 检测浏览器是否兼容 TRTC Web SDK <br>
     * 若当前浏览器不兼容 TRTC Web SDK，建议引导用户去下载最新版本的 Chrome 浏览器。
     *
     * @example
     * TRTC.checkSystemRequirements().then((result) => {
     *   if(!result) {
     *     alert('Your browser is not compatible with TRTC');
     *   }
     * });
     *
     * @returns {Promise.<boolean>} Promise 返回检测结果
     */
    checkSystemRequirements: function checkSystemRequirements() {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return checkSystemRequirementsInternal();

              case 2:
                return _context.abrupt("return", _context.sent);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },

    /**
     * 检测浏览器是否支持屏幕分享<br>
     * 在创建屏幕分享流之前请调用该方法检查当前浏览器是否支持屏幕分享。
     *
     * @returns {boolean}
     */
    isScreenShareSupported: function isScreenShareSupported() {
      return isScreenCaptureApiAvailable();
    },

    /**
     * 返回媒体输入输出设备列表
     * <br>
     * 出于安全的考虑，在用户未授权摄像头或麦克风访问权限前，label 及 deviceId 字段可能都是空的。因此建议在用户授权访问后
     * 再调用该接口获取设备详情，比如在 {@link LocalStream#initialize initialize()} 后再调用此接口获取设备详情。
     *
     * @returns {Promise.<MediaDeviceInfo[]>} Promise 返回 {@link https://developer.mozilla.org/en-US/docs/Web/API/MediaDeviceInfo|MediaDeviceInfo} 数组
     */
    getDevices: function getDevices() {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var devices;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (navigator.mediaDevices) {
                  _context2.next = 3;
                  break;
                }

                logger.error('navigator.mediaDevices is undefined');
                return _context2.abrupt("return", []);

              case 3:
                _context2.next = 5;
                return navigator.mediaDevices.enumerateDevices();

              case 5:
                devices = _context2.sent;
                return _context2.abrupt("return", devices.map(function (item, index) {
                  var label = item.label;

                  if (!item.label) {
                    label = item.kind + '_' + index;
                  }

                  return {
                    label: label,
                    deviceId: item.deviceId,
                    kind: item.kind
                  };
                }));

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }))();
    },

    /**
     * 返回摄像头设备列表
     * <br>
     * 出于安全的考虑，在用户未授权摄像头或麦克风访问权限前，label 及 deviceId 字段可能都是空的。因此建议在用户授权访问后
     * 再调用该接口获取设备详情，比如在 {@link LocalStream#initialize initialize()} 后再调用此接口获取设备详情。
     *
     * @returns {Promise.<MediaDeviceInfo[]>} Promise 返回 {@link https://developer.mozilla.org/en-US/docs/Web/API/MediaDeviceInfo|MediaDeviceInfo} 数组
     */
    getCameras: function getCameras() {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var devices;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (navigator.mediaDevices) {
                  _context3.next = 3;
                  break;
                }

                logger.error('navigator.mediaDevices is undefined');
                return _context3.abrupt("return", []);

              case 3:
                _context3.next = 5;
                return navigator.mediaDevices.enumerateDevices();

              case 5:
                devices = _context3.sent;
                return _context3.abrupt("return", devices.filter(function (item) {
                  return item.kind === 'videoinput';
                }).map(function (item, index) {
                  // For security reasons, the label field is always blank unless an active media stream
                  // exists or the user has granted persistent permission for media device access.
                  var label = item.label;

                  if (!item.label) {
                    label = 'camera_' + index;
                  }

                  return {
                    label: label,
                    deviceId: item.deviceId,
                    kind: item.kind
                  };
                }));

              case 7:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }))();
    },

    /**
     * 返回麦克风设备列表
     * <br>
     * 出于安全的考虑，在用户未授权摄像头或麦克风访问权限前，label 及 deviceId 字段可能都是空的。因此建议在用户授权访问后
     * 再调用该接口获取设备详情，比如在 {@link LocalStream#initialize initialize()} 后再调用此接口获取设备详情。
     *
     * @returns {Promise.<MediaDeviceInfo[]>} Promise 返回 {@link https://developer.mozilla.org/en-US/docs/Web/API/MediaDeviceInfo|MediaDeviceInfo} 数组
     */
    getMicrophones: function getMicrophones() {
      var _this = this;

      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var devices;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (navigator.mediaDevices) {
                  _context4.next = 3;
                  break;
                }

                logger.error('navigator.mediaDevices is undefined');
                return _context4.abrupt("return", []);

              case 3:
                _context4.next = 5;
                return _this.getLocalDevices();

              case 5:
                devices = _context4.sent;
                return _context4.abrupt("return", devices.filter(function (item) {
                  return item.kind === 'audioinput';
                }).map(function (item, index) {
                  var label = item.label;

                  if (!item.label) {
                    label = 'microphone_' + index;
                  }

                  return {
                    label: label,
                    deviceId: item.deviceId,
                    kind: item.kind
                  };
                }));

              case 7:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }))();
    },

    /**
     * 浏览器兼容，safari 下
     */
    // eslint-disable-next-line no-dupe-keys
    getLocalDevices: function getLocalDevices() {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
        var constraints;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                constraints = {
                  audio: {
                    deviceId: undefined
                  }
                }; // eslint-disable-next-line no-undef

                if (!IS_ANY_SAFARI) {
                  _context5.next = 5;
                  break;
                }

                return _context5.abrupt("return", navigator.mediaDevices.getUserMedia(constraints).then(function () {
                  return navigator.mediaDevices.enumerateDevices();
                })["catch"](function () {
                  logger.error('navigator.mediaDevices.getUserMedia failed');
                }));

              case 5:
                return _context5.abrupt("return", navigator.mediaDevices.enumerateDevices());

              case 6:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }))();
    },

    /**
     * 返回扬声器设备列表
     * <br>
     * 出于安全的考虑，在用户未授权摄像头或麦克风访问权限前，label 及 deviceId 字段可能都是空的。因此建议在用户授权访问后
     * 再调用该接口获取设备详情，比如在 {@link LocalStream#initialize initialize()} 后再调用此接口获取设备详情。
     *
     * @returns {Promise.<MediaDeviceInfo[]>} Promise 返回 {@link https://developer.mozilla.org/en-US/docs/Web/API/MediaDeviceInfo|MediaDeviceInfo} 数组
     */
    getSpeakers: function getSpeakers() {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
        var devices;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return navigator.mediaDevices.enumerateDevices();

              case 2:
                devices = _context6.sent;
                return _context6.abrupt("return", devices.filter(function (item) {
                  return item.kind === 'audiooutput';
                }).map(function (item, index) {
                  var label = item.label;

                  if (!item.label) {
                    label = 'speaker_' + index;
                  }

                  return {
                    label: label,
                    deviceId: item.deviceId,
                    kind: item.kind
                  };
                }));

              case 4:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6);
      }))();
    },

    /**
     * 创建一个实时音视频通话的客户端对象，在每次会话中仅需要调用一次。
     * 通常一个客户端对象跟一个用户 ID(userId) 绑定，同一个页面中可以有多个不同的客户端对象，
     * 每个客户端对象跟不同的用户ID绑定，比如，你可以使用一个客户端对象负责推送本地音视频流和接收
     * 远端流，同时使用另外一个客户端对象负责推送屏幕分享流，但是不接收远端流。
     *
     * @param {object} clientConfig 客户端配置项
     * @param {number} clientConfig.sdkAppId sdkAppId
     * @param {string} clientConfig.userId 用户ID
     * @param {string} clientConfig.userSig userSig 签名
     * @param {string} clientConfig.mode 应用场景，目前支持以下两种场景：
     * - 'videoCall' 实时通话模式
     * - 'live' 互动直播模式
     * @param {string=} clientConfig.streamId 绑定腾讯云直播 CDN 流 ID，设置之后，您就可以在腾讯云直播 CDN 上通过标准直播方案（FLV|HLS）播放该用户的音视频流。
     * 限制长度为64字节，可以不填写，一种推荐的方案是使用 “sdkappid_roomid_userid_main” 作为 streamid，这样比较好辨认且不会在您的多个应用中发生冲突。
     * - 【特殊说明】要使用腾讯云直播 CDN，您需要先在[控制台](https://console.cloud.tencent.com/trtc/) 中的功能配置页开启“启动自动旁路直播”开关。
     * - 【参考文档】[CDN 旁路直播](https://cloud.tencent.com/document/product/647/16826)。
     * @param {string=} clientConfig.userDefineRecordId 设置云端录制完成后的回调消息中的 "userdefinerecordid"  字段内容，便于您更方便的识别录制回调。
     * - 【推荐取值】限制长度为64字节，只允许包含大小写英文字母（a-zA-Z）、数字（0-9）及下划线和连词符。
     * - 【参考文档】[云端录制](https://cloud.tencent.com/document/product/647/16823)。
     * @returns {Client} 客户端对象
     * @param {number=} clientConfig.pureAudioPushMode 纯音频推流模式，需要旁路直播和录制时需要带上此参数:
     * - 1 表示本次是纯音频推流，不需要录制 MP3 文件
     * - 2 表示本次是纯音频推流，录制文件为 MP3
     *
     */
    createClient: function createClient(clientConfig) {
      // 上报 sdkAppID
      mta.report('sdkAppID', {
        value: clientConfig.sdkAppId
      }); // 上报 version

      mta.report('version', {
        value: this.VERSION
      });
      var opt = {
        version: this.VERSION
      };
      return new Client(_objectSpread2(_objectSpread2({}, opt), clientConfig));
    },

    /**
     * 创建一个本地流 Stream 对象，本地流 Stream 对象通过 {@link Client#publish publish()} 方法发布本地音视频流。<br>
     *
     * 注意：一个音视频流 Stream 中最多只能包含一个音频 track 和一个视频 track。<br>
     *
     * 本地音视频流可以
     * - 从摄像头和麦克风采集获得，适用于一般的音视频通话。
     * - 从屏幕分享源采集获得，适用于进行屏幕分享。
     * - 从开发者通过 audioSource/videoSource 指定的
     * {@link https://developer.mozilla.org/en-US/docs/Web/API/MediaStreamTrack|MediaStreamTrack} 获得，
     * 使用这种方式业务层可先对音视频进行前处理，比如，对音频进行混音，或者对视频进行美颜处理，亦或者通过这种方式向远端用户推送一个正在播放的音视频文件。
     * <br>
     *
     * @param {object} streamConfig
     * @param {boolean} streamConfig.audio 是否从麦克风采集音频
     * @param {string=} streamConfig.microphoneId 麦克风设备 deviceId，通过 {@link TRTC.getMicrophones getMicrophones()} 获取
     * @param {boolean} streamConfig.video 是否从摄像头采集视频
     * @param {string=} streamConfig.cameraId 摄像头设备 deviceId，通过 {@link TRTC.getCameras getCameras()} 获取
     * @param {string=} streamConfig.facingMode 指定使用前置或后置摄像头来采集视频。<br>在移动设备上，可通过该参数选择使用前置或后置摄像头：
     * - 'user'：前置摄像头
     * - 'environment'：后置摄像头
     *
     * **注意**
     * - 请勿同时使用 cameraId 和 facingMode 参数。
     * @param {boolean=} streamConfig.screen 是否采集屏幕分享流
     * @param {MediaStreamTrack} streamConfig.audioSource 音频源
     * @param {MediaStreamTrack} streamConfig.videoSource 视频源
     * @param {boolean=} streamConfig.mirror 视频显示是否为镜像，默认为 `true`。建议在使用前置摄像头时开启，使用后置摄像头时关闭。
     * <br>
     * 镜像设置不适用于屏幕分享。
     * @throws {RtcError}
     * @returns {Stream} 本地音视频流对象
     * @example
     * // 从麦克风和摄像头采集本地音视频流
     * const localStream = TRTC.createStream({ audio: true, video: true });
     * localStream.initialize().catch(error => {
     *   console.error('failed initialize localStream ' + error);
     * }).then(() => {
     *   console.log('initialize localStream success');
     *   // 本地流初始化成功，可通过Client.publish(localStream)发布本地音视频流
     * });
     *
     * @example
     * // 从屏幕分享源采集
     * // 仅采集屏幕分享视频流
     * const localStream = TRTC.createStream({ audio: false, screen: true });
     *
     * // 采集麦克风及屏幕分享视频流
     * // const localStream = TRTC.createStream({ audio: true, screen: true });
     *
     * localStream.initialize().catch(error => {
     *   console.error('failed initialize localStream ' + error);
     * }).then(() => {
     *   console.log('initialize localStream success');
     *   // 本地流初始化成功，可通过Client.publish(localStream)发布本地音视频流
     * });
     *
     * @example
     * // 从外部App指定的音视频源创建本地音视频流
     * navigator.mediaDevices.getUserMedia({ audio: true, video: true }).then(stream => {
     *   const audioTrack = stream.getAudioTracks()[0];
     *   const videoTrack = stream.getVideoTracks()[0];
     *
     *   // 对audioTrack和videoTrack处理之后，
     *
     *   const localStream = TRTC.createStream({ audioSource: audioTrack, videoSource: videoTrack });
     *   localStream.initialize().catch(error => {
     *     console.error('failed initialize localStream ' + error);
     *   }).then(() => {
     *     console.log('initialize localStream success');
     *     // 本地流初始化成功，可通过Client.publish(localStream)发布本地音视频流
     *   });
     * }
     * );
     */
    createStream: function createStream(streamConfig) {
      if ((typeof streamConfig.audio !== 'undefined' || typeof streamConfig.video !== 'undefined') && (typeof streamConfig.audioSource !== 'undefined' || typeof streamConfig.videoSource !== 'undefined')) {
        throw new RtcError({
          code: ErrorCode.INVALID_PARAMETER,
          message: 'LocalStream must be created by createStream() with either audio/video or audioSource/videoSource' + 'but can not be mixed with audio/video and audioSource/videoSource'
        });
      }

      if (typeof streamConfig.screen !== 'undefined' && streamConfig.screen === true && streamConfig.video === true) {
        throw new RtcError({
          code: ErrorCode.INVALID_PARAMETER,
          message: 'screen/video options are mutually exclusive, they can not be both true'
        });
      }

      if (typeof streamConfig.screen !== 'undefined' && streamConfig.screen === true && !this.isScreenShareSupported()) {
        throw new RtcError({
          code: ErrorCode.INVALID_OPERATION,
          message: 'screen capture is not supported, please use the latest chrome browser'
        });
      }

      return new LocalStream(streamConfig);
    }
  };
  logger.info('******************************************************************************');
  logger.info('*   欢迎使用 GME Web SDK - 腾讯云游戏多媒体引擎'); // console.info('*   API 文档：' + 'https://trtc-1252463788.file.myqcloud.com/web/docs/index.html');
  // console.info('*   版本更新日志：' + 'https://cloud.tencent.com/document/product/647/38958');
  // console.info('*   反馈问题：' + 'https://github.com/tencentyun/TRTCSDK/issues');

  logger.info('******************************************************************************');
  logger.info('GME Web SDK Version: ' + TRTC.VERSION);
  logger.info('UserAgent: ' + navigator.userAgent);
  logger.info('URL of current page: ' + location.href);

  // `Array.prototype.fill` method implementation
  // https://tc39.es/ecma262/#sec-array.prototype.fill
  var arrayFill = function fill(value /* , start = 0, end = @length */) {
    var O = toObject(this);
    var length = lengthOfArrayLike(O);
    var argumentsLength = arguments.length;
    var index = toAbsoluteIndex(argumentsLength > 1 ? arguments[1] : undefined, length);
    var end = argumentsLength > 2 ? arguments[2] : undefined;
    var endPos = end === undefined ? length : toAbsoluteIndex(end, length);
    while (endPos > index) O[index++] = value;
    return O;
  };

  // `Array.prototype.fill` method
  // https://tc39.es/ecma262/#sec-array.prototype.fill
  _export({ target: 'Array', proto: true }, {
    fill: arrayFill
  });

  // https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
  addToUnscopables('fill');

  var lookup = [];
  var revLookup = [];
  var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array;
  var inited = false;
  function init () {
    inited = true;
    var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
    for (var i = 0, len = code.length; i < len; ++i) {
      lookup[i] = code[i];
      revLookup[code.charCodeAt(i)] = i;
    }

    revLookup['-'.charCodeAt(0)] = 62;
    revLookup['_'.charCodeAt(0)] = 63;
  }

  function toByteArray (b64) {
    if (!inited) {
      init();
    }
    var i, j, l, tmp, placeHolders, arr;
    var len = b64.length;

    if (len % 4 > 0) {
      throw new Error('Invalid string. Length must be a multiple of 4')
    }

    // the number of equal signs (place holders)
    // if there are two placeholders, than the two characters before it
    // represent one byte
    // if there is only one, then the three characters before it represent 2 bytes
    // this is just a cheap hack to not do indexOf twice
    placeHolders = b64[len - 2] === '=' ? 2 : b64[len - 1] === '=' ? 1 : 0;

    // base64 is 4/3 + up to two characters of the original data
    arr = new Arr(len * 3 / 4 - placeHolders);

    // if there are placeholders, only get up to the last complete 4 chars
    l = placeHolders > 0 ? len - 4 : len;

    var L = 0;

    for (i = 0, j = 0; i < l; i += 4, j += 3) {
      tmp = (revLookup[b64.charCodeAt(i)] << 18) | (revLookup[b64.charCodeAt(i + 1)] << 12) | (revLookup[b64.charCodeAt(i + 2)] << 6) | revLookup[b64.charCodeAt(i + 3)];
      arr[L++] = (tmp >> 16) & 0xFF;
      arr[L++] = (tmp >> 8) & 0xFF;
      arr[L++] = tmp & 0xFF;
    }

    if (placeHolders === 2) {
      tmp = (revLookup[b64.charCodeAt(i)] << 2) | (revLookup[b64.charCodeAt(i + 1)] >> 4);
      arr[L++] = tmp & 0xFF;
    } else if (placeHolders === 1) {
      tmp = (revLookup[b64.charCodeAt(i)] << 10) | (revLookup[b64.charCodeAt(i + 1)] << 4) | (revLookup[b64.charCodeAt(i + 2)] >> 2);
      arr[L++] = (tmp >> 8) & 0xFF;
      arr[L++] = tmp & 0xFF;
    }

    return arr
  }

  function tripletToBase64 (num) {
    return lookup[num >> 18 & 0x3F] + lookup[num >> 12 & 0x3F] + lookup[num >> 6 & 0x3F] + lookup[num & 0x3F]
  }

  function encodeChunk (uint8, start, end) {
    var tmp;
    var output = [];
    for (var i = start; i < end; i += 3) {
      tmp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2]);
      output.push(tripletToBase64(tmp));
    }
    return output.join('')
  }

  function fromByteArray (uint8) {
    if (!inited) {
      init();
    }
    var tmp;
    var len = uint8.length;
    var extraBytes = len % 3; // if we have 1 byte left, pad 2 bytes
    var output = '';
    var parts = [];
    var maxChunkLength = 16383; // must be multiple of 3

    // go through the array every three bytes, we'll deal with trailing stuff later
    for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
      parts.push(encodeChunk(uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)));
    }

    // pad the end with zeros, but make sure to not forget the extra bytes
    if (extraBytes === 1) {
      tmp = uint8[len - 1];
      output += lookup[tmp >> 2];
      output += lookup[(tmp << 4) & 0x3F];
      output += '==';
    } else if (extraBytes === 2) {
      tmp = (uint8[len - 2] << 8) + (uint8[len - 1]);
      output += lookup[tmp >> 10];
      output += lookup[(tmp >> 4) & 0x3F];
      output += lookup[(tmp << 2) & 0x3F];
      output += '=';
    }

    parts.push(output);

    return parts.join('')
  }

  function read (buffer, offset, isLE, mLen, nBytes) {
    var e, m;
    var eLen = nBytes * 8 - mLen - 1;
    var eMax = (1 << eLen) - 1;
    var eBias = eMax >> 1;
    var nBits = -7;
    var i = isLE ? (nBytes - 1) : 0;
    var d = isLE ? -1 : 1;
    var s = buffer[offset + i];

    i += d;

    e = s & ((1 << (-nBits)) - 1);
    s >>= (-nBits);
    nBits += eLen;
    for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

    m = e & ((1 << (-nBits)) - 1);
    e >>= (-nBits);
    nBits += mLen;
    for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

    if (e === 0) {
      e = 1 - eBias;
    } else if (e === eMax) {
      return m ? NaN : ((s ? -1 : 1) * Infinity)
    } else {
      m = m + Math.pow(2, mLen);
      e = e - eBias;
    }
    return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
  }

  function write$1 (buffer, value, offset, isLE, mLen, nBytes) {
    var e, m, c;
    var eLen = nBytes * 8 - mLen - 1;
    var eMax = (1 << eLen) - 1;
    var eBias = eMax >> 1;
    var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0);
    var i = isLE ? 0 : (nBytes - 1);
    var d = isLE ? 1 : -1;
    var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0;

    value = Math.abs(value);

    if (isNaN(value) || value === Infinity) {
      m = isNaN(value) ? 1 : 0;
      e = eMax;
    } else {
      e = Math.floor(Math.log(value) / Math.LN2);
      if (value * (c = Math.pow(2, -e)) < 1) {
        e--;
        c *= 2;
      }
      if (e + eBias >= 1) {
        value += rt / c;
      } else {
        value += rt * Math.pow(2, 1 - eBias);
      }
      if (value * c >= 2) {
        e++;
        c /= 2;
      }

      if (e + eBias >= eMax) {
        m = 0;
        e = eMax;
      } else if (e + eBias >= 1) {
        m = (value * c - 1) * Math.pow(2, mLen);
        e = e + eBias;
      } else {
        m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
        e = 0;
      }
    }

    for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

    e = (e << mLen) | m;
    eLen += mLen;
    for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

    buffer[offset + i - d] |= s * 128;
  }

  var toString$3 = {}.toString;

  var isArray$2 = Array.isArray || function (arr) {
    return toString$3.call(arr) == '[object Array]';
  };

  var INSPECT_MAX_BYTES = 50;

  /**
   * If `Buffer.TYPED_ARRAY_SUPPORT`:
   *   === true    Use Uint8Array implementation (fastest)
   *   === false   Use Object implementation (most compatible, even IE6)
   *
   * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
   * Opera 11.6+, iOS 4.2+.
   *
   * Due to various browser bugs, sometimes the Object implementation will be used even
   * when the browser supports typed arrays.
   *
   * Note:
   *
   *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,
   *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
   *
   *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
   *
   *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
   *     incorrect length in some situations.

   * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they
   * get the Object implementation, which is slower but behaves correctly.
   */
  Buffer.TYPED_ARRAY_SUPPORT = global$1.TYPED_ARRAY_SUPPORT !== undefined
    ? global$1.TYPED_ARRAY_SUPPORT
    : true;

  function kMaxLength () {
    return Buffer.TYPED_ARRAY_SUPPORT
      ? 0x7fffffff
      : 0x3fffffff
  }

  function createBuffer (that, length) {
    if (kMaxLength() < length) {
      throw new RangeError('Invalid typed array length')
    }
    if (Buffer.TYPED_ARRAY_SUPPORT) {
      // Return an augmented `Uint8Array` instance, for best performance
      that = new Uint8Array(length);
      that.__proto__ = Buffer.prototype;
    } else {
      // Fallback: Return an object instance of the Buffer class
      if (that === null) {
        that = new Buffer(length);
      }
      that.length = length;
    }

    return that
  }

  /**
   * The Buffer constructor returns instances of `Uint8Array` that have their
   * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of
   * `Uint8Array`, so the returned instances will have all the node `Buffer` methods
   * and the `Uint8Array` methods. Square bracket notation works as expected -- it
   * returns a single octet.
   *
   * The `Uint8Array` prototype remains unmodified.
   */

  function Buffer (arg, encodingOrOffset, length) {
    if (!Buffer.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer)) {
      return new Buffer(arg, encodingOrOffset, length)
    }

    // Common case.
    if (typeof arg === 'number') {
      if (typeof encodingOrOffset === 'string') {
        throw new Error(
          'If encoding is specified then the first argument must be a string'
        )
      }
      return allocUnsafe(this, arg)
    }
    return from(this, arg, encodingOrOffset, length)
  }

  Buffer.poolSize = 8192; // not used by this implementation

  // TODO: Legacy, not needed anymore. Remove in next major version.
  Buffer._augment = function (arr) {
    arr.__proto__ = Buffer.prototype;
    return arr
  };

  function from (that, value, encodingOrOffset, length) {
    if (typeof value === 'number') {
      throw new TypeError('"value" argument must not be a number')
    }

    if (typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer) {
      return fromArrayBuffer(that, value, encodingOrOffset, length)
    }

    if (typeof value === 'string') {
      return fromString(that, value, encodingOrOffset)
    }

    return fromObject(that, value)
  }

  /**
   * Functionally equivalent to Buffer(arg, encoding) but throws a TypeError
   * if value is a number.
   * Buffer.from(str[, encoding])
   * Buffer.from(array)
   * Buffer.from(buffer)
   * Buffer.from(arrayBuffer[, byteOffset[, length]])
   **/
  Buffer.from = function (value, encodingOrOffset, length) {
    return from(null, value, encodingOrOffset, length)
  };

  if (Buffer.TYPED_ARRAY_SUPPORT) {
    Buffer.prototype.__proto__ = Uint8Array.prototype;
    Buffer.__proto__ = Uint8Array;
  }

  function assertSize (size) {
    if (typeof size !== 'number') {
      throw new TypeError('"size" argument must be a number')
    } else if (size < 0) {
      throw new RangeError('"size" argument must not be negative')
    }
  }

  function alloc (that, size, fill, encoding) {
    assertSize(size);
    if (size <= 0) {
      return createBuffer(that, size)
    }
    if (fill !== undefined) {
      // Only pay attention to encoding if it's a string. This
      // prevents accidentally sending in a number that would
      // be interpretted as a start offset.
      return typeof encoding === 'string'
        ? createBuffer(that, size).fill(fill, encoding)
        : createBuffer(that, size).fill(fill)
    }
    return createBuffer(that, size)
  }

  /**
   * Creates a new filled Buffer instance.
   * alloc(size[, fill[, encoding]])
   **/
  Buffer.alloc = function (size, fill, encoding) {
    return alloc(null, size, fill, encoding)
  };

  function allocUnsafe (that, size) {
    assertSize(size);
    that = createBuffer(that, size < 0 ? 0 : checked(size) | 0);
    if (!Buffer.TYPED_ARRAY_SUPPORT) {
      for (var i = 0; i < size; ++i) {
        that[i] = 0;
      }
    }
    return that
  }

  /**
   * Equivalent to Buffer(num), by default creates a non-zero-filled Buffer instance.
   * */
  Buffer.allocUnsafe = function (size) {
    return allocUnsafe(null, size)
  };
  /**
   * Equivalent to SlowBuffer(num), by default creates a non-zero-filled Buffer instance.
   */
  Buffer.allocUnsafeSlow = function (size) {
    return allocUnsafe(null, size)
  };

  function fromString (that, string, encoding) {
    if (typeof encoding !== 'string' || encoding === '') {
      encoding = 'utf8';
    }

    if (!Buffer.isEncoding(encoding)) {
      throw new TypeError('"encoding" must be a valid string encoding')
    }

    var length = byteLength(string, encoding) | 0;
    that = createBuffer(that, length);

    var actual = that.write(string, encoding);

    if (actual !== length) {
      // Writing a hex string, for example, that contains invalid characters will
      // cause everything after the first invalid character to be ignored. (e.g.
      // 'abxxcd' will be treated as 'ab')
      that = that.slice(0, actual);
    }

    return that
  }

  function fromArrayLike (that, array) {
    var length = array.length < 0 ? 0 : checked(array.length) | 0;
    that = createBuffer(that, length);
    for (var i = 0; i < length; i += 1) {
      that[i] = array[i] & 255;
    }
    return that
  }

  function fromArrayBuffer (that, array, byteOffset, length) {
    array.byteLength; // this throws if `array` is not a valid ArrayBuffer

    if (byteOffset < 0 || array.byteLength < byteOffset) {
      throw new RangeError('\'offset\' is out of bounds')
    }

    if (array.byteLength < byteOffset + (length || 0)) {
      throw new RangeError('\'length\' is out of bounds')
    }

    if (byteOffset === undefined && length === undefined) {
      array = new Uint8Array(array);
    } else if (length === undefined) {
      array = new Uint8Array(array, byteOffset);
    } else {
      array = new Uint8Array(array, byteOffset, length);
    }

    if (Buffer.TYPED_ARRAY_SUPPORT) {
      // Return an augmented `Uint8Array` instance, for best performance
      that = array;
      that.__proto__ = Buffer.prototype;
    } else {
      // Fallback: Return an object instance of the Buffer class
      that = fromArrayLike(that, array);
    }
    return that
  }

  function fromObject (that, obj) {
    if (internalIsBuffer(obj)) {
      var len = checked(obj.length) | 0;
      that = createBuffer(that, len);

      if (that.length === 0) {
        return that
      }

      obj.copy(that, 0, 0, len);
      return that
    }

    if (obj) {
      if ((typeof ArrayBuffer !== 'undefined' &&
          obj.buffer instanceof ArrayBuffer) || 'length' in obj) {
        if (typeof obj.length !== 'number' || isnan(obj.length)) {
          return createBuffer(that, 0)
        }
        return fromArrayLike(that, obj)
      }

      if (obj.type === 'Buffer' && isArray$2(obj.data)) {
        return fromArrayLike(that, obj.data)
      }
    }

    throw new TypeError('First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.')
  }

  function checked (length) {
    // Note: cannot use `length < kMaxLength()` here because that fails when
    // length is NaN (which is otherwise coerced to zero.)
    if (length >= kMaxLength()) {
      throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
                           'size: 0x' + kMaxLength().toString(16) + ' bytes')
    }
    return length | 0
  }
  Buffer.isBuffer = isBuffer$1;
  function internalIsBuffer (b) {
    return !!(b != null && b._isBuffer)
  }

  Buffer.compare = function compare (a, b) {
    if (!internalIsBuffer(a) || !internalIsBuffer(b)) {
      throw new TypeError('Arguments must be Buffers')
    }

    if (a === b) return 0

    var x = a.length;
    var y = b.length;

    for (var i = 0, len = Math.min(x, y); i < len; ++i) {
      if (a[i] !== b[i]) {
        x = a[i];
        y = b[i];
        break
      }
    }

    if (x < y) return -1
    if (y < x) return 1
    return 0
  };

  Buffer.isEncoding = function isEncoding (encoding) {
    switch (String(encoding).toLowerCase()) {
      case 'hex':
      case 'utf8':
      case 'utf-8':
      case 'ascii':
      case 'latin1':
      case 'binary':
      case 'base64':
      case 'ucs2':
      case 'ucs-2':
      case 'utf16le':
      case 'utf-16le':
        return true
      default:
        return false
    }
  };

  Buffer.concat = function concat (list, length) {
    if (!isArray$2(list)) {
      throw new TypeError('"list" argument must be an Array of Buffers')
    }

    if (list.length === 0) {
      return Buffer.alloc(0)
    }

    var i;
    if (length === undefined) {
      length = 0;
      for (i = 0; i < list.length; ++i) {
        length += list[i].length;
      }
    }

    var buffer = Buffer.allocUnsafe(length);
    var pos = 0;
    for (i = 0; i < list.length; ++i) {
      var buf = list[i];
      if (!internalIsBuffer(buf)) {
        throw new TypeError('"list" argument must be an Array of Buffers')
      }
      buf.copy(buffer, pos);
      pos += buf.length;
    }
    return buffer
  };

  function byteLength (string, encoding) {
    if (internalIsBuffer(string)) {
      return string.length
    }
    if (typeof ArrayBuffer !== 'undefined' && typeof ArrayBuffer.isView === 'function' &&
        (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {
      return string.byteLength
    }
    if (typeof string !== 'string') {
      string = '' + string;
    }

    var len = string.length;
    if (len === 0) return 0

    // Use a for loop to avoid recursion
    var loweredCase = false;
    for (;;) {
      switch (encoding) {
        case 'ascii':
        case 'latin1':
        case 'binary':
          return len
        case 'utf8':
        case 'utf-8':
        case undefined:
          return utf8ToBytes(string).length
        case 'ucs2':
        case 'ucs-2':
        case 'utf16le':
        case 'utf-16le':
          return len * 2
        case 'hex':
          return len >>> 1
        case 'base64':
          return base64ToBytes(string).length
        default:
          if (loweredCase) return utf8ToBytes(string).length // assume utf8
          encoding = ('' + encoding).toLowerCase();
          loweredCase = true;
      }
    }
  }
  Buffer.byteLength = byteLength;

  function slowToString (encoding, start, end) {
    var loweredCase = false;

    // No need to verify that "this.length <= MAX_UINT32" since it's a read-only
    // property of a typed array.

    // This behaves neither like String nor Uint8Array in that we set start/end
    // to their upper/lower bounds if the value passed is out of range.
    // undefined is handled specially as per ECMA-262 6th Edition,
    // Section 13.3.3.7 Runtime Semantics: KeyedBindingInitialization.
    if (start === undefined || start < 0) {
      start = 0;
    }
    // Return early if start > this.length. Done here to prevent potential uint32
    // coercion fail below.
    if (start > this.length) {
      return ''
    }

    if (end === undefined || end > this.length) {
      end = this.length;
    }

    if (end <= 0) {
      return ''
    }

    // Force coersion to uint32. This will also coerce falsey/NaN values to 0.
    end >>>= 0;
    start >>>= 0;

    if (end <= start) {
      return ''
    }

    if (!encoding) encoding = 'utf8';

    while (true) {
      switch (encoding) {
        case 'hex':
          return hexSlice(this, start, end)

        case 'utf8':
        case 'utf-8':
          return utf8Slice(this, start, end)

        case 'ascii':
          return asciiSlice(this, start, end)

        case 'latin1':
        case 'binary':
          return latin1Slice(this, start, end)

        case 'base64':
          return base64Slice(this, start, end)

        case 'ucs2':
        case 'ucs-2':
        case 'utf16le':
        case 'utf-16le':
          return utf16leSlice(this, start, end)

        default:
          if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
          encoding = (encoding + '').toLowerCase();
          loweredCase = true;
      }
    }
  }

  // The property is used by `Buffer.isBuffer` and `is-buffer` (in Safari 5-7) to detect
  // Buffer instances.
  Buffer.prototype._isBuffer = true;

  function swap (b, n, m) {
    var i = b[n];
    b[n] = b[m];
    b[m] = i;
  }

  Buffer.prototype.swap16 = function swap16 () {
    var len = this.length;
    if (len % 2 !== 0) {
      throw new RangeError('Buffer size must be a multiple of 16-bits')
    }
    for (var i = 0; i < len; i += 2) {
      swap(this, i, i + 1);
    }
    return this
  };

  Buffer.prototype.swap32 = function swap32 () {
    var len = this.length;
    if (len % 4 !== 0) {
      throw new RangeError('Buffer size must be a multiple of 32-bits')
    }
    for (var i = 0; i < len; i += 4) {
      swap(this, i, i + 3);
      swap(this, i + 1, i + 2);
    }
    return this
  };

  Buffer.prototype.swap64 = function swap64 () {
    var len = this.length;
    if (len % 8 !== 0) {
      throw new RangeError('Buffer size must be a multiple of 64-bits')
    }
    for (var i = 0; i < len; i += 8) {
      swap(this, i, i + 7);
      swap(this, i + 1, i + 6);
      swap(this, i + 2, i + 5);
      swap(this, i + 3, i + 4);
    }
    return this
  };

  Buffer.prototype.toString = function toString () {
    var length = this.length | 0;
    if (length === 0) return ''
    if (arguments.length === 0) return utf8Slice(this, 0, length)
    return slowToString.apply(this, arguments)
  };

  Buffer.prototype.equals = function equals (b) {
    if (!internalIsBuffer(b)) throw new TypeError('Argument must be a Buffer')
    if (this === b) return true
    return Buffer.compare(this, b) === 0
  };

  Buffer.prototype.inspect = function inspect () {
    var str = '';
    var max = INSPECT_MAX_BYTES;
    if (this.length > 0) {
      str = this.toString('hex', 0, max).match(/.{2}/g).join(' ');
      if (this.length > max) str += ' ... ';
    }
    return '<Buffer ' + str + '>'
  };

  Buffer.prototype.compare = function compare (target, start, end, thisStart, thisEnd) {
    if (!internalIsBuffer(target)) {
      throw new TypeError('Argument must be a Buffer')
    }

    if (start === undefined) {
      start = 0;
    }
    if (end === undefined) {
      end = target ? target.length : 0;
    }
    if (thisStart === undefined) {
      thisStart = 0;
    }
    if (thisEnd === undefined) {
      thisEnd = this.length;
    }

    if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
      throw new RangeError('out of range index')
    }

    if (thisStart >= thisEnd && start >= end) {
      return 0
    }
    if (thisStart >= thisEnd) {
      return -1
    }
    if (start >= end) {
      return 1
    }

    start >>>= 0;
    end >>>= 0;
    thisStart >>>= 0;
    thisEnd >>>= 0;

    if (this === target) return 0

    var x = thisEnd - thisStart;
    var y = end - start;
    var len = Math.min(x, y);

    var thisCopy = this.slice(thisStart, thisEnd);
    var targetCopy = target.slice(start, end);

    for (var i = 0; i < len; ++i) {
      if (thisCopy[i] !== targetCopy[i]) {
        x = thisCopy[i];
        y = targetCopy[i];
        break
      }
    }

    if (x < y) return -1
    if (y < x) return 1
    return 0
  };

  // Finds either the first index of `val` in `buffer` at offset >= `byteOffset`,
  // OR the last index of `val` in `buffer` at offset <= `byteOffset`.
  //
  // Arguments:
  // - buffer - a Buffer to search
  // - val - a string, Buffer, or number
  // - byteOffset - an index into `buffer`; will be clamped to an int32
  // - encoding - an optional encoding, relevant is val is a string
  // - dir - true for indexOf, false for lastIndexOf
  function bidirectionalIndexOf (buffer, val, byteOffset, encoding, dir) {
    // Empty buffer means no match
    if (buffer.length === 0) return -1

    // Normalize byteOffset
    if (typeof byteOffset === 'string') {
      encoding = byteOffset;
      byteOffset = 0;
    } else if (byteOffset > 0x7fffffff) {
      byteOffset = 0x7fffffff;
    } else if (byteOffset < -0x80000000) {
      byteOffset = -0x80000000;
    }
    byteOffset = +byteOffset;  // Coerce to Number.
    if (isNaN(byteOffset)) {
      // byteOffset: it it's undefined, null, NaN, "foo", etc, search whole buffer
      byteOffset = dir ? 0 : (buffer.length - 1);
    }

    // Normalize byteOffset: negative offsets start from the end of the buffer
    if (byteOffset < 0) byteOffset = buffer.length + byteOffset;
    if (byteOffset >= buffer.length) {
      if (dir) return -1
      else byteOffset = buffer.length - 1;
    } else if (byteOffset < 0) {
      if (dir) byteOffset = 0;
      else return -1
    }

    // Normalize val
    if (typeof val === 'string') {
      val = Buffer.from(val, encoding);
    }

    // Finally, search either indexOf (if dir is true) or lastIndexOf
    if (internalIsBuffer(val)) {
      // Special case: looking for empty string/buffer always fails
      if (val.length === 0) {
        return -1
      }
      return arrayIndexOf(buffer, val, byteOffset, encoding, dir)
    } else if (typeof val === 'number') {
      val = val & 0xFF; // Search for a byte value [0-255]
      if (Buffer.TYPED_ARRAY_SUPPORT &&
          typeof Uint8Array.prototype.indexOf === 'function') {
        if (dir) {
          return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset)
        } else {
          return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset)
        }
      }
      return arrayIndexOf(buffer, [ val ], byteOffset, encoding, dir)
    }

    throw new TypeError('val must be string, number or Buffer')
  }

  function arrayIndexOf (arr, val, byteOffset, encoding, dir) {
    var indexSize = 1;
    var arrLength = arr.length;
    var valLength = val.length;

    if (encoding !== undefined) {
      encoding = String(encoding).toLowerCase();
      if (encoding === 'ucs2' || encoding === 'ucs-2' ||
          encoding === 'utf16le' || encoding === 'utf-16le') {
        if (arr.length < 2 || val.length < 2) {
          return -1
        }
        indexSize = 2;
        arrLength /= 2;
        valLength /= 2;
        byteOffset /= 2;
      }
    }

    function read (buf, i) {
      if (indexSize === 1) {
        return buf[i]
      } else {
        return buf.readUInt16BE(i * indexSize)
      }
    }

    var i;
    if (dir) {
      var foundIndex = -1;
      for (i = byteOffset; i < arrLength; i++) {
        if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
          if (foundIndex === -1) foundIndex = i;
          if (i - foundIndex + 1 === valLength) return foundIndex * indexSize
        } else {
          if (foundIndex !== -1) i -= i - foundIndex;
          foundIndex = -1;
        }
      }
    } else {
      if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength;
      for (i = byteOffset; i >= 0; i--) {
        var found = true;
        for (var j = 0; j < valLength; j++) {
          if (read(arr, i + j) !== read(val, j)) {
            found = false;
            break
          }
        }
        if (found) return i
      }
    }

    return -1
  }

  Buffer.prototype.includes = function includes (val, byteOffset, encoding) {
    return this.indexOf(val, byteOffset, encoding) !== -1
  };

  Buffer.prototype.indexOf = function indexOf (val, byteOffset, encoding) {
    return bidirectionalIndexOf(this, val, byteOffset, encoding, true)
  };

  Buffer.prototype.lastIndexOf = function lastIndexOf (val, byteOffset, encoding) {
    return bidirectionalIndexOf(this, val, byteOffset, encoding, false)
  };

  function hexWrite (buf, string, offset, length) {
    offset = Number(offset) || 0;
    var remaining = buf.length - offset;
    if (!length) {
      length = remaining;
    } else {
      length = Number(length);
      if (length > remaining) {
        length = remaining;
      }
    }

    // must be an even number of digits
    var strLen = string.length;
    if (strLen % 2 !== 0) throw new TypeError('Invalid hex string')

    if (length > strLen / 2) {
      length = strLen / 2;
    }
    for (var i = 0; i < length; ++i) {
      var parsed = parseInt(string.substr(i * 2, 2), 16);
      if (isNaN(parsed)) return i
      buf[offset + i] = parsed;
    }
    return i
  }

  function utf8Write (buf, string, offset, length) {
    return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)
  }

  function asciiWrite (buf, string, offset, length) {
    return blitBuffer(asciiToBytes(string), buf, offset, length)
  }

  function latin1Write (buf, string, offset, length) {
    return asciiWrite(buf, string, offset, length)
  }

  function base64Write (buf, string, offset, length) {
    return blitBuffer(base64ToBytes(string), buf, offset, length)
  }

  function ucs2Write (buf, string, offset, length) {
    return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)
  }

  Buffer.prototype.write = function write (string, offset, length, encoding) {
    // Buffer#write(string)
    if (offset === undefined) {
      encoding = 'utf8';
      length = this.length;
      offset = 0;
    // Buffer#write(string, encoding)
    } else if (length === undefined && typeof offset === 'string') {
      encoding = offset;
      length = this.length;
      offset = 0;
    // Buffer#write(string, offset[, length][, encoding])
    } else if (isFinite(offset)) {
      offset = offset | 0;
      if (isFinite(length)) {
        length = length | 0;
        if (encoding === undefined) encoding = 'utf8';
      } else {
        encoding = length;
        length = undefined;
      }
    // legacy write(string, encoding, offset, length) - remove in v0.13
    } else {
      throw new Error(
        'Buffer.write(string, encoding, offset[, length]) is no longer supported'
      )
    }

    var remaining = this.length - offset;
    if (length === undefined || length > remaining) length = remaining;

    if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
      throw new RangeError('Attempt to write outside buffer bounds')
    }

    if (!encoding) encoding = 'utf8';

    var loweredCase = false;
    for (;;) {
      switch (encoding) {
        case 'hex':
          return hexWrite(this, string, offset, length)

        case 'utf8':
        case 'utf-8':
          return utf8Write(this, string, offset, length)

        case 'ascii':
          return asciiWrite(this, string, offset, length)

        case 'latin1':
        case 'binary':
          return latin1Write(this, string, offset, length)

        case 'base64':
          // Warning: maxLength not taken into account in base64Write
          return base64Write(this, string, offset, length)

        case 'ucs2':
        case 'ucs-2':
        case 'utf16le':
        case 'utf-16le':
          return ucs2Write(this, string, offset, length)

        default:
          if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
          encoding = ('' + encoding).toLowerCase();
          loweredCase = true;
      }
    }
  };

  Buffer.prototype.toJSON = function toJSON () {
    return {
      type: 'Buffer',
      data: Array.prototype.slice.call(this._arr || this, 0)
    }
  };

  function base64Slice (buf, start, end) {
    if (start === 0 && end === buf.length) {
      return fromByteArray(buf)
    } else {
      return fromByteArray(buf.slice(start, end))
    }
  }

  function utf8Slice (buf, start, end) {
    end = Math.min(buf.length, end);
    var res = [];

    var i = start;
    while (i < end) {
      var firstByte = buf[i];
      var codePoint = null;
      var bytesPerSequence = (firstByte > 0xEF) ? 4
        : (firstByte > 0xDF) ? 3
        : (firstByte > 0xBF) ? 2
        : 1;

      if (i + bytesPerSequence <= end) {
        var secondByte, thirdByte, fourthByte, tempCodePoint;

        switch (bytesPerSequence) {
          case 1:
            if (firstByte < 0x80) {
              codePoint = firstByte;
            }
            break
          case 2:
            secondByte = buf[i + 1];
            if ((secondByte & 0xC0) === 0x80) {
              tempCodePoint = (firstByte & 0x1F) << 0x6 | (secondByte & 0x3F);
              if (tempCodePoint > 0x7F) {
                codePoint = tempCodePoint;
              }
            }
            break
          case 3:
            secondByte = buf[i + 1];
            thirdByte = buf[i + 2];
            if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
              tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | (thirdByte & 0x3F);
              if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
                codePoint = tempCodePoint;
              }
            }
            break
          case 4:
            secondByte = buf[i + 1];
            thirdByte = buf[i + 2];
            fourthByte = buf[i + 3];
            if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
              tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | (fourthByte & 0x3F);
              if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
                codePoint = tempCodePoint;
              }
            }
        }
      }

      if (codePoint === null) {
        // we did not generate a valid codePoint so insert a
        // replacement char (U+FFFD) and advance only 1 byte
        codePoint = 0xFFFD;
        bytesPerSequence = 1;
      } else if (codePoint > 0xFFFF) {
        // encode to utf16 (surrogate pair dance)
        codePoint -= 0x10000;
        res.push(codePoint >>> 10 & 0x3FF | 0xD800);
        codePoint = 0xDC00 | codePoint & 0x3FF;
      }

      res.push(codePoint);
      i += bytesPerSequence;
    }

    return decodeCodePointsArray(res)
  }

  // Based on http://stackoverflow.com/a/22747272/680742, the browser with
  // the lowest limit is Chrome, with 0x10000 args.
  // We go 1 magnitude less, for safety
  var MAX_ARGUMENTS_LENGTH = 0x1000;

  function decodeCodePointsArray (codePoints) {
    var len = codePoints.length;
    if (len <= MAX_ARGUMENTS_LENGTH) {
      return String.fromCharCode.apply(String, codePoints) // avoid extra slice()
    }

    // Decode in chunks to avoid "call stack size exceeded".
    var res = '';
    var i = 0;
    while (i < len) {
      res += String.fromCharCode.apply(
        String,
        codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)
      );
    }
    return res
  }

  function asciiSlice (buf, start, end) {
    var ret = '';
    end = Math.min(buf.length, end);

    for (var i = start; i < end; ++i) {
      ret += String.fromCharCode(buf[i] & 0x7F);
    }
    return ret
  }

  function latin1Slice (buf, start, end) {
    var ret = '';
    end = Math.min(buf.length, end);

    for (var i = start; i < end; ++i) {
      ret += String.fromCharCode(buf[i]);
    }
    return ret
  }

  function hexSlice (buf, start, end) {
    var len = buf.length;

    if (!start || start < 0) start = 0;
    if (!end || end < 0 || end > len) end = len;

    var out = '';
    for (var i = start; i < end; ++i) {
      out += toHex(buf[i]);
    }
    return out
  }

  function utf16leSlice (buf, start, end) {
    var bytes = buf.slice(start, end);
    var res = '';
    for (var i = 0; i < bytes.length; i += 2) {
      res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256);
    }
    return res
  }

  Buffer.prototype.slice = function slice (start, end) {
    var len = this.length;
    start = ~~start;
    end = end === undefined ? len : ~~end;

    if (start < 0) {
      start += len;
      if (start < 0) start = 0;
    } else if (start > len) {
      start = len;
    }

    if (end < 0) {
      end += len;
      if (end < 0) end = 0;
    } else if (end > len) {
      end = len;
    }

    if (end < start) end = start;

    var newBuf;
    if (Buffer.TYPED_ARRAY_SUPPORT) {
      newBuf = this.subarray(start, end);
      newBuf.__proto__ = Buffer.prototype;
    } else {
      var sliceLen = end - start;
      newBuf = new Buffer(sliceLen, undefined);
      for (var i = 0; i < sliceLen; ++i) {
        newBuf[i] = this[i + start];
      }
    }

    return newBuf
  };

  /*
   * Need to make sure that buffer isn't trying to write out of bounds.
   */
  function checkOffset (offset, ext, length) {
    if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
    if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
  }

  Buffer.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
    offset = offset | 0;
    byteLength = byteLength | 0;
    if (!noAssert) checkOffset(offset, byteLength, this.length);

    var val = this[offset];
    var mul = 1;
    var i = 0;
    while (++i < byteLength && (mul *= 0x100)) {
      val += this[offset + i] * mul;
    }

    return val
  };

  Buffer.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
    offset = offset | 0;
    byteLength = byteLength | 0;
    if (!noAssert) {
      checkOffset(offset, byteLength, this.length);
    }

    var val = this[offset + --byteLength];
    var mul = 1;
    while (byteLength > 0 && (mul *= 0x100)) {
      val += this[offset + --byteLength] * mul;
    }

    return val
  };

  Buffer.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 1, this.length);
    return this[offset]
  };

  Buffer.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 2, this.length);
    return this[offset] | (this[offset + 1] << 8)
  };

  Buffer.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 2, this.length);
    return (this[offset] << 8) | this[offset + 1]
  };

  Buffer.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 4, this.length);

    return ((this[offset]) |
        (this[offset + 1] << 8) |
        (this[offset + 2] << 16)) +
        (this[offset + 3] * 0x1000000)
  };

  Buffer.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 4, this.length);

    return (this[offset] * 0x1000000) +
      ((this[offset + 1] << 16) |
      (this[offset + 2] << 8) |
      this[offset + 3])
  };

  Buffer.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
    offset = offset | 0;
    byteLength = byteLength | 0;
    if (!noAssert) checkOffset(offset, byteLength, this.length);

    var val = this[offset];
    var mul = 1;
    var i = 0;
    while (++i < byteLength && (mul *= 0x100)) {
      val += this[offset + i] * mul;
    }
    mul *= 0x80;

    if (val >= mul) val -= Math.pow(2, 8 * byteLength);

    return val
  };

  Buffer.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
    offset = offset | 0;
    byteLength = byteLength | 0;
    if (!noAssert) checkOffset(offset, byteLength, this.length);

    var i = byteLength;
    var mul = 1;
    var val = this[offset + --i];
    while (i > 0 && (mul *= 0x100)) {
      val += this[offset + --i] * mul;
    }
    mul *= 0x80;

    if (val >= mul) val -= Math.pow(2, 8 * byteLength);

    return val
  };

  Buffer.prototype.readInt8 = function readInt8 (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 1, this.length);
    if (!(this[offset] & 0x80)) return (this[offset])
    return ((0xff - this[offset] + 1) * -1)
  };

  Buffer.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 2, this.length);
    var val = this[offset] | (this[offset + 1] << 8);
    return (val & 0x8000) ? val | 0xFFFF0000 : val
  };

  Buffer.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 2, this.length);
    var val = this[offset + 1] | (this[offset] << 8);
    return (val & 0x8000) ? val | 0xFFFF0000 : val
  };

  Buffer.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 4, this.length);

    return (this[offset]) |
      (this[offset + 1] << 8) |
      (this[offset + 2] << 16) |
      (this[offset + 3] << 24)
  };

  Buffer.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 4, this.length);

    return (this[offset] << 24) |
      (this[offset + 1] << 16) |
      (this[offset + 2] << 8) |
      (this[offset + 3])
  };

  Buffer.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 4, this.length);
    return read(this, offset, true, 23, 4)
  };

  Buffer.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 4, this.length);
    return read(this, offset, false, 23, 4)
  };

  Buffer.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 8, this.length);
    return read(this, offset, true, 52, 8)
  };

  Buffer.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
    if (!noAssert) checkOffset(offset, 8, this.length);
    return read(this, offset, false, 52, 8)
  };

  function checkInt (buf, value, offset, ext, max, min) {
    if (!internalIsBuffer(buf)) throw new TypeError('"buffer" argument must be a Buffer instance')
    if (value > max || value < min) throw new RangeError('"value" argument is out of bounds')
    if (offset + ext > buf.length) throw new RangeError('Index out of range')
  }

  Buffer.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
    value = +value;
    offset = offset | 0;
    byteLength = byteLength | 0;
    if (!noAssert) {
      var maxBytes = Math.pow(2, 8 * byteLength) - 1;
      checkInt(this, value, offset, byteLength, maxBytes, 0);
    }

    var mul = 1;
    var i = 0;
    this[offset] = value & 0xFF;
    while (++i < byteLength && (mul *= 0x100)) {
      this[offset + i] = (value / mul) & 0xFF;
    }

    return offset + byteLength
  };

  Buffer.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
    value = +value;
    offset = offset | 0;
    byteLength = byteLength | 0;
    if (!noAssert) {
      var maxBytes = Math.pow(2, 8 * byteLength) - 1;
      checkInt(this, value, offset, byteLength, maxBytes, 0);
    }

    var i = byteLength - 1;
    var mul = 1;
    this[offset + i] = value & 0xFF;
    while (--i >= 0 && (mul *= 0x100)) {
      this[offset + i] = (value / mul) & 0xFF;
    }

    return offset + byteLength
  };

  Buffer.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
    value = +value;
    offset = offset | 0;
    if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0);
    if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
    this[offset] = (value & 0xff);
    return offset + 1
  };

  function objectWriteUInt16 (buf, value, offset, littleEndian) {
    if (value < 0) value = 0xffff + value + 1;
    for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {
      buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>
        (littleEndian ? i : 1 - i) * 8;
    }
  }

  Buffer.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
    value = +value;
    offset = offset | 0;
    if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);
    if (Buffer.TYPED_ARRAY_SUPPORT) {
      this[offset] = (value & 0xff);
      this[offset + 1] = (value >>> 8);
    } else {
      objectWriteUInt16(this, value, offset, true);
    }
    return offset + 2
  };

  Buffer.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
    value = +value;
    offset = offset | 0;
    if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);
    if (Buffer.TYPED_ARRAY_SUPPORT) {
      this[offset] = (value >>> 8);
      this[offset + 1] = (value & 0xff);
    } else {
      objectWriteUInt16(this, value, offset, false);
    }
    return offset + 2
  };

  function objectWriteUInt32 (buf, value, offset, littleEndian) {
    if (value < 0) value = 0xffffffff + value + 1;
    for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {
      buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff;
    }
  }

  Buffer.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
    value = +value;
    offset = offset | 0;
    if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);
    if (Buffer.TYPED_ARRAY_SUPPORT) {
      this[offset + 3] = (value >>> 24);
      this[offset + 2] = (value >>> 16);
      this[offset + 1] = (value >>> 8);
      this[offset] = (value & 0xff);
    } else {
      objectWriteUInt32(this, value, offset, true);
    }
    return offset + 4
  };

  Buffer.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
    value = +value;
    offset = offset | 0;
    if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);
    if (Buffer.TYPED_ARRAY_SUPPORT) {
      this[offset] = (value >>> 24);
      this[offset + 1] = (value >>> 16);
      this[offset + 2] = (value >>> 8);
      this[offset + 3] = (value & 0xff);
    } else {
      objectWriteUInt32(this, value, offset, false);
    }
    return offset + 4
  };

  Buffer.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
    value = +value;
    offset = offset | 0;
    if (!noAssert) {
      var limit = Math.pow(2, 8 * byteLength - 1);

      checkInt(this, value, offset, byteLength, limit - 1, -limit);
    }

    var i = 0;
    var mul = 1;
    var sub = 0;
    this[offset] = value & 0xFF;
    while (++i < byteLength && (mul *= 0x100)) {
      if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
        sub = 1;
      }
      this[offset + i] = ((value / mul) >> 0) - sub & 0xFF;
    }

    return offset + byteLength
  };

  Buffer.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
    value = +value;
    offset = offset | 0;
    if (!noAssert) {
      var limit = Math.pow(2, 8 * byteLength - 1);

      checkInt(this, value, offset, byteLength, limit - 1, -limit);
    }

    var i = byteLength - 1;
    var mul = 1;
    var sub = 0;
    this[offset + i] = value & 0xFF;
    while (--i >= 0 && (mul *= 0x100)) {
      if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
        sub = 1;
      }
      this[offset + i] = ((value / mul) >> 0) - sub & 0xFF;
    }

    return offset + byteLength
  };

  Buffer.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
    value = +value;
    offset = offset | 0;
    if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80);
    if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
    if (value < 0) value = 0xff + value + 1;
    this[offset] = (value & 0xff);
    return offset + 1
  };

  Buffer.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
    value = +value;
    offset = offset | 0;
    if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);
    if (Buffer.TYPED_ARRAY_SUPPORT) {
      this[offset] = (value & 0xff);
      this[offset + 1] = (value >>> 8);
    } else {
      objectWriteUInt16(this, value, offset, true);
    }
    return offset + 2
  };

  Buffer.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
    value = +value;
    offset = offset | 0;
    if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);
    if (Buffer.TYPED_ARRAY_SUPPORT) {
      this[offset] = (value >>> 8);
      this[offset + 1] = (value & 0xff);
    } else {
      objectWriteUInt16(this, value, offset, false);
    }
    return offset + 2
  };

  Buffer.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
    value = +value;
    offset = offset | 0;
    if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
    if (Buffer.TYPED_ARRAY_SUPPORT) {
      this[offset] = (value & 0xff);
      this[offset + 1] = (value >>> 8);
      this[offset + 2] = (value >>> 16);
      this[offset + 3] = (value >>> 24);
    } else {
      objectWriteUInt32(this, value, offset, true);
    }
    return offset + 4
  };

  Buffer.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
    value = +value;
    offset = offset | 0;
    if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
    if (value < 0) value = 0xffffffff + value + 1;
    if (Buffer.TYPED_ARRAY_SUPPORT) {
      this[offset] = (value >>> 24);
      this[offset + 1] = (value >>> 16);
      this[offset + 2] = (value >>> 8);
      this[offset + 3] = (value & 0xff);
    } else {
      objectWriteUInt32(this, value, offset, false);
    }
    return offset + 4
  };

  function checkIEEE754 (buf, value, offset, ext, max, min) {
    if (offset + ext > buf.length) throw new RangeError('Index out of range')
    if (offset < 0) throw new RangeError('Index out of range')
  }

  function writeFloat (buf, value, offset, littleEndian, noAssert) {
    if (!noAssert) {
      checkIEEE754(buf, value, offset, 4);
    }
    write$1(buf, value, offset, littleEndian, 23, 4);
    return offset + 4
  }

  Buffer.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
    return writeFloat(this, value, offset, true, noAssert)
  };

  Buffer.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
    return writeFloat(this, value, offset, false, noAssert)
  };

  function writeDouble (buf, value, offset, littleEndian, noAssert) {
    if (!noAssert) {
      checkIEEE754(buf, value, offset, 8);
    }
    write$1(buf, value, offset, littleEndian, 52, 8);
    return offset + 8
  }

  Buffer.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
    return writeDouble(this, value, offset, true, noAssert)
  };

  Buffer.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
    return writeDouble(this, value, offset, false, noAssert)
  };

  // copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
  Buffer.prototype.copy = function copy (target, targetStart, start, end) {
    if (!start) start = 0;
    if (!end && end !== 0) end = this.length;
    if (targetStart >= target.length) targetStart = target.length;
    if (!targetStart) targetStart = 0;
    if (end > 0 && end < start) end = start;

    // Copy 0 bytes; we're done
    if (end === start) return 0
    if (target.length === 0 || this.length === 0) return 0

    // Fatal error conditions
    if (targetStart < 0) {
      throw new RangeError('targetStart out of bounds')
    }
    if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')
    if (end < 0) throw new RangeError('sourceEnd out of bounds')

    // Are we oob?
    if (end > this.length) end = this.length;
    if (target.length - targetStart < end - start) {
      end = target.length - targetStart + start;
    }

    var len = end - start;
    var i;

    if (this === target && start < targetStart && targetStart < end) {
      // descending copy from end
      for (i = len - 1; i >= 0; --i) {
        target[i + targetStart] = this[i + start];
      }
    } else if (len < 1000 || !Buffer.TYPED_ARRAY_SUPPORT) {
      // ascending copy from start
      for (i = 0; i < len; ++i) {
        target[i + targetStart] = this[i + start];
      }
    } else {
      Uint8Array.prototype.set.call(
        target,
        this.subarray(start, start + len),
        targetStart
      );
    }

    return len
  };

  // Usage:
  //    buffer.fill(number[, offset[, end]])
  //    buffer.fill(buffer[, offset[, end]])
  //    buffer.fill(string[, offset[, end]][, encoding])
  Buffer.prototype.fill = function fill (val, start, end, encoding) {
    // Handle string cases:
    if (typeof val === 'string') {
      if (typeof start === 'string') {
        encoding = start;
        start = 0;
        end = this.length;
      } else if (typeof end === 'string') {
        encoding = end;
        end = this.length;
      }
      if (val.length === 1) {
        var code = val.charCodeAt(0);
        if (code < 256) {
          val = code;
        }
      }
      if (encoding !== undefined && typeof encoding !== 'string') {
        throw new TypeError('encoding must be a string')
      }
      if (typeof encoding === 'string' && !Buffer.isEncoding(encoding)) {
        throw new TypeError('Unknown encoding: ' + encoding)
      }
    } else if (typeof val === 'number') {
      val = val & 255;
    }

    // Invalid ranges are not set to a default, so can range check early.
    if (start < 0 || this.length < start || this.length < end) {
      throw new RangeError('Out of range index')
    }

    if (end <= start) {
      return this
    }

    start = start >>> 0;
    end = end === undefined ? this.length : end >>> 0;

    if (!val) val = 0;

    var i;
    if (typeof val === 'number') {
      for (i = start; i < end; ++i) {
        this[i] = val;
      }
    } else {
      var bytes = internalIsBuffer(val)
        ? val
        : utf8ToBytes(new Buffer(val, encoding).toString());
      var len = bytes.length;
      for (i = 0; i < end - start; ++i) {
        this[i + start] = bytes[i % len];
      }
    }

    return this
  };

  // HELPER FUNCTIONS
  // ================

  var INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g;

  function base64clean (str) {
    // Node strips out invalid characters like \n and \t from the string, base64-js does not
    str = stringtrim(str).replace(INVALID_BASE64_RE, '');
    // Node converts strings with length < 2 to ''
    if (str.length < 2) return ''
    // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
    while (str.length % 4 !== 0) {
      str = str + '=';
    }
    return str
  }

  function stringtrim (str) {
    if (str.trim) return str.trim()
    return str.replace(/^\s+|\s+$/g, '')
  }

  function toHex (n) {
    if (n < 16) return '0' + n.toString(16)
    return n.toString(16)
  }

  function utf8ToBytes (string, units) {
    units = units || Infinity;
    var codePoint;
    var length = string.length;
    var leadSurrogate = null;
    var bytes = [];

    for (var i = 0; i < length; ++i) {
      codePoint = string.charCodeAt(i);

      // is surrogate component
      if (codePoint > 0xD7FF && codePoint < 0xE000) {
        // last char was a lead
        if (!leadSurrogate) {
          // no lead yet
          if (codePoint > 0xDBFF) {
            // unexpected trail
            if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
            continue
          } else if (i + 1 === length) {
            // unpaired lead
            if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
            continue
          }

          // valid lead
          leadSurrogate = codePoint;

          continue
        }

        // 2 leads in a row
        if (codePoint < 0xDC00) {
          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
          leadSurrogate = codePoint;
          continue
        }

        // valid surrogate pair
        codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000;
      } else if (leadSurrogate) {
        // valid bmp char, but last char was a lead
        if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
      }

      leadSurrogate = null;

      // encode utf8
      if (codePoint < 0x80) {
        if ((units -= 1) < 0) break
        bytes.push(codePoint);
      } else if (codePoint < 0x800) {
        if ((units -= 2) < 0) break
        bytes.push(
          codePoint >> 0x6 | 0xC0,
          codePoint & 0x3F | 0x80
        );
      } else if (codePoint < 0x10000) {
        if ((units -= 3) < 0) break
        bytes.push(
          codePoint >> 0xC | 0xE0,
          codePoint >> 0x6 & 0x3F | 0x80,
          codePoint & 0x3F | 0x80
        );
      } else if (codePoint < 0x110000) {
        if ((units -= 4) < 0) break
        bytes.push(
          codePoint >> 0x12 | 0xF0,
          codePoint >> 0xC & 0x3F | 0x80,
          codePoint >> 0x6 & 0x3F | 0x80,
          codePoint & 0x3F | 0x80
        );
      } else {
        throw new Error('Invalid code point')
      }
    }

    return bytes
  }

  function asciiToBytes (str) {
    var byteArray = [];
    for (var i = 0; i < str.length; ++i) {
      // Node's code seems to be doing this and not & 0x7F..
      byteArray.push(str.charCodeAt(i) & 0xFF);
    }
    return byteArray
  }

  function utf16leToBytes (str, units) {
    var c, hi, lo;
    var byteArray = [];
    for (var i = 0; i < str.length; ++i) {
      if ((units -= 2) < 0) break

      c = str.charCodeAt(i);
      hi = c >> 8;
      lo = c % 256;
      byteArray.push(lo);
      byteArray.push(hi);
    }

    return byteArray
  }


  function base64ToBytes (str) {
    return toByteArray(base64clean(str))
  }

  function blitBuffer (src, dst, offset, length) {
    for (var i = 0; i < length; ++i) {
      if ((i + offset >= dst.length) || (i >= src.length)) break
      dst[i + offset] = src[i];
    }
    return i
  }

  function isnan (val) {
    return val !== val // eslint-disable-line no-self-compare
  }


  // the following is from is-buffer, also by Feross Aboukhadijeh and with same lisence
  // The _isBuffer check is for Safari 5-7 support, because it's missing
  // Object.prototype.constructor. Remove this eventually
  function isBuffer$1(obj) {
    return obj != null && (!!obj._isBuffer || isFastBuffer(obj) || isSlowBuffer(obj))
  }

  function isFastBuffer (obj) {
    return !!obj.constructor && typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj)
  }

  // For Node v0.10 support. Remove this eventually.
  function isSlowBuffer (obj) {
    return typeof obj.readFloatLE === 'function' && typeof obj.slice === 'function' && isFastBuffer(obj.slice(0, 0))
  }

  //全局定义部分

  var SALT_LEN = 2;
  var ZERO_LEN = 7;
  var DELTA = 0x9e3779b9;
  var ROUNDS = 16;

  var AuthBufferService = function AuthBufferService(sdkappid, roomID, openID, secKey) {
    if (typeof sdkappid === 'undefined') {
      process$4.exit(1);
    }

    this.sdkappid = sdkappid;
    this.roomId = roomID;
    this.openID = openID;
    this.secKey = secKey;
    this.EncrpySignature = Buffer.alloc(512);
    this.EncrpySignatureValidLength = 0;
  };
  /**
   * uin8
   * @returns {number}
   */


  function randomUint8() {
    var cRand = Math.ceil(Math.random() * 255); //cRand = 93;

    return cRand;
  }
  /**
   * @return {number}
   */


  function MakeInt2Uint(intValue) {
    if (intValue < 0) {
      return intValue + 0xffffffff + 1;
    }

    if (intValue > 0xffffffff) {
      return intValue - 0xffffffff - 1;
    }

    return intValue;
  }

  var BufferAppand = function BufferAppand(buf1, buf2) {
    var tmp = new Buffer(buf1.length + buf2.length);
    buf1.copy(tmp, 0);
    buf2.copy(tmp, buf1.length);
    return tmp;
  };

  AuthBufferService.prototype.OI_TeaEncryptECB_1 = function (pInBuf, pKey) {
    //console.log(pInBuf);
    var y = pInBuf.readUInt32BE(0);
    var z = pInBuf.readUInt32BE(4); //4个Int型的数组

    var k0 = pKey.readUInt32BE(0);
    var k1 = pKey.readUInt32BE(4);
    var k2 = pKey.readUInt32BE(8);
    var k3 = pKey.readUInt32BE(12);
    var sum = 0;

    for (var i = 0; i < ROUNDS; i++) {
      sum += DELTA;
      var yMargin = MakeInt2Uint((z << 4) + k0 ^ z + sum ^ (z >>> 5) + k1);
      y = MakeInt2Uint(y + yMargin); //console.log(y);

      var zMargin = MakeInt2Uint((y << 4) + k2 ^ y + sum ^ (y >>> 5) + k3);
      z = MakeInt2Uint(z + zMargin); //console.log(z);
    }

    var bufferRet = Buffer.alloc(8);
    bufferRet.writeUInt32BE(y);
    bufferRet.writeUInt32BE(z, 4);
    return bufferRet;
  };

  AuthBufferService.prototype.getEncrpyBuffer = function () {
    //过期时间, 默认是永远不过期
    var timeStampExp = 2100000000;
    var nTotalLength = 25 + this.openID.length + this.roomId.length;
    var buf = Buffer.alloc(nTotalLength);
    var nOffset = 0; //cVer

    buf.writeUInt8(1, nOffset);
    nOffset += 1; //wOpenIDLen

    buf.writeUInt16BE(this.openID.length, nOffset);
    nOffset += 2; //strOpenID

    buf.fill(Buffer.from(this.openID), nOffset, nOffset + this.openID.length, 'utf-8');
    nOffset += this.openID.length; //dwSdkAppId

    buf.writeUInt32BE(this.sdkappid, nOffset);
    nOffset += 4; //dwReserve, 历史上是存放房间ID

    buf.writeUInt32BE(0, nOffset);
    nOffset += 4; //expTime

    buf.writeUInt32BE(timeStampExp, nOffset);
    nOffset += 4; //nAuthBits

    buf.writeUInt32BE(0xffffffff, nOffset);
    nOffset += 4; //dwReserve

    buf.writeUInt32BE(0, nOffset);
    nOffset += 4; //wRoomIDLength

    buf.writeInt16BE(this.roomId.length, nOffset);
    nOffset += 2; //strRoomID

    buf.fill(Buffer.from(this.roomId), nOffset, nOffset + this.roomId.length, 'utf-8');
    nOffset += this.roomId.length;

    if (nOffset !== nOffset) {
      //拼接完成, 检查长度
      return null;
    } //console.log(buf);


    return buf;
  };

  AuthBufferService.prototype.encrypt = function (bufferToEncrpy, authKey) {
    /*PadLen(1byte)+Salt+Body+Zero的长度 */
    var nInBufLen = bufferToEncrpy.length;
    var nPadSaltBodyZeroLen = nInBufLen
    /*Body长度 */
    + 1 + SALT_LEN + ZERO_LEN;
    /*PadLen(1byte)+Salt(2byte)+Zero(7byte) */

    var nPadlen = nPadSaltBodyZeroLen % 8;
    /*len=nSaltBodyZeroLen%8 */

    if (nPadlen !== 0) {
      /*模8余0需补0,余1补7,余2补6,...,余7补1 */
      nPadlen = 8 - nPadlen;
    }

    var bufferEncrpyFinal = Buffer.alloc(0);
    var src_buf = Buffer.alloc(8);
    var cRand = randomUint8();
    /*加密第一块数据(8byte),取前面10byte */

    var varFirst = cRand & 0x0f8
    /*最低三位存PadLen,清零 */
    | nPadlen;
    src_buf.writeUInt8(varFirst);
    var src_i = 1;
    /*src_i指向src_buf下一个位置 */

    while (nPadlen--) {
      src_buf[src_i++] = randomUint8();
      /*Padding */
    } //console.log(src_buf);


    var i = 0;
    var zero_iv = Buffer.alloc(8);
    var iv_buf = Buffer.alloc(8);

    for (var _i = 1; _i <= SALT_LEN
    /*Salt(2byte) */
    ;) {
      if (src_i < 8) {
        src_buf[src_i++] = randomUint8();
        _i++;
        /*i inc in here */
      }

      if (src_i === 8) {
        for (var j = 0; j < 8; j++
        /*CBC XOR */
        ) {
          src_buf[j] ^= iv_buf[j];
        }

        var bufT = this.OI_TeaEncryptECB_1(src_buf, authKey); //console.log(bufT);

        bufferEncrpyFinal = BufferAppand(bufferEncrpyFinal, bufT); //console.log(bufferEncrpyFinal);

        iv_buf = bufT;
        src_i = 0;
        /*dest_i指向dest_buf下一个位置 */
      }
    }

    var pInBufIndex = 0;

    while (nInBufLen) {
      if (src_i < 8) {
        src_buf[src_i++] = bufferToEncrpy[pInBufIndex++];
        nInBufLen--;
      }

      if (src_i === 8) {
        /*src_i==8 */
        for (i = 0; i < 8; i++
        /*CBC XOR */
        ) {
          src_buf[i] ^= iv_buf[i];
        }
        /*pOutBuffer、pInBuffer均为8byte, pKey为16byte */


        var _bufT = this.OI_TeaEncryptECB_1(src_buf, authKey);

        src_i = 0;
        bufferEncrpyFinal = BufferAppand(bufferEncrpyFinal, _bufT); //console.log(bufferEncrpyFinal)

        iv_buf = _bufT;
      }
    }
    /*src_i指向src_buf下一个位置 */


    for (var _i2 = 1; _i2 <= ZERO_LEN;) {
      if (src_i < 8) {
        src_buf[src_i++] = 0;
        _i2++;
        /*i inc in here */
      }

      if (src_i === 8) {
        /*src_i==8 */
        for (var _j = 0; _j < 8; _j++
        /*CBC XOR */
        ) {
          src_buf[_j] ^= iv_buf[_j];
        }
        /*pOutBuffer、pInBuffer均为8byte, pKey为16byte */


        var _bufT2 = this.OI_TeaEncryptECB_1(src_buf, authKey);

        bufferEncrpyFinal = BufferAppand(bufferEncrpyFinal, _bufT2);
        src_i = 0;
        iv_buf = _bufT2;
      }
    }

    return bufferEncrpyFinal;
  };

  AuthBufferService.prototype.getSignature = function () {
    if (this.openID.toString() === '') {
      return null;
    }

    if (this.roomId.toString() === '') {
      return null;
    }

    if (this.secKey.toString().length !== 16) {
      return null;
    }

    var encrpyBuffer = this.getEncrpyBuffer();

    if (null == encrpyBuffer) {
      return null;
    }

    var authKey = Buffer.from(this.secKey, 'utf-8');
    var signature = this.encrypt(encrpyBuffer, authKey);
    console.log(signature);
    return signature.toString('base64');
  };

  window.AuthBufferService = AuthBufferService;

  var UseTestEnv = false;
  TRTC.Logger.enableUploadLog();

  function ReportSelfVersion(appid) {
    logger.info('report');
  }

  function WebGMEAPI() {
    WebGMEAPI.callbacks = function (event, result) {};

    WebGMEAPI.Param = {};
    WebGMEAPI.Quality = {};
    WebGMEAPI.RemoteStreams = {};
    WebGMEAPI.fn.event = {}; //set default upload local stream or not

    WebGMEAPI.Param.defaultMute = true;
    WebGMEAPI.Param.hasRTCStarted = false;
    WebGMEAPI.Param.localStream_ = null;
    WebGMEAPI.Param.remoteStreams_ = [];
    WebGMEAPI.Param.micId_;
    WebGMEAPI.Param.interval_ = 1000;
    WebGMEAPI.Param.isInRoom = false;
    WebGMEAPI.Param.micEnbale = false; //范围语音、3D音效相关

    WebGMEAPI.SpaParam = {};
    WebGMEAPI.SpaParam.range = 0;
    WebGMEAPI.SpaParam.teamID = 0;
    WebGMEAPI.SpaParam.rangeAudioMode = 0; // 伴奏相关

    WebGMEAPI.AccompanyParam = {};
    WebGMEAPI.AccompanyParam.file = null; //the current file

    WebGMEAPI.AccompanyParam.fileName = null; //the current file name

    WebGMEAPI.AccompanyParam.audioContext = null;
    WebGMEAPI.AccompanyParam.source = null; //the audio source

    WebGMEAPI.AccompanyParam.animationId = null;
    WebGMEAPI.AccompanyParam.forceStop = false;
    WebGMEAPI.AccompanyParam.loopBack = true;
    WebGMEAPI.AccompanyParam.loopCount = 0;
    WebGMEAPI.AccompanyParam.volume = 1.0;
    WebGMEAPI.AccompanyParam.localGainNode = null;
    WebGMEAPI.AccompanyParam.remoteGainNode = null;
    WebGMEAPI.AccompanyParam.micStream = null; //获取伴音的麦克风stream，在退出的时候关闭stream的track
    // 初始化GME的事件系统

    InitGMEEvent();
  } // WebGMEAPI.mygetStats = mygetStats;
  // console.warn(WebGMEAPI.mygetStats);

  /**
   * 初始化一个event事件，会在回调的过程中通过eventType通知给回调函数
   */


  function InitGMEEvent() {
    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_NONE = 0; //Notification of entering a room, triggered by EnterRoom API.

    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ENTER_ROOM = 1; //Notification of exiting a room, triggered by ExitRoom API.

    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_EXIT_ROOM = 2; //Notification of room disconnection due to network or other reasons, which will trigger automatically.

    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ROOM_DISCONNECT = 3; //Notification of the updates of room members, the notification contains detailed information, refer to ITMG_EVENT_ID_USER_UPDATE.

    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_USER_UPDATE = 4;
    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_LOCALSTREAM_READY = 5;
    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_REMOTESTREAM_IN = 6;
    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_REMOTESTREAM_PAUSED = 7;
    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_REMOTESTREAM_OUT = 8;
    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_SPEAKER_ENABLE_RESULT = 9;
    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_MICROPHONE_ENABLE_RESULT = 10;
    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ACCOMPANY_FINISH = 11;
    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_START_ACCOMPANY = 12;
    WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_SET_ACCOMPANY_VOLUME = 13;
  }
  /**
   * 通知状态给回调函数，携带事件类型，返回码返回信息
   * @param eventType 事件类型
   * @param errCode 返回码
   * @param msg 返回信息
   */


  function notifyEveny(eventType, errCode, msg) {
    var result = {};
    result.errorCode = errCode;
    result.errorMsg = msg;

    try {
      logger.info("notifyEvent eventType:".concat(eventType, ",errCode:").concat(errCode, ", msg:").concat(msg));
      WebGMEAPI.callbacks(eventType, result);
    } catch (e) {
      logger.error("Dispatch Event:".concat(eventType, ",Result:").concat(result, " Error!"));
    }
  }
  /**
   * 通知状态给回调函数，携带事件类型和数据，此函数会携带数据obj返回给对调
   * @param eventType 事件类型
   * @param errObj 数据
   */


  function notifyEvenyObj(eventType, errObj) {
    try {
      logger.info("notifyEventObj eventType:".concat(eventType, ",errObj:").concat(errObj));
      WebGMEAPI.callbacks(eventType, errObj);
    } catch (e) {
      logger.error("Dispatch Event:".concat(eventType, ",errObj:").concat(errObj, " Error!"));
    }
  }

  WebGMEAPI.fn = WebGMEAPI.prototype;

  function addView(id) {
    // eslint-disable-next-line no-undef
    if (!$('#' + id)[0]) {
      // eslint-disable-next-line no-undef
      $('<div/>', {
        id: id,
        "class": 'video-view'
      }).appendTo('#gme-audio-wrap');
    }
  }

  function removeView(id) {
    // eslint-disable-next-line no-undef
    if ($('#' + id)[0]) {
      // eslint-disable-next-line no-undef
      $('#' + id).remove();
    }
  } /////////////////////////////

  /**
   * 接收到远端流更新状态，远端流会携带用户的userId等信息
   * @param data 源断流数据对象
   */


  function onRemoteStreamUpdate(data) {
    var userIds = [];
    WebGMEAPI.Param.remoteStreams_.forEach(function (remoteStream) {
      userIds.push(remoteStream.getUserId());
    });
    data.PeerInfo = userIds;
    logger.info('GME:onRemoteStreamUpdate, data:', data);
    notifyEvenyObj(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_USER_UPDATE, data);
  }
  /**
   * 房间断开连接函数
   * @param data 远端流数据
   */


  function onKickout(data) {
    logger.info('GME:onKickout, data:', data);
    notifyEvenyObj(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ROOM_DISCONNECT, data);
  }
  /**
   * 设置 TeamID
   * @param {*} teamID 队伍号，专供范围语音模式中使用。当 TeamID 为0时，通话模式为普通小队语音，默认0。
   */


  WebGMEAPI.fn.SetRangeAudioTeamID = function (teamID) {
    if (parseInt(teamID) !== teamID) {
      console.log('SetRangeAudioTeamID failed:invalid parameter');
      return ErrorCode.INVALID_PARAMETER;
    }

    WebGMEAPI.SpaParam.teamID = teamID;

    if (WebGMEAPI.Param.isInRoom && WebGMEAPI.Param.client_ != undefined) {
      if (WebGMEAPI.Param.client_ != undefined) {
        WebGMEAPI.Param.client_.SetRangeAudioTeamID(teamID);
      }
    }

    return 0;
  };
  /**
   * 设置语音模式
   * @param {*} rangeAudioMode 0 代表“所有人”，1 代表"仅小队"
   */


  WebGMEAPI.fn.SetRangeAudioMode = function (rangeAudioMode) {
    if (parseInt(rangeAudioMode) !== rangeAudioMode) {
      console.log('SetRangeAudioMode failed:invalid parameter');
      return ErrorCode.INVALID_PARAMETER;
    }

    WebGMEAPI.SpaParam.rangeAudioMode = rangeAudioMode;

    if (WebGMEAPI.Param.isInRoom && WebGMEAPI.Param.client_ != undefined) {
      WebGMEAPI.Param.client_.SetRangeAudioMode(rangeAudioMode);
    }
  };
  /**
   * 接收语音距离范围
   * @param {*} range 最大可以接收音频的范围，单位为引擎距离单位
   */


  WebGMEAPI.fn.UpdateAudioRecvRange = function (range) {
    if (parseInt(range) !== range) {
      console.log('UpdateAudioRecvRange failed:invalid parameter');
      return ErrorCode.INVALID_PARAMETER;
    }

    if (WebGMEAPI.Param.isInRoom && WebGMEAPI.Param.client_ != undefined) {
      WebGMEAPI.Param.client_.updateAudioRecvRange(range);
    }
  };
  /**
   * 更新声源方位
   * @param position    自身在世界坐标系中的坐标，顺序是前、右、上
   * @param axisForward 自身坐标系前轴的单位向量（范围语音不需要设置）
   * @param axisRight   自身坐标系右轴的单位向量（范围语音不需要设置）
   * @param axisUp      自身坐标系上轴的单位向量（范围语音不需要设置）
   */


  WebGMEAPI.fn.UpdateSelfPosition = function (position, axisForward, axisRight, axisUp) {
    if (WebGMEAPI.Param.isInRoom && WebGMEAPI.Param.client_ != undefined) {
      WebGMEAPI.Param.client_.UpdateSelfPosition(position, axisForward, axisRight, axisUp);
    }
  };
  /**
   * 客户端连接服务端房间错误信息调用函数，例如房间退出或者房间失去连接等原因造成连接失败
   * @param data 错误数据
   */


  function onErrorNotify(data) {
    logger.error('onErrorNotify, data:', data);

    if (data.getCode() === 10015 && data.errorMsg === 'ice close' || data.getCode() === 10035 && data.errorMsg === 'websocket close') {
      WebGMEAPI.Param.isInRoom = false;
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_EXIT_ROOM, 0, 'Exit OK');
    } else {
      logger.info('start unpublish');
      WebGMEAPI.Param.client_.unpublish(WebGMEAPI.Param.localStream_).then(function () {
        logger.info('start unpublish succ!');
      })["catch"](function (e) {
        logger.error('unpublish failed:' + e);
      })["finally"](function () {
        WebGMEAPI.Param.client_.leave().then(function () {
          logger.info('start client leave succ!');
          WebGMEAPI.Param.isInRoom = false;
        })["catch"](function (e) {
          logger.error('client leave failed:' + e);
        })["finally"](function () {
          resetAccompany();

          if (WebGMEAPI.Param.localStream_) {
            WebGMEAPI.Param.localStream_.stop();
            WebGMEAPI.Param.localStream_.close();
            WebGMEAPI.Param.localStream_ = null;
          }

          if (WebGMEAPI.AccompanyParam.micStream) {
            stopTracks(WebGMEAPI.AccompanyParam.micStream);
            WebGMEAPI.AccompanyParam.micStream = null;
          }

          WebGMEAPI.Param.remoteStreams_ = [];
          WebGMEAPI.Param.client_ = null;
          WebGMEAPI.Param.isInRoom = false;
          WebGMEAPI.Param.micEnbale = false;
        });
        setTimeout(function () {
          notifyEvenyObj(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ROOM_DISCONNECT, data);
        }, 1200);
      });
    }
  }
  /**
   * 进入房间流程时间监听处理，在进入语音房间后处理时间和监听，同时进行相关log的记录
   * @param rtc trtc数据对象
   */


  function handleEvents(rtc) {
    rtc.client_.on('error', function (err) {
      logger.error('GME:error:' + err); // alert(err);

      onErrorNotify(err);
    });
    rtc.client_.on('client-banned', function (err) {
      logger.error('GME:client has been banned for ' + err); // alert(err);

      onKickout(err);
    }); // fired when a remote peer is joining the room

    rtc.client_.on('peer-join', function (evt) {
      var userId = evt.userId; // rtc.peers.push(userId);
      // rtc.updatePeers();

      logger.info('GME:peer-join ' + userId); // onRemoteStreamUpdate(evt);
    }); // fired when a remote peer is leaving the room

    rtc.client_.on('peer-leave', function (evt) {
      var userId = evt.userId; // var templist = []
      // rtc.peers.forEach(p => {
      //   if(p !== userId) {
      //     templist.push(p);
      //   }
      // });
      // rtc.peers = templist;
      // rtc.updatePeers();

      logger.info('GME:peer-leave ' + userId); // onRemoteStreamRemove(evt);
    }); // fired when a remote stream is added

    rtc.client_.on('stream-added', function (evt) {
      var remoteStream = evt.stream;
      var id = remoteStream.getId();
      var userId = remoteStream.getUserId();
      logger.info("GME:remote stream added: [".concat(userId, "] ID: ").concat(id, " type: ").concat(remoteStream.getType()));
      logger.info('GME:subscribe to this remote stream');
      rtc.remoteStreams_.push(remoteStream);
      rtc.client_.subscribe(remoteStream);
    }); // fired when a remote stream has been subscribed

    rtc.client_.on('stream-subscribed', function (evt) {
      var remoteStream = evt.stream;
      var id = remoteStream.getId();
      addView(id);
      remoteStream.play(id).then(function () {
        logger.info("Start play remote stream:".concat(id, " userid:").concat(remoteStream.getUserId()));
      })["catch"](function (e) {
        //log.warn(
        //  `Start play remote stream:${id} userid:${remoteStream.getUserId()} Error, code:${errorCode}`
        //);
        //if (errorCode === 0x4043) {
        // PLAY_NOT_ALLOWED,引导用户手势操作恢复音视频播放
        // stream.resume()
        logger.warn("Start auto play remote stream:".concat(id, " error,             need to resume stream after doing some gesture or click on this webpage!")); //notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_REMOTESTREAM_PAUSED, 0, '');
        //}
      });
      logger.info('GME:stream-subscribed ID: ' + id);
      notifyEvenyObj(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_REMOTESTREAM_IN, remoteStream);
    }); // fired when the remote stream is removed, e.g. the remote user called Client.unpublish()

    rtc.client_.on('stream-removed', function (evt) {
      var remoteStream = evt.stream;
      var id = remoteStream.getId();
      remoteStream.stop();
      rtc.remoteStreams_ = rtc.remoteStreams_.filter(function (stream) {
        return stream.getId() !== id;
      });
      removeView(id);
      logger.info("GME:stream-removed ID: ".concat(id, "  type: ").concat(remoteStream.getType()));
      notifyEvenyObj(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_REMOTESTREAM_OUT, remoteStream);
    });
    rtc.client_.on('stream-updated', function (evt) {
      // seiyabai stream update
      var remoteStream = evt.stream;
      logger.info('GME:type: ' + remoteStream.getType() + ' stream-updated hasAudio: ' + remoteStream.hasAudio() + ' hasVideo: ' + remoteStream.hasVideo() + 'evt:' + evt);
      onRemoteStreamUpdate(evt);
    });
    rtc.client_.on('mute-audio', function (evt) {
      logger.info('GME:' + evt.userId + ' mute audio');
    });
    rtc.client_.on('unmute-audio', function (evt) {
      logger.info('GME:' + evt.userId + ' unmute audio');
    });
    rtc.client_.on('mute-video', function (evt) {
      logger.info('GME:' + evt.userId + ' mute video');
    });
    rtc.client_.on('unmute-video', function (evt) {
      logger.info('GME:' + evt.userId + ' unmute video');
    });
    rtc.client_.on('connection-state-changed', function (evt) {
      logger.info("GME:RtcClient state changed to ".concat(evt.state, " from ").concat(evt.prevState));
    });
  } // function onInitWebRTCSucc(data) {
  //   //可能被重定向, 初始化这个用这个data, 刷新缓存的
  //   log.info('init webGME success');
  //   if (data.roomid !== undefined) {
  //     WebGMEAPI.Param.roomId_redirect = data.roomid;
  //   } else {
  //     WebGMEAPI.Param.roomId_redirect = WebGMEAPI.Param.roomId;
  //   }
  //   var createRoomParam = {
  //     roomid: WebGMEAPI.Param.roomId_redirect,
  //     privateMapKey: WebGMEAPI.Param.authBuffer,
  //     role: WebGMEAPI.Param.roleName
  //   };
  //   log.info('createRoom with param:', createRoomParam);
  //   webRTC.createRoom(
  //     createRoomParam,
  //     function(succ_data) {
  //       log.info('createRoom succ:', succ_data);
  //       listenRTCEvent(this, webRTC);
  //       notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ENTER_ROOM, 0, '');
  //     },
  //     function(fail_data) {
  //       notifyEveny(
  //         WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ENTER_ROOM,
  //         1,
  //         'createRoom failed:' + fail_data
  //       );
  //       log.info('createRoom failed:', fail_data);
  //     }
  //   );
  // }
  // function onInitWebRTCFailed(fail_data) {
  //   notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ENTER_ROOM, 1, 'Init WebRTC failed');
  //   log.info('init WebRTC failed');
  // }
  // function getMicrophoneId() {
  //   const selector = document.getElementById('microphoneId');
  //   const microphoneId = selector[selector.selectedIndex].value;
  //   log.info('selected microphoneId: ' + microphoneId);
  //   return microphoneId;
  // }
  // async function internalInitLocalStream(micId) {
  //   log.info('start create local stream');
  //   WebGMEAPI.Param.localStream_ = TRTC.createStream({
  //     audio: true,
  //     video: false,
  //     userId: WebGMEAPI.Param.openId,
  //     cameraId: 0,
  //     microphoneId: micId
  //   });
  //   ReportSelfVersion(WebGMEAPI.Param.sdkAppId);
  //   // try {
  //   log.info('start init local stream!');
  //   // initialize the local stream and the stream will be populated with audio/video
  //   WebGMEAPI.Param.localStream_.initialize()
  //     .then(function(){
  //       log.info('local stream init ok!');
  //       WebGMEAPI.Param.localStream_.on('player-state-changed', event => {
  //         log.info(`local stream ${event.type} player is ${event.state}`);
  //       });
  //       addView('local-stream');
  //       const container = $('#' + 'local-stream')[0];
  //       // log.info('container:'+container);
  //       // play the localStream within 'local-stream' div
  //       WebGMEAPI.Param.localStream_.play(container)
  //         .then(()=>{
  //           log.info('start localstream play ok');
  //           log.info('start publish!');
  //           notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_LOCALSTREAM_READY, 0, "");
  //           // publish the local stream
  //           WebGMEAPI.Param.client_.publish(WebGMEAPI.Param.localStream_)
  //             .then(()=>{
  //               log.info("start publish local stream ok!");
  //               // setTimeout(getStatsLooper, WebGMEAPI.Param.interval_ || 1000);
  //             })
  //             .catch(e=>{
  //               log.error('start public local stream failed:'+e);
  //             });
  //         })
  //         .catch(e=>{
  //           notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_LOCALSTREAM_READY, 1, "");
  //           log.error('start localstream play error:'+e);
  //         });
  //     })
  //     .catch(function(e){
  //       log.error('start init localstream failed:'+e);
  //     });
  //   log.info('initialize local stream success');
  // }

  /**
   * 初始化本地流对象(主要是音频输入流)，获取本地设备的麦克风设备数据，
   * 创建本地流成功后将流推送到服务端，同时监听stream事件
   * @returns {Promise<boolean>}
   */


  function initLocalStream() {
    return _initLocalStream.apply(this, arguments);
  } //01--初始化GME

  /**
   * 初始化GME的SDK
   * @param document html的document对象
   * @param sdkAppId sdk的appId
   * @param openId sdk的openId
   */


  function _initLocalStream() {
    _initLocalStream = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
      var micId, devices, container;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return TRTC.getMicrophones();

            case 2:
              devices = _context2.sent;

              if (devices.length > 0) {
                micId = devices[0].deviceId;

                if (micId.length === 0) {
                  micId = 'default';
                }

                logger.info("select microphone id:".concat(micId, ", label:").concat(devices[0].label));
              } else {
                logger.info('NO microphone found!');
              }

              WebGMEAPI.Param.micId_ = micId;

              if (WebGMEAPI.Param.micId_) {
                _context2.next = 7;
                break;
              }

              return _context2.abrupt("return", false);

            case 7:
              logger.info('start create local stream');
              WebGMEAPI.Param.localStream_ = TRTC.createStream({
                audio: true,
                video: false,
                userId: WebGMEAPI.Param.openId,
                cameraId: 0,
                microphoneId: micId
              });
              ReportSelfVersion(WebGMEAPI.Param.sdkAppId); // try {

              logger.info('start init local stream!'); // initialize the local stream and the stream will be populated with audio/video

              _context2.next = 13;
              return WebGMEAPI.Param.localStream_.initialize();

            case 13:
              logger.info('local stream init ok!');
              WebGMEAPI.Param.localStream_.on('player-state-changed', function (event) {
                logger.info("local stream ".concat(event.type, " player is ").concat(event.state));
              });
              addView('local-stream'); // eslint-disable-next-line no-undef

              container = $('#' + 'local-stream')[0]; // log.info('container:'+container);
              // play the localStream within 'local-stream' div

              _context2.next = 19;
              return WebGMEAPI.Param.localStream_.play(container);

            case 19:
              logger.info('start localstream play ok');
              logger.info('start publish!');
              notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_LOCALSTREAM_READY, 0, ''); // publish the local stream

              _context2.next = 24;
              return WebGMEAPI.Param.client_.publish(WebGMEAPI.Param.localStream_);

            case 24:
              logger.info('start publish local stream ok!');
              setTimeout(getStatsLooper, WebGMEAPI.Param.interval_ || 1000); // log.error('start public local stream failed:'+e);
              //     notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVNET_TYPE_LOCALSTREAM_READY, 1, "");
              //     log.error('start localstream play error:'+e);
              //   });

              return _context2.abrupt("return", true);

            case 27:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return _initLocalStream.apply(this, arguments);
  }

  WebGMEAPI.fn.Init = function (document, sdkAppId, openId) {
    WebGMEAPI.Param.document = document;
    WebGMEAPI.Param.sdkAppId = sdkAppId;
    WebGMEAPI.Param.openId = openId;
    logger.info('sdkappid:' + sdkAppId);
  };

  function getStatsLooper() {
    if (WebGMEAPI.Param.client_) {
      var data = {};
      WebGMEAPI.Param.client_.getLocalAudioStats().then(function (stats) {
        for (var userId in stats) {
          data.local_userId = userId;
          data.local_bytesSent = stats[userId].bytesSent;
          data.local_packetsSent = stats[userId].packetsSent;
          data.UploadBRSend = stats[userId].bytesSent;
          data.UploadRTT = 0; // log.info('$$$local userId: ' + data.local_userId +
          //             ' bytesSent: ' + data.local_bytesSent +
          //             ' packetsSent: ' + data.local_packetsSent);
        }

        var peerInfo = [];
        WebGMEAPI.Param.client_.getRemoteAudioStats().then(function (stats) {
          for (var _userId in stats) {
            var p = {};
            p.userId = _userId;
            p.bytesReceived = stats[_userId].bytesReceived;
            p.packetsReceived = stats[_userId].packetsReceived;
            p.packetsLost = stats[_userId].packetsLost;
            p.jitter = stats[_userId].jitter; // p.delay = 0;
            // p.jitterBufferMs = 0;
            // p.jitterReceived = 0;

            peerInfo.push(p); // log.info('remote userId: ' + p.userId +
            //             ' bytesReceived: ' + p.bytesReceived +
            //             ' packetsReceived: ' + p.packetsReceived +
            //             ' packetsLost: ' + p.packetsLost);
          }

          data.PeerInfo = peerInfo;
          notifyEvenyObj(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_USER_UPDATE, data);
          setTimeout(getStatsLooper, WebGMEAPI.Param.interval_ || 1000); // log.info('====local userId: ' + data.local_userId +
          //             ' bytesSent: ' + data.local_bytesSent +
          //             ' packetsSent: ' + data.local_packetsSent);
        })["catch"](function (e) {
          logger.error('getRemoteAudioStats error:' + e);
        });
      })["catch"](function (e) {
        logger.error('getLocalAudioStats error:' + e);
      });
    }
  } // async publish() {
  //   // if (!this.isJoined_) {
  //   //   console.warn('publish() - please join() firstly');
  //   //   return;
  //   // }
  //   // if (this.isPublished_) {
  //   //   console.warn('duplicate RtcClient.publish() observed');
  //   //   return;
  //   // }
  //   try {
  //     await WebGMEAPI.Param.client_.publish(WebGMEAPI.Param.localStream_);
  //   } catch (e) {
  //     log.error('failed to publish local stream ' + e);
  //     // this.isPublished_ = false;
  //   }
  //   // this.isPublished_ = true;
  // };
  // async unpublish() {
  //   // if (!this.isJoined_) {
  //   //   console.warn('unpublish() - please join() firstly');
  //   //   return;
  //   // }
  //   // if (!this.isPublished_) {
  //   //   console.warn('RtcClient.unpublish() called but not published yet');
  //   //   return;
  //   // }
  //   await WebGMEAPI.Param.client_.unpublish(WebGMEAPI.Param.localStream_);
  //   // this.isPublished_ = false;
  // }
  //02--进房
  //roomId     --- 房间ID
  //roomType   --- 加入房间类型
  //authBuffer --- 进房密钥, 通过后台获取, 参见文档:


  WebGMEAPI.fn.EnterRoom = function (roomId, roomType, authBuffer) {
    logger.info("EnterRoom, roomId:".concat(roomId, ",roomType=").concat(roomType, ",sdkappid:").concat(WebGMEAPI.Param.sdkAppId, ",openid:").concat(WebGMEAPI.Param.openId, ",authbuffer:").concat(authBuffer)); // authBuffer = authBuffer.replace(/\//g, '%2F');
    // authBuffer = authBuffer.replace(/\+/g, '%2B');
    // authBuffer = authBuffer.replace(/=/g, '%3D');

    logger.info("url safe authbuffer:".concat(authBuffer));
    WebGMEAPI.Param.roomId = roomId;
    WebGMEAPI.Param.roomType = roomType;
    WebGMEAPI.Param.authBuffer = encodeURIComponent(authBuffer);
    WebGMEAPI.Param.roleName = 'esports';
    var isNumber = parseInt(WebGMEAPI.Param.openId);

    if (isNumber.toString() !== 'NaN') {
      if (isNumber < 10000) {
        notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ENTER_ROOM, 1004, 'Invalid Argument');
        return;
      }
    }

    var opt = {
      mode: 'videoCall',
      sdkAppId: WebGMEAPI.Param.sdkAppId,
      userId: WebGMEAPI.Param.openId,
      userSig: WebGMEAPI.Param.authBuffer,
      roomId: WebGMEAPI.Param.roomId,
      UseTestEnv: UseTestEnv
    };

    if (IS_QQB) {
      logger.debug('Find QQBrowser, use unified-plan');
      opt.sdpSemantics = 'unified-plan';
    }

    if (IS_QQ && IS_TBS) {
      logger.debug('Find QQBrowser(TBS) in QQ, use unified-plan');
      opt.sdpSemantics = 'unified-plan';
    }

    if (IS_CHROME && BROWSER_VERSION < 'Chrome/72') {
      logger.debug('Find ChromeBrowser version lower than 72, use unified-plan');
      opt.sdpSemantics = 'unified-plan';
    }

    WebGMEAPI.Param.client_ = TRTC.createClient(opt);
    handleEvents(WebGMEAPI.Param);
    WebGMEAPI.Param.client_.SetRangeAudioMode(WebGMEAPI.SpaParam.rangeAudioMode);
    WebGMEAPI.Param.client_.SetRangeAudioTeamID(WebGMEAPI.SpaParam.teamID);
    logger.info('start join!');
    WebGMEAPI.Param.client_.join({
      roomId: WebGMEAPI.Param.roomId,
      teamID: WebGMEAPI.SpaParam.teamID,
      rangeAudioMode: WebGMEAPI.SpaParam.rangeAudioMode
    }).then(function () {
      logger.info('join ok!');
      WebGMEAPI.Param.isInRoom = true;
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ENTER_ROOM, 0, '');
      setTimeout(getStatsLooper, WebGMEAPI.Param.interval_ || 1000); // play the localStream within 'local-stream' div
      // this.localStream_.play('local_stream');
      // } catch (e) {
      //   log.error('failed to initialize local stream - ' + e);
      // }
    })["catch"](function (e) {
      logger.error('error join:' + e);
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ENTER_ROOM, 1, 'createRoom failed:' + e.message);
    }); // var init_prarm = {
    //   useTest: UseTestEnv,
    //   sdkAppId: WebGMEAPI.Param.sdkAppId,
    //   openid: WebGMEAPI.Param.openId,
    //   roomId: WebGMEAPI.Param.roomId,
    //   privMapEncrypt: WebGMEAPI.Param.authBuffer,
    //   accountType: 0,
    //   audio: true,
    //   video: false,
    //   closeLocalMedia: WebGMEAPI.Param.defaultMute
    // };
    // if (webRTC) {
    //   webRTC.quit();
    // }

    /*
     // webRTC = new WebRTCAPI(init_prarm, onInitWebRTCSucc, onInitWebRTCFailed);
     WebGMEAPI.Param.localStream_ = TRTC.createStream({
    audio: true,
    video: false,
    userId: WebGMEAPI.Param.openId,
    cameraId: 0,
    microphoneId: getMicrophoneId()
     });
     ReportSelfVersion(WebGMEAPI.Param.sdkAppId);
     try {
    // initialize the local stream and the stream will be populated with audio/video
    WebGMEAPI.Param.localStream_.initialize().then(function(){
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ENTER_ROOM, 0, "");
    }).catch(function(e){
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ENTER_ROOM, 1, "createRoom failed:" + e.message);
    });
    log.info('initialize local stream success');
    	WebGMEAPI.Param.localStream_.on('player-state-changed', event => {
      log.info(`local stream ${event.type} player is ${event.state}`);
    });
    	// play the localStream within 'local-stream' div
    // this.localStream_.play('local_stream');
    	// publish the local stream
    WebGMEAPI.Param.client_.publish(WebGMEAPI.Param.localStream_)
      .then(()=>{
    	log.info("start publish")
      })
      .catch(e=>{
    	log.info('start public failed:'+e.message);
      });
     } catch (e) {
    log.error('failed to initialize local stream - ' + e);
     }
     */
  };
  /**
   * 退出房间函数，客户端会停止推流，同时关闭本地流，将远端流置为空流。
   */


  WebGMEAPI.fn.ExitRoom = function () {
    logger.info('ExitRoom');

    if (!WebGMEAPI.Param.isInRoom) {
      logger.error('user not enter room');
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_EXIT_ROOM, 2, 'Exit Room Error: user not enter room');
      return;
    }

    logger.info('start unpublish');
    WebGMEAPI.Param.client_.unpublish(WebGMEAPI.Param.localStream_).then(function () {
      logger.info('start unpublish succ!');
    })["catch"](function (e) {
      logger.error('unpublish failed:' + e);
    })["finally"](function () {
      WebGMEAPI.Param.client_.leave().then(function () {
        logger.info('start client leave succ!');
        WebGMEAPI.Param.isInRoom = false;
        notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_EXIT_ROOM, 0, 'Exit OK');
      })["catch"](function (e) {
        notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_EXIT_ROOM, 1, 'Exit Room Error:' + e);
        logger.error('client leave failed:' + e);
      })["finally"](function () {
        resetAccompany();

        if (WebGMEAPI.Param.localStream_) {
          WebGMEAPI.Param.localStream_.stop();
          WebGMEAPI.Param.localStream_.close();
          WebGMEAPI.Param.localStream_ = null;
        }

        if (WebGMEAPI.AccompanyParam.micStream) {
          stopTracks(WebGMEAPI.AccompanyParam.micStream);
          WebGMEAPI.AccompanyParam.micStream = null;
        }

        WebGMEAPI.Param.remoteStreams_ = [];
        WebGMEAPI.Param.client_ = null;
        WebGMEAPI.Param.isInRoom = false;
        WebGMEAPI.Param.micEnbale = false;
      });
    }); // if (webRTC.isInRoom()) {
    //   if (webRTC) {
    //     webRTC.quit();
    //     WebGMEAPI.Param.defaultMute = true;
    //     WebGMEAPI.Param.hasRTCStarted = false;
    //   } else {
    //     console.warn('ExitRoom WebRTC Not Init');
    //     notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_EXIT_ROOM, 0, 'Exit OK');
    //   }
    // } else {
    //   console.warn('ExitRoom not in room');
    //   notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_EXIT_ROOM, 0, 'Exit OK');
    // }
  };
  /**
   * 禁用（禁用）音频轨道，禁用音频轨道,让本地流停止发送音频，相反会解除该禁用
   * @param bEnable true禁用音频轨道，false解除禁用
   */


  WebGMEAPI.fn.EnableAudioSend = function (bEnable) {
    if (WebGMEAPI.Param.localStream_) {
      if (bEnable === true) {
        WebGMEAPI.Param.localStream_.unmuteAudio();
      } else {
        WebGMEAPI.Param.localStream_.muteAudio();
      }
    }
  };
  /**
   * 打开或关闭麦克风，会通过禁用本地流的音频轨道，让本地流停止发送音频，相反会打开本地流发送音频
   * @param bEnable true为打开，false为关闭
   */


  WebGMEAPI.fn.EnableMic = function (bEnable) {
    if (!WebGMEAPI.Param.isInRoom) {
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_MICROPHONE_ENABLE_RESULT, -1, 'user not enter room');
      logger.error('user not enter room');
      return;
    }

    if (!WebGMEAPI.Param.localStream_) {
      initLocalStream().then(function () {
        if (WebGMEAPI.Param.localStream_) {
          if (bEnable === true) {
            WebGMEAPI.Param.localStream_.unmuteAudio();
          } else {
            WebGMEAPI.Param.localStream_.muteAudio();
          }

          WebGMEAPI.Param.micEnbale = bEnable;
          notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_MICROPHONE_ENABLE_RESULT, bEnable ? 1 : 0, '');
        }
      })["catch"](function (e) {
        logger.error('Init local stream Error');
        return 0;
      });
    } else {
      if (bEnable === true) {
        WebGMEAPI.Param.localStream_.unmuteAudio();
      } else {
        WebGMEAPI.Param.localStream_.muteAudio();
      }

      WebGMEAPI.Param.micEnbale = bEnable;
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_MICROPHONE_ENABLE_RESULT, bEnable ? 1 : 0, '');
    }

    return 1; // }
    // return 0;
    // if (WebGMEAPI.Param.localStream_) {
    //     if (bEnable === true) {
    //       WebGMEAPI.Param.localStream_.addTrack(WebGMEAPI.Param.localStream_.getAudioTrack())
    //         .then(()=>{
    //           log.info('add local stream track to localstream ok!');
    //         })
    //         .catch(e=>{
    //           log.error('add local stream track to localstream error:'+e);
    //         });
    //     } else {
    //       WebGMEAPI.Param.localStream_.removeTrack(WebGMEAPI.Param.localStream_.getAudioTrack())
    //         .then(()=>{
    //           log.info('remove local stream track to localstream ok!');
    //         })
    //         .catch(e=>{
    //           log.error('remove local stream track to localstream error:'+e);
    //         });
    //     }
    // }
  };
  /**
   * 打开或关闭扬声器，会遍历远程流，停止播放音频流，但是仍然会接收音频数据，
   * 相反会继续播放音频流同事接收音频数据。
   * @param bEnable true为打开，false为关闭
   */


  WebGMEAPI.fn.EnableSpeaker = function (bEnable) {
    if (!WebGMEAPI.Param.isInRoom) {
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_SPEAKER_ENABLE_RESULT, -1, 'user not enter room');
      logger.error('user not enter room');
      return;
    }

    if (bEnable === true) {
      WebGMEAPI.Param.remoteStreams_.forEach(function (remoteStream) {
        remoteStream.unmuteAudio();
      });
    } else {
      WebGMEAPI.Param.remoteStreams_.forEach(function (remoteStream) {
        remoteStream.muteAudio();
      });
    }

    notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_SPEAKER_ENABLE_RESULT, bEnable ? 1 : 0, '');
    return 1; // }
    // return 0;
  };
  /**
   * 获取本地流的音轨
   */


  WebGMEAPI.fn.GetMicTrackData = function () {
    if (WebGMEAPI.Param.localStream_ != null) {
      return WebGMEAPI.Param.localStream_.getAudioTrack()[0];
    } // notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_SPEAKER_ENABLE_RESULT, bEnable?1:0, '');


    return null;
  };

  WebGMEAPI.fn.SetMicVolume = function (volume) {// if (webRTC) {
    //   webRTC.setAudioInputVolume(volume);
    // }
  };
  /**
   * 设置回调函数，对外提供GME api的回调事件和回调信息
   * @param 回调方法
   */


  WebGMEAPI.fn.SetTMGDelegate = function (delegate) {
    WebGMEAPI.callbacks = delegate;
  };

  WebGMEAPI.fn.getErrorCode = function () {// return Constants.ERROR_CODE;
  }; //if u wannt to set default mic open please first SetAdvanceParam before enterroom


  WebGMEAPI.fn.SetAdvanceParam = function (key, value) {
    if (key === 'DefaultMute') {
      WebGMEAPI.Param.defaultMute = value; //如果设置mute， 不需要默认推流， 需要在EnableMic的时候， 开RTC

      WebGMEAPI.Param.hasRTCStarted = !value;
    }
  };
  /**
   * 恢复所有远端流的状态，接收该流并且播放相关音频
   */


  WebGMEAPI.fn.resumeAllRemoteStreams = function resumeAllRemoteStream() {
    logger.info('Start resumeAllRemoteStreams');
    WebGMEAPI.Param.remoteStreams_.forEach(function (remoteStream) {
      remoteStream.resume();
    });
  };
  /**
   * 设置log级别，INFO, TRACE, DEBUG, INFO, WARN, ERROR, NONE
   */


  WebGMEAPI.fn.SetLogLevel = function SetLogLevel(level) {
    var logLevel = TRTC.Logger.LogLevel.INFO;

    switch (level) {
      case 0:
        logLevel = TRTC.Logger.LogLevel.TRACE;
        break;

      case 1:
        logLevel = TRTC.Logger.LogLevel.DEBUG;
        break;

      case 2:
        logLevel = TRTC.Logger.LogLevel.INFO;
        break;

      case 3:
        logLevel = TRTC.Logger.LogLevel.WARN;
        break;

      case 4:
        logLevel = TRTC.Logger.LogLevel.ERROR;
        break;

      case 5:
        logLevel = TRTC.Logger.LogLevel.NONE;
        break;
    }

    TRTC.Logger.setLogLevel(logLevel);
  };
  /**
   * 获取麦克风的数据信息，如麦克风的设备id等
   * @returns 麦克风的数据信息
   */


  WebGMEAPI.fn.GetMicrophones = /*#__PURE__*/function () {
    var _getMicrophones = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.abrupt("return", TRTC.getMicrophones());

            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    function getMicrophones() {
      return _getMicrophones.apply(this, arguments);
    }

    return getMicrophones;
  }(); ////////////////////////////////////////////////////////////////
  /// 伴奏部分
  ////////////////////////////////////////////////////////////////

  /**
   * 用作准备播放背景音乐的audioContext，后续通过audioContext进行混音播放
   * @private
   */


  function _prepareAPI() {
    //fix browser vender for AudioContext and requestAnimationFrame
    window.AudioContext = window.AudioContext || window.webkitAudioContext || window.mozAudioContext || window.msAudioContext;
    window.requestAnimationFrame = window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.msRequestAnimationFrame;
    window.cancelAnimationFrame = window.cancelAnimationFrame || window.webkitCancelAnimationFrame || window.mozCancelAnimationFrame || window.msCancelAnimationFrame;

    try {
      WebGMEAPI.AccompanyParam.audioContext = new AudioContext();
    } catch (e) {
      logger.info(e);
    }
  }
  /**
   * 开始伴音播放，此时会播放本地背景音乐，同时采集麦克风录音，同时替换远端的音轨，就可实现将本地播放的音频和麦克风采集的音频混合之后推流给远端，
   * file为选择的本地音频文件，次文件音频会发送给远端房间的接收者。
   */


  function _startAccompany() {
    //read and decode the file into audio array buffer
    var param = WebGMEAPI.AccompanyParam;
    var file = param.file;

    if (!file) {
      logger.error('file is empty');
      return;
    }

    var fr = new FileReader();

    fr.onload = function (e) {
      var fileResult = e.target.result;
      var audioContext = param.audioContext;

      if (!audioContext) {
        logger.error('audioContext is empty');
        return;
      }

      audioContext.decodeAudioData(fileResult, function (buffer) {
        _visualize(audioContext, buffer);
      }, function (e) {
        logger.error(e);
      });
    };

    fr.onerror = function (e) {
      logger.error(e);
    }; //assign the file to the reader


    fr.readAsArrayBuffer(file);
  }
  /**
   *
   * @param audioContext
   * @param buffer
   * @private
   */


  function _visualize(_x, _x2) {
    return _visualize2.apply(this, arguments);
  }

  function _visualize2() {
    _visualize2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(audioContext, buffer) {
      var gainNode, audioBufferSouceNode, analyser, param;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (audioContext) {
                _context3.next = 3;
                break;
              }

              logger.error('audioContext is empty');
              return _context3.abrupt("return");

            case 3:
              gainNode = audioContext.createGain();
              WebGMEAPI.AccompanyParam.localGainNode = gainNode;
              audioBufferSouceNode = audioContext.createBufferSource();
              analyser = audioContext.createAnalyser();
              param = WebGMEAPI.AccompanyParam; //connect the analyser to the destination(the speaker), or we won't hear the sound

              analyser.connect(audioContext.destination);
              gainNode.gain.value = WebGMEAPI.AccompanyParam.volume;
              audioBufferSouceNode.connect(gainNode).connect(analyser); //then assign the buffer to the buffer source node

              audioBufferSouceNode.buffer = buffer; //play the source

              if (!audioBufferSouceNode.start) {
                audioBufferSouceNode.start = audioBufferSouceNode.noteOn; //in old browsers use noteOn method

                audioBufferSouceNode.stop = audioBufferSouceNode.noteOff; //in old browsers use noteOff method
              } //stop the previous sound if any


              if (param.source !== null) {
                param.source.stop(0);
              }

              audioBufferSouceNode.start(0);
              param.source = audioBufferSouceNode;

              if (WebGMEAPI.AccompanyParam.loopCount == -1) {
                audioBufferSouceNode.loop = true;
              } else {
                audioBufferSouceNode.addEventListener('ended', function (a) {
                  if (WebGMEAPI.AccompanyParam.forceStop) {
                    WebGMEAPI.AccompanyParam.forceStop = false;
                    return;
                  }

                  onPlayCompleted(audioContext, buffer);
                }, false);
              }

              if (param.loopBack) {
                _startMixStream(audioContext);
              } else {
                notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_START_ACCOMPANY, 0, 'success');
              }

              audioBufferSouceNode.onended = function () {
                _audioEnd();
              };

              logger.info('local stream gainNode value::' + gainNode.gain.value);

            case 20:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));
    return _visualize2.apply(this, arguments);
  }

  function onPlayCompleted(audioContext, buffer) {
    logger.info('onPlayCompleted');
    setTimeout(function () {
      WebGMEAPI.AccompanyParam.loopCount--;

      if (WebGMEAPI.AccompanyParam.loopCount < 0) {
        WebGMEAPI.AccompanyParam.loopCount = 0;
      }

      logger.info('on play complete loopCount' + WebGMEAPI.AccompanyParam.loopCount);

      if (WebGMEAPI.AccompanyParam.loopCount > 0) {
        _visualize(audioContext, buffer);
      }
    }, 50);
  }
  /**
   * 混音流，获取当前设备的输入流，创建音乐播放的MediaStreamAudioDestinationNode，
   * 绑定本地播放流中，创建混合流node，然后将本地设备的输入流（麦克风的采集流）通过connect音频的node绑定到创建的混合流中，
   * 最后获取混合流的音轨，通过replaceTrack替换远端的推送流，从而形成混音流的推送
   * @param audioContext
   * @private
   */


  function _startMixStream(audioContext) {
    if (WebGMEAPI.Param.localStream_) {
      var gainNode = audioContext.createGain();
      WebGMEAPI.AccompanyParam.remoteGainNode = gainNode;
      gainNode.gain.value = WebGMEAPI.AccompanyParam.volume;
      navigator.mediaDevices.getUserMedia({
        audio: true,
        video: false
      }).then(function (stream) {
        // 创建属于音乐的steam
        var musicDestinationNode = audioContext.createMediaStreamDestination();
        var param = WebGMEAPI.AccompanyParam;

        if (param && param.source) {
          param.source.connect(musicDestinationNode);
          var musicStreamTrack = musicDestinationNode.stream.getAudioTracks()[0];

          if (!musicStreamTrack) {
            logger.error('musicStreamTrack is null');
          } // 获取原本的localsteam
          // for mixing tracks
          // 创建dest for mix


          var mixDestinationNode = audioContext.createMediaStreamDestination();
          var mixStream = new MediaStream([musicStreamTrack]);
          audioContext.createMediaStreamSource(mixStream).connect(gainNode).connect(mixDestinationNode); //绑定music

          WebGMEAPI.AccompanyParam.micStream = stream;
          audioContext.createMediaStreamSource(stream).connect(mixDestinationNode); //绑定mic采集的数据

          var mixSteamTrack = mixDestinationNode.stream.getTracks()[0];

          if (mixSteamTrack && WebGMEAPI.Param.localStream_) {
            //先停掉之前绑定的麦克风的track
            var localSteam = WebGMEAPI.Param.localStream_.getMediaStream();

            if (localSteam) {
              stopTracks(localSteam);
            } // 对audioTrack和videoTrack处理之后，


            WebGMEAPI.Param.localStream_.replaceTrack(mixSteamTrack);
            notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_START_ACCOMPANY, 0, 'success');
            logger.info('remote stream gainNode value::' + gainNode.gain.value);
          }
        } else {
          logger.error('Accompany Param is empty or source is empty');
        }
      });
    }
  }

  function stopTracks(stream) {
    if (stream) {
      stream.getTracks().forEach(function (track) {
        logger.info('stopTracks');
        track.stop();
      });
    }
  }
  /**
   * 背景音乐播放完成，通过事件通知给事件接收者
   * @param instance
   * @private
   */


  function _audioEnd(instance) {
    var loopCount = WebGMEAPI.AccompanyParam.loopCount;
    logger.info('_audioEnd loopCount=: ' + loopCount);
    var that = WebGMEAPI.AccompanyParam;

    if (that.forceStop) {
      that.forceStop = false;
    }

    if (loopCount > 1) {
      return;
    }

    setTimeout(function () {
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_ACCOMPANY_FINISH, 0, 'Finish Successfully');
    }, 0);
  }
  /**
   * 开始播放伴奏和背景音乐，同时开始推流
   * @param file 背景音乐的播放文件
   * @param loopBack 是混音并且发送
   * @param loopCount 循环次数
   */


  WebGMEAPI.fn.StartAccompany = function StartAccompany(file) {
    var loopBack = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var loopCount = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
    logger.info("StartAccompany file:".concat(file, ", loopBack:").concat(loopBack, "\uFF0C loopCount: ").concat(loopCount));

    if (loopCount < -1 || loopCount == 0) {
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_START_ACCOMPANY, 4, 'loopCount is not available');
      return;
    }

    if (!file) {
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_START_ACCOMPANY, 1, 'file is null');
      logger.error('file is null');
      return;
    }

    if (!WebGMEAPI.Param.isInRoom) {
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_START_ACCOMPANY, 2, 'user not enter room');
      logger.error('user not enter room');
      return;
    }

    if (!WebGMEAPI.Param.micEnbale) {
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_START_ACCOMPANY, 3, 'the mic is not enable');
      logger.error('the mic is not enable');
      return;
    }

    if (null === WebGMEAPI.AccompanyParam.audioContext) {
      _prepareAPI();
    }

    WebGMEAPI.AccompanyParam.file = file;
    WebGMEAPI.AccompanyParam.fileName = file.name;
    WebGMEAPI.AccompanyParam.loopBack = loopBack;
    WebGMEAPI.AccompanyParam.loopCount = loopCount;

    _startAccompany();
  };

  WebGMEAPI.fn.setAccompanyVolume = function setAccompanyVolume(volume) {
    logger.info('setAccompanyVolume volume:' + volume);
    WebGMEAPI.AccompanyParam.volume = volume;
    var localGainNode = WebGMEAPI.AccompanyParam.localGainNode;
    var remoteGainNode = WebGMEAPI.AccompanyParam.remoteGainNode;

    if (localGainNode && remoteGainNode) {
      localGainNode.gain.value = volume;
      remoteGainNode.gain.value = volume;
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_SET_ACCOMPANY_VOLUME, 0, 'set accompany volume success');
    } else {
      notifyEveny(WebGMEAPI.fn.event.ITMG_MAIN_EVENT_TYPE_SET_ACCOMPANY_VOLUME, 1, 'local or remote accompany volume not init');
    }
  };
  /**
   * 停止伴奏播放，同时停止推流
   */


  WebGMEAPI.fn.StopAccompany = function StopAccompany() {
    logger.info('StopAccompany');
    resetAccompany();
  };
  /**
   * 获取房间内成员下行实时音量,范围为0 - 200
   */


  WebGMEAPI.fn.GetRecvStreamLevel = function GetRecvStreamLevel(openId) {
    var volume = -1;

    if (WebGMEAPI.Param.localStream_) {
      if (WebGMEAPI.Param.localStream_.getUserId() === openId) {
        volume = Math.round(WebGMEAPI.Param.localStream_.getAudioLevel() * 200);
      }
    }

    if (WebGMEAPI.Param.remoteStreams_) {
      WebGMEAPI.Param.remoteStreams_.forEach(function (remoteStream) {
        if (remoteStream.getUserId() === openId) {
          volume = Math.round(remoteStream.getAudioLevel() * 200);
        }
      });
    }

    return volume;
  };

  function resetAccompany() {
    var param = WebGMEAPI.AccompanyParam;

    if (param) {
      if (param.source) {
        param.forceStop = true;
        WebGMEAPI.AccompanyParam.loopCount = 1;
        param.source.stop(0);
        param.source = null;
        WebGMEAPI.AccompanyParam.loopBack = true;
      }
    }
  } // window.WebGMEAPI = WebGMEAPI;
  // module.exports = WebGMEAPI;


  if (typeof module !== 'undefined' && typeof module.exports !== 'undefined') {
    module.exports = WebGMEAPI;
  } else {
    window.WebGMEAPI = WebGMEAPI;
  }

})));
